public class AIPatrolerPath extends Path
{
    // typy chodzenia po sciezce patrolowej (wczytane z dysku)
    final static int _PATROLPATH_ONCE   = 0;
    final static int _PATROLPATH_LOOPED = 1;
    final static int _PATROLPATH_BACK   = 2;
    
	void ConvertToFlags(int iValue)
	{
		nFlags = 0;
		//GameObject.CrashLog("Konwersja:");
		switch (iValue)
		{
			case _PATROLPATH_ONCE:
				nFlags |= _PATH_ONE_WAY;
				//GameObject.CrashLog("_PATH_ONE_WAY");
			break;
			
			case _PATROLPATH_LOOPED:
				nFlags |= _PATH_LOOPED;
				//GameObject.CrashLog("_PATH_LOOPED");
			break;
			
			case _PATROLPATH_BACK:
				nFlags |= _PATH_TWO_WAYS;
				//GameObject.CrashLog("_PATH_TWO_WAYS");
			break;
		}
	}
	
	static AIPatrolerPath ConvertStdToAIPath(Path path)
    {
        return ConvertStdToAIPath(path, MotionState.SPEED_WALK);   
    }
    
    static AIPatrolerPath ConvertStdToAIPath(Path path, byte iSpeed)
	{
		AIPatrolerPath newPath = new AIPatrolerPath();
		
		newPath.nFlags = path.nFlags;
		newPath.nPathID = -1;
		newPath.sStringID = new String(path.sStringID);
		
		for (int i = 0; i < path.GetPointsNum(); i++)
		{
			AIPatrolerPathPoint point = new AIPatrolerPathPoint((PathPoint) path.aPoints.elementAt(i));
            if (point.fRadius <= 0)
                point.fRadius = 100; //wymagane dla AI
			point.fStopTimeInterval = 0f;
			point.iSpeed = iSpeed;
			newPath.aPoints.addElement(point);
		}
		
		return newPath;
	}
}
