/**Pawn. Stoi, dycha i patrzy za przechodzacym pawnem.
 */
public class Doll extends Pawn
{
    
    void Doll()
    {
        MeshName = "Data/Meshes/Logan/logan.3da";
    }

    Vector vOriginalPos;
    public float fG = -100;

    public void OnCreate()
    {
        super.OnCreate();
		
		fHealth = 10.0f;
        
        vOriginalPos = GetPosition();
        
/*        
        SetAnimType(EBones._HEAD, EAnimType._TRANSFORM, false);
        SetAnimType(EBones._SPINE1, EAnimType._TRANSFORM, false);

        SetAnimType(EBones._L_UPPERARM, EAnimType._TRANSFORM, false);
        SetAnimType(EBones._R_UPPERARM, EAnimType._TRANSFORM, false);
*/        
//        InitAnimSeqFile("Data/meshes/logan_anim.ini");
        
		SetAnimMorphTime(2.45f);

        RegisterKeyRequest();
        
        //ShowCoarseBox(true);
        
        // inicjacja fizyki ciala (po raz drugi, 1. raz w Pawnie)
        PhysicsCreate( 100 );       
        
        ClearFlag( EFlags._NO_ANIMATION );
    }
    
    boolean GetPawnInRadius( float fRadius )
	{
		return ( GetObjectsInRadiusFromClass( fRadius, "Pawn" ).length != 0 );
	}

    static float x = 0;

    
    static float fMaxLookAngle = 75;
    float fLookAngle;

    void BodyDeformLookAt(Vector pos)
    {
        //normalized vector to pos
        Vector toObj = pos;
        toObj.Sub(GetPosition());
        toObj.Normalize();

        if (toObj.Dot(GetForwardVector()) > 0) //if target in ahead
        {
            float cosA = toObj.Dot(GetRightVector());
            //angle of deviation, in degrees
            float fAngle = 90 - (float)(java.lang.Math.acos(cosA)*180.0/java.lang.Math.PI);

            //don't look too far
            if ( java.lang.Math.abs(fAngle) > fMaxLookAngle )
                fAngle = 0;

            //move your head            
            if ( fLookAngle != fAngle )
            {
                fLookAngle = fAngle;
                BoneRotate(EBones._HEAD, new Vector(1, 0, 0), fAngle);
            }
        }
    }

    void BodyDeformAimAt(Vector pos)
    {
        //normalized vector to pos
        Vector toObj = pos;
        toObj.Sub(GetPosition()); //
        toObj.Normalize();

        if ( toObj.Dot(GetBoneDirVector(EBones._R_FOREARM)) > 0 )
        {
            float cosA = toObj.Dot(GetBonePerpVector(EBones._R_FOREARM));
            float fAngle = 90 - (float)(java.lang.Math.acos(cosA)*180.0/java.lang.Math.PI);
            
            if ( java.lang.Math.abs(fAngle) > fMaxLookAngle )
                fAngle = 0;

//            if ( fLookAngle != fAngle )
            {
//                fLookAngle = fAngle;
                BoneRotate(EBones._SPINE1, new Vector(1, 0, 0), fAngle);
            }

        }
    }

    //public void OnFrame()    
    public void WasOnFrame()
    {
        x += 0.1f;

        //refresh only every 20th frame
        if (!((int)x % 2 == 0)) return;
        
        BoneRotate(EBones._L_UPPERARM, new Vector(0, 0 ,1), (float)java.lang.Math.sin(x));
        BoneRotate(EBones._R_UPPERARM, new Vector(0, 0 ,1), -(float)java.lang.Math.sin(x));

        ControlObject [] aPawn;
        aPawn = GetObjectsInRadiusFromClass(500.0f, "Pawn");

        if (aPawn.length > 0)
        {
            BodyDeformLookAt( aPawn[0].GetPosition() );
            //BodyDeformAimAt( aPawn[0].GetPosition() );
        }
    }
    
/*    public void OnTakeDamage(float fDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed, int nDamageType)
    {
        //CrashLog("[Doll.OnTakeDamage] hit by <"+ Assassin.GetName() +">\n");
		//CrashLog("bone="+EBones.GetNameFromID((byte)nDamageType)+"\n");

		// odebranie energii
        fDamage = fDamage * GetDamageMultiplier(nDamageType);
		Damage(fDamage);
				
        Physics.Simulate(this, vHitLocation, vSpeed, fDamage, nDamageType);
/*        
//        if (nDamageType != EBones._NON_BONE)
//        {
//            //PhysicsHit((byte)nDamageType, vHitLocation, vSpeed, fEffectiveStrength, fPhysicsTime);
//            PhysicsDirExplosion( vHitLocation, vSpeed, fEffectiveStrength, 0.2f, 25.f);
//        }
//        else
//        {
//            //podbijamy troszke kierunek odrzutu do gory
//            vHitLocation.Add(new Vector(0, fG, 0));
//
//            PhysicsExplosion( vHitLocation,
//                              fEffectiveStrength, 0.3f, 1500.f);
//        }

        //sztuczne powiekszenie elipsoidy, zeby mozna bylo trafiac goscia po smierci
        SetEllipsoid(200, 200, 100);
    }
*/
	// poprawione OnTakeDamage //////////////////////////////////////////////////////////////
    public void OnTakeDamage(float fDamage, float fPhSimDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed, int nMeshElementorBoneID, int nDamageType)
    {
		// odebranie energii
        fDamage = fDamage * GetDamageMultiplier(nMeshElementorBoneID);
		Damage(fDamage, nDamageType);
				
        Physics.Simulate(this, vHitLocation, vSpeed, fPhSimDamage, nMeshElementorBoneID);
        //sztuczne powiekszenie elipsoidy, zeby mozna bylo trafiac goscia po smierci
        SetEllipsoid(200, 200, 100);
    }
	
    void Rebirth()
    {
        PhysicsOff();
        SetPosition(vOriginalPos);
        ClearFlag(EFlags._NO_ANIMATION_REFRESH);
        SetFlag(EFlags._BLOCK_MOVE);
        PlayAnimSeq(0, 10);
    }

    void OnInputKey(int nKeyCode, boolean bKeyState, char nKeyAscii)
    {

        if (bKeyState)
        {
            if(nKeyCode==EKey._Q)
                Rebirth();
            if (nKeyCode == EKey._Z)
            {
                SetFlag(EFlags._NO_ANIMATION_REFRESH);                

                /*
                PhysicsHit( EBones._HEAD, 
                            GetElementPos(GetElementID("Bip01 Head")),
                            new Vector(0, 1, -1), 6500000, -1);
                */
                /*
                PhysicsDirExplosion( GetElementPos(GetElementID("Bip01 Head")),
                                     new Vector(0, 1, -1),
                                     6500000, 12);
                */
                //LogD("oninputkey "+this+"\n");
                Vector vBomb = GetPosition();
                Vector vDir = GetForwardVector();
                vDir.Mul(100);
                vBomb.Add(vDir);
                
                PhysicsExplosion( vBomb,
                                  650000, 0.2f, 500.f);

            }
            if (nKeyCode == EKey._F8)
            {
                PhysicsCreate(100);
            }

        }
    }

}
