import java.io.*;

public class ChromeMenuModule extends Module
{
	static String _QUICKSAVELOAD_FILE = "save/quick.sav";

    /** Okresla czy gra chodzi w trybie demo */
    boolean bDemo = false;
	
	/** Okresla czy maja byc dostepne na starcie wszystkie misje	 */
	boolean m_bAllMissions = false;
    
    /** Dzwieki odpalane przy odpowiednich akcjach w menu
     */
    static String SoundHighlight="Data/Sounds/menu/bong";
    static String SoundButtonClicked="Data/Sounds/menu/Out_gren";
    
    /** Wartosc ustawiana przez modul gry po wyjsciu do menu
     */
    int ActiveLevelReturnValue=0;
    
    // Window aktualnie wyswietlanego menu
    ChromeMenuWindow Menu = null;

    MenuYesNoDialog m_cYesNoDlg = null;
    
	//modul sceny 3D w menu
	static Chrome3DSceneModule m_c3DSceneModule = null;
	
	//czy wlasnie jest ladowany modul sceny 3D
	boolean m_bLoadinfScene3D = false;
	
	//czy byl odgrywany filmik przy wyjsciu z ostatniego menu (czy odegrac filmik wejsiowy w kolejnym) 
	boolean m_bFilmOutPlayed = true;
	
	//czy ostatnio bylo menuMain (zadzi sie swoimi prawami)
	boolean m_bLastWasMainMenu = true;
	
    // kursor w menu
    static CursorChrome cCursor;
    
    // gdy true to znaczy ze gra jest w trakcie i wszystko wraca do ingame menu
    boolean bInGameMenuAct = false;
    // gdy true to znaczy ze gra jest w trakcie i wszystko wraca do MenuNetIngame
    boolean bMenuNetInGame = false;
    
    boolean IsInGame(){ return bInGameMenuAct || bMenuNetInGame; }
    
    // aktywny level w ktorym toczy sie gra
    ChromeModule ActiveLevelModule=null;
    
    // obiekt do pokazywania tla
    //MenuBackground cMenuBackground=null;
	ChromeMenuBackground cMenuBackground = null;

    
    // kolor tla, ktory byl ustawiony w grze
    /** Obiekt z informacjiami o grze aktualnie urchamianej
     */
    GameInitInfo cGameInitInfo=null;
    
    /**Do jakiego menu mamy wrocic*/
    String sMenuBackName = "";

    /** Nazwa SaveGame'a do wczytania
     */
    String sSaveGameName = null;
    
    /** Progress bar */
    Sprite cProgressBar = null;
    int nProgressTexture = 0;
    int nProgressSizeX = 220;
    int nProgressSizeY = 8;
    String sProgressTexture = "CH_M_Scrollbar.png";
    
    /** Identyfikator wavea z muzyka */
    int nMusicID = 0;

    /** Aktualnie ustawione srodowisko eaxa w grze */
    int nEAXEnv = ESoundEnv.SOUNDENV_NONE;
    
    void StartMenuMusic()
    {
		if(nMusicID == 0)
		{
			nMusicID = PlayWave("Data/sounds/Music/Musicmenu.ogg");//PlayWave("Data/Sounds/MusicMenu.wav");
			if(nMusicID != 0) SetWaveVolume(nMusicID, Music.fMusicVolume);
		}
    }
    
    void OGGTEST()
    {
        BufferedReader cReader = null;
        String sNameFile = "data/sounds/others/list.txt";
        String sBuffer = new String();
		
        try
        {
            cReader = new BufferedReader( new FileReader( sNameFile ));
            if (cReader != null)
            {
                while (true)
                {
                    sBuffer = cReader.readLine();
                    float fLen = GetWaveDuration("data/sounds/others/" + sBuffer);
                    CrashLog(sBuffer + " " + fLen + "\r\n");
                    if (sBuffer == null || sBuffer.length() == 0)
                        break;
                }
                cReader.close();
                cReader = null;
            }
        }
        catch (IOException e)
        { 
            GameObject.LogD("ERROR "+this+" " + e.getMessage() +"\n"); 
        }
    }
    
    
    void UpdateMenuMusicVolume()
    {
        Music.UpdateVolume();
		
        if(nMusicID != 0)
            SetWaveVolume(nMusicID, Music.fMusicVolume);
        else
            StartMenuMusic();
    }
    
    boolean StopMenuMusic()
    {
        if( nMusicID != 0)
        {
            StopWave(nMusicID);
            nMusicID = 0;
			return true;
        }
		return false;
    }
    
    void LoopMenuMusic()
    {
        if(nMusicID != 0)
        {
            if( !IsPlayingWave(nMusicID) )
            {
                //LogD("Powtarzanie muzyki\n");
                    
                StopWave(nMusicID);
                nMusicID = PlayWave("Data/Sounds/Music/MusicMenu.ogg");
                SetWaveVolume(nMusicID, Music.fMusicVolume);
            }
        }
    }
    
    void OnCreate()
    {
        TimerStart();

        fonts = (Fonts) new ChromeFonts();
        fonts.Init(this);
        ((ChromeFonts)fonts).LoadFonts();
		
		#if !_EDITOR
                
        PleaseWait();
        ForceRender();
        
        // pobieramy klawisze
        RegisterKeyRequest();
        RegisterMouseButtonRequest();

		InitGrid(70000.0f, 10000.0f, 70000.0f);
        
        cCursor =(CursorChrome)CreateObject("CursorChrome");
        cCursor.Init(ChromeMenuModule.this);
        cCursor.Hide();
        
        ForceRender();
        
        // ustawiamy menu glowne
        if (!FontTest._ON)
        {
            SetMenu("ChromeMainMenu");
        }
        else
        {
            FontTest cSprite = (FontTest)CreateObject("FontTest");
            AddSprite(cSprite);
        }

        cCursor.Hide();
        ForceRender();
            
        //FogSetColor(0,0,0);
        
        cProgressBar = (Sprite)CreateObject("Sprite");
        AddSprite(cProgressBar);
        
        
        nProgressTexture=cProgressBar.AddTexture(sProgressTexture);
        cProgressBar.SetTexture(nProgressTexture, new Rect(0, 0, 1, 1));
        
        
        cProgressBar.MoveTop();     
        cProgressBar.Hide();
        cProgressBar.SetSize(new Vector(0, nProgressSizeY,0));

        LoadBackground();
		Music.UpdateVolume();
        
        #else
        Sprite cBkg = (Sprite)CreateObject("Sprite");
        cBkg.SetSize(new Vector(GetScreenWidth(), GetScreenHeight(),0));
        cBkg.SetTexture(cBkg.AddTexture("er_t_blue.png"), new Rect(0,0,1,1));
        AddSprite(cBkg);
        cBkg.Show();
        MenuEditorApp  m_cEditorApp;
        m_cEditorApp = new MenuEditorApp();
        m_cEditorApp.Run();
        m_cEditorApp.SetModule(this);
        #endif

    }
    
    void ShowProgress()
    {
        cProgressBar.SetPos(new Vector(0,
									   GetScreenHeight() - nProgressSizeY,//GetScreenHeight()/20f,
									   0f));
        nProgressSizeX = GetScreenWidth();
        cProgressBar.SetSize(new Vector(0, nProgressSizeY, 0));
        cProgressBar.Show();
    }
    
    Sprite m_cPleaseWait = null;
    int m_nPleaseWaitTex = 0;
    void PleaseWait()
    {
        m_cPleaseWait = (Sprite)CreateObject("Sprite");
        AddSprite(m_cPleaseWait);
        m_cPleaseWait.SetSize(new Vector(GetScreenWidth(), GetScreenHeight(),0));
        m_cPleaseWait.Show();
        m_cPleaseWait.SetFont("Verdana22");
        m_cPleaseWait.SetTextPosFlags(ESpriteText.CENTER);
        m_cPleaseWait.DisplayText(Text.Get("&MENU_MAIN_PLEASE_WAIT&"));
        m_nPleaseWaitTex = m_cPleaseWait.AddTexture("er_t_black.png");
        m_cPleaseWait.SetTexture(m_nPleaseWaitTex, new Rect(0,0,1,1));
        m_cPleaseWait.MoveTop();
        ForceRender();
    }
    
    void RemovePleaseWait()
    {
        if (m_cPleaseWait != null)
        {
            m_cPleaseWait.ReleaseTexture(m_nPleaseWaitTex);
            RemoveSprite(m_cPleaseWait);
            m_cPleaseWait.delete();
            m_cPleaseWait = null;
        }
    }
    
    void OnDestroy()
    {
        cCursor.delete();
        cCursor = null;
        
        if( cProgressBar != null )
        {
            cProgressBar.delete();
            cProgressBar = null;
        }
 
        RemoveCurMenu();
        RemoveYesNoDlg();
    }
    
    /**
     */
    void OnActivate()
    {
        //LogR("MENUMODULE OnActivate()");
        
        MethodCaller.cThis.DisableMenuCallPostOnDeactivate();
        
        nEAXEnv = SetSoundEnvironment(ESoundEnv.SOUNDENV_NONE, 0);
        
		#if !_EDITOR
        if(!bInGameMenuAct && !bMenuNetInGame)
        {
            ForceRender();
			LoadScene3D();
            RemovePleaseWait();
            StartMenuMusic();
        }
        
        if (m_cYesNoDlg == null)
            m_cYesNoDlg = (MenuYesNoDialog)(CreateObject("MenuYesNoDialog"));
		#endif

		//wczytanie levelu z pominieciem menu
        /*
        GameInitInfoSingle game=new GameInitInfoSingle();
        
        // chamski hak ustawienie aktualnego levelu na wybrany z listy
        game.cLevels.SetSingleLevel("TestChromeModule.map");
        
        StartGame(game);
        */
    }
    
    /** Deaktywacja menu zawsze wiaze sie z wylaczeniem obslugi klawiszy
     */
    void OnDeactivate()
    {
        //LogR("MENUMODULE OnDeactivate()");
        // rejestrujemy klawisze, zeby mozna bylo chodzic po menu
        UnregisterKeyRequest(); 
		UnregisterMouseButtonRequest();

        if (IsInGame())
            SetSoundEnvironment(nEAXEnv, 0);
        else
            SetSoundEnvironment(ESoundEnv.SOUNDENV_NONE, 0);
        
        MethodCaller.cThis.MenuCallPostOnDeactivate(this);
//        CallOnFrameEnd("PostOnDeactivate");
        bInGameMenuAct = bMenuNetInGame = false;
    }
    
    void RemoveYesNoDlg()
    {
        if (m_cYesNoDlg != null)
        {
            m_cYesNoDlg.Remove();
            RemoveSprite(m_cYesNoDlg);
            m_cYesNoDlg.delete();
            m_cYesNoDlg = null;
        }
    }
    
    void PostOnDeactivate()
    {
        RemoveBackground();
        RemoveYesNoDlg();
        RemoveCurMenu();
    }
    
    void RemoveCurMenu()
    {
        if (Menu != null)
        {
            //LogR("Removing " + Menu +"\n");
            
            if (m_cYesNoDlg != null &&
                m_cYesNoDlg.GetOwner() == Menu)
            {
                //LogR("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n Releasing Yesnodialog for " + Menu+"\n ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n");
                Menu.ReleaseYesNoDialog();
            }
            /*
            else
            {
                if (m_cYesNoDlg != null)
                    LogR("Yesnodialog owner " + m_cYesNoDlg.GetOwner() + "\n");
                else
                    LogR("NO Yesnodialog\n");
            }
            //*/
            
            
            RemoveSprite(Menu);
            Menu.Remove();
            Menu.delete();
            Menu = null;
        }
    }
    
    
    void OnChangeResolution()
    {
        ((ChromeFonts)fonts).LoadFonts();
        if( m_c3DSceneModule != null )
            m_c3DSceneModule.OnChangeResolution();
        
        CallOnFrameEnd("ReloadBackground");
        CallOnFrameEnd("RemoveYesNoDlg");
    }
    
    void RemoveBackground()
    {
        if(cMenuBackground != null) 
        {
            cMenuBackground.Remove();
            RemoveSprite(cMenuBackground);
            cMenuBackground.delete();
            cMenuBackground = null;
        }
//        Thread.dumpStack();
    }
    
    void LoadBackground()
    {
        if(cMenuBackground == null)
        {
            cMenuBackground = (ChromeMenuBackground)CreateObject("ChromeMenuBackground");
   		    cMenuBackground.Hide();
        }
        //Thread.dumpStack();
    }
    
    void ReloadBackground()
    {
        RemoveBackground();
        
        LoadBackground();
        
        if(cMenuBackground != null)
   		    cMenuBackground.Show();
    }
    public void OnLoadingProgress(float fPercent)
    {
        if(m_bLoadinfScene3D) 
			return;
		
		float fSizeX = fPercent * nProgressSizeX;
        cProgressBar.SetSize(new Vector(fSizeX, nProgressSizeY,0));
        
        ForceRender();
    }
    
    ChromeCreditsMenu m_cCredits = null;
    
    void ExitMenuGame()
    {
        // kasujemy sie ladnie
        //CallMethodIn("delete", 0);
                
        if (ChromeModuleSingle._bCDActionDemo ||
            ChromeModuleSingle._bPrologDemo ||
            ChromeModule._bMultiplayerDemo)
        {
            SetMenu("ChromeCreditsMenu");
            ((Cursor)cCursor).cursorTex.SetNoTexture();
        }
        else
        {
            // wychodzimy z gry
                Game.ExitGame();    
        }
    }

    /** Klasa aktualnie pokazywanego menu
     */
    String sMenuWindowName=null;
    
    /** Powoduje przejscie do menu o podanej klasie.
     * Wolane zewnetrznie z klas Window odpowiednich menu
     */
    public void SetMenu(String sTargetMenu)
    {
        if (!sTargetMenu.equalsIgnoreCase("ChromeLoadingScreen"))
        {
            LoadBackground();
            cCursor.Show();
        }
        SetState("MenuState");
		((MenuState)CurrentState).vParams = null;
        if (sMenuWindowName != null)
            sMenuBackName = new String(sMenuWindowName);
        else
            sMenuBackName = null;
        sMenuWindowName=new String(sTargetMenu);
    }
    
    public void SetMenu(String sTargetMenu, java.util.Vector vParams)
    {
        if (!sTargetMenu.equalsIgnoreCase("ChromeLoadingScreen"))
        {
            LoadBackground();
            cCursor.Show();
        }
        SetState("MenuState");		
		((MenuState)CurrentState).vParams = vParams;
        if (sMenuWindowName != null)
            sMenuBackName = new String(sMenuWindowName);
        else
            sMenuBackName = null;
        sMenuWindowName=new String(sTargetMenu);
    }
	
	//podobnie jak setmenu tylko nie podmienia sMenuBackName
	public void SetMenuUnnoticed(String sTargetMenu)
    {
        SetState("MenuState");
        sMenuWindowName=new String(sTargetMenu);
    }
    
    
    MenuYesNoDialog GetYesNoDlg(ChromeMenuWindow cInterface)
    {
        if (m_cYesNoDlg == null)
            m_cYesNoDlg = (MenuYesNoDialog)(CreateObject("MenuYesNoDialog"));
        
        if (m_cYesNoDlg.GetOwner() != null)
        {
            Tools.CrashLogWarning("obiekt MenuYesNoDialog jest juz zajety przez " + m_cYesNoDlg.GetOwner());
            return null;
        }
        else
        {
            m_cYesNoDlg.SetOwner(cInterface);
            return m_cYesNoDlg;
        }
    }
    
    void ReleaseYesNoDlg(ChromeMenuWindow cInterface)
    {
        if (cInterface != m_cYesNoDlg.GetOwner())
            Tools.CrashLogWarning(cInterface + " probuje zwolnic m_cYesNoDlg, a jest on zajety przez " + m_cYesNoDlg.GetOwner());            
        else
            m_cYesNoDlg.SetOwner(null);
    }
    /** Ustawienie menu o podanej stringiem klasie.
     * Automatycznie pokazuje okienko menu
     */
    void SetMenuWindow(String sMenuClassName)
    {
        Menu = (ChromeMenuWindow)CreateObject(sMenuClassName);    
		if (((MenuState)CurrentState).vParams != null)
			Menu.SetParams(((MenuState)CurrentState).vParams);		
		Menu.SetModule(this);
		Menu.Init(null);	
        Menu.MoveTop();
        cCursor.MoveTop();
		Menu.Hide();
    }
    
    
    /** Zatrzymanie wolania timehandlerow w MeshObject'ach
     */
    void FreezeAllMeshObjects()
    {
        GameObject[] aObjs = GetObjectsFromClass("MeshObject");
        for (int i=0; i<aObjs.length; i++)
        {
            GameObject cObj = aObjs[i];
            cObj.FreezeCallMethods();
        }
    }

    /** Wznowienie wolania timehandlerow w MeshObject'ach
     */
    void UnfreezeAllMeshObjects()
    {
        GameObject[] aObjs = GetObjectsFromClass("MeshObject");
        for (int i=0; i<aObjs.length; i++)
            aObjs[i].UnfreezeCallMethods();
    }

    
    /** Podstawowa klasa do obslugi menu
     */
    public class MenuState extends State
    {
        boolean bInitilized=false;
		
		java.util.Vector vParams = null;

        public void OnEnter()
        {
            bInitilized=false;
        }
        
        public void OnFrame()
        {
            if(!bInitilized)
            {
                bInitilized=true;
                //
                InitializeState();                
            }
            
            // sprawdzamy czy muzyka sie odgrywa
            LoopMenuMusic();
        }
    
        /** W tej metodzie powinna odbywac sie inicjalizacja tla i kontrolek menu
         */
        public void InitializeState()
        {
            
			int nReturnMovie = -1;
            if(Menu != null )
            {
				m_bLastWasMainMenu = (Menu instanceof ChromeMainMenu);
					
				nReturnMovie = Menu.nMovieOut;
                Menu.Hide();
                RemoveCurMenu();
            }
			
			// ustawiamy menu na ktore zostal wlaczony stan
            if( sMenuWindowName != null)
                SetMenuWindow(sMenuWindowName);
			
			if(Menu != null)
			{
				if (m_c3DSceneModule != null && nReturnMovie != -1 && (Menu.nMovieIn != -1 || Menu instanceof ChromeMainMenu))
				{
					m_bFilmOutPlayed = true;
					m_c3DSceneModule.PlayMovie(nReturnMovie, ChromeMenuModule.this, "MovieToCurMenu");
				}   
				else
				{
					m_bFilmOutPlayed = false;
					//CallMethodIn("MovieToCurMenu", 0);
                    MovieToCurMenu();
				}
			}
            // ustawiamy tlo w menu
            //FogSetColor(0, 0, 0);
        }
        
		void OnInputKey(int nKeyCode, boolean bKeyState, char nKeyAscii)
        {
            if( !bKeyState ) return;
            
            if(nKeyCode==EKey._SPACE || nKeyCode==EKey._RETURN)
            {
                //przerwanie dzialania filmu
				if (m_c3DSceneModule != null &&
                    m_c3DSceneModule.CanStopMovie())
					m_c3DSceneModule.CallMethodIn("OnEndMovie", 0);
            }
			
			if (Menu != null && 
				(Menu instanceof ChromeMainMenu ||
                 Menu instanceof InGameMenu)&&
				bKeyState &&
                !bMenuNetInGame &&
				nKeyCode == EGameControl.QUICKLOAD &&
                ((ChromeGame) ChromeGame.cSingleton).IsLoadSaveEnabled())
            QuickLoad(false);

        }    
        
        public void OnInputMouseButton(int nButton, int nState)
        {
            boolean bRShift = GetKeyState(EKey._RSHIFT);
            boolean bLShift = GetKeyState(EKey._LSHIFT);
            
            if(nState == 0 && 
               (bRShift || bLShift) && 
               ChromeGameRunInfo.s_bShowCheatLevelsMenu)
            {
                SetMenu("TestMainMenu");
            }
            else
            {
                //przerwanie dzialania filmu
                if (nState == 0 && 
                    m_c3DSceneModule != null && 
                    m_c3DSceneModule.CanStopMovie())
                    m_c3DSceneModule.CallMethodIn("OnEndMovie", 0);
            }
        }
    }
    
	void MovieToCurMenu()
	{
		
		if (Menu != null)
		{
			//LogR("MovieToCurMenu movie " + Menu.nMovieIn + " menu " + Menu);
			if ((Menu.nMovieIn != -1 ) && (m_c3DSceneModule != null) && (m_bFilmOutPlayed || m_bLastWasMainMenu))
				m_c3DSceneModule.PlayMovie(Menu.nMovieIn, this, "ShowCurMenu");
			else
				ShowCurMenu();
		
		}
	}
	
	void ShowCurMenu()
	{
		if (Menu != null)
		{
			//LogR("ShowCurMenu loop " + Menu.nMovieLoop + " menu " + Menu);
			Menu.Show();
			if ((Menu.nMovieLoop != -1) && (m_c3DSceneModule != null))
				m_c3DSceneModule.PlayMovieLoop(Menu.nMovieLoop);
		}
	}
    
    
	
	
///////////////////////////////////
// Stany odpowiadajace ladowaniu //
///////////////////////////////////
    public class LoadLevel extends MenuState
    {
        void MenuLoadLevelBegin()
        {
            // wylaczamy muzyke
            StopMenuMusic();
            
			DeleteScene3D();
			
            sMenuWindowName=null;
            SetMenu("ChromeLoadingScreen");
                          
            cCursor.Hide();
        }
        
        void MenuLoadLevelDescript()
        {
            // pokazujemy tlo dla wczytywanego levelu
            String sLevelBack = cGameInitInfo.cLevels.GetCurrent().sDescriptionLevelBackground;
            String sLevelDescript = cGameInitInfo.cLevels.GetCurrent().sDescriptionLevel;
            if (Menu != null && Menu instanceof ChromeLoadingScreen)
            {
                
                if (sLevelDescript == null || sLevelBack == null)
                {
                    ((ChromeLoadingScreen)Menu).SetDescription(null);
                    ((ChromeLoadingScreen)Menu).SetScreenShot(null);
                    ((ChromeLoadingScreen)Menu).SetPreFilmBackground();
                }
                else
                {
                    ((ChromeLoadingScreen)Menu).SetDescription(Text.Get(sLevelDescript));
                    ((ChromeLoadingScreen)Menu).SetScreenShot(sLevelBack);
                }                
            }
            
            ShowProgress();
            cProgressBar.MoveTop();
            
            ForceRender();
        }
        
        void MenuLoadLevelEnd()
        {
            RemoveCurMenu();
            
            cProgressBar.Hide();
            cProgressBar.SetSize(new Vector(0, nProgressSizeY,0));
        }
        
        void LoadSavedGame()
        {
            boolean bLoadLevel = false;
            
            
        }
        
        public void InitializeState()
        {
            // flaga okresla czy odczytujemy level
            boolean bLoadLevel = true;
            
            // sprawdzamy czy nie trzeba odczytac SaveGame'a
            if( sSaveGameName!=null )
			{
				if (cGameInitInfo == null ||
                    cGameInitInfo instanceof NetGameInitInfo)
					cGameInitInfo = new GameInitInfoSingle();

                cSG.PreLoad(sSaveGameName, cGameInitInfo);
                
                // okreslamy czy wczytac level
                bLoadLevel = ((GameInitInfoSingle)cGameInitInfo).bLoadLevel;
                
                // jak nie ma jeszcze zadnego levelu to i tak ladujemy
                if(ActiveLevelModule==null)
                    bLoadLevel = true;
			}
			
            MenuLoadLevelBegin();
			super.InitializeState();
            
			Module cLoadedModule = null;
			
            try 
            {
				// pokazujemy opis misji na menu z odpowienim tlem
				MenuLoadLevelDescript();
				
				if(bLoadLevel)
				{
                    // wylaczamy poprzednia gre na wypadek wszelki
				    ShutdownGame();
                
					// ladujemy level
					cLoadedModule = cGameInitInfo.LoadCurrentLevel(ChromeMenuModule.this);

					// sprawdzamy czy modul sie wczytal
					if( cLoadedModule ==null ) throw new Exception();

					// przeksztalcamy wczytany modul w arcydzielo
					ActiveLevelModule = (ChromeModule)cLoadedModule;
				}
				

                // doczytujemy pelne dane z Save'a
                if( sSaveGameName!=null )
				{
					if (ActiveLevelModule instanceof ChromeModuleSingle)
						((ChromeModuleSingle)ActiveLevelModule).sSaveGameName = new String( sSaveGameName );
					
                    // odczytujemy save'a
                    cSG.Load(sSaveGameName, ActiveLevelModule);
				}
				
                		
                
				sSaveGameName = null;                
            }
            catch(Exception e)
            {
                if(cLoadedModule==null) CrashLog("[ChromeMenuModule$LoadLevel.InitializeState] Couldn't load level.\n");
                if(e instanceof ClassCastException) CrashLog("[ChromeMenuModule$LoadLevel.InitializeState] Wrong module class.\n");
                
                CrashLog("[ChromeMenuModule$LoadLevel.InitializeState] Error:\n");
                e.printStackTrace();
                
                // nie zaladowal sie level, wiec trzeba wrocic do menu
                SetMenu("ChromeMainMenu");
                cCursor.Show();
            }

            MenuLoadLevelEnd();
            // wlaczamy gre
            SetState("DuringGame");		
        }
        
        void OnInputKey(int nKeyCode, boolean bKeyState, char nKeyAscii)
        {
            if( !bKeyState ) return;
            
            /*
            if(nKeyCode==EKey._SPACE)
            {
                LogD("SPACE\n");
                HideLevelDescription();
                UnfreezeAllMeshObjects();
                SetState("DuringGame");    
            }
            */
        }    
    }
    
    /** Rozpoczecie gry z podaniem jej typu poprzez obiekt GameInfo.
     */
    void StartGame()
    {
        // wczhodzimy do wczytywania gry
        SetState("LoadLevel");
    }
    
        
    /** Ustawia w menu rozpoczecie nowej gry - ciagu leveli
     */
    void NewGame(GameInitInfo gameinit)
    {
        // gdy juz jest jakis inny typ gry to trzeba go wywalic
        if( (cGameInitInfo != null) && (cGameInitInfo != gameinit))
            cGameInitInfo.Destroy();
        
        cGameInitInfo=gameinit;
    }
    
/////////////////////////////////
// Stan powrotu do menu z gry  //
/////////////////////////////////

    void CancelGame()
    {
        //cMenuBackground.ShowMain( "" );
        //cMenuBackground.ShowMain( MenuTextures.sBackLoading );
        CallOnFrameEnd("ShutdownGameAndShowMenu");
    }

	void LevelFailedCancelGame()
	{
		SetMenu("InGameMenu");
	}

	
    /** Wejscie w ten stan powoduje aktywowanie levelu ze zmiennej ActiveLevelModule
     */
    public class DuringGame extends State
    {
        public void OnEnter()
        {
            // chowamy tlo zawsze
            //cMenuBackground.Hide();
            
            // aktywujemy modul do zagrania
            if(ActiveLevelModule != null) 
            {
                if (!ActiveLevelModule.AmIDedicatedServer())
                    ActiveLevelModule.SetRenderSpritesOnly(false);
                ActiveLevelModule.Activate();
            }

            // wylaczamy sami siebie
			Deactivate();

            // ustawiamy kolor ostatnio zapamietany
            
            // wylaczamy muzyke
            StopMenuMusic();
        }
        
        void OnActivate()
        {
            MethodCaller.cThis.DisableMenuCallPostOnDeactivate();
            
            //FogSetColor(0,0,0);
            // zapamietujemy kolor tla wtrakcie gry
            
            nEAXEnv = SetSoundEnvironment(ESoundEnv.SOUNDENV_NONE, 0);
        
            if (ActiveLevelModule != null)
            {
                Player cPlayer = ActiveLevelModule.GetMainPlayer();
                if (cPlayer != null)
                {
                    HUDImplant cImplants = ((PlayerHUD)cPlayer).HUD.GetHUDImplant();
                    if (cImplants != null)
                        cImplants.Deactivate();
                }
            }
            
            // tu trzeba rozpoznac powod wejscia do menu
            LogR("DURINGGAME - OnActivate() ActiveLevelReturnValue="+ActiveLevelReturnValue+"\n");
            switch(ActiveLevelReturnValue)
            {
                case ChromeModule._LEVEL_CANCELED: // gra przerwana poprzez 
                        LevelFailedCancelGame();
                    break;
                    
                case ChromeModule._LEVEL_INPROGRESS: // w trakcie gry
                    {
                        if ( cGameInitInfo instanceof NetGameInitInfo )
                            SetMenu("MenuNetInGame");
                        else
						{
							ChromeGame game = (ChromeGame) ChromeGame.cSingleton; 
                            SetMenu("InGameMenu");
							StartMenuMusic();
						}
                    }
                    break;
                    
                case ChromeModule._INVENTORY_MENU_CANCELLED:
                    CancelGame();
                    break;
                    
                case ChromeModule._LEVEL_QUICK_LOADING:
                    ActiveLevelModule.Deactivate();
                    QuickLoad(false);
                    break;
                    
                case ChromeModule._LEVEL_FINISHED: // koniec levelu, ale teraz ma sie odpalic kolejny w zaleznosci od typu gry
                    {
                        cGameInitInfo.SetNextLevel();
                        if( cGameInitInfo.cLevels.GetCurrent() != null )
                            CallOnFrameEnd("ShutdownAndLoadLevel");
                        else
                        {
                            if (ChromeModuleSingle._bCDActionDemo ||
                                ChromeModuleSingle._bPrologDemo ||
                                ChromeModule._bMultiplayerDemo)
                                ExitMenuGame();
                            else
                                CancelGame();
                        }
                    }   
                    break;
                    
                case ChromeModule._LEVEL_SERVER_FINISHED: // koniec levelu na serverze
                    {
                        cGameInitInfo.SetNextLevel();
                        if( cGameInitInfo.cLevels.GetCurrent() != null )
                        {
                            CallOnFrameEnd("ShutdownAndStartServer");
                        }
                        else
                            CancelGame();
                    }   
                    break;
                    
                case ChromeModule._LEVEL_CLIENT_FINISHED: // koniec levelu na cliencie
                    {
                        // w grze sieciowej na kliencie aktualny level
                        // zostal wczesniej ustawiony
                        if( cGameInitInfo.cLevels.GetCurrent() != null )
                        {
                            LogD("cGameInitInfo.cLevels.GetCurrent() " + cGameInitInfo.cLevels.GetCurrent() + "\n");
                            CallOnFrameEnd("ShutdownAndStartClient");
                        }
                        else
                            CancelGame();
                    }   
                    break;
            case ChromeModule._LEVEL_CLIENT_FAILED_TO_ENTER_GAME:
                    {
                        ShutdownClientGame();
                    }
                    break;
            }
            
            // rejestrujemy klawisze, zeby mozna bylo chodzic po menu
            RegisterKeyRequest();
            RegisterMouseButtonRequest();
        }
    }
    
    void ShutdownGameAndShowMenu()
    {
        
        // wlaczamy menu
        if(bDemo)
            SetMenu("ChromeCreditsMenu");
        else
            SetMenu("ChromeMainMenu");
        
        CallMethodIn("ShutdownGame",0);
        
        
        CallMethodIn("StartMenuMusic",0);;
    }
    
    void ShutdownAndLoadLevel()
    {
        ShutdownGame();
        
        // wczytujemy kolejny level
        SetState("LoadLevel");
    }
        
    void ShutdownAndStartServer()
    {
        ShutdownGame();
        
        // od nowa tworzymy serwer
        ModuleNet.CreateServer(ChromeMenuModule.this, (NetGameInitInfo)cGameInitInfo);
    }
    
    void ShutdownAndStartClient()
    {
        ShutdownGame();
        
        //powracamy na ekran join
        //TODO: dopracowac....
        NetServerInitInfo cServerInitInfo = (NetServerInitInfo)((NetGameInitInfo)cGameInitInfo).GetServerInfo(); 
        ChromeNetJoinMenu.ForceJoinServer( this, 
                                           cServerInitInfo.GetServerAddr(),
                                           cServerInitInfo.GetGamePort(),
                                           true); 
    }
    
    void ShutdownClientNetModule()
    {
        ShutdownGame();
        SetMenu("ChromeNetJoinMenu");
    }

    /*
	void ShutdownAndStartClient()
    {
        ShutdownGame();
        
        //TODO: ustalic do jakies gry sie podlaczamy!!!
        
        // od nowa tworzymy klienta
        
        SetMenu("ChromeNetJoinMenu");
        
        //TODO: odpalic ponowne przylaczanie sie do servera, 
        //na ktorym gralismy poprzednio        
    }*/
	
    void ShutdownGame()
    {
		boolean bMusicStopped = StopMenuMusic();
        ActiveLevelReturnValue = -1;
        ShowPleaseWaitText();
        
		DeleteActiveLevelModule();
        
			
        if (Menu != null && !(Menu instanceof ChromeLoadingScreen))
        {
            LoadScene3D();
            if(Menu instanceof ChromeMainMenu)
                ((ChromeMainMenu)Menu).InfoText("");
            cCursor.Show();
            if(Menu instanceof ChromeMainMenu)
                ((ChromeMainMenu)Menu).ShowButtons();
            ShowCurMenu();
            //odkryje sie scena pod spodem
            cMenuBackground.Show();
            
        }       
		if(bMusicStopped)
			StartMenuMusic();
    }
	
	void DeleteActiveLevelModule()
	{
        if(ActiveLevelModule!=null)
        {
            ActiveLevelModule.delete();
            ActiveLevelModule=null;
            // kasujemy lightmapy po levelu
            ShutdownLightmapMgr();
        }
	}
	
	void ShowPleaseWaitText()
	{
		if (Menu != null && sMenuWindowName.equalsIgnoreCase("ChromeMainMenu"))
		{
			Menu.InfoText("&MENU_MAIN_PLEASE_WAIT&");
			cCursor.Hide();
			((ChromeMainMenu)Menu).HideButtons();
			ForceRender();
		}       
	}
	
	void ShutdownClientGame()
	{
		//boolean bMusicStopped = StopMenuMusic();
		
		ShowPleaseWaitText();
		DeleteActiveLevelModule();
		
        LoadBackground();
        cMenuBackground.Show();
            
		LoadScene3D();
		
		SetMenu("ChromeNetJoinMenu");
		//if(bMusicStopped)
		StartMenuMusic();
	}
	
	
	void ShutdownServerGame()
	{
		//boolean bMusicStopped = StopMenuMusic();
		ShowPleaseWaitText();
		
		DeleteActiveLevelModule();

		cMenuBackground.Show();
		LoadScene3D();
		
		SetMenu("ChromeNetCreatMenu");
		SetRenderSpritesOnly(false);
		//if(bMusicStopped)
		StartMenuMusic();
	}
	
    void QuickLoad(boolean bRestart)
    {
        String sSaveName = null;
				
        if (bRestart)
            sSaveName = cSG._SG_RESTARTSAVELOAD_FILE;
        else
            sSaveName = ChromeMenuLoad.GetActiveQuickSave();

        if (sSaveName == null)
            return;
        
        java.io.File cFile = new java.io.File(sSaveName);
        if (!cFile.exists())
            return;
        
		FileChunk.Log("Loading <"+sSaveName+">\n");
		sSaveGameName = sSaveName;
		
		MuteAllSounds();
		StartGame();
		UnMuteAllSounds();		
		
        
        //CallOnFrameEnd("AfterQuickLoad");
        //MethodCaller.cThis.MenuCallAfterQuickLoad(this);
                        
    }
	
    /*void AfterQuickLoad()
    {
        if(ActiveLevelModule != null)
        {
            // wylaczamy ewentualnego huda statystyk
            ((ChromeModuleSingle)ActiveLevelModule).DisableMissionEnd();
        }
    }*/
    
	void LoadScene3D()
	{
        SetRenderSpritesOnly(false);
        if (ChromeGameRunInfo.s_bLoadMenu3dScene)
        {
		    m_bLoadinfScene3D = true;
		    if(m_c3DSceneModule == null)
		    {
		    	m_c3DSceneModule = (Chrome3DSceneModule)LoadModule(Chrome3DSceneModule._3DSCENEMAP_FILE);
		    	m_c3DSceneModule.Activate();
		    }
		    m_bLoadinfScene3D = false;
        }
	}
     
	void DeleteScene3D()
	{
		if(m_c3DSceneModule!=null)
		{
			m_c3DSceneModule.Deactivate();
			m_c3DSceneModule.delete();
            ShutdownLightmapMgr();
            m_c3DSceneModule = null;
		}
	}
}
