public class ChromeModulePreMission extends ChromeModule
{
    /** Film odpalany na poczatek */
    public Movie cStartMovie = null;//#MOVIE;
    
    /** Filmy odpalane na poczatek */
    public Movie[] aMovies = null;//#MOVIE;
    
    /** Muzyka odpalona podczas briefingu */
    public Music cMusic = null;//#MOVIE;
    
    // muzyczki pod poszczegolne filmy
    public Music[] aMusics = null;//#MOVIE;
    
    //FreeCamera cFreeCam = null;
    CameraTracking cTrackingCam = null;
    MeshObject cSceneryObject = null;
    LevelContent cLevelInfo = null;
    
    UIStatic m_cText = null;
    //Film film = null;
    
    void OnCreate()
    {
        super.OnCreate();
        
        PumpObjectsExtents(this);
       
        // zasieg widocznosci obiektow sa wielkie, bo duze obiekty sa pokazywane
        SetObjectsVisibilityRange(100000.0f, 1000000.0f);
        
        RegisterKeyRequest();
        
        cLevelInfo = cGameInitInfo.cLevels.GetCurrent(); 
        if ( cLevelInfo.nLevelType == cLevelInfo._MAP )
        {
            Terrain_EnableHorizon(false);
            
            // wlaczamy beriefing
            StartBriefing();
        }
        else
        {
            FogSetColor(0,0,0);
            
            // tworzymy kamere do sledzenia
            cTrackingCam = (CameraTracking)CreateObject("CameraTracking");
        
            // inicjalizujemy grida odpowiednio duzego zeby nie bylo !
            // grid ma 20km na 20km kratka grida to 2km
            InitGrid(200000.0f, 200000.0f,
                     -2000000.0f, 2000000.0f,
                     -2000000.0f, 2000000.0f,  
                     -2000000.0f, 2000000.0f);
        
            if ( cLevelInfo.nLevelType == cLevelInfo._MOVIES_S )
            {
                PlayScenery(cLevelInfo.sPhat3DA, cLevelInfo.sPhatWAV, cLevelInfo.sTrackingMeshElementName, cLevelInfo.sCameraName, cLevelInfo.nLastAnimFrame, cLevelInfo.fFOV, cLevelInfo.fFadingTime);
            }
            
            if ( cLevelInfo.nLevelType == cLevelInfo._MOVIES_TH )
            {
                SetState("PlayMovie");
            }
        }
    }
    
    static void PumpObjectsExtents(Module cModule)
    {
        GameObject[] aAll = cModule.GetObjectsFromClassModule("MeshObject", cModule);
        if(aAll == null) return;
        
        Vector vMin = new Vector();
        Vector vMax = new Vector();
        for(int i=0; i<aAll.length; ++i)
        {
            MeshObject cObj = (MeshObject)aAll[i];
            
            cObj.GetMeshExtents(vMin, vMax);
            float fDist = 3f*vMin.Distance(vMax);
            vMin.fX -= fDist; vMin.fY -= fDist; vMin.fZ -= fDist;
            vMax.fX += fDist; vMax.fY += fDist; vMax.fZ += fDist;
            
            cObj.SetExtents(vMin, vMax);
        }
    }
    
    void OnDestroy()
    {
        super.OnDestroy();
        
        if (m_cText != null)
        {
            RemoveSprite(m_cText);
            m_cText.delete();
            m_cText = null;
        }
        
        if(cTrackingCam != null)
        {
            cTrackingCam.delete();
            cTrackingCam = null;
        }
        
    }
    
    void OnDeactivate()
    {
    }
    
    /** Metoda wspolna dla wszystkich typow premission
     */
    void EndPrepareToMission()
    {
        super.EndPrepareToMission();
        SetState("BackFromScenery");
    }

    void ShowTextLevel01()
    {
        if (m_cText == null)
        {
            m_cText = (UIStatic)CreateObject("UIStatic");
            AddSprite(m_cText);
            m_cText.OnInit();
            m_cText.UpdateLogicSizeAndPos(new Vector(GetScreenWidth(), 20, 0), new Vector(0, 3f*GetScreenHeight()/4f, 0));
            m_cText.OnSizeAndPos();
            m_cText.SetFont(ChromeFonts.FONT_VERDANA_18);
            m_cText.SetTextPosFlags(ESpriteText.CENTER);
        }
        m_cText.Show();
        m_cText.SetText("&LEVEL01_PRE_MISSION_TEXT&");
        m_cText.CallMethodIn("Hide", 5f);
        
    }
    
    void HideTextLevel01()
    {
        if(m_cText != null)
        {
            m_cText.Hide();
            m_cText.DisableCallMethod("Hide");
        }
    }
    
    
    /**Stan do odgrywania filmow z gadjacymi Loganami
     */
    /*
    public class PlayMovie extends FadeScene
    {
        public void OnEnter()
        {
            film = (Film)CreateObject("Film");
            film.SetScene(cLevelInfo.sLevelName);
            film.SetScriptScene(cLevelInfo.sMoviesScr);
            film.cBackModule = ChromeModulePreMission.this;
            fFadingTime = cLevelInfo.fFadingTime;
            film.StartScene();
            FadeIn(fFadingTime);
            //FadeIn(10f);
        }
        
        void OnFadeInEnd()
        {
            film.SetState("PlayingScene");
        }
        
        void OnInputKey(int nKeyCode, boolean bKeyState, char nKeyAscii)
        {
        }
    }
    */
    
    public class Idle extends State
    {
        public void OnEnter()
        {
            
        }
    }
    
    /** Stan odapalany gdy skonczy sie kazda scenka.
     * Powinien byc pokryty w celu stwierdzenia co zrobic po scence
     */
    public class BackFromScenery extends FadeScene
    {
        boolean bDeleteMenu = false;
        
        public void OnEnter()
        {
            LogR("BackFromScenery.OnEnter");
            
            //HACK, natychmiastowe wylaczenie bez fade'a
            //FadeOut(fFadingTime);
            OnFadeOutEnd();
        }
        
        void OnFadeOutEnd()
        {
            LogR("BackFromScenery.OnFadeOutEnd");
            RemoveAll();
        }
        
        void RemoveAll()
        {
            if(cTrackingCam != null)
            {
                cTrackingCam.ChangeTarget(null);
            }
            
            if ( cSceneryObject != null )
            {
                cSceneryObject.delete();
                cSceneryObject=null;
            }
            
            /*
            if ( film != null )
            {
                film.delete();
                film = null;
            }
            */
            
            // standarodow zmieniamy kamere
            //ActivateCamera(cFreeCam);
            
            if (m_InventoryWindow != null)
            {
				LogR("Usuwam inventory window\n");
                ((ChromeInventoryMenu)m_InventoryWindow).Deactivate();
                m_InventoryWindow.Remove();
                RemoveSprite(m_InventoryWindow);
                m_InventoryWindow.delete();
                m_InventoryWindow = null;
            }
            
            if ( cMenu != null )
            {
                cMenu.ActiveLevelReturnValue = ChromeModule._LEVEL_FINISHED;
                Deactivate();
                cMenu.Activate();
            }
            else
            {
                // jesli film zostal odpalony nie zmeni ale z gry to modul musi byc deaktywowany
                Deactivate();
            }
        }
    }
   
///////////////////////////////////////
//
///////////////////////////////////////
    int nMovie = 0;
    
    void StartBriefing()
    {
        // kasowanie na dzien dobry
        HideTextLevel01();
        
        String sNext = "StartPrepareToMission";
        
        if(aMovies != null)
        {
            cStartMovie = aMovies[nMovie];
            
            if(aMusics[nMovie] != null) aMusics[nMovie].Start();
            
            nMovie++;
            
            if(nMovie < aMovies.length)
                sNext = "StartBriefing";
        }
        else
            if(cMusic != null) cMusic.Start();
        
        if(cStartMovie == null)
        {
            cStartMovie = (Movie)CreateObject("Movie");
            cStartMovie.nMovie = 1;
            cStartMovie.fMovieFadeOut = 0.0f;
            cStartMovie.fWorldFadeIn = 0.0f;
        }
        
        cStartMovie.Play(ChromeModulePreMission.this, sNext);
    }

    void OnInputKey(int nKeyCode, boolean bKeyState, char nKeyAscii)
    {
        if(bKeyState)
        {
            if(nKeyCode==EKey._ESCAPE)
            {
                if( IsMoviePlaying() )
                {
                    StopMovieFade();
                }
                else
                {
                    // wlaczamy to co ma byc po filmie
                    if(!(CurrentState instanceof ChromeModule.PrepareToMission))
                        StartPrepareToMission();
                }
            }
        }
    }
    
    void StartPrepareToMission()
    {
        // kasowanie na dzien dobry
        HideTextLevel01();
        
        FadeDeleteSprite();
        
        cFreeCamera.UnregisterKeyRequest();
        cFreeCamera.UnregisterMouseAxisRequest();

        // sprawdzamy czy nie ma podzielenia akcji
        if(cLevelInfo.aActionPaths.size() > 0)
        {
            // TODO rozdzielenie akcji
            
        }
        else
        {
            if(cLevelInfo.bPrepareToMission)
                SetState("PrepareToMission");
            else
                SetState("BackFromScenery");
        }
    }
    
///////////////////////////////////////
// Uruchomienie scenki, gdzie kamera //
///////////////////////////////////////
    
    /** Parametry ogrywania sceneri latajacej */
    String sSceneryObject       = null;
    String sWaveName            = null;
    String sTrackingElement     = null;
    String sCameraName          = null;
    int nLastAnimFrame          = 0;
    float fFOV                  = 60.0f;
    float fFadingTime           = 1.0f; // niknacy czas
    
    /** Uruchamia scenke o zadanych parametrach
     * @param sMeshName plik z meshem na dysku, ktory zawiera scenke
     * @param sWaveName plik z muzyka do scenki
     * @param sTrackingElement MeshElement powyzszego mesha ktory ma byc sledzony
     * @param vCamPos pozycja kamery
     * @param nLastAnimFrame numer ostaniej ramki animacji
     * @param fDesiredFov FOV w trakcie grania filmu
     * @param fFade czas przez jaki scenka sie wygasza
     */
    
    void PlayScenery(String sMeshName, String sWave, String sTrackingElement, String sCameraName, int nLastFrame, float fDesiredFov, float fFade)
    {
        this.sWaveName = sWave;
        this.sSceneryObject = sMeshName;
        this.sTrackingElement = sTrackingElement;
        this.sCameraName = sCameraName;
        this.nLastAnimFrame = nLastFrame;
        fFOV = fDesiredFov;
        fFadingTime = fFade;
                   
        SetState("PlayScenery");
    }
    
    public class PlayScenery extends FadeScene
    {
        int nWave = -1;

        public void OnEnter()
        {
            LogD("\n");
            
            // tworzymy obiekt ktory jest sceneria
            cSceneryObject = (MeshObject)CreateObjectNoInit("MeshObject");
            cSceneryObject.ClearFlag(EFlags._NO_ANIMATION);
            cSceneryObject.MeshName = sSceneryObject;
            cSceneryObject.InitObject();
            cSceneryObject.ActivateOnModule();
            
            cSceneryObject.SetPosition(new Vector(0,0,0));
            
            if(cSceneryObject == null)
                LogD("No scenery object\n");
            else
            {
                LogD("Initializing animation\n");
                
                cSceneryObject.InitAnimSeq("loop", 0, nLastAnimFrame);
                
                // ustawiamy kamere, zeby napewno widziala obiekt
                Vector vMin=new Vector();
                Vector vMax=new Vector();
                cSceneryObject.GetMeshExtents(vMin, vMax);
                
                LogD("Setting cliping\n");
                cTrackingCam.SetClipNear(1.0f);
                cTrackingCam.SetClipFar(2000000.0f);
            
                SetObjectsVisibilityRange(100000.0f, 1000000.0f);
            }

            // przygotowujemy kamere odpowiednio
            int nCamID = cSceneryObject.GetElementID(sCameraName);
            if(nCamID != -1)
            {
                Vector vPosition = cSceneryObject.GetElementPos(nCamID);
                Vector vForward = cSceneryObject.GetElementForwardVector(nCamID);
                Vector vUp = cSceneryObject.GetElementUpVector(nCamID);

                cTrackingCam.FromForwardUpPos(vForward, vUp, vPosition);
            }
            else
            {
                LogD("Brak kamery \"" + sCameraName + "\" w scenie\n");
                cTrackingCam.FromForwardUpPos(new Vector(1,0,0),new Vector(0,1,0),new Vector(0,0,0));
            }

            if(sTrackingElement != null)
                cTrackingCam.ChangeTarget(cSceneryObject, sTrackingElement);

            cTrackingCam.SetFOV(fFOV);

            SetViewFullscreen(cTrackingCam);
            
            // fejdujemy
            FadeIn(fFadingTime);
            
            bSceneTerminated = false;
        }
        
        void OnFadeInEnd()
        {
            //Log("Animacja: "+ cSceneryObject.GetAnimLength("loop") +"\n");
            cSceneryObject.SetAnimFreq("loop", 25);
            cSceneryObject.SetAnimMorphTime(0.0f);
            cSceneryObject.PlayAnim("Animacje", "loop", 1);
            float fAnimLen = cSceneryObject.GetAnimLength("loop");
            CallMethodIn("AnimEnded", fAnimLen);
            
            // odtwarzamy muzyke
            if(sWaveName != null)
            {
                LogD("Playing wave <"+sWaveName+">\n");
                nWave = PlayWave(sWaveName);
            }
        }
        
        void OnFadeOutEnd()
        {
            TerminateScene();
        }
        
        boolean bSceneTerminated = false;
        
        void TerminateScene()
        {
            bSceneTerminated = true;
            
            StopWave(nWave);
            
            StartPrepareToMission();
        }

        /** Wolane gdy konczy sie animacja dla scenery objecta
         */
        void AnimEnded()
        {
            if(!bSceneTerminated) TerminateScene();
        }
        
        void OnInputKey(int nKeyCode, boolean bKeyState, char nKeyAscii)
        {
            if((nKeyCode==EKey._ESCAPE) && (bKeyState) && !bSceneTerminated)
            {
                LogD("Esc pressed!\n");
                /*
                cSceneryObject.InitAnimSeq("loop_stop", nLastAnimFrame-1, nLastAnimFrame);
                cSceneryObject.SetAnimFreq("loop_stop", 25);
                cSceneryObject.PlayAnim("Animacje", "loop_stop", 1);
                */
                cSceneryObject.StopAnim("");
                
                FadeDeleteSprite();
                // przerywamy scenke
                TerminateScene();
            }
        }
    }
}
