import java.io.*;
public class ChromeModuleSingle extends ChromeModule
{
    static boolean  _bCDActionDemo = false,
                    _bPrologDemo = false,
                    _bEnglishDemo1 = false;

	// Prosz o uzupenianie tej listy z datami
	// Historia = (50033 = 11.08.03, ..., 50036 = 17.08.03)
    // Historia = (50037 = 17.08.03, ..., 50038 = 20.08.03) :)
    // 50040 = 21.08.03 wersja GM EN
    // 50041 = 15.09.03 wersja sprzed patcha EN
	public static int _SAVE_VERSION_NUMBER = 50041;
    
    boolean m_bImplantsAvailable = true;
    
    void SetEnglishDemo1(boolean bDemo)
    {
        _bEnglishDemo1 = bDemo;
    }
    
    
    ChromeModuleSingle()
    {
        // ustawiamy, aby modul nagrywal swoje dane
        bSG = true;
    }

    /** Nazwa klasy levelu. Pole uzupelniane przy odpalaniu levelu */
    public String sLevelName = null;//#NAME;
	
	public String sSaveGameName = null;
    
    /** Manager podpowiadaczy na poczatku misji */
    HintManager cHintManager = null;//dyn
            
    ////////////////////
    // MISC
    ////////////////////

    
    public String sLockerDefaultItems = "%15 Radio, %40 WeaponGrenade, %20 DrugHealthex, %3 DrugNeuralHealthex, %7 WeaponGrenadeCluster";//#LOCKER;All possible items than can be found in this locker with chances to appear [%]
    public int nLockerItemsChance = 50;//#LOCKER;Chance to find item on single shelf [%]

    /** Akcja odpalana po uruchomieniu gry */
    public Action[] cStartAction;//#\START;Actions run when level starts

    public Action[] aOnF2;//#\START;Actions run when F5 is pressed
    public Action[] aOnF3;//#\START;Actions run when F6 is pressed
    public Action[] aOnF7;//#\START;Actions run when F7 is pressed
    public Action[] aOnF8;//#\START;Actions run when F8 is pressed
    
    /** Gdy ustawione level konczy sie ostatnio pokazanym ekranem z gry */
    boolean bDontUseLevelFinishCamera = false;//dyn
    
    /** Ustawienie flagi powoduje, ze w misji defaultow sa niektore implanty */
    boolean bEasyImplants = false;
    
    //flaga mowiaca czy misja jest zakonczona sukcesem
    boolean bMissionSuccessful = false;
    
    /** HUD koncowy po misji lub zabiciu gracza */
    HUDStatistics cHUDStats = null;
    
    /** lista obiektow AIBase na levelu */
	//AIBase m_aAIActiveOnLevel[] = null;

    /** Czas kiedy wystartowala misja - do statystyk */
    float fMissionStartTime = 0;//dyn
    
    // terminal aktualnie pokazywany na ekranie
    ComputerTerminalNew cCurrentTerminal = null;

    Music cMusicSuccess = null;
    Music cMusicFailed = null;
    Music cMusicEnd = null;
    
    boolean m_bQuickloading = false;
    ////////////
    // GRACZ
    ////////////
    
    /** Nazwa klasy tworzonego playera - wykorzystywana w InitPlayer. */
	String m_sPlayerClassName = "PlayerSingle";
    
    /** Gracz */
    PlayerSingle MainPlayer = null;

    ///////////////////////////
    // WIDOCZNOSC OBIEKTOW
    ///////////////////////////
    /** Mnoznik zasiegu widzenia (dla AI) */
    public float fVisibilityRangeFactor    = 1.f;
    /** Maksymalny dopuszczalny zasieg widzenia (dla AI) */
    public float fVisibilityRangeThreshold = Float.MAX_VALUE;

	////////////
    // CAMERY
    ///////////
	
    //indeksy kamer
    final static byte CAMERA_PLAYER = 0;
    final static byte CAMERA_LEVEL_FINISHED = 1;
    final static byte CAMERA_PLAYER_DEATH = 2;
    
    
    boolean m_b_LEVEL_FINISHED = false;
    
    //kamery na levelu (przelaczanie F8 - cheat)
    Camera aCameras[] = new Camera[3];
	
    /** aktywna kamera */
    int nActiveCamera = CAMERA_PLAYER;
    
    ////////////////////////////
    // CHAT
    ////////////////////////////
    
    /** Scenariusz gadek uzupelniany w metodzie InitChatScenario */
    String aChatScenario[][] = null;
    
    /** Aktualnie odgrywana scenka, gdy nie ma scenki to -1 */
    int nScenePlaying = -1;//dyn
    
    /** Aktualnie ogrywany dialog w scenie */
    int nCurrentDialog = -1;//dyn

    /** przerwa (w sec) pomiedzy kolejnymi gadkami w scence */
    float fWavePause = 0.3f;    

    /** Sciezka do gadek */
    String sChatSoundsPath = "Data/Sounds/Levels/";
    
    ////////////////////////////
    // teksty do filmow TODO wywalic to i uzywac filmow z C++, ale UWAGA!
    // level02 korzysta z tych filmow
    ////////////////////////////
    
    String sMovieScenario[][] = null;

    String sFilmSoundsPath = "Data/Sounds/Films/";
    
	/** system alarmow na levelu */
	AlarmsManager m_AlarmsManager = null;
	
	/** czy w danej chwili odgrywana jest jakas gadka */
	boolean m_bPlayingScene = false;

    /** czy misja sie skonczyla */
    boolean m_bMissionEnded = false;
    
    
    /** Dummy Actor do wydawania noise'a tymczasowa pozycje do pobrania w OnHearNoise */
    public Actor DummyNoisyActor = null;

    // czy inventory ma byc przekazane po grze do menu
    boolean bLeaveInventory = false;
    
    int m_nBlackLoadingTex = 0;
    Sprite m_cBlackLoading = null;
    
    void OnCreate()
    {
        //w singlu detektor jest dostepny, w module netowym ustawiane to jest na false
        if (ChromeGame.GetDiffLevel() == ChromeGame.DIFF_VERY_HARD ||
            (cMenu!=null && cMenu.cGameInitInfo.cLevels.GetCurrent().bDisableDetector))
            HUDManager._DETECTOR_IS_AVAILABLE = false;
        else
            HUDManager._DETECTOR_IS_AVAILABLE = true;

        // odblokowujemy savey
        if(Game.cSingleton instanceof ChromeGame)
        {
            ChromeGame game = (ChromeGame)Game.cSingleton;
            game.EnableLoadSave(true);
        }
        
        super.OnCreate();

        fMissionStartTime = GetTime();
        if(sLevelName==null) 
            sLevelName = getClass().getName();

        ControlLoadSave.LoadKeySeting("Data\\UserControls.scr");
        ControlLoadSave.SetGameControls();
        
        RegisterKeyRequest();

        InitHints();
		
		Dialog.cPlayingDialog = null;
        
        cMusicSuccess = (Music)CreateObject("Music");
        cMusicSuccess.sMusic = new FileName("Data/Sounds/Music/MissionSuccessful.ogg");
        cMusicSuccess.nLoops = -1;
            
        cMusicFailed = (Music)CreateObject("Music");
        cMusicFailed.sMusic = new FileName("Data/Sounds/Music/MissionFailed.ogg");
        cMusicFailed.nLoops = -1;
        
        cMusicEnd = (Music)CreateObject("Music");
        cMusicEnd.sMusic = new FileName("Data/Sounds/Music/MissionEnd.ogg");
        cMusicEnd.nLoops = -1;
        
        DummyNoisyActor = (Actor)CreateObject("Actor");
        DummyNoisyActor.ActivateOnModule();
        DummyNoisyActor.EnableRendering(false);
        DummyNoisyActor.ClearFlag(EFlags._COLLISION | EFlags._BLOCK_MOVE | EFlags._BLOCK_TRACE | 
                                  EFlags._BLOCK_PARTICLES | EFlags._FXPARTICLE_COLLISION |
                                  EFlags._CAST_SHADOWS | EFlags._RECEIVE_SHADOWS);
        
        if(cMenu != null)
        {
            LevelContent cLevel = cMenu.cGameInitInfo.cLevels.GetCurrent();
            bLeaveInventory = cLevel.bLeaveInventory;
        }
        
        m_cBlackLoading = (Sprite)CreateObject("Sprite");
        AddSprite(m_cBlackLoading);
        m_cBlackLoading.SetSize(new Vector(GetScreenWidth(), GetScreenHeight(),0));
        m_nBlackLoadingTex = m_cBlackLoading.AddTexture("er_t_black.png");
        m_cBlackLoading.SetTexture(m_nBlackLoadingTex, new Rect(0,0,1,1));
        
        if(_bPrologDemo) CallMethodIn("TenSecondsAway", 10.f);
    }

	public void OnPostCreate()
	{
        // wrzucamy ekran PRECACHING
        Precache cPrecache = null;
        
        // na filmach nie ma precachu
        if(!ChromeGame.bFilms && !Game.IsGameInEditor())
        {
            cPrecache = ((Precache)CreateObject("Precache"));
            ForceRender();
        }
        
		super.OnPostCreate();
		
        InitPlayer();

        InitCameras();
        
        InitChatScenario();
     
        InitImplants();
		
        InitObjectives();
		
        InitAlarms();
		
        InitializeAI();
        
        InitDialogs();
        
		if (m_AlarmsManager != null)
			m_AlarmsManager.StartAlarmSystem();
		else
			CrashLog("Na levelu nie istnieje system alarmow\n");

        /** UWAGA: Przeniesione z OnCreate */
        Init();

        // wylaczamy mozliwosc pokazania menu podczas Precache
        bCanShowInGameMenu = false;
        
        // uruchamiamy precache z kamera gracza
        if (cPrecache != null)
			cPrecache.Start(aCameras[CAMERA_PLAYER]);
        else
            StartLevelAction();
	}

    void TenSecondsAway()
    {
        if(Eval("bDemo") == 0)
        {
            CrashLog("Checking...\n");
            ExitGame();
        }
    }
    
    void StartLevelAction()
    {
        // wlaczamy menu
        bCanShowInGameMenu = true;
        
        WriteMissionAvailableFile();
        
        if( sSaveGameName==null )
        {
            // inicjalizacja poczatkowej akcji levelu
            InvokeActionChain(cStartAction);
            
            //jesli zmienily sie implanty to wrzucamy info na konsole
            if(cMenu != null)
            {
                LevelContent cLevel = cMenu.cGameInitInfo.cLevels.GetCurrent();
                if (cLevel.bImplantsChanged)
                {
                    ShowImplantChangeInfo();
                }
                
                //CallOnFrameEnd("QuickSaveForRestart");
                QuickSave(true);
            }
        } 
		if(ChromeGameRunInfo.s_bAutoReloadingLevels)
		{
			//Zrzucamy zawartosc pamieci zaalokowanej w c
			//Projekt musi byc skompilowany z odblokowanym memdumpem
			int iMemoryAllocated = GetUsedMemSize();
			
			String sDumpFileName = "" + ((ChromeGame)ChromeGame.cSingleton).m_iAutoloadLevel +"_"+ ChromeGameRunInfo.s_iHowManyTimesPreloadLevel + ".txt";
			DumpMemory("DumpLevelMemory" + sDumpFileName/*, false*/);
			DumpMeshes("DumpLevelMeshes" + sDumpFileName);		
			DumpTextures("DumpLevelTextures" + sDumpFileName);
		
			CrashLog("Memory allocated for level: "+sLevelName + "(DumpLevelMemory" + sDumpFileName + "): " +iMemoryAllocated + " difference:" + (iMemoryAllocated - s_iLastAllocatedMemory));
			
			//CrashLog("Memory allocated for level: "+sLevelName + " " +iMemoryAllocated + " difference:" + (iMemoryAllocated - s_iLastAllocatedMemory));
			s_iLastAllocatedMemory = iMemoryAllocated;
			
			ChromeGameRunInfo.s_iHowManyTimesPreloadLevel--;
			
			//wracamy do menu
			MissionSuccess("");
			CallOnFrameEnd("LevelEnd");			
		}
    }
	
	//zmienna pomocnicza slazaca do wyliczania roznicy w uzyciu pamieci
	static int s_iLastAllocatedMemory;
    
    void ShowImplantChangeInfo()
    {
        if (IsMoviePlaying())
        {
            //czekamy na zakonczenie filmu
            CallMethodIn("ShowImplantChangeInfo", 0.1f);
            return;
        }
        
        PlayerHUD cPlayer = (PlayerHUD)GetMainPlayer();
        cPlayer.TextMessage( "&IMPLANTS_CHANGED&" );
        // dodajemy info do okna logow
        if ( (cPlayer.HUD               != null) &&
             (cPlayer.HUD.GetHUDLogs()  != null) )
        {
            cPlayer.HUD.GetHUDLogs().InputText( "&IMPLANTS_CHANGED&" );        
        }
        
    }
    
    void InitCameras()
    {
        aCameras[CAMERA_LEVEL_FINISHED] = (Camera)CreateObject("CameraTracking");
        ((CameraTracking)aCameras[CAMERA_LEVEL_FINISHED]).ChangeTarget(MainPlayer, "Bip01 Head");
        aCameras[CAMERA_LEVEL_FINISHED].SetState("Rotating");
        aCameras[CAMERA_PLAYER_DEATH] = (Camera)CreateObject("CameraMovie");
        aCameras[CAMERA_PLAYER] = MainPlayer.Camera;

        SetActiveCamera(CAMERA_PLAYER);
    }
    
    void InitDialogs()
    {
        GameObject[] aObjs = GetObjectsOfClass("Dialog");
        for(int i=0; i<aObjs.length; ++i)
            ((Dialog)aObjs[i]).Init();
    }
    
    void InitAlarms()
    {
        // zainicjowanie systemu alarmow na levelu
		m_AlarmsManager	= (AlarmsManager) CreateObjectNoInit("AlarmsManager");
		m_AlarmsManager.SetModule(this);
		m_AlarmsManager.InitObject();
    }
    
    
    void InitializeAI()
    {
/*        GameObject list[] = null;
        
		// wypelniamy tablice wszystkimi AI na levelu i inicjalizujemy ai
		list = GetObjectsFromClass("AIBase");
		m_aAIActiveOnLevel = new AIBase[list.length];
		for (int i = 0; i < list.length; i++)
			m_aAIActiveOnLevel[i] = (AIBase) list[i];
        
        // generowanie waypointow
		list = GetObjectsFromClass("AIMover");
		for (int i = 0; i < list.length; i++)
		{
			AIMover mover = (AIMover) list[i];
			if ( WaypointSystem.InBuilding(mover) )
			{
				WaypointSystem.CorrectPosInBuilding(mover);
				// najpierw probujemy ladowac
				mover.m_WpSystem = null;
				mover.m_WpSystem = WaypointSystem.LoadWaypoints(mover);
		    				
				if (mover.m_WpSystem == null)
				{
					mover.m_WpSystem = new WaypointSystem(mover);
					mover.m_WpSystem.GenerateWaypoints();
				}
                    
                mover.ClearFlag( EFlags._STOPPED_BY_PATHFINDER );
			}
		}
*/    }
    
	/**Tworzy, inicjuje i aktywuje gracza
	 */
	void InitPlayer()
	{
        //deaktywujemy wszystkie spawnPoint
		GameObject []aSpawnPoint = GetObjectsFromClass("SpawnPoint");
        for (int i=0; i<aSpawnPoint.length; i++) aSpawnPoint[i].DeactivateOnModuleAlways();

		//tworzymy gracza
        
        
        GameObject[] aObjs = GetObjectsFromClass("PlayerSingle");
        if(aObjs==null || aObjs.length==0)
        {
            CrashLog("No player on level! Creating new one!\n");
            MainPlayer = (PlayerSingle)CreateObject(m_sPlayerClassName);
        }
        else
            MainPlayer = (PlayerSingle)aObjs[0];
        
        //ustawiamy spawnPoint SinglePlayera
        if (aSpawnPoint.length > 0)
            MainPlayer.spawnPoint = (SpawnPoint)aSpawnPoint[0];
        else
        {
            MainPlayer.spawnPoint = (SpawnPoint)CreateObject("SpawnPoint");
            MainPlayer.spawnPoint.SetPosition(MainPlayer.GetPosition());
            MainPlayer.spawnPoint.SetDir(MainPlayer.GetForwardVector());
        }

        //przywrocenie do zycia: ustawienie na pozycji, reset wskaznikow zycia itp..
        MainPlayer.Respawn();
        MainPlayer.ActivateOnModule();
        
        // zapisujemy huda do gadek
        cNiunia = MainPlayer.HUD.GetHUDNiunia();
    }

    void InitImplants()
    {    
		// inicjalizacja systemu implantow
		ImplantSystem implantSystem = MainPlayer.GetImplantSystem();
		// inicjalizacja (utworzenie) implantow
		implantSystem.InitImplants(this, MainPlayer);
		// pobieramy modyfikatory implantow
		java.util.Vector implantMods = cGameInitInfo.cLevels.GetCurrent().aImplantModifiers;
		LogLine("SIZE:" + implantMods);
        
        /** Hack
         */
        if(bEasyImplants)
        {
            ImplantModifier aModifier;
            aModifier = new ImplantModifier("Dermal Armor", 100);
            implantMods.addElement(aModifier);
            aModifier = new ImplantModifier("TendoAmplify's", 100);
            implantMods.addElement(aModifier);
            aModifier = new ImplantModifier("Targeting Assistance System", 100);
            implantMods.addElement(aModifier);
            aModifier = new ImplantModifier("Termovision System", 100);
            implantMods.addElement(aModifier);
        }
        
		// modyfikujemy implanty poleceniami ze skryptu
		implantSystem.ApplyImplantChanges(implantMods);
        // zaczynamy update'owac implanty
        implantSystem.StartUpdate();
    }
    
	/** metoda sluzaca do inicjacji levelu, nalezy ja wolac z klas pochodnych
	 */
    void Init()
    {
	}
    
    void OnDestroy()
    {
        super.OnDestroy();
        
        DestroyChatScenario();
        
        DestroyHintManager();
        
        if (m_cBlackLoading != null)
        {
            m_cBlackLoading.ReleaseTexture(m_nBlackLoadingTex);
            RemoveSprite(m_cBlackLoading);
            m_cBlackLoading.delete();
            m_cBlackLoading = null;
        }
        
        Log("[ChromeModuleSingle.OnDestroy]\n");

        if(m_b_LEVEL_FINISHED && bLeaveInventory)
        {
            // kopiujemy inventory gracza do cGameInfoInit z przylaczaniem go do modulu menu
            try {
                
                ((GameInitInfoSingle)cGameInitInfo).SetInventory((InventoryPlayer)MainPlayer.cInventory);
                ((GameInitInfoSingle)cGameInitInfo).GetInventory().Acquire(cMenu, null);
                
            } catch (ClassCastException e)
            {
                Log("[ChromeModuleSingle.OnDestroy] Wrong class !\n");
                e.printStackTrace();
            }
        }
        else
        {
            ((GameInitInfoSingle)cGameInitInfo).SetInventory(null);
        }
		
		// usuwamy managera alarmow
		m_AlarmsManager.delete();
		m_AlarmsManager = null;
    }
    
    void OnActivate()
    {
        
        LogR("GAMEMODULE OnActivate()");
        if (Precache.bPrecaching)
            MuteAllSounds();
        //if (m_bQuickloading || 
        //   (sSaveGameName != null))// &&
            //sSaveGameName.toLowerCase().indexOf("restart") != -1))
        {
            if(m_cBlackLoading != null)
            {
                m_cBlackLoading.Show();
                m_cBlackLoading.MoveTop();
                ForceRender();
                m_cBlackLoading.CallMethodIn("Hide",0);
            }

            if (Precache.bPrecaching)
            {
                GameObject[] aPrecache = GetObjectsOfClass("Precache");
                if (aPrecache != null && aPrecache.length > 0)
                    ((Precache)aPrecache[0]).MoveTop();
            }
        }
        
        super.OnActivate();
        
        // brzydki hack na to, zeby Niunia byla na wierzchu tylko
        // jak aktywny jest level single a nie menu
        if(cNiunia != null )
            cNiunia.SetActiveModuleSingle( true );
        
        // wystartuj czas tylko, jesli nie jest w fazie precachingu (na starcie)
        /*GameObject[] aPrecache = GetObjectsOfClass("Precache");
        if (aPrecache == null ||
            aPrecache.length == 0)*/
        if (!Precache.bPrecaching)
        {
            TimerStart();
        }

        CallOnFrameEnd("RegisterKeyRequest");
        
        //przy hackowaniu nie przywracamy klawiszy        
        int nActiveHUDMenu = ((HUDManager)((PlayerHUD)GetMainPlayer()).HUD).m_nActiveHudMenu;
        if (MainPlayer != null &&
            !m_bMissionEnded)
        {
            if (nActiveHUDMenu != HUDManager._HUD_HACK)
                MainPlayer.GameActivatedFromMenu();
            if(!MainPlayer.bInMovie)
                ((ImplantSystem)MainPlayer.GetImplantSystem()).UnFreezeImplants();
        }
        else
        {
            TimerStop();
        }
    }
    
    void OnDeactivate()
    {
        LogR("GAMEMODULE OnDeactivate()");
        TimerStop();

        ((ImplantSystem)MainPlayer.GetImplantSystem()).FreezeImplants();
        
        UnregisterKeyRequest();
        
        if (MainPlayer != null)
            MainPlayer.GameDeactivatedToMenu();
        
        // brzydki hack na to, zeby Niunia byla na wierzchu tylko
        // jak aktywny jest level single a nie menu
        if(cNiunia != null )
            cNiunia.SetActiveModuleSingle( false );
        
        Music.UpdateVolume();
    }
	
    /** Handler wolany, gdy zmienia sie widocznosc outdoorow
     */
	void OnOutdoorVisible(boolean bOutDoorVisible)
	{
//		CrashLog("OnOutdoorVisible:" + bOutDoorVisible + "\n");
/*		if (m_aAIActiveOnLevel == null)
		{
			CrashLog("Na levelu nie ma AI - nie ma co wylaczac.");
			return;
		}
		for (int i = 0; i < m_aAIActiveOnLevel.length; i++)
			m_aAIActiveOnLevel[i].SwitchOutdoorAI(bOutDoorVisible);
*/	}

    void SetActiveCamera(int nCamera)
    {
        nActiveCamera = nCamera;
        SetViewFullscreen(aCameras[nActiveCamera]);
    }
    
    /** Level w sposob konczy sie w sposob naturalny (sukces lub porazka)
     */
    public void LevelEnd()
    {
        if ( cMenu != null )
        {
            if (bMissionSuccessful)
            {
                cMenu.ActiveLevelReturnValue = ChromeModule._LEVEL_FINISHED;
                m_b_LEVEL_FINISHED = true;
            }
            else
                cMenu.ActiveLevelReturnValue = ChromeModule._LEVEL_CANCELED;

            Deactivate();
            cMenu.Activate();
        }
        else
            LogR("nie ma modulu menu Alt-F4 \n");
    }

    
    /** Level jest przerwany - wychodzimy do "menu w trakcie gry"
     */
    public void LevelBreak()
    {
        int nActiveHUDMenu = ((HUDManager)((PlayerHUD)GetMainPlayer()).HUD).m_nActiveHudMenu;
        //przy hackowaniu mozemy pokazac menu
        if (nActiveHUDMenu != -1 && 
            nActiveHUDMenu != HUDManager._HUD_HACK)
        {
            if (nActiveHUDMenu != HUDManager._HUD_UNIVERSAL)
                ((HUDManager)((PlayerHUD)GetMainPlayer()).HUD).DeactivateCurMenu();
            else
                return;
        }
        else
        {
            if ( cMenu != null && bCanShowInGameMenu)
            {
                ForceRender();
                Game.cSingleton.TakeScreenshot("save.tga");
                cMenu.ActiveLevelReturnValue = ChromeModule._LEVEL_INPROGRESS;
                MainPlayer.UnregisterKeyRequest();
                MainPlayer.UnregisterMouseButtonRequest();
                MainPlayer.UnregisterMouseAxisRequest();
                Deactivate();
                cMenu.Activate();
                UnregisterKeyRequest();
            }
            else Log("nie ma modulu menu Alt-F4 \n");
        }
    }
    
    void ReturnFromMenu()
    {
        RegisterKeyRequest();
    }
    
    /** metoda wolana gdy gracz wejdzie w jakis hotspot 
     *  jesli jest to HotSpotBirds to startujemy birdsy
     */
    void OnEnterHotSpot(Actor Adventurer, HotSpot Point)
    {
        if( Adventurer instanceof Player )
        {
            /*
            if (Point instanceof HotSpotBirds)
                ((HotSpotBirds)Point).StartBirds();
            */
        }
    }
    
    boolean IsHudStatsActive()
    {
        return (cHUDStats!=null) && (cHUDStats.bActiveFlag);
    }
    
    void OnInputKey(int nKeyCode, boolean bKeyState, char nKeyAscii)
    {
        //super.OnInputKey(nKeyCode, bKeyState, nKeyAscii);
	
        if ( (nKeyCode==EKey._F1) && (bKeyState) && 
              Game.cSingleton.IsScreenShotMode())
        {
            // w trybie robienia screenshotow ustawiamy gracza tam gdzie jest kamera
            Vector vCamPos = Game.cSingleton.GetScreenshotCamera().GetPosition();
            MainPlayer.SetPositionWorld(vCamPos);
        }
    
        //misja przegrana i spacja lub escape
        if ( (bKeyState) && 
             IsHudStatsActive() &&
             (nKeyCode==EKey._SPACE))
        {
            cHUDStats.Deactivate();

            //GameObject.ExitGame();
            LevelEnd();
            //odblokowanie gracza, InGameMovieStart bylo zawolane w PlayerDied()
            MainPlayer.InGameMovieEnd();
        }
        else
        if(nKeyCode==EKey._ESCAPE && 
           bKeyState && 
           !Precache.bPrecaching)
        {
            if( IsMoviePlaying() )
            {
                if(bBlockMovieBreak)
                {
                    // przejscie do menu, wali sie strasznie :))
                    //LevelBreak();
				    CallOnFrameEnd("LevelBreak");
                }
                else
                {
                    if(cMoviePlaying != null && cMoviePlaying.bUpdateToEndOnBreak)
                       StopMovieUpdateToEnd();
                    else
                        StopMovieFade();
                }
            }
            else
				CallOnFrameEnd("LevelBreak");
                //LevelBreak();                            
        }
        
        boolean bControl = GetKeyState(EKey._LCONTROL)||GetKeyState(EKey._RCONTROL);
        
        // jak nie ma cheatow to nie interesuje nas czy jest kontrol czy nie
        if(!Game.cSingleton.bCheats)
            bControl = false;
        
        if(nKeyCode == EGameControl.QUICKSAVE && bKeyState && 
           !bControl &&
           !m_bMissionEnded &&
           ChromeGame.cSingleton instanceof ChromeGame &&
           ((ChromeGame)ChromeGame.cSingleton).IsLoadSaveEnabled())
        {
            ((PlayerHUD)GetMainPlayer()).HUD.GetHudCompInvPl().AboutToQuickSave();
            CallOnFrameEnd("QuickSaveForKey");
            ClearInputQueue();
        }

        if(nKeyCode == EGameControl.QUICKLOAD && bKeyState && 
           !bControl &&
           ChromeGame.cSingleton instanceof ChromeGame &&
           ((ChromeGame)ChromeGame.cSingleton).IsLoadSaveEnabled())
				//CallOnFrameEnd("QuickLoad");
        {
            DisableCallMethod("QuickLoad");
            CallMethodIn("QuickLoad", 0);
            ClearInputQueue();
        }
        
        //------------------- CHEAT CODES ------------------------
        if(Game.cSingleton.bCheats && bKeyState)
        {
            if(nKeyCode==EKey._HOME)
            {
                if (MainPlayer != null)
                {
                    MainPlayer.HUD.AddConsText( "FPS="+Float.toString( 1000.0f / GetLastFrameTime() ) );
                    //MainPlayer.HUD.AddConsText( "Render="+Float.toString( GetLastRenderTime() ) );
                    //MainPlayer.HUD.AddConsText( "Sim="+Float.toString( GetLastSimTime() ) );
                }
            }
            
            if(nKeyCode==EKey._F2 && 
               (GetKeyState(EKey._LCONTROL)||GetKeyState(EKey._RCONTROL)))
                if(aOnF2 != null) InvokeActionChain(aOnF2);
            
            if(nKeyCode==EKey._F3 && 
               (GetKeyState(EKey._LCONTROL)||GetKeyState(EKey._RCONTROL)))
                if(aOnF3 != null) InvokeActionChain(aOnF3);
            
            if(nKeyCode==EKey._F7 && 
               (GetKeyState(EKey._LCONTROL)||GetKeyState(EKey._RCONTROL)))
                if(aOnF7 != null) InvokeActionChain(aOnF7);
            
            if(nKeyCode==EKey._F8 && 
               (GetKeyState(EKey._LCONTROL)||GetKeyState(EKey._RCONTROL)))
                if(aOnF8 != null) InvokeActionChain(aOnF8);
        }
	}
	
	public long GetSaveVersion() { return _SAVE_VERSION_NUMBER; }	
	
	void QuickSaveForKey()
	{
		QuickSave(false);
	}
	
	void QuickSaveForRestart()
	{
		QuickSave(true);
	}	

    void QuickSave(boolean bForRestart)
    {
		if (!bForRestart)
            MuteAllSounds();
        String sSaveName = null;
        if (bForRestart)
        {
            sSaveName = SGController._SG_RESTARTSAVELOAD_FILE;
        }
        else
        {
            sSaveName = ChromeMenuLoad.GetNextQuickSave();
            if (!bForRestart)
                ((PlayerHUD)GetMainPlayer()).TextMessage(Text.Get("&MENU_SAVE_SAVING&"));
            ChromeGame.cSingleton.TakeScreenshot(sSaveName+".tga");
            ForceRender();
        }
        
        boolean bTermoIsActive = GetMainPlayer().GetImplantSystem().GetImplant(ImplantSystem._IMPLANT_TERMOVISION_SYSTEM).IsActive();
        if (bTermoIsActive)
            GetMainPlayer().GetImplantSystem().GetImplantTermovision().DeactivateToSave();
        
        try
        { 
            // upewniamy sie, ze jest katalog
            File cSaveDir = new java.io.File("Save");
            if(!cSaveDir.exists())
            {
                cSaveDir.mkdir();
                cSaveDir = null;
            }
            
            // lecimy dalej
            FileOutputStream jMiniSave = new FileOutputStream(sSaveName,false);
			
            BufferedWriter cWriter = null; 
            
            String sNameFile = sSaveName + ".lev";
            try
            {
                cWriter = new BufferedWriter( new FileWriter( sNameFile ));
            }
            catch (IOException e)
            { 
                GameObject.LogD("ERROR "+this+" " + e.getMessage() +"\n"); 
            }
            LevelContent cLevel = cMenu.cGameInitInfo.cLevels.GetCurrent();
            String sBuffer = cLevel.sSaveName;
            if (cWriter != null)
            {
                cWriter.write( sBuffer, 0, sBuffer.length() );
                cWriter.close();
                cWriter = null;
            }
            
            //ForceRender();                              
			cSG.Save(sSaveName,this,this.cGameInitInfo);				
            jMiniSave.close();
            if (!bForRestart)
                ((PlayerHUD)GetMainPlayer()).TextMessage(Text.Get("&INFO_QUICKSAVE_OK&"));
        }
        catch (IOException e)
        { 
            if (!bForRestart)
			    UnMuteAllSounds();
            if (bTermoIsActive)
                GetMainPlayer().GetImplantSystem().GetImplantTermovision().ActivateAfterSave();
            LogD("Blad zapisu save " + e.getMessage()); 
        }
        if (!bForRestart)
		    UnMuteAllSounds();
        
        if (bTermoIsActive)
            GetMainPlayer().GetImplantSystem().GetImplantTermovision().ActivateAfterSave();
        
    }
    
    void QuickLoad()
    {
        // upewniamy sie, ze jest plik
        if (ChromeMenuLoad.GetActiveQuickSave() == null)
            return;

        m_cBlackLoading.Show();
        m_cBlackLoading.MoveTop();
        MainPlayer.HUD.GetHUDNiunia().Deactivate();
        ForceRender();
        
        m_bQuickloading = true;
        
        cMenu.ActiveLevelReturnValue = ChromeModule._LEVEL_QUICK_LOADING;
        cMenu.Activate();
        
    }
    
    void QuickLoadOK()
    {
        ((PlayerHUD)GetMainPlayer()).TextMessage(Text.Get("&INFO_QUICKLOAD_OK&"));
        m_bQuickloading = false;
        m_cBlackLoading.Hide();
    }
    
    
    /** Obsluga przelaczania kamery normalnej
     */
    void NormalCameraDisabled()
    {
        // wylaczamy HUDy gracza
        MainPlayer.HUD.HideAll();
    }
    
    void TrackCameraDisabled()
    {
        // przywracamy HUDy gracza
        MainPlayer.HUD.UnhideAll();
    }

    /** metoda wolana gdy misja zakonczy sie niepowodzeniem
     */
    public void MissionFailed(String sComment)
    {
        if (m_bMissionEnded)
            return;
        
        MissionEnded();
        
        bMissionSuccessful = false;  
		bCanShowInGameMenu = true;

        //statystyki
        cHUDStats = MainPlayer.HUD.GetHudStats();
        if (cHUDStats != null)
        {
            cHUDStats.SetMissionFailed(false, sComment, cMusicFailed);
            cHUDStats.Activate();
        }
    }

    /** metoda wolana gdy misja zakonczy sie powodzeniem
     */
    public void MissionSuccess(String sComment)
    {
        if (m_bMissionEnded) 
            return;
        
        MissionEnded();
        
        bMissionSuccessful = true;
        
        WriteNextMissionAvailableFile();
        
        //statystyki
        cHUDStats = MainPlayer.HUD.GetHudStats();
        if (cHUDStats != null)
        {
            if (m_cCredits == null)
            {
                cHUDStats.SetMissionSuccesful(sComment, cMusicSuccess);
                cHUDStats.Activate();
            }
            else
            {
                //sa creditsy, wiec to po ostatniej misji
                LevelEnd();
            }
        }
    }

    void WriteMissionAvailableFile()
    {
        String sFileName = GetMissionAvailableFileName();
        
        LogR("WriteMissionAvailableFile " + sFileName);
        
        if (sFileName == null)
            return;
        
        File cFileSuccess = new File(sFileName);
        try
        {
            if (!cFileSuccess.exists())
                cFileSuccess.createNewFile();
        }
        catch (Exception e)
        {
            e.printStackTrace();
        } 
    }
    
    void WriteNextMissionAvailableFile()
    {
        String sFileName = GetNextMissionAvailableFileName();
        
        if (sFileName == null)
            return;
        
        File cFileSuccess = new File(sFileName);
        try
        {
            if (!cFileSuccess.exists())
                cFileSuccess.createNewFile();
        }
        catch (Exception e)
        {
            e.printStackTrace();
        } 
    }
    
    String GetMissionAvailableFileName()
    {
        if(cMenu == null) 
            return null;
        
        LevelContent cLevel = cMenu.cGameInitInfo.cLevels.GetCurrent();
        String sMapPath = cLevel.sLevelName;
        return MapPathToMissionAvailableFileName(sMapPath);
    }
    
    String GetNextMissionAvailableFileName()
    {
        if(cMenu == null) 
            return null;
        
        String sMapPath = cMenu.cGameInitInfo.cLevels.GetNextMissionFileName();
        return MapPathToMissionAvailableFileName(sMapPath);
    }
    
    
    static String MapPathToMissionAvailableFileName(String sMapPath)
    {
        //LogR("MapPathToMissionAvailableFileName " + sMapPath);
            
        File cFile = new File(sMapPath);
        if (!cFile.exists())
            return null;
        
        
        
        String sDir = cFile.getParent();
        String sName = cFile.getName();
        
        //LogR("sDir " + sDir + " sName " + sName);
        
        if (sName.equalsIgnoreCase("Level00.map"))
            return sDir + "/" + "chk_anb.ddk";
        if (sName.equalsIgnoreCase("Level01.map"))
            return sDir + "/" + "chk_kah.ddk";
        if (sName.equalsIgnoreCase("Level02.map"))
            return sDir + "/" + "chk_lek.ddk";
        if (sName.equalsIgnoreCase("Level03.map"))
            return sDir + "/" + "chk_kda.ddk";
        if (sName.equalsIgnoreCase("Level04.map"))
            return sDir + "/" + "chk_opr.ddk";
        if (sName.equalsIgnoreCase("Level06.map"))
            return sDir + "/" + "chk_qcc.ddk";
        if (sName.equalsIgnoreCase("Level07.map"))
            return sDir + "/" + "chk_ain.ddk";
        if (sName.equalsIgnoreCase("Level08.map"))
            return sDir + "/" + "chk_udp.ddk";
        if (sName.equalsIgnoreCase("Level09.map"))
            return sDir + "/" + "chk_cdn.ddk";
        if (sName.equalsIgnoreCase("Level10.map"))
            return sDir + "/" + "chk_tzn.ddk";
        if (sName.equalsIgnoreCase("Level10a.map"))
            return sDir + "/" + "chk_npn.ddk";
        if (sName.equalsIgnoreCase("Level11.map"))
            return sDir + "/" + "chk_ids.ddk";
        if (sName.equalsIgnoreCase("Level12.map"))
            return sDir + "/" + "chk_trh.ddk";
        if (sName.equalsIgnoreCase("Level13a.map"))
            return sDir + "/" + "chk_vhs.ddk";
        if (sName.equalsIgnoreCase("Level13b.map"))
            return sDir + "/" + "chk_cdr.ddk";
        if (sName.equalsIgnoreCase("Level13c.map"))
            return sDir + "/" + "chk_img.ddk";
        if (sName.equalsIgnoreCase("test.map"))
            return sDir + "/" + "chk_test.ddk";
        
        return null;
    }
        
    static boolean IsMissionAvailable(String sMapPath)
    {
        String sFile = MapPathToMissionAvailableFileName(sMapPath);
        if (sFile != null)
        {
            File cFile = new File(sFile);
            return cFile.exists();
        }
        else
        {
            return false;
        }
    }
    
    /** metoda wolana gdy misja zakonczy sie a nic sie nie stalo
     */
    public void MissionToBeContinue(String sComment)
    {
        if(m_bMissionEnded) return;

        MissionEnded();
        bMissionSuccessful = true;

        //statystyki
        cHUDStats = MainPlayer.HUD.GetHudStats();
        if (cHUDStats != null)
        {
            cHUDStats.SetMissionToBeContinue(sComment, cMusicEnd);
            cHUDStats.Activate();
        }
    }

    
    float m_fAfterDeathTimeSpeedup = 0.2f;
    float m_fAfterDeathFadeTime = 3f;
    
    /** metoda wolana gdy player zostal przykilowany
     */
    public void PlayerDied()
    {
        if (m_bMissionEnded)
            return;
        
        //Thread.dumpStack();
        
        MissionEnded();
        
        CrashLog("PlayerDied\n");
        bMissionSuccessful = false;

        //widzimy gracza z TPP
        //MainPlayer.CameraModeChanged(CameraPlayer.CMODE_TPP);

        //PO CO TO TU BYLO? peh
        //UnregisterMouseAxisRequest();

        //obracajaca sie kamera
        if(!bDontUseLevelFinishCamera)
        {
            //obracajaca sie kamera
            //SetActiveCamera(CAMERA_LEVEL_FINISHED);
        }
        
        TimerSetSpeedUp(m_fAfterDeathTimeSpeedup);
        
        SetState("FadeSceneAfterDeath");
        //wlaczamy calego gracza
        //MainPlayer.nRenderMode = MainPlayer.REN_FULL;
        MainPlayer.ShowPlayer(false);
        
        //statystyki
        cHUDStats = MainPlayer.HUD.GetHudStats();
        
        if (cHUDStats == null)
            LogD("HUDStatistics == null\n");
        else
        {
            cHUDStats.SetMissionFailed(true, "&PlayerDied&", cMusicFailed);
            cHUDStats.CallMethodIn("Activate", m_fAfterDeathTimeSpeedup * m_fAfterDeathFadeTime);
        }
    }

    // metoda wylacza HUD statystyk gdy ktos wczyta z menu save'a podczas niego
    void DisableMissionEnd()
    {
        if (!m_bMissionEnded) 
            return;
        
        m_bMissionEnded = false;
        
        if (cHUDStats != null) 
            cHUDStats.Deactivate();
        
        TimerSetSpeedUp(1f);
        cHUDStats.DisableCallMethod("Activate");
        SetState("Idle");
        
        MainPlayer.InGameMovieEnd();
        MainPlayer.HUD.AllowActivate();
        MainPlayer.HUD.HideAll();
        MainPlayer.HUD.ActivateDefaultHUDs();
        MainPlayer.ShowPlayer(true);
        FadeDeleteSprite(); 
        
    }
    
    public class FadeSceneAfterDeath extends FadeScene
    {
        public void OnEnter()
        {
            FadeOut(m_fAfterDeathFadeTime);
            //ShowFade(true);
        }
        
        public void OnFadeOutEnd()
        {
            LogR("OnFadeOut");
            TimerSetSpeedUp(1f);
        }
    }
    
    MeshObject cMissionEndCameraTarget = null;
    String sMissionEndCameraTargetElement = "";
    
    protected void MissionEnded()
    {
        MuteAllSounds();
        
        // wlaczamy cel kamery koncowej
        if(cMissionEndCameraTarget != null)
        {
            ((CameraTracking)aCameras[CAMERA_LEVEL_FINISHED]).ChangeTarget(cMissionEndCameraTarget, sMissionEndCameraTargetElement);
            aCameras[CAMERA_LEVEL_FINISHED].SetState("Rotating");
        }
        
        m_bMissionEnded = true;
        
        if(cCurrentTerminal != null)
        {
            cCurrentTerminal.ScreenExit();
        }
        
        if (Music.cPlayingMusic != null)
            Music.cPlayingMusic.ForceStop();
        
        ((ImplantSystem)MainPlayer.GetImplantSystem()).DeactivateAllImplants();
        ((ImplantSystem)MainPlayer.GetImplantSystem()).FreezeImplants();
        MainPlayer.HUD.GetHUDPlayer().DeactivateForMovie();
        MainPlayer.HUD.HideAll();
        MainPlayer.HUD.GetHUDNiunia().Deactivate();
        MainPlayer.HUD.DisallowActivate();
        if (Dialog.cPlayingDialog != null)
        {
            Dialog.cPlayingDialog.Stop();
        }
        
        if (!MainPlayer.bDead)
            CallMethodIn("TimerStop", 1.0f);
        CallMethodIn("DisableTimeHandlers", 1.0f);
        
        if (GetHintManager() != null)
            GetHintManager().Deactivate();
        
        FreezeAI(); // freeze dla AI
        
        //blokada gracza
        MainPlayer.bInMovieCameraLeave = true;
        MainPlayer.InGameMovieStart();
        MainPlayer.bInMovieCameraLeave = false;
    }
    
    void DisableTimeHandlers()
    {
        GameObject[] a = GetObjectsFromClassModule("GameObject", this);
        for(int i=0; i<a.length; ++i)
            a[i].DisableCallMethods();
    }
///////////////////////////////////////////////////////////////////////////////
// FILMY    

    Weapon cSniperForTurnOnView = null;
    boolean bSniperForMovieTurnedOn = false;
    
    // wlaczanie widoku ze snajperki - do filmow z HUDem snajperki
    public void TurnOnSniperView()
	{
        CrashLog("[ChromeModuleSingle.TurnOnSniperView]\n");
        
        // TODO: Obsluga innych snajperek
        HUDManager cHUD = ((PlayerHUD)MainPlayer).HUD;
        HUDSniper cHUDSniper = (HUDSniper)cHUD.GetHUDSniper();
        
        // tworzymy malutka snajperke do filmu
        if(cSniperForTurnOnView == null)
        {
            cSniperForTurnOnView = (Weapon)CreateObject("WeaponRifleSniper");
            cSniperForTurnOnView.nCellsHeight = 1;
            cSniperForTurnOnView.nCellsWidth = 1;
            cSniperForTurnOnView.AddToInventory(MainPlayer);
        }
        
        cHUDSniper.SetWeapon(cSniperForTurnOnView);
        cHUDSniper.SetCompass(cHUD.GetHUDAddCompassSniper());
		cHUDSniper.ActivateForMovie();
        
        bSniperForMovieTurnedOn = true;
	}
	
    // wylaczanie widoku ze snajperki - do filmow z HUDem snajperki
	public void TurnOffSniperView()
	{
        if(!bSniperForMovieTurnedOn) return;

        //prosze nie zmieniac kolejnosci (jesli usuniemy snajperke z aktywnym hudem, 
        //to przywroci sie widok tpp zapamietany przy aktywacji snajperki)
        ((PlayerHUD) MainPlayer).HUD.GetHUDSniper().Deactivate();
        
        if(cSniperForTurnOnView != null)
        {
            cSniperForTurnOnView.delete();
            cSniperForTurnOnView = null;
        }
        
        
        bSniperForMovieTurnedOn = false;
	}
    
    void BlindPlayer()
    {
        ExecuteFXBlind("BlindFlashBang", 0.0f);
    }
    
    void PlayMovie(Movie cMovie)
    {
        if(cCurrentTerminal != null)
        {
            cCurrentTerminal.ScreenExit();
        }
        
        super.PlayMovie(cMovie);
    }
    
    public void OnShowSubtitle(String sText, int iSubNumber)
    {
        // dodajemy tekst ze sceny do okna logow
		if(MainPlayer.HUD.GetHUDLogs() != null)
			MainPlayer.HUD.GetHUDLogs().InputText(sText);
        
        super.OnShowSubtitle(sText, iSubNumber);
    }
    
    /** Kamera zapamietana podczas wlaczania filmu */
    boolean bCanShowInGameMenu = false;
    
    public void ShowMovieView()
    {
        MainPlayer.HUD.HideAllForMovie();
        MainPlayer.HUD.DisallowActivate();
        
        super.ShowMovieView();
    
        if (cMoviePlaying != null && cMoviePlaying.bDisableAIRadioCommunication)
        {
            NewAI.s_bRadioCommDisabledForMovie = true;
            LogR("NewAI.s_bRadioCommDisabledForMovie := true\n");
        }
        
        bCanShowInGameMenu = false;
        
        RemoveBulletsForMovie();
        
        //blokada gracza
        MainPlayer.InGameMovieStart();
        
        //sfreezowanie implantow
        MainPlayer.GetImplantSystem().FreezeImplants();

    }
    
    /**Usuwa lecace pociski (granaty i rakiety), wolana jest na starcie filmu po to by 
     * wyrzucony przed filmem granat nie zabil np. jednego z aktorow
     */
    void RemoveBulletsForMovie()
    {
        GameObject[] cBullets = GetObjectsFromClass("Bullet");
        if (cBullets != null)
        {
            for (int i = 0; i < cBullets.length; i ++)
            {
                if(((Bullet)cBullets[i]).IsStarted())
                    ((Bullet)cBullets[i]).RemoveForMovie();
            }
        }
            
    }
    
    public void ShowWorldView()
    {
        super.ShowWorldView();
        
        LogR("[ChromeModuleSingle.ShowWorldView]\n");
        
        NewAI.s_bRadioCommDisabledForMovie = false;
        bCanShowInGameMenu = true;
        
        //unfreeze dla wszystkich zafreezowanych
        MainPlayer.InGameMovieEnd();
        
        MainPlayer.HUD.AllowActivate();
        MainPlayer.HUD.UnhideAll();
        //unfreezowanie implantow
        MainPlayer.GetImplantSystem().UnFreezeImplants();
    }

    public void OnEndMovie()
    {
        super.OnEndMovie();
        
        //FIXIT hack na zostawanie snajperki po filmie
        TurnOffSniperView();
    }

//////////////////////////////////////////////////////////////////////////
// odgrywanie scenek gadanych
//////////////////////////////////////////////////////////////////////////
    
    // lista wszystkich aktorow
    java.util.Vector aCharacters = new java.util.Vector(1);
    
    /** Inicjalizacja scenek. Metoda do pokrycia
     */
    public void InitChatScenario()
    {
        // zawsze logan i niunia jest na scenkach
        AddSceneCharacter('L', "Logan", null, MainPlayer);
		AddSceneCharacter('C', "Carrie", null, null , "TalkingHeadNiunia");
    }

/////////////////////////////////////////////////////////////////////
    
    HUDCompNiunia cNiunia = null;
    
    void DestroyChatScenario()
    {
        // kasujemy z listy tekstury
        for(int i=0; i<aCharacters.size(); ++i)
        {
            CharacterDescription cDesc = (CharacterDescription)aCharacters.elementAt(i);
            
            // powiadommy huda, ze juz nie bedziemy potrzebowali gostka,
            // po to by zrobic releasa na tekstrze oraz skasowac gadajaca glowe
            cNiunia.ReleaseCharacter( cDesc );
        }
    }
    
    /** Rejestrowanie charactera.
     * @param chInitial inicjal postaci
     * @param sTextureName nazwa tekstury do pokazania
     * @param cActor aktor dla ktorego 
     * @param sClassName string z nazwa klasy gadajacej glowy
     */
    public void AddSceneCharacter(char chInitial, String sName, String sTexture, AnimActor cActor, String sClassName)
    {
        CharacterDescription cDesc = new CharacterDescription();
        
        cDesc.cActor = cActor;
		cDesc.sName = sName;
        cDesc.chInitial = chInitial;
        cDesc.nTexture = (sTexture==null) ? 0 : cNiunia.GetTextureNumber(sTexture);
        cDesc.sTalkingHeadModuleClassName = sClassName;
        
        aCharacters.addElement(cDesc);
        
        if ( sClassName != null )
            cDesc.cTalkingHeadModule = cNiunia.CreateTalkingHead(sClassName);
    }
    
    public void AddSceneCharacter(char chInitial, String sName, String sTexture, AnimActor cActor )
    {
        AddSceneCharacter( chInitial, sName, sTexture, cActor, null );
    }
    
    /** Zwraca podanego charactera po inicjale
     */
    CharacterDescription GetCharacter(char chInitial)
    {
        for(int i=0; i<aCharacters.size(); ++i)
        {
            CharacterDescription cDesc = (CharacterDescription)aCharacters.elementAt(i);
            if(cDesc.chInitial == chInitial) return cDesc;
        }

        return null;
    }
    
    /** Odgrywa scene o podanym numerze z tablicy scenek
     */
    public float PlayScene(int nChatScenario)
    {
        return PlayScene(nChatScenario, null, null);
    }

    public float PlayScene(int nChatScenario, String sAfterSceneMethod, GameObject cAfterSceneObject)
    {
        if(nChatScenario >= aChatScenario.length)
        {
            CrashLog("[ChromeModuleSingle.PlayScene] No such scenario <"+nChatScenario+"> last scenario is <"+(aChatScenario.length-1)+">\n");
        }
        
        String[] aScenario = aChatScenario[nChatScenario];
        float fTime = 0;
        if(nScenePlaying == -1)
        {
            for (int i=0; i<aScenario.length; i++)
            {
                fTime += GetWaveDuration( sChatSoundsPath+sLevelName+"/"+aScenario[i].substring(2)+".wav" );
            }
            fTime += fWavePause * (aScenario.length-1);

            nScenePlaying = nChatScenario;
            nCurrentDialog = 0;

            PlayScene();
        }
		
		m_bPlayingScene = true;
		DisableCallMethod("ScenePlayingEnd");
		CallMethodIn("ScenePlayingEnd", fTime);
	
        if(cAfterSceneObject!=null && sAfterSceneMethod!=null)
        {
            CrashLog("[ChromeModuleSingle.PlayScene] Scene will finish in "+fTime+" seconds.\n");
            cAfterSceneObject.CallMethodIn(sAfterSceneMethod, fTime);
        }
        
        return fTime;
    }

    protected void PlayScene()
    {
        String sCurrentDialog = aChatScenario[nScenePlaying][nCurrentDialog];
        String sWave = sChatSoundsPath+sLevelName+"/"+sCurrentDialog.substring(2)+".wav";
        String sText = "&"+sCurrentDialog.substring(2)+"&";

        float fTime = GetWaveDuration(sWave) + fWavePause;
        
        // wyszukujemy kto to ma gadac
        char chInitial = sCurrentDialog.charAt(0);
        CharacterDescription cDesc = GetCharacter( chInitial );
                
        PlayWave(sWave);
  
        if ( cDesc != null )
        {
            if(cDesc.cTalkingHeadModule != null)
            {
                // jezeli byla podana klasa gadajacej glowy to...
                //cNiunia.Message( sWave, sText, fTime, cDesc.cTalkingHeadModule);
            } 
            else
                if ( cDesc.nTexture!=0 )
                {
                    // odpalamy gdy jest teksture
                    cNiunia.Message( cDesc.nTexture, sText, fTime);
                }

            // odpalamy gdy jest aktorowi gadanie
            if( (cDesc.cActor!=null) && (cDesc.nTexture!=0) )
			{
                cDesc.cActor.SpeakText(sText, fTime);
			}

			// dodajemy tekst ze sceny do okna logow
			if ( (MainPlayer.HUD != null) &&
				 (MainPlayer.HUD.GetHUDLogs() != null) )
				MainPlayer.HUD.GetHUDLogs().InputText(cDesc.sName + ": " + sText);
        }
        else
        {
            CrashLog("[ChromeModuleSingle.PlayScene] Unrecognized character '"+chInitial+"' in dialog ["+nScenePlaying+","+nCurrentDialog+"]\n");
        }
        
        nCurrentDialog++;

        if (nCurrentDialog < aChatScenario[nScenePlaying].length)
            CallMethodIn("PlayScene", fTime);
        else
        {
			MainPlayer.HUD.GetHUDLogs().InputText("-----------------------------------------------------------------------------------------------------------------------------------------------");
            nScenePlaying = -1;
        }
    }
	
	
	public void ScenePlayingEnd()
	{
		m_bPlayingScene = false;
	}

    //////////////////////////////////////////////////////////////////////////
    // pomoc w odpalaniu dialogow przez klase Dialog
    
    String GetDialogSoundPath()
    {
        return sChatSoundsPath+sLevelName+"/";
    }
    
    // lista wszystkich unikalnych klasa postaci w gadkach
    java.util.Vector aDialogCharacters = new java.util.Vector(0);
    
    /** Zwraca zupdejtowana postac do gadania w scence
     */
    DialogCharacter UpdateCharacter(DialogCharacter cSpeaker)
    {
        if(cSpeaker==null) return null;
        
        String cSpeakerClassName = cSpeaker.getClass().getName();
        
        //CrashLog("[ChromeModuleSingl.UpdateCharacter] cSpeakerClass='"+cSpeakerClass.getName()+"'\n");
        
        if(cSpeaker instanceof chr_Character)
            cSpeakerClassName = null;
        
        // szukamy czy wystepuje juz charakter o podanej klasie
        for(int i=0; i<aDialogCharacters.size(); ++i)
        {
            DialogCharacter cFound = (DialogCharacter)aDialogCharacters.elementAt(i);
            if((cFound.getClass().getName().equals(cSpeakerClassName)) && (cFound.cActor == cSpeaker.cActor))
                return cFound;
        }
        
        DialogCharacter cNewSpeaker = null;
        
        if(cSpeakerClassName != null)
        {
            cNewSpeaker = (DialogCharacter)CreateObject(cSpeakerClassName);
            cNewSpeaker.cActor = cSpeaker.cActor;
            cNewSpeaker.bSimpleText = cSpeaker.bSimpleText;
            
            // nie znaleziona klasa, wiec dodajemy nowa
            aDialogCharacters.addElement(cNewSpeaker);
            //CrashLog("[ChromeModuleSingle.UpdateCharacter] Class added '"+cSpeakerClass+"'\n");
        }
        else
            cNewSpeaker = cSpeaker;
        
        // inicjalizujemy wszystko pod cSpeaker
        String sTexture = cNewSpeaker.sTextureName;
        if(sTexture!=null)
            cNewSpeaker.nTexture = cNiunia.GetTextureNumber(sTexture);
        else
        {
            if(!cNewSpeaker.bSimpleText)
                cNewSpeaker.cTalkingHeadModule = cNiunia.CreateTalkingHead(cNewSpeaker);
        }

        return cNewSpeaker;
    }
    
    //////////////////////////////////////////////////////////////////////////
    // pomoc w odgrywaniu filmow

    //TODO wypierdolic to!
    float MovieSpeak(AnimActor who, String what)
    {
        String wavePath = new String(sFilmSoundsPath+"/"+what+".wav");
        who.Speak(wavePath);
        
        return GetWaveDuration(wavePath) + fWavePause;
    }
    
//---------------------------------------------------------------------------------------        
    FreeCamera cFreeCamera = null;
    
    void ToggleFreeCamera()
    {
        if( cFreeCamera == null )
        {
            cFreeCamera = (FreeCamera)CreateObject("FreeCamera");
            cFreeCamera.FromForwardUpPos(MainPlayer.GetForwardVector(), Vector.Up, MainPlayer.GetPosition());

            SetViewFullscreen(cFreeCamera);
            
            MainPlayer.UnregisterKeyRequest();
            MainPlayer.UnregisterMouseAxisRequest();
            MainPlayer.UnregisterMouseButtonRequest();
        }
        else
        {
            // wylaczamy kamere - przywracamy gracza
            cFreeCamera.delete();

            SetViewFullscreen(MainPlayer.Camera);

            MainPlayer.RegisterKeyRequest();
            MainPlayer.RegisterMouseAxisRequest();
            MainPlayer.RegisterMouseButtonRequest();
        }
    }
    
    void InitHints()
    {
        //Hinty sa tylko na levelu00 (prolog)
    }
    
    void DestroyHintManager()
    {
        if(cHintManager != null)
        {
            cHintManager.delete();
            cHintManager = null;
        }
    }
    
    void InitImplantHints(java.util.Vector vHints)
    {
        LogR("InitImplantHints");
            
        if (vHints.size() == 0)
            return;
        
        if (cHintManager == null)
            cHintManager = (HintManager) CreateObject("HintManager");
        else
            return;//cHintManager.Clear();
        
        cHintManager._TIME_START_DELAY = 100f;

        //na pierwszym levelu dochodza 3 implanty, mowimy o nich
        //poza tym musimy tu wstawic hint o pojazdach
        if (vHints.size() > 2)
        {
            cHintManager.AddHint( new HintImplant(Hint._HINT_IMPLANT_GENERAL) );
            cHintManager.AddHint( new HintJeepAvailable());
            //niunia gada z loganem
            cHintManager._TIME_START_DELAY = 120f;
        }
        
        for (int i = 0; i < vHints.size(); i++)
	        cHintManager.AddHint( new HintImplant(((Integer)vHints.elementAt(i)).intValue()) );
        
        cHintManager.Activate();
        cHintManager.Start(false);
    }
    
    void AddImplantHints(java.util.Vector vHints)
    {
        if (vHints.size() == 0)
            return;
        
        if (cHintManager == null)
            cHintManager = (HintManager) CreateObject("HintManager");
        

        cHintManager.AddHint( new HintImplant(Hint._HINT_IMPLANT_GENERAL) );
        
        for (int i = 0; i < vHints.size(); i++)
	        cHintManager.AddHint( new HintImplant(((Integer)vHints.elementAt(i)).intValue()) );
        
        cHintManager.Activate();
        cHintManager.Start(false);
    }
    
	/*
    void InitLoadedHints()
    {
        LogR("initloadedhints");
        if (m_vLoadedHints == null)
            return;
        
        if (cHintManager == null)
        {
            cHintManager = (HintManager) CreateObject("HintManager");
        }
        else
        {
            cHintManager.Clear();
        }
        
        if (m_vLoadedHints.size() == 0)
        {
            cHintManager.delete();
            cHintManager = null;
        }
        else
        {
            cHintManager._TIME_START_DELAY = 100f;
            cHintManager._MIN_DISPLAY_PAUSE = 5f;

            AddLoadedHints();
            cHintManager.Activate();
            cHintManager.Start(false);
        }
    }
	*/
    
    void ActivateHints()
    {
        if(cHintManager != null)
            cHintManager.Activate();
    }
    void DeactivateHints()
    {
        if(cHintManager != null)
            cHintManager.Deactivate();
    }
    
    HintManager GetHintManager()
    {
        return cHintManager;
    }
    
    void CheckHints()
    {
        if(cHintManager != null)
            cHintManager.CheckHints();
    }
    
    void MessageToHints( int nId )
    {
        if(cHintManager != null)
            cHintManager.IncomingMessage( nId );
    }
    
    
    //////////////////////////////////////////////////////////////
    // TESTY
    //
    String SpawnObject(String className)
    {
        return SpawnObjectWithMesh(className, null);
    }
    

    String SpawnObjectWithMesh(String className, String meshName)
    {
        if (GetClassID(className) != 0)
        {
            Camera camera = GetActiveViewCamera();
            Vector vPos = camera.GetForwardVector();
            vPos.Mul(-400);
            vPos.Add(camera.GetPosition());
            MeshObject object = (MeshObject)CreateObjectNoInit(className);
            if (meshName != null)
                object.MeshName = meshName;
            object.InitObject();
            object.ActivateOnModule();
            object.SetPositionWorld(vPos);
            Vector vMove = new Vector(0, -2000, 0);
            if (!object.MoveByEllipsoidPure(vMove))
                vPos.Add(vMove);
            object.SetPositionWorld(vPos);
            return "Object of class <" + className + "> spawned!\n";
        }
        else
            return "Incorrect class name!";
    }
	
    void ReinitializeSoundEmitters()
    {
        GameObject[] aObjs = GetObjectsFromClassModule("SoundEmitter", this);
        if(aObjs==null) return;
        for(int i=0; i<aObjs.length; ++i)
        {
            SoundEmitter cEmitter = (SoundEmitter)aObjs[i];
            if(cEmitter != null)
                cEmitter.Reinitialize();
        }
    }
    
    //*********************************************************
	//					SaveGame
    //*********************************************************
	
    /** Metoda wczytujaca zapisane dane w Save gracza
     */	
    public void SGLoadChunk(FileChunk cParentFC)
    {	
        //m_vLoadedHints = new java.util.Vector();
        
		FileChunk.Log("[ChromeModuleSingle.SGLoadChunk]\n");
		
		FileChunk cFC = GameObject.LoadChunk(cParentFC);   
		
        if (cFC.GetID() == ESGChunksChrome._CHK_CHROMEMODULE_SINGLE)
        {	
			super.SGLoadChunk(cFC);
						
			// aktywna kamera
			nActiveCamera = cFC.LoadInt();
            
            //NIE MA TAKIEJ MOZLIWOSCI,ZEBY ZASEJWOWAC PO KONCU MISJI, WIEC CZYTANIE
            //TEGO JEST BEZ SENSU, ZA TO W SGUPDATE MOZEMY ODWOLAC MISSION END KTORY
            //BYL PRZED LOADEM
			// czy misja sie skonczyla
			boolean bMissionEnded = cFC.LoadBool();			
            //NIE PRZYPISUJEMY DO MEMBERA, ON MA BYC NA TRUE JESLI TRZEBA
            
			// flaga mowiaca czy misja jest zakonczona sukcesem
			bMissionSuccessful = cFC.LoadBool();			
			
            bDontUseLevelFinishCamera = cFC.LoadBool();
            fMissionStartTime = cFC.LoadFloat();
            
            int nLoadScenePlaying = cFC.LoadInt();
            int nLoadCurrentDialog = cFC.LoadInt();		
			
			// system alarmow na levelu
			if (m_AlarmsManager == null)
				CrashLog("[ChromeModuleSingle.SGLoadChunk] ERROR! : Loading AlarmsManager failed ! \n");
			m_AlarmsManager.SGLoadChunk(cFC);						

            ObjectsSense.m_CalcManager = (CalcManager)cFC.LoadObject(ObjectsSense.m_CalcManager, this);
            ObjectsSense.m_GridManager = (GridManager)cFC.LoadObject(ObjectsSense.m_GridManager, this);
            AIController.m_NoiseManager = (NoiseManager)cFC.LoadObject(AIController.m_NoiseManager, this);
			
            boolean bPlayingMusic = cFC.LoadBool();
            if(bPlayingMusic)
            {
                if (Music.cPlayingMusic != null)
				    Music.cPlayingMusic.ForceStop();
			
    			Music.cPlayingMusic = (Music)cFC.LoadObjectRef();
            }
            else
                Music.cPlayingMusic = null;
          
			/*
            //hintmanager
            int nHints = cFC.LoadInt();
            for (int i = 0; i < nHints; i++)
            {
                int nHint = cFC.LoadInt();
                if (nHint != -1)
                    m_vLoadedHints.addElement(new Integer(nHint));
            }
			*/
			
			cHintManager = (HintManager)cFC.LoadObject(cHintManager,this);		
            
            m_bImplantsAvailable = cFC.LoadBool();
            
            SoundLoadState(cFC);
        }
		
		cFC.delete();
    }
    
    /** Metoda zapisujaca dane do Save gracza
     */	
    public void SGSaveChunk(FileChunk cFCParent)
    {
		FileChunk.Log("[ChromeModuleSingle.SGSaveChunk]\n");
		
        FileChunk cFC = NewChunk(ESGChunksChrome._CHK_CHROMEMODULE_SINGLE, cFCParent);
		
		super.SGSaveChunk(cFC);
		
		// aktywna kamera
		cFC.SaveInt(nActiveCamera);
		// czy misja sie skonczyla
		cFC.SaveBool(m_bMissionEnded);
		// flaga mowiaca czy misja jest zakonczona sukcesem
		cFC.SaveBool(bMissionSuccessful);
		
        cFC.SaveBool( bDontUseLevelFinishCamera );
        cFC.SaveFloat( fMissionStartTime );
        cFC.SaveInt( nScenePlaying );
        cFC.SaveInt( nCurrentDialog );

		// system alarmow na levelu
		m_AlarmsManager.SGSaveChunk(cFC);			
        
        cFC.SaveObject(ObjectsSense.m_CalcManager);
        cFC.SaveObject(ObjectsSense.m_GridManager);
        cFC.SaveObject(AIController.m_NoiseManager);
		
        cFC.SaveBool(Music.cPlayingMusic != null);
        if(Music.cPlayingMusic != null)
        {
            cFC.SaveObjectRef(Music.cPlayingMusic);
        }

		/*
        //hintmanager
        if (cHintManager != null)
        {
            cFC.SaveInt(cHintManager.m_aHints.size());
            for (int i = 0; i < cHintManager.m_aHints.size(); i++)
            {
                Hint cHint = (Hint)cHintManager.m_aHints.elementAt(i);
                if (!cHint.m_bToRemove && 
                    !(cHint instanceof HintTutorial))
                {
                    cFC.SaveInt((cHint).m_nId);
                }
                else
                {
                    cFC.SaveInt(-1);
                }
            }
        }
        else
        {
            cFC.SaveInt(0);
        }
		*/
	
     	cFC.SaveObject(cHintManager);		
        
        cFC.SaveBool(m_bImplantsAvailable);
        
        SoundSaveState(cFC);		
        
        cFC.delete();
    }		
	
	public void SGUpdate()
	{
        if (m_bMissionEnded)
        {
            DisableMissionEnd();            
            ReinitializeSoundEmitters();
        }
        
        // wylaczamy deszcz
        //MK: to zaremowalem, bo Czesiu ma lokalnie to u siebie
        //RainListenerResetSound();
        
		FileChunk.Log("[ChromeModuleSingle.SGUpdate]\n");
		super.SGUpdate();
		
		SetActiveCamera(CAMERA_PLAYER);
		//SetActiveCamera(nActiveCamera);
		
		if ((GetMainPlayer().cSeatInfo != null) && 
			(GetMainPlayer().cSeatInfo.GetOccupiedObject() != null) &&
			(GetMainPlayer().cSeatInfo.GetOccupiedObject() instanceof StationaryCannon))
		{
			((StationaryCannon)GetMainPlayer().cSeatInfo.GetOccupiedObject()).SGUpdate();
		}
		

        if (ObjectsSense.m_CalcManager != null)
            ObjectsSense.m_CalcManager.SGUpdate();
        if (ObjectsSense.m_GridManager != null)
            ObjectsSense.m_GridManager.SGUpdate();
        if (AIController.m_NoiseManager != null)
            AIController.m_NoiseManager.SGUpdate();

        CallMethodIn("RegisterKeyRequest", 0);

        if (sSaveGameName.toLowerCase().indexOf("quick") != -1 && m_bQuickloading)
        {
            MethodCaller.cThis.CallQuickLoadOK(this);
        }
        else
        {
            m_bQuickloading = false;
        }
        //MethodCaller.cThis.CallInitLoadedHints(this);
        
        //CallOnFrameEnd("InitLoadedHints");
        //CallOnFrameEnd("ClearInputQueue");
				
		if (cHintManager != null)
			cHintManager.SGUpdate();			
		
        ClearInputQueue();
	}
	
	/*
    java.util.Vector m_vLoadedHints = null;
    void AddLoadedHints()
    {
        for (int i = 0; i < m_vLoadedHints.size(); i++)
        {
            int nHintId = ((Integer)m_vLoadedHints.elementAt(i)).intValue();
            switch(nHintId)
            {
            case Hint._HINT_JEEPAVAILABLE:
                cHintManager.AddHint( new HintJeepAvailable() );
                break;
            case Hint._HINT_HEALTHEXNEEDED:
                cHintManager.AddHint( new HintHealthexNeeded() );
                break;
            case Hint._HINT_RELOADNEEDED:
                cHintManager.AddHint( new HintReloadNeeded() );
                break;
            case Hint._HINT_SEARCH_BODY:
                cHintManager.AddHint( new HintSearchBody() );
                break;
            case Hint._HINT_BODY_SPOTTED:
                cHintManager.AddHint( new HintBodySpotted() );
                break;
            case Hint._HINT_CAMOUFLAGE:
                cHintManager.AddHint( new HintCamouflage() );
                break;
            case Hint._HINT_CLOAKING_DEVICE:
                cHintManager.AddHint( new HintCloakingDevice() );
                break;
            case Hint._HINT_SNEAKING:
                cHintManager.AddHint( new HintSneaking() );
                break;
            default:
                if (Hint.IsImplantHint(nHintId))
                    cHintManager.AddHint(new HintImplant(nHintId));
                break;
            }
        }
    } 
	*/

    Player GetMainPlayer()
    {
        return MainPlayer;
    }
    
    
    ///////////////////////////////////////////////////
    // Widocznosc obiektow (dla AI)
    
    /** Pobranie mnoznika zasiegu widzenia na levelu (dla AI) */
    float GetVisibilityRangeFactor()
    {
        return fVisibilityRangeFactor;
    }
    /** Pobranie maksymalnego zasiegu widzenia na levelu (dla AI) */
    float GetVisibilityRangeThreshold()
    {
        return fVisibilityRangeThreshold;
    }
    
    ///////////////////////////////////////////////////
    // Glosnosc muzyki
    
}    

/** Klasa opisuje pojedynczego aktora bioracego udzial w scenach gry.
 */
class CharacterDescription
{
    char chInitial;
    int nTexture;
    AnimActor cActor = null;
    String sTalkingHeadModuleClassName = null;
	String sName = null;
    TalkingHeadModule cTalkingHeadModule = null;
}
