import java.io.*;

public class Destroyable extends ChromeActor
{
    //////////////
    // ATRYBUTY //
    //////////////
    
    /** Okresla czy obiekt ma byc skasowany po rozwaleniu */
    public boolean bDeleteAfterDestroy = false;//#DESTROYABLE;When set to true object will be deleted after destoying
    
    /** Zasieg wybuchu obiektu w jakim odbierana jest energia */
    public float fBlastRange = 0.0f;//#DESTROYABLE
    
    /** Blast damage odbierany w centrum wybuchu */
    public float fBlastDamage = 0.0f;//#DESTROYABLE
    
    /** Nazwa FXow do odpalenia przy wybuchu */
    public String sBlowFX = null;//#DESTROYABLE

    /** Nazwa dzwieku odpalanego */
    public String sBlowSound = "Data/Sounds/Demolish/Demolish";//#DESTROYABLE
    
    float fMinSoundRange = -1f; // zakresy dzwieku - jezeli beda zostawione bez zmian wtedy
    float fMaxSoundRange = -1f; // dzwiek bedzie odpalany przez PlaySound bez parametrow
    
    /** Trzesienie kamera */
    public float fBlowUpShakeStrength = 0;//#DESTROYABLE
    public float fBlowUpShakeDistMin = 0;//#DESTROYABLE
    public float fBlowUpShakeDistMax = 0;//#DESTROYABLE

    /** Czas po jakim obiekt odpala sie efekt wybuchu */
    public float fDelayTime = 0.5f;//#DESTROYABLE
    
    /** Ile energii trzeba zabrac obiektowi jednorazowo, zeby wybuchl */
    public float fBlowThreshold = 50.f;//#DESTROYABLE
    
    /** Prog kiedy obiekt zmienia mesha */
    public float fDemolishThreshold = 50.0f;//#DESTROYABLE
    
    /** Obiekt, ktory aktualnie obiera nam energie */
    GameObject cAssassin = null;
    
    /** Czy odpalac dwa systemy particli (drugi to nazwa + 2)*/
    boolean m_bSecondParticleSystem = false;
    ////////////
    // METODY //
    ////////////
    
    // zeby zycie policzyc na podstawie wielkosci tu jest -1;
    public float m_fDestroyableHealth = -1f;//#DESTROYABLE
    
    Destroyable()
    {
        fHealth = m_fDestroyableHealth; 
    }

    public void OnCreate()
    {
        super.OnCreate();
		
		bSG = true;
        
        
        if ((MeshName.toLowerCase().endsWith("butelka.3da")) ||
            (MeshName.toLowerCase().endsWith("butelkaczysta.3da")) ||
            (MeshName.toLowerCase().endsWith("butelkapelna.3da")))
        {
            sBlowFX = "FXGlassBlow";
            if (fHealth < 0)
                fHealth = 10.0f;
            fBlowThreshold = 10f;
            sBlowSound = "data/sounds/demolish/glass_large";
            fMinSoundRange = 300f;
            fMaxSoundRange = 1500f;
        }
        else
        if((MeshName.toLowerCase().endsWith("szklanka.3da")) ||
            (MeshName.toLowerCase().endsWith("szklankapelna.3da")))
        {
            sBlowFX = "FXGlassBlowSmall";
            if (fHealth < 0)
                fHealth = 10.0f;
            fBlowThreshold = 10f;
            sBlowSound = "data/sounds/demolish/glass_small";
            fMinSoundRange = 300f;
            fMaxSoundRange = 1500f;
        }
        else
        if ((MeshName.toLowerCase().endsWith("butla.3da")) ||
            (MeshName.toLowerCase().endsWith("kanister.3da")))
        {
            sBlowFX = "FXBlowFlammable";
            if (fHealth < 0)
                fHealth = 80.0f;
            fMinSoundRange = 1500f;
            fMaxSoundRange = 3000f;
        }
        else  
        if (MeshName.toLowerCase().endsWith("kostka.3da"))
        {
            sBlowFX = "FXTinBlow";
            if (fHealth < 0)
                fHealth = 20.0f;
            fBlowThreshold = 20f;
            sBlowSound = "data/sounds/demolish/cube";
            fMinSoundRange = 300f;
            fMaxSoundRange = 1200f;
        }
        else
        if (MeshName.toLowerCase().endsWith("puszka.3da"))
        {
            sBlowFX = "FXTinBlow";
            if (fHealth < 0)
                fHealth = 20.0f;
            fBlowThreshold = 20f;
            sBlowSound = "data/sounds/demolish/tin";
            fMinSoundRange = 300f;
            fMaxSoundRange = 1200f;
        }
        else
        if (MeshName.toLowerCase().endsWith("szachownica.3da"))
        {
            sBlowFX = "FXTinBlow";
            if (fHealth < 0)
                fHealth = 20.0f;
            fBlowThreshold = 20f;
            sBlowSound = "data/sounds/demolish/board";
            fMinSoundRange = 300f;
            fMaxSoundRange = 1200f;
        }
        else
        if ((MeshName.toLowerCase().endsWith("pudlo.3da")))
        {
            sBlowFX = "FXBlowBox";
            if (fHealth < 0)
                fHealth = 80.0f;
            fBlowThreshold = 20;
            fMinSoundRange = 300f;
            fMaxSoundRange = 2000f;
        }
        else
        if ((MeshName.toLowerCase().endsWith("gasnica.3da")))
        {
            sBlowFX = "FXBlowBarrel";
            if (fHealth < 0)
                fHealth = 100.0f;
            fMinSoundRange = 800f;
            fMaxSoundRange = 2500f;
        }
        else
        if ((MeshName.toLowerCase().endsWith("laptop.3da")))
        {
            m_bSecondParticleSystem = true;
            sBlowFX = "FXBlowLaptop";
            if (fHealth < 0)
                fHealth = 40.0f;
            fBlowThreshold = 20;
            sBlowSound = "data/sounds/demolish/laptop";
            fMinSoundRange = 300f;
            fMaxSoundRange = 1200f;
        }
        else
        if(MeshName.toLowerCase().endsWith("rurakrataa.3da"))
        {
            sBlowFX = "FXBlowBigBar";
            //sBlowSound = "data/sounds/demolish/";
            fMinSoundRange = 800f;
            fMaxSoundRange = 2000f;
        }
        else
        if(MeshName.toLowerCase().endsWith("pretya.3da"))
        {
            sBlowFX = "FXBlowBar";
            //sBlowSound = "data/sounds/demolish/";
            fMinSoundRange = 300f;
            fMaxSoundRange = 2000f;
        }
        
        // ustalamy jakiego typu fx i dzwiek podpiac pod obiekt
        float fSize = GetMeshSize();
        //CrashLog("Object '"+GetName()+"' size="+fSize+"\n");
        
        if(sBlowFX==null)
        {
            // wybieramy fxa na podatawie wielkosci
            if(fSize < 100.0f)
            {
                sBlowFX = "FXDemolishSmall";
                sBlowSound = "Data/Sounds/Demolish/DemolishSmall";
                if (fHealth < 0)
                    fHealth = 300.0f;
                fMinSoundRange = 300f;
                fMaxSoundRange = 1500f;
            }
            
            if(100.0f <= fSize && fSize <= 200.0f)
            {
                sBlowFX = "FXDemolishCrate";
                sBlowSound = "Data/Sounds/Demolish/DemolishMedium";
                if (fHealth < 0)
                    fHealth = 400.0f;
                fMinSoundRange = 500f;
                fMaxSoundRange = 2000f;
            }
            
            if(200.0f < fSize )
            {
                sBlowFX = "FXDemolishCrate";
                sBlowSound = "Data/Sounds/Demolish/DemolishLarge";
                if (fHealth < 0)
                    fHealth = 500.0f;
                fMinSoundRange = 800f;
                fMaxSoundRange = 2500f;
            }
        }
        
        if (fHealth < 0)
            fHealth = 300; //stara wartosc z konstruktora

        // sprawdzamy czy jest na dysku mesh zniszczony
        String sDemolishedMesh = GetDemolishedMesh();
        if(sDemolishedMesh!=null)
        {
            java.io.File cCheckFile = new File(sDemolishedMesh);
            if(!cCheckFile.exists())
            {
                // nie ma pliku wiec nie ma co przelaczac meshy
                fDemolishThreshold = 0.0f;
            }
            else
                Precache.AddMeshToPrecache(sDemolishedMesh);
        }
    }
    
    /** Flaga mowi czy trafienie bylo wieksze niz fBlastThreshold */
    boolean bGreatHit = false;
    
/*    public void OnTakeDamage(float fDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed, int nDamageType)
    {
        if (bDead)
			return;
        
        bGreatHit = fDamage > fBlowThreshold;
        if (nDamageType == -2)
			bGreatHit = true;
        
        cAssassin = Assassin;
        Damage(fDamage);
        cAssassin = null;
        bGreatHit = false;
    }
*/
	// poprawione OnTakeDamage //////////////////////////////////////////////////////////////
    public void OnTakeDamage(float fDamage, float fPhSimDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed, int nMeshElementorBoneID, int nDamageType)
    {
        if (bDead)
			return;

        bGreatHit = fDamage > fBlowThreshold;
        
        cAssassin = Assassin;
        Damage(fDamage, nDamageType);
        
        cAssassin = null;
        bGreatHit = false;
    }

    public void Damage(float fDamage, int nDamageType)
    {
		if (!GetsDamageIfType(nDamageType))
			return;
		
		// sprawdzamy czy obiekt nie powinien sie zdemolowac
        if (fDemolishThreshold != 0f)
        {
            if( (fHealth - fDamage < fDemolishThreshold) &&
                (fHealth >= fDemolishThreshold) )
            {
                Demolish();
            }
        }
        
        super.Damage(fDamage, nDamageType);
    }
    
    String GetDemolishedMesh()
    {
        String sLowerName = MeshName.toLowerCase();
        int nExt = sLowerName.indexOf(".3da");
        String sBaseMesh = MeshName.substring(0,nExt);
		if (sLowerName.indexOf("dem00.3da") != -1)
			return MeshName;
        return sBaseMesh + "Dem00.3da";
    }
    
    public void Demolish()
    {
        // kasujemy fxy poprzednio dodane do obiektu
        if(!bLoadingSG) CallMethodIn("DeleteAttachedFXes", 0.0f);
        
        // kasujemy wszystko co bylo postawione na obiekcie
        if(!bLoadingSG) CallMethodIn("DieAllDestroyableChildren", 0.0f);
        
        // podmieniamy mesha
        MeshName = GetDemolishedMesh();
        LoadMesh();
        
        // zmieniamy kolor na poszarzaly
        SetMeshColor(new Vector(0.3f, 0.3f, 0.3f));
        
        // odpalamy fxa
        if(!bLoadingSG) SpawnFX();
    }
    
    public void Die()
    {
        super.Die();
        
        if ( bGreatHit || bDeleteAfterDestroy )
        {
            bDead = true;
            
            // efekt wybuchu
            if(!bLoadingSG) SpawnFX();
            
            // chowamy po wybuchu beczke
            DeleteAttachedFXes();
            DetachFromParentAndKeepWorldPos();
            DeactivateOnModuleAlways();
            
            
            DieAllDestroyableChildren();
            CallMethodIn( "DelayedBlow", RandomFloat( fDelayTime ) );
        }
        else
        {
            bDead = false;
        }
    }

    /**
     * Rozwala wszystkie podlaczone obiekty 
     * TOD: zastanowic sie co bedzie jak na obiekcie
     * Destroyable bedzie stalo cos innego (nie pochodzace
     * z tej klasy)
     */
    void DieAllDestroyableChildren()
    {
        GameObject [] aChildren = GetChildren();
        if (aChildren == null) 
            return;
        for ( int i = 0; i < aChildren.length; i++ )
        {
            if ( aChildren[i] instanceof Destroyable )
            {
                Destroyable cDestroyable = (Destroyable)aChildren[ i ];
                // zwykle obiekty odlaczamy i chowamy
                cDestroyable.bDeleteAfterDestroy = true;
                cDestroyable.Die();
            }
        }
    }
    

    void DelayedBlow()
    {
        // odpalamy odbieranie energii obiektom w promieniu
        if ( (fBlastRange > 0.0f) || (fBlastDamage > 0.0f) ) 
            Blast();
        
        //CallMethodIn("delete", 0.0f);
    }
    
    /** Odpalamy efekt wybuchu. Do pokrycia w klasach pochodnych, gdy
     * ma byc niestandardowy efekt wybuchu.
     */
    public void SpawnFX()
    {
        if( sBlowFX != null)
        {
            //CrashLog("A teraz FX:" + sBlowFX + "\n");
            ExecuteFX(sBlowFX, GetPosition(), Vector.Up);
            ExecuteParticleSystem(sBlowFX, GetPosition(), Vector.Up);
            
            if (m_bSecondParticleSystem)
                ExecuteParticleSystem(sBlowFX + "2", GetPosition(), Vector.Up);
            
            if (fBlowUpShakeStrength > 0)
                ShakePlayersCamera(fBlowUpShakeStrength, fBlowUpShakeDistMin, fBlowUpShakeDistMax);

            // sprawdzamy czy obiekt nie stoi na czyms innym
/*  ///TODO: RK zablokowalem z powodu braku trace-a FXDemolishLarge!
            Vector vPos = GetPosition();
            float fTerrainY=TerrainHeight(vPos.fX, vPos.fY);
            float fDiff = vPos.fY - fTerrainY;
            if( 0 <= fDiff && fDiff < 50.0f)
                ExecuteFXTrace(sBlowFX, GetPosition(), Vector.Up);
*/
        }

        if( sBlowSound != null)
        {
            String sSound = sBlowSound + (1+RandomInt(3)) +".wav";
            
            if (fMinSoundRange != -1f)
                PlaySound(sSound, fMinSoundRange, fMaxSoundRange);
            else
                PlaySound(sSound);
        }
    }

    /** Odebranie energii obiektom wokol wybuchu
     */
    void Blast()
    {
        MakeBlastDamage(fBlastDamage, fBlastDamage, GetPosition(), fBlastRange, true,
						cAssassin instanceof Actor ? (Actor)cAssassin : null, EnumDamageType._BLAST);
	}

    //*********************************************************
	//					SaveGame
    //*********************************************************
	
    /** Metoda wczytujaca zapisane dane w Save gracza
     */	
    public void SGLoadChunk(FileChunk cParentFC)
    {	
		FileChunk.Log("[Destroyable.SGLoadChunk]\n");
		
		FileChunk cFC = GameObject.LoadChunk(cParentFC);   
		
        if (cFC.GetID() == ESGChunksChrome._CHK_DESTROYABLE)
        {	
			super.SGLoadChunk(cFC);
			
			String sMeshName = cFC.LoadString();
			
			if (sMeshName == null)
				GameObject.CrashLog("[Destroyable.SGLoadChunk] ERROR! MeshName = NULL for <"+GetName()+"> \n");
						
			if ((sMeshName != null) && (sMeshName.compareTo(MeshName) != 0))
			{
				FileChunk.Log("[LoadMesh] : "+sMeshName+" from "+MeshName+" Name = <"+GetName()+"> ID = <"+GetUniqueID()+">\n");
				LoadMesh(sMeshName);
			}
			
            fHealth = cFC.LoadFloat();

            // odtwarzamy stan obiektu
            if(fHealth < fDemolishThreshold)
				Demolish();
        }
		
		cFC.delete();
    }
    
    /** Metoda zapisujaca dane do Save gracza
     */	
    public void SGSaveChunk(FileChunk cFCParent)
    {
		FileChunk.Log("[Destroyable.SGSaveChunk]\n");
		
        FileChunk cFC = NewChunk(ESGChunksChrome._CHK_DESTROYABLE, cFCParent);
		
		super.SGSaveChunk(cFC);
		
		if (MeshName == null)
			FileChunk.Log("[Destroyable.SGSaveChunk] MeshName = NULL for <"+GetName()+"> \n");
				
		cFC.SaveString(MeshName);

        // zapisujemy energie obiektu
        cFC.SaveFloat(fHealth);
        
        cFC.delete();
    }	
}
