public class DoorableBase extends MeshObject
{
    /** Odleglosc w jakiej budynki reaguja na otwieranie drzwi
     */
    public float fDoorReactionDistance = 150.0f;//#DOORABLEBASE
    
    /** dzwiek, ktory jest odgrywany przy otwieraniu
     */
    public String sOpenSound = "Data/Sounds/DoorD_Open.wav";//#DOORABLEBASE
    
    /** dzwiek, ktory jest odgrywany przy zamykaniu
     */
    public String sCloseSound = "Data/Sounds/DoorD_Close.wav";//#DOORABLEBASE
    
    /** poczatkowa klatka animacji otwierania drzwi
     */
    public int nOpenStartFrame = 0;//#DOORABLEBASE
    
    /** koncowa klatka animacji
     */
    public int nOpenEndFrame = 50;//#DOORABLEBASE
    
    /** poczatkowa klatka animacji otwierania drzwi
     */
    public int nCloseStartFrame = 50;//#DOORABLEBASE
    
    /** koncowa klatka animacji
     */
    public int nCloseEndFrame = 100;//#DOORABLEBASE

    // flaga okresla czy drzwi maja sie otworzyc jak trup jest w poblizu
    public boolean bDeadCanOpen = false;//#DOORABLEBASE
    
    /** Zasieg halasu drzwi.
     */
    float fDoorNoiseRange = 1000.0f;
    
    /** Dzwiek wydawany przez drzwi.
     */
    static final int _NOISE_DOOROPEN = 51;
    
    /** Tablica Pawn'ow znajdujacych sie aktualnie w budynku, 
     * updatowana przez PawnInside & PawnOutside
     */
    java.util.Vector aVisitors = new java.util.Vector();
	
	DoorableBase()
	{
		bSG = true;
	}

    public void PawnInside(Pawn cPawn)
    {
        if (aVisitors.indexOf(cPawn) == -1)
            aVisitors.addElement(cPawn);
    }

    public void PawnOutside(Pawn cPawn)
    {
        aVisitors.removeElement(cPawn);
    }
	
    //*********************************************************
	//					SaveGame
    //*********************************************************	
	
    /** Metoda wczytujaca zapisane dane w Save gracza
     */	
    public void SGLoadChunk(FileChunk cParentFC)
    {	
		FileChunk.Log("[DoorableBase.SGLoadChunk]\n");
		
		FileChunk cFC = GameObject.LoadChunk(cParentFC);   
		
        if (cFC.GetID() == ESGChunksChrome._CHK_DOORABLE_BASE)
        {	
			super.SGLoadChunk(cFC);

			// Tablica Pawn'ow znajdujacych sie aktualnie w budynku, 
			aVisitors = cFC.LoadObjectsVectorRef();
        }
		
		cFC.delete();
    }
    
    /** Metoda zapisujaca dane do Save gracza
     */	
    public void SGSaveChunk(FileChunk cFCParent)
    {
		FileChunk.Log("[DoorableBase.SGSaveChunk]\n");
		
        FileChunk cFC = NewChunk(ESGChunksChrome._CHK_DOORABLE_BASE, cFCParent);
		
		super.SGSaveChunk(cFC);
		
		// Tablica Pawn'ow znajdujacych sie aktualnie w budynku, 
		cFC.SaveObjectsVectorRef(aVisitors);
					
        cFC.delete();
    }	    					
}
