public class DoorsObject extends DoorableBase implements iact_LockUnlock, iact_LockOpened
{
    /** Okresla czy drzwi sa zablokowane */
    public boolean bLock = false;//#DOORSOBJECT

    /** Gdy true to drzwi zamykaja sie bez wzgledu na aktualnie odpalana animacje */
    public boolean bCloseIgnoresOpenAnim = true;//#DOORSOBJECT
    
    /** Aktualny stan drzwi */
    boolean bDoorsOpened = false;
    
    /** Czas w ktorym ostatnio drzwi sie zamknely lub otwarly */
    float fSwitchTime = 0.0f;
    
    /** Identyfikatory portali */
    int nPortalIn, nPortalOut;
    
    /** Identyfikator animacji */
    int nAnimOpenID, nAnimCloseID;

    /** Lista obiektow indykatorow stanu drzwi */
    public TriggerObject[] cIndicators = null;//#DOORSOBJECT;Lampki do drzwi , jesli null to drzwi sobie same znajda
    /** Tablica obiektow indykujacych stan drzwi */
    TriggerObject[] aIndicators = null;
    
    String[] m_sIndicatorElems = new String[]{
                                    "TerminalA",
                                    "Terminal"
                                    };

    /** Znacznik, ze drzwi znajduja sie na module singleplayerowym
     */
    protected boolean m_bSinglePlayerModule;
    
    public boolean bMakeNoise = true;//#DOORSOBJECT
    /** Zasieg noise'a wydawanego przez otwierajace sie drzwi */
    public float fNoiseRangeOpen = 2000.f;

    DoorsObject()
    {
        nOpenStartFrame = 0;
        nOpenEndFrame = 30;
        nCloseStartFrame = 30;
        nCloseEndFrame = 60;
    }
    
    public void OnCreate()
    {
		bSG = true;
		
        nPortalIn =  GetPortalID("Portal01");
        nPortalOut = GetPortalID("Portal02");
		
        ClosePortals();

        // wyliczamy animacje otwarcia
        int nLastFrame = (int)GetNumFrames();
        nOpenStartFrame = 0;
        nOpenEndFrame = nLastFrame/2;
        nCloseStartFrame = nLastFrame/2;
        nCloseEndFrame = nLastFrame;
        
        //inicjalizacja animacji 
        InitAnimSeq("opening", nOpenStartFrame, nOpenEndFrame);
        InitAnimSeq("closing", nCloseStartFrame, nCloseEndFrame);
        nAnimOpenID = GetAnimID(0, "opening");
        nAnimCloseID = GetAnimID(0, "closing");

        //ustawienie predkosci odtwarzania
        SetAnimMorphTime(0);

        SetFrame(nCloseEndFrame, 0);
        //iDoorCloseMethod = RegisterCallMethod("DoorClosed");
            
        ClearFlag(EFlags._NO_ANIMATION);
        ClearFlag(EFlags._NO_ANIMATION_REFRESH);
        
        SetFlag(EFlags._COLLISION);
        SetFlag(EFlags._BLOCK_MOVE);
        SetFlag(EFlags._BLOCK_TRACE);
        SetTraceCollType(ECollTraceFlags._HULL);
        SetFlag(EFlags._NO_CULL_BY_SIZE);
        
        ClearFlag(EFlags._CAST_SHADOWS);
        ClearFlag(EFlags._AI_TARGET);
        
        m_bSinglePlayerModule = (GetModule() instanceof ChromeModuleSingle);
        
        CallMethodIn("Init", 0.0f);
    }
    
    void GetNearestDoorsIndicators()
    {
        Vector vPos = GetPosition();
        GameObject[] aLampkas = GetObjectsInRadiusFromClass(vPos, 300.0f, "TriggerObject");
        float fMinDist = 100000000000.0f;
        float fMinDist2 = 100000000000.0f;
        int nMinLampka = -1;
        int nMinLampka2 = -1;
        for(int i=0; i<aLampkas.length; i++)
        {
            if (!IsIndicator((MeshObject)aLampkas[i]))
                continue;
            
            float fDist = vPos.Distance2(((ControlObject)aLampkas[i]).GetPosition());
            if(fDist < fMinDist)
            {
                if (nMinLampka != -1)
                {
                    nMinLampka2 = nMinLampka;
                    fMinDist2 = fMinDist;
                }
                fMinDist = fDist;
                nMinLampka = i;
            }
            else
            {
                if(fDist < fMinDist2)
                {
                    fMinDist2 = fDist;
                    nMinLampka2 = i;
                }
            }
        }

        if(nMinLampka != -1 && nMinLampka2 != -1)
        {
            aIndicators = new TriggerObject[2];
            aIndicators[0] = (TriggerObject)aLampkas[nMinLampka];
            aIndicators[1] = (TriggerObject)aLampkas[nMinLampka2];
        }
        else
            if (nMinLampka != -1)
            {
                aIndicators = new TriggerObject[1];
                aIndicators[0] = (TriggerObject)aLampkas[nMinLampka];
            }
            else
                if (nMinLampka2 != -1)
                {
                    aIndicators = new TriggerObject[1];
                    aIndicators[0] = (TriggerObject)aLampkas[nMinLampka2];
                }
        
    }
    
    boolean IsIndicator(MeshObject cObj)
    {
        for (int i = 0; i < m_sIndicatorElems.length; i++)
        {
            if (cObj.GetElementID(m_sIndicatorElems[i]) != -1)
                return true;
        }
        return false;
        
    }
    
    /** Inicjalizacja po wczytaniu wszystkich obiektow
     */
    void Init()
    {
        if(cIndicators==null)
        {
            GetNearestDoorsIndicators();
        }
        else
        {
            // przepisujemy indykatory drzwi
            int nObjects = cIndicators.length;
            aIndicators = new TriggerObject[nObjects];
            for(int i=0; i<nObjects; ++i)
            {
                aIndicators[i] = cIndicators[i];
            }
        }

        if(bLock && bDoorsOpened)
            LockOpened();
        else
        {
            if(bLock && !bDoorsOpened)
                Lock();
            else if (!bLoading || bDoorsOpened)
                OpenDoors();
        }
        
        UpdateIndicators();
    }
    
    /** Update stanu lampek
     */
    void UpdateIndicators()
    {
        if(aIndicators==null) return;
        for(int i=0; i<aIndicators.length; ++i)
                if(bLock && !bDoorsOpened)
                    aIndicators[i].SetSkin("Locked");//DoorClose();
                else
                    aIndicators[i].SetSkin("Unlocked");//DoorOpen();
    }
    
    void OpenDoors()
    {
        if ( Role == ERole._AUTHORITY )
        {
            if ( OpenDoorsDo( GetTime() ) )
            {
                MsgSendClientState();            
            }
        }
    }
    
    boolean OpenDoorsDo( float fTime )
    {
        if (bLock || !IsActiveOnModule()) 
            return false;
        
        //ustawiam flage ze drzwi sa otwarte
        if (bDoorsOpened == false) //jestem blisko i sa zamkniete
        {
            if( (!IsPlaying(nAnimOpenID)) && (!IsPlaying(nAnimCloseID)) )
            {
                //CrashLog("[DoorsObject.OpenDoors] Playing open doors anim\n");
                //TODO: uwzglednic czas! fTime
                
                PlayAnim(nAnimOpenID, 1);
                PlaySound(sOpenSound);

                if (m_bSinglePlayerModule && bMakeNoise)
                {
                    Actor noisyActor = ((ChromeModuleSingle)GetModule()).DummyNoisyActor;
                    noisyActor.SetPositionWorld(GetPositionVectorVolatile());
                    noisyActor.MakeNoise(fNoiseRangeOpen, Pawn._NOISE_PASSAGE);
                }
                
                bDoorsOpened = true;
                fSwitchTime  = fTime;

                // otwieramy portale
                OpenPortals();
                
                //added by MK, zeby nie bylo problemow gdy zawola
                //sie otwieranie drzwi zanim do konca one sie zamkna...
                DisableCallMethod("DelayedCloseDoors");
                
                return true;
            }
        }
        
        return false;
    }
    
    void CloseDoors()
    {
        if ( Role == ERole._AUTHORITY )
        {
            if (CloseDoorsDo( GetTime() ))
            {
                MsgSendClientState();
            }
        }
    }
    
    boolean CloseDoorsDo( float fTime )
    {
        if (bLock || !IsActiveOnModule()) 
            return false;
        
        //ustawiam flage ze drzwi sa otwarte
        if (bDoorsOpened == true) //jestem poza i sa otwarte
        {
            boolean bNotPlayingOpenAnim = !IsPlaying(nAnimOpenID);
            if(bCloseIgnoresOpenAnim) bNotPlayingOpenAnim = true;
            
            if( bNotPlayingOpenAnim && (!IsPlaying(nAnimCloseID)) )
            {
                //CrashLog("[DoorsObject.CloseDoors] Playing close anim\n");
                
                PlayAnim(nAnimCloseID, 1);
                PlaySound(sCloseSound);
                
                bDoorsOpened = false;
                fSwitchTime  = fTime;
                
                // zamykamy portal z opoznieniem
                float fCloseAnimLen = GetAnimLength(nAnimCloseID);
                //TODO moze dodac jeszcze lekkie opoznienie
                CallMethodIn("DelayedCloseDoors", fCloseAnimLen);
                
                return true;
            }
        }
        
        return false;
    }
    
    void DelayedCloseDoors()
    {
        //CrashLog("[DoorsObject.DelayedCloseDoors] \n");
        
        ClosePortals();
    }
    
    /** Metoda sprawdza
     */
    boolean IsAnybodyNearDoor()
    {
        // sprawdzamy wszystkich visitorow
        // wlasciwie to nie trzeba, bo drzwi sa pojedyncze
        return true;    
    }
    
    /** metoda wywolywana przez DoorContolera, gdy Pawn znajdzie sie w poblizu DoorableObjectu
     */
    public void PawnInside(Pawn cPawn)
    {
        super.PawnInside(cPawn);
        
        if(IsAnybodyNearDoor())
        {
            OpenDoors();

            //TODO FIXIT! Powinno byc chyba odpalanie noisa na pozycji drzwi!!!
            //cPawn.MakeNoise(fDoorNoiseRange, _NOISE_DOOROPEN);
        }
    }

    public void PawnOutside(Pawn cPawn)
    {
        super.PawnOutside(cPawn);

        // zamykamy drzwi jak nikt juz nie stoi przy drzwiach
        if(aVisitors.size()==0)
            CloseDoors();
    }
    

    /** Blokowanie otwierania drzwi
     */
    public void Lock()
    {
        bLock = false;
        CloseDoors();
        bLock = true;
        UpdateIndicators();
    }
    
    /** Blokowanie otwierania drzwi z otwartym stanem drzwi
     */
    public void LockOpened()
    {
        bLock = false;
        OpenDoors();
        bLock = true;
        UpdateIndicators();
    }

    /** Odblokowanie otwierania drzwi
     */
    public void Unlock()
    {
        bLock = false;
        UpdateIndicators();
    }
    
    public boolean IsLocked()
    {
        return bLock;
    }
    
    public void ToggleLockUnlock()
    {
        if(bLock)
            Unlock();
        else
            Lock();
    }
        
    public void ReplicationInit()
    {
    }
    
    public void OnReplicateServer()
    {
        if ( bNetInit )
            MsgSendClientState();
    }
    
    final static int MSG_CLIENT_INIT  = 0;
    final static int MSG_CLIENT_STATE = 1;
    
    public void OnMessage()
    {
        switch ( MessageGetId() )
        {
        case MSG_CLIENT_INIT:
            LogD(" MSG_CLIENT_INIT\n");
            MsgRecvClientInit();
            break;
            
        case MSG_CLIENT_STATE:
            LogD(" MSG_CLIENT_STATE\n");
            MsgRecvClientState();
            break;
        
        default:
            MessageCancel();
        }
    }
    
    void MsgSendClientInit()
    {
        MessageNew( MSG_CLIENT_INIT );
        //TODO: pobrac identyfikator
        MessagePackInt( 0 );
        MessagePackVector( GetPosition() );
        MessagePackBoolean( bDoorsOpened );
        MessagePackFloat( fSwitchTime );
        //TODO
        MessageSend();
    }
    
    void MsgRecvClientInit()
    {
        //TODO
        int     nId   = MessageUnPackInt();
        Vector  vPos  = MessageUnPackVector();
        boolean bOpen = MessageUnPackBoolean();
        float   fTime = MessageUnPackFloat();
        MessageEnd();
        
        //LogD(" vPos:"+vPos+" bOpen:"+bOpen+"\n");
        //TODO: odswiezyc identyfikator
        //SetThisID( nId );
        //TODO: zawolac przeliczenie portali
        
        SetPosition( vPos );
        if ( bOpen )
            OpenDoorsDo( fTime );
        else
            CloseDoorsDo( fTime );
    }
    
    void MsgSendClientState()
    {
        MessageNew( MSG_CLIENT_STATE );
        MessagePackBoolean( bDoorsOpened );
        MessagePackFloat( fSwitchTime );
        MessageSend();
    }
    
    void MsgRecvClientState()
    {
        boolean bOpen = MessageUnPackBoolean();
        float   fTime = MessageUnPackFloat();
        MessageEnd();
        
        if ( bDoorsOpened != bOpen && fSwitchTime <= fTime )
        {
            if ( bOpen )
                OpenDoorsDo( fTime );
            else
                CloseDoorsDo( fTime );
        }
    }

    void OpenPortals()
    {
        OpenPortal(nPortalIn);
        OpenPortal(nPortalOut);
    }
    
    void ClosePortals()
    {
        ClosePortal(nPortalIn);
        ClosePortal(nPortalOut);
    }
    
    //*********************************************************
	//					SaveGame
    //*********************************************************
	
    /** Metoda wczytujaca zapisane dane w Save gracza
     */	
    public void SGLoadChunk(FileChunk cParentFC)
    {	
		FileChunk.Log("[DoorsObject.SGLoadChunk]\n");
		
		FileChunk cFC = GameObject.LoadChunk(cParentFC);   
		
        if (cFC.GetID() == ESGChunksChrome._CHK_DOORS_OBJECT)
        {
			super.SGLoadChunk(cFC);
			
            String sName = GetName();

			// Okresla czy drzwi sa zablokowane
			bLock = cFC.LoadBool();
			// Aktualny stan drzwi
			bDoorsOpened = cFC.LoadBool();
						
			// Czas w ktorym ostatnio drzwi sie zamknely lub otwarly
			fSwitchTime = cFC.LoadFloat();
            
            boolean bPlayingAnim = false;
            
			if (cFC.LoadBool())
            {
				//PlayAnim(nAnimOpenID, 1);
                bPlayingAnim = true;
            }
			
			if (cFC.LoadBool())
            {
				//PlayAnim(nAnimCloseID, 1);
                bPlayingAnim = true;
            }
			
			if (bDoorsOpened)
			{
				FileChunk.Log("[DoorsObject.SGLoadChunk] Portal Opened\n");
				OpenPortals();
				DisableCallMethod("DelayedCloseDoors");
			}			
			else
			{
				FileChunk.Log("[DoorsObject.SGLoadChunk] Portal Closed\n");
				if (!bPlayingAnim)
					ClosePortals();
				else
				{
					// zamykamy portal z opoznieniem					
					OpenPortals();
					float fCloseAnimLen = GetAnimLength(nAnimCloseID);
					CallMethodIn("DelayedCloseDoors", fCloseAnimLen+100000.f);
				}
			}			
            
            // odtwarzamy stan otwarcia drzwi
            if(!bPlayingAnim)
            {
                if(bDoorsOpened)
                    SetFrame(nAnimOpenID, GetLastFrame(nAnimOpenID), -1);
                else
                    SetFrame(nAnimCloseID, GetLastFrame(nAnimCloseID), -1);
            }
        }
		
		cFC.delete();
	}
	
	boolean bLoading = false;
	
    /** Metoda zapisujaca dane do Save gracza
     */	
    public void SGSaveChunk(FileChunk cFCParent)
    {
		FileChunk.Log("[DoorsObject.SGSaveChunk]\n");
		
        FileChunk cFC = NewChunk(ESGChunksChrome._CHK_DOORS_OBJECT, cFCParent);
		
		super.SGSaveChunk(cFC);
				
		// Okresla czy drzwi sa zablokowane
		cFC.SaveBool(bLock);
		// Aktualny stan drzwi
		cFC.SaveBool(bDoorsOpened);
				
		// Czas w ktorym ostatnio drzwi sie zamknely lub otwarly
		cFC.SaveFloat(fSwitchTime);
		
		cFC.SaveBool(IsPlaying(nAnimOpenID));
		cFC.SaveBool(IsPlaying(nAnimCloseID));
							
		cFC.delete(); 
	}	
	
	public void SGUpdate()
	{
		FileChunk.Log("[DoorsObject.SGUpdate]\n");
		super.SGUpdate();
        
        String sName = GetName();
		bLoading = true;
		Init();
		bLoading = false;
        
	}
}
