public class TeleportIn extends MeshObject
{    
    /** Referencja do gracza */
    Player cPlayer = null;
    
    boolean bPlayerInside = false;
    boolean bPlayerInsidePrev = false;
    
    void ClearFlags()
    {
        bPlayerInside = false;
        bPlayerInsidePrev = false;
    }
    
    public void OnCreate()
    {
		bSG = true;
        CallMethodIn("Init", 0f);
    }

    Vector vMinExt = new Vector();
    Vector vMaxExt = new Vector();
    
    void Init()
    {
        // pobieramy gracza
        cPlayer = ((ChromeModuleSingle)GetModule()).MainPlayer;
        if (cPlayer == null)
			CrashLog("TeleportIn.Init: cPlayer == null\n");
        // pobieramy extenty gracza
        GetMeshExtents(vMinExt, vMaxExt);
        //GetMeshExtentsInWorld(vMinExt, vMaxExt);
        vMinExt.fX-=10.f; vMinExt.fY-=10.f; vMinExt.fZ-=30.f;
        vMaxExt.fX+=10.f; vMaxExt.fY+=10.f; vMaxExt.fZ+=30.f;
		
		SetFlag(EFlags._NOT_STATIC);
		
        //CrashLog("Tel <"+GetUniqueID()+"> vMinExt="+vMinExt+" vMaxExt="+vMaxExt+"\n");
    }
    
    boolean IsPlayerInside()
    {
        if (cPlayer == null)
		{
			//CrashLog("TeleportIn.IsPlayerInside: cPlayer == null\n");
			return false;
		}
        
        Vector vPlayerPos = PointWorldToLocal( cPlayer.GetPosition() );
        
        //CrashLog("Tel <"+GetUniqueID()+"> vPlayerPos="+vPlayerPos+" vMinExt="+vMinExt+" vMaxExt="+vMaxExt+"\n");
        
        return (vPlayerPos.fX > vMinExt.fX) &&
               (vPlayerPos.fX < vMaxExt.fX) &&
               (vPlayerPos.fZ > vMinExt.fZ) &&
               (vPlayerPos.fZ < vMaxExt.fZ) &&
               (vPlayerPos.fY > vMinExt.fY) &&
               (vPlayerPos.fY < vMaxExt.fY);
    }
    
    public void OnFrame()
    {
        bPlayerInsidePrev = bPlayerInside;
        bPlayerInside = IsPlayerInside();
    }
	
    //*********************************************************
	//					SaveGame
    //*********************************************************	
	
    /** Metoda wczytujaca zapisane dane w Save gracza
     */	
    public void SGLoadChunk(FileChunk cParentFC)
    {	
		FileChunk.Log("[TeleportIn.SGLoadChunk]\n");
		
		FileChunk cFC = GameObject.LoadChunk(cParentFC);   
		
        if (cFC.GetID() == ESGChunksChrome._CHK_TELEPORT_IN)
        {	
			super.SGLoadChunk(cFC);
			
			bPlayerInside = cFC.LoadBool();
			bPlayerInsidePrev = cFC.LoadBool();
        }
		
		cFC.delete();
    }
    
    /** Metoda zapisujaca dane do Save gracza
     */	
    public void SGSaveChunk(FileChunk cFCParent)
    {
		FileChunk.Log("[TeleportIn.SGSaveChunk]\n");
		
        FileChunk cFC = NewChunk(ESGChunksChrome._CHK_TELEPORT_IN, cFCParent);
		
		super.SGSaveChunk(cFC);		
		
		cFC.SaveBool(bPlayerInside);
		cFC.SaveBool(bPlayerInsidePrev);
			
        cFC.delete();
    }
	
	// nie wywala to musi by z bSG = true, bo inaczej inicjacja si nie zawoa !!!!
	public void SGUpdate()
	{
		FileChunk.Log("[TeleportIn.SGUpdate] \n");
		
		super.SGUpdate();
		
		Init();				
	}	
}
