/**Klasa wspomagajaca generowanie fontow na podstawie pliku fonts.scr*/
public class FontTest extends Sprite
{
    static boolean _ON = false;
    
    int nCurFont = -1;
    float fScaleStep = 0.01f;
    String sFontID = "";
    String sText = "abcdefghijklmnopqrstuvwxyz ABCDEFGHIJKLMNOPQRSTUVWXYZ 0123456789;'[].,/";
    public void OnCreate()
    {
        ProcessKb(true);
        SetName("FontTest");
        SetSize(new Vector(GetScreenWidth(), GetScreenHeight(), 0));
        Show();
        MoveTop();
        SetTextPosFlags(ESpriteText.CENTER);
        Fonts.Font font = (Fonts.Font)Fonts.m_vFonts.elementAt(0);
        sFontID = font.m_sFontID;
        SetFont(sFontID);
        
        SetTexture(AddTexture("er_t_black.png"), new Rect(0,0,1,1));
        
        ChromeFonts.m_vFonts.removeAllElements();
        ChromeFonts.LoadScript();
        ((Fonts)GetModule().fonts).m_cModule = null;
        ((Fonts)GetModule().fonts).Init(GetModule());
        CallMethodIn("FontUp", 0);
        //DisplayText("abcdef ABCDEF 12345");

    }
    
    void OnKeyReleased(int nKey, char nAsci)
    {
        switch(nKey)
        {
        case EKey._1:
            SetFontScale(0.8f);
            SetResolution(640,480);
            ApplyVideoSettings();
            SetSize(new Vector(GetScreenWidth(), GetScreenHeight(), 0));
            if (Tools.g_cInfoSprite != null)
                Tools.g_cInfoSprite.SetSize(new Vector(GetScreenWidth(), GetScreenHeight(), 0));
            break;
        case EKey._2:
            SetFontScale(1f);
            SetResolution(800,600);
            ApplyVideoSettings();
            SetSize(new Vector(GetScreenWidth(), GetScreenHeight(), 0));
            if (Tools.g_cInfoSprite != null)
                Tools.g_cInfoSprite.SetSize(new Vector(GetScreenWidth(), GetScreenHeight(), 0));
            break;
        case EKey._3:
            SetFontScale(1.28f);
            SetResolution(1024,768);
            ApplyVideoSettings();
            SetSize(new Vector(GetScreenWidth(), GetScreenHeight(), 0));
            if (Tools.g_cInfoSprite != null)
                Tools.g_cInfoSprite.SetSize(new Vector(GetScreenWidth(), GetScreenHeight(), 0));
            break;
        case EKey._LEFT:
            FontDn();
            SetFontScale(1f);
            break;
        case EKey._RIGHT:
            FontUp();
            SetFontScale(1f);
            break;
        case EKey._UP:
            ScaleUp();
            break;
        case EKey._DOWN:
            ScaleDn();
            break;
        case EKey._BACK:
            SetFontScale(1f);
            break;
        case EKey._END:
            SetSize(GetTextExtent(sText));
            SetTexture(AddTexture("er_t_red.png"), new Rect(0,0,1,1));
            break;
        case EKey._HOME:
            SetSize(new Vector(GetScreenWidth(), GetScreenHeight(), 0));
            SetTexture(AddTexture("er_t_black.png"), new Rect(0,0,1,1));
            break;
        }
        
        Info();
    }
    
    void Info()
    {
        CallMethodIn("ShowInfo", 0);
        DisplayText(sText);
    }
    
    void FontUp()
    {
        nCurFont ++;
        if (nCurFont >= Fonts.m_vFonts.size())
            nCurFont = 0;
        sFontID = ((Fonts.Font)Fonts.m_vFonts.elementAt(nCurFont)).m_sFontID;
        SetFont(sFontID);
        Info();
    }
    
    void FontDn()
    {
        nCurFont --;
        if (nCurFont < 0)
            nCurFont = Fonts.m_vFonts.size() - 1;
        sFontID = ((Fonts.Font)Fonts.m_vFonts.elementAt(nCurFont)).m_sFontID;
        SetFont(sFontID);
    }
    
    void ScaleUp()
    {
        SetFontScale(GetFontScale() + fScaleStep);
    }
    
    void ScaleDn()
    {
        SetFontScale(GetFontScale() - fScaleStep);
    }
    
    void ShowInfo()
    {
        Tools.ShowInfoTop((GetFontScale() + " * " + sFontID), GetModule());
    }
    
    
    
}
