/**Klasa, ktora jest stara lista, ale wyswietla na sobie obiekty wczytane ze skryptu przez
 * macierzysty UserInterface, pomost pom. starym a nowym hudem/menu*/
public class ListBoxWithUIWindows extends ListBox
{
    final static int ID_LISTBOX = 100000000;
    final static int ID_SCROLLBAR = 100000001;    
    static UIElement ScrollUpArrow = new UIElement(EUI.ID_SCROLL_UP, 0,
													   new Vector(0, 0, 0),
													   new Vector(0, 0, 0),        
													   "",
                                                       new Rect(),
													   "",
													   new Rect(),
													   "",
													   new Rect(),
													   "",
													   new Rect(),
													   EButtonFlags.BTN_TYPE_PRESSBUTTON,
													   "" );
	static UIElement ScrollDnArrow = new UIElement(EUI.ID_SCROLL_DN, 0,
													   new Vector(0, 0, 0),
													   new Vector(0, 0, 0),            
													   "",
                                                       new Rect(),
													   "",
													   new Rect(),
													   "",
													   new Rect(),
													   "",
													   new Rect(),
													   EButtonFlags.BTN_TYPE_PRESSBUTTON,
													   "");
    
    static UIElement ListBox = new UIElement(ID_LISTBOX, 0,
											   new Vector(0, 0, 0),
											   new Vector(0, 0, 0),
											   "",
											   new Rect(),
											   "",
											   new Rect(),
											   "",
											   new Rect(),
											   "",
											   new Rect(),
											   EButtonFlags.BTN_TYPE_LISTBOX,
											   "");
    
    UIWindow m_cListWindow = null;
    UIWindow m_cScroll = null;
    UIWindow m_cScrollUp = null;
    UIWindow m_cScrollDn = null;
    UIWindow m_cScrollThumb = null;
    
    float m_fScrollAreaY = -1;
    
    void Init(UIWindow cParent)
    {
        m_cListWindow = cParent.GetElem("ID_LIST");
        m_cScroll = cParent.GetElem("ID_SCROLL");
        m_cScrollUp = cParent.GetElem("ID_UP");
        m_cScrollDn = cParent.GetElem("ID_DOWN");
        m_cScrollThumb = cParent.GetElem("ID_THUMB");                                    
        m_cScrollThumb.SetVisible(false);
        
        super.Init(ListBox, GetModule());
        SetPos(m_cListWindow.GetPos());
        SetSize(m_cListWindow.GetSize());
        ProcessMouse(true);
        CreateScrollBar();
        UpdateList();
        Show();
        RegisterMouseAxisRequest();
    } 
    
    public void SetSize(Vector v)
    {
        super._SetSize(v);
		
        Vector arrowSize = m_cScrollUp.GetSize();
        
        btnUpArrow.SetPos(m_cScrollUp.GetPos());
        btnDnArrow.SetPos(m_cScrollDn.GetPos());
		if (btnScrollBar != null)
			btnScrollBar.SetPos(new Vector(m_cScrollThumb.GetPos().fX,
										   m_cScrollUp.GetPos().fY + arrowSize.fY,
										   0f));
        vClientSize = m_cListWindow.GetSize();
        SetCapacity(nCapacity);
    }
    
    void ChangeScrollBarPos()
    {
        if ( btnScrollBar != null && IsActuallyVisible())
		{
            if (nCapacity < nItemCount)
            {
			    Vector size = m_cScroll.GetSize();
			    Vector arrowSize = btnUpArrow.GetSize();
			    Vector vScrollSize = btnScrollBar.GetSize();
			    btnScrollBar.SetPos(new Vector(m_cScrollThumb.GetPos().fX, 
                                               m_cScrollUp.GetPos().fY + arrowSize.fY + ((nFirstVisible) * (m_fScrollAreaY/(nItemCount - nCapacity))),0.0f));   	
                m_cScrollThumb.SetPos(new Vector(btnScrollBar.GetPos()));
                if (bScrollVisible)
                {
                    btnScrollBar.Show();
                    m_cScrollThumb.SetVisible(true);
                }
            }
            else
            {
                btnScrollBar.Hide();
                m_cScrollThumb.SetVisible(false);
            }
		}
    }
    
    void SetCursor(Cursor cursor)
	{
		((ButtonScrollBar) btnScrollBar).SetCursor(cursor);
	}
    
    public void Show()
    {
        m_cScrollDn.Show();
        m_cScrollThumb.Show();
        m_cScrollUp.Show();
        ((UIButton)m_cScrollDn).SetFocus(false);
        ((UIButton)m_cScrollThumb).SetFocus(false);
        ((UIButton)m_cScrollUp).SetFocus(false);
        ChangeScrollBarPos();
        super.Show();
        
    }

    public void Hide()
    {
        m_cScrollDn.Hide();
        m_cScrollThumb.Hide();
        m_cScrollUp.Hide();
        super.Hide();
    }
    
    void CreateScrollBar()
	{
		btnUpArrow = (Button) this.CreateObject("Button");
        btnUpArrow.Init(ScrollUpArrow, module);
        AddChild(btnUpArrow);
        AddChildWnd(btnUpArrow, wndRoot);
        btnUpArrow.SetPos(m_cScrollUp.GetPos());
        btnUpArrow.SetSize(m_cScrollUp.GetSize());
        
        btnDnArrow = (Button) this.CreateObject("Button");
        btnDnArrow.Init(ScrollDnArrow, module);
        btnDnArrow.SetPos(m_cScrollDn.GetPos());
        btnDnArrow.SetSize(m_cScrollDn.GetSize());
        
        AddChild(btnDnArrow);
        AddChildWnd(btnDnArrow, wndRoot);
		
		btnScrollBar = (ButtonScrollBar) CreateObject("ButtonScrollBar");
		
		btnScrollBar.Init( new UIElement(ID_SCROLLBAR, 0,
										 new Vector(0, 0, 0),
										 m_cScrollThumb.GetSize(),
		                                 "",
                                         new Rect(0,0,1,1),
		                                 "",
                                         new Rect(),
		                                 "",
                                         new Rect(),
		                                 "",
                                         new Rect(),
										 EButtonFlags.BTN_TYPE_PUSHBUTTON,
										 ""),
						   module);
        
		AddChild(btnScrollBar);
        btnScrollBar.SetSize(m_cScrollThumb.GetSize());
        btnScrollBar.SetPos(m_cScrollThumb.GetPos());
        AddChildWnd(btnScrollBar, wndRoot);
        
        m_fScrollAreaY = m_cScrollDn.GetPos().fY - (m_cScrollUp.GetPos().fY + m_cScrollUp.GetSize().fY) - m_cScrollThumb.GetSize().fY; 
	}

    void OnInputMouseAxis(int nAxis, int nDelta)
    {
        if (!IsActuallyVisible())
            return;
        
        switch (nAxis)
        {
        case EMouse._AXIS_Z:
            {
                if (IsCursorInWindow())
                {
                    if (nDelta < 0)
                        OnScrollUp();
                    else
                        OnScrollDown();
                }
            }
            break;
            
        }
    }
    
    public void OnDestroy()
    {
        /*if (btnScrollBar != null)
        {
            RemoveSprite(btnScrollBar);
            btnScrollBar.delete();
            btnScrollBar = null;
        }
        
        if (btnUpArrow != null)
        {
            RemoveSprite(btnUpArrow);
            btnUpArrow.delete();
            btnUpArrow = null;
        }
        
        if (btnDnArrow != null)
        {
            RemoveSprite(btnDnArrow);
            btnDnArrow.delete();
            btnDnArrow = null;
        }*/
        super.OnDestroy();            
    }
    
}
