public class HUDBinoculars extends HUDComponent
{
    String m_TextureName = "data/textures/CH_lornetka.png";
    
	/** glowny sprite lornetki */
    Sprite m_ZoomerSprite = null;
    int m_iZoomerSpriteTex = 0;

	/** referencja na aktualna lornetke */
	Binoculars m_Binoculars = null;
	
	public void OnCreate()
    {
		super.OnCreate();
        
        if (m_bDisableInNetGame)
            return;
        // glowny sprite
		m_ZoomerSprite = (Sprite) CreateObject("Sprite");
		m_iZoomerSpriteTex = m_ZoomerSprite.AddTexture(m_TextureName);

        m_ZoomerSprite.SetTexture(m_iZoomerSpriteTex, new Rect(0,0,1,1));
		m_ZoomerSprite.ProcessMouse(false);

        m_ZoomerSprite.SetSize(new Vector(GetScreenWidth(), GetScreenHeight(), 0));
		m_ZoomerSprite.SetPos(new Vector());
		m_ZoomerSprite.MoveTop();

		AddSprite(m_ZoomerSprite);

        m_ZoomerSprite.SetBlendingMode(EBlendingModes.S_BLEND_MIX);
    }
    
    public void OnDestroy()
    {
        if (m_ZoomerSprite != null)
        {
            if (m_iZoomerSpriteTex != 0)
                m_ZoomerSprite.ReleaseTexture(m_iZoomerSpriteTex);

            RemoveSprite(m_ZoomerSprite);
            m_ZoomerSprite.delete();
            m_ZoomerSprite = null;
        }
        //CrashLog("[HUDBinoculars.OnDestroy]: Destroing DONE. \n");
    }
	
	public void Activate()
    {
		if (bActiveFlag)
			return;
		if (cHUDManager.m_bIsUserHUDActive)
			return;
		if (!cHUDManager.m_bActivateAllowed)
			return;

		PrepareView();
		
        super.Activate();
		
		cHUDManager.m_bIsUserHUDActive = true;

        Draw();
    }
	
	public void ActivateByHUD()
    {
		if (bActiveFlag)
			return;
		if (cHUDManager.m_bIsUserHUDActive)
			return;
		if (!cHUDManager.m_bActivateAllowed)
			return;

        super.Activate();
		
		cHUDManager.m_bIsUserHUDActive = true;

        Draw();
    }
	
    public void Deactivate()
    {
		if (!bActiveFlag)
			return;
		
        super.Deactivate();

		cHUDManager.m_bIsUserHUDActive = false;

		RestoreView();
		
		HideAll();
    }
	
	public void DeactivateByHUD()
	{
		if (!bActiveFlag)
			return;
		
        super.Deactivate();

		cHUDManager.m_bIsUserHUDActive = false;
		
		RestoreViewWORetrieveHUDComponents();
		
		HideAll();
	}

	public void PrepareView()
	{
        if ( m_Binoculars == null )
            return;
                
        PlayerHUD player = (PlayerHUD) m_Binoculars.Owner;
        
        if ( player.HUD != null )
		    player.HUD.HideAll();
		
	}
	
	public void RestoreView()
	{
		RestoreViewWORetrieveHUDComponents();
		
        if (m_Binoculars == null)
            return;
        if (m_Binoculars.Owner instanceof PlayerHUD)
        {
            PlayerHUD player = (PlayerHUD) m_Binoculars.Owner;
            if (player == null)
                return;
            if (player.bNetIsOwner)
                player.HUD.UnhideAll();
        }
	}
	
	public void RestoreViewWORetrieveHUDComponents()
	{
		if (m_Binoculars == null)
		{
			//CrashLog("ERROR !!! RestoreView() - m_Binoculars == null !!!");
			((ChromeModuleSingle)GetModule()).MainPlayer.RestoreViewAfterBinoculars();
			return;
		}
        if (m_Binoculars.Owner instanceof PlayerHUD)
        {
            PlayerHUD player = (PlayerHUD) m_Binoculars.Owner;
            if ( player != null )
                 player.RestoreViewAfterBinoculars();
        }
        if ( m_Binoculars != null )
        {
            m_Binoculars.UnregisterKeyRequest();
            m_Binoculars.SetState("Idle");
        }
	}

    public void DrawDo()
    {
        m_ZoomerSprite.Show();
    }
	
	public void HideAll()
	{
        if (m_ZoomerSprite != null)
            m_ZoomerSprite.Hide();
	}
	
        
	/*public void SetBinoculars(Binoculars binoculars)
	{
        
		
	}*/
    
    
    
    public void Draw() 
    {
         if ( !m_bDisableInNetGame )
         {
             DrawDo();
         }
    }	
}
