/**Hud wyswietla teksture glowy i tekst mowiony przez dana postac, standardowo jest to niunia, 
 * wystarczy zawolac Message(String sMessage, float fDelayTime), jesli ma to byc ktos inny, 
 * to najpierw trzeba go dodac (AddCharacter(String sTexName, char chCharacterInitial)), a 
 * potem zawolac Message(char chCharacterInitial, String sMessage, float fDelayTime) z odpowiednim
 * inicjalem.
 */
public class HUDCompNiunia extends HUDComponent
{
    // aktualnie gadajaca glowa
    TalkingHeadModule cTalkingHead = null;

    UIStatic cNiuniaTxtSpr = null;
    UIWindow cHeadWindow = null;
    UIWindow cBitmapHeadWindow = null;
    // lista gadajacych glow
    java.util.Vector aTalkingHeads = new java.util.Vector(1);
    
    int nHeadPosX = 0;
    int nHeadPosY = 0;
    int nHeadSizeX = 0;
    int nHeadSizeY = 0;
    
    /** Metoda pomocnicza zwraca numerek tekstury do wyswietlenia na spricie
     */
    public int GetTextureNumber(String sTexture)
    {
        int nTexture = cHeadWindow.AddTexture(sTexture);
        return nTexture;
    }
        
    public void OnInit()
    {
        super.OnInit();
        cNiuniaTxtSpr = (UIStatic)GetElem("ID_TEXT");
        cHeadWindow = GetElem("ID_HEAD");
        cHeadWindow.OnSizeAndPos();
        cBitmapHeadWindow = GetElem("ID_HEAD_TEX");
        cNiuniaTxtSpr.SetTextColor( vFontColor.fX, vFontColor.fY, vFontColor.fZ, 1.0f );
        cNiuniaTxtSpr.SetFontCharactersShiftV(-4);
    }
    
    public void UpdateHeadSizeAndPos()
    {
        nHeadPosX = (int)cHeadWindow.GetPos().fX;
        nHeadPosY = (int)cHeadWindow.GetPos().fY;
        nHeadSizeX = (int)cHeadWindow.GetSize().fX;
        nHeadSizeY = (int)cHeadWindow.GetSize().fY;
    }
    
    public void ReleaseCharacter(CharacterDescription cDesc)
    {
        if ( cDesc == null )
        {
            LogD(" cDesc == null\n");
        }
        if (cDesc.nTexture != 0)
            ReleaseTextureNumber( cDesc.nTexture );
        
        DeleteTalkingHead( cDesc.cTalkingHeadModule );
    }
    
    /** Zwolnienie tekstury pobranej przez GetTextureNumber
     */
    public void ReleaseTextureNumber(int nTexture)
    {
        cBitmapHeadWindow.ReleaseTexture(nTexture);
    }
    
	public void OnCreate()
	 {
		super.OnCreate();
        
        Load(GetModule(), "data\\Hud\\HUDCommunicator.scr", false);

        // a co z lista?
        cTalkingHead = null;
                
		PositionHUDComponent(0, 0);
	}
	
	public void OnDestroy()
	{
		super.OnDestroy();
		
        Remove();
        GetModule().RemoveSprite(this);            
                
        DeleteAllTalkingHeads();
        
        //CrashLog("[HUDCompNiunia.OnDestroy]: Destroing DONE. \n");
	 }

    public void MoveTop()
    {
        super.MoveTop();
        cNiuniaTxtSpr.MoveTop();
    }
    
    /** Postac sie wyswetla, mowi, i znika
     */
    public void Message(int nTexture, String sMessage, float fDelayTime)
    {
        if (GetModule() instanceof ChromeModuleSingle)
        {
            if(((ChromeModuleSingle)GetModule()).m_bMissionEnded)
                return;
        }
        
		if (!bActiveFlag)
	        Activate();

        cHeadWindow.Show();
        cBitmapHeadWindow.SetTexture(nTexture,new Rect(0, 0, 1, 1));
        cBitmapHeadWindow.Show();
        
        cNiuniaTxtSpr.DisplayText(sMessage);

        DisableCallMethod("HideNiunia");
        CallMethodIn("HideNiunia", fDelayTime);        
    }

    
    /** Postac sie wyswetla, z gadajaca glowa, odpala wavea i tekst, pozniej znika
     */
    public void Message(String sWave,String sMessage, float fDelayTime, TalkingHeadModule cTalkingModule, int nPlayingWave)
    {
        if (GetModule() instanceof ChromeModuleSingle)
        {
            if(((ChromeModuleSingle)GetModule()).m_bMissionEnded)
                return;
        }
        
		if (!bActiveFlag)
	        Activate();

		cBitmapHeadWindow.SetNoTexture();
        cNiuniaTxtSpr.DisplayText(sMessage);

        ActivateTalkingHead( cTalkingModule, sWave, nPlayingWave );

        DisableCallMethod("HideNiunia");
        CallMethodIn("HideNiunia", fDelayTime);        
    }

     // metoda chowajaca HUDNinia
     void HideNiunia()
     {
		 Deactivate();
     }
     
    /** metoda aktywujaca HUD'a
	 */
	 public void Activate()
	 {
		if (bActiveFlag)
			return;
		
        super.Activate();
	 }

	
	 /** metoda deaktywujaca  HUD'a
	  */
	 public void Deactivate()
	 {
		 if (!bActiveFlag)
			return;
		 
         super.Deactivate();
		 
		 HideAll();
	 }
	 
	 public void HideAll()
	 {
         Hide();
         DeactivateTalkingHeads();
	 }
	      
    
    /** Stworzenie odpowiedniego modulu z gadajaca glowa i dodanie na liscie
     */
    TalkingHeadModule CreateTalkingHead( String sClassName )
    {
        if (aTalkingHeads == null)
        {
            LogD("ERROR aTalkingHeads == null\n");
            return null;
        }
        
        if ( sClassName == null )
        {
            //Character nie ma zdefiniowanej klasy modulu z gadajaca glowa
            LogD("ERROR: sTalkingHeadModuleClassName == null\n");
            return null;
        }
        
        // stworzmy obiekt modulu z gadajaca glowa
        TalkingHeadModule cHead = (TalkingHeadModule)CreateObjectNoInit( sClassName );
        UpdateHeadSizeAndPos();
        // powiedzmy mu jakiego charaktera dotyczy i jakie ma miec wymiary
        cHead.SetParams( this, nHeadPosX, nHeadPosY, nHeadSizeX, nHeadSizeY);
        cHead.InitObject();            
            
        // dodajmy modul z glowa na liscie
        aTalkingHeads.addElement( cHead );
        return cHead;
    }

    /** Stworzenie odpowiedniego modulu z gadajaca glowa i dodanie na liscie
     */
    TalkingHeadModule CreateTalkingHead(DialogCharacter cCharacter)
    {
        if (aTalkingHeads == null)
            return null;
        
        // stworzmy obiekt modulu z gadajaca glowa
        TalkingHeadModule cHead = (TalkingHeadModule)CreateObjectNoInit( "TalkingHeadModule" );
        
        UpdateHeadSizeAndPos();
        // powiedzmy mu jakiego charaktera dotyczy i jakie ma miec wymiary
        cHead.SetParams( this, nHeadPosX, nHeadPosY, nHeadSizeX, nHeadSizeY);
        
        // przepisujemy parametry
        cHead.m_sTHMeshName = cCharacter.sTHMeshName;
        cHead.m_sTHHeadAnimName = cCharacter.sTHHeadAnimName;
        cHead.m_sTHSkin = cCharacter.sTHSkin;
        
        cHead.m_sBackMeshName = cCharacter.sBackMeshName;
        cHead.m_vBackPos = cCharacter.vBackPos;
        
        cHead.m_fCameraFOV = cCharacter.fCameraFOV;
        cHead.m_vCamPos = cCharacter.vCamPos;
        cHead.m_vCamLookAt = cCharacter.vCamLookAt;
        cHead.m_vLightPos  = cCharacter.vLightPos;
        
        // inicjalizujemy
        cHead.InitObject();            
            
        // dodajmy modul z glowa na liscie
        aTalkingHeads.addElement( cHead );
        return cHead;
    }
    
    /** Metoda aktywujaca w hudzie modul z gadajaca glowa
     * oraz odpalajaca wave'a
     */
    void ActivateTalkingHead( TalkingHeadModule cNewModule, String sWave, int nPlayingWave )
    {
        // najpierw zdeaktywujmy innych "gadaczy"
        // UWAGA jesli bedzie wymagane aby klika glow gadalo na raz, to trzeba bedzie
        // zrezygnowac z tej deaktywacji
        DeactivateTalkingHeads();
        
        // sprawdzmy ktora glowe mamy uaktywnic
        cTalkingHead = cNewModule;
        
        if (cTalkingHead != null)
        {
            // no to go!
            cTalkingHead.ActivateAndSpeak( sWave, nPlayingWave );
        }
        else
        {
            LogD("ERROR: Talking head for wave '"+sWave+"' not found\n");
        }
    }

    void ActivateTalkingHead( TalkingHead cHead, String sWave )
    {
    }
    
    /** Deaktywacja wszystkich modulow z gadajacymi glowami
     */
    void DeactivateTalkingHeads()
    {
        if ( cTalkingHead != null )
        {
            cTalkingHead.Deactivate();
            cTalkingHead = null;
        }
        
        if (aTalkingHeads == null)
        {
            LogD("ERROR aTalkingHeads == null\n");
            return;
        }
        
        for (int i=0; i<aTalkingHeads.size(); ++i)
        {
            TalkingHeadModule cMod = (TalkingHeadModule)aTalkingHeads.elementAt(i);
            if ( cMod != null )
                cMod.Deactivate();
        }
    }
        
    /** Odnalezienie na liscie odpowiedniego modulu z gadajaca glowa
     */
    TalkingHeadModule GetTalkingHead(int i)
    {
        if (aTalkingHeads == null)
        {
            LogD("ERROR aTalkingHeads == null\n");
            return null;
        }
        

        if (i < 0 || i >=aTalkingHeads.size())
        {
            LogD("ERROR i "+i+" out of rande (0.."+aTalkingHeads.size()+"\n");
            return null;
        }

        return (TalkingHeadModule)aTalkingHeads.elementAt(i);
    }
    
    /** Usuniecie odpowiedniego modulu z gadajaca glowa z listy
     */
    void RemoveTalkingHead(TalkingHeadModule cHeadToRemove)
    {
        if( cHeadToRemove != null && (aTalkingHeads != null))
        {
            aTalkingHeads.remove( cHeadToRemove );
        }
    }
    
    /** Usuniecie odpowiedniego modulu z gadajaca glowa z listy
     */
    TalkingHeadModule RemoveTalkingHead(int i)
    {
        TalkingHeadModule cHeadToRemove = GetTalkingHead(i);
        if ( (cHeadToRemove != null) && (aTalkingHeads != null))
        {
            aTalkingHeads.remove( cHeadToRemove );
            return cHeadToRemove;
        }
        

        return null;
    }
    
    /** Skasowanie wskazego modulu
     * (usuniecie z listy i skasowanie obiektu)
     */
    void DeleteTalkingHead(TalkingHeadModule cHeadToDelete)
    {
        if (cHeadToDelete == null)
            return;   

        RemoveTalkingHead(cHeadToDelete);
        
        if (cTalkingHead == cHeadToDelete)
        {
            cTalkingHead = null;
        }
        
        cHeadToDelete.Deactivate();
        cHeadToDelete.delete();
        cHeadToDelete = null;
    }
    
    
    /** Skasowanie wszystkich modulow 
     * (usuniecie z listy i skasowanie obiektu)
     */
    void DeleteAllTalkingHeads()
    {
        if (aTalkingHeads == null)
        {
            LogD("ERROR aTalkingHeads == null\n");
            return;
        }
        
        while (aTalkingHeads.size() > 0)
        {
            TalkingHeadModule cHeadToDelete = RemoveTalkingHead( 0 );
        
            DeleteTalkingHead(cHeadToDelete);
        }
    }

    
    /** HACK na to zeby przy wybuchu granatu flash takze przykryl
     *  gadajaca niunia
     */
    void PropagatedFlash(int nId, float fDuration,float fValue, float fMaxValue)
    {
        for (int i=0; i<aTalkingHeads.size(); ++i)
        {
            TalkingHeadModule cMod = (TalkingHeadModule)aTalkingHeads.elementAt(i);
            if ( cMod != null )
            {
                CameraExtended camera = cMod.GetCamera();
                if ( camera != null )
                     camera.PropagatedFlash( nId, fDuration, fValue, fMaxValue );
            }
        }
    }
    
    /** Kolejne brzydkie haki na pojawiajaca sie niunie...
     * No wiec Niunia powinna renderowac sie na samym koncu
     * ale tylko wtedy gdy aktywne jest ChromeModuleSingle,
     * w przeciwnym przypadku (np jak jest w menu) to gadajaca 
     * glowa powinna byc schowana
     */
    boolean m_bActiveModuleSingle = false;
    void SetActiveModuleSingle( boolean bActive )
    {
        if ( m_bActiveModuleSingle == bActive )
            return;
        
        for (int i=0; i<aTalkingHeads.size(); ++i)
        {
            TalkingHeadModule cMod = (TalkingHeadModule)aTalkingHeads.elementAt(i);
            if ( cMod != null )
            {
                cMod.SetRenderAfterSprites( bActive );
            }
        }
        
        m_bActiveModuleSingle = bActive;
    }
    
    boolean GetActiveModuleSingle()
    {
        return m_bActiveModuleSingle;
    }

	//*********************************************************
	//					SaveGame
    //*********************************************************
	
	boolean m_bActiveModuleSingleSG = false;
	TalkingHeadModule cTalkingHeadSG = null;
    
    /** Metoda wczytujaca zapisane dane w Save gracza
     */	
    public void SGLoadChunk(FileChunk cParentFC)
    {	
		FileChunk.Log("[HUDCompNiunia.SGLoadChunk]\n");
		
		FileChunk cFC = GameObject.LoadChunk(cParentFC);   
		
        if (cFC.GetID() == ESGChunksChrome._CHK_HUD_COMP_NIUNIA)
        {
			super.SGLoadChunk(cFC);
			
			if (cFC.LoadInt() != aTalkingHeads.size())
			{
				CrashLog("[HUDCompNiunia.SGLoadChunk] Error! Number of talking heads is diffrent than saved !\n");
				HideAll();
				DeactivateTalkingHeads();
				cFC.delete();
				return;
			}
				
			for (int i=0; i<aTalkingHeads.size(); ++i)
			{
			    TalkingHeadModule cMod = (TalkingHeadModule)aTalkingHeads.elementAt(i);
				
				boolean b = cFC.LoadBool();
				
				if (((cMod == null) && b) || (!b && (cMod != null)))
				{
					CrashLog("[HUDCompNiunia.SGLoadChunk] Error! Number of talking heads is diffrent than saved !\n");
					HideAll();
					DeactivateTalkingHeads();
					cFC.delete();
					return;						
				}
				
			    if ( b )
				{
			        cMod.SGLoadChunk(cFC);
				}
			}					
						
			if ( cTalkingHead != null )
			{
			    cTalkingHead.Deactivate();
			    cTalkingHead = null;
			}
			
			int nTalkingHead = cFC.LoadInt();

			if (nTalkingHead != -1)
				cTalkingHeadSG = (TalkingHeadModule)aTalkingHeads.elementAt(nTalkingHead);			
						
			m_bActiveModuleSingleSG = cFC.LoadBool();
        }
		
		cFC.delete();
	}
    
    /** Metoda zapisujaca dane do Save gracza
     */	
    public void SGSaveChunk(FileChunk cFCParent)
    {
		FileChunk.Log("[HUDCompNiunia.SGSaveChunk]\n");
		
        FileChunk cFC = NewChunk(ESGChunksChrome._CHK_HUD_COMP_NIUNIA, cFCParent);
		
		super.SGSaveChunk(cFC);
		
		cFC.SaveInt(aTalkingHeads.size());
		
		int nTalkingHead = -1;
			
        for (int i=0; i<aTalkingHeads.size(); ++i)
        {
            TalkingHeadModule cMod = (TalkingHeadModule)aTalkingHeads.elementAt(i);
			cFC.SaveBool(cMod != null);				
            if ( cMod != null )
                cMod.SGSaveChunk(cFC);
			
			if (cTalkingHead == cMod)
				nTalkingHead = i;
        }	
		
		cFC.SaveInt(nTalkingHead);
		
		cFC.SaveBool(m_bActiveModuleSingle);
									        
		cFC.delete(); 
	}				
	
	public void SGUpdate()
	{
		FileChunk.Log("[HUDCompNiunia.SGUpdate]\n");
		
		super.SGUpdate();				
	}	    	    	
}
