/** klasa reprezentujaca konsole do wypisywania komunikatow
 */
public class HUDConsole extends HUDComponent
{
	/////////////////////////////
	// atrybuty
	/////////////////////////////
	//sciezka do i nazwa tekstury tla konsoli
	String sTextureName = "Data/Textures/console.png";
 	
	//sprit - tlo konsoli
	//Sprite cHUDConsole = null;
	//int nHUDConsoleTex = 0;
	
	// ilosc pol tekstowych w konsoli
	int nArraySize = 5;
	
	// tablica przechowujaca teksty
	String aTexts[] = null;
	
	// aktualna pozycja w tablicy tekstow
	int nActualPos = 0;
	
	// rozmiary sprite'a z tekstem
	int nSprSizeX = 120;
	int nSprSizeY = 20;
	
	// tablica z spritami-tekstami
	Sprite aSprites[] = null;
	
	// odstep miedzy kolejnymi wierszami tekstow
	int nYSpace = 2;
	// pozycja startowa Y wyswietlania tekstw
	int nStartPos = 5;
    
    //czas po jakim znika napisany tekst
    int nHideTxtTime = 6;
	
	
	/////////////////////////////
	// metody
	/////////////////////////////
//--------------------------------------------------------------------
	public void OnCreate()
	{
        Log("[HUDConsole.OnCreate]: Creating HUDConsole \n");
        
		super.OnCreate();
		//pozycja na ekranie 

		nHUDCompPosX = GetScreenWidth() - nSprSizeX - 15;
		nHUDCompPosY = 64+nSprSizeY/2;
	
		// rozmiary w pixelach
	 	nHUDCompWidth = 512;
		nHUDCompHeight = 128;
		
		aTexts = new String[nArraySize];
		
			
		//teraz aduje do tablicy sprite'y wszystkich tekstw
		
		aSprites = new Sprite[nArraySize];
		for (int i=0; i<nArraySize; i++)
		{
			aSprites[i] = (Sprite)CreateObject("Sprite");
			aSprites[i].SetNoTexture();
			aSprites[i].ProcessMouse(false);
            aSprites[i].SetTextColor( vFontColor.fX, vFontColor.fY, vFontColor.fZ, 1.0f );
            //aSprites[i].SetTextColor( 0, 1.0f, 0.89f, 1.0f );
			
			aSprites[i].SetSize(new Vector(nSprSizeX, nSprSizeY,0));
			aSprites[i].SetPos(new Vector(nHUDCompPosX+5, nHUDCompPosY+nStartPos+i*nSprSizeY, 0));
			
					
			aSprites[i].MoveTop();
			AddSprite(aSprites[i]);
			
		}
		
		//teraz tymczasowo zapelniam tablice tekstow
		for (int j=0; j<nArraySize; j++)
		{
			
			aTexts[j] = "yo !";
		}
			
		
		ActivateOnModule();
		Log("[HUDConsole.OnCreate]: Creating HUDConsole DONE. \n");
	}
	
//--------------------------------------------------------------------
	public void OnDestroy()
	{
        super.OnDestroy();	
		
		aTexts = null;
		
			
		//kasujemy sprite'y tekstw
		for (int i = 0; i < nArraySize; i++)
		{
			RemoveSprite(aSprites[i]);				
			aSprites[i].delete();
			aSprites[i] = null;
		}	
		aSprites = null;
        
        //CrashLog("[HUDConsole.OnDestroy]: Destroing DONE. \n");
	}
//--------------------------------------------------------------------
	/** metoda aktywujaca konsole
	 */
	 public void Activate()
	 {
		super.Activate();
		Draw();
	 }
//--------------------------------------------------------------------
	 /** metoda deaktywujaca konsole
	  */
	 public void Deactivate()
	 {
		super.Deactivate();
		
		for (int i=0; i<nArraySize; i++ )
			aSprites[i].Hide();
	 }
//--------------------------------------------------------------------
	 /** metoda wyswietlajaca konsolez tekstami
	  */
	 public void DrawDo() 
	 {
		
		SetTexts();
		for (int i=0; i<nActualPos; i++)
			aSprites[i].Show();
		
	 }

//--------------------------------------------------------------------
	/** metoda ustawia wartosci napisow sprite'ow na podstawie tablicy
	 */
	 public void SetTexts()
	 {
		
		for (int i=0; i<this.nArraySize; i++)
		{
            aSprites[i].SetFont(ChromeFonts.FONT_HUD_BIGGER);
            aSprites[i].SetTextPosFlags(ESpriteText.HORIZ_RIGHT);
			aSprites[i].DisplayText(aTexts[i]);	 
		}
		 
	 }
//--------------------------------------------------------------------
	 /** metoda dodajaca tekst do konsoli
	  */
	 public void AddText(String txt)
	 {
		if (bActiveFlag)
		{
			if (nActualPos<nArraySize)	 
			{
				aTexts[nActualPos] = new String(txt);
				nActualPos++;
			
			} else //przepisuje teksty o jeden do gory
			{
				String temp[] = new String[nArraySize];
				for (int i=0; i<nArraySize-1; i++)
				{
					temp[i] = aTexts[i+1];	
				}
				temp[nArraySize-1] = new String(txt);
				aTexts = null;
				aTexts = new String[nArraySize];
				
				for (int i=0; i<nArraySize; i++)
				{
					aTexts[i] = temp[i];	
				}
				temp = null;
				
				
			}//else
			
		Draw();	
			
		}//active]
        
        CallMethodIn("HideFirstRow", nHideTxtTime);
		 
	 
	 }
//--------------------------------------------------------------------
     /** metoda kasuje pierwsza od gory linijke tekstu
      */
     void HideFirstRow()
     {
       int i=0;
       
       for (i=0; i<nActualPos-1; i++)  
       {
        aTexts[i]=aTexts[i+1];   
       }
       aTexts[i]="";
       if (nActualPos > 0) nActualPos--;
       
       Draw();
     
     }
	
     public void MoveTop()
     {
         super.MoveTop();
         for (int i = 0; i < aSprites.length; i++)
         {
             aSprites[i].MoveTop();
         }         
     }
     
     public void Clear()
     {
         for (int i = 0; i < nArraySize; i++)
         {
             aTexts[i] = "";	
         }
         Draw();
         LogR("Clearing console");
         nActualPos = 0;
     }
     
     public void SGUpdate()
     {
         super.SGUpdate();
         Clear();
     }
	
}
