public class HUDHack extends HUDComponent
{
    java.util.Vector m_vButtons = new java.util.Vector();
    
    float   m_fButtonBlinkTime = 0.5f,
            m_fButtonBlinks = 2f;

    String m_sCallbackFunc = null;
    GameObject m_cCallbackObj = null;
    
    java.util.Vector m_vChecked = new java.util.Vector();
    
    float m_fCheckTime = 0.33f;
    
    boolean m_bChecking = false;
    
    /**Ile elementow ma miec sekwencja*/
    int m_nCombo = 0;

    /**Ile jeszcze do odgadniecia*/
    int m_nToFind = 0;
    
    /**ile dostepnych ruchow*/
    int m_nMoves = 0;
    
    String m_sCode = "";
    
    UIStatic    m_cCodeText = null,
                m_cSecurity = null,
                m_cCombo = null,
                m_cTitle = null,
                m_cMoves = null;
    
    UIWindow m_cFrameHack = null;
        
    MenuScreen_ m_cComputerMenuScreen = null;
    
    final static String m_sCodes[] = new String[]{
                                        "a",
                                        "b",
                                        "c",
                                        "d",
                                        "e",
                                        "f",
                                        "g",
                                        "h",
                                        "i",
                                        "j",
                                        "k",
                                        "l",
                                        "m",
                                        "o",
                                        "p",
                                        "r",
                                        "s",
                                        "t",
                                        "u",
                                        "v",
                                        "w",
                                        "x",
                                        };
    
    public void OnCreate()
    {
        super.OnCreate();   
        
        Load(GetModule(), "data/hud/HUDHack.scr", false);
		
		ProcessMouse(false);
    }
    
    public void OnInit()
    {
        UIWindow cWndA = null, cWndB = null;
        super.OnInit();
        
        m_cCodeText = (UIStatic)GetElem("ID_CODE_TEXT");
        m_cSecurity = (UIStatic)GetElem("ID_SECURITY");
        m_cCombo = (UIStatic)GetElem("ID_COMBO");
        m_cMoves = (UIStatic)GetElem("ID_MOVES");
        
        m_cFrameHack = GetElem("ID_FRAME_HACK");
        m_cComputerMenuScreen = (MenuScreen_)GetElem("ID_FRAME_COMPUTER");
        m_cTitle = (UIStatic)m_cComputerMenuScreen.GetElem("ID_TITLE");
        int nIdx = 0;
        while (true)
        {
            cWndA = GetElem("ID_BTN_A_" + nIdx);
            if (cWndA != null)
            {
                m_vButtons.addElement(cWndA);
                cWndB = GetElem("ID_BTN_B_" + nIdx);
                m_vButtons.addElement(cWndB);
                ((UIButton)cWndA).SetText("");
                ((UIButton)cWndB).SetText("");
            }
            else
                break;
            
            nIdx ++;
        }
    }
	
    void SetTitle(String sTitle)
    {
        m_cTitle.SetText(sTitle);
    }
    
    void MenuState(GameObject cCallbackObj)
    {
        m_cCallbackObj = cCallbackObj;
        m_cComputerMenuScreen.Show();
        m_cFrameHack.Hide();
        DeactivateHackImplant();
    }
        
    void HackState(String sCallbackFunc, GameObject cCallbackObj)
    {
        m_sCallbackFunc = new String(sCallbackFunc);
        m_cCallbackObj = cCallbackObj;
        m_cFrameHack.Show();
        m_cComputerMenuScreen.Hide();
        ActivateHackImplant();
    }
    
    void ActivateHackImplant()
    {
        if (cPlayer != null && cPlayer.GetImplantSystem() != null)
        {
            cPlayer.GetImplantSystem().GetImplant(ImplantSystem._IMPLANT_HACK).Activate();
            cHUDManager.RefreshImplantsIndicators();            
        }
    }
    
    void DeactivateHackImplant()
    {
        if (cPlayer != null && cPlayer.GetImplantSystem() != null)
        {
            cPlayer.GetImplantSystem().GetImplant(ImplantSystem._IMPLANT_HACK).Deactivate();
            cHUDManager.RefreshImplantsIndicators();
        }
    }
    
    void RiddleSolved()
    {
        PlaySound("data/sounds/player/hack_success.wav");
        if (m_sCallbackFunc != null && m_sCallbackFunc.length() > 0 && m_cCallbackObj != null)
            m_cCallbackObj.CallMethodIn(m_sCallbackFunc, 0);
    }
    
    void OnLogOff()
    {
        if (m_cCallbackObj != null)
            m_cCallbackObj.CallMethodIn("Logout", 0);
    }
    
    void ForceLogOff()
    {
        CallOnFrameEnd("OnLogOff");
    }
    
    MenuScreen_ GetMenuScreen()
    {
        return m_cComputerMenuScreen;
    }
    
    void InitRiddle(int nMoves, int nSecurity, int nCombo)
    {
        m_sCode = "";
        m_cCodeText.SetText(m_sCode);
        m_nCombo = nCombo;
        m_nToFind = nSecurity;
        m_cSecurity.SetText(String.valueOf(m_nToFind));
        m_cCombo.SetText(String.valueOf(m_nCombo));
        if (nSecurity * nCombo % 2 == 1)
            Tools.CrashLogError(" HUDHack.InitRiddle liczba przyciskow musi byc parzysta (nSecurity * nCombo)");
        if (nSecurity * nCombo > m_vButtons.size())
            Tools.CrashLogError(" HUDHack.InitRiddle za malo przyciskow dla zagadki!!!");
        
        if (nMoves < nSecurity)
        {
            Tools.CrashLogWarning(" HUDHack.InitRiddle za malo ruchow dla zagadki!!!");
            nMoves = nSecurity;
        }
        m_nMoves = nMoves;
        m_cMoves.SetText(String.valueOf(m_nMoves));
        java.util.Vector vCodes = new java.util.Vector();
        java.util.Vector vButtonsToCode = new java.util.Vector();
        
        for (int i = 0; i < m_sCodes.length; i++)
            vCodes.addElement(new String(m_sCodes[i]));

        UIWindow cWnd = null;
        
        for (int i = 0; i < nSecurity * nCombo; i++)
        {
            vButtonsToCode.addElement(m_vButtons.elementAt(i));
        }
        
        for (int i = 0; i < nSecurity; i++)
        {
            int nCode = RandomInt(vCodes.size());
            String sCode = (String)vCodes.elementAt(nCode);
            vCodes.removeElementAt(nCode);
            for (int j = 0; j < nCombo; j++)
            {
                int nBtn = RandomInt(vButtonsToCode.size());
                cWnd = (UIWindow)vButtonsToCode.elementAt(nBtn);
                vButtonsToCode.removeElementAt(nBtn);
                cWnd.SetData((Object)(new String(sCode)));
                cWnd.SetVisible(true);
                ((UIButtonHack)cWnd).StartBlink(RandomFloat(m_fButtonBlinkTime), m_fButtonBlinkTime/(float)(2 * (RandomInt(3)+1)), true);
                ClearButton((UIButton)cWnd);
            }
        }
        for (int i = nSecurity * nCombo; i < m_vButtons.size(); i++)
        {
            ((UIWindow)m_vButtons.elementAt(i)).SetVisible(false);
            ClearButton((UIButton)m_vButtons.elementAt(i));
        }
    }
    
    void ClearButton(UIButton cBtn)
    {
        cBtn.SetText("");
        cBtn.SetFocus(false);
        cBtn.SetCheck(false);
    }
    
    /*int nKeys = 0;
    void OnKeyPressed(int nKey, char nAsci)
	{
        switch(nKey)
        {
        case EKey._UP:
            nKeys ++;
            if (nKeys > m_vButtons.size())
                nKeys = 0;
            break;
        case EKey._DOWN:
            nKeys--;
            if (nKeys < 0)
                nKeys = m_vButtons.size() - 1;
            break;
        }
        for (int i = 0; i < m_vButtonsA.size(); i++)
        {
            if (i < nKeys)
            {
                ((UIWindow)m_vButtonsA.elementAt(i)).SetVisible(true);
                ((UIWindow)m_vButtonsB.elementAt(i)).SetVisible(true);
            }
            else
            {
                ((UIWindow)m_vButtonsA.elementAt(i)).SetVisible(false);
                ((UIWindow)m_vButtonsB.elementAt(i)).SetVisible(false);
            }
        }
    }*/
    
    
    
    void OnUICommand(UIWindow cSender, int nCommand)
	{
		super.OnUICommand(cSender,nCommand);
        /*int nId = TranslateSIdToId(cSender.m_sId);
        if (nId == -1)
            return;
          */              
		
		if(nCommand == EUIConst.CM_CLICK || nCommand == EUIConst.CM_DBCLICK)
        {
            if (cSender.m_sId.compareTo("ID_BUTTON_LOGOFF") == 0)
                CallMethodIn("OnLogOff", 0);
            
            if (cSender.m_sId.startsWith("ID_BTN_"))
            {
                UIButton cBtn = (UIButton)cSender;
                //jestesmy w trakcie sprawdzania (metoda sie jeszcze nie zawolala na call...)
                if (m_bChecking)
                {
                    DisableCallMethod("CheckMatch");                 
                    CheckMatch();
                }
                
                
                //czy jest juz na liscie
                if (IsChecked(cBtn))
                {
                    //wcisnelismy drugi raz ten sam
                    cBtn.SetCheck(true);
                    return;
                }
                
                if (cBtn.GetCheck())
                {
                    ((UIButton)cSender).SetText((String)cSender.GetData());
                    m_vChecked.addElement(cBtn);
                } 
                
                if (GetCheckedCount() > 1)
                {
                    CallMethodIn("CheckMatch", m_fCheckTime);
                    m_bChecking = true;
                }
                
            }
        }
	}
    
    UIButton GetChecked(int i)
    {
        return ((UIButton)m_vChecked.elementAt(i));
    }
    
    int GetCheckedCount()
    {
        return m_vChecked.size();
    }
    
    boolean IsChecked(UIButton cBtn)
    {
        return (m_vChecked.indexOf(cBtn) != -1);
    }
    
    void ClearCheckedButtons()
    {
        for (int i = 0; i < m_vChecked.size(); i++)
            ClearButton(((UIButton)m_vChecked.elementAt(i)));
        m_vChecked.removeAllElements();
    }
    
    void CheckMatch()
    {
        m_bChecking = false;
        if (m_vChecked.size() <= 1)
            return;
        String sCode = null;
        for (int i = 0; i < m_vChecked.size() - 1; i++)
        {
            UIButton cCur = (UIButton)m_vChecked.elementAt(i);
            UIButton cNext = (UIButton)m_vChecked.elementAt(i + 1);
            String sCodeCur = (String)cCur.GetData();
            String sCodeNext = (String)cNext.GetData();
            
            if (sCode == null)
                sCode = new String(sCodeCur);
            
            if (!sCodeCur.equals(sCodeNext))
            {
                //kody na dwoch kolejnych zaznaczonych sie roznia, zjebanana, clearujemy
                OnCheckIsWrong();
                return;
            }
        }
        //nie bylo skuchy, element zaliczony
        if (m_vChecked.size() == m_nCombo)
            OnCheckIsOK(sCode);
        
    }
    
    void OnCheckIsOK(String sCode)
    {
        for (int i = 0; i < m_vChecked.size(); i++)
        {
            //ukrywamy odgadnieta sekwencje
            ((UIButtonHack)m_vChecked.elementAt(i)).StartBlink(m_fButtonBlinkTime, m_fButtonBlinkTime/(2f * m_fButtonBlinks), false);            
        }
        m_nToFind --;
        m_cSecurity.SetText(String.valueOf(m_nToFind));
        if (m_nToFind == 0)
            CallMethodIn("RiddleSolved", m_fButtonBlinkTime);
        ClearCheckedButtons();
        m_sCode += sCode + "\n";
        m_cCodeText.SetText(m_sCode);
        
        m_nMoves --;
        m_cMoves.SetText(String.valueOf(m_nMoves));
        if (m_nMoves == 0 && m_nToFind > 0)
            OnNoMoreMoves();
    }
    
    void OnCheckIsWrong()
    {
        ClearCheckedButtons();
        m_nMoves --;
        m_cMoves.SetText(String.valueOf(m_nMoves));
        if (m_nMoves == 0)
            OnNoMoreMoves();
    }
    
    void OnNoMoreMoves()
    {
        PlaySound(ComputerTerminalNew.sWrongPassword);
        if (m_cCallbackObj != null)
            m_cCallbackObj.CallMethodIn("ReinitRiddle", 0);
    }
    
    void Match(String s)
    {
        return;
    }
    
    
    void Overload()
    {
        //TODO overloadowac gracza i robic overload po overloadzie
        if (m_cCallbackObj != null)
        {
            m_cCallbackObj.CallMethodIn("Overload", 0);
        }
    }
    
    public void OnDestroy()
    {
		super.OnDestroy();
        
	
        //Log("[HUDHack.OnDestroy]: Destroing DONE. \n");
    }
      
    public void Activate()
    {
		if (bActiveFlag)
			return;
		if (!cHUDManager.CanActivate(HUDManager._HUD_HACK))
			return;
		
        super.Activate();   
		
        ProcessMouse(true);

		Draw();
		
        cHUDManager.HudMenuActivated(HUDManager._HUD_HACK);
        
        CallMethodIn("CheckPlayerMovement", 0.5f);
    }
	
    public void CheckPlayerMovement()
    {
        if (cPlayer != null)
        {
            if (cPlayer.motion.IsMoving())
                ForceLogOff();
        }
    }
    
	public void ActivateSlow()
	{
		Activate();
	}

	public void ComponentMoved()
	{
		if (!bActiveFlag)
		{
			cHUDManager.m_bIsUserHUDActive = false;
			HideAll();
		}
	}
	
	public void HideAll()
	{
        Hide();
	}
	
    public void Deactivate()
    {
		if (!bActiveFlag)
			return;
		
        super.Deactivate();   
        DeactivateHackImplant();
		HideAll();
		
        ProcessMouse(false);
        
        cHUDManager.HudMenuDeactivated(HUDManager._HUD_HACK);
    }
	
	public void DeactivateSlow()
	{
		Deactivate();
	}
    
    
    public void DrawDo()
    {
	    if (bActiveFlag)
        {
            Show();
        }
    }
    
    public void SetCursorPos(Vector vPos)
    {
        if (m_currCursor != null)
            m_currCursor.SetPos(vPos);
    }
    
    Vector GetCursorPos()
    {
        if (m_currCursor != null)
            return m_currCursor.GetPos();
        else
            return null;
    }

    boolean IsProperHackSequenceCount(int nCombo, int nCount)
    {
        return true;
    }
    
}
