/** klasa reprezentujaca huda wyboru implantow
 */
public class HUDImplant extends HUDComponent
{
    static float _UPDATE_INTERVAL = 0.1f;
    
    /**identyfikatory przyciskow, id implantow powinno sie pokrywac z id implantow z implant
     * systemu. kolejnosc implantow jest definiowana w skrypcie implants.scr     
     * w skrypcie huda przyciski musza sie nazywac tak jak tu*/
    final static int    ID_IMPLANT_0 = 0,
                        ID_IMPLANT_1 = 1,
                        ID_IMPLANT_2 = 2,
                        ID_IMPLANT_3 = 3,
                        ID_IMPLANT_4 = 4,
                        ID_IMPLANT_5 = 5,
                        ID_IMPLANT_6 = 6;

    final static int    BTN_STATE_ON = 0,
                        BTN_STATE_OFF = 1,
                        BTN_STATE_DISABLED = 2;
    
	static float _DEACTIVATE_TIME = 1f;
	
    
	/** modul ze szkieletem Logana*/
	ImplantModule m_ImplantModule = null;
    
    ImplantSystem m_cImplantSystem = null;
    
    UIWindow m_cModuleWindow = null;
    UIStatic m_cCurImplantName = null;
    UIButton m_tImplantButtons[] = null;
    UIStatic m_tImplantButtonTexts[] = null;
    UIWindow m_tImplantButtonIcons[] = null;
    UIWindow m_cAssimilationTitle = null;
    UIWindow m_cAssimilationProgress = null;
    UIControlObject m_cAssimilation = null;
    
    ImplantDescriptionWindow m_cDescriptionWindow = null;

    java.util.Vector m_vThresholdIndicators = null;
    
    boolean m_bImplantModuleActive = false;
    
    public void OnInit()
    {
        super.OnInit();
        m_cModuleWindow = GetElem("ID_IMPLANT_MODULE");
        m_cDescriptionWindow = (ImplantDescriptionWindow)GetElem("ID_IMPLANT_DESC");
        m_cCurImplantName = (UIStatic)GetElem("ID_IMPLANT_NAME");
        m_cAssimilationProgress = GetElem("ID_PROGRESS");
        m_cAssimilation = (UIControlObject)GetElem("ID_ASSIMILATION");
        m_cAssimilation.Hide();
        m_cAssimilationTitle = GetElem("ID_ASSIMILATION_TITLE");
        m_cAssimilationTitle.Hide();
        m_vThresholdIndicators = new java.util.Vector();
        RegisterKeyRequest();
		RegisterMouseButtonRequest();
    }
	
	
    public void OnCreate()
    {
        super.OnCreate();   
        
        if (!m_bDisableInNetGame)
            Load(GetModule(), "data/hud/HUDImplants.scr", false);
        

    }

    void DelayedInitHUDImplant()
    {
        m_ImplantModule = (ImplantModule) CreateObject("ImplantModule");
        m_ImplantModule.SetImplantWindow(m_cModuleWindow);
        m_ImplantModule.InitImplantModule(m_cImplantSystem);
        GetModule().RemoveSprite(m_cDescriptionWindow);
        m_ImplantModule.AddSprite(m_cDescriptionWindow);
        cCursor = (Cursor) CreateObject("Cursor");
		cCursor.SetCursorTex(GetModule(), sCursorTex);
        m_ImplantModule.AddSprite(cCursor.cursorTex);
		cCursor.Hide();
        InitButtons();
        PositionHUDComponent(0, 0);
    }
    
    void InitButtons()
    {
        int nImplants = m_cImplantSystem._IMPLANTS_NUM;
        m_tImplantButtons = new UIButton[nImplants];
        m_tImplantButtonIcons = new UIWindow[nImplants];
        m_tImplantButtonTexts = new UIStatic[nImplants];
        int nBtn = 0;
        for (int i = 0; i < nImplants; i++)
        {
            Implant cImplant = m_cImplantSystem.GetImplant(i);
            UIButton cBtn = (UIButton)GetElem("ID_IMPLANT_" + nBtn);
            cBtn.SetVisible(true);
            m_tImplantButtons[i] = cBtn;
            m_tImplantButtonIcons[i] = cBtn.GetElem("ID_ICON");
            m_tImplantButtonIcons[i].SetNormalTexture(cImplant.GetIconNormal());
            m_tImplantButtonTexts[i] = (UIStatic)cBtn.GetElem("ID_NAME");
            m_tImplantButtonTexts[i].SetText(TextToUpperCase(cImplant.m_sName));
            nBtn ++;
        }
        KillFocus();
    }
    
    public void Show()
    {
        KillFocus();
        super.Show();
    }
   
    void KillFocus()
    {
        int nFocus = FindFocus();
        if (nFocus != -1)
            GetButton(nFocus).SetFocus(false);
    }
    
    public void InitHUDImplant(ImplantSystem system)
	{
        m_cImplantSystem = system;
        if (!m_bDisableInNetGame)
        {
            if (MethodCaller.cThis == null)
            {
                if (!(ChromeGame.cSingleton instanceof ChromeGame))
                    return;
            }
            //MethodCaller.cThis.CallDelayedInitHUDImplant(this);
            CallOnFrameEnd("DelayedInitHUDImplant");
        }
	}
    
    public void OnDestroy()
    {
		super.OnDestroy();
        
        if(cCursor != null)
        {
            if(m_ImplantModule != null) m_ImplantModule.RemoveSprite(cCursor.cursorTex);
            cCursor.Destroy();
            cCursor.delete();
            cCursor = null;
        }
    
        if (m_ImplantModule != null)
    		m_ImplantModule.delete();
		m_ImplantModule = null;

        //CrashLog("[HUDImplant.OnDestroy]: Destroing DONE. \n");
	}
      
    public void Activate()
    {
		if (bActiveFlag)
			return;
		if (!cHUDManager.CanActivate(HUDManager._HUD_IMPL_MENU))
			return;
		
        super.Activate();   

        Draw();
        
		cHUDManager.HudMenuActivated(HUDManager._HUD_IMPL_MENU);
    }
	
	public void ActivateSlow()
	{
        Activate();   
	}

	public void ComponentMoved()
	{
		if (!bActiveFlag)
		{
			cHUDManager.m_bIsUserHUDActive = false;
			
			for (int i = 0; i < cPlayer.aWeaponHands.length; i++)
			{
				BaseAnimations cAnims = cPlayer.aWeaponHands[i];
			    if (cAnims!=null && cAnims.cMesh != null)
					((FPPHands) cPlayer.aWeaponHands[i].cMesh).SetHandsOnTop(true);
			}
			
			HideAll();
		}
	}
	
	public void HideAll()
	{
		if (m_bImplantModuleActive && m_ImplantModule != null)
		{
			m_ImplantModule.Deactivate();
			m_bImplantModuleActive = false;
		}
		cCursor.Hide();
		StopUpdateSystemInfo();
        ProcessMouse(false);
	}
    
    public void DrawDo()
    {
	    if (bActiveFlag)
        {
            Show();
			if (!m_bImplantModuleActive && m_ImplantModule != null)
			{
				m_ImplantModule.Activate();
				m_bImplantModuleActive = true;
			}
			if(cCursor != null)
			    cCursor.Show();
			StartUpdateSystemInfo();
	        ProcessMouse(true);
        }
    }
	
    public void Deactivate()
    {
		if (!bActiveFlag)
			return;
		
        super.Deactivate();   
		HideAll();
        
        cHUDManager.HudMenuDeactivated(HUDManager._HUD_IMPL_MENU);
		
    }
	
	public void DeactivateSlow()
	{
        Deactivate();   
	}
	
	public void PositionHUDComponent(int relX, int relY)
	{
		super.PositionHUDComponent(relX, relY);
		
		// liczymy polozenie widoku w ukladzie wspolrzednych WIDOKOW !!!,
		// iY to polozenie we wspolrzednych sprite'ow lewego dolnego rogu widoku
		int iY = (int)(m_cModuleWindow.GetPos().fY + m_cModuleWindow.GetSize().fY + relY);
        
        if (m_ImplantModule != null)
		    m_ImplantModule.SetViewOrigin(m_ImplantModule.m_iViewID,
									  (int)(m_cModuleWindow.GetPos().fX + relX),
									  (int)(GetScreenHeight() - (m_cModuleWindow.GetPos().fY + m_cModuleWindow.GetSize().fY)));
	}
	

    /****************************************************
     * ************* Update implantow
     */
    
    public void StartUpdateSystemInfo()
	{
		if (m_ImplantModule == null)
		{
			CrashLog("[HUDImplant:StartUpdateSystemInfo] Error! m_ImplantModule was not created yet ;( \n");
			return;
		}
		m_ImplantModule.SetSoundSource(((ChromeModule)GetModule()).GetMainPlayer().GetSpeaker());
		UpdateImplantsStates();
		UpdateInfo();
		CallMethodEvery("UpdateInfo", _UPDATE_INTERVAL);
	}
	
	public void StopUpdateSystemInfo()
	{
		DisableCallMethod("UpdateInfo");
	}
	
	public void UpdateInfo()
	{
		UpdateImplantsStates();
		
        //TODO zrobic
        /*int fTimeToShutDown = (int) m_cImplantSystem.GetSystemTimeToShutDown();
		if (fTimeToShutDown > 0)
			m_cModuleWindow.DisplayText("" + fTimeToShutDown + " s");
		else
			m_cModuleWindow.DisplayText("N/A");

		m_Progress.SetProgressPos((int) m_cImplantSystem.GetSystemOverload());*/
	}
	
	void UpdateImplantsStates()
	{
		for (int i = 0; i < m_cImplantSystem._IMPLANTS_NUM; i++)
		{
			if (!m_cImplantSystem.GetImplant(i).IsDisabled())
			{
				if (m_cImplantSystem.GetImplant(i).IsActive())
					SetImplantButtonState(i, BTN_STATE_ON);
				else
                {
                    if (m_cImplantSystem.CanActivateImplants())
					    SetImplantButtonState(i, BTN_STATE_OFF);
                    else
                        SetImplantButtonState(i, BTN_STATE_DISABLED);
                }
			}
			else
            {
				SetImplantButtonState(i, BTN_STATE_DISABLED);
            }
		}
	}
    
        
    void DisplayInfo(int iNofImplant)
	{
        m_cAssimilation.Show();
        m_cAssimilationTitle.Show();
        Implant cImplant = m_cImplantSystem.GetImplant(iNofImplant);
		m_cDescriptionWindow.DisplayDescriptionText(cImplant.m_sInfo);
        m_cCurImplantName.SetText(TextToUpperCase(cImplant.m_sName));
        Vector vLogicSize = m_cAssimilationProgress.GetLogicSize();
        vLogicSize.fX = cImplant.m_fCurrAssimilation;
        m_cAssimilationProgress.SetLogicSize(vLogicSize);
        m_cAssimilationProgress.OnSizeAndPos();
        for (int i = 0; i < m_vThresholdIndicators.size(); i ++)
        {
            ((UIWindow)m_vThresholdIndicators.elementAt(i)).Hide();
        }
        
        for (int i = 0; i < cImplant.GetAssimilationThresholdsCount(); i ++)
        {
            UIWindow cPattern = m_cAssimilation.GetPattern(EUIConst.sWINDOW);
            if (i >= m_vThresholdIndicators.size())
            {
                UIWindow cWnd = (UIWindow)CreateObject("UIWindow");
                cWnd.m_sId = ("ID_THRESHOLD_" + i);
                cWnd.Copy(cWnd, cPattern);            
                cWnd.OnSizeAndPos();
                m_cAssimilation.AddElement(cWnd);
                m_vThresholdIndicators.addElement(cWnd);
            }
            UIWindow cThreshold = ((UIWindow)m_vThresholdIndicators.elementAt(i));
            vLogicSize = cThreshold.GetLogicSize();
            vLogicSize.fX = cImplant.GetAssimilationThreshold(i);
            cThreshold.SetLogicSize(vLogicSize);
            cThreshold.OnSizeAndPos();
            cThreshold.Show();
            cThreshold.MoveTop();
        }
	}
	
	void HideInfo()
	{
        m_cAssimilation.Hide();
        m_cAssimilationTitle.Hide();
		m_cDescriptionWindow.HideWindow();
        m_cCurImplantName.SetText("");
	}
    
    /******************************************************************
     * *******************Obsluga przyciskow
     */
    int TranslateSIdToId(String sId)
    {
        String sImplant = "ID_IMPLANT_";
        int nImpLen = sImplant.length();
        if (sId.startsWith(sImplant))
        {
            String sNum = sId.substring(nImpLen, sId.length());
            Integer cNum = Integer.valueOf(sNum);
            return (ID_IMPLANT_0 + cNum.intValue());
        }
        return -1;
    }
    void OnUICommand(UIWindow cSender, int nCommand)
	{
		super.OnUICommand(cSender,nCommand);		
        int nId = TranslateSIdToId(cSender.m_sId);
        if (nId == -1)
            return;
                        
		if(nCommand == EUIConst.CM_DBCLICK)
        {
            OnButton(nId);
        }
		if(nCommand == EUIConst.CM_CLICK)
        {
            OnButton(nId);			
        }
	}
    
    void OnButton(int nId)
	{
        if (nId >= 0 && nId < ImplantSystem._IMPLANTS_NUM)
        {
            Implant cImplant = m_cImplantSystem.GetImplant(nId);
			if (cImplant != null)
			{
				if (!cImplant.IsDisabled() && cImplant.bPlayerCanActivate)
				{
					if (cImplant.IsActive())
					{
						cPlayer.ActionImplantOff(nId);
						SetImplantButtonState(nId, BTN_STATE_OFF);
					}
					else
					{
                        if (m_cImplantSystem.CanActivateImplants())
                        {
						    cPlayer.ActionImplantOn(nId);
						    SetImplantButtonState(nId, BTN_STATE_ON);
                        }
					}
				}
				else
                {
					SetImplantButtonState(nId, BTN_STATE_DISABLED);
                }
			}
            cHUDManager.RefreshImplantsIndicators();
		}
		else
        {
			
		}
		
	}
    
    
    
    void OnUINotify(UIWindow cSender, int nEvent)
	{
        int nId = TranslateSIdToId(cSender.m_sId);
        if (nId >= 0 && nId < ImplantSystem._IMPLANTS_NUM)
        {
            int nFocus = FindFocus();
            OnFocus(nFocus);
        }
        else
        {
            if(m_ImplantModule != null)
                m_ImplantModule.ViewImplant(ImplantModule._NO_IMPLANT);
        }
	}
	
    void OnFocus(int nFocus)
    {
        if (m_ImplantModule == null)
            return;
        
        if (nFocus != -1)
        {
            m_ImplantModule.ViewImplant(nFocus);
            DisplayInfo(nFocus);
        }
        else
        {
            m_ImplantModule.ViewImplant(ImplantModule._NO_IMPLANT);
            HideInfo();
        }
    }
    
    int FindFocus()
    {
        if (m_tImplantButtons == null)
            return -1;
        
        for (int i = 0; i < m_tImplantButtons.length; i++)
        {
            UIButton cBtn = GetButton(i);
            if (cBtn != null && cBtn.m_bFocus)
                return i;
        }
        return -1;
    }
    
    void SetImplantButtonState(int nButton, int nState)
    {
        Implant cImplant = m_cImplantSystem.GetImplant(nButton);
        switch(nState)
        {
        case BTN_STATE_ON:
            GetButtonIcon(nButton).SetNormalTexture(cImplant.GetIconActive());
            GetButtonText(nButton).SetTextAllColors(179f/255f, 254f/255f, 193f/255f);
            GetButton(nButton).SetData(new Integer(1));
            break;
        case BTN_STATE_OFF:
            GetButtonIcon(nButton).SetNormalTexture(cImplant.GetIconNormal());
            GetButtonText(nButton).SetTextAllColors(1, 1, 1);
            GetButton(nButton).SetData(null);
            break;
        case BTN_STATE_DISABLED:
            GetButtonIcon(nButton).SetNormalTexture(cImplant.GetIconDisabled());
            GetButtonText(nButton).SetTextAllColors(252f/255f, 178f/255f, 178f/255f);
            GetButton(nButton).SetData(null);
            break;
        }
    }
    
    UIButton GetButton(int i)
    {
        return m_tImplantButtons[i];
    }
    
    UIStatic GetButtonText(int i)
    {
        return m_tImplantButtonTexts[i];
    }
    
    UIWindow GetButtonIcon(int i)
    {
        return m_tImplantButtonIcons[i];
    }

    
    public void MoveTop()
    {
        super.MoveTop();
        cCursor.MoveTop();
    }
    
	public void OnInputMouseButton(int nButton, int nState)
    {
        // gdy wylaczona mysz to nie dziala lewy przycisk myszy sluzacy do klikania
        if(cHUDManager.player.bMouseUnacquired && (nButton == EMouse._BUTTON_1)) return;
        
        //uzyty tu jest OnInputKey, zeby nie powielac obslugi klawiatury (myszka tez
        //moze byc podpieta pod rozne akcje)
        CallOnInputKey(cHUDManager.player.ConvertMouseButtonToKey(nButton), nState, '0');
    }
    
	void OnInputMouseAxis(int nAxis, int nDelta)
    {
        HUDManager.ProcessMouseWheel(this, nAxis, nDelta);
    }
    
    void OnInputKey(int nKeyCode, boolean bKeyState, char nKeyAscii)
    {
        if (bKeyState)
        {
            if (nKeyCode == EGameControl.IMPLANTBIND_1)
            {
				ActivateBind(EGameControl.IMPLANTBIND_1);
            }
            if (nKeyCode == EGameControl.IMPLANTBIND_2)
            {
				ActivateBind(EGameControl.IMPLANTBIND_2);
			}
			if (nKeyCode == EGameControl.IMPLANTBIND_3)
			{
				ActivateBind(EGameControl.IMPLANTBIND_3);
			}
			if (nKeyCode == EGameControl.IMPLANTBIND_4)
			{
				ActivateBind(EGameControl.IMPLANTBIND_4);
            }
        }
    }
    
    void Bind(int nBind)
    {
        if (!bActiveFlag)
            return;
        ImplantsBinding cBinding = null;
        if (nBind == EGameControl.IMPLANTBIND_1)
            cBinding = EGameControl.m_cImplantsBindingF1;

        if (nBind == EGameControl.IMPLANTBIND_2)
            cBinding = EGameControl.m_cImplantsBindingF2;

        if (nBind == EGameControl.IMPLANTBIND_3)
            cBinding = EGameControl.m_cImplantsBindingF3;

        if (nBind == EGameControl.IMPLANTBIND_4)
            cBinding = EGameControl.m_cImplantsBindingF4;

        cBinding.Clear();
        for (int i = 0; i < EGameControl.IMPLANTS_NUM; i ++)
        {
            if (GetButton(i).GetData() != null)
                cBinding.BindImplant(i);
        }
        
        cHUDManager.AddConsText("&HUD_IMPLANT_BINDING_CHANGED&");
                    
        if (GetModule() instanceof ChromeModuleSingle)
            ControlLoadSave.SaveControls("Data/UserControls.scr");
        else
            ControlLoadSave.SaveControls(NetPlayerProfile.GetCurrentControlsFileName());
    }
    
    void ActivateBind(int nBind)
    {
        if (GetModule() instanceof ChromeModuleSingle &&
            !((ChromeModuleSingle)GetModule()).m_bImplantsAvailable)
            return;
            
        
        ImplantsBinding cBinding = null;
        if (nBind == EGameControl.IMPLANTBIND_1)
            cBinding = EGameControl.m_cImplantsBindingF1;
    
        if (nBind == EGameControl.IMPLANTBIND_2)
            cBinding = EGameControl.m_cImplantsBindingF2;

        if (nBind == EGameControl.IMPLANTBIND_3)
            cBinding = EGameControl.m_cImplantsBindingF3;

        if (nBind == EGameControl.IMPLANTBIND_4)
            cBinding = EGameControl.m_cImplantsBindingF4;

        
        boolean bAlreadyActive = IsBindActivated(cBinding);
        for (int i = 0; i < EGameControl.IMPLANTS_NUM; i ++)
        {
            Implant cImplant = m_cImplantSystem.GetImplant(i);
			if (cImplant != null)
			{
				if (!cImplant.IsDisabled() && cImplant.bPlayerCanActivate)
				{
					if (cBinding.IsBinded(i))
					{
                        if (!bAlreadyActive)
                        {
                            if (m_cImplantSystem.CanActivateImplants())
                            {
                                
                                cPlayer.ActionImplantOn(i);
                                cHUDManager.AddConsText("&IMPLANT& " + cImplant.m_sName +
                                    " &ACTIVATED&");
                                SetImplantButtonState(i, BTN_STATE_ON);
                            }
                            
                        }
                        else
                        {
                            cPlayer.ActionImplantOff(i);
                            cHUDManager.AddConsText("&IMPLANT& " + cImplant.m_sName + 
                                    " &DEACTIVATED&");
                            SetImplantButtonState(i, BTN_STATE_OFF);
                        }
					}
				}
				else
                {
					SetImplantButtonState(i, BTN_STATE_DISABLED);
                }
			}
        }
        cHUDManager.RefreshImplantsIndicators();
    }
    
    boolean IsBindActivated(ImplantsBinding cBinding)
    {
        for (int i = 0; i < EGameControl.IMPLANTS_NUM; i ++)
        {
            Implant cImplant = m_cImplantSystem.GetImplant(i);
            if (cImplant != null &&
                cBinding.IsBinded(i) && 
                !cImplant.IsActive() &&
                !cImplant.m_bDisabled)
                return false;
        }
        return true;
    }
	
	public void SGUpdate()
	{
		FileChunk.Log("[HUDImplant.SGUpdate]\n");		
		
		if (bActiveFlag && !bActiveFlagSG)
			CallMethodIn("Deactivate",0.f);
		if (!bActiveFlag && bActiveFlagSG)
			CallMethodIn("Activate",0.f);		
	}
}
