/** klasa reprezentujaca HUD ekranowy
 */
public class HUDManager extends GameObject
{
    static boolean _MAP_AVAILABLE_IN_NET_GAME               = true;
    static boolean _IMPLANTS_AVAILABLE_IN_NET_GAME          = true;
    static boolean _DETECTOR_ALWAYS_ON                      = true;
    static boolean _DETECTOR_IS_AVAILABLE                   = true;
    /** ze wzgledu na mozliwe wykorzystanie tego systemu w innych grach, nalezy zawsze
     * ustalac wartosc _HUD_LAST_ITEM jako o jeden wyzsza od najwiekszej wartosci pozostalych
	 * stalych
	 */
    final static byte _HUD_LAST_ITEM            =   22;
    final static byte _HUD_VOICE_MENU           =   21;
    final static byte _HUD_HACK                 =   20;
    final static byte _HUD_IMPLANT_INDICATORS   =   19;
    final static byte _HUD_LOGS		            =   18;
    final static byte _HUD_OBJ_DETECT           =   17;
    final static byte _HUD_ADD_COMPAS_SNIPER    =   16;
    final static byte _HUD_ADD_COMPAS           =   15;
    final static byte _HUD_TIMER	            =   14;
    final static byte _HUD_RACK                 =   13;
    final static byte _HUD_BINOCULARS           =   12;
    final static byte _HUD_SNIPER               =   11;
    final static byte _HUD_IMPL_MENU            =   10;
    final static byte _HUD_STATS                =   9;
    final static byte _HUD_INV_MENU             =   8;
    final static byte _HUD_MAP                  =   7;
    final static byte _HUD_UNIVERSAL            =   6;
    final static byte _NIUNIA                   =   5;
    final static byte _HUD_COMPASS	            =   4;
    final static byte _HUD_CONSOLE	            =   3;
    final static byte _HUD_INV_PLAYER           =   2;
    final static byte _PLAYER_DATA              =   1;
    final static byte _CROSSHAIR                =   0;
	
    int m_nActiveHudMenu = -1;
    
    /** rozmiar tablicy z komponentami HUD'a */
    static int nHUDArraySize = _HUD_LAST_ITEM;

    static float s_fWheelTime = 0;
    static float _WHEEL_LATENCY = 0.1f;
    
    ChromeInventoryMenu m_cInvMenu = null;
    
    Player player = null;

    /** tablica przechowujaca skladowe elementy HUD'a */
    HUDComponent aHUDComponent[] = null;

    /** referencje do inventory playera i innego powna */
    Inventory cPlayerInv = null;
    Inventory cPawnInv	= null;
    
    /** aktywne HUD'y */
    boolean[] aActiveHUD = null;

	/** czy zezwalamy na aktywowanie komponentow huda, ktorych ta zmienna dotyczy -
	 * jest ustawiana na false wtedy, gdy np. odpalamy filmy - czyli z przyczyn niezaleznych
	 * od samego huda i jego elementow
	 */
	boolean m_bActivateAllowed = true;
	
	/** zmienna sluzaca do sprawdzania, czy gracz moze aktywowac danego huda - mowiac
	 *  o hudzie mamy na mysli takie hudy jak inventory (pojedyncze lub z AI),
	 * mapa, implanty. Zmienna ta jest ustawiana (w przeciwienstwie do m_bActivateAllowed)
	 * przez inne elementy huda.
	 */
	boolean m_bIsUserHUDActive = false;

	/** flaga mowiaca, czy aktywna jest lornetka - wtedy deaktywujemy tylko ja przy hide
	 * all, a pozniej ja przywracamy. spowodowane jest to tym, ze sama lornetka korzysta
	 * z hideall i unhideall.
	 */
	boolean m_bActivateBinocularsOnly = false;
	
	HitIndicators m_HitIndicators = null;
    
    /** 
     * Flaga mowiaca ze hud "sieci" na levelu sieciowym
     */
    boolean m_bModuleNet = false;
	
	void AllowActivate()
	{
		m_bActivateAllowed = true;
	}
	
	void DisallowActivate()
	{
		m_bActivateAllowed = false;
	}
	
    public void OnCreate()
    {
		bSG = false;
		m_bModuleNet = GetModule() instanceof ModuleNet;
        ActivateOnModule();
        s_fWheelTime = 0;
    }

    boolean m_bDisableInNetGame = false;
    
    void InitInGame(Player pl, GameInitInfo cGameInitInfo )
    {
        start =  java.lang.System.currentTimeMillis();
        
        player = pl;
        
        m_bDisableInNetGame = ( player instanceof PlayerNetBase &&
                                      player.bNetIsOwner == false );
        
        // pobieram z playera jego inventory
        cPlayerInv = player.GetInventory();
        
        ChromeModule cModule = (ChromeModule)GetModule();
        
        String sHudMapClassName = "HUDMap";
        String sHudCompassClassName = "HUDCompass";
        int    nPlayersCnt      = 1;
        int    nVehiclesCnt     = 0;
        if ( cGameInitInfo instanceof NetGameInitInfo )
        {
            NetGameInitInfo cInitInfo = (NetGameInitInfo)cGameInitInfo;
            
            LogD(" ENetGameType."+cInitInfo.nGameType+"\n");
            
            nPlayersCnt = cInitInfo.GetServerInfo().GetMaxPlayers();
            nVehiclesCnt = ((ModuleNet)GetModule()).GetVehiclesCnt();
            sHudMapClassName = ENetGameType.GetHudMapClassName( cInitInfo.nGameType );
            sHudCompassClassName = ENetGameType.GetHudCompassClassName( cInitInfo.nGameType );
            
        }
        aHUDComponent = new HUDComponent[nHUDArraySize];

        if (GetModule() instanceof ChromeModuleSingle)
        {
            // laduje hud'a z gadajaca glowa
            aHUDComponent[_NIUNIA] = CreateHUD("HUDCompNiunia", player);
        }
        
        // laduje hud'a z implantami
        aHUDComponent[_HUD_IMPL_MENU] = CreateHUD("HUDImplant", player);
        // ustawiamy komponentowi z implantami referencje do systemu implantow biezacego gracza
		((HUDImplant) aHUDComponent[_HUD_IMPL_MENU]).InitHUDImplant( pl.GetImplantSystem() );
        
        if(!m_bDisableInNetGame)
        {
            // laduje do tablicy CrossHair
            aHUDComponent[_CROSSHAIR] = CreateHUD("HUDCompCrossHair", player);
        }
        
        // laduje huda z mapa 
        HUDMap cHUDMap = (HUDMap) CreateHUDNoInit( sHudMapClassName, player );
        
        pre =  java.lang.System.currentTimeMillis();
        cHUDMap.SetPlayersCnt( nPlayersCnt );
        cHUDMap.SetVehiclesCnt( nVehiclesCnt );
        cHUDMap.InitObject();
        aHUDComponent[_HUD_MAP] = cHUDMap;
        
        post = java.lang.System.currentTimeMillis();
        overall += post - pre;
        /*
        if (GetModule() instanceof ModuleNet)
        LogR("HudMap init" + " " + (post - pre) + " delta " + (post-start)+
             " overall " + overall + 
             " owner " + !m_bDisableInNetGame + 
             " server " + (((ModuleNet)GetModule()).AmIServer()));
        */
        // laduje do tablicy PlayerHUD
        aHUDComponent[_PLAYER_DATA] = CreateHUD("HUDCompPlayer", player);					
        
        // laduje do tablicy PlayerInvHUD
        aHUDComponent[_HUD_INV_PLAYER] = CreateHUD("HUDCompInvPl", player);
        
        if (!m_bDisableInNetGame)
        {
            // laduje do tablicy HUDConsole
            aHUDComponent[_HUD_CONSOLE] = CreateHUD("HUDConsole", player);
        }
        
        // ustawiamy odpowiednia teksture mapy dla huda mapy
        String sMapTexture = null;
		if (cModule.sInGameMap != null)
			sMapTexture = cModule.sInGameMap.sName;
        if (sMapTexture == null)
            sMapTexture = cGameInitInfo.cLevels.GetCurrent().sLevelMapTexture;
        
        //w sieci na kompasie ma byc to co na mapce...
        if ( cModule instanceof ModuleNet )
            cModule.SetInGameMapName( sMapTexture );

        // laduje do tablicy HUDCompass
        aHUDComponent[_HUD_COMPASS] = CreateHUD(sHudCompassClassName, player);
        
        // laduje huda z wskaznikami pojazdow, bossow itd.
        aHUDComponent[_HUD_UNIVERSAL] = CreateHUD("HUDUniversal", player);
        
        if (cModule instanceof ModuleNet)
        {
            aHUDComponent[_HUD_VOICE_MENU]       = CreateHUD("HUDVoiceMenu", player);
        }
        
        // hud dla stojaka z bronia
        aHUDComponent[_HUD_RACK] = null;//(HUDCompRack)CreateObject("HUDCompRack");
        
        if (!m_bDisableInNetGame)
        {
            // hud z logami
		    aHUDComponent[_HUD_LOGS] = CreateHUD("HUDGameLogs", player);
        }
        
        if (cModule instanceof ChromeModuleSingle)
        {
            // HUD Timer'a
		    aHUDComponent[_HUD_TIMER] = CreateHUD("HUDTimer", player);
        }
        
        
        // kompas do lornetki
		aHUDComponent[_HUD_ADD_COMPAS] = CreateHUD("HUDAdditionalCompass", player);
        // kompas do sniperki
		aHUDComponent[_HUD_ADD_COMPAS_SNIPER] = CreateHUD("HUDAdditionalCompassSniper", player); 
        
        if (cModule instanceof ChromeModuleSingle)
        {
            // HUD detektora obiektow
		    aHUDComponent[_HUD_OBJ_DETECT] = CreateHUD("HUDObjectsDetector", player);
        }
        
        // HUD ikon implantow
		aHUDComponent[_HUD_IMPLANT_INDICATORS] = CreateHUD("HUDImplantIndicators", player);
        
        if (cModule instanceof ChromeModuleSingle)
        {
            // HUD hackowania
            aHUDComponent[_HUD_HACK] = CreateHUD("HUDHack", player);
        }
        
        if (aHUDComponent[_HUD_MAP] == null)
            LogD("aHUDComponent[_HUD_MAP] == null\n");
        if(cGameInitInfo == null)
            LogD("cGameInitInfo == null\n");
        if(cGameInitInfo.cLevels == null)
            LogD("cGameInitInfo.cLevels == null\n");
        if(cGameInitInfo.cLevels.GetCurrent() == null)
            LogD("cGameInitInfo.cLevels.GetCurrent() == null\n");
        if(cGameInitInfo.cLevels.GetCurrent().sLevelMapTexture == null)
            LogD("cGameInitInfo.cLevels.GetCurrent().sLevelMapTexture == null\n");

		
        // przekazuje HUDMap referencje do HUDCompas
        ((HUDMap) aHUDComponent[_HUD_MAP]).SetCompassRef((HUDCompass) aHUDComponent[_HUD_COMPASS]);
        // ustawiamy mape
        
        if (!m_bDisableInNetGame)
            ((HUDMap) aHUDComponent[_HUD_MAP]).SetTerrainMap( sMapTexture );

        if (cModule instanceof ChromeModuleSingle)
        {
            // laduje huda z statystykami
            aHUDComponent[_HUD_STATS] = CreateHUD("HUDStatistics", player);
        }
        
        aHUDComponent[_HUD_SNIPER] = CreateHUD("HUDSniper", player);
        
        //aHUDComponent[_HUD_BINOCULARS] = null; //inicjalizacja przeprowadzana jest w PlayerzeHUD, po uzyciu danej lornetki 
        // bylo: '= (HUDBinoculars)CreateObject("HUDBinoculars");'
        //jednak przez preloading ladujemy ja tu
        CreateHUDBinoculars(player, cGameInitInfo);

        pre =  java.lang.System.currentTimeMillis();
        if (!m_bDisableInNetGame)
        {
            m_HitIndicators = (HitIndicators) CreateObject("HitIndicators");    
	    	m_HitIndicators.SetPlayer((PlayerHUD)player);
		    m_HitIndicators.ActivateOnModule();
        }
        post = java.lang.System.currentTimeMillis();
        overall += post - pre;
/*
        if (GetModule() instanceof ModuleNet)
        LogR("HitIndicators" + " " + (post - pre) + " delta "+(post-start)+
             " overall " + overall + 
             " owner " + !m_bDisableInNetGame + 
             " server " + (((ModuleNet)GetModule()).AmIServer()));
*/
        //w sieci zadziala tylko dla ownera
        RegisterKeyRequestIfNeeded();
        
        // zapisanie inventory do HUDCompInvPl
        ((HUDCompInvPl)(aHUDComponent[_HUD_INV_PLAYER])).SetPlayerInv(cPlayerInv);

        //zapisanie inventory do HUDCompPlayer
        ((HUDCompPlayer)(aHUDComponent[_PLAYER_DATA])).SetPlayerInv(cPlayerInv);
        
        // teraz robie update pozycji gridow w invenotry
        UpdateGridGamePos();
        
        if ( !m_bDisableInNetGame )
        {
            ActivateDefaultHUDs();
        }

		// zaktywowanie hintow
        if ( (GetModule() != null) && (GetModule() instanceof ChromeModuleSingle) )
            ((ChromeModuleSingle)GetModule()).ActivateHints();
		
        // teraz wyswietlam przedmiot do uzycia
        player.cInventory.SetFirstUsableInvObj();
		
        if (aHUDComponent[_PLAYER_DATA] != null)
        {
			InvObject obj = player.cInventory.GetActualUsableInvObj();
            ((HUDCompPlayer) aHUDComponent[_PLAYER_DATA]).ShowUsableInvObj(obj);
        }
        
        //zmienna statyczna musi byc ustawiona zeby nie bylo konsekwencji z poprzedniej gry 
        m_bActivateAllowed = true;
    }

    void ActivateDefaultHUDs()
    {
        if (m_bDisableInNetGame)
            return;
        
		aHUDComponent[_CROSSHAIR].Activate();
        aHUDComponent[_CROSSHAIR].MoveTop();
        aHUDComponent[_HUD_COMPASS].Activate();
        aHUDComponent[_HUD_COMPASS].MoveTop();
        aHUDComponent[_PLAYER_DATA].Activate();
        aHUDComponent[_PLAYER_DATA].MoveTop();
        aHUDComponent[_HUD_CONSOLE].Activate();
        aHUDComponent[_HUD_CONSOLE].MoveTop();
        GetHudUniversal().Activate();
        GetHudUniversal().MoveTop();
        //aHUDComponent[_NIUNIA].Activate();
        //aHUDComponent[_NIUNIA].MoveTop();
        aHUDComponent[_HUD_IMPLANT_INDICATORS].Activate();
        aHUDComponent[_HUD_IMPLANT_INDICATORS].MoveTop();
        
        
        HintsMoveTop();
    }
    
    long overall = 0;
    long start   = 0;
    long pre = 0;
    long post = 0;
    HUDComponent CreateHUD(String sClass, Player cPlayer)
    {
        pre =  java.lang.System.currentTimeMillis();
        HUDComponent cHUD = (HUDComponent)CreateObjectNoInit(sClass);
        cHUD.m_bDisableInNetGame = m_bDisableInNetGame;
		cHUD.SetParams( (PlayerHUD)cPlayer, this );
        cHUD.InitObject();
            
        post = java.lang.System.currentTimeMillis();
        overall += post - pre;
        /*if (GetModule() instanceof ModuleNet)
        LogR(sClass + " " + (post - pre) + " delta "+(post-start)+
             " overall " + overall + 
             " owner " + !m_bDisableInNetGame + 
             " server " + (((ModuleNet)GetModule()).AmIServer()) + "\n");
            */
        start = post;
        return cHUD;
    }
    
    HUDComponent CreateHUDNoInit(String sClass, Player cPlayer)
    {
        long pre = 0;
        long post = 0;
        pre =  java.lang.System.currentTimeMillis();
        HUDComponent cHUD = (HUDComponent)CreateObjectNoInit(sClass);
        cHUD.m_bDisableInNetGame = m_bDisableInNetGame;
		cHUD.SetParams( (PlayerHUD)cPlayer, this );
            
        post = java.lang.System.currentTimeMillis();
        overall += post - pre;
        //LogR(sClass + " " + (post - pre) + " overall " + overall + " owner " + !m_bDisableInNetGame);
        return cHUD;
    }
    
    void HintsMoveTop()
    {
        if ( (GetModule() != null) && (GetModule() instanceof ChromeModuleSingle) &&
             ((ChromeModuleSingle)GetModule()).GetHintManager() != null)
            ((ChromeModuleSingle)GetModule()).GetHintManager().MoveTop();
    }
    
    void InitInMenu(Player pl)
    {
        Log("[HUDManager.InitInMenu]\n");
        
        player = pl;
        
        // pobieram z playera jego inventory
        cPlayerInv = player.GetInventory();
        
        aHUDComponent = new HUDComponent[nHUDArraySize];
        for (int i = 0; i < aHUDComponent.length; i++)
			aHUDComponent[i]=null;
        
        /*aHUDComponent[_HUD_INV_MENU] = (HUDInvMenu) CreateObject("HUDInvMenu");
        aHUDComponent[_HUD_INV_MENU].SetParams( (PlayerHUD)player, this );
        ((HUDInvMenu) (aHUDComponent[_HUD_INV_MENU])).SetPlayerInv(cPlayerInv);*/
        
        RegisterKeyRequestIfNeeded();
    }
    
    void FinishInMenu()
    {
        Log("[HUDManager.FinishInMenu]\n");
        
        cPlayerInv = null;
        
        UnregisterKeyRequest();
        UnregisterMouseButtonRequest();
        UnregisterMouseAxisRequest();
    }
    
    
    public void Activate(int nComp)
    {
        if(aHUDComponent[nComp]!=null)
        {
            aHUDComponent[nComp].Activate();
        }
    }

    public void Deactivate(int nComp)
    {
        if(aHUDComponent[nComp]!=null)
        {
            aHUDComponent[nComp].Deactivate();
        }
    }

    public void DeactivateAll()
    {
        for(int nComp = 0; nComp < nHUDArraySize; nComp++)
        {
            if(aHUDComponent[nComp]!=null)
            {
                aHUDComponent[nComp].Deactivate();
            }
        }
    }
	
    /**Chowa prawie wszystko :), zostawia tylko niunie
     */
    public void HideAll()
    {
		// jezeli ukrywamy huda, gdy aktywna jest lornetka, mamy problem, bo ukrycie
		// lornetki spowodowalo wczesniej ustawienie tablicy aActiveHUD, ktorej nie mozemy
		// nadpisac, bo nie bedziemy wiedzieli co mamy aktywowac po wylaczeniu lornetki
		if ( (aHUDComponent[_HUD_BINOCULARS] != null) &&
			 (aHUDComponent[_HUD_BINOCULARS].bActiveFlag) )
		{
			m_bActivateBinocularsOnly = true;
			GetHUDBinoculars().DeactivateByHUD();

			// zdezaktywowanie hintow - wtedy, gdy chowamy wszystkie hudcomponents lacznie z lornetka...
			if ( (GetModule() != null) && (GetModule() instanceof ChromeModuleSingle) )
			    ((ChromeModuleSingle)GetModule()).DeactivateHints();
			
			return;
		}
        
		// ...zdezaktywowanie hintow - rowniez podczas filmu
		if ( (GetModule() != null) && (GetModule() instanceof ChromeModuleSingle) &&
             (((ChromeModuleSingle)GetModule()).IsMoviePlaying()))
		    ((ChromeModuleSingle)GetModule()).DeactivateHints();
		
        aActiveHUD = new boolean[nHUDArraySize];

        Log("Komponenty do schowania: ");
        for (int nComp = 0; nComp < nHUDArraySize; nComp++)
        {
            aActiveHUD[nComp] = ( (aHUDComponent[nComp] != null) &&
                                  (aHUDComponent[nComp].bActiveFlag) &&
                                  nComp != _NIUNIA);
            if (aActiveHUD[nComp])
            {
                Log(" "+nComp);
                aHUDComponent[nComp].Deactivate();
            }
        }
		
        LogD(" all HUDs hidden\n");
    }

    /**Chowa rzeczywiscie wszystko
     */
    public void HideAllForMovie()
    {
        boolean bActivateAllowed = m_bActivateAllowed;
        AllowActivate();
        
        if ( (aHUDComponent[_HUD_BINOCULARS] != null) &&
			 (aHUDComponent[_HUD_BINOCULARS].bActiveFlag) )
		{
			GetHUDBinoculars().DeactivateByHUD();
        }
        
        if ( (aHUDComponent[_PLAYER_DATA] != null) &&
			 (aHUDComponent[_PLAYER_DATA].bActiveFlag) )
            GetHUDPlayer().DeactivateForMovie();
        
        if ( (aHUDComponent[_HUD_SNIPER] != null) &&
			 (aHUDComponent[_HUD_SNIPER].bActiveFlag) )
		{
			GetHUDSniper().Deactivate();
        }
        
        HideAll();
        
        if (aHUDComponent[_NIUNIA] != null &&
            aHUDComponent[_NIUNIA].bActiveFlag)
        {
            aHUDComponent[_NIUNIA].Deactivate();
        }
        
        if (m_HitIndicators != null)
            m_HitIndicators.HideForMovie();
        
        if (!bActivateAllowed)
            DisallowActivate();
    }
    
    public void UnhideAll()
    {
        if (aActiveHUD == null || (player != null && player.IsDead()))
            return;
        
        AllowActivate();
        
		if (m_bActivateBinocularsOnly)
		{
			GetHUDBinoculars().ActivateByHUD();
			m_bActivateBinocularsOnly = false;
			
			return;
		}

		if ( (GetModule() != null) && (GetModule() instanceof ChromeModuleSingle) )
		    ((ChromeModuleSingle)GetModule()).ActivateHints();
        
        Log("Komponenty do pokazania: ");
        for(int nComp = 0; nComp < nHUDArraySize; nComp++)
        {
            if (aActiveHUD[nComp] && (aHUDComponent[nComp] != null))
            {
                Log(" "+nComp);
                aHUDComponent[nComp].Activate();
            }
        }
        
        ActivateDefaultHUDs();
        
        
        Log("\n");
    }

    boolean CanActivate(int nHud)
    {
        //wyjatkowo w sieci logi mozna ogladac zawsze
        if ( player instanceof PlayerNetBase &&
             player.bNetIsOwner &&
             nHud == _HUD_LOGS )
            return true;
        
        if (!m_bActivateAllowed)
            return false;
        
        if (IsPlayerInVehicle())
        {
            //siedzimy w pojezdzie, dziala tylko mapa, logi i zwykle hudy
            if (nHud == _HUD_MAP || 
                nHud == _HUD_LOGS ||
                (!IsHudMenu(nHud) && !IsHudZoomer(nHud)))
                return true;
            else
                return false;
        }
        else
        {
            if (GetHUDBinoculars() != null && GetHUDBinoculars().bActiveFlag || 
                GetHUDSniper() != null && GetHUDSniper().bActiveFlag)
                return false;
            else
                return true;
        }
        
    }
    
    HUDVoiceMenu GetHUDVoiceMenu()
    {
        return (HUDVoiceMenu)aHUDComponent[_HUD_VOICE_MENU];
    }
    
    HUDMap GetHUDMap()
    {
        return (HUDMap) aHUDComponent[_HUD_MAP];
    }
	
	HUDGameLogs GetHUDLogs()
	{
		return (HUDGameLogs) aHUDComponent[_HUD_LOGS];
	}
    
    HUDCompPlayer GetHUDPlayer()
    {
        return (HUDCompPlayer) aHUDComponent[_PLAYER_DATA];
    }

    HUDCompCrossHair GetHUDCrossHair()
    {
        return (HUDCompCrossHair) aHUDComponent[_CROSSHAIR];
    }

    HUDCompNiunia GetHUDNiunia()
    {
        return (HUDCompNiunia) aHUDComponent[_NIUNIA];
    }
    
    HUDCompInvPl GetHudCompInvPl()
    {
        return (HUDCompInvPl) aHUDComponent[_HUD_INV_PLAYER]; 	
    }

    HUDStatistics GetHudStats()
    {
        return (HUDStatistics) aHUDComponent[_HUD_STATS]; 	
    }
    
    HUDCompRack GetHudRack()
    {
        return (HUDCompRack)aHUDComponent[_HUD_RACK];
    }
	
	HUDUniversal GetHudUniversal()
	{
        return (HUDUniversal) aHUDComponent[_HUD_UNIVERSAL];
	}

    HUDTimer GetHUDTimer()
	{
		return (HUDTimer) aHUDComponent[_HUD_TIMER];
	}
	
	void SetHUDBinoculars(HUDComponent binoculars)
	{
		aHUDComponent[_HUD_BINOCULARS] = binoculars;
	}
	
	HUDBinocularsExtended GetHUDBinoculars()
	{
		return (HUDBinocularsExtended) aHUDComponent[_HUD_BINOCULARS];
	}
	
    void CreateHUDBinoculars(Player cPlayer, GameInitInfo cGameInitInfo )
    {
        HUDBinocularsExtended cBinoculars = (HUDBinocularsExtended)CreateHUD("HUDBinocularsExtended", cPlayer);
        cBinoculars.SetCompass(GetHUDAddCompass());
        cBinoculars.SetStaticText(cGameInitInfo.cLevels.GetCurrent().sWeather);
        SetHUDBinoculars((HUDComponent) cBinoculars);
    }
    
	HUDAdditionalCompass GetHUDAddCompass()
	{
		return (HUDAdditionalCompass) aHUDComponent[_HUD_ADD_COMPAS];
	}
	
    HUDAdditionalCompassSniper GetHUDAddCompassSniper()
    {
        return (HUDAdditionalCompassSniper) aHUDComponent[_HUD_ADD_COMPAS_SNIPER];
    }
    
	HUDObjectsDetector GetHUDObjDetector()
	{
		return (HUDObjectsDetector) aHUDComponent[_HUD_OBJ_DETECT];
	}
	
	HUDCompass GetHUDCompass()
	{
		return (HUDCompass) aHUDComponent[_HUD_COMPASS];
	}
	
	public HUDSniper GetHUDSniper()
	{
		return (HUDSniper) aHUDComponent[_HUD_SNIPER];
	}
	
    public HUDImplant GetHUDImplant()
    {
        return (HUDImplant) aHUDComponent[_HUD_IMPL_MENU];
    }
    
    public HUDImplantIndicators GetHUDImplantIndicators()
    {
        return (HUDImplantIndicators) aHUDComponent[_HUD_IMPLANT_INDICATORS];
    }
    
    public HUDHack GetHUDHack()
    {
        return (HUDHack) aHUDComponent[_HUD_HACK];
    }
    
    
    public void OnDestroy()
    {
        //CrashLog(this + " OnDestroy\n");
        for (int i = 0; i < aHUDComponent.length; i++)
        {
            if (aHUDComponent[i] != null)
            {
                aHUDComponent[i].delete();
                aHUDComponent[i] = null;
            }
        }
		if (m_HitIndicators != null)
        {
            m_HitIndicators.delete();
		    m_HitIndicators = null;
        }
    }

    public void OnInputMouseButton(int nButton, int nState)
    {
        // gdy wylaczona mysz to nie dziala lewy przycisk myszy sluzacy do klikania
        if(player.bMouseUnacquired && (nButton == EMouse._BUTTON_1)) return;
        
        //uzyty tu jest OnInputKey, zeby nie powielac obslugi klawiatury (myszka tez
        //moze byc podpieta pod rozne akcje)
        CallOnInputKey(player.ConvertMouseButtonToKey(nButton), nState, '0');
    }
    
    static void ProcessMouseWheel(GameObject cObj, int nAxis, int nDelta)
    {
        if (nAxis != EMouse._AXIS_Z)
            return;
        
        //w czasie zoomowania (sniper, lornetka) zoomujemy, wpp przetwarzamy
        if (cObj instanceof ChromeModule)
        {
            if ((((ChromeModule)cObj).GetMainPlayer()) != null &&
                ((ChromeModule)cObj).GetMainPlayer().cZoomer != null)
                return;
        }
        else
        {
            if (cObj.GetModule() != null &&
                (((ChromeModule)cObj.GetModule()).GetMainPlayer()) != null &&
                ((ChromeModule)cObj.GetModule()).GetMainPlayer().cZoomer != null)
                return;
        }
        if (cObj.GetTime() - s_fWheelTime < _WHEEL_LATENCY &&
            cObj.GetTime() != s_fWheelTime)
            return;
        
        s_fWheelTime = cObj.GetTime();
            
        //uzyty tu jest OnInputKey, zeby nie powielac obslugi klawiatury (myszka tez
        //moze byc podpieta pod rozne akcje)
        
        if (nDelta > 0)   
            cObj.CallOnInputKey(EKey._MOUSE_WHEEL_DN, 1, '0');
        else
            if (nDelta < 0)
                cObj.CallOnInputKey(EKey._MOUSE_WHEEL_UP, 1, '0');
    }
    
    void OnInputMouseAxis(int nAxis, int nDelta)
    {
        ProcessMouseWheel(this, nAxis, nDelta);
    }
    
    /** reakcja na wcisniecie klawisza
     */
    public void OnInputKey(int nKeyCode, boolean bKeyState, char nKeyAscii)
    {
        if (bKeyState)
        {
            if (Precache.bPrecaching || 
                (ChromeGame.cSingleton instanceof ChromeGame && 
                ((ChromeGame)ChromeGame.cSingleton).Menu.bInGameMenuAct) ||
                ((ChromeModule)GetModule()).bInFadeState)
                return;

// od teraz podczas celowania mozna normalnie wlaczac wszystko
//            if ((player.cZoomer == null) && (!player.bBurbotMode))
            {
                // wcisniecie I
                if ( (nKeyCode == EGameControl.INVENTORY) && 
                     (aHUDComponent[_HUD_INV_PLAYER] != null) )
                {
					// jezeli przypadkiem nacisnelismy I podczas przeszukiwania zwlok
					if ( ((HUDCompInvPl) aHUDComponent[_HUD_INV_PLAYER]).AIActive )
						return;
					
                    if (aHUDComponent[_HUD_INV_PLAYER].bActiveFlag)
                    {
                        aHUDComponent[_HUD_INV_PLAYER].Deactivate();
                    }
                    else
                    {
                        aHUDComponent[_HUD_INV_PLAYER].ActivateSlow();
                    }
                }
				else
				if (nKeyCode == EGameControl.IMPLANTS)
				{
                    if (CanOperateImplants())
                    {
					    SwitchImplantMenu();
                        // wyslanie komunikatu do modulu ze gracz uzyl implanow
                        if ( GetModule() != null && GetModule() instanceof ChromeModuleSingle )
                        {
                            ((ChromeModuleSingle)GetModule()).MessageToHints( HintManager._MSG_IMPLANTSUSED );
                        }
                    }
				}
                else
                //TODO uwzglednic w ustawieniach klawiszy
                if (_DETECTOR_IS_AVAILABLE && !_DETECTOR_ALWAYS_ON &&
                    nKeyCode == EGameControl.DETECTOR && (aHUDComponent[_HUD_OBJ_DETECT] != null))
				{
                    if (aHUDComponent[_HUD_OBJ_DETECT].bActiveFlag)
                    {
                        aHUDComponent[_HUD_OBJ_DETECT].DeactivateSlow();
                    }
                    else
                    {
                        aHUDComponent[_HUD_OBJ_DETECT].ActivateSlow();
                    }
				}
                else if (nKeyCode == EGameControl.IMPLANT0) { ToggleImplant(0); }
                else if (nKeyCode == EGameControl.IMPLANT1) { ToggleImplant(1); }
                else if (nKeyCode == EGameControl.IMPLANT2) { ToggleImplant(2); }
                else if (nKeyCode == EGameControl.IMPLANT3) { ToggleImplant(3); }
                else if (nKeyCode == EGameControl.IMPLANT4) { ToggleImplant(4); }
                else if (nKeyCode == EGameControl.IMPLANT5) { ToggleImplant(5); }
                else if (nKeyCode == EGameControl.IMPLANT6) { ToggleImplant(6); }
                else
                if (nKeyCode == EGameControl.IMPLANTS_OFF)
                {
                    for (int i = 0; i < ImplantSystem._IMPLANTS_NUM; i++)
                        if (player.IsImplantActive(i) && (i != ImplantSystem._IMPLANT_HACK))
                            DeactivateImplant(i);                            

                }
                /*else if (nKeyCode == EGameControl.IMPLANT7) { ToggleImplant(7); }
                else if (nKeyCode == EGameControl.IMPLANT8) { ToggleImplant(8); }
                else if (nKeyCode == EGameControl.IMPLANT9) { ToggleImplant(9); }*/
                
                else
				if ( (nKeyCode==EGameControl.ACTION) &&
                     (aHUDComponent[_HUD_INV_PLAYER] != null) )
                {
                    //tak wolane, zeby w graczu sie z powrotem nie wlaczyl ten hud
                    //(to samo przetwarzanie klawiszy)
                    if (aHUDComponent[_HUD_INV_PLAYER].bActiveFlag)
					    CloseGetInventory();
                }
				
				// wcisniecie klawisza powodujacego ruch, gdy inventory jest wlaczone
				else
                    if ( (nKeyCode == EGameControl.BACKWARD) ||
                         (nKeyCode == EGameControl.FORWARD) ||
                         (nKeyCode == EGameControl.STRAFE_LEFT) ||
                         (nKeyCode == EGameControl.STRAFE_RIGHT) ) 
				{
                    if (aHUDComponent[_HUD_INV_PLAYER] != null &&
					 ((HUDCompInvPl)aHUDComponent[_HUD_INV_PLAYER]).AIActive)
					    CloseGetInventory();
                    
                    if (aHUDComponent[_HUD_HACK] != null && GetHUDHack().bActiveFlag)
                        GetHUDHack().ForceLogOff();
				}
                else
				if ( (nKeyCode == EGameControl.MAP) &&
                     (aHUDComponent[_HUD_MAP] != null) )
                {
                    if ( !(GetModule() instanceof ModuleNet) || _MAP_AVAILABLE_IN_NET_GAME)
                    {
                        SwitchHudMap();
                    }
                }
                else
				if ( (nKeyCode == EGameControl.LOGS) &&
                     (aHUDComponent[_HUD_LOGS] != null) )
                {
                    SwitchHudLogs();
                }
                else
                    if (nKeyCode == EGameControl.VOICE_MENU && 
                        (aHUDComponent[_HUD_VOICE_MENU] != null) )
                    {
                        if (aHUDComponent[_HUD_VOICE_MENU].bActiveFlag)
                            aHUDComponent[_HUD_VOICE_MENU].Deactivate();
                        else
                            aHUDComponent[_HUD_VOICE_MENU].Activate();

                    }
            }

            //jesli aktywny hud itemow:
            if (aHUDComponent[_PLAYER_DATA] != null &&
                aHUDComponent[_PLAYER_DATA].bActiveFlag)
            {
                //LogD("items HUD active\n");
                // wcisniecie NextItem
                if (nKeyCode==EGameControl.ITEM_NEXT)
                {
                    //false - bez powtorzen obiektow
                    player.cInventory.SetNextUsableInvObj(false);
                    if (aHUDComponent[_PLAYER_DATA] != null)
                    {
                        InvObject obj = player.cInventory.GetActualUsableInvObj();
                        ((HUDCompPlayer)aHUDComponent[_PLAYER_DATA]).ShowUsableInvObj(obj, EGameControl.ITEM_NEXT);
                    }
                    
                }

                // wcisniecie PrevItem
                if (nKeyCode==EGameControl.ITEM_PREV)
                {
                    //false - bez powtorzen obiektow
                    player.cInventory.SetPrevUsableInvObj(false);
                    if (aHUDComponent[_PLAYER_DATA] != null)
                    {
                        InvObject obj = player.cInventory.GetActualUsableInvObj();
                        ((HUDCompPlayer)aHUDComponent[_PLAYER_DATA]).ShowUsableInvObj(obj, EGameControl.ITEM_PREV);
                    }
                    
                }
                
                // wcisniecie USE
                if ((nKeyCode==EGameControl.USE))// && (player.nFiringState == Weapon._NO_FIRING))
                {
                    player.cInventory.UseInvObject();
                    //((HUDCompInvUse)aHUDComponent[_INV_USE]).UseInvObj();
                }
            }
            
            if (nKeyCode == EGameControl.USE_ITEM_HEALTHEX) 
                player.cInventory.UseSpecificInvObject(InvObject._E_DRUG_HEALTH);
            if (nKeyCode == EGameControl.USE_ITEM_NEURAL_HEALTHEX) 
                player.cInventory.UseSpecificInvObject(InvObject._E_DRUG_NEURALHEALTH);
            if (nKeyCode == EGameControl.USE_ITEM_BINOCULARS) 
                player.cInventory.UseSpecificInvObject(InvObject._E_BINOCULARS);
            
/* do testow - MZM
			
			// wcisniecie L
            if (nKeyCode == EKey._L)
            {
				GetHUDTimer().Activate();
			}

			// wcisniecie L
            if (nKeyCode == EKey._L)
            {
				if (!m_bActivateAllowed)
				{
					m_bActivateAllowed = !m_bActivateAllowed;
					UnhideAll();
				}
				else
				{
					HideAll();
					m_bActivateAllowed = !m_bActivateAllowed;
				}
			}
            // wcisniecie O
            if (nKeyCode == EKey._O)
            {
				if (GetHudUniversal().bActiveFlag)
					GetHudUniversal().DeactivateSlow();
				else
					GetHudUniversal().ActivateSlow();
			}
*/			
            /* wcisniecie SPACE
            if ((nKeyCode==EKey._SPACE) && (aHUDComponent[_HUD_STATS]!=null))
            {
                if (aHUDComponent[_HUD_STATS].bActiveFlag)
                {
                    aHUDComponent[_HUD_STATS].Deactivate();
                }
            }
            */
            
            
            // TYMACZASOWE KLAWISZE DO MIESZANIA W ZDROWIU GRACZA 
/*          
            if ((nKeyCode==EKey._H) )
            {
                CrashLog("Zdrowie max gracza : "+ player.fMaxHealth+"\n");
            }
            
            if ((nKeyCode==EKey._L) )
            {
                
                player.fHealth+=10.0f;
                CrashLog("Zdrowie gracza : "+ player.fHealth+"\n");
                ((HUDCompPlayer)(aHUDComponent[_PLAYER_DATA])).SetTextHealth(player.fHealth);
            }
            
            if ((nKeyCode==EKey._J) )
            {
                
                player.fHealth-=10.0f;
                CrashLog("Zdrowie gracza : "+ player.fHealth+"\n");
                ((HUDCompPlayer)(aHUDComponent[_PLAYER_DATA])).SetTextHealth(player.fHealth);
            }
            
            if ((nKeyCode==EKey._K) )
            {
                
                player.fHealth=player.fMaxHealth;
                CrashLog("Zdrowie gracza : "+ player.fHealth+"\n");
                ((HUDCompPlayer)(aHUDComponent[_PLAYER_DATA])).SetTextHealth(player.fHealth);
            }
            
            if ((nKeyCode==EKey._P) )
            {
                
                player.fHealth=1.0f;
                CrashLog("Zdrowie gracza : "+ player.fHealth+"\n");
                ((HUDCompPlayer)(aHUDComponent[_PLAYER_DATA])).SetTextHealth(player.fHealth);
            }

            // TYMACZASOWE KLAWISZE DO MIESZANIA W ZDROWIU GRACZA :)
  */  
        }
    }

	void CloseGetInventory()
	{
        if ( ((HUDCompInvPl)aHUDComponent[_HUD_INV_PLAYER]).AIActive )   
        {
            ((PlayerTriggered)player).ActiveTrigger = null;
            GetHUDPlayer().cActiveTriggerFrames.HideTriggerFrames();
            ((HUDCompInvPl)aHUDComponent[_HUD_INV_PLAYER]).Deactivate();
            ((HUDCompInvPl)aHUDComponent[_HUD_INV_PLAYER]).cAIInventory.Owner.bIsCorpseActive = false;    
            
        }
	}

    //----------------------------------------------------------------------
    /** metoda dodaje do konsoli text
     */	
    public void AddConsText(String text)
    {
		LogD("AddConsText "+text);
        try
        {
            ((HUDConsole)(aHUDComponent[_HUD_CONSOLE])).AddText(text);
        } catch (Exception ex)
        {
            Log("[HUDManager.AddConsText] : ERROR Cast \n");	
        }
    }
    
    /** metoda dodaje do konsoli text
     */	
    public void AddLogsText(String sText,Vector vColor)
    {
        if ( GetHUDLogs() != null )
            GetHUDLogs().InputText(sText,vColor);
    }
    
    //----------------------------------------------------------------------	
    /** metoda updatuje pozycje gridow z inventory w grze
     */
    void UpdateGridGamePos()
    {
        if (m_bDisableInNetGame)
            return;
        
        HUDCompInvPl hud_inv_game = ((HUDCompInvPl)(aHUDComponent[_HUD_INV_PLAYER]));
        
        Vector Grid_inv = new Vector(hud_inv_game.cInvGridSprite.GetPos());
        Vector Spr_size = new Vector(hud_inv_game.cInvGridSprite.GetSize());
        //Log("--pos_x = "+Grid_inv.fX+" pos_y="+Grid_inv.fY+"\n");
        //Log("--size_x = "+Spr_size.fX+" size_y="+Spr_size.fY+"\n");
        
        for (int i=0;i<cPlayerInv.aInvGrids.length; i++)
        {
            cPlayerInv.aInvGrids[i].UpdateInventoryGridsPos(i, (int)Grid_inv.fX, (int)Grid_inv.fY, hud_inv_game);
        }   
    }
	
    
    
    void MoveTopAll()
    {
        for (int i = 0; i < aHUDComponent.length; i++)
        {
            if (aHUDComponent[i] != null)
                aHUDComponent[i].MoveTop();
        }
    }
    
    /**
     * Metoda wykorzystywana w sieci przy spawnie gracza
     */
    public void Show()
    {
        m_bActivateAllowed = true;
        m_bIsUserHUDActive = false;
                
        if (aHUDComponent[_HUD_COMPASS] != null )
        {
		    aHUDComponent[_HUD_COMPASS].Activate();
            aHUDComponent[_HUD_COMPASS].MoveTop();
        }
        if (aHUDComponent[_PLAYER_DATA] != null )
        {
		    aHUDComponent[_PLAYER_DATA].Activate();
            aHUDComponent[_PLAYER_DATA].MoveTop();
        }
        if (aHUDComponent[_HUD_IMPLANT_INDICATORS] != null)
        {
            aHUDComponent[_HUD_IMPLANT_INDICATORS].Activate();
            aHUDComponent[_HUD_IMPLANT_INDICATORS].MoveTop();
        }
        if (aHUDComponent[_CROSSHAIR] != null )
        {
            aHUDComponent[_CROSSHAIR].Activate();
            aHUDComponent[_CROSSHAIR].MoveTop();
        }
        if (aHUDComponent[_HUD_CONSOLE] != null )
        {
            aHUDComponent[_HUD_CONSOLE].Activate();
            aHUDComponent[_HUD_CONSOLE].MoveTop();
        }
        if (aHUDComponent[_HUD_LOGS] != null )
            aHUDComponent[_HUD_LOGS].MoveTop();
        RegisterKeyRequestIfNeeded();
    }
    
    /**
     * Metoda wykorzystywana w sieci przy smierci gracza
     */
    public void Hide()
    {
        if (aHUDComponent[_HUD_IMPL_MENU] != null &&
		    aHUDComponent[_HUD_IMPL_MENU].bActiveFlag)
        {
            aHUDComponent[_HUD_IMPL_MENU].Deactivate();
			// wlaczamy mysz w graczu
			player.MouseAcquire();
        }
        if (aHUDComponent[_HUD_INV_PLAYER] != null &&
            aHUDComponent[_HUD_INV_PLAYER].bActiveFlag)
        {
            aHUDComponent[_HUD_INV_PLAYER].Deactivate();
            // wlaczamy mysz w graczu
			player.MouseAcquire();
        }
        
        if (aHUDComponent[_CROSSHAIR] != null )
            aHUDComponent[_CROSSHAIR].Deactivate();
        if (aHUDComponent[_HUD_COMPASS] != null )
		    aHUDComponent[_HUD_COMPASS].Deactivate();
        if (aHUDComponent[_PLAYER_DATA] != null )
		    aHUDComponent[_PLAYER_DATA].Deactivate();
        if (aHUDComponent[_HUD_IMPLANT_INDICATORS] != null )
            aHUDComponent[_HUD_IMPLANT_INDICATORS].Deactivate();
        if (aHUDComponent[_HUD_CONSOLE] != null )
            aHUDComponent[_HUD_CONSOLE].Deactivate();
        //w sieci logi moga byc wydoczne zawsze
        if (aHUDComponent[_HUD_LOGS] != null )
            aHUDComponent[_HUD_LOGS].Deactivate();
        if (GetHUDHack() != null)
            GetHUDHack().Deactivate();
        if (GetHudUniversal() != null )
			GetHudUniversal().Deactivate();
        
        m_bActivateAllowed = false;
        m_bIsUserHUDActive = true;
        UnregisterKeyRequest();
        UnregisterMouseButtonRequest();
        UnregisterMouseAxisRequest();
    }
        
	public void SwitchImplantMenu()
	{
        if (aHUDComponent[_HUD_IMPL_MENU] != null)
		{
			if (!aHUDComponent[_HUD_IMPL_MENU].bActiveFlag && m_bActivateAllowed)
			{
        		// probujemy aktywowac
			    aHUDComponent[_HUD_IMPL_MENU].ActivateSlow();
			}
			else
			{
			    aHUDComponent[_HUD_IMPL_MENU].DeactivateSlow();
			}
		}
    }
    
    boolean CanOperateImplants()
    {
        if (GetModule() instanceof ChromeModuleSingle)
            return ((ChromeModuleSingle)GetModule()).m_bImplantsAvailable;
        else
            return _IMPLANTS_AVAILABLE_IN_NET_GAME;
    }
    
    void ToggleImplant(int n)
    {
        //HACK niestety inaczej sie nie da :(  ImplantHack nie mozna wlaczyc, on sie 
        //aktywuje automatycznie, ladujemy go zawsze jako pierwszego wiec nie powinno
        //sie jebac
        n++;

        if (!CanOperateImplants())
            return;
        
        if (!player.IsImplantDisabled(n))
        {
            if (player.IsImplantActive(n))
                DeactivateImplant(n);
            else
                ActivateImplant(n);
                
            // wyslanie komunikatu do modulu ze gracz uzyl implanow
            if (GetModule() instanceof ChromeModuleSingle)
                ((ChromeModuleSingle) GetModule()).MessageToHints( HintManager._MSG_IMPLANTSUSED );
        }
        else
        {
            if (GetModule() instanceof ChromeModuleSingle)
                AddConsText("&IMPLANT& " + player.GetImplantSystem().GetImplant(n).m_sName +
                        " &IS_STILL_DISABLED&");
        }
    }
    
    void ActivateImplant(int nImplant)
    {
        if (player.GetImplantSystem().CanActivateImplants())
        {   
            if (nImplant == ImplantSystem._IMPLANT_TERMOVISION_SYSTEM && 
                player.cBinoculars != null)
                return;
                
            AddConsText("&IMPLANT& " + player.GetImplantSystem().GetImplant(nImplant).m_sName +
                        " &ACTIVATED&");
            player.ActionImplantOn(nImplant);
            RefreshImplantsIndicators();
        }
    }

    void DeactivateImplant(int nImplant)
    {
        AddConsText("&IMPLANT& " + player.GetImplantSystem().GetImplant(nImplant).m_sName + 
                    " &DEACTIVATED&");
        player.ActionImplantOff(nImplant);
        RefreshImplantsIndicators();
    }
    
    void RefreshImplantsIndicators()
    {
        GetHUDImplantIndicators().SetActiveImplants(player.GetImplantSystem().GetImplants());
        if (GetHUDImplant().bActiveFlag)
            GetHUDImplant().UpdateImplantsStates();
    }
    
	void ShowHitAssassinPlace(Vector vAssassinPos)
	{
		if (m_HitIndicators == null)
			return;
		m_HitIndicators.Hit(vAssassinPos);
	}
    
    void RegisterKeyRequestIfNeeded()
    {
        if (GetModule() instanceof ModuleNet)
		{
			if ( player != null && player.bNetIsOwner )
            {
	            RegisterKeyRequest();
                RegisterMouseButtonRequest();
                RegisterMouseAxisRequest();
            }
		}
		else
        {
            RegisterKeyRequest();
            RegisterMouseButtonRequest();
            RegisterMouseAxisRequest();
        }
    }
    
    void SwitchHudMap()
    {
        ActivateHudMap( !aHUDComponent[_HUD_MAP].bActiveFlag );
    }
    
    void ActivateHudMap(boolean bActivate)
    {
        if ( aHUDComponent[_HUD_MAP].bActiveFlag == bActivate )
            return;
        
        if (aHUDComponent[_HUD_MAP].bActiveFlag)
	    {
	        aHUDComponent[_HUD_MAP].DeactivateSlow();
	        // wlaczamy mysz w graczu
	    	player.MouseAcquire();
	    }
	    else
	    {
	        aHUDComponent[_HUD_MAP].ActivateSlow();
	        if (aHUDComponent[_HUD_MAP].bActiveFlag)
	    	{
	            // udalo sie aktywowac, wylaczamy mysz w graczu
                player.MouseUnacquire(false);
	    	}
	    					    
	        // wyslanie komunikatu do modulu ze gracz uzyl juz mapy
	        if ( GetModule() instanceof ChromeModuleSingle )
	        {
	            ((ChromeModuleSingle)GetModule()).MessageToHints( HintManager._MSG_MAPUSED );
	        }
	    }    
    }

    /**
     * Wlaczenie wylaczenie huda z logami
     */
    void SwitchHudLogs()
    {
        if (aHUDComponent[_HUD_LOGS] == null)
            return;
        if (aHUDComponent[_HUD_LOGS].bActiveFlag)
            aHUDComponent[_HUD_LOGS].DeactivateSlow();
        else
            aHUDComponent[_HUD_LOGS].ActivateSlow();
    }

    //---------------- updejtowanie HUDUniversal energia podanego aktora
    
    private ChromeActor cActorHUDUniversal1 = null,
                        cActorHUDUniversal2 = null;

    void SetUniversalHUDActor(ChromeActor actor, String sComment, float fMaxValue, float fValueShift)
    {
        if (m_bDisableInNetGame)
            return;
        
        HUDUniversal cHud = GetHudUniversal();
        if (actor == cActorHUDUniversal1 || 
            actor == cActorHUDUniversal2)
        {
            Tools.CrashLogWarning("HUDManager.SetUniversalHUDActor " + actor + " was already added");
            return;
        }
        if (actor instanceof NewAI)
        {
            cActorHUDUniversal1 = actor;
            if (sComment == null)
                sComment = Text.Get("&HUD_ENEMY_HEALTH&");
            cHud.SetDescription1(TextToUpperCase(sComment));
            cHud.SetMaxValue1(fMaxValue);
            cHud.SetValueShift1(fValueShift);
        }
        else
            if (actor instanceof Vehicle)
            {
                cActorHUDUniversal2 = actor;
                if (sComment == null)
                    sComment = Text.Get("&HUD_VEHICLE_HEALTH&");
                cHud.SetDescription2(TextToUpperCase(sComment));
                cHud.SetMaxValue2(fMaxValue);
                cHud.SetValueShift2(fValueShift);
            }
            else
            {
                Tools.CrashLogError("nieznana klasa chromeactora dla HUDUniversal");
                printStackTrace("");
            }
        
        DisableCallMethod("UpdateHUDUniversal");

        if(cActorHUDUniversal1 != null || cActorHUDUniversal2 != null)
        {
            UpdateHUDUniversal();
            CallMethodEvery("UpdateHUDUniversal", 0.2f);
        }
    }
    
    void ClearUniversalHUDActor(ChromeActor actor)
    {
        HUDUniversal cHud = GetHudUniversal();
        if (cActorHUDUniversal1 == actor)
        {
            cActorHUDUniversal1 = null;
            cHud.Hide1();
        }
        else
            if (cActorHUDUniversal2 == actor)
            {
                cActorHUDUniversal2 = null;
                cHud.Hide2();
            }
        
        DisableCallMethod("UpdateHUDUniversal");

        if(cActorHUDUniversal1 != null || cActorHUDUniversal2 != null)
        {
            UpdateHUDUniversal();
            CallMethodEvery("UpdateHUDUniversal", 0.2f);
        }
    }
    
    void UpdateHUDUniversal()
    {
        if (!m_bActivateAllowed)
            return;
        
        HUDUniversal cUniv = GetHudUniversal();
        if(cActorHUDUniversal1 == null && cActorHUDUniversal2 == null) 
        {
            cUniv.Hide1();
            cUniv.Hide2();
            return;
        }
        
        if (cActorHUDUniversal1 != null)
        {
            cUniv.SetValue1(cActorHUDUniversal1.fHealth);
            cUniv.Show1();
        }
        else
            cUniv.Hide1();
        
        if (cActorHUDUniversal2 != null)
        {
            cUniv.SetValue2(cActorHUDUniversal2.fHealth);
            if ( m_bModuleNet )
                cUniv.SetVehiclePassengers( (Vehicle)cActorHUDUniversal2 );
            cUniv.Show2();
        }
        else
            cUniv.Hide2();
    }
    
    void TermovisionOn()
    {
        MoveTopAll();
        //HideAll();
        //ActivateDefaultHUDs();
        //GetHUDObjDetector().Deactivate();
        //DisallowActivate();
    }
    
    void TermovisionOff()
    {
        //AllowActivate();
        //GetHUDObjDetector().Activate();
        //UnhideAll();
    }
    
	Vector m_vLastCursorPos = null;
    void HudMenuActivated(int nMenu)
    {
        if (m_nActiveHudMenu != -1)
            aHUDComponent[m_nActiveHudMenu].Deactivate();
        if (nMenu == _HUD_HACK || nMenu == _HUD_TIMER || nMenu == _HUD_UNIVERSAL)
        {
            DisallowActivate();
            if(GetHUDCrossHair()!=null)
                GetHUDCrossHair().Deactivate();
        }
        m_nActiveHudMenu = nMenu;
        // wylaczamy mysz w graczu
        player.MouseUnacquire(false) ;
        HintsMoveTop();
        if (!m_bDisableInNetGame)
        {
            if (m_vLastCursorPos == null)
                m_vLastCursorPos = new Vector(GetScreenWidth()/2f, GetScreenHeight()/2f, 0);
            aHUDComponent[m_nActiveHudMenu].SetCursorPos(m_vLastCursorPos);
        }
    }
	
    void HudMenuDeactivated(int nMenu)
    {
        Vector vCursorPos = aHUDComponent[m_nActiveHudMenu].GetCursorPos();
        if (vCursorPos != null && m_vLastCursorPos != null && !m_bDisableInNetGame)
            m_vLastCursorPos.Set(vCursorPos);
        
        if (nMenu == _HUD_INV_PLAYER && GetModule() instanceof Level00)
            ((Level00)GetModule()).InventoryTurnedOff();
        
        m_nActiveHudMenu = -1;
        
        //if (!IsPlayerInVehicle())
        {
            // wlaczamy mysz w graczu
	    player.MouseAcquire();   
        }
       // else
        {
            //wlaczamy mysz dla kamery, bo gracz ma sie dalej nie ruszac
            //player.MouseAcquireCamera();
        }
        
        if (nMenu == _HUD_HACK || nMenu == _HUD_TIMER || nMenu == _HUD_UNIVERSAL)
        {
            AllowActivate();
            if(GetHUDCrossHair()!=null)
                GetHUDCrossHair().Activate();
        }
    }
    
    int GetActiveHudMenu()
    {
        return m_nActiveHudMenu;
    }
    
    void DeactivateCurMenu()
    {
        if (m_nActiveHudMenu != -1 && aHUDComponent[m_nActiveHudMenu] != null &&
            m_nActiveHudMenu != _HUD_HACK)
        {
            aHUDComponent[m_nActiveHudMenu].Deactivate();
            m_nActiveHudMenu = -1;
        }
    }
    
    /**sprawdza, czy dany hud jest typu menu, tzn. wl/wyl przez gracza*/
    boolean IsHudMenu(int nHud)
    {
        return (nHud == _HUD_MAP ||
                nHud == _HUD_INV_PLAYER ||
                nHud == _HUD_IMPL_MENU ||
                nHud == _HUD_LOGS ||
                nHud == _HUD_HACK);
    }
    
    boolean IsHudZoomer(int nHud)
    {
        return (nHud == _HUD_SNIPER ||
                nHud == _HUD_BINOCULARS);
    }
    
    boolean IsPlayerInVehicle()
    {
        return (player != null && player.cSeatInfo != null);
    }
    
    
    ChromeInventoryMenu GetInventoryMenu()
    {
        return m_cInvMenu;
    }
    
    void SetInventoryMenu(ChromeInventoryMenu cMenu)
    {
        m_cInvMenu = cMenu;
    }
	//*********************************************************
	//					SaveGame
    //*********************************************************
    
    /** Metoda wczytujaca zapisane dane w Save gracza
     */	
    public void SGLoadChunk(FileChunk cParentFC)
    {	
		FileChunk.Log("[HUDManager.SGLoadChunk]\n");
		
		FileChunk cFC = GameObject.LoadChunk(cParentFC);   
		
        if (cFC.GetID() == ESGChunksChrome._CHK_HUD_MANAGER)
        {
			super.SGLoadChunk(cFC);
			
	
			for (int i=0; i < nHUDArraySize; i++)
			{
				if (cFC.LoadBool())
				{
					String sClass = cFC.LoadString();
						
					if (aHUDComponent[i] == null)
					{
						aHUDComponent[i] = (HUDComponent)CreateObject(sClass);
						if (player instanceof PlayerHUD)
							aHUDComponent[i].SetParams((PlayerHUD)player,this);
					}
						
					aHUDComponent[i].SGLoadChunk(cFC);
				}
				else
					aHUDComponent[i] = null;
			}			
		
            if (cActorHUDUniversal1 != null)
                ClearUniversalHUDActor(cActorHUDUniversal1);
            if (cActorHUDUniversal2 != null)
                ClearUniversalHUDActor(cActorHUDUniversal2);
            
            if (cFC.LoadBool())
            {
                SetUniversalHUDActor((ChromeActor)cFC.LoadObjectRef(),
                                     cFC.LoadString(),
                                     cFC.LoadFloat(),
                                     cFC.LoadFloat());
            }
            if (cFC.LoadBool())
            {
                SetUniversalHUDActor((ChromeActor)cFC.LoadObjectRef(),
                                     cFC.LoadString(),
                                     cFC.LoadFloat(),
                                     cFC.LoadFloat());
            }
			
			// hud z logami - Nie komentowa bo zabij !!!
			aHUDComponent[_HUD_LOGS].SGLoadChunk(cFC);							
            
			// HUD detektora obiektow
			aHUDComponent[_HUD_OBJ_DETECT].SGLoadChunk(cFC);				
			
            m_HitIndicators.SGLoadChunk(cFC);
			/*
			// laduje huda z statystykami
			aHUDComponent[_HUD_STATS].SGLoadChunk(cFC);
			// laduje hud'a z gadajaca glowa
			aHUDComponent[_NIUNIA].SGLoadChunk(cFC);	
			aHUDComponent[_HUD_MAP].SGLoadChunk(cFC);
			aHUDComponent[_HUD_COMPASS].SGLoadChunk(cFC);
			aHUDComponent[_NIUNIA].SGLoadChunk(cFC);	
			*/
        }
		
		cFC.delete();
		
		FileChunk.Log("[HUDManager.SGLoadChunk] - END\n");
	}
    
    /** Metoda zapisujaca dane do Save gracza
     */	
    public void SGSaveChunk(FileChunk cFCParent)
    {
		FileChunk.Log("[HUDManager.SGSaveChunk]\n");
		
        FileChunk cFC = NewChunk(ESGChunksChrome._CHK_HUD_MANAGER, cFCParent);
		
		super.SGSaveChunk(cFC);
		
		for (int i=0; i < nHUDArraySize; i++)
		{
			cFC.SaveBool(aHUDComponent[i] != null);
			
			if (aHUDComponent[i] != null)
			{
				cFC.SaveString(aHUDComponent[i].getClass().getName());					
				aHUDComponent[i].SGSaveChunk(cFC);
			}
		}
        
        HUDUniversal cHud = GetHudUniversal();
        if (cActorHUDUniversal1 != null)
        {
            cFC.SaveBool(true);
            cFC.SaveObjectRef(cActorHUDUniversal1);
            cFC.SaveString(cHud.m_sDescTxt1);
            cFC.SaveFloat(cHud.m_fMaxValue1);
            cFC.SaveFloat(cHud.m_fValueShift1);
        }
        else
        {
            cFC.SaveBool(false);
        }
        
        if (cActorHUDUniversal2 != null)
        {
            cFC.SaveBool(true);
            cFC.SaveObjectRef(cActorHUDUniversal2);
            cFC.SaveString(cHud.m_sDescTxt2);
            cFC.SaveFloat(cHud.m_fMaxValue2);
            cFC.SaveFloat(cHud.m_fValueShift2);
        }
        else
        {
            cFC.SaveBool(false);
        }
		
		// hud z logami - Nie komentowa bo zabij !!!
		aHUDComponent[_HUD_LOGS].SGSaveChunk(cFC);	
		
		// HUD detektora obiektow
		aHUDComponent[_HUD_OBJ_DETECT].SGSaveChunk(cFC);		
		
        m_HitIndicators.SGSaveChunk(cFC);
		/*
		// laduje huda z statystykami
        aHUDComponent[_HUD_STATS].SGSaveChunk(cFC);
		// laduje hud'a z gadajaca glowa
        aHUDComponent[_NIUNIA].SGSaveChunk(cFC);		
		aHUDComponent[_HUD_MAP].SGSaveChunk(cFC);
		aHUDComponent[_HUD_COMPASS].SGSaveChunk(cFC);
		aHUDComponent[_NIUNIA].SGSaveChunk(cFC);		
		*/
		
		        
		cFC.delete(); 
	}						
	
	public void SGUpdate()
	{
        m_bIsUserHUDActive = false;
		m_bActivateAllowed = true;
		m_bActivateBinocularsOnly = false;
		aActiveHUD = null;
		s_fWheelTime = 0;
	    for (int i = 0; i < aHUDComponent.length; i++)
        {
            if (aHUDComponent[i] != null)
                aHUDComponent[i].SGUpdate();
        }
		if (m_HitIndicators != null)
			m_HitIndicators.SGUpdate();
        ActivateDefaultHUDs();

		GetHUDPlayer().cActiveTriggerFrames.HideTriggerFrames();
		GetHUDPlayer().UpdateActiveTrigger();
    }
}
