/** HUD sluzacy do wyswietlania statystyk po misji
 */
public class HUDStatistics extends HUDComponent
{
    // muzyka odgrywana podczas huda
    Music cEndMusic = null;
    
    UIStatic m_cTitle = null;
    UIStatic m_cInfo = null;
        
    /** flaga mowiaca czy player zostal zakillowany */
    public boolean bPlayerDied = false;

    /** text-status ukonczonej misji (MissionSuccesfull / MissionFailed) */
    String sMissionStatusTxt = "&MISSION_SUCCESS&";
    
    public void OnInit()
    {
        super.OnInit();
        m_cTitle = (UIStatic)GetElem("ID_TITLE");
        m_cInfo = (UIStatic)GetElem("ID_TEXT");
    }

	public void OnCreate()
	{
		super.OnCreate();   
		
        Load(GetModule(), "data/hud/HUDEnd.scr", false);
        
		bSG = false;

		PositionHUDComponent(0, 0);
    }
	
    /** metoda aktywujaca HUda
     */
    public void Activate()
    {
        super.Activate();   
        
        if(cEndMusic != null)
        {
            if(Music.cPlayingMusic != null) Music.cPlayingMusic.ForceStop();
            cEndMusic.Start();
        }
        
        Draw();
    }
	
    /** metoda deaktywujaca Huda
     */
    public void Deactivate()
    {
        super.Deactivate();
		
        bPlayerDied = false;
        
        if(cEndMusic != null)
            cEndMusic.Stop();
    }
	
    /** metoda rysujaca wszytkie komponenty tego HUDa
     */
    public void DrawDo()
    {
        Show();
    }
	

    
    
    /** Metoda ustawia flage mission Succesfull
     */
    void SetMissionSuccesful(String sComment, Music endMusic)
    {
        cEndMusic = endMusic;
        
        sMissionStatusTxt = "&MISSION_SUCCESS&";
        m_cTitle.SetText(Text.Get(sMissionStatusTxt));
        m_cInfo.SetText(Text.Get(sComment));
    }
	
    /** Metoda ustawia flage mission Succesfull na FALSE
     */
    void SetMissionFailed(boolean dead, String sComment, Music endMusic)
    {
        if (dead) 
			bPlayerDied = true;   
        
        cEndMusic = endMusic;
        
        sMissionStatusTxt = "&MISSION_FAILED&";
        m_cTitle.SetText(Text.Get(sMissionStatusTxt));
        m_cInfo.SetText(Text.Get(sComment));
    }
	
    /** Metoda ustawia flage mission Succesfull
     */
    void SetMissionToBeContinue(String sComment, Music endMusic)
    {
        cEndMusic = endMusic;
        sMissionStatusTxt = "&MISSION_TO_BE_CONTINUE&";
        m_cTitle.SetText(Text.Get(sMissionStatusTxt));
        m_cInfo.SetText(Text.Get(sComment));
    }
	
	public void PositionHUDComponent(int relX, int relY)
	{
		super.PositionHUDComponent(relX, relY);
        Vector vPos = new Vector(GetScreenWidth() / 2f - GetSize().fX / 2f,
                                 GetScreenHeight() / 2f - GetSize().fY / 2f,
                                 0);
        SetPos(vPos);
	}
	
    //*********************************************************
	//					SaveGame
    //*********************************************************
	
    /** Metoda wczytujaca zapisane dane w Save gracza
     */	
    public void SGLoadChunk(FileChunk cParentFC)
    {	
		FileChunk.Log("[HUDStatistics.SGLoadChunk]\n");
		
		FileChunk cFC = GameObject.LoadChunk(cParentFC);   
		
        if (cFC.GetID() == ESGChunksChrome._CHK_HUD_STATISTICS)
        {	
			super.SGLoadChunk(cFC);		
			
			bPlayerDied = cFC.LoadBool();
        }
		
		cFC.delete();
    }
    
    /** Metoda zapisujaca dane do Save gracza
     */	
    public void SGSaveChunk(FileChunk cFCParent)
    {
		FileChunk.Log("[HUDStatistics.SGSaveChunk]\n");
		
        FileChunk cFC = NewChunk(ESGChunksChrome._CHK_HUD_STATISTICS, cFCParent);
		
		super.SGSaveChunk(cFC);
		
		cFC.SaveBool(bPlayerDied);
		        
        cFC.delete();
    }			
}
