/** hud uzywany przy jezdzie pojazdami, walce z bosami itp.
 */
public class HUDUniversal extends HUDComponent
{
    /** teksty sprite'ow */
	String m_sDescTxt1 = "";
	String m_sDescTxt2 = "";
	String m_sMoreInfoTxt2 = "";
    
    /** maksymalne wartosci paskow */
	float m_fMaxValue1 = 1f;
	float m_fMaxValue2 = 1f;
	
    float m_fValueShift1 = 0;
    float m_fValueShift2 = 0;
	/** biezace wartosci paskow */
	float m_fCurrValue1 = 0;
    float m_fCurrValue2 = 0;
	
    UIWindow    m_cProgress1 = null, 
                m_cProgress2 = null,
                m_cDialog    = null,
                m_cDemoOKDialog = null;
                
    UIStatic    m_cTitle1 = null, 
                m_cTitle2 = null,
                m_cNumber1 = null, 
                m_cNumber2 = null,
                m_cMoreInfo2 = null;
    
    boolean m_bRestoreComponent = false;
    
    public void OnInit()
    {
        super.OnInit();
        m_cProgress1 = GetElem("ID_PROGRESS_1");
        m_cProgress2 = GetElem("ID_PROGRESS_2");
        m_cNumber1 = (UIStatic)m_cProgress1.GetElem("ID_NUMBER");
        m_cNumber2 = (UIStatic)m_cProgress2.GetElem("ID_NUMBER");
        m_cTitle1 = (UIStatic)m_cProgress1.GetElem("ID_TITLE");
        m_cTitle2 = (UIStatic)m_cProgress2.GetElem("ID_TITLE");
        m_cMoreInfo2 = (UIStatic)m_cProgress2.GetElem("ID_MORE_INFO");
        m_cMoreInfo2.SetText("");
        m_cProgress1.Hide();
        m_cProgress2.Hide();
        m_cDialog = (UIWindow)GetElem("ID_DIALOG");
        m_cDialog.Hide();
        m_cDemoOKDialog = (UIWindow)GetElem("ID_DEMO_OK_DIALOG");
        m_cDemoOKDialog.Hide();
        
    }
        
    
    public void OnCreate()
    {
        super.OnCreate();
        
        if (!m_bDisableInNetGame)
        {
            // inicjalizcja kursora
            cCursor = (Cursor) CreateObject("Cursor");
            cCursor.SetCursorTex(cModule, sCursorTex);
            cCursor.Hide();
            Load(GetModule(), "data/hud/HUDUniversal.scr", false);
        }
    }
    
	
    /** metoda aktywujaca HUD'a
     */
    public void Activate()
    {
		if (bActiveFlag)
			return;
		if (!cHUDManager.m_bActivateAllowed)
			return;

        super.Activate();
		
        Draw();

	}

    /** metoda aktywujaca HUD'a
     */
    public void ActivateSlow()
    {
		if (bActiveFlag)
			return;
		if (!cHUDManager.m_bActivateAllowed)
			return;
		
        super.Activate();
		
        Draw();
		
    }

	public void ComponentMoved()
	{
		if (!bActiveFlag)
			HideAll();
	}

    /** metoda deaktywujaca HUD'a
     */
    public void Deactivate()
    {
		if (!bActiveFlag)
			return;

        if (m_cDialog.IsActuallyVisible())
        {
            HideDialog();
        }
        else
        {
            if (m_cDemoOKDialog.IsActuallyVisible())
            {
                HideDemoOKDialog();
            }
            else
            {
                super.Deactivate();
    
	    	    HideAll();
                cCursor.Hide();
            }
        }
    }

	public void DeactivateSlow()
	{
        Deactivate();   
	}
	
    /** metoda rysujaca na ekranie HUD'a
     */
    public void DrawDo()
    {
		if (bActiveFlag)
		{
            Show();
		}
    }

    GameObject m_cDialogCallBack = null;
    String  m_sDialogCallBackMethodOk = null, 
            m_sDialogCallBackMethodCancel = null;
    
    void ShowDialog(GameObject cCallBack, String sMethodOk, String sMethodCancel)
    {
        if (m_cDialog.IsActuallyVisible())
        {
            if (cCallBack != m_cDialogCallBack ||
                sMethodOk != m_sDialogCallBackMethodOk ||
                m_sDialogCallBackMethodCancel != sMethodCancel)
                
                HideDialog();
            else
                return;
        }
        ((UIButton)m_cDemoOKDialog.GetElem("ID_OK")).SetFocus(true);
        m_cDialogCallBack = cCallBack;
        m_sDialogCallBackMethodOk = sMethodOk;
        m_sDialogCallBackMethodCancel = sMethodCancel;
        cCursor.Show();
		cCursor.MoveTop();
        m_cDialog.Show();
        cHUDManager.HudMenuActivated(HUDManager._HUD_UNIVERSAL);
    }
   
    void HideDialog()
    {
        if (m_cDialog.IsActuallyVisible())
        {
            m_cDialog.Hide();
            cCursor.Hide();
            cHUDManager.HudMenuDeactivated(HUDManager._HUD_UNIVERSAL);
        }
    }
    
    void ShowDemoOKDialog(String sInfo)
    {
        if (m_cDemoOKDialog.IsActuallyVisible())
            HideDemoOKDialog();
        
        if (!bActiveFlag)
            Activate();
        
        if (!IsVisible())
            Show();
            
        
        m_cDialogCallBack = null;
        m_sDialogCallBackMethodOk = null;
        ((UIStatic)m_cDemoOKDialog.GetElem("ID_INFO")).SetText(sInfo);
        ((UIButton)m_cDemoOKDialog.GetElem("ID_OK")).SetFocus(true);
        cCursor.Show();
		cCursor.MoveTop();
        m_cDemoOKDialog.Show();
        cHUDManager.HudMenuActivated(HUDManager._HUD_UNIVERSAL);
    }
    
    void HideDemoOKDialog()
    {
        if (m_cDemoOKDialog.IsVisible())
        {
            m_cDemoOKDialog.Hide();
            cCursor.Hide();
            cHUDManager.HudMenuDeactivated(HUDManager._HUD_UNIVERSAL);
        }
    }
    
    void OnUICommand(UIWindow cSender, int nCommand)
	{
		super.OnUICommand(cSender,nCommand);
		
		if(nCommand == EUIConst.CM_CLICK || nCommand == EUIConst.CM_DBCLICK)
        {
            if (cSender.m_sId.equals("ID_OK"))
            {
		    	HideDialog();
                HideDemoOKDialog();
                if (m_cDialogCallBack != null &&
                    m_sDialogCallBackMethodOk != null)
                    m_cDialogCallBack.CallMethodIn(m_sDialogCallBackMethodOk, 0);
		    }
		
		    if (cSender.m_sId.equals("ID_CANCEL"))
		    {
		    	HideDialog();
                if (m_cDialogCallBack != null &&
                    m_sDialogCallBackMethodCancel != null)
                    m_cDialogCallBack.CallMethodIn(m_sDialogCallBackMethodCancel, 0);
		    }
		
        }
	}
    
    void OnKeyPressed(int nKey, char nAsci)
    {
        if (nKey == EKey._ESCAPE)
        {
            HideDemoOKDialog();
        }
    }
    
    /** ustawienie maksymalnej wartosci dla gornego paska
	 */
	public void SetMaxValue1(float fMaxValue)
	{
		m_fMaxValue1 = fMaxValue;
	}

	/** ustawienie maksymalnej wartosci dla dolnego paska
	 */
	public void SetMaxValue2(float fMaxValue)
	{
		m_fMaxValue2 = fMaxValue;
	}
	
    public void SetValueShift1(float fShift)
    {
        m_fValueShift1 = fShift;
    }
    
    public void SetValueShift2(float fShift)
    {
        m_fValueShift2 = fShift;   
    }
    
	/** ustawienie biezacej wartosci gornego paska
	 */
	public void SetValue1(float fValue)
	{
		float fValueNorm = (fValue + m_fValueShift1) / (m_fMaxValue1 + m_fValueShift1);
        if (fValueNorm < 0)
            fValueNorm = 0;
		int nValueNorm100 = (int)(100f * fValueNorm);

        if (nValueNorm100 == 0 && fValueNorm > 0)
            nValueNorm100 = 1;
        
        m_cNumber1.SetText(String.valueOf(nValueNorm100) + " %");
	}
    
	/** ustawienie biezacej wartosci dolnego paska
	 */
	public void SetValue2(float fValue)
	{
		float fValueNorm = (fValue - m_fValueShift1) / (m_fMaxValue2 - m_fValueShift1);
        
        if (fValueNorm < 0)
            fValueNorm = 0;
		int nValueNorm100 = (int)(100f * fValueNorm);
        
        if (nValueNorm100 == 0 && fValueNorm > 0)
            nValueNorm100 = 1;
        
        m_cNumber2.SetText(String.valueOf(nValueNorm100) + " %");
		
	}
	
	/** ustawienie biezacej wartosci opisu gornego paska
	 */
	public void SetDescription1(String text)
	{
		m_sDescTxt1 = text;
		if (m_sDescTxt1 == null)
			m_sDescTxt1 = "";
		m_cTitle1.SetText(m_sDescTxt1);
	}
		
	/** ustawienie biezacej wartosci opisu dolnego paska
	 */
	public void SetDescription2(String text)
	{
		m_sDescTxt2 = text;
		if (m_sDescTxt2 == null)
			m_sDescTxt2 = "";
		m_cTitle2.SetText(m_sDescTxt2);
	}

    public void SetDescription2Info(String text)
    {
        m_sMoreInfoTxt2 = text;
		if (m_sMoreInfoTxt2 == null)
			m_sMoreInfoTxt2 = "";
		m_cMoreInfo2.SetText(m_sMoreInfoTxt2);
    }
    
    
    void Show1()
    {
        if (!cHUDManager.m_bActivateAllowed || m_bDisableInNetGame)
			return;
        
        if (!bActiveFlag)
            Activate();
        m_cProgress1.Show();
    }
    
    void Show2()
    {
        if (!cHUDManager.m_bActivateAllowed || m_bDisableInNetGame)
			return;
        
        if (!bActiveFlag)
            Activate();
        m_cProgress2.Show();
    }
    
    void Hide1()
    {
        m_cProgress1.Hide();
    }
    
    void Hide2()
    {
        m_cProgress2.Hide();
    }
    
    void SetVehiclePassengers( Vehicle cVehicle )
    {
        if (GetModule() instanceof ChromeModuleSingle)
            return;
        
        String aPassengers = "";
        //bierzemy kolejno: kierowce, pasazera z dzialkiem, pozostalych pasazerow
        for ( int nPassengerRole =  EPassengerRole._MIN; 
                  nPassengerRole <= EPassengerRole._MAX;
              ++  nPassengerRole )
        {
            //pobieramy wszystkich o podanej roli
            Pawn[] aPawns = cVehicle.GetOccupants( nPassengerRole );
            
            //jesli cos znalezlismy to pobieramy ich nicki i dodajemy do wyniku
            if ( aPawns != null && aPawns.length > 0)
            {
                aPassengers += ("  " + EPassengerRole.GetRoleName(nPassengerRole) + "\n");
                for ( int i = 0; i < aPawns.length; ++i )
                {
                    if ( aPawns[ i ] != null )
                    {
                        //poszczegolnych pasazerow oddzielam nowa linia
                        aPassengers = (aPassengers + "      " + aPawns[ i ].GetName() + "\n");
                    }
                }
            }
        }
        
        SetDescription2Info(aPassengers);
    }
    
    String m_aPassengers = null;
    
    public void SGUpdate()
    {
        super.SGUpdate();
        HideDialog();
        HideDemoOKDialog();
    }
    
}
