/** klasa reprezenyujaca obiekt z Inventory gracza, AI i inne obiekty do podnoszenia na terenie
 */
public abstract class InvObject extends ChromeActor
{
    final static int    _W_KNIFE                =   1,
                        _W_PISTOL               =   2, 
                        _W_PISTOL_SILENCED      =   3, 
                        _W_PISTOL_HEAVY         =   4, 
                        _W_RIFLE_SHOTGUN        =   5,
                        _W_RIFLE_SHORT          =   6,
                        _W_RIFLE_SHORT_SILENCED =   7,
                        _W_RIFLE_STANDARD       =   8,
                        _W_RIFLE_SNIPER         =   9,    
                        _W_RIFLE_SNIPER_HEAVY   =  10,  
                        _W_RIFLE_HEAVY          =  11,
                        _W_RIFLE_MACHINE_GUN    =  12,    
                        _W_HEAVY_HEX            =  13,
                        _W_HEAVY_ROCKET_LAUNCHER=  14, 
                        _W_HEAVY_ELECTRO        =  15, 
                        _W_GRENADE              =  16,
                        _W_GRENADE_CLUSTER      =  17,
                        _W_GRENADE_EMP          =  18,//electro-magnetic pulse
                        _W_HAND                 =  19,
                        _W_BINOCULARS           =  20,
                        
        
                        //_E_DRUG_AIM         = 500,
                        _E_DRUG_NEURALHEALTH = 500,
                        _E_DRUG_HEALTH      = 501,
                        //_E_DRUG_POWER       = 502,
                        //_E_DRUG_SPEED       = 503,
                        _E_BINOCULARS       = 504,
                        _E_BOOK             = 505,
                        _E_CDPLAYER         = 506,
                        _E_CHIPSG           = 507,//GARLIC
                        _E_CHIPSO           = 508,//ONION
                        _E_CIGARS           = 509,
                        _E_CIGARSL          = 510,//LIGHT
                        _E_EXPLOSIVE        = 511,
                        _E_KEY              = 512,
                        _E_MP3PLAYER        = 513,
                        _E_NANOCHIP         = 514,
                        _E_POWERCELL        = 515,
                        _E_REDBOX           = 516,
                        _E_TIMEBOMB         = 517,
                        _E_VODKAL           = 518,
                        _E_VODKAS           = 519,
                        _E_W_RACK           = 520,//WeaponRack
                        _E_W_RACK_CTRL      = 521,//WeaponRackController
                        _E_W_BURBOT         = 522,
                        _E_RADIO            = 523,
                        _E_PROXIMITY_MINE   = 524,
                        _E_CLOAKING_DEVICE  = 525,
        
                        _E_NET_CTF_FLAG     = 600,

                        _E_UNIFORM      = 666;
    /** Dzwiek zbierania przedmiotu
     */
    String sTakeObjectSound = "Data/Sounds/InventoryPut.wav";
    
    /**Jesli true, to obiekt nie jest widoczny w inventory*/
    public boolean bHidden = false;
    
    /**Obiekt jest niewidoczny w gridzie, ale mozna go uzyc*/
    public boolean bHiddenButUsable = false;
    
    /**Jesli true to przedmiot nie zabiera miejsca i nie mozna nim manipulowac w inventory*/
    public boolean bMissionCritical = false;//#InvObject
    
    /** Flaga okreslajaca w jaki sposob dodawany jest przedmiot do invetory 
     *  jesli true to wg wartosci pol: nGrid, nCellX, nCellY
     *  jesli false to: patrz opis blizniaczej flagi bNearestCell
     */
    boolean bPlaceAtGivenCells = false;
    
    /** Flaga okreslajaca w jaki sposob dodawany jest przedmiot do invetory 
     *  jesli TRUE to do najblizszej celsy w gridzie , jesli FALSE to do pierwszego wolnego miejsca
     */
    boolean bNearestCell = false;

    /** Flaga ustawiona jesli udalo sie wlozyc obiekt do inventory po zawolaniu Execute.
     * UWAGA: flaga ta ma sensowna wartosc (odpowiadajaca rzeczywistosci) tylko bezposrednio
     * po zrobieniu Execute. Wyrzucenie obiektu nie zeruje jej!!! */
    boolean bJustTakenToInventory = false;
    
    /** Flaga mowi o tym czy mozna wyrzucic z inventory objekt.
     * Wprowadzone dla obiektow niezbednych do misji.
     */
    public boolean bLocked = false;		//#InvObject;Can object be dropped out of inventory
    
    /** Nazwa przedmiotu z inventory */
    protected String sName = "";
    
    /** Opis przedmiotu */
    protected String sInfo = "";
    
    /** Wektor normalny ulozenia przedmiotu na ziemi */
    Vector vUpOnGround = new Vector(0, 1, 0);
    
    /** kto jest wlascicielem tego przedmiotu jesli nikt - lezy na ziemi - to NULL */
    Pawn Owner = null;
    
    /** typ przedmiotu w Inventory */
    int nInvType = EInvObjType._NONE;
    
    /** indeks potrzebny do sortowania przedmiotow w INV */
    int nInvIndex = 0;
    
    /** stan obiektu.  */
    int nInvState = EInvObjState._ONGROUND;
    
    /** Sprite reprezentujacy przedmiot w Inventory */
    SpriteInvObj cInvObjSprite = null;
    int nInvObjSpriteTex = 0;
    
    /** Nazwa i sciezka do tekstury sprite'a */
    String sTexFileName = "Data/Textures/gun1_tex.png";
    
    /**Nazwy dzwiekow odpalanych przy zbieraniu przedmiotow
     */
    String sObjTakenSound = "Data/Sounds/InventoryPut.wav";
    String sObjNotTakenSound = "Data/Sounds/InventoryPutOut.wav";

    
    /** Wspolrzedne na teksturze cela X, cela Y */
    float nOnTexPosX = 0;
    float nOnTexPosY = 0;
    
    /** rozmiary tekstury */
    float nTexSizeX = 256.0f;
    float nTexSizeY = 256.0f;
    
    /** Ilosc kratek zajmowanych w plecaku */
    int nCellsWidth = 3;
    int nCellsHeight = 1;
    
    /** polozenie przedmiotu w plecaku */
    byte nCellX = 0;
    byte nCellY = 0;
    
    /** numer grida w inventory */
    byte nGrid = 0;
    
    /** referencja do inventory w ktorym znajduje sie przedmiot */
    Inventory cInventory = null;

    /** czas ostatniej kolizji z polem silowym (przedmiot rzucony na nie nie powinien odpalac
     * miliona fxow tylko co jakis czas)*/
    float fLastForceFieldCollision  = 0;
    
    /** Znacznik, ze po wyrzuceniu bron ma sie attachowac do parenta Owner'a
     *  - gdy item wyrzucany w czasie jazdy pojazdem
     */
    boolean bAttachToMovingPlatformAfterDrop = true;
    
    
    public void AdjustEllipsoid()
    {
        Vector vMin = new Vector(), vMax = new Vector();
        GetMeshExtents(vMin, vMax);
        Vector vSize = vMax.Sub2(vMin);
        if (vSize.fX > 10)
            vSize.fX = 10;
        SetEllipsoidNoExtents(vSize.fX / 2f, vSize.fY, vSize.fY/2f);
    }

    public void ReplicationInit()
    {
    }
  
    public boolean DeleteIfNotRelevant()
    {
        return false;
    }
    
    /** Replikacja odpowiednich zestawow dla odpowiednich warunkow
     */
    public void OnReplicateServer()
    {
        super.OnReplicateServer();
    }
    
    public void OnReplicateClient()
    {
    }
    
    
    InvObject()
    {
        super();
        Role = ERole._AUTHORITY;
    }

    int METHOD_AnnihilateIfNotUsedDo = 0;
    
    public void OnCreate()
    {
        //ProfileIntervalStart();
        
		bSG = true;
		
        METHOD_AnnihilateIfNotUsedDo = RegisterCallMethod("AnnihilateIfNotUsedDo");
        
        //MK: aaaale super ze tu sie nie wola super.OnCreate()! :-///
        //oczywiscie nie bede teraz robil takich zmian, bo jeszcze z Chrome 
        //wyjdzie nam inna gra ;-) wiec tu rejestruje metode
        METHOD_ShowFromUnderGround = RegisterCallMethod("ShowFromUnderGround");

        ClearFlag(EFlags._BLOCK_MOVE);
        SetFlag(EFlags._PORTAL_INDEPENDENT);
        ClearFlag(EFlags._FXPARTICLE_COLLISION);

        SetLighting(true);        

        // tworze sprite'a
        cInvObjSprite = (SpriteInvObj) CreateObject("SpriteInvObj");
        nInvObjSpriteTex = cInvObjSprite.AddTexture(sTexFileName);
        
        // pobieramy rozmiary tekstury, zeby nie trzeba bylo tego wpisywac
        nTexSizeX = cInvObjSprite.GetTextureWidth(nInvObjSpriteTex);
        nTexSizeY = cInvObjSprite.GetTextureHeight(nInvObjSpriteTex);
        
        cInvObjSprite.SetTexture(nInvObjSpriteTex, new Rect(nOnTexPosX/nTexSizeX,
                                                            nOnTexPosY/nTexSizeY,
                                                           (nOnTexPosX+nCellsWidth*(float)EHudInvParams.GetCellTexWidth())/nTexSizeX,
                                                           (nOnTexPosY+nCellsHeight*(float)EHudInvParams.GetCellTexHeight() )/nTexSizeY ));
        cInvObjSprite.ProcessMouse(false);
        //AddSprite(cInvObjSprite);
        // ustawiam spritowi obiektu referencje do obiektu
        cInvObjSprite.SetInvObj(this);
        // ustalam poczatkowy stan obiektu
        SetInvObjCellsGrid((byte)0, (byte)0, (byte)0);
        
        SetInventory(null);

        SetMass(80.0f);

        //poczatkowo jestesmy na ziemi (domysla wartosc zmiennej nInvState)
        ChangeInvState( null, EInvObjState._ONGROUND);

		bIsActiveTarget = false;
		
/*PP        
        // CLIENT, WLASCICIEL
        if( bNetIsOwner && (Role < ERole._AUTHORITY) )
        {
            ModuleNet cModule = (ModuleNet)GetModule();
            // laduje w inventory gracza bedacego wlasnoscia clienta
            Execute(cModule.cPlayer);
        }
*/      
        //float fDeltaTime = ProfileIntervalEnd();
        //LogR("InvObj.OnCreate.Start="+fDeltaTime+"\n");
        
        //ProfileIntervalStart();
        
        InitOriginalMaterials();
        
        AdjustEllipsoid();
        
        //fDeltaTime = ProfileIntervalEnd();
        //LogR("InvObj.OnCreate.InitOriginalMaterials="+fDeltaTime+"\n");
    }
    
    
//----------------------------------------------------------------------            
    
    /** Metoda sluzy przelaczaniu obiektu na inny level. Nalezy ja pokryc gdy jeden z itemow
     * ma dane zalezace od levlu !
     */
    void Acquire(Module mod, Pawn owner)
    {
        LogD("Acquiring: "+sName+" for "+owner+"\n");
        mod.AcquireObjectModule(this);

        METHOD_AnnihilateIfNotUsedDo = RegisterCallMethod("AnnihilateIfNotUsedDo");
        
        Owner=owner;

        if (owner != null)
        {
            mod.AcquireObjectModule(cInvObjSprite);
            mod.AcquireObjectModule(cInvObjSprite.cSprBack);

            mod.AddSprite(cInvObjSprite);
            mod.AddSprite(cInvObjSprite.cSprBack);
                
            if ( owner instanceof PlayerHUD )
            {
                
                PlayerHUD playerHUD = (PlayerHUD) owner;
				if ( (playerHUD.HUD != null) && 
                     (playerHUD.HUD.GetHudCompInvPl() != null) &&
                     (playerHUD.HUD.GetHudCompInvPl().cInvGridSprite != null) &&
					 (cInvObjSprite != null) )
                {
				    playerHUD.HUD.GetHudCompInvPl().cInvGridSprite.AddChild(cInvObjSprite);
                }
            }
        }
        else
        {
            RemoveSprite(cInvObjSprite);
            RemoveSprite(cInvObjSprite.cSprBack);
            mod.AcquireObjectModule(cInvObjSprite);
            mod.AcquireObjectModule(cInvObjSprite.cSprBack);
        }
        //CrashLog(" Acquire "+this+" "+owner+"\n");
    }
    
    
    void Unacquire()
    {
        RemoveSprite(cInvObjSprite);            //
        if(cInvObjSprite != null)
            RemoveSprite(cInvObjSprite.cSprBack);   //
        DetachFromParent();
        DeactivateOnModuleAlways();                   //
    }

//----------------------------------------------------------------------            
    
    /** inicjalizator wywolywany po konstruktorze
     */
    public void Initialize(String name)
    {
        sName = new String(name);	 
    }

//----------------------------------------------------------------------    
    
    public void SetInventory(Inventory cInventory)
    {
        this.cInventory = cInventory;
    }

//----------------------------------------------------------------------    
    
    public Inventory GetInventory()
    {
        return cInventory;
    }
    
//----------------------------------------------------------------------    
    
    public boolean IsInInventory()
    {
        return (cInventory != null);
    }

//----------------------------------------------------------------------
    
    public String GetInvName()
    {
        return Text.Get(sName);
    }
    
    String GetInfoString()
    {
        if (sInfo != null && sInfo.length() > 0)
            return Text.Get(sInfo);
        else 
            return "";
    }
    
    /**
     */
    void ChangeInvState( Pawn owner, int newState )
    {
        /*Pawn cPawnWithInv = owner;
        if ( cPawnWithInv == null )
            cPawnWithInv = Owner;*/
        
        if ( nInvState == EInvObjState._HANDS )
        {
            //CrashLog("[InvObject.ChangeInvState] Object in hands - detaching from"+GetParent()+"\n");
            //LogD("DetachFromParent\n");
            DetachFromParent();
        }
        
        //LogD("new invState:"+this+", state:"+newState+"\n");

        switch (newState)
        {
        case EInvObjState._ONGROUND :
            ActivateOnModule();
            EnableRendering(true);
            SetFlag(EFlags._BLOCK_TRACE);
            SetFlag(EFlags._COLLISION);
            RemovedOnGround();
            SetFlag(EFlags._NOT_STATIC);
            if ( owner instanceof PlayerNet )
            {
                //jezeli gracz sieciowy wyrzuci bron
                //na ziemie, to zostanie ona w przyszlosci
                //skasowana (jesli nikt jej nie uzyje do tego czasu)
                ScheduleAnnihilateIfNotUsed();
            }
            break;

        case EInvObjState._HANDS :
            SetPosition(new Vector(0, 0, 0));
            StopFallingDown();
            ClearFlag(EFlags._BLOCK_TRACE);
            // kasujemy wszelkie fxy przyklejone do przedmiotu
            DeleteAttachedFXes();
            SetFlag(EFlags._NOT_STATIC);
            //CrashLog("[InvObject.ChangeInvState] Taking to hands - owner <"+owner.getClass().getName()+">\n");
            
            if (owner != null)
            {
                if (owner.GetElementID("Right_hand") < 0)
                    owner.AttachChild(this, "Bip01 R Hand");
                else
                    owner.AttachChild(this, "Right_hand");
                
                SetPosition(Vector.Zero);
            }
            else
            {
                CrashLog("ERROR: Null Owner during changing InvObj state to HANDS (object:"+GetNetInfo()+")");
            }
            ActivateOnModule();
            EnableRendering(true);
            //kolizje w rzeczach w rekach nie sa wskazane
            ClearFlag(EFlags._BLOCK_TRACE);
            // jezeli obiekt zostal uzyty a bylo zaplanowane
            // jego skasowanie, to rezygnujemy z tego kasowania
            CancelAnnihilateIfNotUsed();
            break;

        case EInvObjState._INVENTORY:
            ClearFlag(EFlags._NOT_STATIC);
            // kasujemy wszelkie fxy przyklejone do przedmiotu
            DeleteAttachedFXes();
            ClearFlag(EFlags._BLOCK_TRACE);
            StopFallingDown();
            DetachFromParentAndKeepWorldPos(); //zeby deactivate zadzialalo
            DeactivateOnModuleAlways();
            EnableRendering(false);
            AddedToInventory();
            // jezeli obiekt zostal uzyty a bylo zaplanowane
            // jego skasowanie, to rezygnujemy z tego kasowania
            CancelAnnihilateIfNotUsed();
            break;
            
        case EInvObjState._SPARE:
            ClearFlag(EFlags._NOT_STATIC);
            // kasujemy wszelkie fxy przyklejone do przedmiotu
            DeleteAttachedFXes();
            ClearFlag(EFlags._BLOCK_TRACE);
            StopFallingDown();
            DetachFromParentAndKeepWorldPos(); //zeby deactivate zadzialalo
            DeactivateOnModuleAlways();
            EnableRendering(false);
            Clean();
            break;
        }
        
        /*if ( cPawnWithInv instanceof PlayerNetBaseInventory )
            ((PlayerNetBaseInventory)cPawnWithInv).ShowInventory("CHANGE "+this+" state: "+nInvState+"  "+newState);*/
        nInvState = newState;        
    }

//----------------------------------------------------------------------            

    /**Pokryta metoda TriggerObject. W InventoryObject umieszcza obiekt w inventory Pawna.
     * @param executor Pawn wykonujacy akcje. Jesli executor nie jest pawnem, metoda nie robi nic. (<code>Actor</code>)
     */
    void Execute(Actor executor)
    {
        if ( bDeleted )
        {
            CrashLog("ERROR: "+GetNetInfo()+" deleted!\n");
            return;
        }
        if ( executor == null )
        {
            CrashLog("ERROR: "+GetNetInfo()+" executor == null\n");
            return;
        }
        
        //TODO: czy nie trzeba sprawdzic czy obiekt jest na ziemi?
        
        //CrashLog("Owner: "+Owner+"\n");
        //nie mozna zebrac, jesli przyczepiony do stojaka
        if (Owner instanceof WeaponRackPawn)
        {
            return;
        }
        
        if ( nInvState == EInvObjState._SPARE )
        {
            boolean bStop = true;
        }
        AddToAutoRespawnIfNeeded();
        
        Pawn oldOwner = Owner;
        AddToInventory(executor, false);

        // Przeniesione tutaj, zeby mozna bylo na levelu sprawdzic, czy udalo sie zebrac
        super.Execute(executor);

        // odpalenie dzwieku zabierania przedmiotu
        if ( executor.bNetIsOwner )
            PlaySound(sTakeObjectSound);
    }

    boolean AddToInventory(Actor executor)
    {
        return AddToInventory(executor, false);
    }
    
    /**bLoud : true - stosuje dzwiek i tekst, false - bez dzwieku i tekstow
     */
    boolean AddToInventory(Actor executor, boolean bLoud)
    {
        //TEMP!! ma byc uruchomienie dragowania!
        //        teraz jest tylko chowanie do inventory
        
        
        if ( executor instanceof Pawn )
        {
            Pawn pawn = (Pawn)executor;

            
            InvObject cLastConflictedObj = null;
            int       nSafetyCnt         = 20;//zawor bezpieczenstwa
            boolean   bRepeat            = false;
            do {
                bJustTakenToInventory = false;
                bRepeat               = false;
                
                if ( cLastConflictedObj != null )
                    NetLog.InvObj("AddToInventory try again "+GetNetInfo()+
                                  " because: "+cLastConflictedObj.GetNetInfo()); 
                
                if ( (pawn != null) && (pawn.cInventory != null))
                {
                    //wloz sie pawnowi do inventory...
			    	if (bPlaceAtGivenCells)
                        bJustTakenToInventory =  pawn.cInventory.AddInvObjectInPlace(this);
                    else if (bNearestCell) 
                        bJustTakenToInventory =  pawn.cInventory.AddInvObjectNearest(this); 
                    else 
                        bJustTakenToInventory =  pawn.cInventory.AddInvObject(this);
                }
            
                if ( m_bActionFromServer && (!bJustTakenToInventory))
                {
                    //sprawdzmy kto z nami koliduje w inwentory
                    InvObject cConflictedObj = pawn.cInventory.GetGridConflictedObject( this );
                    
                    if ( (cConflictedObj != null) && 
                         (cConflictedObj != cLastConflictedObj) )
                    {
                        //ktos koliduje
                        cLastConflictedObj = cConflictedObj;         

                        //jesli on ma starszy stan to trzeba z nim zrobic
                        //maly porzadek.
                        if ( cConflictedObj.GetChangeStateCounter() < 
                             GetChangeStateCounter() )
                        {
                            NetLog.InvObj("AddToInventory failed "+GetNetInfo()+
                                          " because: "+cConflictedObj.GetNetInfo()+
                                          " force state on ground"); 
                            //wywalic tego co z nami kolidowal
                            cConflictedObj.m_vReqPos = cConflictedObj.GetPosition();
                            cConflictedObj.SetStateOnGround();
                            //poprosmy serwer o jego prawdziwy stan
                            cConflictedObj.MsgSendServerStateRequest();
                            
                            //i powtorzyc wkladanie jeszcze raz                                
                            bRepeat = true;
                        }
                        else
                            NetLog.Error("AddToInventory failed "+GetNetInfo()+
                                         ((cConflictedObj != null)?
                                         " conflicted "+cConflictedObj.GetNetInfo():
                                         " unknown problem"));
                    }
                    else
                    {
                        NetLog.Error("AddToInventory failed "+GetNetInfo()+
                                     ((cConflictedObj != null)?
                                      " conflicted "+cConflictedObj.GetNetInfo():
                                      " unknown problem"+
                                      ((cLastConflictedObj != null)?
                                      " last conflicted "+cLastConflictedObj.GetNetInfo():
                                      " unknown last problem")));
                    }
                }
            } while ( bRepeat && (--nSafetyCnt > 0) );

			// jezeli dodanie powiodlo sie
            if (bJustTakenToInventory)
            {
                PlayerHUD player = (executor instanceof PlayerHUD)? 
                                   (PlayerHUD)executor : null;
                
				// to po to, by inventory objecty sie dobrze pokazywaly (NA inventory)
                //MK: dlaczego to tylko w Single'u ?!!!!!
				if ( (player != null) && (GetModule() != null) && (GetModule() instanceof ChromeModuleSingle) )
				{
					// zmieniamy przypisanie invobjecta
					if ( (player.HUD != null) && 
                         (player.HUD.GetHudCompInvPl() != null) &&
                         (player.HUD.GetHudCompInvPl().cInvGridSprite != null) &&
						 (cInvObjSprite != null) )
						player.HUD.GetHudCompInvPl().cInvGridSprite.AddChild(cInvObjSprite);
                    if (player.GetActiveTrigger() == this)
                        player.SetActiveTrigger(null);
				}
			
                if (bLoud && pawn.bNetIsOwner)
                {
                    //dzwiek dodania
                    PlaySound(sObjTakenSound);
                }

                Owner = pawn;
                ChangeInvState( pawn, EInvObjState._INVENTORY );
                //LogD(this+" dodano do inventory: "+Owner+"\n");

                // jezeli bylo wykonane execute "z ziemi", to poinformuj o tym
                // czyli wywolaj metode nic nie robiaca :-)
                // w Weaponie bedzie mozna nadpisac tak, aby poinformowac Pawna
                // o zdarzeniu, ten bedzie mogl od razu uzyc tej broni...
                if ( bNearestCell == false && bPlaceAtGivenCells == false )
                    JustAddedToInventory();

                // na podstawie dostepnych hudow domyslamy sie
                // kto chce obslugiwac dzialania na obiektach (sprajtach)
				if((player!=null) && (player.HUD != null))
                {
	                // trzeba pokazac przedmiot w HUDInvUse jesli jest to przedmiot do uzywania
                    if ( (player.cInventory != null) && 
                         (player.HUD.aHUDComponent[player.HUD._PLAYER_DATA] != null) )
					{
						if (player.cInventory.cActualUsableInvObj == null)
						{
						   player.cInventory.SetFirstUsableInvObj();
						   InvObject obj = player.cInventory.GetActualUsableInvObj();
						   HUDCompPlayer hudInvUse = (HUDCompPlayer)player.HUD.aHUDComponent[player.HUD._PLAYER_DATA];
						   hudInvUse.ShowUsableInvObj(obj);
						}
					}
                            
                    					
                        
                    if(player.HUD.aHUDComponent[HUDManager._HUD_INV_PLAYER] != null)
                    {
                        if(cInvObjSprite!=null) cInvObjSprite.SetHUDInvPl((HUDCompInvPl)player.HUD.aHUDComponent[HUDManager._HUD_INV_PLAYER]);
                    }
                    else
                    {
					    if(player.HUD.GetInventoryMenu() != null)
                        {
                            if(cInvObjSprite!=null)
                                cInvObjSprite.SetInvMenu(player.HUD.GetInventoryMenu());
                        }
                        else
                        {
                            if(cInvObjSprite!=null)
                            {
                                cInvObjSprite.SetHUDInvPl(null);
                                cInvObjSprite.SetInvMenu(null);
                            }
                        }
                    }
                }
            }
			else //nie ma miejsca w plecaku
			{
                if ( bLoud && executor.bNetIsOwner )
                {
                    //dzwiek niedodania
                    PlaySound( sObjNotTakenSound );
                }
                
                //bLoud i tak jest zwykle ustawione na false, zatem
                //dzwiek olewam w sieci
                if ( executor instanceof PlayerHUD  && sm_bShowMsgNoInvRoom )
                    ((PlayerHUD)executor).NotEnoughRoomInInventory();
                
			} //else nie ma miejsca w plecaku

			//Log("[InventoryObject.Execute]: "+this+" executed!\n");

        } 
        else
        {
            LogR("Obiekt "+executor+" is not instanceof Pawn\n");
            return false;
        }
        
        return bJustTakenToInventory;
    }

    /** Static mowiacy czy w danej chwili maja byc wyswietlane komunikatu
     * o braku miejsca w inwentory (podczas proby dodawania do niego)
     * Wylaczane w sieci podczas wypelniania inwentory na serwerze.
     */
    static boolean sm_bShowMsgNoInvRoom = true;
    
    /** ta metoda mozemy umiescic obiekt w inventory Pawna w konkretnym
     * miejscu jego inwentarza
     */
    void Execute( Actor executor, byte nG, byte nCX, byte nCY )
    {
        nGrid  = nG;
        nCellX = nCX;
        nCellY = nCY;
        bPlaceAtGivenCells = true;
        Execute( executor );
        bPlaceAtGivenCells = false;
    }
    
    /**
     * Parametry zaplanowanej akcji
     */
    boolean m_bActionPlaceAtGivenCells = false;
    byte     m_nActionGrid = -1;
    byte     m_nActionCellX = -1;
    byte     m_nActionCellY = -1;
    
    void ActionExecute( Actor executor )
    {
        m_bActionPlaceAtGivenCells = false;
        super.ActionExecute( executor );
    }
    void ActionExecute( Actor executor, byte nGrid, byte nCellX, byte nCellY  )
    {
        m_bActionPlaceAtGivenCells = true;
        m_nActionGrid  = nGrid;
        m_nActionCellX = nCellX;
        m_nActionCellY = nCellY;
        
        //MK dodalem super. bo chyba tak powinno byc (????)
        super.ActionExecute( executor );
    }
    
    /**
     * Weryfikacja mozliwosci wykonania akcji na obiekcie
     */
    boolean ServerVerifyActionExecute( Actor cExecutor, float fMaxDistance )
    {
        return super.ServerVerifyActionExecute( cExecutor, fMaxDistance )&&
               (( nInvState == EInvObjState._ONGROUND ));
    }
    
    void ExecuteDo()
    {
        if ( m_bActionPlaceAtGivenCells )
        {
            Execute( m_cActionExecutor, 
                     m_nActionGrid, 
                     m_nActionCellX, 
                     m_nActionCellY );
            m_bActionPlaceAtGivenCells = false;
        }
        else
            super.ExecuteDo();
    }
    
    void MessagePackData()
    {
        super.MessagePackData();
        
        MessagePackBoolean( m_bActionPlaceAtGivenCells );
        if ( m_bActionPlaceAtGivenCells )
        {
            MessagePackByte( m_nActionGrid );
            MessagePackByte( m_nActionCellX );
            MessagePackByte( m_nActionCellY );
        }
    }
    
    void MessageUnPackData()
    {
        super.MessageUnPackData();
        
        m_bActionPlaceAtGivenCells = MessageUnPackBoolean();
        if ( m_bActionPlaceAtGivenCells )
        {
            m_nActionGrid  = MessageUnPackByte();
            m_nActionCellX = MessageUnPackByte();
            m_nActionCellY = MessageUnPackByte();
        }
    }
    
//----------------------------------------------------------------------        
    
    /** 
     */
    public boolean IsActive(ControlObject Activator)
    {
        return ( nInvState == EInvObjState._ONGROUND );
    }
    
//----------------------------------------------------------------------        
    
    /** metoda ustawiajaca parametry (ilosc zajmowanych kratek)
     *	przedmiotu i polozenie przedmiotu w gridzie plecaka
     */
    public void SetInvObjParams(int cellsWidth, int cellsHeight, byte cellX, byte cellY)
    {
        nCellsWidth = cellsWidth;
        nCellsHeight = cellsHeight;
        nCellX = cellX;
        nCellY = cellY;
    }

//----------------------------------------------------------------------            
    
    /** destuktor
     */
    public void OnDestroy()
    {
        /* CLIENT
         * Wyrzucamy obiekt z inventory gdy dostalismy sygnal o skasowaniu obiektu
         */
        if ( cInventory != null )
        {
            cInventory.RemoveInvObject( this );
        }


        if (cInvObjSprite != null)
        {
            //LogR("[InvObject.OnDestroy] name="+GetName()+" obj="+this+"\n");
            
            RemoveSprite(cInvObjSprite);
            cInvObjSprite.ReleaseTexture(nInvObjSpriteTex);
            cInvObjSprite.CallMethodIn("delete", 0.0f);
            cInvObjSprite = null;	
        }
        
		cInventory = null;
        
		// DetachFromParent();
		DeleteAttachedFXes();
        
        super.OnDestroy();
    }

    void delete()
    {
        if ( GetModule() instanceof ModuleNet && ModuleNet.IsGameGoing() )
        {
            if ( nInvState == EInvObjState._SPARE )
            {
                NetLog.InvObj("ERROR: Skasowany obiekt "+GetNetInfo()+" jest w stanie _SPARE!\n");
                Thread.dumpStack();
            }
        }
        super.delete();
    }
    
    /**Metoda wolana przez inventory przy wyrzucaniu obiektu*/
    void OnRemoveFromInventory()
    {
    }
//----------------------------------------------------------------------            
    
    /** metoda rysujaca InvObject
     */
    public void Draw()
    {
        if (!bHidden && !bHiddenButUsable)
        {
            cInvObjSprite.Show();
            cInvObjSprite.CallMethodIn("MoveTop", 0);
            cInvObjSprite.ProcessMouse(true);
        }
    }
    
//----------------------------------------------------------------------            
    
    /** metoda chowajaca InvObject
     */
    public void Hide()
    {
        //FIXIT chowanie inv objecta napewno wylacza przeciaganie mysza
        if ( cInvObjSprite != null )
        {
            cInvObjSprite.bDrag = false;
            cInvObjSprite.Hide();
            cInvObjSprite.ProcessMouse(false);
        }
        else
        {
			// PJP: tu cos powinno byc
			//Log
        }
    }
    
 //----------------------------------------------------------------------        
    
    /** metoda ustawiajaca pozycje sprite'a przedmiotu
     */
    public void SetInvObjPos(int x, int y)
    {
        cInvObjSprite.SetPos(new Vector(x,y,0));
    }
    
//----------------------------------------------------------------------
    
    /** metoda ustawiajaca pozycje przedmiotu w plecaku - wspolrzedne w grid'zie
     */
    public void SetInvObjCells(byte cellX, byte cellY)
    {
        nCellX = cellX;
        nCellY = cellY;
        ScaleTexture();

        cInvObjSprite.SetRelativePos(new Vector(EHudInvParams.GetCellWidth()*nCellX,
                                                EHudInvParams.GetCellHeight()*nCellY,
                                                0));
    }

//----------------------------------------------------------------------
    
    /** metoda ustawiajaca pozycje przedmiotu w plecaku - 
     *	wspolrzedne w grid'zie i referencja do grida
     */
    public void SetInvObjCellsGrid(byte cellX, byte cellY, byte grid)
    {
        nCellX = cellX;
        nCellY = cellY;
        
        nGrid = grid;
        
        ScaleTexture();
        
        if(cInventory != null && nGrid != -1)
        {
            InvGrid cGrid = cInventory.GetInvGrid(nGrid);
            if(cGrid != null)
                cInvObjSprite.SetPos(new Vector(cGrid.nGridPosX+EHudInvParams.GetCellWidth()*nCellX,
                                                cGrid.nGridPosY+EHudInvParams.GetCellHeight()*nCellY,
                                                0));
            else
                cInvObjSprite.SetPos(new Vector(0,0,0));
        }
        else
        {
            cInvObjSprite.SetPos(new Vector(0,0,0));
        }
    }
    
//----------------------------------------------------------------------
    
    /** metoda skalujaca texture przedmiotu
     */
    public void ScaleTexture()
    {
        cInvObjSprite.SetSize(new Vector(EHudInvParams.GetCellWidth() * nCellsWidth,
                                         EHudInvParams.GetCellHeight() * nCellsHeight,
                                         0));
    }

//----------------------------------------------------------------------
    
    /** metoda wyrzuca przedmiot na teren
     */
    public void DropOnTerrain(Vector pos)
    {
        //LogD(pos.fX + " " + pos.fY + " " + pos.fZ + " " + "\n");
        
        SetPosition(pos);
    }
    
    /** Wyrzucenie przedmiotu na teren przy uzyciu fizyki spadania
     *  @param vFrom pozycja poczatkowa (<code>Vector</code>)
     *  @param vSpeed predkosc (i zarazem kierunek) wyrzucania (<code>Vector</code>)
     */
    public void PhysicsDrop(Vector vFrom, Vector vSpeed)
    {
        SetPhysicsType(EPhysics._FALL);
        SetCollAction(ECollFlags.OBJCOL_ACTION_STOP);
        SetCollHandler(ECollFlags.OBJCOL_HANDLER_OBJECT);
        SetCollType(ECollFlags.OBJCOL_TYPE_PERFACE);

        SetSpeed(vSpeed);
        SetPhysicsActive(true);
        //SetPosition(vFrom);
        
        //SetDir(vOnGroundNormal);
        Vector vDir = new Vector();
        vDir.fX = 1 - RandomFloat(2);
        vDir.fZ = 1 - RandomFloat(2);
        vDir.fY = 0;
        if (vDir.Len() > 0)
            vDir.Normalize();
        else
            vDir = new Vector(Vector.Forward);
        if (this instanceof Weapon)
        {
            //vUpOnGround.fY = 1 - RandomFloat(2);
            vUpOnGround.fZ = 1 - RandomFloat(2);
            vUpOnGround.Normalize();
            vDir = Vector.Forward;
        }
        
        ((ControlObject)this).FromUpForwardPos(vUpOnGround, vDir, vFrom);
    }

    public void SetPositionOnGroundDrop(Vector vPos, Vector vDroppingPawnPos)
    {
/*TODO effect is weak...
        Vector vMove = new Vector(vDroppingPawnPos);
        vMove.Sub(vPos);
        
        MoveByEllipsoid(vMove);
        
        vPos.Set(vDroppingPawnPos);
        vPos.Add(vMove);
*/
        SetPositionWorld(vPos);
    }
    
    public void StopFallingDown()
    {
        SetSpeed(new Vector());
        SetPhysicsActive(false);
        // sprawdzamy punkt trafienia w ziemie
        DisableCallMethod("WatchFallingDown");
    }
            
    boolean IsObjectAttachedTo(ControlObject cObj, ControlObject cParent)
    {
        ControlObject cCurrObject = cObj;

        while (cCurrObject != null &&
               cCurrObject != cParent)
            cCurrObject = cCurrObject.GetParent();
        
        return cCurrObject == cParent;
    }
    
    
    void WatchFallingDown()
    {
        Vector vStart = GetPosition(),
               vEnd = new Vector(vStart);
        vStart.fY += 50;
        vEnd.fY -= 250;
        TraceTerrain(vStart, vEnd);
        TraceTrees(vStart, vEnd);
        Collision cCol = TraceObjectsExclude(vStart, vEnd, this);
        if (cCol == null || !IsObjectAttachedTo(cCol.Obstacle,GetParent()) )
        {
            Vector vSpeed = GetAbsoluteSpeed();
            DetachFromParentAndKeepWorldPos();
            SetSpeed(vSpeed);
            DisableCallMethod("WatchFallingDown");
        }
    }
    
    
    public void OnCollisionObject(ControlObject Col)
    {
        //CrashLog("[InvObject.OnCollisionObject] vPos="+GetPosition()+"\n");
        if (Col instanceof ForceFieldFence)
        {
            return;
        }
        StopFallingDown();
        /**
         * Serwer po zakonczeniu "lotu" wysle na klientow
         * stan (chodzi o pozycje) obiektu
         */
        if ( Role == ERole._AUTHORITY )
            MsgSendClientState();
        if (!IsObjectAttachedTo(Col,GetParent()))
            DetachFromParentAndKeepWorldPos();
    }

    
//----------------------------------------------------------------------            

    /**
     */
    String GetTip()
    {
        return sName + " " + Text.Get("&GET_OBJECT&");
    }    
    
//----------------------------------------------------------------------    
    
    /** metoda powodujaca uzycie przedmiotu - tylko dla USABLE objects
     */
    public void Use()
    {
        //Log("[InvObject.Use]: USE OBJECT \n");
    }
    
    /** metoda powodujaca zakonczenie uzycia przedmiotu - do sieci
     */
    public void EndUse()
    {
        //Log("[InvObject.Use]: USE OBJECT \n");
    }
    
//----------------------------------------------------------------------        
    /** metoda wolana jest za kazdym razem, gdy przedmiot zostaje usuniety (wyrzucony) z inventory
     */
    public void RemovedOnGround()
    {
    }
    //----------------------------------------------------------------------        
    /** metoda wolana jest za kazdym razem, gdy przedmiot zostaje dodany do inventory
     */
    public void AddedToInventory()
    {
        //kasujemy slady krwi itp. z obiektu
        DeleteAttachedFXes();
    }
    
    
    /** metoda zwraca aktualne miejsce w Gridach w postaci
     *	Vector(CellX, CellY, numerGrida) 
     */
    public Vector GetCurrentPlace()
    {
        Vector retVect = new Vector( nCellX, nCellY , nGrid );
        return retVect;
    }

    
    /** Siec
     */
    
    // identyfikatory komunikatow
    static final int MSG_CLIENT_STATE           = 10; // serwer wysyla klientowi stan obiektu

    static final int MSG_SERVER_THROW_AWAY_REQ  = 20; // klient prosi o wyrzucenie broni
    static final int MSG_CLIENT_THROW_AWAY      = 21; // serwer kaze wyrzucic bron
    
    static final int MSG_SERVER_NEW_GRID_POS    = 22; //klient informuje serwera ze przesunal obiekt w inwentory
    static final int MSG_CLIENT_NEW_GRID_POS    = 23; //serwer informuje klienta ze ma przesunac obiekt w inwentory
    
    static final int MSG_SERVER_DELETE_REQ      = 24; // klient prosi o skasowanie obiektu
    
    static final int MSG_SERVER_STATE_REQ       = 25; //klient prosi o ponowne przyslanie stanu obiektu
    
    static final int MSG_CLIENT_VERIFY_POS      = 26; //TODO: tylko do testow
    static final int MSG_SERVER_VERIFY_RESULTS  = 27; //TODO: tylko do testow


    //Uwaga!
    //W klasach potomnych zaczynam uzywac numerkow od 50 w gore!
    
    
    
    // tu bedziemy przetrzymywac odczytane z komunikatow dane (do obsluzenia)
    // pozycja
    Vector m_vReqPos         = null;
    // stan
    int    m_nReqInvState    = -1;
    // wlasciciel
    int    m_nReqOwnerId     = -1;
    // pozycje w inwentory
    int      m_nReqInvIndex   = -1;
    byte     m_nReqGrid       = -1;
    byte     m_nReqCellX      = -1;
    byte     m_nReqCellY      = -1;
    //flagi
    boolean  m_bReqHidden           = false;
    boolean  m_bReqHiddenButUsable  = false; 
    boolean  m_bReqLocked           = false;
    
    // do obslugi inventory room'a
    // czy obiekt istnieje tylko tymczasowo
    boolean m_bLocalObj = false;
    
    /** Odebranie komunikatow przychodzacych z sieci
     */
    public void OnMessage()
    {
        switch ( MessageGetId() )
        {
        case MSG_CLIENT_STATE:
            NetLog.MsgIn( "MSG_CLIENT_STATE", this );
            MsgRecvClientState();
            break;
            
        case MSG_SERVER_THROW_AWAY_REQ:
            NetLog.MsgIn( "MSG_SERVER_THROW_AWAY_REQ", this );
            MsgRecvServerThrowAwayRequest();
            break;
            
        case MSG_CLIENT_THROW_AWAY:
            NetLog.MsgIn( "MSG_CLIENT_THROW_AWAY", this );
            MsgRecvClientThrowAway();
            break;
            
        case MSG_SERVER_NEW_GRID_POS:
            NetLog.MsgIn( "MSG_SERVER_NEW_GRID_POS", this );
            MsgRecvServerNewGridPos();
            break;
            
        case MSG_CLIENT_NEW_GRID_POS:
            NetLog.MsgIn( "MSG_CLIENT_NEW_GRID_POS", this );
            MsgRecvClientNewGridPos();
            break;
            
        case MSG_SERVER_DELETE_REQ:
            NetLog.MsgIn( "MSG_SERVER_DELETE_REQ", this );
            MsgRecvServerDeleteRequest();
            break;
            
        case MSG_SERVER_STATE_REQ:
            NetLog.MsgIn( "MSG_SERVER_STATE_REQ", this );
            MsgRecvServerStateRequest();            
            break;
            
        case MSG_CLIENT_VERIFY_POS:
            NetLog.MsgIn( "MSG_CLIENT_VERIFY_POS", this );
            MsgRecvClientVerifyPos();
            break;            
        
        case MSG_SERVER_VERIFY_RESULTS:
            NetLog.MsgIn( "MSG_SERVER_VERIFY_RESULTS", this );
            MsgRecvServerVerifyResults();
            break;                        
                                    
        default:
            super.OnMessage();
        }
    }
    
    // wyslanie komunikatu o stanie obiektu
    void MsgSendClientState()
    {
        MsgSendClientState( false, -1 );
    }
    void MsgSendClientStateToHost(int nHostId)
    {
        NetLog.InvObj("SEND MSG_CLIENT_STATE "+GetNetInfo()+" to host "+nHostId+"\n");
        MsgSendClientState( true, nHostId );
    }
    private void MsgSendClientState(boolean bOnlyOneHost, int nHostId)
    {
        if ( Role < ERole._AUTHORITY )
        {
            NetLog.InvObj("ERROR: "+GetNetInfo()+" MsgSendClientState() zawolane na kliencie!\n");
            Thread.dumpStack();
            return;
        }
        
        NetLog.MsgOut( "MSG_CLIENT_STATE", this );
        MessageNew( MSG_CLIENT_STATE );
        MessagePackInt( GetNextGlobalChangeInvStateCounter() );
        MessagePackInt( this.nInvState );
        PackAdditionalData();
        LogD(" "+getClass().getName()+" netid:"+GetNetId()+" state"+this.nInvState+"\n" );
        switch ( this.nInvState )
        {
        case EInvObjState._ONGROUND:
            PackStateOnGround();
            break;
            
        case EInvObjState._INVENTORY:
            PackStateInventory();
            break;
            
        case EInvObjState._HANDS:
            PackStateHands();
            break;
            
        case EInvObjState._SPARE:
            break;
        }
    
        if ( bOnlyOneHost )
            MessageSendHost( nHostId );
        else
            MessageSend();
    }
    
    
    boolean   m_bActionFromServer = false;

    // odbranie stanu obiektu
    void MsgRecvClientState()
    {
        m_bActionFromServer  = true;
        
        int nChangeStateCounter = MessageUnPackInt();
        m_nReqInvState          = MessageUnPackInt();
        UnPackAdditionalData();        
        
        boolean bVerified    = VerifyChangeInvStateCounter( nChangeStateCounter );
        if ( bVerified )
        {
            DisableAllWaitingMethod();
            NetLog.InvObj("RecvClientState Verified "+GetNetInfo()+" -> "+EInvObjState.GetName(m_nReqInvState)+"\n");
        }        
        else
        {
            NetLog.InvObj("RecvClientState CANCELED "+GetNetInfo()+" -> "+EInvObjState.GetName(m_nReqInvState)+"\n");
        }
        
        //weryfikacja dodatkowych danych moze sie odbywac indywidualnie
        //na kazdym z poziomow, wiec przekazujemy parametr, ale nie
        //jest pewnie czy zostanie on wykorzystany
        ApplyAdditionalData( bVerified );
        
        switch ( m_nReqInvState )
        {
        case EInvObjState._ONGROUND:
            //LogR(" "+this+" EInvObjState._ONGROUND\n");
            UnPackStateOnGround();
            MessageEnd();
            if ( bVerified )
                SetStateOnGround();
            break;
            
        case EInvObjState._INVENTORY:
            //LogR(" "+this+" EInvObjState._INVENTORY\n");
            UnPackStateInventory();
            MessageEnd();
            if ( bVerified )
                SetStateInventory();
            break;
            
        case EInvObjState._HANDS:
            //LogR(" "+this+" EInvObjState._HANDS\n");
            UnPackStateHands();
            MessageEnd();
            if ( bVerified )
                SetStateHands();
            if ( Owner != null )
                Log(" "+this+" OwnerWeapon "+Owner.ActiveWeapon+"\n");
            else
                LogR("ERROR: "+this+" SetStateHands() Owner == null!!!!\n");
            break;
            
        case EInvObjState._SPARE:
            //LogR(" "+this+" EInvObjState._SPARE\n");
            MessageEnd();
            if ( bVerified )
                SetStateSpare();
        }
    
        m_bActionFromServer = false;
    }

    /**
     * Globalny licznik zmian stanow obiektow
     * Bedzie on wykorzystywany na klientach do rozstrzygania czy dana
     * akcja (ktora zleca nam serwer) ma sie wykonac czy nie (bo jest stara)
     * TODO: dac szerszy opis
     */
    private static 
    ChangeStateCounter sm_cGlobalChangeInvStateCounter = new ChangeStateCounter();
    static void CleanGlobalChangeInvStateCounter() { sm_cGlobalChangeInvStateCounter.Clean(); }
    static int  GetNextGlobalChangeInvStateCounter(){ return sm_cGlobalChangeInvStateCounter.GetNext(); }
    
    /**
     * Indywidualny licznik zapamietujacy ostatnio
     * odebrana i wykonana akcje na tym obiekcie
     */
    private 
    ChangeStateCounter m_cChangeInvStateCounter = new ChangeStateCounter(this);
    boolean VerifyChangeInvStateCounter( int nCounter ){ return m_cChangeInvStateCounter.Verify( nCounter ); }
    int     GetChangeStateCounter(){ return m_cChangeInvStateCounter.Get(); }
    
    void DisableAllWaitingMethod()
    {
        DisableCallMethod("ChangeStateInventory");
        DisableCallMethod("ChangeStateHands");
        DisableCallMethod("ChangeStateOnGround");
    }
    
    void PackAdditionalData()
    {
    }
    void UnPackAdditionalData()
    {
    }
    void ApplyAdditionalData(boolean bVerified)
    {
    }
    
    //
    // poszczegolne stany
    //
    
    // OnGround
    //
    
    // wyslanie stanu
    void PackStateOnGround()
    {
        MessagePackVector( GetPosition() );
    }
    
    // odebranie stanu
    void UnPackStateOnGround()
    {
        m_vReqPos    = MessageUnPackVector();
    }
    
    // ustawienie stanu
    void SetStateOnGround()
    {
        DisableAllWaitingMethod();
        // TODO:tymczasowo tak samo
        ChangeStateOnGround();
    }
    
    // zmiana stanu
    void ChangeStateOnGround()
    {
        //TODO: tylko do testow
        PlayerNetBaseInventory cPlayer = null;
        if ( (Owner != null) && Owner.bNetIsOwner && Owner instanceof PlayerNetBaseInventory )
            cPlayer = (PlayerNetBaseInventory)Owner;
        //TODO: tylko do testow end

        //jesli jest w inventory to go wywalamy
        if ( Owner != null )
        {
            Owner.cInventory.RemoveInvObject( this );
        }
        
        // zmieniamy stan
        ChangeInvState( null, EInvObjState._ONGROUND );
        // stawiamy na ziemi
        ApplyPosition();
        
        //TODO: tylko do testow
        if ( cPlayer != null )
             cPlayer.ShowInventory(" "+this+" ChangeStateGround()");
        //TODO: tylko do testow end            
    }

    void ApplyPosition()
    {
        SetPosition( m_vReqPos );
    }

    
    // Spare
    //
    
    // ustawienie stanu
    void SetStateSpare()
    {
        DisableAllWaitingMethod();
        // TODO:tymczasowo tak samo
        ChangeStateSpare();
    }
    
    // zmiana stanu
    void ChangeStateSpare()
    {
        //TODO: tylko do testow
        PlayerNetBaseInventory cPlayer = null;
        if ( (Owner != null) && Owner.bNetIsOwner && Owner instanceof PlayerNetBaseInventory )
            cPlayer = (PlayerNetBaseInventory)Owner;
        //TODO: tylko do testow end
        

        //jesli jest w inventory to go wywalamy
        if ( Owner != null )
        {
            Owner.cInventory.RemoveInvObject( this );
        }
        
        // zmieniamy stan
        ChangeInvState( null, EInvObjState._SPARE );
        
        //TODO: tylko do testow
        if ( cPlayer != null )
            cPlayer.ShowInventory(" "+this+" ChangeStateSpare()");              
        //TODO: tylko do testow end
    }
    
    
    //
    // Inventory
    
    // wyslanie stanu
    void PackStateInventory()
    {
        int nOwnerId = Owner != null ? Owner.GetNetId() : -1 ;
        
        //nOwnerId = cInventory.Owner.GetNetId();
        //TODO: porownac ownera naszego i naszego inwentory
        
        MessagePackInt( nOwnerId );
        MessagePackByte( nGrid );
        MessagePackByte( nCellX );
        MessagePackByte( nCellY );
        MessagePackBoolean( bHidden );
        MessagePackBoolean( bHiddenButUsable );
        MessagePackBoolean( bLocked );
        
        if ( nOwnerId == -1 )
            NetLog.Error("PackStateInventory "+GetNetInfo()+" !!!!\n");
    }

    // odebranie stanu
    void UnPackStateInventory()
    {
        m_nReqOwnerId         = MessageUnPackInt();
        m_nReqGrid            = MessageUnPackByte();
        m_nReqCellX           = MessageUnPackByte();
        m_nReqCellY           = MessageUnPackByte();
        m_bReqHidden          = MessageUnPackBoolean();
        m_bReqHiddenButUsable = MessageUnPackBoolean();
        m_bReqLocked          = MessageUnPackBoolean();
    }
    
    // ustawienie stanu
    void SetStateInventory()
    {
        DisableAllWaitingMethod();
                // TODO:tymczasowo tak samo
        ChangeStateInventory();
    }
    
    // zmiana stanu
    void ChangeStateInventory()
    {
        Pawn pawn = GetPawnByNetId( m_nReqOwnerId );
        if ( pawn == null )
        {
            //jesli jeszcze nie ma pawna to poczekajmy chwile
            CallMethodIn("ChangeStateInventory",0.1f);
            return;
        }
        
        //jezeli ten obiekt juz siedzi w inwentory, to trzeba
        //go pierw usunac
        if ( Owner != null )
        {
            Owner.cInventory.RemoveInvObject( this );
        }
        
        //zastosowujemy odebrane flagi
        bHidden          = m_bReqHidden;
        bHiddenButUsable = m_bReqHiddenButUsable;
        bLocked          = m_bReqLocked;
        
        //i probujemy wlozyc obiekt do inwentarza
        Execute( pawn, m_nReqGrid, m_nReqCellX, m_nReqCellY );
        
        if ( m_bActionFromServer  )
        {
            if ( ! AmIInInventory( pawn ) )
            {
                NetLog.InvObj("Obiekt "+GetNetInfo()+" nie dostal sie do inwentarza!\n");
                
                //TODO: sprawdzic czy to czasem nie wina tego co tam siedzi!
                //jesli tak to go wywalic, jesli to nasza wina to mowi sie trudno
                
                //m_cConflictedObj = this;
            }
        }
            
        //TODO: tylko do testow
        if ( pawn.bNetIsOwner && pawn instanceof PlayerNetBaseInventory )
            ((PlayerNetBaseInventory)pawn).ShowInventory(" "+this+" ChangeStateInventory()");  
        //TODO: tylko do testow end
    }
    
    
    //
    // Hands
    
    // wyslanie stanu
    void PackStateHands()
    {
        // to samo co Inventory
        PackStateInventory();
    }
    
    // oderanie stanu
    void UnPackStateHands()
    {
        // to samo co Inventory
        UnPackStateInventory();
    }
    
    // ustawienie stanu
    void SetStateHands()
    {
        DisableAllWaitingMethod();
        // TODO:tymczasowo tak samo
        ChangeStateHands();
    }
    
    // zmiana stanu
    void ChangeStateHands()
    {
        Pawn pawn = GetPawnByNetId( m_nReqOwnerId );
        if ( pawn == null )
        {
            //jesli jeszcze nie ma pawna to poczekajmy chwile
            CallMethodIn("ChangeStateHands",0.1f);
            return;
        }

        //TODO: tylko do testow
        PlayerNetBaseInventory cPlayer = null;
        if ( pawn.bNetIsOwner && pawn instanceof PlayerNetBaseInventory )
            cPlayer = (PlayerNetBaseInventory)pawn;
        //TODO: tylko do testow end

                
        //wyrzucam i wkladam ponownie tylko wtedy gdy
        //aktualny owner i docelowy sie roznia,
        //po to, aby powtornie nie wolac UseWeapon( (Weapon)this )
        //bo to powoduje komplikacje (np wylaczenie przycelowania itp.)
        
        //wada tego rozwiazania jest, ze byc moze nie beda zgadzac sie
        //parametry m_nReqGrid, m_nReqCellX, m_nReqCellY
        //Wada ta jest w chwili obecnej o tyle nie grozna, ze
        //nie liczymy relewantnosci dla obiektow inwentory,
        //zatem nie powinny sie zdarzac takie sytuacje.
        
        //TODO: tak naprawde to tu trzebaby sprawdzac czy obiekt jest
        //w tym inwentory
        if ( pawn != Owner )
        {
            if ( Owner != null )
            {
                Owner.cInventory.RemoveInvObject( this );
            }
            
            Execute( pawn, m_nReqGrid, m_nReqCellX, m_nReqCellY );
        }
        else
        {
            if ( cPlayer != null )
                NetLog.InvObj("WARNING: ChangeStateHands() Execute skipped "+
                              GetNetInfo()+
                              " is in inwentory "+cPlayer.IsObjectInInventory(this)+
                              "\n"); 
        }
        
        if ( this instanceof Weapon )
        {
            if (this != pawn.ActiveWeapon)
                pawn.UseWeapon( (Weapon)this );
            
            if ( pawn instanceof PlayerNet )
            {
                PlayerNet player = (PlayerNet) pawn;
                player.Anims.SetupAnims(player.motion, player.ActiveWeapon);
                player.UpdateMotion();
            }
        }
        
        //TODO: tylko do testow
        if ( cPlayer != null )
            cPlayer.ShowInventory(" "+this+" ChangeStateHands()");  
        //TODO: tylko do testow end
    }

    /**
     * Metoda zwraca informacje czy obiekt znajduje sie 
     * w inwentory podanego pawna
     */
    boolean AmIInInventory( Pawn cPawn )
    {
        return ( (cPawn != null) && (cPawn.IsObjectInInventory( this )) );
    }
    
    void ActionThrowAway()
    {
		LogLine("ActionThrowAway");
        if (Role == ERole._AUTHORITY)
        {
            ThrowAway();
            MsgSendClientThrowAway();
        }
        else
        {
            MsgSendServerThrowAwayRequest();
        }
    }
    
    void ThrowAway()
    {
        //CrashLog("[InvObject.ThrowAway] " + this + " Owner "+ Owner +"\n");
        Pawn owner = Owner;
        if (owner == null)
            return;
        
        if( owner instanceof Player)
        {
            ((Player)owner).BreakWeaponReload();
            ((Player)owner).ForceWeaponGot();
        }
        
        boolean bInHands = (nInvState == EInvObjState._HANDS);

        if ( bInHands )
            owner.WeaponThrowAway();
        
        owner.cInventory.RemoveInvObject( this );
        ChangeInvState( owner, EInvObjState._ONGROUND);

        if (bAttachToMovingPlatformAfterDrop &&
            owner.GetParent() != null)
        {
            AttachAsChildToAndKeepWorldPos(owner.GetParent());
            CallMethodEvery("WatchFallingDown", 0.5f);
        }
        PhysicsDrop( owner.ComputePhysicsDropPosition(), owner.ComputePhysicsDropSpeed());
                        
        // gdy wyrzucilismy bron w zamian pojawia sie noz
        if (bInHands  && owner.ActiveWeapon == null)
        {
            LogD(" bInHands\n");
            if ( owner instanceof Player )
            {
                Player player = (Player)owner;
                player.WeaponToUse = player.GetBestWeapon();
                player.SetState("ChangeWeaponState");
            }
        }
    }
	
	void RemoveFromHands()
	{
        Pawn owner = Owner;
		
		if (nInvState == EInvObjState._HANDS)
		{
            if( owner instanceof Player)
            {
                ((Player)owner).BreakWeaponReload();
                ((Player)owner).ForceWeaponGot();
            }
            
		    owner.WeaponThrowAway();
			if (owner.ActiveWeapon == null)
			{
				if ( owner instanceof Player )
				{
				    Player player = (Player)owner;
				    player.WeaponToUse = player.GetBestWeapon();
				    player.SetState("ChangeWeaponState");
				}
			}
            
		}
	}
    
    void MsgSendServerThrowAwayRequest()
    {
        NetLog.MsgOut( "MSG_SERVER_THROW_AWAY_REQ", this );
        MessageNew( MSG_SERVER_THROW_AWAY_REQ );
        MessageSend();
    }
    
    void MsgRecvServerThrowAwayRequest()
    {
        MessageEnd();
        
        if ( Owner != null )
            ActionThrowAway();
    }
    
    void MsgSendClientThrowAway()
    {
        NetLog.MsgOut( "MSG_CLIENT_THROW_AWAY", this );
        MessageNew( MSG_CLIENT_THROW_AWAY );
        MessagePackInt( GetNextGlobalChangeInvStateCounter() );
        MessageSend();
    }
    
    void MsgRecvClientThrowAway()
    {
        int nChangeStateCounter = MessageUnPackInt();
        MessageEnd();
        
        boolean bVerified = VerifyChangeInvStateCounter( nChangeStateCounter );
        if ( bVerified )
            ThrowAway();
    }
    
    
    
    void MsgSendServerNewGridPos()
    {
        NetLog.MsgOut( "MSG_SERVER_NEW_GRID_POS", this );
        MessageNew( MSG_SERVER_NEW_GRID_POS );
        MessagePackByte(this.nGrid);
        MessagePackByte(this.nCellX);
        MessagePackByte(this.nCellY);
        MessageSend();
    }
    
    void MsgRecvServerNewGridPos()
    {
        byte nG = MessageUnPackByte();
        byte nX = MessageUnPackByte();
        byte nY = MessageUnPackByte();
        MessageEnd();
        
        //najpierw wyciagamy ze starej pozycji
        byte nOldG = this.nGrid;
        byte nOldX = this.nCellX;
        byte nOldY = this.nCellY;
        InvGrid cGrid = cInventory.GetInvGrid(this.nGrid);
        if (cGrid != null)
        {
            cGrid.SetFreeCells( this.nCellY, this.nCellsHeight, 
                                this.nCellX, this.nCellsWidth);
		    cGrid.PrintFreeCells();
        }
        //sprawdzmy czy da sie wetknac na pozycje ktara chce klient
        cGrid = cInventory.GetInvGrid( nG );
        if (cGrid != null && 
            cGrid.AreCellsFree( nY, this.nCellsHeight, nX, this.nCellsWidth) )
        {
            //wszystko, ok
            //wkladamy tu
            SetNewGridPos( cInventory, nX, nY, nG );
        }
        else
        {
            // chyba bylo cos nie tak,
            // przywracamy stara pozycje
            SetNewGridPos( cInventory, nOldX, nOldY, nOldG );
        }
        
        // i nakazujemy to samo zrobic klientowi
        MsgSendClientNewGridPos();
    }
    
    void MsgSendClientNewGridPos()
    {
        NetLog.MsgOut( "MSG_CLIENT_NEW_GRID_POS", this );
        MessageNew( MSG_CLIENT_NEW_GRID_POS );
        MessagePackInt( GetNextGlobalChangeInvStateCounter() );
        MessagePackByte(this.nGrid);
        MessagePackByte(this.nCellX);
        MessagePackByte(this.nCellY);
        MessageSend();
    }
    
    void MsgRecvClientNewGridPos()
    {
        int  nChangeStateCounter = MessageUnPackInt();
        byte nG                  = MessageUnPackByte();
        byte nX                  = MessageUnPackByte();
        byte nY                  = MessageUnPackByte();
        MessageEnd();
        
        boolean bVerified = VerifyChangeInvStateCounter( nChangeStateCounter );
        if ( bVerified )
        {
            //TODO: zastosowanie odebranych pozycji
            //najpierw wyciagamy ze starej pozycji
            InvGrid cGrid = cInventory.GetInvGrid(this.nGrid);
            if (cGrid != null)
            {
                cGrid.SetFreeCells( this.nCellY, this.nCellsHeight, 
                                    this.nCellX, this.nCellsWidth);
		        cGrid.PrintFreeCells();
            }
            //ustawiamy w nowej pozycji
            SetNewGridPos( cInventory, nX, nY, nG );
        }
    }
    
    void MsgSendServerDeleteRequest()
    {
        NetLog.MsgOut( "MSG_SERVER_DELETE_REQ", this );
        MessageNew( MSG_SERVER_DELETE_REQ );
        MessageSend();
    }
    
    void MsgRecvServerDeleteRequest()
    {
        MessageEnd();
        
        // TODO
        // skasowac obiekt (jak mozna)
    }
    
    void MsgSendServerStateRequest()
    {
        MsgSendServerStateRequest( false, null, false );
    }
    
    void MsgSendServerStateRequest(boolean bFullInfo, PlayerNetBaseInventory cPlayer, boolean bRequested)
    {
        if ( Role == ERole._AUTHORITY )
            return;
        
        NetLog.InvObj("SEND MSG_SERVER_STATE_REQUEST "+GetNetInfo()+"\n");
        NetLog.MsgOut( "MSG_SERVER_STATE_REQUEST", this );
        MessageNew( MSG_SERVER_STATE_REQ );
        MessagePackBoolean( bFullInfo );
        if ( bFullInfo )
        {
            MessagePackInt( (cPlayer != null)?cPlayer.GetNetId():-1  );
            MessagePackBoolean( bRequested );//czy chcemy ten obiekt u siebie czy nie
        }
        MessageSend();
    }
    
    void MsgRecvServerStateRequest()
    {
        int nHostId        = MessageGetSenderId();
        boolean bFullInfo  = MessageUnPackBoolean();
        int     nPlayerId  = -1;
        boolean bRequested = false;  
        if ( bFullInfo )
        {
            nPlayerId  = MessageUnPackInt();
            bRequested = MessageUnPackBoolean();
        }
        MessageEnd();
        
        if ( Role < ERole._AUTHORITY )
            return;
        
        if ( bFullInfo )
        {
            PlayerNet cPlayer = GetPlayerNetByNetId( nPlayerId );
            if ( cPlayer != null )
            {
                boolean bIsInInventory = cPlayer.IsObjectInInventory( this );
                if ( (  bIsInInventory  && (!bRequested))||
                     ((!bIsInInventory) && (bRequested)) )
                {
                    //chyba klient ma zla informacje w liscie content
                    //wysylamy mu jeszcze raz liste zawartosci inwentory
                    NetLog.InvObj("SEND MSG_CLIENT_INVENTORY_CONTENT "+
                                  cPlayer.GetNetInfo()+" obj:"+GetNetInfo()+"\n");
                    cPlayer.MsgSendClientInventoryContent();
                }
            }
        }
        MsgSendClientStateToHost( nHostId );
    }

    
    void JustAddedToInventory()
    {
    }
    
    void ActionSetNewGridPos(Inventory cInventory, byte nX,byte nY,byte nZ)
    {
        SetNewGridPos( cInventory, nX, nY, nZ );
        
        if ( Role == ERole._AUTHORITY )
            MsgSendClientNewGridPos();
        else
            MsgSendServerNewGridPos();
    }
        
    void SetNewGridPos(Inventory cInventory,byte nX,byte nY,byte nG)
    {
        SetInvObjCellsGrid( nX,nY,nG );
        
        cInventory.aInvGrids[ nG ].SetTakenCells( nY, nCellsHeight, 
                                                  nX, nCellsWidth ); 
        
        //Log("SetNewGridPos grid:"+nG+" ["+nX+","+nY+"]\n");
    }
    
    /** Zwraca informacje, czy mozna na obiekcie 
     * zawolac Use podczas przycelowania
     */
    boolean CanUseWhileAiming()
    {
        return m_bCanUseWhileAiming;
    }
    
    /** decyduje o powyzszym */
    //TODO: ustalic jakich jeszcze obiektow mozna uzywac, a jakich nie.
    //na razie tylko lornetka jest zabroniona
    boolean m_bCanUseWhileAiming = true;
    

    /** Do gry sieciowej.
     * Przy restarcie levelu niektore obiekty inwentory beda
     * kasowane (i ewentualnie spawnowane w nowym miejscu)
     */
    private boolean m_bDeleteOnLevelRestart = false;
    void    EnableDeleteOnLevelRestart(){ m_bDeleteOnLevelRestart = true; }
    boolean DeleteOnLevelRestartEnabled(){ return m_bDeleteOnLevelRestart; }
    
    /** Do gry sieciowej.
     * Obiekty rozloone na levelu (mapie) beda mogly sie automatycznie
     * spawnowac, tzn 
     * - po restarcie levelu wszystkie obiekty z ustawiona 
     * flaga m_bRespawnOnLevelRestart zostana skasowane i 
     * powtornie wyspawnowane w swojej pozycji poczatkowej
     * i z poczatkowymi parametrami
     * - po podniesieniu obiektu z ziemi przez gracza, po 
     * pewnym czasie wyspawnuje sie taki sam obiekt (tzn tej 
     * samej klasy) w tym samym miejscu. Mozna regulowac zarowno 
     * czasem (opoznieniem) respawnu, jak i ich iloscia
     * 
     * Bedzie to obslugiwane przez ModuleNet.
     */
    
    public boolean m_bRespawnOnLevelRestart = false;//#Net
    boolean RespawnOnLevelRestartEnabled(){ return m_bRespawnOnLevelRestart; }
    
    
    private boolean m_bAutoRespawn = false;
    void EnableAutoRespawn() { m_bAutoRespawn = true; }
    void DisableAutoRespawn(){ m_bAutoRespawn = false; } 
    
    boolean AutoRespawnEnabled()
    {
        return ( m_bAutoRespawn && GetAutoRespawnTime() >= 0.0 && GetAutoRespawnCnt() != 0 );
    }
    
    /** Czas po jakim bedzie spawnowal sie "taki sam" obiekt 
     * od momentu jego uzycia (tzn podniesienia z ziemi)
     */
    public float m_fAutoRespawnTime = 60.0f;//#Net
    float GetAutoRespawnTime()              {   return m_fAutoRespawnTime;   }
    void  SetAutoRespawnTime(float fTime)   {   m_fAutoRespawnTime = fTime;  }
    
    /** Ilosc automatycznych respawnow, 
     * jesli  0 to obiekt pojawi sie tylko raz na starcie. (TODO: checkit)
     * jesli -1 to obiekty beda sie respawnowac w nieskonczonosc
     */
    public int   m_nAutoRespawnCnt  = -1;//#Net
    int   GetAutoRespawnCnt()               {   return m_nAutoRespawnCnt;    }
    void  SetAutoRespawnCnt(int nCnt)       {   m_nAutoRespawnCnt = nCnt;    }
    
    /** Przeslanie do NetModule informacji o tym aby za jakis
     * czas wyspawnowal sie taki sam obiekt w tym samym miejscu
     */
    void AddToAutoRespawnIfNeeded()
    {
        Module cModule = GetModule();
        if ( cModule instanceof ModuleNet )
        {
            ((ModuleNet)cModule).AddInvObjectToAutoRespawn( this );
        }
    }
    
    void ServerRespawn( InvObjectSpawnInfo cSpawnInfo, float fDelayTime )
    {
        //ustawiamy na pozycji
        super.ServerRespawn( cSpawnInfo, fDelayTime );
        
        //i ustawiamy mu parametry respawnu na przyszlosc...
        SetAutoRespawnTime( cSpawnInfo.m_fAutoRespawnTime );
        SetAutoRespawnCnt( cSpawnInfo.m_nAutoRespawnCnt );
    }
    
    /** Do gry sieciowej.
     * Kazdy obiekt wyrzucony przez gracza po jego smierci
     * (ktory byl wyspawnowany przy starcie levelu, albo
     * w inwentory gracza przy jego spawnie) bedzie przez pewien 
     * czas dostepny dla innych, po czym (jesli nie zostanie 
     * uzyty przez nikogo) zostanie skasowany
     * 
     * Bedzie to obslugiwane przez ModuleNet.
     */
    void RespawnedOnLevel()
    {
        EnableDeleteOnLevelRestart();
        EnableAnnihilateIfNotUsed();
        EnableAutoRespawn();//TODO: enable czy disable?
    }
    
    void RespawnedInInventory()
    {
        EnableDeleteOnLevelRestart();
        EnableAnnihilateIfNotUsed();
    }
        
    /**
     * czy obiekt sam sie skasuje jesli nie zostanie
     * uzyty po smierci swojego wlasciciela
     */  
    private boolean m_bAnnihilateIfNotUsed = false;
    void    EnableAnnihilateIfNotUsed(){ m_bAnnihilateIfNotUsed = true; }
    /**
     * czas po jakim obiekt zniknie (sam sie skasuje) jesli nie 
     * zostanie uzyty przez kogos innego po smierci swojego wlasciciela
     * Jezeli < 0.0f to obiekt _nigdy_ nie zniknie
     */  
    public float m_fTimeToAnnihilateIfNotUsed = 20.0f;//#Net
    
    /** Zaplanowanie skasowania obiektu za jakis czas,
     * jesli obiekt w miedzyczasie zostanie uzyty, to do 
     * skasowania nie dojdzie
     */
    boolean ScheduleAnnihilateIfNotUsed()
    {
        // odwolanie poprzedniego zaplanowanego kasowania
        DisableCallMethod( METHOD_AnnihilateIfNotUsedDo );
        // nowe zaplanowanie kasowania
        if ( m_bAnnihilateIfNotUsed && m_fTimeToAnnihilateIfNotUsed >= 0.0f )
        {
            NetLog.RespawnObj(" ScheduleAnnihilate "+GetNetInfo()+
                              " RespawnCnt "+m_nAutoRespawnCnt+ 
                              " RespawnTime "+m_fAutoRespawnTime);
            CallMethodIn( METHOD_AnnihilateIfNotUsedDo,
                          m_fTimeToAnnihilateIfNotUsed );
            return true;
        }
        return false;
    }
    
    /** Odwolanie zaplanowanego skasowania obiektu
     */
    void CancelAnnihilateIfNotUsed()
    {
        DisableCallMethod( METHOD_AnnihilateIfNotUsedDo );
    }
    /** Egzekucja zaplanowanego skasowania obiektu
     */
    private void AnnihilateIfNotUsedDo()
    {
        if ( GetModule() instanceof ModuleNetBase )
        {
            NetLog.RespawnObj(" Annihilate "+GetNetInfo()+
                              " RespawnCnt "+m_nAutoRespawnCnt+ 
                              " RespawnTime "+m_fAutoRespawnTime);
            NetObjectsManager cObjMgr = ((ModuleNetBase)GetModule()).GetObjectsManager();    
            if ( cObjMgr != null )
            {
                cObjMgr.DeleteObject( this );
                return;
            }
        }
        delete();
    }
    
    void AddedToSpareList()
    {
        SetStateSpare();
        MsgSendClientState();
    }
    
    void Clean()
    {
        Owner = null;
        DisableAllWaitingMethod();
        CancelAnnihilateIfNotUsed();
        DisableCallMethod("delete");
    }
	
    void InGameMovieStart()
    {
        
    }
    
    void InGameMovieEnd()
    {
    }
    
    //*********************************************************
	//					SaveGame
    //*********************************************************
	
    /** Metoda wczytujaca zapisane dane w Save gracza
     */	
    public void SGLoadChunk(FileChunk cParentFC)
    {	
		FileChunk.Log("[InvObject.SGLoadChunk]\n");
		
		FileChunk cFC = GameObject.LoadChunk(cParentFC);   
		
        if (cFC.GetID() == ESGChunksChrome._CHK_INV_OBJECT)
        {	
			super.SGLoadChunk(cFC);
			
			// Wektor normalny ulozenia przedmiotu na ziemi
			vUpOnGround = cFC.LoadVector();			
			
			// indeks potrzebny do sortowania przedmiotow w INV
			nInvIndex = cFC.LoadInt();
			// stan obiektu
			nInvState = cFC.LoadInt();
			// polozenie przedmiotu w plecaku
			nCellX = (byte)cFC.LoadInt();
			nCellY = (byte)cFC.LoadInt();
			// numer grida w inventory
			nGrid = (byte)cFC.LoadInt();
            
            // kto jest wlascicielem tego przedmiotu jesli nikt - lezy na ziemi - to NULL
			Owner = (Pawn)cFC.LoadObjectRef();
			
            // referencja do inventory w ktorym znajduje sie przedmiot
            if(Owner != null)
			    cInventory = (Inventory)Owner.cInventory;
            else
			    cInventory = null;
        }
		
		cFC.delete();
    }
    
    /** Metoda zapisujaca dane do Save gracza
     */	
    public void SGSaveChunk(FileChunk cFCParent)
    {
		FileChunk.Log("[InvObject.SGSaveChunk]\n");
		
        FileChunk cFC = NewChunk(ESGChunksChrome._CHK_INV_OBJECT, cFCParent);
		
		super.SGSaveChunk(cFC);
		    
		// Wektor normalny ulozenia przedmiotu na ziemi
		cFC.SaveVector(vUpOnGround);			
		// indeks potrzebny do sortowania przedmiotow w INV
		cFC.SaveInt(nInvIndex);
		// stan obiektu
		cFC.SaveInt(nInvState);
		// polozenie przedmiotu w plecaku
		cFC.SaveInt(nCellX);
		cFC.SaveInt(nCellY);
		// numer grida w inventory
		cFC.SaveInt(nGrid);
    	
        // kto jest wlascicielem tego przedmiotu jesli nikt - lezy na ziemi - to NULL
		cFC.SaveObjectRef(Owner);
        
        cFC.delete();
    }	    	
	
	public void SGUpdate()
	{
		FileChunk.Log("[InvObject.SGUpdate]\n");
		
		super.SGUpdate();

		if (Owner instanceof Player)
		{
			Player player = (Player)Owner;
			if (player.nCameraGameMode != CameraPlayer.CMODE_FPP)
				ChangeInvState(Owner,nInvState);
		}
        
        if (cInvObjSprite != null)
            cInvObjSprite.SGUpdate();
            
        fLastForceFieldCollision = 0;
	}
    
    private boolean m_bInborn = false;
    boolean IsInborn(){ return m_bInborn; }
    
    //ustawienie obiektu w tryb Inborn, to znaczy ze
    //gracz sie z tym obiektem urodzil i nie moze go stracic
    void SetInborn()
    {
        m_bInborn = true;
        bLocked = true;
        bHidden = true;
    }
    
    /**
     * W grze sieciowej po smierci gracza obiekty w jego 
     * inventory zostana rozstawione obok trupka
     * Dla niektorych z nich trzeba zawoac fizyczne
     * wurzycenie, zeby czasem obiekt nie wpadl w 
     * drzewo, czy sciane.
     * Taki obiektem jest np FlagaCTF'owa
     */
    boolean m_bThrowAwayOnRemoveFromInventory = false;
    boolean ThrowAwayOnRemoveFromInventory()
    {
        return m_bThrowAwayOnRemoveFromInventory;
    }
    

    String GetNetInfo()
    { 
        return super.GetNetInfo()+
               " state:"+EInvObjState.GetName(nInvState)+
               ((Owner!=null)?(" owner:"+Owner.GetNetInfo()):"")+
                (bDeleted?" DELETED!":""); 
    }
    
    
    /**
     * Do testow ustawiania pozycji obiektu
     */
    
    
    /**
     * Metody sustawiania pozycji nadpisuje i 
     * za kazdym razem wolam stack tracea...
     */ 
    /*    
    public void SetPosition( Vector vPos )
    {
        super.SetPosition( vPos );
        CrashLogDumpStack();
    }
    
    public void SetPositionWorld( Vector vPos )
    {
        super.SetPositionWorld( vPos );
        CrashLogDumpStack();
    }
    
    public void FromUpForwardPos(Vector vUp, Vector vForward, Vector vPos)
    {
        super.FromUpForwardPos( vUp, vForward, vPos );
        CrashLogDumpStack();
    }
    //*/
    
    void CrashLogDumpStack()
    {
        NetLog.Test( GetNetInfo()+" pos: "+GetPosition()+"\n");
        Thread.dumpStack();
    }
    
    void MsgSendClientVerifyPos()
    {
        NetLog.MsgOut( "MSG_CLIENT_VERIFY_POS", this );
        MessageNew( MSG_CLIENT_VERIFY_POS );
        MessagePackVector( GetPosition() );
        MessageSend();
    }
    
    void MsgRecvClientVerifyPos()
    {
        Vector vPos = MessageUnPackVector();
        MessageEnd();
        
        if ( vPos.Distance2( GetPosition() ) > 0.1f )
        {
            NetLog.Test("**********************************************\n");
            NetLog.Test("******    ERROR  - VERIFY POS FAILED   *******\n");
            NetLog.Test( GetNetInfo()+
                        " pos: "+GetPosition()+
                        " server pos: "+vPos+
                        "\n");
            NetLog.Test("**********************************************\n");
            
            MsgSendServerVerifyResults( false );
        }
    }
    
    void MsgSendServerVerifyResults(boolean bSuccess)
    {
        NetLog.MsgOut( "MSG_SERVER_VERIFY_RESULTS", this );
        MessageNew( MSG_SERVER_VERIFY_RESULTS );
        MessagePackBoolean( bSuccess );
        MessageSend();
    }
    
    void MsgRecvServerVerifyResults()
    {
        boolean bSuccess = MessageUnPackBoolean();
        MessageEnd();
        
        if ( ! bSuccess )
            CancelAnnihilateIfNotUsed();
    }

}


/** Struktura przechowujaca informacje na temat inwentory obiektu
 * pomocna w InventoryRoom
 */
class NewInvObjectInfo
{
    String m_sClassName = null;
    int    m_nNetId     = -1;
    int    m_nInvType   = 0;
    byte    m_nGrid      = 0;
    byte    m_nCellX     = 0;
    byte    m_nCellY     = 0;
        
    NewInvObjectInfo()
    {
    }
    
    NewInvObjectInfo(String sClassName,int nInvType,byte nGrid, byte nCellX, byte nCellY)
    {
        m_sClassName = sClassName;
        m_nInvType   = nInvType;
        m_nGrid      = nGrid;
        m_nCellX     = nCellX;
        m_nCellY     = nCellY;
    }
    
    NewInvObjectInfo(int nNetId,int nInvType,byte nGrid, byte nCellX, byte nCellY)
    {
        m_nNetId     = nNetId;
        m_nInvType   = nInvType;
        m_nGrid      = nGrid;
        m_nCellX     = nCellX;
        m_nCellY     = nCellY;
    }    
}
