/**
 */
public class Ammo extends InvObjectInst
{
    byte eAmmoType = EAmmoType._9mmShort;

    // ile jest amunicji w pudelku(Ammo) maksymalnie
    public int nCapacity = 100;//#AMMO;Max ammo
     
    // ile jest obecnie w pudelku
    public int nCount = 100;//#AMMO;Start ammo
	
	// ile defaultowo jest w pudelku
	int nDefaultCount = 0;

    Ammo()
    {
        super();

        // MeshObject
        MeshName="Data/Meshes/Equipment/Pocisk.3DA";        
        
        nOnTexPosX = 0;
        nOnTexPosY = 220;
    
        // rozmiary tekstury
        nTexSizeX = 256.0f;
        nTexSizeY = 256.0f;
        
        // inventory object
        nInvType = EInvObjType._AMMO;
        nCellsWidth = 3;
        nCellsHeight = 2;
        sName = "Generic Ammo";
        sTexFileName = "Data/Textures/CH_I_Weapons4.png";
    }
	
	public void OnCreate()
	{
		super.OnCreate();
		
        if (GetModule() instanceof ModuleNet)
          nCount = nCapacity;
        
		nDefaultCount = nCount;
	}
    
    void Clean()
    {
        super.Clean();
        nCount = nCapacity = nDefaultCount;
        m_bExploded = false;
        bDead = false;
    }
    
    public String GetInvName()
    {
        return (super.GetInvName() + " " + nCount + "/" + nCapacity);
    }
	
    public void OnTakeDamage(float fDamage, float fPhSimDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed, int nMeshElementorBoneID, int nDamageType)
    {
        if (bDead || Role < ERole._AUTHORITY)
			return;

        Damage(fDamage, nDamageType);
    }
    
    boolean m_bExploded = false;
    
    /** Wolane gdy Actor umiera*/
    public void Die() 
    {
        super.Die();
        
        EnableRendering(false);
        DeactivateOnModuleAlways();
        ExecuteFX(this, "FXBlowAmmo", GetUpVector());
        ExecuteParticleSystem(this, "FXBlowAmmo", new Vector(), GetUpVector());
        m_bExploded = true;
        
        if ( Role == ERole._AUTHORITY )
            MsgSendClientExplode();
    }

    boolean ServerVerifyActionExecute( Actor cExecutor, float fMaxDistance )
    {
        return super.ServerVerifyActionExecute( cExecutor, fMaxDistance )&&
               (!m_bExploded);
    }
    
    static final int MSG_CLIENT_EXPLODE      = 50;
    static final int MSG_CLIENT_COUNT        = 51;
    
    /** Odebranie komunikatow przychodzacych z sieci
     */
    public void OnMessage()
    {
        switch ( MessageGetId() )
        {
        case MSG_CLIENT_EXPLODE:
            LogD(" MSG_CLIENT_EXPLODE\n");
            MsgRecvClientExplode();
            break;
            
        case MSG_CLIENT_COUNT:
            LogD(" MSG_CLIENT_COUNT\n");
            MsgRecvClientCount();
            break;            
            
        default:
            super.OnMessage();
        }
    }
    
    
    /**
     * Globalny licznik zmian stanow obiektow
     * Bedzie on wykorzystywany na klientach do rozstrzygania czy dana
     * akcja (ktora zleca nam serwer) ma sie wykonac czy nie (bo jest stara)
     * TODO: dac szerszy opis
     */
    private static 
    ChangeStateCounter sm_cGlobalChangeCountCounter = new ChangeStateCounter();
    static void CleanGlobalChangeCountCounter() { sm_cGlobalChangeCountCounter.Clean(); }
    static int  GetNextGlobalChangeCountCounter(){ return sm_cGlobalChangeCountCounter.GetNext(); }
    
    /**
     * Indywidualny licznik zapamietujacy ostatnio
     * odebrana i wykonana akcje na tym obiekcie
     */
    private 
    ChangeStateCounter m_cChangeCountCounter = new ChangeStateCounter(this);
    boolean VerifyChangeCountCounter( int nCounter ){ return m_cChangeCountCounter.Verify( nCounter ); }

    
    // wyslanie komunikatu o stanie obiektu
    void MsgSendClientExplode()
    {
        MessageNew( MSG_CLIENT_EXPLODE );
        MessageSend();
    }
    
    // odbranie stanu obiektu
    void MsgRecvClientExplode()
    {
        MessageEnd();
        
        Die();
    }

    //wyslanie ilosci amunicji
    void MsgSendClientCount()
    {
        MessageNew( MSG_CLIENT_COUNT );
        PackCount();
        MessageSend();
    }
    
    // odbranie ilosci amunicji
    void MsgRecvClientCount()
    {
        UnPackCount();
        MessageEnd();
        
        if ( VerifyChangeCountCounter( m_nReceivedCountCounter ) )
            ApplyCount();
    }
    
    void PackAdditionalData()
    {
        super.PackAdditionalData();
        PackCount();
    }
    void UnPackAdditionalData()
    {
        super.UnPackAdditionalData();
        UnPackCount();
    }
    void ApplyAdditionalData(boolean bVerified)
    {
        super.ApplyAdditionalData( bVerified );
        
        if ( VerifyChangeCountCounter( m_nReceivedCountCounter ) )
            ApplyCount();
    }
    
    void PackCount()
    {
        MessagePackInt( GetNextGlobalChangeCountCounter() );
        MessagePackInt( nCount );
    }
    
    int m_nReceivedCountCounter = 0;
    int m_nReceivedCount        = 0;
    
    void UnPackCount()
    {
        m_nReceivedCountCounter = MessageUnPackInt();
        m_nReceivedCount        = MessageUnPackInt();
    }
    
    void ApplyCount()
    {
        nCount = m_nReceivedCount;
    }


    //*********************************************************
	//					SaveGame
    //*********************************************************
	
    /** Metoda wczytujaca zapisane dane w Save gracza
     */	
    public void SGLoadChunk(FileChunk cParentFC)
    {	
		FileChunk.Log("[Ammo.SGLoadChunk]\n");
		
		FileChunk cFC = GameObject.LoadChunk(cParentFC);   
		
        if (cFC.GetID() == ESGChunksChrome._CHK_AMMO)
        {	
			super.SGLoadChunk(cFC);
			
			// ile jest obecnie w pudelku
			nCount = cFC.LoadInt();
        }
		
		cFC.delete();
    }
    
    /** Metoda zapisujaca dane do Save gracza
     */	
    public void SGSaveChunk(FileChunk cFCParent)
    {
		FileChunk.Log("[Ammo.SGSaveChunk]\n");
		
        FileChunk cFC = NewChunk(ESGChunksChrome._CHK_AMMO, cFCParent);
		
		super.SGSaveChunk(cFC);

		// ile jest obecnie w pudelku
		cFC.SaveInt(nCount);
    				        
        cFC.delete();
    }	    		
}
