public class AmmoGrenadeFlashFree extends AmmoGrenadeFree
{
    public float fFlashDuration = 7.f;//#AMMO_GRENADE_FLASH_FREE;Overall flash duration [s]
    public float fFlashStrength = 1.4f;//#AMMO_GRENADE_FLASH_FREE;Start intensity multiplier (must be >0)
    public float fMaxIntensity = 2.0f;//#AMMO_GRENADE_FLASH_FREE;Maximum flash intensity (for flash saturation)

    AmmoGrenadeFlashFree()
    {
        sName = "Grenades Flashes";
        MeshName= "Data/Meshes/Equipment/granat_zaczepny.3da";
        fHealth = 1.0f;
        fDamage = 5.0f;
        fPhysicsSimDamage = fDamage;
        fBlastDamage = 100.0f;
        fPhysicsSimBlastDamage = fBlastDamage;
        fBlastRadius = 5000.0f;
        fStartSpeed = 100.0f;
        fSpeedUpdateTime = 0.1f;
        sSoundExplodeName = "Data/Sounds/Weapon/FlashGrenadeExplosion";
        sSoundCollisionName = "Data/Sounds/Weapon/FlashGrenadeHitLevel02";
        sFXHitName = "FXBlowBarrel";
    }

    public void OnCreate()
    {
        super.OnCreate();
        SetPhysicsActive(false);
    }

    public void Init(GameObject cBulletOwner)
    {
        super.Init(cBulletOwner);
    }
    
    /**Wybuchamy bullet i odbieramy wszystkim w promieniu odpowiednia ilosc energii*/
    void Explode()
    {
        Vector vMyPos = GetPosition();

		//fx'y
        ExecuteFX(sFXHitName, vMyPos);
		PlaySound(sSoundExplodeName, vMyPos);

		//zbieramy ofiary wybuchu
        GameObject []aVictim = GetObjectsInRadiusFromClass(fBlastRadius,"Actor");

        if ( aVictim != null )
        {
            for ( int index = 0 ; index < aVictim.length ; index++ )
            {
                Vector vVictimPos = ((ControlObject)aVictim[index]).GetPosition();
                float fDis = vVictimPos.Distance(vMyPos);

                if (fDis < fBlastRadius) //jestesmy w zasiegu razenia
                {
                    Vector vFromCenter = new Vector(vVictimPos);
                    vFromCenter.Sub(vMyPos);
					vFromCenter.Normalize();
					vFromCenter.Mul(fBlastSpeed);

                    //flash jest interpolowany liniowo na caly fBlastRadius
                    float fDam = (fBlastRadius - fDis) * fBlastCoeff;
                    
                    //TODO do zmiany
                    //do uwzglednienia przeskody, kierunek patrzenia itp
                    if(aVictim[index] instanceof Player)
                    {
                        Camera cCamera = GetModule().GetActiveCamera();
                        if(cCamera instanceof CameraExtended)
                        {
                            ((CameraExtended)cCamera).Flash(CameraExtended._FLASH_WHITE, 
                                                            fFlashDuration, 
                                                            fFlashStrength * fDam / 100.0f, 
                                                            fMaxIntensity);
                        }
                    }
                }
            }
        }
        DeactivateOnModuleAlways();
        bExploded = true;
		
		CallMethodIn("delete", 0);
        //cOwner.CallMethodIn("RemoveBullet",0.1f);
    }
}
