public class AmmoGrenadeFree extends AmmoBulletFree
{
    AmmoGrenadeFree()
    {
        sName = "Grenades Grenades";
        MeshName= "Data/Meshes/Equipment/granat_zaczepny.3DA";
        fHealth = 1.0f;
        fDamage = 10.0f;
        fPhysicsSimDamage = fDamage;
        fBlastDamage = 1000.0f;
        fPhysicsSimBlastDamage = fBlastDamage;
        fBlastRadius = 1000.0f;
        fStartSpeed = 100.0f;
        fSpeedUpdateTime = 0.1f;
        sSoundExplodeName = "Data/Sounds/Weapon/GrenadeExplosion";
        sFXHitName = "FXBlowGrenade";
    }

    /** Dzwiek odpalany przy kolizji granatu z podlozem */
    public String sSoundCollisionName = "Data/Sounds/Weapon/GrenadeHitMetal.wav";
    
    /**Czas liczony od rzucenia po jakim granat eksploduje - podany w sekundach*/
    public float fExplodeTime = 3.0f;
    /**Sila rzutu granatu*/
    public float fThrowForce = 0.0f;  
    /**O ile jest zmniejszana predkosc granatu podczas lotu co fSpeedUpdateTime*/
    public float fReduceSpeed = 100.0f;
    Vector vDir = null;
    
    /** Minimalna przerwa miedzy odpalaniem dzwiekow uderzenia granata */
    public float fHitSoundDelay = 0.3f;
    
    
    /**z jaka predkoscia maksymalnie moze krecic sie granat (wokol kazdej z osi)  */
    float  m_fRotateMaxSpeed  = 800.0f;
    /**wektor rotacji losowany przy wyrzucie granatu (oraz po odbiciu sie granatu od ziemi)
     * granat moze sie precic wokol kazdej z osi z pradkoscia z przedzielu
     * -m_fRotateMaxSpeed .. +m_fRotateMaxSpeed */
    Vector m_vRotate          = null;
    /** czas ostatniego obrotu granatu */
    float  m_fRotateLastTime  = 0;
    

    
    
    public void OnCreate()
    {
        super.OnCreate();
        SetMass(80.0f);
        SetPhysicsType(EPhysics._FALL);
        SetCollAction(ECollFlags.OBJCOL_ACTION_BOUNCE);
    }

    public void Init(GameObject cBulletOwner)
    {
        super.Init(cBulletOwner);
    }

    void Start( float fForce , Vector vDirection )
    {
         //SetDir(vDirection);
        vDir = new Vector(vDirection);
        RotateInit( m_fRotateMaxSpeed );
        fThrowForce = fForce;
        SetState("Flying");
    }

    void RotateInit(float fRotateSpeed)
    {
        m_vRotate           = new Vector( -fRotateSpeed, -fRotateSpeed, -fRotateSpeed );
        m_vRotate.fX       += 2.0f * RandomFloat( fRotateSpeed );
        m_vRotate.fY       += 2.0f * RandomFloat( fRotateSpeed );
        m_vRotate.fZ       += 2.0f * RandomFloat( fRotateSpeed );
        m_fRotateLastTime   = GetTime();
    }
    
    void Rotate()
    {
        if ( GetSpeedValue() > fStartSpeed * fThrowForce * 0.01f )
        {
            float fTime       = GetTime();
            float fDeltaTime  = fTime - m_fRotateLastTime;
            m_fRotateLastTime = fTime;

            RotateLocal( new Vector(1,0,0), m_vRotate.fX * fDeltaTime );
            RotateLocal( new Vector(0,1,0), m_vRotate.fY * fDeltaTime );
            RotateLocal( new Vector(0,0,1), m_vRotate.fZ * fDeltaTime );
        }
    }
    
    public class Flying extends AmmoBulletFree.Flying  
    {
        public void OnEnter()
        {			
            super.OnEnter();
            fSpeed = fStartSpeed * fThrowForce;
            vDir.Mul(fSpeed);
            SetSpeed(vDir);
            CallMethodIn("Explode",fExplodeTime);
            //CallMethodIn("SpeedUpdate",fSpeedUpdateTime);
        }

        void SpeedUpdate()
        {
            //LogD("Zmniejszamy predkosc granatu \n");
			//LogD("pozycja: "+GetPosition()+" owner:"+cOwner.GetPosition());
            //fSpeed = fSpeed - fReduceSpeed;
            //SetLocalSpeed(new Vector(0.0f,0.0f,fSpeed));
        }
        
        void OnFrame()
        {
            super.OnFrame();
            
            Rotate();
        }

        /**Gdy ktos nas trafi to wybuchamy*/
/*        public void OnTakeDamage(float fDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed, int nDamageType)
		{
            super.OnTakeDamage(fDamage,Assassin,vHitLocation,vSpeed,nDamageType);
        }
*/		
		// poprawione OnTakeDamage //////////////////////////////////////////////////////////////
		public void OnTakeDamage(float fDamage, float fPhSimDamage, GameObject Assassin, Vector vHitLocation,
								 Vector vSpeed, int nMeshElementorBoneID, int nDamageType)
		{
            super.OnTakeDamage(fDamage, fPhSimDamage, Assassin, vHitLocation, vSpeed, nMeshElementorBoneID, nDamageType);
		}

        float fLastHitSoundTime = 0;
        
        /** Kolizja redukuje predkosc granatu */
        public void OnCollisionFullInfo(ControlObject Col,Vector v1,Vector v2)
        {
            super.OnCollisionFullInfo(Col,v1,v2);
            float fCurrentSpeed = GetSpeedValue() * 0.4f;
            SetSpeedValue(fCurrentSpeed);
            //SetLocalSpeed(new Vector(0.0f,0.0f,0.0f));
            
            RotateInit( m_fRotateMaxSpeed );
            float fTime = GetTime();
            if (fTime - fLastHitSoundTime > fHitSoundDelay)
            {
                PlaySound(sSoundCollisionName, GetPosition());
                fLastHitSoundTime = fTime;
            }
        }
		
 		//*********************************************************
		//					SaveGame
		//*********************************************************
				
		public void SGLoad(FileChunk cParentFC)
		{
			FileChunk.Log("[AmmoGrenadeFree$Flying] : SGLoad\n");
			
			FileChunk cFC = GameObject.LoadChunk(cParentFC);   
		
			if (cFC.GetID() == ESGChunksChrome._CHK_AMMO_GRENADE_FREE_FLYING_STATE)
			{
				super.SGLoad(cFC);
		
				fLastHitSoundTime = cFC.LoadFloat();				
			}
			
			cFC.delete();
		}
	
		public void SGSave(FileChunk cParentFC)
		{
			FileChunk.Log("[AmmoGrenadeFree$Flying] : SGSave\n");
			
			FileChunk cFC = NewChunk(ESGChunksChrome._CHK_AMMO_GRENADE_FREE_FLYING_STATE, cParentFC);
			
			super.SGSave(cFC);
			
			cFC.SaveFloat(fLastHitSoundTime);
			
			cFC.delete();
		}
		
		public void SGUpdate()
		{
			FileChunk.Log("[AmmoGrenadeFree$Flying] : SGUpdate\n");
	
            fSpeed = fStartSpeed * fThrowForce;
            vDir.Mul(fSpeed);
            SetSpeed(vDir);
		}		
    }
	
 	//*********************************************************
	//					SaveGame
	//*********************************************************
				
	public void SGLoadChunk(FileChunk cParentFC)
	{
		FileChunk.Log("[AmmoGrenadeFree.SGLoadChunk]\n");
			
		FileChunk cFC = GameObject.LoadChunk(cParentFC);   
		
		if (cFC.GetID() == ESGChunksChrome._CHK_AMMO_GRENADE_FREE)
		{
			super.SGLoadChunk(cFC);
			
			// Sila rzutu granatu
			fThrowForce = cFC.LoadFloat();
			// Kierunek lotu granatu
			vDir = cFC.LoadVector();			
			// wektor rotacji
			m_vRotate = cFC.LoadVector();
			// czas ostatniego obrotu granatu 
			m_fRotateLastTime = cFC.LoadFloat();					
		}
			
		cFC.delete();
	}
	
	public void SGSaveChunk(FileChunk cParentFC)
	{
		FileChunk.Log("[AmmoGrenadeFree.SGSaveChunk]\n");
			
		FileChunk cFC = NewChunk(ESGChunksChrome._CHK_AMMO_GRENADE_FREE, cParentFC);
			
		super.SGSaveChunk(cFC);
		
		// Sila rzutu granatu
		cFC.SaveFloat(fThrowForce);
		// Kierunek lotu granatu
		cFC.SaveVector(vDir);
		// wektor rotacji
		cFC.SaveVector(m_vRotate);
		// czas ostatniego obrotu granatu 
		cFC.SaveFloat(m_fRotateLastTime);		
			
		cFC.delete();
	}
		
	public void SGUpdate()
	{
		FileChunk.Log("[AmmoGrenadeFree.SGUpdate]\n");
			
		super.SGUpdate();			      
	}			
}
