public class GrenadeCluster extends Grenade
{
    int _PIECE_COUNT = 6;
    float _PIECE_FORCE = 6;
    float _PIECE_BLAST_DAMAGE = 400;
    
    GrenadeCluster()
    {
        sName = "Grenades";
        MeshName= "Data/Meshes/Equipment/TPPGrenadeCluster.3DA";
        
        fHealth = 1.0f;
        fDamage = 10.0f;
        fDirectHitDamage = 0;
        fPhysicsSimDamage = fDamage;
        fBlastDamage = 200.0f;
        fPhysicsSimBlastDamage = fBlastDamage;
        fBlastRadius = 300f;
        fStartSpeed = 100.0f;
        sSoundExplodeName = "Data/Sounds/Weapon/GrenadeExplosion";
        sFXHitName = "FXGrenadeCluster";
        fExplodeTime = 2.5f;
        
        fLightScaleExplosion = 600;
        fLightScaleFlight = 1;
    }
    
    void Start( float fForce , Vector vPos, Vector vDir, float fTime )
    {
        String sAnimFile = "Data/Meshes/Equipment/TPPGrenadeCluster.scr";
        InitAnimSeqFile(sAnimFile);
        ClearFlag(EFlags._NO_ANIMATION);
        ClearFlag(EFlags._NO_ANIMATION_REFRESH);
        PlayAnim("odbezpieczony", 1);//GetFirstFrame(CharacterAnims.Anims[Anims.A_DRIVE_SPEEDER]), -1);
        super.Start(fForce , vPos, vDir, fTime );
    }
    /**Wybuchamy bullet i odbieramy wszystkim w promieniu odpowiednia ilosc energii*/
    void Explode()
    {
        super.Explode();
        
        for (int i = 0; i < _PIECE_COUNT; i ++)
        {
            Vector vPos = GetPosition();
            
            Vector vDir = new Vector(0, 0.25f + RandomFloat(0.5f), 0);
            vDir.fZ += RandomFloat(1f);
            vDir.fX += RandomFloat(1f);
            if (RandomFloat(1) < 0.5f)
                vDir.fX *= -1;
            if (RandomFloat(1) < 0.5f)
                vDir.fZ *= -1;
            
            vDir.Normalize();
            
            GrenadeClusterPiece cPiece = (GrenadeClusterPiece)CreateObject("GrenadeClusterPiece");
            GetModule().AddControlObject(cPiece);
            cPiece.SetPosition(vPos);
            cPiece.Init(cWeaponOwner);
            cPiece.Owner = Owner;
            ((Grenade)cPiece).Start(_PIECE_FORCE - RandomFloat(1), vDir);
            
            cPiece.ClearFlag(EFlags._COLLISION);
        }
        
		CallMethodIn("delete", 5f);
        //cOwner.CallMethodIn("RemoveBullet",0.1f);
    }
}
