/** drug zwiekszajacy energie neural gracza
 */
public class DrugNeuralHealthex extends Drug
{
    DrugNeuralHealthex()
    {
        super();
        
        MeshName="Data/Meshes/Equipment/Drag_neural.3da";
        
        nInvIndex = _E_DRUG_NEURALHEALTH;
        nInvType = EInvObjType._EQUIP;
        sName = "&E_N_NEURAL_HEALTHEX&";
        sInfo = "&E_D_NEURAL_HEALTHEX&";
        sTexFileName = "Data/Textures/CH_I_Weapons2.png";
        nCellsWidth = 1;
        nCellsHeight = 2;
        
        //wspolrzedne polozenia na teksturze
        nOnTexPosX = 0.0f;
        nOnTexPosY = 160.0f;
        
        //rozmiary tekstury
        nTexSizeX = 256.0f;
        nTexSizeY = 256.0f;
        
        // Nazwa i sciezka do tekstury ktora ma pojawiac sie na HUDzie po wciagnieciu druga
        sHUDTexFileName = "Data/Textures/healthpack.png";
        
        // Wspolrzedne na teksturze ikonki pojawiajacej sie na HUDzie
        
        nHUDOnTexPosX = 0;
        nHUDOnTexPosY = 0;
        
        // rozmiary tekstury z ikonka druga pojawiajacego sie na HUDzie
        
        nHUDTexSizeX = 32.0f;
        nHUDTexSizeY = 32.0f;
        
        // Rozmiar ikonki druga na texturze
        
        nOnTexSizeX = 32;
        nOnTexSizeY = 32;
        
        /** poziom toksycznosci drug'a */
        fDrugToxicLevel = 0.f;
        
        fDurationTime = fHealthUnitAdding/fAddingSpeed;

    }
    /** dzwiek, ktory wczytywany jest podczas uzycia
     */        
    public String sWave = "Data/Sounds/DrugInjection.wav";//#EXPLOSIVES

    //---------------------------------------------
    // **** atrybuty specyficzne dla tego druga ***
    //---------------------------------------------
    
    /** ilosc procentow antytoksycznosci dodawanych graczowi po uzyciu
     */
    float fHealthUnitAdding = 100.0f;
    
    /** ilosc jednostek jakie dodawane sa graczowi w podanej jednostce czasu
     */
    float fAddingUnits = 20.0f;
    
    /** co jaki czas graczowi dodawana jest okreslona ilosc jednostek zdrowia (w sec)
     */
    float fAddingSpeed = 0.1f;
    
    
    /** pomocnicze zmienne
     */    
    float fUnitAlreadyAdded = 0.0f;
    
    public void Use()
    {
        super.Use();
        fDurationTime = (fHealthUnitAdding/fAddingUnits)*fAddingSpeed;
        
        if (Owner!=null)
        {
            RemoveDrugFromInventory();
            PlayerHUD playerH = (PlayerHUD) Owner;
            
            if ( playerH != null && playerH.bNetIsOwner )
                playerH.PlayWave(sWave);        
            
            // wyslanie komunikatu do modulu ze gracz uzyl lekarstwa
            if ( GetModule() != null && GetModule() instanceof ChromeModuleSingle )
            {
                //TODO((ChromeModuleSingle)GetModule()).MessageToHints( HintManager._MSG_NEURALHEALTHEXUSED );
            }
        }
        fUnitAlreadyAdded = 0.0f;
        CallMethodEvery("AddingUnits",fAddingSpeed);
    }
    
    void AddingUnits()
    {
        if (Owner!= null)
        {
            if (fUnitAlreadyAdded >= fHealthUnitAdding)
            {
                StopAddingUnits();
            }
            else
            {
                PlayerHUD cPlayer = (PlayerHUD)Owner;
                
                float fUnitsToAdd = fAddingSpeed * fAddingUnits;
                
                if (!cPlayer.GetImplantSystem().m_bConstantOverload)
                {
                    if (cPlayer.GetImplantSystem().m_fSystemOverload <= fUnitsToAdd)
                        cPlayer.GetImplantSystem().m_fSystemOverload = 0.f;
                    else
                        cPlayer.GetImplantSystem().m_fSystemOverload -= fUnitsToAdd;
                }                
                cPlayer.GetImplantSystem().Update();
                
                fUnitAlreadyAdded += fUnitsToAdd;
            }
        }//if Owner != null
    }
    
    //-----------------------------------------------------------------------------------------
    /** metoda wywolywana gdy zakonczone zostanie dzialanie druga
     */
    void StopAddingUnits()
    {
        DisableCallMethod("AddingUnits");   
        if (nDrugIdx!=-1)
        {
            if (Owner!=null) 
            {
                PlayerHUD playerH = (PlayerHUD)Owner;
                //playerH.UpdateOverloadLevelOnHUD();
            }//if owner!=null
        }//if
    }
    
    void StopUse()
    {
        super.StopUse();
        StopAddingUnits();
    }

    void Clean()
    {
        super.Clean();
        fUnitAlreadyAdded = 0;
    }
    
    //*********************************************************
	//					SaveGame
    //*********************************************************
	
    /** Metoda wczytujaca zapisane dane w Save gracza
     */	
    public void SGLoadChunk(FileChunk cParentFC)
    {	
		FileChunk.Log("[DrugNeuralHealthex.SGLoadChunk]\n");
		
		FileChunk cFC = GameObject.LoadChunk(cParentFC);   
		
        if (cFC.GetID() == ESGChunksChrome._CHK_INV_OBJECT)
        {	
			super.SGLoadChunk(cFC);
			
			fUnitAlreadyAdded = cFC.LoadFloat();			
			
        }
		
		cFC.delete();
    }
    
    /** Metoda zapisujaca dane do Save gracza
     */	
    public void SGSaveChunk(FileChunk cFCParent)
    {
		FileChunk.Log("[DrugNeuralHealthex.SGSaveChunk]\n");
		
        FileChunk cFC = NewChunk(ESGChunksChrome._CHK_INV_OBJECT, cFCParent);
		
		super.SGSaveChunk(cFC);
		    
		cFC.SaveFloat(fUnitAlreadyAdded);		
        
        cFC.delete();
    }	    			
}
