/** Bron snajperkowa tzn. odpala z opoznieniem efekty trafienia
 */
public class WeaponBulletSniper extends WeaponBullet
{
    float fHitDelayClamp = 0.3f;
    
    DelayedHit cCurrentHit = null;
    
    /** Metoda pokryta z WeaponBullet
     */
    void Hit(float fDistance, ControlObject cObstacle, int nObstacleElement, Vector vHitPoint, Vector vDir, Vector vNormal, int nMaterial, int nMaterialFlags, boolean bWaterHit)
    {
        // zapamietujemy trafienie
        DelayedHit hit = new DelayedHit(fDistance, cObstacle, nObstacleElement, vHitPoint, vDir, vNormal, nMaterial, nMaterialFlags, bWaterHit);
        
        cCurrentHit = hit;
        
        // obliczamy kiedy wypada trafienie
        float fHitDelay = fDistance/fBulletSpeed;
        if(fHitDelay > fHitDelayClamp) fHitDelay = fHitDelayClamp;
        CallMethodIn("DelayedHit", fHitDelay);
    }
    
    void DelayedHit()
    {
        if(cCurrentHit!=null)
        {
            super.Hit(cCurrentHit.fDistance, cCurrentHit.cObstacle, cCurrentHit.nObstacleElement, cCurrentHit.vHitPoint, cCurrentHit.vDir, cCurrentHit.vNormal, cCurrentHit.nMaterial, cCurrentHit.nMaterialFlags, cCurrentHit.bWaterHit);
            cCurrentHit = null;
        }
    }
	
    void Acquire(Module mod, Pawn owner)
    {
        super.Acquire(mod, owner);
        cCurrentHit = null;
    }
	
}

/** Klasa przechowuje informacje o pojednyczym trafieniu
 */
class DelayedHit
{
    DelayedHit(float fDist, ControlObject cO, int nOE, Vector vHP, Vector vD, Vector vN, int nMat, int nMatFlgs, boolean bWaterColl)
    {
        fDistance = fDist;
        cObstacle = cO;
        nObstacleElement = nOE;
        vHitPoint = new Vector(vHP);
        vDir = new Vector(vD);
        vNormal = new Vector(vN);
        nMaterial = nMat;
        nMaterialFlags = nMatFlgs;
        bWaterHit = bWaterColl;
    }
    
    float fDistance;
    ControlObject cObstacle;
    int nObstacleElement;
    Vector vHitPoint;
    Vector vDir;
    Vector vNormal;
    int nMaterial;
    int nMaterialFlags;
    boolean bWaterHit;
}