
/** High Explosive - rakietnice itp.
 */
public class WeaponHEX extends Weapon
{
    /**Aktualnie wystrzelona rakieta*/
    //Rocket cRocket = null;
    /**Lista rakiet jaie zostaly wystrzelone i nie skasowane*/
    //java.util.Vector vRocketList = new java.util.Vector();
    
    /** Rodzaj wystrzeliwanej rakiety */
    String sRocketClassName = "Rocket";
    
	WeaponHEX()
	{
		super();
		m_bShowFXBeam = false;
	}
	
    public void OnCreate()
    {
        super.OnCreate();
        
        CreateRocket();
    }
    
    void CreateRocket()
    {
        if ( Role == ERole._AUTHORITY )
        {
            if ( GetModule() instanceof ModuleNet &&
                 ((ModuleNet)GetModule()).GetObjectsManager() != null )
            {
                cBullet = (Rocket)((ModuleNet)GetModule()).GetObjectsManager().CreateNewObject( sRocketClassName, this );
                cBullet.SetOwner( this );
                
                //ustawiamy na chama tylko 2 sample dla rakiety
                cBullet.nBlastDamageSamples = 2;
            }
            else
                cBullet = (Rocket)CreateObject(sRocketClassName);    
            
            if (cBullet!=null)
                cBullet.Init(this);
            else
                LogD("ERROR:Rocket not created\n");
        }
    }
    
    void Clean()
    {
        super.Clean();
        if ( cBullet == null )
            CreateRocket();
    }
    
    void Fire(Vector vBarrelPos, Vector vDir)
    {
        if (cBullet == null || cBullet.GetModule() == null)
            CreateRocket();
        
        super.Fire(vBarrelPos, vDir);

        // wyliczamy, pobieramy, ustalamy kierunek w ktory strzelamy
        Vector vEnd=new Vector(vDir);
        //vEnd.Mul(fRange);
        vEnd.Add(vBarrelPos);
        
        if ( cBullet != null )
        {
            cBullet.SetOwner( this );
            //cBullet.bNetIsOwner = bNetIsOwner;
            //vRocketList.addElement( cBullet );
            cBullet.ActionStart( this, 0.0f, vBarrelPos, vDir );
        }
        else
            CrashLog("[WeaponHEX.Fire] no bullet\n");
        
        //CrashLog("vDir = "+vDir+"\n");
        
        // dodajemy efekty zwiazane z wystrzalem
        if(sFXCombName != null)
            OwnerExecuteFXBarrel(sFXCombName);
        
        AttachOneShotSound(sSoundShoot, fMinShootSound, fMaxShootSound);
        
        Owner.MakeNoise(fNoiseShot, Pawn._NOISE_WEAPON_FIRING);
        
        CreateRocket();
    }
    /*
    void RemoveBullet()
    {
        //cRocket.delete();
        //cRocket = null;
        for( int index = 0; index < vRocketList.size() ; index++ )
        {
            if(((Rocket)vRocketList.elementAt(index)).bExploded)
            {
                Rocket cTemp = (Rocket)vRocketList.elementAt(index);
                vRocketList.removeElementAt(index);
                cTemp.delete();
                cTemp = null;
                break;
            }
        }
    }*/
    
    void OwnerExecuteFXBarrel(String sFXCombName)
    {
        if ( m_cWalker != null )
            WalkerExecuteFXBarrel( sFXCombName );
        else
            Owner.ExecuteFXBarrel(sFXCombName);
    }
    
    String GetInfoString()
    {
        if (cBullet == null)
            cBullet = (Rocket)GetObjectOfClass(sRocketClassName);
        return Text.Get("&W_D_AMMO&") + EAmmoType.GetAmmoName(eBulletType) + "\n" +
                Text.Get("&W_D_CAPACITY&") + String.valueOf(nCapacity) + "\n" +
                Text.Get("&W_D_DAMAGE&") + String.valueOf((int)cBullet.fBlastDamage) + "\n" +
                Text.Get("&W_D_RANGE&") + String.valueOf((int)((((Rocket)cBullet).fRange)/100)) + "m";
    }
    
    /**
     * Rakietnicom zawsze wysylamy ilosc amunicji
     * kanalem pewnym
     */
    void SetSendClientAmmoMode()
    {
        bSendClientAmmoReliable = true;
    }

    /*
    void SetNullOwner()
    {
        Owner = null;
    }
    
    void SendWeaponMessage( int iWeaponState )
    {
        if ( iWeaponState == STATE_NO_AMMO )
            CrashLog("FIRE WARNING: "+this+" STATE_NO_AMMO "+
                     "Owner"+Owner+" "+((Owner!=null)?Owner.GetName():"")+"\n");
            
        if ( iWeaponState == STATE_OVERHEAT ) 
            CrashLog("FIRE WARNING: "+this+" STATE_OVERHEAT "+
                     "Owner"+Owner+" "+((Owner!=null)?Owner.GetName():"")+"\n");
        
        super.SendWeaponMessage( iWeaponState );
    }
    */          
    
    
}
