/** Bron uzywana przez Walkera_k
 *  (Standardowy WeaponBulet z ustawionymi parametrami)
 */
public class WeaponWalker_k extends WeaponBullet
{
    WeaponWalker_k()
    {
        super();

    //MeshObject
        MeshName="wykrzyknik.3da";
        
        //Weapon
        nType = EWeaponType._RIFLE;

        //InvObject properites
        nInvIndex = 8;
        sName = "Light Walker internal gun";
        sInfo = "Ammo : 8mmLong \nDamage : Medium \nRoF : 1500f FullAuto";
        sTexFileName = "Data/Textures/CH_I_Weapons3.png";
        
        //wspolrzedne polozenia na teksturze
        nOnTexPosX = 0.0f;
        nOnTexPosY = 0.0f;
        
        //rozmiary tekstury
        nTexSizeX = 256.0f;
        nTexSizeY = 256.0f;

		// Ilosc kratek zajmowanych w plecaku
	    nCellsHeight = 3;
	    nCellsWidth = 7;
		
        fBaseAcc = 1.75f;
        
        //TODO jesli trzeba to zmodyfikowac
        vRecoilShift = new Vector(0, 0.2f, 0);

        //zmieniane przy dodawaniu broni do walkera zaleznie czy to ai czy playerowy walker
        fDamage             = 60.0f;
        
        fPhysicsSimDamage   = fDamage;
        fRange              = 50000.0f;
        fBulletSpeed        = 100000.0f;
	    fRateOfFire         = 450.0f;
	    eBulletType         = EAmmoType._8mmLong;
		nCapacity		    = 1000000000;

		fNoiseShot = 2500.0f;
		fNoiseHit  = 500.0f;

        /** Klasa mesha pokazywanego w FPP */
        sFPPHandsClass = "FPPHandsRifle";
        
        /**Nazwa dzieku odpalanego przy wystrzale */
        sSoundShoot = "Data/Sounds/Weapon/W01_Fire";
        sSoundReload = "Data/Sounds/Weapon/W01_Reload";
        sSoundEmpty = "Data/Sounds/Weapon/W01_Click";
        
        fMinShootSound = 2000.f;
        fMaxShootSound = 7000.f;
        
        /**Nazwa FX odpalanego przy wystrzale (grzebien)*/
		sFXCombName = "FXGrzebienWalker";
        
        nAIFireModes = _FIREMODE_BURST;
    
        fAIBurstFireDelay = 0.2f;
        fAIRandomBurstFireDelay = .4f;

        fAIBurstTime = 0.5f;
        fAIRandomBurstTime = 3.5f;

        nAIReadinessToAim = 0;
        
        fAINearTargetDistance = 200.f;
        fAIMaxAimingChanceDistance = 800.f;
        fAIFarTargetDistance = 3000.f;
    
        fAIMinDesiredHitRatio = 15.f;
        fAIMaxDesiredHitRatio = 80.f;
        
        fAIEffectiveRange = fAIMaxBurstDistance = 6000.f;
        
        vBarrelElementPos = new Vector(0.0f, 0.0f, 10.0f);
        bHidden = true;
    }
    
    
    void StartFire()
    {
        StartFire( MODE_AUTO );
    }
    
    /** Pobranie z wlasciciela pozycji, z ktorej strzelamy
     */
    Vector GetOwnerFireOrigin()
    {
        if ( m_cWalker != null )
            return GetPosition();
        return super.GetOwnerFireOrigin();
    }
    
    /** Pobranie z wlasciciela kierunku, w ktory strzelamy
     */
    Vector GetOwnerFireDir()
    {
        if ( m_cWalker != null )
            return GetWalkerFireDir();
        return super.GetOwnerFireDir();
    }
    
    void SendWeaponMessage(int nState)
    {
        if ( m_cWalker == null )
            super.SendWeaponMessage( nState );
    }

    float fMinBeamDistance = 200f;
    
    float FireBullet(Vector vBarrelPos, Vector vDir)
    {
        float fDist = super.FireBullet(vBarrelPos, vDir);
        Owner.fFXSizeX = 2.0f;
        Owner.fFXZero = 0f;
        if (fDist <= fRange)
        {
            Owner.fFXSizeY = fDist - fMinBeamDistance;
            Owner.fFXPosY = fDist/2f + fMinBeamDistance/2f;
        }
        else
        {
            //brak kolizji w zasiegu, wtedy w fDist jest jakas kosmiczna liczba
            Owner.fFXSizeY = fRange - fMinBeamDistance;
            Owner.fFXPosY = fRange/2f + fMinBeamDistance/2f;
        }
        if (!(Owner instanceof NewAIWalker))
            Owner.ExecuteFX("WeaponBeam",
                              vBarrelPos, vDir
                              );
        return fDist;
    }
    
    void SetWalkerMode( Walker cWalker )
    {
        super.SetWalkerMode( cWalker );
        
        fDamage     = 75;
        fRateOfFire = 600;
        fDelay      = 60/fRateOfFire;
        eBulletType = EAmmoType._Cannon;
    }
}
