public class ZoomerSniperSmooth extends Zoomer
{
    /** Maksymalne powiekszenie lunetki
     */
    public float fZoomMax = 15.f;

    /**Mnoznik zoomu, przy duzych wartosciach fZoomMax za dlugo trzeba krecic
     * kolkiem zoomu zeby przejsc na koniec skali, ten mnoznik przyspiesza
     * zoomowanie*/
    public float fZoomMul = 1f;
    /** Czas miedzy update'ami zooma [s]
     */
    public float fZoomUpdateTime = 0.05f;
    
    /** dzwieki ktory odgrywane sa przy ZoomIn i ZoomOut */
    String sZoomInSound = "Data/Sounds/Weapon/R02_Zoom.wav";
    String sZoomOutSound ="Data/Sounds/Weapon/R02_Zoom.wav";
    
    /** Tablica progow czasowych [s]
     *  (po danym czasie pobierane jest odpowiadajace mu 
     *   przyspieszenie z aZoomSpeedValue)
     */
    public float aZoomSpeedTime[] = { .2f, .5f, 1.f, 2.f };
    /** Tablica szybkosci dla progow czasowych z aZoomSpeedTime
     *  w [1/s]
     */
    public float aZoomSpeedValue[] = { 2f, 4f, 8f, 12f };
                     
    protected boolean bScrollerZoom = false;
    
    ZoomerSniperSmooth()
    {
        eAimingType = EWeaponAimingType._SNIPER;
    }
    ///////////////////////////////////////
    // Przesloniete metody klasy bazowej //
    ///////////////////////////////////////

    public void Reset()
    {
        super.Reset();
        bUpdateZoom = false;
    }
    
    int nIDSound = -1;

    public void AddZoom(float fZoomChange)
    {
        if  (!bUpdateZoom)
        {
            //moze byc jeszcze stare callmethodin("StopZoomChange")
            DisableCallMethods();
            
            if (fZoomChange > 0)
                StartZoomChange( _ZOOM_IN);
            else
                StartZoomChange( _ZOOM_OUT);

            bScrollerZoom = true;

            CallMethodIn("StopZoomChange", .25f);
        }
    }

    public void StartZoomChange(byte nZoomType)
    {
        nZoomChangeType = nZoomType;

        bScrollerZoom = false;

        ControlObject cSpeaker = null;
        
        if ( cOwner instanceof InvObject && ((InvObject)cOwner).Owner != null)
            cSpeaker = ((InvObject)cOwner).Owner;
        else
            cSpeaker = cOwner;
        
        if (cSpeaker != null)
        {
            if ( nZoomChangeType == _ZOOM_IN && (fCurrentZoom < fZoomMax))
                cSpeaker.AttachOneShotSound(sZoomInSound);
            
            if ( nZoomChangeType == _ZOOM_OUT && (fCurrentZoom > fInitialZoom))
                cSpeaker.AttachOneShotSound(sZoomOutSound);
        }
        
        bUpdateZoom  = true;
        fZoomingTime = 0.f;
        UpdateZoom();
    }
    
    public void StopZoomChange(byte nZoomType) 
    {
        if (nZoomChangeType == nZoomType)
            StopZoomChange();
    }
    
    public void StopZoomChange() 
    {
        /*
        if ( cOwner != null && nIDSound != -1 )
        {
            cOwner.DetachSound(nIDSound);
        }
        */
        if (nIDSound != -1)
        {
                // CO TO Q.. MIALO BYC ?? [TK]
            //cBinoculars.Owner.DetachSound(nIDSound);
            nIDSound = -1;
        }
        bUpdateZoom = false;
    }

    
    public void UpdateZoom()
    {
        int nIdx = 0;
        
        float fZoomSpeed;
        if (bScrollerZoom) 
        {
            fZoomSpeed = 0.4f * fZoomMul;
        }
        else
        {
            for (nIdx=0; nIdx < aZoomSpeedTime.length-1; nIdx++)
            if (fZoomingTime < aZoomSpeedTime[nIdx])
                break;
            
            fZoomSpeed = aZoomSpeedValue[nIdx] * fZoomUpdateTime;
        }            

        //Log("Zoom Speed=" + fZoomSpeed + "\n");

        // zmodyfikuj zoom
        if (nZoomChangeType == _ZOOM_IN)
            fCurrentZoom += fZoomSpeed;
        else
            fCurrentZoom -= fZoomSpeed;
        
        // Sprawdz, czy nie przegielismi - jesli tak - stop
        if (fCurrentZoom < fInitialZoom)
        {
            fCurrentZoom = fInitialZoom;
            bUpdateZoom = false;
        }
        if (fCurrentZoom > fZoomMax)
        {
            fCurrentZoom = fZoomMax;
            bUpdateZoom = false;
        }
        fZoomingTime += fZoomUpdateTime;

        // Jesli trzeba - powtorz
        if (bUpdateZoom)
            CallMethodIn("UpdateZoom", fZoomUpdateTime);
    }

    public float GetBaseZoom()
    {
        return fInitialZoom;
    }
    
    protected byte nZoomChangeType;
    protected boolean bUpdateZoom = false;
    protected float fZoomingTime;
    
    public float GetMaxZoom()
    {
        return fZoomMax;
    }
    
}
