/** Lunetka umozliwiajaca skokowa zmiane powiekszenia
 */
public class ZoomerSniperStep extends Zoomer
{
    /** Tablica kolejnych wartosci powiekszen
     */
    public float aZoomFactors[] = { 1.f, 2.f, 3.f, 4.f };
    
    
    /** dzwieki ktory odgrywane sa przy ZoomIn i ZoomOut */
    String sZoomInSound = "Data/Sounds/Weapon/zoomIn.wav";
    String sZoomOutSound ="Data/Sounds/Weapon/zoomOut.wav";                      
                         

    ZoomerSniperStep()
    {
        eAimingType = EWeaponAimingType._SNIPER;
        Reset();
    }

    ///////////////////////////////////////
    // Przesloniete metody klasy bazowej //
    ///////////////////////////////////////
    public void Reset()
    {
        fCurrentZoom = aZoomFactors[0];
        nCurrentZoomIdx = 0;
    }

    public void AddZoom(float fZoomChange)
    {
        if( fZoomChange > 0) StartZoomChange(_ZOOM_IN);
        if( fZoomChange < 0) StartZoomChange(_ZOOM_OUT);
    }
    
    public void StartZoomChange(byte nZoomType)
    {
        //Log("Zoom" + (nZoomType!=0 ? "Out\n" : "In\n"));
        ControlObject cSpeaker = null;
        if ( cOwner instanceof InvObject && ((InvObject)cOwner).Owner != null)
            cSpeaker = ((InvObject)cOwner).Owner;
        else
            cSpeaker = cOwner;
        
        if (cSpeaker != null)
        {
            if ((nZoomType == _ZOOM_IN) && (nCurrentZoomIdx < aZoomFactors.length-1))
            {
                nCurrentZoomIdx++;
                cSpeaker.AttachOneShotSound(sZoomInSound);
            }
            else if ((nZoomType == _ZOOM_OUT) && (nCurrentZoomIdx > 0))
            {
                nCurrentZoomIdx--;
                cSpeaker.AttachOneShotSound(sZoomOutSound);
            }
        }
        
        fCurrentZoom = aZoomFactors[nCurrentZoomIdx];
    }
    
    protected int nCurrentZoomIdx = 0;
    
    public float GetBaseZoom()
    {
        return aZoomFactors[0];
    }
    
    public float GetMaxZoom()
    {
        return aZoomFactors[aZoomFactors.length - 1];
    }
}
