public class LevelContent extends NetObjectContainer
{
    /**mozliwe typy wczytywanych modulow*/
    final static int _MAP		   = 0;  //mapa zwykly level
    final static int _MODULE	   = 1;  // menu lub inne 
	final static int _MOVIES_TH    = 2;  // film typu TalkHead
	final static int _MOVIES_S     = 3;  // film typu Scenery    
    
    /**typ modulu*/
    int nLevelType;
    
    /**Nazwa noda kamery dla filmiku typu Scenery*/
    String sCameraName = null;
    
    /**sciezka do pliku 3DA ze scena dla filmu Scenery */
    String sPhat3DA = null;

    /**sciezka do pliku WAV z muzyka dla filmu Scenery */
    String sPhatWAV = null;
    
    /**nazwa MeshElementu ktory ma byc sledzony w filmie Scenery*/
    String sTrackingMeshElementName = null;
    
    /**Ostatnia ramka animacji dla w filmie Scenery*/
    int nLastAnimFrame = 0;
    
    /**Kat widzenia dla filmu typu SceneryTracking(FOV)*/
    float fFOV = 90.0f;
    
    /**Czas wygaszania sceny */
    
    float fFadingTime = 0.5f;
    
    /**Czy po filmie ma pokazac sie inventory room i inplant room*/
    boolean bPrepareToMission = false;
    
    /**nazwa skryptu do wczytania dla filmu typu TalkHead*/
	String sMoviesScr = null;
    
    /**Nazwa Levelu do wczytania*/
    String sLevelName = null;

    /**Nazwa doklejana do nazwy savegame'a, czytana ze skryptu*/
    String sSaveName = "Level??";
    
    /** Nazwa broni jaka ma miec Logan defaultowo w rekach */
    String sStartWithWeapon = null;
    
    /** Lista nazw przedmiotow do dodania na level, jak nie ma inventory przed levelem */
    java.util.Vector aStartItems = null;
    
    /** Lista rozszczepien akcji na inne levele */
    java.util.Vector aActionPaths = null;
    
     /** Lista obiektow klasy , ktore okreslaja zmiany dla inventory room */
    java.util.Vector aInventoryRoomModifiers = null;
    
    /** Lista implantow jakie maja byc zmodyfikowane */
    java.util.Vector aImplantModifiers = null;
    
    /**domyslne ustawienia broni dla danego modulu*/
    java.util.Vector aDefaultWeapons = null;
	/**objectives levelu*/
	java.util.Vector aObjectives = null;

	/** MZM nowe objectives levelu */
	java.util.Vector m_Objectives = null;
	/** MZM nowe cele na mapie */
	java.util.Vector m_Locations = null;
	
    String sLevelMapTexture = "Data/Textures/mapa.png";
    
    java.util.Vector aLevelTexturesPaths = new java.util.Vector(1);
        
    boolean bImplantsChanged = false;
    
    boolean bLeaveInventory = false;
    
    float m_fHackMovesMult = 1;
    int m_nHackElemsMin = 5;
    int m_nHackElemsMax = 10;
    int m_nHackCombo = 2;
    
        
    boolean bDisableDetector = false;
    
    void SetLevelMapTexture(String sName)
    {
        sLevelMapTexture = sName;
    }
    
    /**Opis levelu jaki ma sie pojawic w trakcie jego ladowania */
    String sDescriptionLevel = null;
    
    /**Opis levelu w inv roomie jako briefing*/
    String sBriefing = null;
    
    /**Opis pogody pokazywany w lornetce*/
    String sWeather = null;
    
    /** Textura tla przy wczytywaniu levelu */
    String sDescriptionLevelBackground = null;
    void SetDescriptionLevelBackground(String sName)
    {
        sDescriptionLevelBackground = sName;
    }
    
    /**
     * Gra sieciowa
     */
    /**typ gry sieciowej*/
    private int              m_nNetGameType;
    /**sciezka do mapy*/
    //private String           m_sMapPathName = null;
    /** Lista ustawien gry jakie maja byc zmodyfikowane, odczytywane ze skryptu */
    private java.util.Vector m_aNetGameSettingsModifiers = null;
    /** Obiekt z ustawieniami gry: domyslnymi+odczytanymi ze skryptu*/
    private NetGameSettings  m_cNetGameSettings  = null;
        
    LevelContent()
    {
        nLevelType = _MAP;

        aInventoryRoomModifiers = new java.util.Vector(0);
        
        aImplantModifiers = new java.util.Vector(0);
		
		aObjectives = new java.util.Vector(0);
        
        aDefaultWeapons = new java.util.Vector(0);
		
		m_Objectives = new java.util.Vector(0);
		m_Locations = new java.util.Vector(0);
        
        m_aNetGameSettingsModifiers = new java.util.Vector(0);
        
        aStartItems = new java.util.Vector(0);
        
        aActionPaths = new java.util.Vector(0);
    }
    
    void SetNetGameType(int nGameType) 
    { 
        m_nNetGameType = nGameType; 
    }
    
    String GetMapPath() 
    { 
        int    nSlashPos = sLevelName.lastIndexOf("/");
        return new String( sLevelName.substring( 0, nSlashPos ) );
    }
    
    String GetLevelName()
    { 
        int    nSlashPos  = sLevelName.lastIndexOf("/");
        int    nExtPos    = sLevelName.lastIndexOf(".map");
        return new String( sLevelName.substring( nSlashPos+1,nExtPos ) );
    }
        
    int  GetNetGameType()              
    { 
        return m_nNetGameType;      
    }
    
    void AddNetGameSettingsModifier(ModifierNetGameSettings cModifier)
    {
        m_aNetGameSettingsModifiers.addElement( cModifier );
    }
    
 
    
    /**
     * Do gry sieciowej trzeba najwazniejsze informacje
     * wrzucic do paczki i wyslac na klientow,
     * Ponizesz metody zagwarantuja te czynnosci
     */
    
    NetDataContainer ToDataContainer( boolean bCopyInventoryRoomToContainer )
    {
        m_bCopyInventoryRoomToContainer = bCopyInventoryRoomToContainer;
        return ToDataContainer();
    }

    private
    boolean m_bCopyInventoryRoomToContainer = false;
        
    
    /**
     * Wrzucenie do paczki istotnych danych
     */
    void CopyDataToContainer()
    {
        //Lista implantow jakie maja byc zmodyfikowane
        m_cContainer.PackInt( aImplantModifiers.size() );
        for ( int i = 0; i < aImplantModifiers.size() ; i++ )
        {
            ImplantModifier cModifier = (ImplantModifier)aImplantModifiers.get( i );
            cModifier.PackToContainer( m_cContainer );
        }
    
        //czy podajemy ustawienia inwentory room
        m_cContainer.PackBoolean( m_bCopyInventoryRoomToContainer );
        if ( ! m_bCopyInventoryRoomToContainer )
            return;
        
        //zawartosc inwentory room
        m_cContainer.PackInt( aInventoryRoomModifiers.size() );
        for ( int i = 0; i < aInventoryRoomModifiers.size() ; i++ )
        {
            InventoryRoomModifier cModifier = (InventoryRoomModifier)aInventoryRoomModifiers.get( i );
            cModifier.PackToContainer( m_cContainer );
        }
            
        //domyslne ustawienia broni
        m_cContainer.PackInt( aDefaultWeapons.size() );
        for ( int i = 0; i < aDefaultWeapons.size() ; i++ )
        {
            String sWeaponName    = (String)aDefaultWeapons.get( i );
            int    nWeaponClassId = (sWeaponName != null) ? GameObject.GetClassGUID( sWeaponName ) : 0;
            m_cContainer.PackInt( nWeaponClassId );
        }
    }

    /**
     * Wyciagniecie z paczki istotnych danych
     * i zastosowanie ich
     */
    void CopyDataFromContainer()
    {
        //Lista implantow jakie maja byc zmodyfikowane
        aImplantModifiers.removeAllElements();
        int nImplantsModifiers = m_cContainer.UnPackInt();
        for ( int i = 0 ; i < nImplantsModifiers; i++ )
        {
            ImplantModifier cModifier = new ImplantModifier( m_cContainer );
            aImplantModifiers.addElement( cModifier );
        }
        
        //jesli w komunikacie nie przyszedl InventoeyRoom
        if ( ! m_cContainer.UnPackBoolean() )
            return;
         
        //zawartosc inwentory room
        aInventoryRoomModifiers.removeAllElements();
        int nInventoryModifiers = m_cContainer.UnPackInt();
        for ( int i = 0 ; i < nInventoryModifiers; i++ )
        {
            InventoryRoomModifier cModifier = new InventoryRoomModifier( m_cContainer );
            aInventoryRoomModifiers.addElement( cModifier );
        }
        
        //domyslne ustawienia broni
        aDefaultWeapons.removeAllElements();
        int nDefaultWeapons = m_cContainer.UnPackInt();
        for ( int i = 0 ; i < nDefaultWeapons; i++ )
        {
            int nWeaponClassId = m_cContainer.UnPackInt();
            String sWeaponName = (nWeaponClassId > 0) ? GameObject.GetClassByGUID( nWeaponClassId ) : null;

            if ( sWeaponName != null )
                aDefaultWeapons.addElement( sWeaponName );
        }
        m_bReceivedFromServer = true;
    }
    
    private 
    boolean m_bReceivedFromServer = false;
    boolean IsReceivedFromServer(){ return m_bReceivedFromServer; }
    
   
    // metoda dodaje sciezke z texturami specyficznymi dla levelu
    void AddTexturePaths()
    {
        for(int i=0; i<aLevelTexturesPaths.size(); ++i)
        {
            String sTexturePath = (String)aLevelTexturesPaths.elementAt(i);
            //TODO GameObject.AddTexturePath()
            GameObject.CrashLog("Add '"+sTexturePath+"'\n");
            GameObject.AddTexturePath(sTexturePath);
        }
    }
    
    void RemoveTexturePaths()
    {
        for(int i=0; i<aLevelTexturesPaths.size(); ++i)
        {
            String sTexturePath = (String)aLevelTexturesPaths.elementAt(i);
            //TODO GameObject.RemoveTexturePath()
            GameObject.CrashLog("Remove '"+sTexturePath+"'\n");
            GameObject.RemoveTexturePath(sTexturePath);
        }
    }

    
    boolean IsEqual( NetMapInfo cMapInfo, boolean bCheckGameType )
    {
        if ( !GetLevelName().equalsIgnoreCase( cMapInfo.GetLevelName() ) )
            return false;
        
        if ( ! bCheckGameType )
            return true;
        
        return GetNetGameType() == cMapInfo.GetGameType();
    }
}