/** ptaki startujace z chaszczow */

public class Bird extends Actor
{
///////////////////////////////////////////////////
/// ATRYBUTY //////////////////////////////////////    
///////////////////////////////////////////////////
    
    /** vektor kierunku poruszania sie po starcie */
    Vector vDirection = null;
    
    /** vektor zaklocajacy kierunek poruszania sie  */
    Vector vDirChange = new Vector(0,0,0);
    
    /** aktualna pozycja bird'a */
    Vector vPosition = null;
    
    /** predkos poruszania sie (0 - nie porusza, x>0 predkosc) */
    float fMoveSpeed = 650f;
    
    /** nazwa dzwieku odgrywanego podczas lotu */
    String sFlyingSound = "Data/Sounds/Animals/bird.wav";

///////////////////////////////////////////////////
/// METODY ////////////////////////////////////////    
///////////////////////////////////////////////////    

    Bird()
    {
        super();
        MeshName = "data/meshes/animals/Papuga.3DA";
    }

    public void OnCreate()
    {
        super.OnCreate();
        GenerateDirectionVect(); 
        ClearFlag(EFlags._COLLISION);
        ClearFlag(EFlags._BLOCK_MOVE);
        ClearFlag(EFlags._BLOCK_TRACE);
        ClearFlag(EFlags._FXPARTICLE_COLLISION);
        ClearFlag(EFlags._NO_ANIMATION);
        ClearFlag(EFlags._NO_ANIMATION_REFRESH);
    }

    /** generacja kierunku poruszania sie */
    void GenerateDirectionVect()
    {
        float fMaxValue = 6.0f;
        float fGen = 0.0f;
        
        vDirection = new Vector();
        //generujemy wartosc skladowa X kierunku poruszania sie 
        fGen = RandomFloat(fMaxValue);
        vDirection.fX = fGen;
        fGen = RandomFloat(1.0f);
        if (fGen >= 0.5f) vDirection.fX*= -1.0f;
        
        //generujemy skladowa Y
        fGen = RandomFloat(fMaxValue-0.5f)+0.5f;
        vDirection.fY = fGen;
        
        //generujemy skladowa Z
        fGen = RandomFloat(fMaxValue);
        vDirection.fZ = fGen;
        fGen = RandomFloat(1.0f);
        if (fGen >= 0.5f) vDirection.fZ*= -1.0f;
        
        vDirection.Normalize();
        SetDir(vDirection);
        
        //generujemy wektor zaklocajacy kierunek poruszania sie
        //skladowa X
        fGen = RandomFloat(fMaxValue);
        vDirChange.fX = fGen;
        fGen = RandomFloat(1.0f);
        if (fGen >= 0.5f) vDirChange.fX*= -1.0f;
        //skladowa z
        fGen = RandomFloat(fMaxValue);
        vDirChange.fZ = fGen;
        fGen = RandomFloat(1.0f);
        if (fGen >= 0.5f) vDirChange.fZ*= -1.0f;
        
        vDirChange.Normalize();
        
    }
    
    public void FlyAway(Vector vPos)
    {
        vPosition = vPos;
        
        ActivateOnModule();
        InitAnimSeq("fly", 0, 10);
        SetAnimFreq("fly", 40);
        PlayAnim("", "fly", -1);
    }

    Vector vMove = new Vector();
    float fLastTime = 0;
    void OnPostUpdate()
    {
        vMove.Set(vDirection);
        float fTime = GetTime();
        if (fLastTime == 0)
            fLastTime = fTime;
        float fTimeDelta = fTime - fLastTime;
        fLastTime = fTime;
        vMove.Mul(fMoveSpeed * fTimeDelta);
        vPosition.Add(vMove);
        //vPosition.Add(vDirChange);
        SetPosition(vPosition);        
    }

    public void StopFly()
    {
        DeactivateOnModuleAlways();
        CallMethodIn("delete", 0.0f);
    }
}
