public class ShybkovDeath extends MeshObject
{
    public float fHeight = 160f;//#ShybkovDeath;
    
    // skladowe wektora pokazujacego kierunek strzalu
    public float fDirX = 0f;//#ShybkovDeath;
    public float fDirY = 0f;//#ShybkovDeath;
    public float fDirZ = -1f;//#ShybkovDeath;
    
    public float fRand = 3f;//#ShybkovDeath;
    
    public int nTimes = 12;//#ShybkovDeath;
    public float fTimeInterval = 0.1f;//#ShybkovDeath;
        
    int nCounter = 0;
    
    public void MakeBlood()
    {
        nCounter = nTimes;
        
        CallMethodEvery("MakeSingleBlood", fTimeInterval);
    }
    
    public void MakeSingleBlood()
    {
        Vector vDir = new Vector(fDirX, fDirY, fDirZ);
        vDir = VectorLocalToWorld(vDir);
        vDir.Negate();
        vDir.Normalize();
        vDir.fX += (-fRand/2f) + GameObject.RandomFloat(fRand);
        vDir.fY += (-fRand/2f) + GameObject.RandomFloat(fRand);
        vDir.fZ += (-fRand/2f) + GameObject.RandomFloat(fRand);
        vDir.Normalize();
        vDir.Mul(100f);
        
        Vector vStart = new Vector(vDir);
        vStart.Add(GetPosition());
        
        vDir.Negate();
        vDir.Normalize();
        Vector vEnd = new Vector(vDir);
        vEnd.Mul(400f);
        vEnd.Add(GetPosition());
        
        vStart.fY += fHeight;
        vEnd.fY += fHeight;

        Collision stCollObjects = new Collision();
        int nFaceSkipFlags = EFaceFlags.NO_BLOCK_RAY;
            
        if (TraceObjectsWithFaceFlags(stCollObjects, vStart, vEnd, null, 0, nFaceSkipFlags))
        {
            if (stCollObjects.ObstacleElement != EBones._NON_BONE)
            {
                int nLocale = ELocale.GetLocale();
                if (nLocale != ELocale._GERMAN)
                {
                    ExecuteFX("FXBlood", vEnd, vDir);
                    ExecuteParticleSystem("FXBlood", vEnd, vDir);
                    ExecuteFXTraceProjected( this, stCollObjects.ObstacleElement, "TraceBlood", 
                                             PointWorldToLocal(stCollObjects.ObstacleElement, vEnd), 
                                             VectorWorldToLocal(stCollObjects.ObstacleElement, vDir) );
                }
                else
                {
                    ExecuteFX("MetalBulletSmall", vEnd, vDir);
                    ExecuteParticleSystem("MetalBulletSmall", vEnd, vDir);
                }
            }
        }
        nCounter--;
        if (nCounter == 0)
            DisableCallMethod("MakeSingleBlood");
    }
}
