/** Trigger pozwalajacy na przelaczanie w jeden z dwoch stanow: Locked/Unlocked
 *  Stan obrazowany jest na ekranie terminala (podmieniana tekstura)
 */
public class SecurityTerminal extends AnimatedScreen
{
    /** Znacznik, ze w danym momencie terminal (albo to czym steruje) jest zablokowany
     */
    public boolean bIsLocked = true;//#SecurityTerminal
    

    /** Co jaki czas maja sie przelaczac dwie tekstury dla kazdego stanu (kolorowa i czarna)
     *  (jesli <=0, nie przelaczaja sie)
     */
    public float fBlinkTime = 0.5f;//#SecurityTerminal
    
    /** Ktora tekstura stanu ma byc wyswietlana (kolorowa, czy czarna),
     *  jesli sie nie przelaczaja (0 lub 1)
     */
    public int nDefaultStateTexture = 0;//#SecurityTerminal
    
    
    /*-------------------------------------------------------------------------*/
    
    /** Ktora z dwoch tekstur stanu jest aktualnie wyswietlana
     */
    int nStateTexture = 0;
    
    int METHOD_Blink = 0;
    
    
    SecurityTerminal()
    {
        super();
        //TODO ustalic materialy i poprawic ich przelaczanie na razie nie ma takich obiektow na levelach
        //PeH 2003.02.27
        sMaterialsList = "Ekran1GreenOff.mat;Ekran1GreenOn.mat;Ekran1RedOff.mat;Ekran1RedOn.mat";
    }
    
    public void OnCreate()
    {
        super.OnCreate();
        nStateTexture = nDefaultStateTexture;
        METHOD_Blink = RegisterCallMethod("Blink");
        if (fBlinkTime > 0)
            CallMethodEvery(METHOD_Blink, fBlinkTime);
    }
    
    
    /** Ustawienie stanu terminala
     */
    void SetLocked(boolean bLocked)
    {
        bIsLocked = bLocked;
        SetScreen(bLocked ? nStateTexture : nStateTexture + 2);        
    }
    
    
    public void Blink()
    {
        nStateTexture = 1 - nStateTexture;
        SetLocked(bIsLocked);
    }
    

    void Execute( Actor executor )
    {
        super.Execute(executor);
        SetLocked(!bIsLocked);
    }
    

    String GetTip()
    {
        return bIsLocked ? "Unlock" : "Lock";
    }


    public boolean IsActive(ControlObject Activator)
    {
        return true;
    }

}
