public class LiftPlatformBase extends TriggerObject
{
    static boolean bMidFloor = false;
    
    LightObject cLight = null;
    
    /** Czas jak dlugo gracz ma chodzic po windzie, zeby ruszyla */
    public float fPlatformStartTime = 1.0f;
    
    /** dzwiek odgrywany podczas jazdy */
    String sMovingSound = null;
    
    /** dzwiek odgrywany na starcie windy */
    String sStartSound = null;
    
    /** dzwiek odgrywany na koncu jazdy windy */
    String sStopSound = null;
    
    /** identyfikator dzwieku "jazdy"
     **/
    int nSoundId = -1;
    
    boolean bActive = true;
    
    /** predkosc poruszania sie windy w cm/s
     */
    public float fMoveSpeed = 300.0f;
    
    /** wyokosc na jaka wjezdza lub z jakiej zjezdza winda (w cm)
     */
    public float fMovingDistance = 1000.0f;//#LIFTPLATFORM
    
    /** kierunek w ktorym, po uzyciu windy, bedzie sie ona poruszac 1- gora, -1 -dol
     */
    float fMovingDirection = 1.0f;
        
    
    /** poczatkowe polozenie windy
     */
    Vector vStartPos = null;
    
    /** odleglosc na jaka poruszyla sie winda
     */
    float fDistance = 0.0f;
    
    
    /** referencja do playera
     */
    Player cPlayer = null;
    
    Vector vMinExt=new Vector();
    Vector vMaxExt=new Vector();
    
    float fExtRadius = 0;
    
    /** parametry "czasowe" zwiazane z predkoscia poruszania sie windy
     */
    float fPrevTime = 0.0f;
    float fActualTime = 0.0f;
    
    
    PlayerNetManager m_cPlayerManager = null;
    
    java.util.Vector aAttachedPlayers = null;
    java.util.Vector aPlayersToAttach = null;
    
    float m_fAnimHideHogasLength = 0.0f;
    
    
    public float _NOISE_INTERVAL = 0.5f;
    
    public boolean bMakeNoise = true;//#LIFTPLATFORM
    
    public boolean bOutdoorLift = false;//#LIFTPLATFORM
    
    /** Zasieg noise'a wydawanego przez jadaca winde */
    public float fNoiseRangeMoving = 700.f;

    
    
    void OnCreate()
    {
        super.OnCreate();
		
		bSG = true;
        
        int nFrames = (int)GetNumFrames() - 1;
        InitAnimSeq("OpenNogas", 0, nFrames/2);
        InitAnimSeq("HideNogas", nFrames/2, nFrames);
        SetFrame(nFrames/2, 0);
                
        GetMeshExtents(vMinExt, vMaxExt);
        Vector vPos = GetPosition();
		
        vMinExt.Add(vPos);
        vMaxExt.Add(vPos);
        
        fExtRadius = Math.max(vMaxExt.fX - vMinExt.fX, vMaxExt.fZ - vMinExt.fZ) * 0.5f;
        
        /*
        cLight = (LightObject)CreateObject("LightObject");
        cLight.SetPosition(new Vector(0, 50.f, 0));
        cLight.SetScale(new Vector(350.f, 150.f, 350.f));
        
        cLight.m_fR = 0.2f;
        cLight.m_fG = 0.2f;
        cLight.m_fB = 0.2f;
        //HACK: bo nie dzialaja
        cLight.m_fR = cLight.m_fG = cLight.m_fB = 0;
        //END HACK
        AttachChild(cLight);
        */
        aAttachedPlayers = new java.util.Vector(0,8);
        aPlayersToAttach = new java.util.Vector(0,8);
        
        m_fAnimHideHogasLength = GetAnimLength("HideNogas");
        SetCollType(ECollFlags.OBJCOL_TYPE_PERFACEOBJECT);
        
        CallMethodIn("Init", 0.0f);
    }
    
    void OnDestroy()
    {
        /*
        cLight.DetachFromParent();
        cLight.delete();
        */
        cLight = null;
    }

    void Init()
    {
        if ( GetModule() instanceof ChromeModuleSingle )
            cPlayer = ((ChromeModuleSingle)GetModule()).MainPlayer;
        
        fDistance = 0.0f;
        vStartPos = GetPosition();
    }
    
    
    void InitNet()
    {
        if ( GetModule() instanceof ModuleNet )
        {
            m_cPlayerManager = ((ModuleNet)GetModule()).GetPlayerManager();
        }
        
        if ( m_cPlayerManager == null )
        {
            CrashLog("NetLiftPlatform "+this+" m_cPlayerManager == null \n");
        }        
    }
    
    void AttachPlayerDo(Actor cPlayer)
    {
        if ( cPlayer == null )
             return;
        
        aAttachedPlayers.addElement( cPlayer );
        cPlayer.AttachAsChildToAndKeepWorldPos( this );
    }
    
    void DetachPlayerDo(Actor cPlayer)
    {
        cPlayer.DetachFromParentAndKeepWorldPos();
    }
    
    
    final boolean IsPlayerAbove()
    {
        return IsPlayerAbove( cPlayer );
    }
    
    private Vector vPlayerPos = new Vector();
    
    boolean IsPlayerAbove(Actor cPlayer)
    {
        cPlayer.GetPosition(vPlayerPos);
                                                                                              
        if( !((vPlayerPos.fX > vMinExt.fX) && (vPlayerPos.fX < vMaxExt.fX) &&
              (vPlayerPos.fZ > vMinExt.fZ) && (vPlayerPos.fZ < vMaxExt.fZ) )) 
            return false;
        
        // TODO narazie tempe sprawdzenie
        float fDist = vPlayerPos.fY - GetPositionVectorVolatile().fY;
        
        return (-10.0f < fDist) && (fDist < 210.0f);
    }
    

    boolean bPlayerAttached = false;
    int nAutoAttachFlagsBeforeAttach;
    void AttachPlayer()
    {
        if(IsPlayerAbove())
        {
            cPlayer.AttachAsChildToAndKeepWorldPos(LiftPlatformBase.this);
            
            if (!bPlayerAttached)
            {
                nAutoAttachFlagsBeforeAttach = cPlayer.GetCollFlags() &
                                               (ECollFlags.OBJCOL_FLAG_CHECKFROMLASTPOS | 
                                                ECollFlags.OBJCOL_FLAG_AUTOATTACH);
            }

            cPlayer.ClearCollFlags(ECollFlags.OBJCOL_FLAG_CHECKFROMLASTPOS | 
                                   ECollFlags.OBJCOL_FLAG_AUTOATTACH);
            bPlayerAttached = true;
        }
    }
    
    void DetachPlayer()
    {
        if (bPlayerAttached)
        {
            bPlayerAttached = false;
            cPlayer.DetachFromParentAndKeepWorldPos();
            cPlayer.SetCollFlags(nAutoAttachFlagsBeforeAttach);
        }
    }
    
    /////////////////////////////////////////////////////////////////////////////

    /** Klasa ai podrozujacego winda */
    public String sNPCPassengerBaseClass = "NewAIHuman";
    
    /** AI podrozujace winda */
    protected ControlObject[] aNPCPassengers = null;

    void AttachNPCPassengers()
    {
        aNPCPassengers = GetObjectsInRadiusFromClass(fExtRadius, sNPCPassengerBaseClass);
        for (int i=0; i<aNPCPassengers.length; i++)
        {
            if (aNPCPassengers[i] instanceof Actor &&
                IsPlayerAbove((Actor)aNPCPassengers[i]))
                aNPCPassengers[i].AttachAsChildToAndKeepWorldPos(this);
        }
    }
    
    void DetachNPCPassengers()
    {
        if (aNPCPassengers != null)
        {
            for (int i=0; i<aNPCPassengers.length; i++)
            {
                if (aNPCPassengers[i] != null &&
                    aNPCPassengers[i].GetParent() == this)
                    aNPCPassengers[i].DetachFromParentAndKeepWorldPos();
            }
            aNPCPassengers = null;
        }
    }
    
    // w momencie np. startu windy fizyka dla wszystkich podpietych actorow nie playerow jest aktywowana
    void StartPhysicsForPassengers()
    {
        ControlObject[] aPassengers = GetChildren();
		if (aPassengers != null)
        {
            for(int i=0; i < aPassengers.length; i++) 
            {
                // wlacz fizyke dla wylaczonych na fizyce particli CDBiped
                if( aPassengers[i] instanceof Actor &&
                    !(aPassengers[i] instanceof Player) )
                {
                    Actor cAct = (Actor)aPassengers[i];
                    if(cAct.bDead)
                        ((MeshObject)aPassengers[i]).PhysicsOn();
                }
            }
        }
    }
    
    
    /////////////////////////////////////////////////////////////////////////////
    
    void SetStateStopped(float fTime)
    {
        if ( GetModule() instanceof ModuleNet)
            m_nState     = _STATE_STOPPED;
        m_fTimeState = fTime;
        
        SetState("Stoped");
    }
    
    public class Stoped extends State
    {
		boolean bLoading = false;
		
        public void OnEnter()
        {
            m_nState = _STATE_STOPPED;
            
            DetachPlayer();
            DetachNPCPassengers();
            
            if (nSoundId!=-1) 
			{ 
				DetachSound(nSoundId); 
				nSoundId = -1;
			}
			
            nSoundId = AttachSound(sStopSound);
			
			if (!bLoading)
			{
				PlayAnimAtTime( "OpenNogas", m_fTimeState );
			
				float fAnim = GetAnimLength("OpenNogas");
			
				CallMethodIn((!bLoading) ? "Stoped" : "SGStoped", m_fTimeState + fAnim - GetTime() );
			}
        }		
		
		
		public void SGUpdate()
		{		
			bLoading = true;
			OnEnter();
			if (bActive) SGStoped();
			bLoading = false;
		}
        
        public void OnAudioReinitialize()
        {
            if (nSoundId != -1)
            {
                nSoundId = AttachSound(sMovingSound);
            }
        }
    }
    
    void Stoped()
    {
    }
	
    void SGStoped()
    {
    }	
    
    
    /** Powoduje odpalenie windy
     */
    public void SetStateMoving(float fTime)
    {
        if ( GetModule() instanceof ModuleNet )
            m_nState     = _STATE_MOVING;
		
        m_fTimeState = fTime;
        
        // sprawdzamy czy winda nie jedzie juz
        if (!bActive) return;     
        
        // wlaczamy sekwencje ruszania
        bActive = false;
        
        PlayAnimAtTime("HideNogas", fTime);
        
        CallMethodIn( "SetStateMoving", (m_fTimeState + m_fAnimHideHogasLength) - GetTime() );
        
        if (nSoundId!=-1) 
		{
            DetachSound(nSoundId); 
			nSoundId = -1;
		}

        nSoundId = AttachSound(sStartSound);
    }
        
    public void OnAudioReinitialize()
    {
        if (nSoundId != -1)
        {
            nSoundId = AttachSound(sMovingSound);
        }
    }
    
    /** Metoda uruchamia ruszanie windy
     */
    void SetStateMoving()
    {
        SetState("Moving");
    }
	
	public void InMovingState()
	{
	}
    
    public class Moving extends State
    {
        float fNextNoiseTime;
        
        public void OnEnter()
        {
            m_nState = _STATE_MOVING;						
			
			InMovingState();
            
            AttachPlayer();
            AttachNPCPassengers();
            StartPhysicsForPassengers();
            
            if (nSoundId!=-1) 
			{
				//CrashLog("[LiftPlatformBase:State:Moving] : Dettached sound : <" + nSoundId + ">\n");
                DetachSound(nSoundId); nSoundId = -1;
			}
            nSoundId = AttachSound(sMovingSound);
			//CrashLog("[LiftPlatformBase:State:Moving] : Attached moving sound : <" + nSoundId + ">\n");
						            
			fActualTime       = (m_fTimeState + m_fAnimHideHogasLength);
            fDistance         = 0.0f;                        
			
            vStartPos         = GetPosition();
            fNextNoiseTime = GetTime() + _NOISE_INTERVAL;
        }

        void OnFrame()
        {
            if (bPlayerAttached && cPlayer != null && 
                !IsPlayerAbove(cPlayer))
            {
                DetachPlayer();
            }

            float fTimeDiff = 0.0f;
            Vector vPos = null;
                        
            fPrevTime   = fActualTime;
            fActualTime = GetTime();
            fTimeDiff   = fActualTime - fPrevTime;
            fDistance  += fTimeDiff*fMoveSpeed;
                
            vPos = new Vector(vStartPos);
            
            float fMove = fDistance >= fMovingDistance ? fMovingDistance : fDistance;
			
            vPos.fY += fMove*fMovingDirection;
            SetPosition(vPos);
			
            if (fDistance >= fMovingDistance) 
            {
                float fEndTime = m_fTimeState // czas rozpoczecia poruszania
                                 + m_fAnimHideHogasLength // czas animacji
                                 + (fMovingDistance / fMoveSpeed); // czas przesuwu windy
                
                SetStateStopped( fEndTime );
                
                // zmieniamy kierunek na przyszlosc
                fMovingDirection *= -1.0f;
                // i policzmy poczatkowa pozycje
                vStartPos         = GetPosition();
            }

            if (bMakeNoise && 
                GetModule() instanceof ChromeModuleSingle &&
                fActualTime > fNextNoiseTime)
            {
                fNextNoiseTime = fActualTime + _NOISE_INTERVAL;
                Actor noisyActor = ((ChromeModuleSingle)GetModule()).DummyNoisyActor;
                noisyActor.SetPositionWorld(GetPositionVectorVolatile());
                noisyActor.MakeNoise(fNoiseRangeMoving, Pawn._NOISE_PASSAGE);
            }
        }
        
        public void OnAudioReinitialize()
        {
            if (nSoundId != -1)
            {
                nSoundId = AttachSound(sMovingSound);
            }
        }
        
    }
    
    
 
    
    void AttachPlayers()
    {
        if ( m_cPlayerManager == null )
        {
            ControlObject[] aObj = GetObjectsInRadiusFromClass(5.0f,"Actor");
            for (int i = 0; i < aObj.length; i++)
            {
                Actor cPlayer = (Actor)aObj[ i ];
                
                if ( IsPlayerAbove( cPlayer ) )
                {
                    AttachPlayer( cPlayer );
                }
            }
        }
        else
        {
            for ( int i=0; i< m_cPlayerManager.GetMaxPlayers(); i++ )
            {
                Actor cPlayer = m_cPlayerManager.GetPlayer(i);
                if ( cPlayer == null )
                    continue;
                
                if ( IsPlayerAbove( cPlayer ) )
                {
                    AttachPlayer( cPlayer );
                    
                    MsgSendClientAttachPlayer( cPlayer );
                }
            }
        }
    }
    
    void AttachPlayer(Actor cPlayer)
    {
        if ( cPlayer instanceof PlayerNetBase )
            ((PlayerNetBase)cPlayer).AttachPlayerToFloor( this );
    }
    
    
    
    //TODO: a co bedzie z detachowaniem trupkow?
    
    void DetachPlayers()
    {
        DisableCallMethod("CheckPlayersToAttach");
            
        for ( int i=0; i<aAttachedPlayers.size(); i++ )
		{
			Actor cPlayer = ((Actor) aAttachedPlayers.elementAt(i));
			if ( cPlayer == null )
				continue;
            
            DetachPlayer( cPlayer );
        }
        
        aAttachedPlayers.removeAllElements();
    }
    
    void DetachPlayer(Actor cPlayer)
    {
        if ( cPlayer instanceof PlayerNetBase )
            ((PlayerNetBase)cPlayer).DetachPlayerFromFloor();
    }
    
    final static int _STATE_STOPPED = 0;
    final static int _STATE_MOVING  = 1;
    int   m_nState     = _STATE_STOPPED;
    float m_fTimeState = 0.0f;

    
    final static int MSG_CLIENT_LIFT_STATE     = 10;
    final static int MSG_CLIENT_ATTACH_PLAYER  = 11;
    final static int MSG_SERVER_LIFT_RUN_REQ   = 12;
    final static int MSG_SERVER_LIFT_CALL_REQ  = 13;
    
    
    public void OnMessage()
    {
        switch ( MessageGetId() )
        {
        case MSG_CLIENT_LIFT_STATE:    
            LogD("->MSG_CLIENT_LIFT_STATE\n");
            MsgRecvClientState();
            break;
            
        case MSG_CLIENT_ATTACH_PLAYER:    
            LogD("->MSG_CLIENT_ATTACH_PLAYER\n");
            MsgRecvClientAttachPlayer();
            break;
            
        case MSG_SERVER_LIFT_RUN_REQ:    
            LogD("->MSG_SERVER_LIFT_RUN_REQ\n");
            MsgRecvServerLiftRunRequest();
            break;
            
        case MSG_SERVER_LIFT_CALL_REQ:    
            LogD("->MSG_SERVER_LIFT_CALL_REQ\n");
            MsgRecvServerLiftCallRequest();
            break;
        
        default:
            MessageCancel();
        }
    }
    
    
    void MsgSendClientState()
    {
        LogD("MSG_CLIENT_LIFT_STATE->\n");
        MessageNew( MSG_CLIENT_LIFT_STATE );
        MessagePackInt( m_nState );
        MessagePackFloat( m_fTimeState );

        MessagePackStateData();
        
        MessageSend();
    }
    
    void MessagePackStateData()
    {
        
    }
    
    void MsgRecvClientState()
    {
        LogD("\n");
        
        int   nState = MessageUnPackInt();
        float fTime  = MessageUnPackFloat();
        
        MessageUnPackStateDataEnd(nState,fTime);
    }
    
    void MessageUnPackStateDataEnd(int nState,float fTime)
    {
        MessageEnd();
    }
    
    void MsgSendClientAttachPlayer( Actor cPlayer )
    {
        MessageNew( MSG_CLIENT_ATTACH_PLAYER );
        MessagePackInt( cPlayer.GetNetId() );
        MessageSend();
    }
    
    void MsgRecvClientAttachPlayer()
    {
        int nId = MessageUnPackInt();
        MessageEnd();
        
        // odrzucmy go, jesli juz mamy go podlaczonego
        for ( int i=0; i<aAttachedPlayers.size(); i++ )
		{
			Actor cPlayer = ((Actor) aAttachedPlayers.elementAt(i));
            if ( cPlayer != null && cPlayer.GetNetId() == nId )
                return;
        }
        
        aPlayersToAttach.addElement( new Integer( nId ) );
             
        CheckPlayersToAttach();
    }
    
    void MsgSendServerLiftRunRequest(boolean bUp)
    {
        LogD("MSG_SERVER_LIFT_RUN_REQ -> "+(bUp?"up":"down")+"\n");
        MessageNew( MSG_SERVER_LIFT_RUN_REQ );
        MessageSend();
    }
    
    void MsgRecvServerLiftRunRequest()
    {
        MessageEnd();
    }
    
    void MsgSendServerLiftCallRequest(MeshObject cFloor)
    {
        LogD("MSG_SERVER_LIFT_CALL_REQ->\n");
        MessageNew( MSG_SERVER_LIFT_CALL_REQ );
        MessageSend();
    }
    
    void MsgRecvServerLiftCallRequest()
    {
        MessageEnd();
    }
    
    void CheckPlayersToAttach()
    {
        DisableCallMethod("CheckPlayersToAttach");
        
        for ( int i=0; i<aPlayersToAttach.size(); i++ )
        {
            if ( ! (aPlayersToAttach.elementAt(i) instanceof Integer ))
                continue;
            
            int nId = ((Integer)aPlayersToAttach.elementAt(i)).intValue();
            Actor cPlayer = GetActorByNetId( nId );
            
            if ( cPlayer != null )
            {
                AttachPlayer( cPlayer );
                aPlayersToAttach.removeElementAt( i );
                i--;
            }
        }
        
        if ( aPlayersToAttach.size() > 0 )
            CallMethodIn("CheckPlayersToAttach",0.1f);
    }
    
    //*********************************************************
	//					SaveGame
    //*********************************************************
	
		
    /** Metoda wczytujaca zapisane dane w Save gracza
     */	
    public void SGLoadChunk(FileChunk cParentFC)
    {	
		FileChunk.Log("[LiftPlatformBase.SGLoadChunk]\n");
		
		FileChunk cFC = GameObject.LoadChunk(cParentFC);   
		
        if (cFC.GetID() == ESGChunksChrome._CHK_LIFT_PLATFORM_BASE)
        {
			super.SGLoadChunk(cFC);
			
			bActive = cFC.LoadBool();
						
			// kierunek w ktorym, po uzyciu windy, bedzie sie ona poruszac 1- gora, -1 -dol
			fMovingDirection = cFC.LoadFloat();
			// wysokosc na jaka wjezdza lub z jakiej zjezdza winda (w cm)
			fMovingDistance = cFC.LoadFloat();			
			// poczatkowe polozenie windy
			vStartPos = cFC.LoadVector();
			vPlayerPos = cFC.LoadVector();
			bPlayerAttached = cFC.LoadBool();
            nAutoAttachFlagsBeforeAttach = cFC.LoadInt();
			// odleglosc na jaka poruszyla sie winda
			fDistance = cFC.LoadFloat();
			
			// referencja do playera
			cPlayer = (Player)cFC.LoadObjectRef();
			
			m_nState = cFC.LoadInt();
			
			// parametry "czasowe" zwiazane z predkoscia poruszania sie windy
			fPrevTime = cFC.LoadFloat();
			fActualTime = cFC.LoadFloat();
			m_fTimeState = cFC.LoadFloat();
																									
			//Klasa ai podrozujacego winda
			sNPCPassengerBaseClass = cFC.LoadString();
			// AI podrozujace winda
			int nSize = cFC.LoadInt();
			
			if (nSize > 0)
			{
				aNPCPassengers = new ControlObject[nSize];
				for (int i=0; i < aNPCPassengers.length; i++)
					aNPCPassengers[i] = (ControlObject)cFC.LoadObjectRef();			
			}
			else
				aNPCPassengers = null;
        }
		
		cFC.delete();
	}
		
    /** Metoda zapisujaca dane do Save gracza
     */	
    public void SGSaveChunk(FileChunk cFCParent)
    {
		FileChunk.Log("[LiftPlatformBase.SGSaveChunk]\n");
		
        FileChunk cFC = NewChunk(ESGChunksChrome._CHK_LIFT_PLATFORM_BASE, cFCParent);
		
		super.SGSaveChunk(cFC);
		
		cFC.SaveBool(bActive);
		    
		// kierunek w ktorym, po uzyciu windy, bedzie sie ona poruszac 1- gora, -1 -dol
		cFC.SaveFloat(fMovingDirection);
		// wysokosc na jaka wjezdza lub z jakiej zjezdza winda (w cm)
		cFC.SaveFloat(fMovingDistance);
		// poczatkowe polozenie windy
		cFC.SaveVector(vStartPos);
		cFC.SaveVector(vPlayerPos);
		cFC.SaveBool(bPlayerAttached);
        cFC.SaveInt(nAutoAttachFlagsBeforeAttach);
        
		// odleglosc na jaka poruszyla sie winda
		cFC.SaveFloat(fDistance);
		// referencja do playera
		cFC.SaveObjectRef(cPlayer);
    
		cFC.SaveInt(m_nState);
		
		// parametry "czasowe" zwiazane z predkoscia poruszania sie windy
		cFC.SaveFloat(fPrevTime);
		cFC.SaveFloat(fActualTime);    		
		cFC.SaveFloat(m_fTimeState);
						
		//Klasa ai podrozujacego winda
		cFC.SaveString(sNPCPassengerBaseClass);
		// AI podrozujace winda			
		cFC.SaveInt((aNPCPassengers == null) ? -1 : aNPCPassengers.length);
		if (aNPCPassengers != null)
		for (int i=0; i < aNPCPassengers.length; i++)
			cFC.SaveObjectRef(aNPCPassengers[i]);
							
		cFC.delete(); 
	}
	
	public void SGUpdate()
	{
		FileChunk.Log("[LiftPlatformBase.SGUpdate]\n");
		
		SetPosition(vStartPos);
		
		DisableCallMethod( "Init" );
		
		super.SGUpdate();	
	}	
}
