/** Guzik przywolujacy winde
 */
public class LiftPlatformButton extends AnimatedScreen
{
    /** Ustawiana w edytorze winda kontrolowana przez guzik  */
    public Object cControlledLift = null;//#BUTTON
    
    /** Ustawiany w edytorze obiekt pietra do ktorego winda przyjezdza po nacisnieciu guzika */
    public Object cFloorRef = null;//#BUTTON

    public AnimatedScreen cTwinButtonForTeleport = null;//#BUTTON
    
    String sUseSound = "Data/Sounds/doors/LockSystemAccept.wav";//#BUTTON
    
    LiftPlatform cLift = null;
    MeshObject cFloor = null;

    int _DOORS_UNLOCKED_LIFT_OK         = 0,
        _DOORS_UNLOCKED_LIFT_AWAY       = 1,
        _DOORS_UNLOCKED_LIFT_COMING     = 2,
        _DOORS_LOCKED_ACTIVE            = 3,
        _DOORS_LOCKED_INACTIVE          = 4;
    
    LiftPlatformButton()
    {
        sOriginalMaterial = "Ekran1.mat";
        sMaterialsList = "Ekran1GreenOn.mat;Ekran1YellowOff.mat;Ekran1YellowOn.mat;Ekran1RedOff.mat;Ekran1RedOn.mat";
        nStartupScreenIdx = 0;
    }
    
    public void OnCreate()
    {
        super.OnCreate();
		
		bSG = true;

        // ustawiamy winde
        cLift = (LiftPlatform)cControlledLift;
        
        if(cControlledLift==null)
        {
            LogR("[LiftPlatformButton.OnCreate] <"+GetName()+"> No controlled lift selected\n");
            bActiveTrigger = false;
            return;
        }

        if(cFloorRef==null)
        {
            CrashLog("[LiftPlatformButton.OnCreate] <"+GetName()+"> No controlled floor selected\n");
            bActiveTrigger = false;
        }
        else
        {
            cFloor = (MeshObject)cFloorRef;
            if( cFloor instanceof LiftPlatformFloor)
            {
                ((LiftPlatformFloor)cFloor).cButton = this;
            }
        }
        
        fHealth = 1e9f;//HAK!!!
        
        NoLiftOnFloor(cLift.bLocked);
    }

    String GetTip()
    {
        return "&CALL_LIFT&";
    }
    
    void NoLiftOnFloor(boolean bDoorsLocked)
    {
        if (bDoorsLocked && !cLift.bActive)
            SetScreen(_DOORS_LOCKED_INACTIVE);
        else
            if (bDoorsLocked && cLift.bActive)
                SetScreen(_DOORS_LOCKED_ACTIVE);
            else
                SetScreen(_DOORS_UNLOCKED_LIFT_AWAY);
        if (!bDoorsLocked)
            bActiveTrigger = true;
        else 
            bActiveTrigger = false;
    }
    
    void LiftOnFloor(boolean bDoorsLocked)
    {
        if (bDoorsLocked && !cLift.bActive)
            SetScreen(_DOORS_LOCKED_INACTIVE);
        else
            if (bDoorsLocked && cLift.bActive)
                SetScreen(_DOORS_LOCKED_ACTIVE);
            else
                SetScreen(_DOORS_UNLOCKED_LIFT_OK);
        
        bActiveTrigger = false;
    }
    
    void DoorsLockedByMission(boolean bLiftOnFloor)
    {
        //zakladamy, ze jesli jest winda i jest przycisk, to w pewnych okolicznosciach 
        //winde da sie wlaczyc
        SetScreen(_DOORS_LOCKED_ACTIVE);
        bActiveTrigger = false;
    }
    
    void DoorsUnlockedByMission(boolean bLiftOnFloor)
    {
        if (!bLiftOnFloor)//winda poza pietrem
        {
            SetScreen(_DOORS_UNLOCKED_LIFT_AWAY);
            bActiveTrigger = true;
            
        }
        else
        {
            SetScreen(_DOORS_UNLOCKED_LIFT_OK);
            bActiveTrigger = false;
        }
    }
    
    void LiftRunningToFloor()
    {
        SetScreen(_DOORS_UNLOCKED_LIFT_COMING);
        bActiveTrigger = false;
    }
    
    void ActionExecute( Actor executor )
    {
        Execute( executor );
    }
    
    // metoda wolana na filmach do przywolania windy na pietro
    // dodana 2003-03-20 by Czesiu
    void CallLift()
    {
        Execute(null);
    }
        
    void Execute( Actor executor )
    {
        if (cLift==null) 
            return;
        
        PlaySound( sUseSound );
        
        //LogR("ButtonExecute "+((Role == ERole._AUTHORITY)?"server":"client")+"\n");
        if (Role == ERole._AUTHORITY)
        {
            cLift.SetStateMoving( cFloor, GetTime() );
            cLift.MsgSendClientState();
        }
        else
            cLift.MsgSendServerLiftCallRequest( cFloor );
    }
    
    
    public LiftPlatformFloor GetFloor() // nowy system!!!
    {
        if (cFloor instanceof LiftPlatformFloor)
            return (LiftPlatformFloor)cFloor;
        else
            return null;
    }

    
    public LiftPlatform GetLift()
    {
        return cLift;
    }
	
    public void Enable()
    {
        super.Enable();
        if (cFloor instanceof LiftPlatformFloor)
            ((LiftPlatformFloor)cFloor).UpdateButton();
    }
    
    public void Disable()
    {
        super.Disable();
        SetScreen(_DOORS_LOCKED_INACTIVE);
    }
    
    
    public void SetScreen(int nScreen)
    {
        super.SetScreen(nScreen);
        if (cTwinButtonForTeleport != null)
        {
            cTwinButtonForTeleport.SetScreen(nScreen);
        }
    }
    
    //*********************************************************
	//					SaveGame
    //*********************************************************
	
    /** Metoda wczytujaca zapisane dane w Save gracza
     */	
    public void SGLoadChunk(FileChunk cParentFC)
    {	
		FileChunk.Log("[LiftPlatformButton.SGLoadChunk]\n");
		
		FileChunk cFC = GameObject.LoadChunk(cParentFC);   
		
        if (cFC.GetID() == ESGChunksChrome._CHK_LIFT_PLATFORM_BUTTON)
        {
			super.SGLoadChunk(cFC);									
        }
		
		cFC.delete();
	}
	
    /** Metoda zapisujaca dane do Save gracza
     */	
    public void SGSaveChunk(FileChunk cFCParent)
    {
		FileChunk.Log("[LiftPlatformButton.SGSaveChunk]\n");
		
        FileChunk cFC = NewChunk(ESGChunksChrome._CHK_LIFT_PLATFORM_BUTTON, cFCParent);
		
		super.SGSaveChunk(cFC);
						
		cFC.delete(); 
	}
    
    /*public void SetScreen(int n)
    {
        CrashLog("Setting " + n + " screen");
        super.SetScreen(n);
    }*/

}
