/** menu z wyswietlanymi creditsami
 */

public class ChromeCreditsMenu extends ChromeMenuWindow
{
    /** czas trwania wygaszania sie (pojawiania sie) kolejnego spritea 
     */
    float fFadeTime = 0.5f;
    
    /** czas po ktorym pojawia sie kolejny sprite
     */
    float fDelayTime = 6;
    
    /** wektor nazw kolenych tekstur wysietlanych w slide show
     */
    java.util.Vector vTexturesNames = new java.util.Vector(5);
    java.util.Vector vTexts = new java.util.Vector(5);
    
    /** rozmiary kolejno wyswietlanych picturesow w slide_show
     */
    float fSizeX = 640.0f;
    float fSizeY = 480.0f;
    
    /** wspolrzedne obrazka na teksturze
     */
    float fOnTexPosX = 640.0f;
    float fOnTexPosY = 480.0f;
    
    /** index aktualnie wyswietlanego obrazka
     */
    int nActualPictIdx = -1;
    
    /** zmienne pomocnicze do ustalania czasw fade'ow
     */
    float fPrevTime = 0.0f;
    float fActualTime = 0.0f;
    float fAlfaChangeStep = 0.03f;
        
    /** aktualna alfa picturesa
     */
    float fAlfa = 0.0f;
    
    /** rozmiary ekranu
     */
    float fScrSizeX = 0.0f;
    float fScrSizeY = 0.0f;                    
    
    Sprite cBackgr = null;
    int nTexture = 0;
    
    Sprite cBlack = null;
    int nBlackTex = 0;
    
    Sprite cText = null;
    
    boolean m_bWaitForExit = false;
    
    String GetScriptName()
    {
        return null;
    }
    
    public void OnCreate()
    {
        super.OnCreate();
    }
    
    String sCurText = null;
    
    
    
//------------------------------------------------------------------------------------------------    
    void Init(MenuBackground cBack)
    {
        cBlack = (Sprite)CreateObject("Sprite");
        AddSprite(cBlack);
        cBlack.SetSize(new Vector(GetScreenWidth(), GetScreenHeight(),0));
        cBlack.Show();
        nBlackTex = cBlack.AddTexture("er_t_black.png");
        cBlack.SetTexture(nBlackTex, new Rect(0,0,1,1));
        
        cBackgr = (Sprite)CreateObject("Sprite");
        AddSprite(cBackgr);
        cBackgr.SetSize(new Vector(GetScreenWidth(), GetScreenHeight(),0));
        cBackgr.Show();
        
        sCurText = "";
        
        if(ChromeModuleSingle._bCDActionDemo)
        {
            nTexture = cBackgr.AddTexture("data/Textures/slideshow/SlideShow01.jpg", true, false, ETextureQuality.HIGH);
            sCurText = "&SLIDESHOW_01&";
        }
        else
            if(ChromeModuleSingle._bPrologDemo)
            {
                nTexture = cBackgr.AddTexture("data/Textures/slideshow/SlideShow_01.png", true, false, ETextureQuality.HIGH);
                sCurText = "";
            }
            else
                if(ChromeModule._bMultiplayerDemo)
                {
                    nTexture = cBackgr.AddTexture("data/Textures/slideshow/SlideShow_01.png", true, false, ETextureQuality.HIGH);
                    sCurText = "";
                }
        
        cBackgr.SetTexture(nTexture, new Rect(0,0,1,1));
        MenuModule=(ChromeMenuModule)GetModule();
        cBackgr.MoveTop();

        cText = (Sprite)CreateObject("Sprite");
        AddSprite(cText);
        cText.SetSize(new Vector(GetScreenWidth(), GetScreenHeight(),0));
        cText.SetPos(new Vector(GetScreenWidth()/6f, GetScreenHeight() - GetScreenHeight()/3, 0));
        cText.Show();
        cText.SetFont("Verdana22");
        cText.SetTextPosFlags(ESpriteText.MULTILINE);
        cText.MoveTop();
        
        MenuModule.cCursor.Hide();
        fScrSizeX = GetScreenWidth();
        fScrSizeY = GetScreenHeight();
        
        SetRelativePos(new Vector(0,0,0));
        SetSize(new Vector(fScrSizeX,fScrSizeY,0));

        ProcessMouse(true);
        ProcessKb(true);
        
        //inicjalizacja wektora z kolejnymi picturesami do slide show
        if(ChromeModuleSingle._bCDActionDemo)
        {
            vTexturesNames.addElement((String)"data/Textures/slideshow/SlideShow02.jpg");//SlideShow/panel02.png");
            vTexturesNames.addElement((String)"data/Textures/slideshow/SlideShow03.jpg");//SlideShow/panel03.png");
            vTexturesNames.addElement((String)"data/Textures/slideshow/SlideShow04.jpg");//SlideShow/panel04.png");
            vTexturesNames.addElement((String)"data/Textures/slideshow/SlideShow05.jpg");
            vTexturesNames.addElement((String)"data/Textures/slideshow/SlideShow06.jpg");
            vTexturesNames.addElement((String)"data/Textures/slideshow/SlideShow07.jpg");
            vTexturesNames.addElement((String)"data/Textures/slideshow/SlideShow08.jpg");
        
            vTexts.addElement("&SLIDESHOW_02&");
            vTexts.addElement("&SLIDESHOW_03&");
            vTexts.addElement("&SLIDESHOW_04&");
            vTexts.addElement("&SLIDESHOW_05&");
            vTexts.addElement("&SLIDESHOW_06&");
            vTexts.addElement("&SLIDESHOW_07&");
            vTexts.addElement("&SLIDESHOW_08&");
        }
        else
        if(ChromeModuleSingle._bPrologDemo)
        {
            vTexturesNames.addElement((String)"data/Textures/slideshow/SlideShow_02.png");//SlideShow/panel02.png");
            vTexturesNames.addElement((String)"data/Textures/slideshow/SlideShow_03.png");//SlideShow/panel03.png");
            vTexturesNames.addElement((String)"data/Textures/slideshow/SlideShow_04.png");//SlideShow/panel04.png");
            vTexturesNames.addElement((String)"data/Textures/slideshow/SlideShow_05.png");
            vTexturesNames.addElement((String)"data/Textures/slideshow/SlideShow_06.png");
            vTexturesNames.addElement((String)"data/Textures/slideshow/SlideShow_07.png");
            vTexturesNames.addElement((String)"data/Textures/slideshow/SlideShow_08.png");

            vTexts.addElement("");
            vTexts.addElement("");
            vTexts.addElement("");
            vTexts.addElement("");
            vTexts.addElement("");
            vTexts.addElement("");
            vTexts.addElement("");
        }
        else
        if(ChromeModule._bMultiplayerDemo)
        {
            vTexturesNames.addElement((String)"data/Textures/slideshow/SlideShow_02.png");//SlideShow/panel02.png");
            vTexturesNames.addElement((String)"data/Textures/slideshow/SlideShow_03.png");//SlideShow/panel03.png");
            vTexturesNames.addElement((String)"data/Textures/slideshow/SlideShow_04.png");//SlideShow/panel04.png");
            vTexturesNames.addElement((String)"data/Textures/slideshow/SlideShow_05.png");

            vTexts.addElement("");
            vTexts.addElement("");
            vTexts.addElement("");
            vTexts.addElement("");
            vTexts.addElement("");
        }
        
        cBackgr.SetAlpha(0.0f);
        cText.SetTextColor(1,1,1, 0.0f);
        cText.DisplayText(sCurText);
        fActualTime = GetTime();
        CallMethodIn("StartIncreaseAlpha", 0.0f);
       
                
        RegisterKeyRequest();

    }
    
    public void OnDestroy()
    {
        super.OnDestroy();
        cBackgr.ReleaseTexture(nTexture);
        RemoveSprite(cBackgr);
        cBackgr.delete();
        cBackgr = null;
        
        cBlack.ReleaseTexture(nBlackTex);
        RemoveSprite(cBlack);
        cBlack.delete();
        cBlack = null;
        
        RemoveSprite(cText);
        cText.delete();
        cText = null;
    }
    
//--------------------------------------------------------------------------------------    
    void Discard()
    {
		if(!CanDiscard())
			return;
		
        ExitGame();
    }
//--------------------------------------------------------------------------------------    
     public void OnInputKey(int nKeyCode, boolean bKeyState, char nKeyAscii)
    {
        if (bKeyState)
        {
            if (m_bWaitForExit)
            {
                ExitGame();
            }
            else
            {
                PlaySound(ChromeMenuModule.SoundButtonClicked);
                DisableCallMethod("ShowNextPicture");
                ShowNextPicture();
            }
                
        }
    }
     
     

//--------------------------------------------------------------------------------------
     void ShowNextPicture()
     {
         nActualPictIdx++;
         if (nActualPictIdx > vTexturesNames.size() - 1)
         {
             nActualPictIdx--;
             cBackgr.SetAlpha(1.0f);
             cText.SetTextColor(1,1,1, 1.0f);
             fActualTime = GetTime();
             CallMethodEvery("DecreaseAlfaTheEnd", 0.01f);
         }
         else
         {
             cBackgr.SetAlpha(1.0f);
             cText.SetTextColor(1,1,1, 1.0f);
             fActualTime = GetTime();
             CallMethodEvery("DecreaseAlfa", 0.01f);
         }

     }
     
//--------------------------------------------------------------------------------------     
    /** metoda wyswietla pictures o podanym indeksie
     */
    void ShowPictureNr(int idx)
    {
       
        if (nTexture != 0)
            cBackgr.ReleaseTexture(nTexture);
        
        nTexture = cBackgr.AddTexture((String)(vTexturesNames.elementAt(idx)), true, false, ETextureQuality.HIGH);
        cBackgr.SetTexture(nTexture, new Rect(0,0,1,1));
        sCurText = (String)(vTexts.elementAt(idx));
        cBackgr.SetAlpha(0.0f);
        cText.SetTextColor(1,1,1, 0.0f);
        cText.DisplayText(sCurText);
     
        CallMethodIn("StartIncreaseAlpha", 0.0f);
    }
//--------------------------------------------------------------------------------------
    /** metoda wywolywana gdy pokazano juz wszytskie picturesy
     */
    void TheEnd()
    {
        m_bWaitForExit = true;
    }
//--------------------------------------------------------------------------------------
    /** metoda zwiekszajaca stopniowo alfe picturesa
     */
    void IncreaseAlfa()
    {
        Log("Zwiekszam alfe \n");
        
        fPrevTime = fActualTime;
        fActualTime = GetTime();
        
        fAlfa+=(fActualTime - fPrevTime)/fFadeTime;
        if (fAlfa >= 1.0f)
        {
            fAlfa = 1.0f;
            cBackgr.SetAlpha(fAlfa);
            cText.SetTextColor(1,1,1, fAlfa);
            cText.DisplayText(sCurText);
          
            DisableCallMethod("IncreaseAlfa");
            CallMethodIn("ShowNextPicture",fDelayTime);
        }
        else
        {
               
            cBackgr.SetAlpha(fAlfa);
            cText.SetTextColor(1,1,1, fAlfa);
            cText.DisplayText(sCurText);
            
        }
        
        
    }

//--------------------------------------------------------------------------------------
     /** metoda zmniejszajaca stopniowo alfe picturesa
     */
    void DecreaseAlfa()
    {
        
        fPrevTime = fActualTime;
        fActualTime = GetTime();
        
        fAlfa-=(fActualTime - fPrevTime)/fFadeTime;
        if (fAlfa <= 0.0f)
        {
            fAlfa = 0.0f;
            cBackgr.SetAlpha(fAlfa);
            cText.SetTextColor(1,1,1, fAlfa);
            cText.DisplayText(sCurText);
         
            DisableCallMethod("DecreaseAlfa");
            ShowPictureNr(nActualPictIdx);
        }
        else
        {
        
            cBackgr.SetAlpha(fAlfa);
            cText.SetTextColor(1,1,1, fAlfa);
            cText.DisplayText(sCurText);
            
        }
        
        
    }

//--------------------------------------------------------------------------------------
 /** metoda zmniejszajaca stopniowo alfe picturesa
     */
    void DecreaseAlfaTheEnd()
    {
        
        fPrevTime = fActualTime;
        fActualTime = GetTime();
        
        fAlfa-=(fActualTime - fPrevTime)/fFadeTime;
        if (fAlfa <= 0.0f)
        {
            TheEnd();
        }
        else
        {
         
            //nie fadujemy, czekamy na klawisz
            //cBackgr.SetAlpha(fAlfa);
            //cText.SetTextColor(1,1,1, fAlfa);
            //cText.DisplayText(sCurText);
            
        }
        
        
    }
//--------------------------------------------------------------------------------------    
    void StartIncreaseAlpha()
    {
        fActualTime = GetTime();
        CallMethodEvery("IncreaseAlfa", 0.01f);  
    }
//--------------------------------------------------------------------------------------    
}
