public class ChromeMenuLevelSelection extends ChromeMenuWindow
{
    int m_iNumberOfActiveButtons = 0;
    
    int m_iActiveButton = -1;
    
    final static int _MAX_NR_OF_BUTTONS = 16;
    
    UIMenu m_cUIButtonsMenu = null;
    
    UIMenuButton m_cMenuButtons[] = new UIMenuButton[_MAX_NR_OF_BUTTONS];
    
    String m_cBitmapsFile[] = new String[_MAX_NR_OF_BUTTONS];
    String m_cLevelSriptFile[] = new String[_MAX_NR_OF_BUTTONS];
    //String m_cBitmapsFile[] = null;
    //String m_cLevelSriptFile[] = null;
	
	final static String[] s_aScriptLevelsNames = {"LevelsSingle_0.scr",
												"LevelsSingle_1.scr",
												"LevelsSingle_2.scr",
												"LevelsSingle_3.scr",
												"LevelsSingle_4.scr",
												"LevelsSingle_6.scr",
												"LevelsSingle_8.scr",
												"LevelsSingle_9.scr",
												"LevelsSingle_10a.scr",
												"LevelsSingle_10.scr",
												"LevelsSingle_11.scr",
												"LevelsSingle_12.scr",
												"LevelsSingle_7.scr",
												"LevelsSingle_13.scr",
                                                "LevelsSingle_T.scr"};
    
    /**Czy wypelniamy menu tylko pod katem obecnosci na dysku  (dema itp)*/
    static boolean s_bCheatLevelsMenu = false;
    
    void Init(MenuBackground cBack)
    {
    	MenuModule=(ChromeMenuModule)GetModule();
      
        m_cUIButtonsMenu = (UIMenu)GetElem("ID_MENU_LEVELS");
        
        for(int i = 0; i < _MAX_NR_OF_BUTTONS; i++)
        {
            int iButtonID = i+1;
            m_cMenuButtons[i] = (UIMenuButton)m_cUIButtonsMenu.GetElem("ID_" + iButtonID);
            
            //na poczatek chowamy wszystkie przyciski
            m_cMenuButtons[i].Hide();
			m_cMenuButtons[i].SetDisabled(true);
        }
        GetElem("ID_SCREENSHOT").Hide();
        FillLevelsButtons();
    }

    boolean CheckFile(String  sFile)
    {
        if (s_bCheatLevelsMenu)
        {        
            java.io.File file = new java.io.File(sFile);
            return file.exists();            
        }
        else
        {
            return (MenuModule.m_bAllMissions || ChromeModuleSingle.IsMissionAvailable(sFile));
        }
    }
    
        
    void FillLevelsButtons()
    {
        ActivateNewButton("&LEVEL_SAVE_0&", "Data/" + s_aScriptLevelsNames[0]);
        if(CheckFile("Data/Levels/Level01/Level01.map")) ActivateNewButton("&LEVEL_SAVE_1&", "Data/" + s_aScriptLevelsNames[1]);
        if(CheckFile("Data/Levels/Level02/Level02.map")) ActivateNewButton("&LEVEL_SAVE_2&", "Data/" + s_aScriptLevelsNames[2]);
        if(CheckFile("Data/Levels/Level03/Level03.map")) ActivateNewButton("&LEVEL_SAVE_3&", "Data/" + s_aScriptLevelsNames[3]);
        if(CheckFile("Data/Levels/Level04/Level04.map")) ActivateNewButton("&LEVEL_SAVE_4&", "Data/" + s_aScriptLevelsNames[4]);
        if(CheckFile("Data/Levels/Level06/Level06.map")) ActivateNewButton("&LEVEL_SAVE_6&", "Data/" + s_aScriptLevelsNames[5]);
        if(CheckFile("Data/Levels/Level08/Level08.map")) ActivateNewButton("&LEVEL_SAVE_8&", "Data/" + s_aScriptLevelsNames[6]);
        if(CheckFile("Data/Levels/Level09/Level09.map")) ActivateNewButton("&LEVEL_SAVE_9&", "Data/" + s_aScriptLevelsNames[7]);
        if(CheckFile("Data/Levels/Level10a/Level10a.map")) ActivateNewButton("&LEVEL_SAVE_10a&", "Data/" + s_aScriptLevelsNames[8]);
        if(CheckFile("Data/Levels/Level10/Level10.map")) ActivateNewButton("&LEVEL_SAVE_10&", "Data/" + s_aScriptLevelsNames[9]);
        if(CheckFile("Data/Levels/Level11/Level11.map")) ActivateNewButton("&LEVEL_SAVE_11&", "Data/" + s_aScriptLevelsNames[10]);
        if(CheckFile("Data/Levels/Level12/Level12.map")) ActivateNewButton("&LEVEL_SAVE_12&", "Data/" + s_aScriptLevelsNames[11]);
        if(CheckFile("Data/Levels/Level07/Level07.map")) ActivateNewButton("&LEVEL_SAVE_7&", "Data/" + s_aScriptLevelsNames[12]);
        if(CheckFile("Data/Levels/Level13a/Level13a.map") ||
           CheckFile("Data/Levels/Level13b/Level13b.map") ||
           CheckFile("Data/Levels/Level13c/Level13c.map")) 
            ActivateNewButton("&LEVEL_SAVE_13&", "Data/" + s_aScriptLevelsNames[13]);
    }
    
    void ActivateNewButton(String sText, String sLevelScriptFile)
    {
        sText = TextToUpperCase(Text.Get(sText));
        if( m_iNumberOfActiveButtons == _MAX_NR_OF_BUTTONS)
            return;
        
        int iButtonID = m_iNumberOfActiveButtons;
        
        
        m_cLevelSriptFile[iButtonID] = new String(sLevelScriptFile);
        
        if (MenuModule.cGameInitInfo == null)
            MenuModule.cGameInitInfo = new GameInitInfoSingle();
        
        MenuModule.cGameInitInfo.cLevels.Init(sLevelScriptFile);
        MenuModule.cGameInitInfo.cLevels.Restart();
        String sBitmapToShow = MenuModule.cGameInitInfo.cLevels.GetNextLevelBackground();
        m_cBitmapsFile[iButtonID] = new String(sBitmapToShow);
        
		m_cMenuButtons[iButtonID].SetDisabled(false);
        m_cMenuButtons[iButtonID].DisplayTextFitSizeWithMargin(sText, new Vector(2.0f, 1.0f, 0.0f));
        m_cMenuButtons[iButtonID].Show();
        
        m_iNumberOfActiveButtons++;
        
        FitMenuSize();
        
        //Aktywacja pierwszego dodanego buttonu
        if (m_iActiveButton == -1)
        {
            OnSetButton(iButtonID);
            m_cMenuButtons[iButtonID].SetCheck(true);
        }
    }
    
    //dostosowanie rozmiaru okna do ilosci aktywowanych buttonow
    void FitMenuSize()
    {
        Vector vMenuSize = m_cUIButtonsMenu.GetSize();
        Vector vButtonSize = m_cMenuButtons[0].GetSize();
        
        m_cUIButtonsMenu.SetSize(new Vector(vMenuSize.fX, (2+m_iNumberOfActiveButtons)*vButtonSize.fY, vMenuSize.fZ));
        m_cUIButtonsMenu.OnSizeAndPos();
        m_cUIButtonsMenu.OnSizeAndPos();
    }
    
    void ShowBitmap( String sTex )
    {
        LogR("ShowBitmap " + sTex + "\n");
        if (sTex != null)
        {
            GetElem("ID_SCREENSHOT").Show();
            UITexture cTexture = new UITexture(sTex, 512, 256, 0,0,512,256);
            GetElem("ID_SCREENSHOT").SetNormalTexture(cTexture);
            
        }
        else
        {
            GetElem("ID_SCREENSHOT").Hide();
        }
    }
    
    void OnSetButton(int nID)
    {
        for(int i = 0; i < _MAX_NR_OF_BUTTONS; i++)
        {
            if( nID != i)
                m_cMenuButtons[i].SetCheck(false);
            else
                m_cMenuButtons[i].SetCheck(true);
        }
                
                
        m_iActiveButton = nID;
        
        ShowBitmap( m_cBitmapsFile[nID] );
    }
    
    void LoadLevel()
    {
        GameInitInfoSingle game=new GameInitInfoSingle( m_cLevelSriptFile[m_iActiveButton] );
        if (!s_bCheatLevelsMenu)
        {
            //ma sie zaladowac cala lista leveli, a nie pojedynczy, zeby mozna bylo kontynuowac
            String sMap = game.cLevels.GetCurrent().sLevelName;
            game = new GameInitInfoSingle("data/LevelsSingleMissions.scr");
            while (game.cLevels.GetCurrent() != null)
            {
                LevelContent cLevel = game.cLevels.GetCurrent();
                if (cLevel.sLevelName.equals(sMap))
                    break;
                else
                    game.cLevels.NextLevel();
            }
        }
        MenuModule.NewGame(game);
        MenuModule.StartGame();
        LogR("LoadLevel " + m_cLevelSriptFile[m_iActiveButton] + "\n");
    }
     
    void Discard()
    {
        if(!CanDiscard())
			return;
		//MenuModule.SetMenu("ChromeNewGameMenu");
		MenuModule.SetMenu(MenuModule.sMenuBackName);
    }
    
    void OnUICommand(UIWindow cSender, int nCommand)
	{
		super.OnUICommand(cSender,nCommand);
        
        if(nCommand == EUIConst.CM_CLICK || nCommand == EUIConst.CM_DBCLICK)
        {
            if(cSender.m_sId.equals("ID_BACK"))
			{
			    Discard();
                return;
			}else
			if(cSender.m_sId.equals("ID_OK"))
			{
				if(s_bCheatLevelsMenu)
					LoadLevel();
				else
				{
					java.util.Vector vParams = new java.util.Vector();
					vParams.addElement(new String(m_cLevelSriptFile[m_iActiveButton]));
					MenuModule.SetMenu("ChromeNewGameMenu", vParams);
				}
                return;
			}
        
		    int nID = GetButtonId(cSender.m_sId);
            if( nID > 0 && nID <= _MAX_NR_OF_BUTTONS) 
			{
				OnSetButton( nID-1 ); //indeksowane od zera
			}
        }
    }
	

 }

