public class EChromeVideoMenuUI extends EUI 
{
    final static float P256 = 1.0f/256.0f;
    final static float P1024 = 1.0f/1024.0f;
    
    final static int ID_BTN_DEFAULT       = 402;
    final static int ID_BTN_OK            = 403;
    final static int ID_BTN_BACK          = 404;
    
    final static int ID_LABEL_VIDEOMODE   = 300; 
    final static int ID_LABEL_BPP         = 301;
    final static int ID_LABEL_FULLSCREEN  = 302;
    final static int ID_LABEL_FILTERING   = 303;
    final static int ID_LABEL_TEXQ        = 304;
    final static int ID_LABEL_FORCE16BIT  = 305;
    final static int ID_LABEL_BRIGHTNESS  = 306;
    
    final static int ID_BTN_VIDEOMODE   = 200; 
    final static int ID_BTN_BPP         = 201;
    final static int ID_BTN_FULLSCREEN  = 202;
    final static int ID_BTN_FILTERING   = 203;
    final static int ID_BTN_TEXQ        = 204;
    final static int ID_BTN_FORCE16BIT  = 205;
    final static int ID_BTN_BRIGHTNESS  = 206;
    final static int ID_BTN_SHADOWS     = 207;
    
    static int nH = 20;
    //-----------------------------------------------------------------------
    
    static UIElement Label_VideoMode = new UIElement(
        ID_LABEL_VIDEOMODE,0,
        new Vector(112,50 - nH,0),
        new Vector(256,32,0),
        MenuTextures.sRamka, 
        MenuTextures.sRamka, 
        MenuTextures.sRamka, 
        MenuTextures.sRamka, 
        EButtonFlags.BTN_TYPE_PUSHBUTTON,
        "&VIDEO MODE&"
        );
    
    static UIElement Button_VideoMode = new UIElement(
        ID_BTN_VIDEOMODE,0,
        new Vector(112+256,50 - nH,0),
        new Vector(128,32,0),
        MenuTextures.sRamkaMala, 
        MenuTextures.sRamka2Mala, 
        MenuTextures.sRamkaMala, 
        MenuTextures.sRamka2Mala,
        EButtonFlags.BTN_TYPE_PUSHBUTTON,
        ""
        );
    
    static UIElement Label_BPP = new UIElement(
        ID_LABEL_BPP,0,
        new Vector(112,84-nH,0),
        new Vector(256,32,0),
        MenuTextures.sRamka, 
        MenuTextures.sRamka, 
        MenuTextures.sRamka, 
        MenuTextures.sRamka, 
        EButtonFlags.BTN_TYPE_PUSHBUTTON,
        "&BPP&"
        );
    
    static UIElement Button_BPP = new UIElement(
        ID_BTN_BPP,0,
        new Vector(112+256,84-nH,0),
        new Vector(128,32,0),
        MenuTextures.sRamkaMala, 
        MenuTextures.sRamka2Mala, 
        MenuTextures.sRamkaMala, 
        MenuTextures.sRamka2Mala, 
        EButtonFlags.BTN_TYPE_PUSHBUTTON,
        ""
        );
    
    static UIElement Label_Fullscreen = new UIElement(
        ID_LABEL_FULLSCREEN,0,
        new Vector(112,118-nH,0),
        new Vector(256,32,0),
        MenuTextures.sRamka, 
        MenuTextures.sRamka, 
        MenuTextures.sRamka, 
        MenuTextures.sRamka, 
        EButtonFlags.BTN_TYPE_PUSHBUTTON,
        "&FULLSCREEN&"
        );
    
    static UIElement Button_Fullscreen = new UIElement(
        ID_BTN_FULLSCREEN,0,
        new Vector(112+256,118 - nH,0),
        new Vector(32,32,0),
        MenuTextures.sCheckbox, 
        MenuTextures.sCheckbox2, 
        "", 
        "", 
        EButtonFlags.BTN_TYPE_CHECKBUTTON,
        ""
        );
    
    static UIElement Label_Filtering = new UIElement(
        ID_LABEL_FILTERING,0,
        new Vector(112,152-nH,0),
        new Vector(256,32,0),
        MenuTextures.sRamka, 
        MenuTextures.sRamka, 
        MenuTextures.sRamka, 
        MenuTextures.sRamka, 
        EButtonFlags.BTN_TYPE_PUSHBUTTON,
        "&FILTERING&"
        );
    
    static UIElement Button_Filtering = new UIElement(
        ID_BTN_FILTERING,0,
        new Vector(112+256,152 - nH,0),
        new Vector(128,32,0),
        MenuTextures.sRamkaMala, 
        MenuTextures.sRamka2Mala, 
        MenuTextures.sRamkaMala, 
        MenuTextures.sRamka2Mala, 
        EButtonFlags.BTN_TYPE_PUSHBUTTON,
        ""
        );
    
    static UIElement Label_TexQ = new UIElement(
        ID_LABEL_TEXQ,0,
        new Vector(112,186-nH,0),
        new Vector(256,32,0),
        MenuTextures.sRamka, 
        MenuTextures.sRamka, 
        MenuTextures.sRamka, 
        MenuTextures.sRamka, 
        EButtonFlags.BTN_TYPE_PUSHBUTTON,
        "&TEXQUALITY&"
        );
    
    static UIElement Button_TexQ = new UIElement(
        ID_BTN_TEXQ,0,
        new Vector(112+256,186 - nH,0),
        new Vector(128,32,0),
        MenuTextures.sRamkaMala, 
        MenuTextures.sRamka2Mala, 
        MenuTextures.sRamkaMala, 
        MenuTextures.sRamka2Mala, 
        EButtonFlags.BTN_TYPE_PUSHBUTTON,
        ""
        );
    
    static UIElement Label_Shadows = new UIElement(
        ID_LABEL_TEXQ,0,
        new Vector(112,288-nH,0),
        new Vector(256,32,0),
        MenuTextures.sRamka, 
        MenuTextures.sRamka, 
        MenuTextures.sRamka, 
        MenuTextures.sRamka, 
        EButtonFlags.BTN_TYPE_PUSHBUTTON,
        "&SHADOWS&"
        );
    
    static UIElement Button_Shadows = new UIElement(
        ID_BTN_TEXQ,0,
        new Vector(112+256,288 - nH,0),
        new Vector(128,32,0),
        MenuTextures.sRamkaMala, 
        MenuTextures.sRamka2Mala, 
        MenuTextures.sRamkaMala, 
        MenuTextures.sRamka2Mala, 
        EButtonFlags.BTN_TYPE_PUSHBUTTON,
        ""
        );
    
    static UIElement Label_Force16bit = new UIElement(
        ID_LABEL_FORCE16BIT,0,
        new Vector(112,220-nH,0),
        new Vector(256,32,0),
        MenuTextures.sRamka, 
        MenuTextures.sRamka, 
        MenuTextures.sRamka, 
        MenuTextures.sRamka, 
        EButtonFlags.BTN_TYPE_PUSHBUTTON,
        "&FORCE16BIT&"
        );
    
    static UIElement Button_Force16bit = new UIElement(
        ID_BTN_FORCE16BIT,0,
        new Vector(112+256,220 - nH,0),
        new Vector(32,32,0),
        MenuTextures.sCheckbox, 
        MenuTextures.sCheckbox2, 
        "", 
        "", 
        EButtonFlags.BTN_TYPE_CHECKBUTTON,
        ""
        );
    
    static UIElement Label_Brightness = new UIElement(
        ID_LABEL_BRIGHTNESS,0,
        new Vector(112,254 - nH,0),
        new Vector(256,32,0),
        MenuTextures.sRamka, 
        MenuTextures.sRamka, 
        MenuTextures.sRamka, 
        MenuTextures.sRamka, 
        EButtonFlags.BTN_TYPE_PUSHBUTTON,
        "&BRIGHTNESS&"
        );
    
    static UIElement Button_Brightness = new UIElement(
        ID_BTN_BRIGHTNESS,0,
        new Vector(112+256,254 - nH,0),
        new Vector(64,32,0),
        MenuTextures.sRamka64, 
        MenuTextures.sRamka64, 
        MenuTextures.sRamka64, 
        MenuTextures.sRamka64,
        EButtonFlags.BTN_TYPE_PUSHBUTTON,
        ""
        );
    
    //--------------------------------------------------------------------------------
    
    static UIElement Button_Default = new UIElement(
        ID_BTN_DEFAULT,0,
        new Vector(186+14,430,0),
        new Vector(128,32,0),
        MenuTextures.sRamkaMala, 
        MenuTextures.sRamka2Mala, 
        MenuTextures.sRamkaMala, 
        MenuTextures.sRamka2Mala, 
        EButtonFlags.BTN_TYPE_PUSHBUTTON,
        "&DEFAULT&"
        );
    
    static UIElement Button_Ok = new UIElement(
        ID_BTN_OK,0,
        new Vector(324+14,430,0),
        new Vector(128,32,0),
        MenuTextures.sRamkaMala, 
        MenuTextures.sRamka2Mala, 
        MenuTextures.sRamkaMala, 
        MenuTextures.sRamka2Mala, 
        EButtonFlags.BTN_TYPE_PUSHBUTTON,
        "&OK&"
        );
    
    static UIElement Button_Back = new UIElement(
        ID_BTN_BACK,0,
        new Vector(48+14,430,0),
        new Vector(128,32,0),
        MenuTextures.sRamkaMala, 
        MenuTextures.sRamka2Mala, 
        MenuTextures.sRamkaMala, 
        MenuTextures.sRamka2Mala,  
        EButtonFlags.BTN_TYPE_PUSHBUTTON,
        "&CANCEL&"
        );
}
