public class Credits extends UserInterface
{
    java.util.Vector m_vElements = new java.util.Vector();
    
    String m_sDefaultTitleFont = Fonts.GetDefaultFont();
    float m_fDefaultTitleFontScale = 1f;
    int m_nDefaultTitleFontFlags = ESpriteText.CENTER;
    
    String m_sDefaultNameFont = Fonts.GetDefaultFont();
    float m_fDefaultNameFontScale = 1f;
    int m_nDefaultNameFontFlags = ESpriteText.CENTER;
    /**Czas pomiedzy kolejnymi creditsami*/
    float m_fDefaultLifeTime = 5f;
    
    CreditEntry m_cCurrentEntry = null;

    float m_fDefaultLineSpacing = 0;
    
    String m_sScriptName =  "data/Credits.scr";
    
    public void OnCreate()
    {
        super.OnCreate();
        Load(GetModule(), "data/menu/credits.scr", true);
    }
    
    public void OnInit()
    {
        super.OnInit();
        
        Init(m_sScriptName);
    }
    
    /** inicjacja, przeparsowanie skryptu z creditsami */
	public void Init(String sScriptFile)
	{
		ParseKeyword Root = GameObject.ParseFile(sScriptFile);
												  
		if (Root == null)
		{
			GameObject.CrashLog("No file " + sScriptFile + "!\n");
			return;
		}
		else
		{
			ParseKeyword Key = null;
			ParseKeyword SubKey = null;
			
			for (Key = Root; Key != null; Key = Key.GetNext())
			{
				if (Key.Equals("CreditEntry"))
				{
                    String sElemId = Key.GetSParam(1);
                    CreditsEntryWindow cWnd = (CreditsEntryWindow)GetElem(sElemId);
                    if (cWnd != null)
                    {
					    CreditEntry cEntry = new CreditEntry(this, Key.GetSParam(0), cWnd);
                        cEntry.Load(Key);
                        m_vElements.addElement(cEntry);
                    }
				}
				else
				if (Key.Equals("DefaultTitleFont"))
				{
					m_sDefaultTitleFont = Key.GetSParam(0);
                    m_fDefaultTitleFontScale = Key.GetFParam(1);
                    m_nDefaultTitleFontFlags = GetTextFlagFromName(Key.GetSParam(2));
				}
				else
				if (Key.Equals("DefaultNameFont"))
				{
					m_sDefaultNameFont = Key.GetSParam(0);
                    m_fDefaultNameFontScale = Key.GetFParam(1);
                    m_nDefaultNameFontFlags = GetTextFlagFromName(Key.GetSParam(2));
				}
                else
                if (Key.Equals("DefaultLifeTime"))
                {
					m_fDefaultLifeTime = Key.GetFParam(0);
				}
                else
                if (Key.Equals("DefaultLineSpacing"))
                {
                    m_fDefaultLineSpacing = Key.GetFParam(0);
                }
			}
            Root.delete();
		}
        
        //CallMethodIn("ShowNextEntry", 2);        
	}
    
    void TestInit()
    {
        Init("data/credits.scr");
    }
    
    void ShowNextEntry()
    {
        if (m_vElements != null && m_vElements.size() > 0)
        {
            if (m_cCurrentEntry != null)
            {
                m_cCurrentEntry.Hide();
                m_cCurrentEntry = null;
            }
            
            m_cCurrentEntry = (CreditEntry)m_vElements.elementAt(0);
            m_vElements.removeElementAt(0);
            m_cCurrentEntry.Show();
            CallMethodIn("HideCurEntry", m_cCurrentEntry.m_fLifeTime);
        }
    
    }
    
    void HideCurEntry()
    {
        if (m_cCurrentEntry != null)
        {
            m_cCurrentEntry.Hide();
            CallMethodIn("ShowNextEntry", m_cCurrentEntry.m_cWindow.m_fBlendTime);
            m_cCurrentEntry = null;
        }
    }
    
    int GetTextFlagFromName(String sName)
    {
        if (sName.equals("Center"))
            return ESpriteText.CENTER;
        if (sName.equals("Left"))
            return (ESpriteText.VERT_MIDDLE | ESpriteText.HORIZ_LEFT);
        if (sName.equals("Right"))
            return (ESpriteText.VERT_MIDDLE | ESpriteText.HORIZ_RIGHT);
        if (sName.equals("Multiline"))
            return (ESpriteText.MULTILINE);
        if (sName.equals("CenterMultiline"))
            return ESpriteText.CENTER | ESpriteText.MULTILINE;
        
        //jesli nic nie pasuje to srodeczek
        return ESpriteText.CENTER;
    }
    
    public class CreditEntry
    {
        float m_fLifeTime = -1f;
        CreditsEntryWindow m_cWindow = null;
        String m_sTitle = null;
        String m_sFontName = null;
        float m_fFontScale = -1f;
        int m_nFontFlags = -1;
        Credits m_cCredits = null;
        java.util.Vector m_vNames = new java.util.Vector();
        
        CreditEntry(Credits cCredits,
                    String sTitle, CreditsEntryWindow cWindow)
        {
            m_cCredits = cCredits;
            m_sTitle = new String(sTitle);
            m_cWindow = cWindow;
            m_fLifeTime = cCredits.m_fDefaultLifeTime;
            m_sFontName = cCredits.m_sDefaultTitleFont;
            m_fFontScale = cCredits.m_fDefaultTitleFontScale;
            m_nFontFlags = cCredits.m_nDefaultTitleFontFlags;
            if (m_sFontName.compareTo("Konstrukcyjny32") == 0)
                m_sTitle = GameObject.TextToUpperCase(Text.Get(m_sTitle));
        }
        
        void Show()
        {
            m_cWindow.Clear();
            m_cWindow.SetText(m_sTitle);
            m_cWindow.SetFont(m_sFontName);
            m_cWindow.SetFontScale(m_fFontScale);
            m_cWindow.SetTextPosFlags(m_nFontFlags);
            m_cWindow.SetText(m_sTitle);
            
            for (int i = 0; i < m_vNames.size(); i++)
                m_cWindow.AddName((Credits.CreditName)m_vNames.elementAt(i));
            
            m_cWindow.Show();
            
        }

    
        void Hide()
        {
            m_cWindow.Hide();
        }
        
        void Load(ParseKeyword cKey)
        {
            ParseKeyword cSubkey = null;
            for (cSubkey = cKey.GetChild(); cSubkey != null; cSubkey = cSubkey.GetNext())
            {
                if (cSubkey.Equals("LifeTime"))
                    m_fLifeTime = cSubkey.GetFParam(0);
                if (cSubkey.Equals("Font"))
                {
                    m_sFontName = cSubkey.GetSParam(0);
                    m_fFontScale = cSubkey.GetFParam(1);
                    m_nFontFlags = m_cCredits.GetTextFlagFromName(cSubkey.GetSParam(2));
                }
                if (cSubkey.Equals("Name"))
                {
                    String sName = cSubkey.GetSParam(0);
                    Credits.CreditName cName = new Credits.CreditName(m_cCredits, sName);
                    cName.Load(cSubkey);
                    m_vNames.addElement(cName);
                }
            }
        }
    }
    
    public class CreditName
    {
        String m_sName = "";
        String m_sFontName = null;
        float m_fFontScale = -1f;
        int m_nFontFlags = -1;
        Credits m_cCredits = null;
        float m_fLineSpacing = 0;
        
        CreditName(Credits cCredits, String sName)
        {
            m_cCredits = cCredits;
            m_sName = new String(sName);
            m_sFontName = cCredits.m_sDefaultNameFont;
            m_fFontScale = cCredits.m_fDefaultNameFontScale;
            m_nFontFlags = cCredits.m_nDefaultNameFontFlags;
            m_fLineSpacing = cCredits.m_fDefaultLineSpacing;
        }
        
        void Load(ParseKeyword cKey)
        {
            ParseKeyword cSubkey = null;
            for (cSubkey = cKey.GetChild(); cSubkey != null; cSubkey = cSubkey.GetNext())
            {
                if (cSubkey.Equals("Font"))
                {
                    m_sFontName = cSubkey.GetSParam(0);
                    m_fFontScale = cSubkey.GetFParam(1);
                    m_nFontFlags = m_cCredits.GetTextFlagFromName(cSubkey.GetSParam(2));
                }
                if (cSubkey.Equals("LineSpacing"))
                {
                    m_fLineSpacing = cSubkey.GetFParam(0);
                }
            }
        }
    }
}
