public class InGameMenu extends ChromeMenuWindow 
{
    final static int ID_BTN_RESUME    = 311; 
    final static int ID_BTN_SAVE_LOAD = 312;
    final static int ID_BTN_OPTIONS   = 314;
    final static int ID_BTN_QUIT      = 315;
    final static int ID_BTN_RESTART   = 316;
    
    UIMenuButton Button_Save_Load;
    
    void Init(MenuBackground cBack)
    {
        MenuModule=(ChromeMenuModule)GetModule();
        
		Button_Save_Load = (UIMenuButton)GetElem("ID_312");
		
        // ustawiamy powiadomienie o wlaczeniu tego menu
        MenuModule.bInGameMenuAct=true;
        
        if (MenuModule.bMenuNetInGame)
            return;
        
        ChromeGame game = (ChromeGame) ChromeGame.cSingleton;
        if ( (game != null) && (!game.IsLoadSaveEnabled()) )
        {
            Button_Save_Load.SetDisabled(true);
        }
        if (!CanResume())
        {
            ((UIMenuButton)GetElem("ID_311")).SetDisabled(true);
        }
    }
    
    boolean CanResume()
    {
        return MenuModule.bMenuNetInGame ||
               !(((ChromeModuleSingle)MenuModule.ActiveLevelModule).m_bMissionEnded &&
                    !((ChromeModuleSingle)MenuModule.ActiveLevelModule).bMissionSuccessful);
    }
    
    void OnUICommand(UIWindow cSender, int nCommand)
	{
		super.OnUICommand(cSender,nCommand);
		int nID = GetButtonId(cSender.m_sId);
            
		if(nCommand == EUIConst.CM_CLICK || nCommand == EUIConst.CM_DBCLICK)
        {
            switch(nID)
            {
            case ID_BTN_RESUME:
                {
                    Discard();
                    break;
                }
            case ID_BTN_RESTART:
                {
					if(!CanResume())
						MenuModule.QuickLoad(true);					
					else
						ShowYesNoDialog(ID_BTN_RESTART, "&InGameMenuRestartTitle&", "&InGameMenuRestartQuestion&", "&BtnYes&", "&BtnNo&");
                    break;   
                }
            case ID_BTN_SAVE_LOAD:
                {
                    MenuModule.SetMenu("ChromeMenuLoad");
                    break;
                }
            case ID_BTN_OPTIONS:
                {
                    MenuModule.SetMenu("ChromeOptionsMenu");
                    break;
                }
            case ID_BTN_QUIT:
                {
                    ShowYesNoDialog(ID_BTN_QUIT, "&InGameMenuYesNoTitle&", "&InGameMenuYesNoQuestion&", "&BtnYes&", "&BtnNo&");
                    break;
                }
            }
        }
    }
    
    void Discard()
    {
        if(!CanDiscard())
			return;
		
		BreakInputProcessing();
        if(m_cYesNoDlg != null)
		{
			return;
		}
		if (!CanResume())
            return;
        MenuModule.SetState("DuringGame");
        UnregisterKeyRequest();
        MenuModule.ActiveLevelModule.CallMethodIn("ReturnFromMenu", 0.01f);
    }
    
    public void OnDestroy()
    {
        super.OnDestroy();
        GetModule().RemoveSprite(this);
    }
    
    void OnYesFromDlg(int nID)
    {
        BreakInputProcessing();
        super.OnYesFromDlg(nID);
        switch(nID)
        {
        case ID_BTN_QUIT:
			
			MenuModule.SetMenu("ChromeMainMenu");
			if(MenuModule.bMenuNetInGame)
			{
				if(AmIServer())
				{
					MenuModule.CallMethodIn("ShutdownServerGame", 0);
				}
				else
				{
					MenuModule.CallMethodIn("ShutdownClientGame", 0);
				}
			}
			else
			{
				MenuModule.CallMethodIn("ShutdownGame", 0);
			}
            break;
        case ID_BTN_RESTART:
            MenuModule.QuickLoad(true);
            break;
        }
    }
    
    void OnNoFromDlg(int nID)
    {
        super.OnNoFromDlg(nID);
        switch(nID)
        {
            case ID_BTN_QUIT:
                break;
            case ID_BTN_RESTART:
                break;
        }
    }
}
