/** Obiekt zarzadza wyswietlaniem tla w zaleznosci od rodzdzielczosci ekranu
 */
public class MenuBackground
{
    // szerokosc ramki bocznej
    float fSideFrameWidth = 128.0f;
    float fSideFrameHeight = 64.0f;
    
    // na jakiej wysokosci wzgledem obrazka tla(Back) zaczyna sie ramka boczna
    float fSideFramePositionY = 313.0f;
        
    // wielkosc obrazka ktory jest ustawiony na srodku
    float fBackWidth=640.0f;
    float fBackHeight=480.0f;
    
    // modul menu na ktorym jest podlaczone tlo
    Module MenuModule=null;
    
    // sprite tla wlascicwego, do niego doczepiaja sie inne menu
    public Sprite Back=null;
    
    // ramki wokol
    Sprite Left=null;
    int LeftTexture;
    
    Sprite Right=null;
    int RightTexture;
    
    Sprite Fszelakosz = null;
    int nFszelakosz;
    
    // nazwa textury, ktora aktualnie jest pokazywana
    String sCurrentBack="none";
    
    void Init(Module menuModule)
    {
        MenuModule=menuModule;
        
        // tworzymy odpowiednio sprite'y
        Left = (Sprite)MenuModule.CreateObject("Sprite");
        Left.SetPos(new Vector( GameObject.GetScreenWidth()/2.0f - fBackWidth/2.0f - fSideFrameWidth,
                                GameObject.GetScreenHeight()/2.0f - fBackHeight/2.0f + fSideFramePositionY, 0));
        Left.SetSize(new Vector(fSideFrameWidth, fSideFrameHeight, 0));
        LeftTexture=Left.AddTexture(MenuTextures.sBackBorderLeft);
        Left.SetTexture(LeftTexture, new Rect(0, 0, 1, 1));
        MenuModule.AddSprite(Left);
        
        Right = (Sprite)MenuModule.CreateObject("Sprite");
        Right.SetPos(new Vector( GameObject.GetScreenWidth()/2.0f + fBackWidth/2.0f,
                                 GameObject.GetScreenHeight()/2.0f - fBackHeight/2.0f + fSideFramePositionY, 0));
        Right.SetSize(new Vector(fSideFrameWidth, fSideFrameHeight, 0));
        RightTexture=Right.AddTexture(MenuTextures.sBackBorderRight);
        Right.SetTexture(RightTexture, new Rect(0, 0, 1, 1));
        MenuModule.AddSprite(Right);
        
        // tworzymy odpowiednio sprite'y
        Back = (Sprite)MenuModule.CreateObject("Sprite");
        Back.SetPos(new Vector( GameObject.GetScreenWidth()/2.0f - fBackWidth/2.0f,
                                GameObject.GetScreenHeight()/2.0f - fBackHeight/2.0f, 0));
        Back.SetSize(new Vector(fBackWidth, fBackHeight, 0));
        MenuModule.AddSprite(Back);
        
        Back.ProcessMouse(true);
        Back.ProcessKb(true);
        
        // tworzymy odpowiednio sprite'y
        Fszelakosz = (Sprite)MenuModule.CreateObject("Sprite");
        Fszelakosz.SetPos(new Vector(0.0f, 0.0f, 0.0f));
        Fszelakosz.SetSize(new Vector(1024.f, 768.0f, 0));
        nFszelakosz = Fszelakosz.AddTexture("ER_T_Black.png");
        Fszelakosz.SetTexture(nFszelakosz, new Rect(0, 0, 1, 1));
        MenuModule.AddSprite(Fszelakosz);
    }
    
    void ChangScreen()
    {
        Left.SetPos(new Vector( GameObject.GetScreenWidth()/2.0f - fBackWidth/2.0f - fSideFrameWidth,
                                GameObject.GetScreenHeight()/2.0f - fBackHeight/2.0f + fSideFramePositionY, 0));
        Left.SetSize(new Vector(fSideFrameWidth, fSideFrameHeight, 0));
        
        Right.SetPos(new Vector( GameObject.GetScreenWidth()/2.0f + fBackWidth/2.0f,
                                 GameObject.GetScreenHeight()/2.0f - fBackHeight/2.0f + fSideFramePositionY, 0));
        Right.SetSize(new Vector(fSideFrameWidth, fSideFrameHeight, 0));
        
        Back.SetPos(new Vector( GameObject.GetScreenWidth()/2.0f - fBackWidth/2.0f,
                                GameObject.GetScreenHeight()/2.0f - fBackHeight/2.0f, 0));
        Back.SetSize(new Vector(fBackWidth, fBackHeight, 0));    
        
        Fszelakosz.SetPos(new Vector(0.0f, 0.0f, 0.0f));
        Fszelakosz.SetSize(new Vector(1024.f, 768.f, 0));    
    }
    
    void Destroy()
    {
        Fszelakosz.ReleaseTexture(nFszelakosz);
        MenuModule.RemoveSprite(Fszelakosz);
        Fszelakosz.delete();
        Fszelakosz = null;
        
        // kasujemy spritey
        Left.ReleaseTexture(LeftTexture);
        MenuModule.RemoveSprite(Left);
        Left.delete();
        Left=null;
        
        Right.ReleaseTexture(RightTexture);
        MenuModule.RemoveSprite(Right);
        Right.delete();
        Right=null;
        
        MenuModule.RemoveSprite(Back);
        Back.delete();
        Back=null;
    }
    
    
    void ShowMain(String sName)
    {
        Show(sName);
     
        Left.Show();
        Right.Show();
        Fszelakosz.Show();
    }
    
    void Show(String sName)
    {
        if ( sName == null )
            return;
        //MK: ten if to taki hak, zebym mogl zaladowac backgrounda takze
        //z katalogu mapy, a nie tylko z data/textures/
        if ( (!sName.equals("")) && !sName.toLowerCase().startsWith( ModuleNet.sm_sMapDir.toLowerCase() ) )
            sName = "data/textures/" + sName;
        
        //if(sName.compareTo(sCurrentBack)!=0)
        {
            if(!sName.equals(""))
                Back.SetBackground(sName);
            sCurrentBack=new String(sName);
        }
        
        Back.Show();
        Left.Hide();
        Right.Hide();
        Fszelakosz.Show();
    }
    
    void Hide()
    {
        Left.Hide();
        Right.Hide();
        Back.Hide();
        Back.ReleaseBackground();
        
        Fszelakosz.Hide();
    }
}
