public class AlarmTerminal extends AnimatedScreen implements IAlarmID
{
    public Alarm cAlarm = null;//#\ALARMTERMINAL;Alarm connected with this terminal
    
	public int m_iAlarmID = AlarmsManager._DEFAULT_ALARM_ID;
	
	ChromeModuleSingle cLevel = null;
	
    AlarmTerminal()
    {
        //sTexturesList = "CH_E_Alert.png;CH_E_AlertActive.png";
        nStartupScreenIdx = 0;
		SetTriggerExecutionMode(EnumExecuteMode._KEYBOARD_TYPE);
        fDefExecutionDistance = 50f;
    }
    
    public void OnCreate()
    {
        super.OnCreate();
		
		try
		{
			cLevel = (ChromeModuleSingle) GetModule();
		}
		catch (Exception e)
		{
			CrashLog("AlarmTerminal moze byc uzywany tylko na ChromeModuleSingle");
		}
        
		SetScreen(0);

        Vector vLocalExecDir = new Vector(Vector.Forward);
        vLocalExecDir.Mul(-1);
        
        Vector vLocalExecPos = new Vector(Vector.Forward);
        vLocalExecPos.Mul(fDefExecutionDistance);

        Vector vLocalFinishDir = new Vector(Vector.Forward);

        /** Zainicjowanie akcji potrzebnych do uzycia tego obiektu */
        aExecutionSteps = new ExecutionInfo[] {
                             new ExecutionInfo(EnumExecuteMode._MOVE_TO, _IEM_NONE, 
                             vLocalExecPos, vLocalExecDir),
                             new ExecutionInfo(EnumExecuteMode._KEYBOARD_TYPE, _IEM_EXECUTE),
                             new ExecutionInfo(EnumExecuteMode._TURN, _IEM_NONE, 
                             null, vLocalFinishDir),
                             new ExecutionInfo(EnumExecuteMode._MOVE_BACK, _IEM_NONE)
                             };
        InitExecutionActions();
    }

    public void OnPostCreate()
    {
        if (cAlarm != null)
        {
            // ta metoda wbrew pozorom ustawia pole m_iAlarmID w tym
            // obiekcie na podstawie cAlarm
            cAlarm.AddAlarmObject(this);
        }
        
		SetSkin("AlertOff");
    }
    
    public void SetAlarmID(int iAlarmID)
    {
        m_iAlarmID = iAlarmID;
    }
    
    public int GetAlarmID()
    {
        return m_iAlarmID;
    }
    
    String GetTip()
    {
		if (cLevel.m_AlarmsManager.IsAlarmEnabled(m_iAlarmID))
			return "&DEACTIVATE_ALARM&";
		else
			return "&ACTIVATE_ALARM&";
    }

    public boolean IsActive(ControlObject Activator)
    {
        return true;
    }
    
    void Execute(Actor executor)
    {
        if (cAlarm != null)
        {
            if (cAlarm.IsEnabled())
                cAlarm.Disable();
            else
                cAlarm.Enable();
        }
        else        
            cLevel.m_AlarmsManager.EnableAlarm(!cLevel.m_AlarmsManager.IsAlarmEnabled(m_iAlarmID), m_iAlarmID);
		
		if (executor instanceof PlayerHUD)
		{
			PlayerHUD playerHUD = (PlayerHUD) executor;
			
			playerHUD.HUD.GetHUDPlayer().UpdateActiveTrigger();
		}
    }
	
    //*********************************************************
	//					SaveGame
    //*********************************************************
	
    /** Metoda wczytujaca zapisane dane w Save gracza
     */	
    public void SGLoadChunk(FileChunk cParentFC)
    {
		FileChunk.Log("[AITerminal.SGLoadChunk]\n");
		
		FileChunk cFC = GameObject.LoadChunk(cParentFC);
        
        if (cFC.GetID() == ESGChunksChrome._CHK_AI_TERMINAL)
        {
			super.SGLoadChunk(cFC);

			m_iAlarmID = cFC.LoadInt();
        }
		cFC.delete();
	}
	
    /** Metoda zapisujaca dane do Save gracza
     */		
    public void SGSaveChunk(FileChunk cFCParent)
    {
		FileChunk.Log("[AITerminal.SGSaveChunk]\n");
		
        FileChunk cFC = NewChunk(ESGChunksChrome._CHK_AI_TERMINAL, cFCParent);
		
		super.SGSaveChunk(cFC);

		cFC.SaveInt(m_iAlarmID);			
		
		cFC.delete();
	}				
	
	public void SGUpdate()
	{
		FileChunk.Log("[AIAlarmed.SGUpdate]\n");
		
		super.SGUpdate();
	
	}		
}
