import java.util.*;

public class cnd_Inventory extends Condition
{
    // komentarz pokazywany w edytorze
    {sEditorComment = "Condition checks if there is specified item in player's inventory"; }
    
    public InvObject[] aItemTypes = null;//#;Array of item classes 
    
    public InvObjectInst[] aItems = null;//#;Array of items

    
    
    protected NumInst[] aItemTypesNum = null;
    ChromeModuleSingle cModule;
    
    public class NumInst {
        public Class clss = null;
        public int n = 0;
        public NumInst(int n) { this.n = n; };
        public NumInst(Class clss, int n) { this.clss = clss; this.n = n; };
    };

    
    public void OnCreate()
    {
        try {
            cModule = (ChromeModuleSingle)GetModule();
        } catch(Exception e) {
            CrashLog("[cnd_Inventory.OnCreate] ");
            if(e instanceof ClassCastException) CrashLog("Condition used on non single player module\n");
        }

        if (aItemTypes != null)
        {
            HashMap cTypesMap = new HashMap();
            for (int i=0; i<aItemTypes.length; i++)
            {
                InvObject obj = aItemTypes[i];
                if (obj != null)
                {
                    Class clss = obj.getClass();
                    NumInst val = (NumInst)cTypesMap.get(clss);
                    if (val != null) // jest w mapie
                        val.n++;
                    else
                        cTypesMap.put(clss, new NumInst(1));
                }
            }

            Set cTypesSet = cTypesMap.keySet();
            aItemTypesNum = new NumInst[cTypesSet.size()];
            Iterator iter = cTypesSet.iterator();
            NumInst num;
            Class clss;
            int i = 0;

            while (iter.hasNext())
            {
                clss = (Class)iter.next();
                num = (NumInst)cTypesMap.get(clss);
                num.clss = clss;
                aItemTypesNum[i++] = num;
            }
        }
    }
    
    boolean EvaluateInternal()
    {
        if(aItemTypesNum != null)
        {
            for(int i=0; i<aItemTypesNum.length; ++i)
            {
                // sprawdzamy czy jest przedmiot, jak nie ma no to nie ma
                if(!CheckIsInInventory(aItemTypesNum[i].clss, aItemTypesNum[i].n))
                    return false;
            }
        }
        
        if(aItems != null)
        {
            // sprawdzamy wszystkie obiekty z listy
            for(int i=0; i<aItems.length; ++i)
            {
                InvObject cInvObj = aItems[i];
                // sprawdzamy czy jest przedmiot, jak nie ma no to nie ma
                if(!CheckIsInInventory(cInvObj))
                    return false;
            }
        }
        
        return true;
    }
    
    boolean CheckIsInInventory(Class cItemClass, int nCount)
    {
        if (nCount == 0)
            return true;
        // sprawdzamy czy jakis item dziedziczy po podanej klasie
        java.util.Vector aInvObjects = cModule.MainPlayer.cInventory.aInvObjects;
        for(int i=0; i<aInvObjects.size(); ++i)
        {
            InvObject cInvObj = (InvObject)aInvObjects.elementAt(i);
            if(cInvObj.getClass().isAssignableFrom(cItemClass))
            {
                if (--nCount == 0)
                    return true;
            }
        }
        return false;
    }
    
    boolean CheckIsInInventory(InvObject cInvObjToCheck)
    {
        // sprawdzamy czy jakis item dziedziczy po podanej klasie
        java.util.Vector aInvObjects = cModule.MainPlayer.cInventory.aInvObjects;
        for(int i=0; i<aInvObjects.size(); ++i)
        {
            InvObject cInvObj = (InvObject)aInvObjects.elementAt(i);
            if(cInvObj == cInvObjToCheck)
                return true;
        }
        
        return false;
    }
}
