public class InstantCameraShake extends InstantAction
{
    {sEditorComment = "Causes camera to shake simulating earthquake";}
    
    public Player cTarget = null;//#\;Player, which camera should start shaking
    
    public float fShakeTime = 3;//#\;Total shaking time (when <= 0 - stop shake)
    
    public float fBetweenShakesDelay = 0.1f;//#\;Time interval between consecutive shakes
    
    public void Invoke()
    {
        if (cTarget != null && 
            cTarget.Camera != null)
        {
            cTarget.Camera.StopEarthquakeShake();
            if (fShakeTime > 0 || fBetweenShakesDelay >= 0)
                cTarget.Camera.StartEarthquakeShake(fBetweenShakesDelay, fShakeTime);
        }
    }
}
