public class mt_Destroy extends ChromeMotionType
{
    /** obiekt do zniszczenia */
    public IDestroyTarget cTarget = null;//#\MT_DESTROY;Target to destroy - single AI or single group of AI
    public IDestroyTarget[] aTargets = null;//#\MT_DESTROY;List of targets to destroy - member can be either AI or AIGroup
    
    public float fTime = 60f;//#\MT_DESTROY;Max time for searching target(ai) or attack time(flying)

    public boolean bForgetAboutPreviousTargets = false;//#\MT_DESTROY;When true, all previous targets are marked as non-editor
        
	public java.util.ArrayList allTargets = null;

    public mt_Destroy()
    {
		bSG = true;
        m_ValidScenarios.SetAllBits();
        
        m_ValidScenarios.CalcIntersectionWithComplement(Scenario._EDITOR_SCENARIOS);

    }
	
    public void StartActivity(AIController ai)
	{
        if (allTargets == null) // pierwsze zapytanie - utworz liste
        {
            allTargets = new java.util.ArrayList();
            if (cTarget != null)
                allTargets.add(cTarget);
            if (aTargets != null)
            {
                for (int i = 0; i < aTargets.length; i++)
                {
                    if (aTargets[i] != null)
                        allTargets.add(aTargets[i]);
                }
            }
        }
        
        if (bForgetAboutPreviousTargets)
            ai.RemoveAllEditorEnemies(false);
        
		for (int i = 0; i < allTargets.size(); i++)
			AddObjectsToDestroy(ai, (IDestroyTarget) allTargets.get(i));
		
        if (fTime < 0f)
            fTime = Float.MAX_VALUE;
        ai.CallMethodIn("ServeNextWaypointActivity", fTime);
	}
	
	public void StartActivity(FlyingTransporter vehicle)
	{
		//vehicle.EditorAttack(this);
	}
    
    public void StopActivity(AIController ai)
	{
		ai.DisableCallMethod("ServeNextWaypointActivity");
	}
	
	void AddObjectsToDestroy(AIController ai, IDestroyTarget cTarget)
	{
		if (cTarget == null)
			return;
		ChromeActor [] objectsToDestroy = cTarget.GetObjectsToDestroy();
		if (objectsToDestroy != null)
		{
			for (int i = 0; i < objectsToDestroy.length; i++)
			{
				if (objectsToDestroy[i] == null)
					continue;
				EnemyInfo info = ai.AddEnemy(objectsToDestroy[i], true);
				if (info != null)
					ai.RecognizeEnemy(info);
			}
		}
	}
	
   //*********************************************************
	//					SaveGame
    //*********************************************************
    
    /** Metoda wczytujaca zapisane dane w Save gracza
     */	
    public void SGLoadChunk(FileChunk cParentFC)
    {
		FileChunk.Log("[mt_Destroy.SGLoadChunk]\n");
		
		FileChunk cFC = GameObject.LoadChunk(cParentFC);
		
        if (cFC.GetID() == ESGChunksChrome._CHK_MT_DESTROY)
        {
			super.SGLoadChunk(cFC);
			
			int nSize = cFC.LoadInt();
			if (nSize != -1)
			{
				allTargets = new java.util.ArrayList(nSize);			
				for (int i = 0; i < nSize; i++)
					allTargets.add(cFC.LoadObjectRef());			
			}
			else
				allTargets = null;
        }
		
		cFC.delete();
    }

    /** Metoda zapisujaca dane do Save gracza
     */		
    public void SGSaveChunk(FileChunk cFCParent)
    {
		FileChunk.Log("[mt_Destroy.SGSaveChunk]\n");
		
        FileChunk cFC = NewChunk(ESGChunksChrome._CHK_MT_DESTROY, cFCParent);
		
		super.SGSaveChunk(cFC);

		if (allTargets != null)
		{
			cFC.SaveInt(allTargets.size());
			for (int i = 0; i < allTargets.size(); i++)
				cFC.SaveObjectRef((ISaveGame)allTargets.get(i));
		}
		else
			cFC.SaveInt(-1);
		        		        
        cFC.delete();
    }	
}
