public class ParamMotionSpeed extends Param
{
    {sEditorComment = "Change objects speed value for given motion speed";}

    public ipar_MotionSpeed cTarget = null;//#\;Object which speed value should be changed
    
    public EnumMotionSpeeds cSpeed = new EnumMotionSpeeds(EnumMotionSpeeds._WALK);//#\;MotionSpeed which value should be changed

    public float fSpeedValue = -1;//#\;New speed value for given MotionSpeed (when -1 - leave unchanged)

    public float fSpeedValueMultiplier = -1;//#\;How many times new speed is greater than old (when -1 - leave unchanged)

    
    public void ChangeParam()
    {
        if (cTarget != null)
        {
            if (Math.abs(fSpeedValue + 1.f) > 0.001f) //!= -1f
                cTarget.SetMotionSpeedValue(cSpeed.GetValue(), fSpeedValue);
            if (Math.abs(fSpeedValueMultiplier + 1.f) > 0.001f) //!= -1f
                cTarget.MultiplyMotionSpeedValue(cSpeed.GetValue(), fSpeedValueMultiplier);
        }
    }
}
