public class sensor_TrackCylinder extends sensor_Track
{
    /** Ograniczenie dzialania sensora do gory */
    public float fMaxHeight = -1.f;//#SENSOR
    
    /** Ograniczenie dzialania sensora do dolu */
    public float fMinHeight = -1.f;//#SENSOR
    
    float fLastY = Float.MAX_VALUE;//trzeba zainicjowac duza wartoscia, bo inaczej na poczatku bedzie leave
    
    boolean IsInHeight(float fY)
    {
        if ( (fMinHeight == -1.f) && (fMaxHeight == -1.f) )
            return true;
        if (fMinHeight == -1.f)
            return fY <= fMaxHeight;
        if (fMaxHeight == -1.f)
            return fMinHeight <= fY;
        return (fMinHeight <= fY) && (fY <= fMaxHeight);
    }
    
    void CheckObject()
    {
        Vector vPos = GetPosition();

        // wybieramy pozycje z obiektu
        Vector vObjectPos = null;
        if(nSensorType == SENS_PLAYER)
            vObjectPos = cModule.MainPlayer.GetPosition();
        else
            vObjectPos = ((ControlObject)cObject).GetPosition();

        if(!bEnabled) return;

        float fY = vObjectPos.fY - vPos.fY;
        
        // splaszczamy obliczenie odleglosci
        vPos.fY = 0.0f;
        vObjectPos.fY = 0.0f;
        
        // wyliczamy odleglosc gracza od hotspota
        float fDistance2 = vPos.Distance2(vObjectPos);

        //CrashLog("[sensor_Track.Check] Checking fRadius2="+fRadius2+" fDistance2="+fDistance2+" bDisabled="+bEnabled+"\n");
        
        boolean bIsInSensor = (fDistance2 < fRadius2) && IsInHeight(fY);
        boolean bWasInSensor = (fLastDistance2 < fRadius2) && IsInHeight(fLastY);
        
        if ( !bWasInSensor && bIsInSensor )
        {
            // wywolujemy akcje wejscia w sensor
            if(cOnEnter != null && (nOnEnterTimes != 0))
            {
                InvokeActionChain(cOnEnter);
                if(nOnEnterTimes>0) nOnEnterTimes--;
            }
        }

        // sprawdzanie czy sensor nie jest wylaczony
        if(!bEnabled) return;

        if ( bWasInSensor && !bIsInSensor )
        {
            // wywolujemy akcje wyjscia z sensora
            if(cOnLeave != null && (nOnLeaveTimes != 0))
            {
                InvokeActionChain(cOnLeave);
                if(nOnLeaveTimes>0) nOnLeaveTimes--;
            }
        }

        // przepisujemy odleglosc
        fLastDistance2 = fDistance2;
        fLastY = fY;
        
        // sprawdzamy czy nie skasowac Sensora, ale wylaczamy jego dzialanie
        // tylko, bo ktos moze sie do niego odwolywac za pomoca akcji i bedzie
        // wtedy exception
        if(nOnEnterTimes==0 && nOnLeaveTimes==0)
        {
            DisableCallMethod("Check");
        }
    }
	
    //*********************************************************
	//					SaveGame
    //*********************************************************
	
    /** Metoda wczytujaca zapisane dane w Save gracza
     */	
    public void SGLoadChunk(FileChunk cParentFC)
    {
		FileChunk.Log("[sensor_TrackCylinder.SGLoadChunk]\n");
		
		FileChunk cFC = GameObject.LoadChunk(cParentFC);
        
        if (cFC.GetID() == ESGChunksChrome._CHK_SENSOR_TRACK_CYLINDER)
        {
			super.SGLoadChunk(cFC);

			fLastY = cFC.LoadFloat();
        }
		cFC.delete();
	}
	
    /** Metoda zapisujaca dane do Save gracza
     */		
    public void SGSaveChunk(FileChunk cFCParent)
    {
		FileChunk.Log("[sensor_TrackCylinder.SGSaveChunk]\n");
		
        FileChunk cFC = NewChunk(ESGChunksChrome._CHK_SENSOR_TRACK_CYLINDER, cFCParent);
		
		super.SGSaveChunk(cFC);

		cFC.SaveFloat( fLastY );
			
		cFC.delete();
	}			
}
