public class NetConnector extends GameObject
{
    ChromeNetJoinMenu m_cJoinMenu = null;
    
    /** CLIENT
     */
    void JoinServer(ChromeNetJoinMenu cJoinMenu, 
                    ChromeMenuModule cMenuModule, 
                    NetGameInitInfo cGameInitInfo, 
                    String strPassword,
                    int iWishListQueryNum,
                    int iCRC)
    {
        // kasujemy aktualny level gry na wszelki wypadek
        if ( cMenuModule.ActiveLevelModule != null ) 
        {
            cMenuModule.ActiveLevelModule.delete();
            cMenuModule.ActiveLevelModule = null;
        }
        
        //zapamietujemy, z ktorego menu nas zawolano, zeby poinformowac o wyniku        
        m_cJoinMenu = cJoinMenu;
       
        // inicjujemy klienta po stronie C++
        CrashLog("[NetConnector.JoinServer] Initializing client host...");
        int nResult = InitClientHost(  cGameInitInfo.GetServerInfo().GetServerAddr(),
                                       cGameInitInfo.GetServerInfo().GetGamePort() );
        if (nResult == 0)
            CrashLog(" failed.\n");
        else
        {
            CrashLog(" done.\n");
            
            //TODO: sprawdzic, co bedzie, jesli strPassword == null
            Join(cGameInitInfo.GetCurrentLevelName(), strPassword, iWishListQueryNum, iCRC);
            
            m_cJoinMenuModule   = cMenuModule;
            m_cJoinGameInitInfo = cGameInitInfo;
    
            CheckJoined();
        }
    }
    
    static ChromeMenuModule m_cJoinMenuModule = null;
    static NetGameInitInfo  m_cJoinGameInitInfo = null;

    void CheckJoined()
    {
        int iStatus = GetConnectingStatus();
		if ( iStatus == EConnectingStatus.APPROVED )
        {
            m_cJoinMenuModule.NewGame( m_cJoinGameInitInfo );
            // odpalamy gre
            m_cJoinMenuModule.StartGame();
        }
		else
        {//na pewno sie jeszcze nie podlaczylismy, ale trzeba sprawdzic, czy
         //nasze zadanie podlaczenia nie zostalo juz odrzucone
            if ( iStatus != EConnectingStatus.CONNECTING )
            {//serwer odrzucil nasze zadanie podlaczenia
                CrashLog("[NetConnector.CheckJoined] Cannot join "+EConnectingStatus.GetFlagName(iStatus)+"\n");
                
                //kasujemy klienta, bo jest on tworzony przy kazdym InitClientHost()
                //wolanym z JoinServer, o ile jeszcze nie istnieje                
                if (m_cJoinMenu != null)
                {
                    m_cJoinMenu.UnregisterMessager();
                }
                
                DeleteClient();
                
                //informujemy menu, z ktorego tu wlezlismy, ze nie udalo sie polaczyc
                if (m_cJoinMenu != null)
                {
                    m_cJoinMenu.JoiningGameFailed("&FAILED_TO_JOIN_SERVER&", EConnectingStatus.GetFlagName(iStatus));

                    m_cJoinMenu.InitClient();

                    if (iStatus == EConnectingStatus.INVALID_MAP)
                    {
                        ChromeNetJoinMenu.ForceJoinServer((ChromeMenuModule)m_cJoinMenu.GetModule(),
                                                          m_cJoinMenu.GetGameInitInfo().GetServerInfo().GetServerAddr(),
                                                          m_cJoinMenu.GetGameInitInfo().GetServerInfo().GetGamePort(),
                                                          true);
                    }
                }
            }
            else
            {//wciaz nie dostalismy odpowiedzi od serwera
		        CallMethodIn("CheckJoined",0.5f);
            }
        }
    }
}
