import java.io.*;

public class WishListCounter
{
    java.util.ArrayList vQuestions = new java.util.ArrayList();
    
    String sCurrentMap = null;
    
    public WishListCounter(String sCurrentMap)
    {
        this.sCurrentMap = sCurrentMap;
    }
    
    public void AddQuestion(int iFileNo, int iStartPos, int iEndPos)
    {
        AddQuestion(WishListFileIDToPath(iFileNo), iStartPos, iEndPos);
    }
    
    public void AddQuestion(String sFileName, int iStartPos, int iEndPos)
    {
        if (sFileName != null)
        {
            FileCRCCounter cFileCounter = new FileCRCCounter();
            cFileCounter.Set(sFileName, iStartPos, iEndPos);
            vQuestions.add(cFileCounter);
        }
    }
    
    public void FromWishList(WishList cWishList)
    {
        vQuestions.clear();

        if (cWishList != null)
        {
            /*
            int iCnt = cWishList.GetQuestionCount();
            for (int i = 0; i < iCnt; ++i)            
            {
                vQuestions.add((FileCRCCounter)cWishList.GetQuestion(i));
            }
            */

            int iMaxIdx = cWishList.GetQuestionMaxIdx(); 
            for (int i = 0; i < iMaxIdx; ++i)            
            {
                FileCRCCounter question = (FileCRCCounter)cWishList.GetQuestion(i);
                if (question != null)
                {
                    vQuestions.add(question);
                }
            }
        }
    }
    
    public int Count()
    {
        int iRet = 0;
        
        int iCount = vQuestions.size();
        for (int i = 0; i < iCount; ++i)
        {
            FileCRCCounter cFileCounter = (FileCRCCounter)vQuestions.get(i);
            
            if (cFileCounter != null)
            {
                iRet += cFileCounter.Count();
            }
        }
        
        return iRet;
    }

    public static String s_sWishListDataFile = "\\data\\wishlist.txt";
    public static String s_sWishListIdxFile = "\\data\\wishlist.idx";
    
    public String WishListFileIDToPath(int iFileID)
    {
        //jesli zapodano iFileID == 0, to pytaja sie o aktualna mape
        if (iFileID == 0)
        {
            return sCurrentMap;
        }
        
        int iIDinFile = iFileID - 1;
        
        //otwieramy oba potrzebne pliki        
        RandomAccessFile cIdxFile = null;
        RandomAccessFile cDataFile = null;
        
        try
        {
            cIdxFile = new RandomAccessFile(s_sWishListIdxFile, "r");
        }
        catch (FileNotFoundException e)
        {
            GameObject.CrashLog("[WishListCounter.WishListFileIDToPath] file " + s_sWishListIdxFile + " not found\n");
            return null;
        }
        
        try
        {
            cDataFile = new RandomAccessFile(s_sWishListDataFile, "r");
        }
        catch (FileNotFoundException e)
        {
            GameObject.CrashLog("[WishListCounter.WishListFileIDToPath] file " + s_sWishListDataFile + " not found\n");
            CloseFile(cIdxFile);
            return null;
        }

        try
        {
            //sprawdzmy, czy nie pytaja sie o zbyt duze ID
            long lIdxFileLen = cIdxFile.length();
            
            if (iIDinFile * 4 + 4 > lIdxFileLen)
            {
                GameObject.CrashLog("[WishListCounter.WishListFileIDToPath] invalid file " + s_sWishListIdxFile + "size or FileID\n");
                CloseFile(cIdxFile);
                CloseFile(cDataFile);
                return null;
            }
            
            cIdxFile.seek(iIDinFile * 4);
            long lDataFileOffs = cIdxFile.readLong();
            
            cDataFile.seek(lDataFileOffs);
            String sRet = cDataFile.readLine();
            
            GameObject.Log("[WishListCounter.WishListFileIDToPath] file read : " + sRet + "\n");
            return sRet;
        }
        catch(IOException e)
        {
            GameObject.CrashLog("[WishListCounter.WishListFileIDToPath] IO error\n");
            
            CloseFile(cIdxFile);
            CloseFile(cDataFile);
            return null;
        }
    }
    
    public static void CloseFile(RandomAccessFile file)
    {
        if (file != null)
        {
            try
            {
                file.close();   
            }
            catch(IOException e)
            {
            }
        }
    }
}
