public class CommandAdminLogout extends ConsoleCommand
{
    CommandAdminLogout()
    {
        super();
        m_nRequiredAdminRights  = EAdminRights._STANDARD;
    }
    
    void SetErrorId(int nErrorId)
    {
        if ( nErrorId == EConsoleCommandError._YOU_ARE_NOT_ADMIN )
            nErrorId = EConsoleCommandError._YOU_ARE_NOT_LOGGED_IN_TO_LOG_OUT;
        super.SetErrorId( nErrorId );
    }
    
    void Perform()
    {
        int nHostId = GetHost();
    
        if ( nHostId != 0 )
        {
            int nErrorId = 
                m_cGameInfo.GetAdminsManager().AdminLogout( nHostId );

            if ( nErrorId != EConsoleCommandError._NONE )
                SetErrorId( nErrorId );
        }
        else
            SetErrorId( EConsoleCommandError._YOU_CANNOT_LOG_OUT_AS_ADMIN ); 
        
    }
    
    void ShowErrors()
    {
        String sError = GetTextCommandNotAccepted();
        switch ( GetErrorId() )
        {
        case EConsoleCommandError._YOU_ARE_NOT_LOGGED_IN_TO_LOG_OUT:
            sError = sError + " " + Text.Get("&ConsoleCommandYouAreNotLoggedInToLogOut&");
            break;      
        case EConsoleCommandError._YOU_CANNOT_LOG_OUT_AS_ADMIN:
            sError = sError + " " + Text.Get("&ConsoleCommandYouCannotLogOutAsAdmin&");
            break;                  
        default:
            sError = null;
            super.ShowErrors();
        }
        if ( sError != null )
            WriteResults( sError );
    }
    
    void ShowResults()
    {
        String sResults = GetTextCommandAccepted() +
                          " " + 
                          Text.Get("&ConsoleCommandYouHaveLoggedOutAsAdmin&");
        //"ConsoleCommandPlayerHasLoggedOutAsAdmin"
        WriteResults( sResults );
    }
    
}
