/**
 * Wyswietlenie listy wszystkich graczy
 */
public class CommandPlayersList extends ConsoleCommand
{
    CommandPlayersList()
    {
        super();
        m_bShouldExecuteOnlyOnServer = false;
    }
    
    int      m_nPlayersCnt  = 0;
    String[] m_aPlayersNick = null;    
    int   [] m_aPlayersPID  = null;
    
    void Clean()
    {
        super.Clean();
        m_nPlayersCnt  = 0;
        m_aPlayersNick = null;    
        m_aPlayersPID  = null;
    }
        
    void Perform()
    {
        m_nPlayersCnt = m_cGameInfo.GetPlayerInfoList().GetSize();
        if ( m_nPlayersCnt <= 0 )
            return;
        m_aPlayersNick = new String[ m_nPlayersCnt ];
        m_aPlayersPID  = new int[ m_nPlayersCnt ];
        
        for ( int i=0; i<m_nPlayersCnt; ++i )
        {
            NetPlayerInfo cPlayer = m_cGameInfo.GetPlayerInfoList().GetPlayerByIndex( i );
            //TODO: docelowo chyba bedziemy wysylac NetId
            m_aPlayersNick[ i ] = cPlayer.GetNick();
            //TODO: docelowo bedziemy wysylac PIDy
            m_aPlayersPID [ i ] = cPlayer.GetClientOwnerId();
        }
    }
    
    void ShowResults()
    {
        if ( m_nPlayersCnt <= 0 )
        {
            WriteResults( Text.Get("&ConsoleCommandNoPlayersInGame&") );
            return;
        }
        WriteResults( NetGameTools.MixString(
                        Text.Get("&ConsoleCommandThereArePlayersInGame&"),
                        Integer.toString(m_nPlayersCnt)) );
        for ( int i=0; i<m_nPlayersCnt; ++i )
        {
            WriteResults(""+(i+1)+" "+m_aPlayersNick[ i ]+" id:"+m_aPlayersPID[ i ] );
        }
    }
}
