/**
 * Sprawdzenie czasu pozostalego do konca gry/rundy
 */
public class CommandTimeLeft extends ConsoleCommand
{
    CommandTimeLeft()
    {
        super();
        m_bShouldExecuteOnlyOnServer = false;
    }
    
    //rezultaty
    int m_nTime      = 0;
    int m_nTimeLimit = 0;
    
    void Clean()
    {
        super.Clean();
        m_nTime      = 0;
        m_nTimeLimit = 0;
    }
        
    void Perform()
    {
        m_nTime        = (int)m_cGameInfo.GetGameTime();
        m_nTimeLimit   = (int)m_cGameInfo.GetGameSettings().GetGameTimeLimit();
    }
    
    void ShowResults()
    {
        String sResults = null;
        
        String sTime = NetGameTools.Time2String( m_nTime );
        if ( m_nTimeLimit > -1 )
        {
            String sTimeLimit   = NetGameTools.Time2String( m_nTimeLimit );
            String sTimeLeft    = NetGameTools.Time2String( m_nTimeLimit-m_nTime );    
            sResults = NetGameTools.MixString(
                                            Text.Get("&ConsoleCommandTimeLimit&"),
                                            sTimeLimit            
                                             ) + 
                       " " +
                       NetGameTools.MixString(
                                            Text.Get("&ConsoleCommandTimeLeft&"),
                                            sTimeLeft            
                                             );
        }
        else
        {
            sResults = Text.Get("&ConsoleCommandNoTimeLimit&");
        }

        if ( sResults != null )
            WriteResults( sResults );
    }
}
