public class NetGameSettingsCTF extends NetGameSettingsTeam
{
    //czy pozycja flagi ma byc pokazywana na mapie
    boolean    _FLAGS_VISIBLE_ON_HUD_MAP = true;
    //po jakim czasie porzucona flaga wraca automatycznie do bazy, 
    float      _FLAG_AUTO_RETURN_TIME_IN_SECONDS = 120.0f;
    
    NetGameSettingsCTF()
    {
        super();
       
        _POINTS_LIMIT                  =   5;
        _TIME_LIMIT_IN_MINUTES         =  30;
        //remuje bo chlopakom sie to nie podoba
        //_MIN_RESPAWN_TIME_IN_SECONDS   =  10f;
    }
    
    //czy pozycja flagi ma byc pokazywana na mapie
    private boolean    m_bFlagsVisibleOnHudMap = true;
    //po jakim czasie porzucona flaga wraca automatycznie do bazy, 
    private float      m_fFlagAutoReturnTime = 120.0f;
    
    
    boolean GetFlagsVisibleOnHudMap(){ return m_bFlagsVisibleOnHudMap;}
    void    SetFlagsVisibleOnHudMap(boolean bVal){ m_bFlagsVisibleOnHudMap = bVal;}
    float   GetFlagAutoReturnTime(){ return m_fFlagAutoReturnTime; }
    void    SetFlagAutoReturnTime(float fTime){ m_fFlagAutoReturnTime = fTime; }
    
    
    void Init()
    {
        super.Init();
        SetFlagsVisibleOnHudMap( _FLAGS_VISIBLE_ON_HUD_MAP );
    }
    
    boolean ApplyModifier(ModifierNetGameSettings cModifier)
    {
        boolean bOk = true;
        
        switch ( cModifier.GetId() )
        {
        case EModifiersNetGameSettings._FLAGS_VISIBLE_ON_HUD_MAP:
            SetFlagsVisibleOnHudMap( cModifier.GetBooleanParam() );
            break;
        case EModifiersNetGameSettings._FLAG_AUTO_RETURN_TIME:
            SetFlagAutoReturnTime( cModifier.GetFloatParam() );
            break;
            
        default:
            bOk = super.ApplyModifier( cModifier );
        }
        return bOk;
    }
    
    void SaveSettings()
    {
        super.SaveSettings();
                    
        m_cScriptWriter.Write("FlagsVisibleOnHudMap("+Bool2String(m_bFlagsVisibleOnHudMap)+")");
        m_cScriptWriter.Write("FlagAutoReturnTime("+m_fFlagAutoReturnTime+")");
    }

    
    void CopyDataFromContainer()
    {
        super.CopyDataFromContainer();
        
        SetFlagsVisibleOnHudMap( m_cContainer.UnPackBoolean() );
        SetFlagAutoReturnTime( m_cContainer.UnPackFloat() );
    }

    void CopyDataToContainer()
    {
        super.CopyDataToContainer();
                
        m_cContainer.PackBoolean( GetFlagsVisibleOnHudMap() );
        m_cContainer.PackFloat( GetFlagAutoReturnTime()  );
    }
    
    NetGameRule GetGameRule()
    {
        if ( GetPointsLimit()   > -1 && 
             GetGameTimeLimit() > -1 )
        {
            return new NetGameRule( NetGameRule._MSG_PointsAndTime,
                                    GetPointsLimit(),
                                    GetGameTimeLimitInMinutes() );              
        }
        else if ( GetPointsLimit() > -1 )
        {
            return new NetGameRule( NetGameRule._MSG_PointsOnly,
                                    GetPointsLimit() );              
        } 
        else if ( GetGameTimeLimit() > -1 )
        {
            return new NetGameRule( NetGameRule._MSG_TimeOnly,
                                    GetGameTimeLimitInMinutes() );              
        }
        else return null;
    }
}
