public class NetGameSettingsDM extends NetGameSettingsIndividual
{
    NetGameSettingsDM()
    {
        super();

        _FRAGS_LIMIT                   = 20;
        _TIME_LIMIT_IN_MINUTES         = 20;
        
        m_bScorePoints = false;
    }
    
    boolean ApplyModifier(ModifierNetGameSettings cModifier)
    {
        boolean bOk = true;
        
        switch ( cModifier.GetId() )
        {
        case EModifiersNetGameSettings._MAX_FRAGS:
            SetFragsLimit( cModifier.GetIntParam() );
            break;
        default:
            bOk = super.ApplyModifier( cModifier );
        }
        
        return bOk;
    }
    
    NetGameRule GetGameRule()
    {
        GameObject.LogD("\n");
        GameObject.LogD("GetFragsLimit() "+GetFragsLimit()+
             "GetGameTimeLimit() "+GetGameTimeLimit()+"\n");
        if ( GetFragsLimit() >-1 && GetGameTimeLimit() > -1 )
        {
            return new NetGameRule( NetGameRule._MSG_FragsAndTime,
                                    GetFragsLimit(),
                                    GetGameTimeLimitInMinutes() );              
        }
        else if ( GetFragsLimit() >-1 )
        {
            return new NetGameRule( NetGameRule._MSG_FragsOnly,
                                    GetFragsLimit() );              
        } 
        else if ( GetGameTimeLimit() > -1 )
        {
            return new NetGameRule( NetGameRule._MSG_TimeOnly,
                                    GetGameTimeLimitInMinutes() );              
        }
        else return null;
    }
}
