public class NetGameSettingsTD extends NetGameSettingsTeam
{
    //co ile zliczamy punkty
    float   _SCORE_UPDATE_TIME                  = 5.0f;
    //czy zliczamy tez punkty indywidualne
    boolean _SCORE_INDIVIDUAL_POINTS            = true;
    //czy stan bazy ma byc pokazywany na mapie
    boolean _BASES_VISIBLE_ON_HUD_MAP           = true;
    
    
    NetGameSettingsTD()
    {
        super();
        
        _POINTS_LIMIT                  = 200;
        _TIME_LIMIT_IN_MINUTES         = 30;
        _MIN_RESPAWN_TIME_IN_SECONDS   = 10.0f;
    }
       
    //co jaki czas zliczamy punkty,
    private float   m_fScoreUpdateTime = 5.0f; 
    //czy zliczamy tez punkty indywidualne
    private boolean m_bScoreIndividualPoints = true;
    //czy stan bazy ma byc pokazywana na mapie
    private boolean    m_bBasesVisibleOnHudMap = true;
       
    float   GetScoreUpdateTime(){ return m_fScoreUpdateTime; }
    boolean GetScoreIndividualPoints(){ return m_bScoreIndividualPoints; }
    boolean GetBasesVisibleOnHudMap(){ return m_bBasesVisibleOnHudMap;}
    void    SetScoreUpdateTime(float fTime){ m_fScoreUpdateTime = fTime; }    
    void    SetScoreIndividualPoints(boolean bVal){ m_bScoreIndividualPoints = bVal; }
    void    SetBasesVisibleOnHudMap(boolean bVal){ m_bBasesVisibleOnHudMap = bVal;}
    
    void Init()
    {
        super.Init();
        SetScoreUpdateTime( _SCORE_UPDATE_TIME );
        SetScoreIndividualPoints( _SCORE_INDIVIDUAL_POINTS );
        SetBasesVisibleOnHudMap( _BASES_VISIBLE_ON_HUD_MAP );
    }
    
    boolean ApplyModifier(ModifierNetGameSettings cModifier)
    {
        boolean bOk = true;
        
        switch ( cModifier.GetId() )
        {
        case EModifiersNetGameSettings._DOMINATION_SCORE_UPDATE_TIME:
            SetScoreUpdateTime( (float)cModifier.GetIntParam() );
            break;            
        case EModifiersNetGameSettings._BASES_VISIBLE_ON_HUD_MAP:
            SetBasesVisibleOnHudMap( cModifier.GetBooleanParam() );
            break;            
        default:
            bOk = super.ApplyModifier( cModifier );
        }
        
        return bOk;
    }
    
    void SaveSettings()
    {
        super.SaveSettings();
        
        m_cScriptWriter.Write("ScoreUpdateTime("+((int)(m_fScoreUpdateTime))+")");
        m_cScriptWriter.Write("BasesVisibleOnHudMap("+Bool2String(GetBasesVisibleOnHudMap())+")");
    }
    
    void CopyDataFromContainer()
    {
        super.CopyDataFromContainer();
        SetScoreUpdateTime( (float)m_cContainer.UnPackInt() );
        SetBasesVisibleOnHudMap( m_cContainer.UnPackBoolean() );
    }

    void CopyDataToContainer()
    {
        super.CopyDataToContainer();
        m_cContainer.PackInt( (int)GetScoreUpdateTime() );
        m_cContainer.PackBoolean( GetBasesVisibleOnHudMap() );
    }

    
    NetGameRule GetGameRule()
    {
        if ( GetPointsLimit() >-1 && GetGameTimeLimit() > -1 )
        {
            return new NetGameRule( NetGameRule._MSG_PointsAndTime,
                                    GetPointsLimit(),
                                    GetGameTimeLimitInMinutes() );              
        }
        else if ( GetPointsLimit() > -1 )
        {
            return new NetGameRule( NetGameRule._MSG_PointsOnly,
                                    GetPointsLimit() );              
        } 
        else if ( GetGameTimeLimit() > -1 )
        {
            return new NetGameRule( NetGameRule._MSG_TimeOnly,
                                    GetGameTimeLimitInMinutes() );              
        }
        else return null;
    }
}
