/**
 * Lista wszystkich czastkowych skinow dla wybranego
 * elemntu mesha
 */
public class SkinPartialList
{
    java.util.Vector m_aList = new java.util.Vector();
    int m_nCurrent = 0;
    
    void Add(SkinPartial cSkin)
    {
        if ( cSkin instanceof SkinPartial )
            m_aList.addElement( cSkin );
    }
    
    void SetNext()
    {
        if ( m_aList.size() > 0 )
            m_nCurrent = (m_nCurrent + 1) % m_aList.size();
    }
    void SetPrevious()
    {
        if ( m_aList.size() > 0 )
            m_nCurrent = (m_nCurrent - 1 + m_aList.size()) % m_aList.size();
    }
    
    void SetCurrentByFlag( byte nFlag )
    {
        int i = 0;
        for ( i=0; i<m_aList.size(); i++ )
        {
            SkinPartial cSkin = Get( i );
            if ( (cSkin.m_nFlags & nFlag) != 0 )
            {
                m_nCurrent = i;    
                break;
            }
        }
        if ( i >= m_aList.size() )
            GameObject.LogD("Nie znaleziono skina o fladze "+
                             SkinPartial.GetFlagName(nFlag) + "\n");
    }
    
    void SetCurrentByIndex( int nIndex )
    {
        if ( nIndex >= 0 && nIndex < m_aList.size() )
            m_nCurrent = nIndex;
        else
            m_nCurrent = 0;
    }
    
    int GetCurrentIndex(){ return m_nCurrent; }
    int GetSize(){ return m_aList.size(); }
    
    String GetCurrentSkinName()
    {
        SkinPartial cSkin = GetCurrent();
        if ( cSkin != null )
            return cSkin.GetName();
        return null;
    }
    SkinPartial GetCurrent()
    { 
        return Get( m_nCurrent );
    }    
    SkinPartial Get(int i)
    { 
        if ( i >= 0 && i < m_aList.size() )
            return (SkinPartial)m_aList.get( i );
        return null; 
    }    
        
    //czy mozna zmieniac aktualnego skina?
    private boolean m_bChangeAvailable = true;
    boolean IsChangeAvailable(){ return m_bChangeAvailable; }
    void SetChangeAvailable(boolean bAvailable){ m_bChangeAvailable = bAvailable; }
}
