/**
 * Klasa bazowa dla NetServerInitInfo i NetServerFullInfo
 */
public class NetServerInitInfoBase extends NetObjectContainer
{
    //_bMultiplayerDemo
    //final static int _MAX_PLAYERS = 16;
    final static int _MAX_PLAYERS = 32;
    final static int _DEF_PLAYERS = 16;
    
    // nazwa serwera
    private String m_sServerName = "ChromeNet Server";
    void SetServerName(String sName)
    {
        if(ChromeModule._bMultiplayerDemo)
        {
            if(!sName.startsWith("DEMO"))
            {
                int nChars = 10;
                if( nChars > sName.length() ) nChars = sName.length();
                m_sServerName = "DEMO" + sName.substring(0, nChars);
            }
            else
                m_sServerName = sName;
        }
        else
            m_sServerName = sName;
    }

    String GetServerName(){ return m_sServerName; }
    
    // maksymalna liczba graczy
    private int m_nMaxPlayers = _DEF_PLAYERS;
    int GetMaxPlayers(){ return m_nMaxPlayers; }
    
    void SetMaxPlayers(String sMax)
    {
        SetMaxPlayers(Integer.parseInt( sMax ));
    }
    
    int GetMaxConnections(){ return m_nMaxPlayers-(m_bDedicated?0:1); }
    
    void SetMaxPlayers(int nMax)
    { 
        m_nMaxPlayers = nMax; 
        if (m_nMaxPlayers <= 0 )
            m_nMaxPlayers = 1;
        else if (m_nMaxPlayers > _MAX_PLAYERS )
            m_nMaxPlayers = _MAX_PLAYERS;
    }
    
    // gdy true to levele z listy sa loopovane w nieskonczonosc
    private boolean m_bLoopLevels = false;
    void SetLoopLevels(boolean bLoop){ m_bLoopLevels = bLoop; }
    boolean GetLoopLevels(){ return m_bLoopLevels; }
    
    //czy server dedykowany czy z graczem
    private boolean m_bDedicated = false;
    void SetDedicated(boolean bDedicated){ m_bDedicated = bDedicated; }
    boolean GetDedicated(){ return m_bDedicated; }
    
    //czy server chroniony haslem
    private boolean m_bPassword = false;
    void SetPassword(boolean bPassword){ m_bPassword = bPassword; }
    boolean IsPassword(){ return m_bPassword; }
    
    NetServerInitInfoBase()
    {
    }
    NetServerInitInfoBase(NetServerInitInfo cInfo)
    {
        m_sServerName = cInfo.GetServerName();
        m_nMaxPlayers = cInfo.GetMaxPlayers();
        m_bLoopLevels = cInfo.GetLoopLevels();
        m_bDedicated  = cInfo.GetDedicated();
        m_bPassword   = cInfo.IsPassword();
    }
    
    /**
     * Pakowanie zawartosci klasy do kontenera
     */
    void CopyDataToContainer()
    {
        m_cContainer.PackString( m_sServerName );
        m_cContainer.PackInt( m_nMaxPlayers );
        m_cContainer.PackBoolean( m_bLoopLevels );
        m_cContainer.PackBoolean( m_bDedicated );  
        m_cContainer.PackBoolean( m_bPassword );   
    }

    /**
     * Odpakowanie zawartosci klasy do kontenera
     */
    void CopyDataFromContainer()
    {
        m_sServerName = m_cContainer.UnPackString();
        m_nMaxPlayers = m_cContainer.UnPackInt();
        m_bLoopLevels = m_cContainer.UnPackBoolean();
        m_bDedicated  = m_cContainer.UnPackBoolean();  
        m_bPassword   = m_cContainer.UnPackBoolean();   
    }
}
