/** abstrakcyjna klasa reprezentujaca HUDComponent sieciowy
 */

public abstract class HUDComponentNet extends HUDComponent
{
    static int _HUD_NET_MAIN_WIDTH  = 512;
    static int _HUD_NET_MAIN_HEIGHT = 256;
    static int _HUD_NET_MAIN_POS_Y  = 60;
   
    /** 
     * rozmiar Y pojedynczego spritea-tekstu 
     **/
    static int sm_nSpriteTextHeight = 10;
    static int sm_nColumnHeight     = 14;
    
    
    int METHOD_DeactivateInTime = 0;
    
    
    public void OnCreate()
    {
        METHOD_DeactivateInTime = RegisterCallMethod("DeactivateInTime");
        super.OnCreate();
    }
    
    
    /**
     * Flaga mowiaca o tym, ze hud juz wystartowal i mozna
     * go odswiezac...
     */
    byte m_byStatus = HUDNetManager._STATUS_UNKNOWN;
    /**
     * Metoda wolana przy starcie huda
     */
    void SetStatus(byte byStatus) 
    { 
        m_byStatus = byStatus; 
        if ( byStatus == HUDNetManager._STATUS_STOPPED )
            Deactivate();
    }
    
    
    /** 
     * referencja do HUDNetManagera
     */
    HUDNetManager m_cHudNetManager = null;
    
    /** 
     * referencja do NetGameInfo
     */
    NetGameInfoHud m_cNetGameInfo = null;
    
    public void Init(HUDNetManager cManager,NetGameInfoHud cGameInfo)
    {
        m_cHudNetManager  = cManager;
        m_cNetGameInfo    = cGameInfo;
    }
      
    public void DeactivateIn( float fTime )
    {
        DisableCallMethod( METHOD_DeactivateInTime );
        CallMethodIn( METHOD_DeactivateInTime, fTime );
    }
    
    public void DeactivateInTime()
    {
        DisableCallMethod( METHOD_DeactivateInTime );
        Deactivate();
    }
    
    void Refresh()
    {
        if (bActiveFlag)
        {
            Deactivate();
            if ( m_cHudNetManager.IsLocked() )
                bActiveFlag = true;
            else
			    Activate();
        }
    }
    
    void TryToActivate()
    {
        if ( !m_cHudNetManager.IsLocked() )
            Activate();
    }
    void TryToActivate(int nMode)
    {
        if ( !m_cHudNetManager.IsLocked() )
            Activate( nMode );
    }
    
    
    /** metoda aktywujaca HUD'a
     */
    public void Activate()
    {
        if ( m_byStatus != HUDNetManager._STATUS_STOPPED )
        {
            super.Activate();
            InitText();
            Draw();
        }
    }
    
    /** metoda deaktywujaca HUD'a
     */
    public void Deactivate()
    {
        super.Deactivate();   
        HideAll();
    }
    
    /**
     *  abstrakcyjne metody do nadpisania
     */ 
    public void HideAll(){}
    void SetText( String sTxt ){}
    void SetText( String sTxt, Vector vColor ){}
    void SetRule( String sText ){}
    void SetInfoText( String sTxt, Vector vColor ){}
    void SetScoreText( String sTxt, Vector vColor ){}
    String GetText(){ return null; }
    boolean InitText(){ return true; }
    void CheckTextsTime(){}
    void Activate(int nMode){}
    void ShowHistory(){}
    void SetConnectionStatus( byte byStatus ){};
}




