public class HUDNetGameStatus extends HUDComponentNet
{
    boolean m_bScoreVisible = true;
    boolean m_bInfoVisible  = false;
        
    String m_sScoreText    = null;
    Vector m_vScoreColor   = NetMsg._COLOR_DEFAULT;
    Sprite m_cScoreSprText = null;

    String m_sInfoText    = null;
    Vector m_vInfoColor   = NetMsg._COLOR_DEFAULT;
    Sprite m_cInfoSprText = null;
    
    public void OnCreate()
    {
        nHUDCompWidth  = GetScreenWidth();
	    nHUDCompHeight = sm_nSpriteTextHeight * 2;
        
        nHUDCompPosX   = 0;
	    nHUDCompPosY   = 0;
        
        m_cScoreSprText = (Sprite)CreateObject("Sprite");
        m_cScoreSprText.SetNoTexture();
		m_cScoreSprText.ProcessMouse(false);
        m_cScoreSprText.SetSize(new Vector(nHUDCompWidth,sm_nSpriteTextHeight,0));
        m_cScoreSprText.SetPos(new Vector(nHUDCompPosX+30,nHUDCompPosY,0));
        AddSprite( m_cScoreSprText );        
        m_cScoreSprText.SetFont(ChromeFonts.FONT_HUD_BIGGER);
        
        m_cInfoSprText = (Sprite)CreateObject("Sprite");
        m_cInfoSprText.SetNoTexture();
		m_cInfoSprText.ProcessMouse(false);
        m_cInfoSprText.SetSize(new Vector(nHUDCompWidth,sm_nSpriteTextHeight,0));
        m_cInfoSprText.SetPos(new Vector(nHUDCompWidth/2,nHUDCompPosY,0));
        AddSprite( m_cInfoSprText );        
        m_cInfoSprText.SetFont(ChromeFonts.FONT_HUD_BIGGER);
        
        InitText();
        Activate();
    }
            
    public void OnDestroy()
    {
        if ( m_cScoreSprText != null )
        {
            RemoveSprite( m_cScoreSprText );
            m_cScoreSprText.delete();
            m_cScoreSprText = null;	 
        }
        if ( m_cInfoSprText != null )
        {
            RemoveSprite( m_cInfoSprText );
            m_cInfoSprText.delete();
            m_cInfoSprText = null;	 
        }
    }
        
    public void Draw()
    {
        if ( m_bScoreVisible )
            m_cScoreSprText.Show();
        if ( m_bInfoVisible )
            m_cInfoSprText.Show();
    }
    
    public void HideAll()
    {
        m_cScoreSprText.Hide();         
        m_cInfoSprText.Hide();
    }
    


    void SetScoreText( String sTxt, Vector vColor )
    {
        m_sScoreText  = sTxt;
        m_vScoreColor = vColor;
    }
             
    void SetInfoText( String sTxt, Vector vColor )
    {
        m_sInfoText  = sTxt;
        m_vInfoColor = vColor;
    }
    
    boolean InitText()
    {
        if ( m_sScoreText != null )
        {
            m_cScoreSprText.SetTextColorV( m_vScoreColor );
            m_cScoreSprText.DisplayText( m_sScoreText );
        }
        else
            m_cInfoSprText.DisplayText("");   
        
        if ( m_sInfoText != null )
        {
            m_cInfoSprText.SetTextColorV( m_vInfoColor );
            m_cInfoSprText.DisplayText( m_sInfoText );
        }
        else
            m_cInfoSprText.DisplayText("");   
        return true;
    }
}

