public class HUDNetOutgoingMessage extends HUDComponentNet
{
    
    
    final static int _MODE_ALL  = 0;
    final static int _MODE_TEAM = 1;
    
    int m_nMode = _MODE_ALL;
        
    private boolean m_bTeamModeAvailable = false;

    HUDNetIncomingMessage m_cHudIncomingMsg = null;
    
    //niech historia bedzie statyczna to bedzie mogla sie 
    //przenosic pomiedzy levelami
    static ConsoleMessageHistory sm_cHistory = null;
    ConsoleMessageHistory GetHistory(){ return sm_cHistory; };
    //aktualnie wpisywany tekst (jeszcze go nie ma w historii)
    String m_sCurrent = null;
    
    String m_sText      = null;
    // Sprite z tekstem
    Sprite[] m_aSprText = null;
    // Sprite z tekstem
    Sprite m_cSprText2  = null;
    
    int m_nPosX = 0;
    int m_nPosY = 0;
    
    Sprite cBkg = null;
    int nBkgTex = 0;
    
    String m_sCursorSign = "_";
    
    HUDNetOutgoingMessage()
    {
        //nPosX = 0,nHUDCompHeight+nHUDCompPosY+35,0));    
    }
    
    public void OnCreate()
    {
        super.OnCreate();
                
        Vector vPos = m_cHudIncomingMsg.GetOutgoingMsgPos();
        Vector vSize = new Vector(m_cHudIncomingMsg.GetOutgoingMsgSizeX(), 0, 0);
        
        cBkg = (Sprite)CreateObject("Sprite");
        AddSprite(cBkg);
        nBkgTex = cBkg.AddTexture("data/hud/ch_p_hud.png");
        cBkg.SetFrameTexture(nBkgTex, new Rect(297f/1024f,465f/512f,307f/1024f,475f/512f),3,3);
        cBkg.SetName("OUTGOING_BKG");
        cBkg.SetAlpha(1f);
                
        m_aSprText = new Sprite[2];
        for (int i=0; i<m_aSprText.length; i++)
        {
            Sprite cSprText = (Sprite)CreateObject("Sprite");
        
            cSprText.SetNoTexture();
		    cSprText.ProcessMouse(false);
            cSprText.SetFont( ChromeFonts.FONT_HINT );    
            cSprText.DisplayText(" ");
            cSprText.SetSize(new Vector(vSize.fX, cSprText.GetTextExtent().fY,0));
            cSprText.DisplayText("");
            cSprText.SetPos(vPos);
            vPos.fY += cSprText.GetSize().fY;
            
            AddSprite( cSprText );        
            m_aSprText[ i ] = cSprText;
        }
        
        //cBkg.SetPos(new Vector(m_aSprText[0].GetPos().fX - 5, m_aSprText[0].GetPos().fY, 0));
        //cBkg.SetSize(new Vector(m_aSprText[0].GetSize().fX + 10, m_aSprText[0].GetSize().fY * 2 + 5, 0));
        
        cBkg.SetPos(new Vector(m_aSprText[0].GetPos().fX-5, m_aSprText[0].GetPos().fY, 0));
        cBkg.SetSize(new Vector(m_aSprText[0].GetSize().fX, m_aSprText[0].GetSize().fY * 2 + 2, 0));
        
        InitText();
        
        if ( sm_cHistory == null )
            sm_cHistory = new ConsoleMessageHistory();
    }
    
    public void OnDestroy()
    {
        super.OnDestroy();

        if ( m_aSprText != null )
        {
            for ( int i=0; i<m_aSprText.length; i++ )
            {
                if ( m_aSprText[ i ] != null )
                {
                    RemoveSprite( m_aSprText[ i ] );
                    m_aSprText[ i ].delete();
                    m_aSprText[ i ] = null;	 
                }        
            }
            m_aSprText = null;
        }
        
        if (cBkg != null)
        {
            cBkg.ReleaseTexture(nBkgTex);
            RemoveSprite(cBkg);
            cBkg.delete();
            cBkg = null;
        }        
        
        UnregisterKeyRequest();
    }
    
    public void Init(HUDNetManager cManager,NetGameInfoHud cGameInfo)
    {
        super.Init( cManager, cGameInfo );
        //bedziemy przechwytywac klawisze
        RegisterKeyRequest();
        m_bTeamModeAvailable = m_cNetGameInfo instanceof NetGameInfoTeam;
    }
    
    boolean InitText()
    {
        return InitText( m_sText );
    }
    boolean InitText(String sMainText)
    {
        if ( sMainText == null )
        {
            m_aSprText[0].DisplayText("");
            m_aSprText[1].DisplayText("");
            return true;
        }
        
        String sText = null;
        switch ( m_nMode )
        {
        case _MODE_TEAM:
            sText = NetMsg.sEnterTeamMessage+" "+sMainText;   
            break;
                
        default:
            sText = NetMsg.sEnterMessage+" "+sMainText;   
        }
        sText += m_sAddText;
        Sprite cTest = m_aSprText[ 0 ];
        cTest.SetTextPosFlags(ESpriteText.MULTILINE);
        String sTab[] = cTest.GetTextLines( sText );
        int i = 0;
		for (i = 0; i < sTab.length; i++)
		{
            if ( i < m_aSprText.length )
                m_aSprText[i].DisplayText( sTab[i] );   
            else
                return false;
		}
        for ( ; i < m_aSprText.length; i++ )
            m_aSprText[i].DisplayText("");
        return true;
    }    
    
    void Activate(int nMode)
    {
        m_nMode = nMode;
        SetText("");
        Activate();
    }
    
    public void Activate()
    {
        CallMethodEvery("BlinkCursor", 0.5f);
        super.Activate();
        RegisterKeyRequestExclusive();
    }
    
    public void Deactivate()
    {
        DisableCallMethod("BlinkCursor");
        super.Deactivate();
        UnregisterKeyRequestExclusive();
    }
    
    /** metoda wyswietlajaca tekst
     */
    public void Draw()
    {
        cBkg.Show();
        cBkg.MoveTop();
        m_aSprText[0].Show();
        m_aSprText[0].MoveTop();
        m_aSprText[1].Show();
        m_aSprText[1].MoveTop();
    }
    
    public void HideAll()
    {
        cBkg.Hide();
        m_aSprText[0].Hide();
        m_aSprText[1].Hide();
    }
    
    String GetText()
    {
        return m_sText;
    }
    
    public void OnInputKey(int nKeyCode, boolean bKeyState, char nKeyAscii)
    {
        if ( !bKeyState )
            return;
        
        if ( bActiveFlag )
        {
            // pobieramy wcisniety klawisz
            //LogD(" nKeyCode:"+nKeyCode+" nKeyAscii:"+nKeyAscii+"\n");
            //String sTyped = GetStringFromKeyCode(nKeyCode);
            String sTyped = GetStringFromKeyCode( nKeyCode, nKeyAscii );
            if ( sTyped != null && sTyped.length() > 0)
            {
                // dodanie klawisza
                AddNewText(sTyped);
            }
            else if (nKeyCode==EKey._UP )
            {
                String sUp = GetHistory().GetPrevious();
                if ( sUp != null )
                {
                    SetText( sUp, false );
                    Refresh();  
                }
            }
            else if (nKeyCode==EKey._DOWN )
            {
                String sDown = GetHistory().GetNext();
                if ( sDown == null )
                {
                    sDown = m_sCurrent;
                    GetHistory().Reset();
                }
                SetText( sDown, false );
                Refresh();  
            }
            else if (nKeyCode==EKey._TAB || nKeyCode==EKey._ESCAPE)
            {
                // rezygnacja
                GetHistory().Reset();
                
                Deactivate();
            }
            else if (nKeyCode==EKey._BACK)
            {
                //skasowanie ostaniego znaczka
                String sText = GetText();
                if ( sText != null && sText.length() > 0 )
                {
                    // obetnij ostatni znaczek
                            
                    sText = sText.substring(0,sText.length()-1);
                    SetNewText( sText );
                }
            }
            else
            if ( nKeyCode==EKey._RETURN )
            {
                // zakonczenie z wyslaniem wiadomosci
                GetHistory().Add( GetText() );
                
                Send();
            }
        }
        else
        {
            if ( nKeyCode == EGameControl.SAY )
                TryToActivate( _MODE_ALL );
            else if ( nKeyCode == EGameControl.SAY_TEAM )
            {
                if ( m_bTeamModeAvailable )
                    TryToActivate( _MODE_TEAM );
                else
                    TryToActivate( _MODE_ALL );
            }
        }
    }
    
    void SetText(String sText)
    {
        SetText( sText, true );
    }
    
    boolean bCursorVisible = false;
    String m_sAddText = "";
    void BlinkCursor()
    {
        bCursorVisible = !bCursorVisible;
        if (bCursorVisible)
            m_sAddText = m_sCursorSign;
        else
            m_sAddText = " ";
        InitText();
        
    }
    
    void SetText(String sText, boolean bSetAsCurrent)
    {
        if ( InitText( sText ) )
        {
            m_sText = sText;
            if ( bSetAsCurrent )
                m_sCurrent = m_sText;
        }
        else
        {
            //TODO: jakis bzyczek o bledzie
        }
    }
        
    void Send()
    {
        if ( m_cNetGameInfo == null )
            return;
        
        String sTypedText       = GetText();
        int    nMode            = m_nMode;
        m_cNetGameInfo.LocalEventTypedText( sTypedText, nMode );
        
        
        
        Deactivate();
    }
   
    void AddNewText(String sNewText)
    {
        String sText = GetText();
        SetText(sText + sNewText);
        Refresh();
    }
    
    void SetNewText(String sNewText)
    {
        SetText(sNewText);
        Refresh();
    }

    // tak na razie do zamiany kodu klawiszy na literke 
    String GetStringFromKeyCode(int nKeyCode,char nAscii)
    {
        String sText = null;
        switch (nKeyCode)
        {
        case EKey._0:   case EKey._1:   case EKey._2:   case EKey._3:   
        case EKey._4:   case EKey._5:   case EKey._6:   case EKey._7:   
        case EKey._8:   case EKey._9:
        
        case EKey._Q:   case EKey._W:   case EKey._E:   case EKey._R:   
        case EKey._T:   case EKey._Y:   case EKey._U:   case EKey._I:   
        case EKey._O:   case EKey._P:   case EKey._A:   case EKey._S:   
        case EKey._D:   case EKey._F:   case EKey._G:   case EKey._H:   
        case EKey._J:   case EKey._K:   case EKey._L:   case EKey._Z:
        case EKey._X:   case EKey._C:   case EKey._V:   case EKey._B:   
        case EKey._N:   case EKey._M:
        
        case EKey._SPACE:   
        
        case EKey._ADD:         case EKey._SUBTRACT:     case EKey._MINUS: 
        case EKey._MULTIPLY:    case EKey._EQUALS:       case EKey._LBRACKET: 
        case EKey._RBRACKET:    case EKey._SEMICOLON:    case EKey._APOSTROPHE:
        case EKey._SLASH:       case EKey._BACKSLASH:    case EKey._COMMA:    
        case EKey._PERIOD:
            if ((int)nAscii != 0)
                sText = ""+nAscii;
            break;
        
        case EKey._NUMPAD0:
            sText = "0";
            break;
        case EKey._NUMPAD1:
            sText = "1";
            break;
        case EKey._NUMPAD2:
            sText = "2";
            break;
        case EKey._NUMPAD3:
            sText = "3";
            break;
        case EKey._NUMPAD4:
            sText = "4";
            break;
        case EKey._NUMPAD5:
            sText = "5";
            break;
        case EKey._NUMPAD6:
            sText = "6";
            break;
        case EKey._NUMPAD7:
            sText = "7";
            break;
        case EKey._NUMPAD8:
            sText = "8";
            break;
        case EKey._NUMPAD9:
            sText = "9";
            break;
        case EKey._DECIMAL:
            sText = ".";
            break;
        case EKey._DIVIDE:
            sText = "/";
            break;
        default:
        }
        return sText;
        
        /*
        if ( nKeyCode >= EKey._1 && nKeyCode <= EKey._MULTIPLY )
            return ""+nAscii;
        else 
            return "";
        */
    }
    
    
}
