public class HUDNetStatisticsTDM extends HUDNetStatisticsDM
{
    
    {
        m_sScriptName = "data/hudnet/HUDNetStatisticsTDM.scr";
    }
    
    void InitializeStatistics()
    {
        super.InitializeStatistics();
        
        SetTitle("&NetGameNameTDM&");
        
    }
    
    void UpdateStatistics()
    {
        if ( m_cNetGameInfo == null)
            return;
            
        NetTeamInfoList   cTeamInfoList   = m_cNetGameInfo.GetTeamInfoList();
        NetPlayerInfoList cPlayerInfoList = m_cNetGameInfo.GetPlayerInfoList();
        
        if ( cTeamInfoList == null || cPlayerInfoList == null )
            return;
        
        cTeamInfoList.Sort();
        cPlayerInfoList.Sort();
                    
        m_nSpaceRowCount = 0;
        
        for (int i = 0; i < cTeamInfoList.GetSize(); i++)
        {
            //teraz wyswietlamy teamy wg scisle okreslonej kolejnosci
            NetTeamInfo cTeam = cTeamInfoList.GetTeamByHudDisplayOrder( i );

            
            if ( cTeam == null )
                continue;
            
            java.util.Vector vPlayers = new java.util.Vector();

            for (int j = 0; j < cPlayerInfoList.GetSize(); j++)
            {
                NetPlayerInfo cPlayer = cPlayerInfoList.GetPlayerByIndex( j );
                
                if ( cPlayer == null )
                    continue;
                
                if (cPlayer.GetTeamId() == cTeam.GetTeamId())
                {
                    vPlayers.addElement(cPlayer);
                }
            } 
            UpdateTeam(i, cTeam, vPlayers);
        }
    }
    
    void SetRow(int nPlace, UIControlObject cRow, float fAlpha, NetPlayerInfo cPlayer)
    {
        cRow.Show();
        if (cPlayer != null)
        {
            Vector vColor = HUDNetManager.GetColorForPlayerInfo( cPlayer );

            SetRow(cRow, vColor, fAlpha, 1, 
                   String.valueOf(nPlace), 
                   cPlayer,
                   String.valueOf(cPlayer.GetFrags()),
                   String.valueOf(cPlayer.GetDeaths()),
                   String.valueOf(cPlayer.GetLatencyAndLoss()));

        }
        else
        {
            Vector vColor = new Vector(1,1,1);
            SetRow(cRow, vColor, fAlpha, 1, "...", "...", "...", "...", "...");
        }
    }
    
    void SetTeamRow(UIControlObject cRow, NetTeamInfo cTeam)
    {
        cRow.Show();
         Vector vColor = HUDNetManager.GetColorForTeamInfo(cTeam);
            
         SetRow(cRow, vColor, 1, fTeamRowFontScale, "", 
                Text.Get("&HUDNET_TEAM&") + cTeam.GetTeamName(), 
                String.valueOf(cTeam.GetFrags()),
                String.valueOf(cTeam.GetDeaths()),
                "");
    }
}

