public class HUDNetStatisticsTeamPoints  extends HUDNetStatistics
{
    final static String _COL_TEXTS[] = {"&NetHudStatsCH_Nick&",
                                        "&NetHudStatsCH_Points&",
                                        "&NetHudStatsCH_Frags&",
                                        "&NetHudStatsCH_Ping&"};
    final static int    _COL_WIDTH[] = { 50,    50 ,    50,      50   };
    final static int    _COL_POS  [] = { 50,    170,    260,     400  };
    
    {
        m_sScriptName = "data/hudnet/HUDNetStatisticsTeamPoints.scr";
    }
    
    void InitializeStatistics()
    {
        super.InitializeStatistics();
        
        SetTitle("&NetGameNameFRONT&");
    }
    
    void UpdateStatistics()
    {
        if ( m_cNetGameInfo == null)
            return;
                
        NetTeamInfoList   cTeamInfoList   = m_cNetGameInfo.GetTeamInfoList();
        NetPlayerInfoList cPlayerInfoList = m_cNetGameInfo.GetPlayerInfoList();
        
        if ( cTeamInfoList == null || cPlayerInfoList == null )
            return;
        
        cTeamInfoList.Sort();
        cPlayerInfoList.Sort();
        
        for (int i = 0; i < cTeamInfoList.GetSize(); i++)
        {
            //teraz wyswietlamy teamy wg scisle okreslonej kolejnosci
            NetTeamInfo cTeam = cTeamInfoList.GetTeamByHudDisplayOrder( i );
            
            if ( cTeam == null )
                continue;

            java.util.Vector vPlayers = new java.util.Vector();
            for (int j = 0; j < cPlayerInfoList.GetSize(); j++)
            {
                NetPlayerInfo cPlayer = cPlayerInfoList.GetPlayerByIndex( j );
                
                if ( cPlayer == null )
                    continue;
                
                if (cPlayer.GetTeamId() == cTeam.GetTeamId())
                {
                    vPlayers.addElement(cPlayer);
                }
            } 
            UpdateTeam(i, cTeam, vPlayers);
        }
    }    
    
    void InitColumns()
    {
        m_tColumns = new UIStatic[5];
        m_tColumns[0] = (UIStatic)GetElem("ID_COLUMN_PLACE");
        m_tColumns[1] = (UIStatic)GetElem("ID_COLUMN_NICK");
        m_tColumns[2] = (UIStatic)GetElem("ID_COLUMN_POINTS");
        m_tColumns[3] = (UIStatic)GetElem("ID_COLUMN_FRAGS");
        m_tColumns[4] = (UIStatic)GetElem("ID_COLUMN_PING");
    }
    
    void SetRow(int nPlace, UIControlObject cRow, float fAlpha, NetPlayerInfo cPlayer)
    {
        cRow.Show();
        if (cPlayer != null)
        {
            Vector vColor = HUDNetManager.GetColorForPlayerInfo( cPlayer );
            SetRow(cRow, vColor, fAlpha, 1, 
                   String.valueOf(nPlace), 
                   cPlayer,
                   String.valueOf( cPlayer.GetPoints() ),
                   String.valueOf( cPlayer.GetFrags() ),
                   String.valueOf( cPlayer.GetLatencyAndLoss()) );
        }
        else
        {
            Vector vColor = new Vector(1,1,1);
            SetRow(cRow, vColor, fAlpha, 1, "...", "...", "...", "...", "...");
        }
    }
    
    void SetTeamRow(UIControlObject cRow, NetTeamInfo cTeam)
    {
        Vector vColor = HUDNetManager.GetColorForTeamInfo(cTeam);
        cRow.Show();
        SetRow(cRow, vColor, 1, fTeamRowFontScale, "",
                   Text.Get("&HUDNET_TEAM&") + cTeam.GetTeamName(), 
                   Integer.toString(cTeam.GetPoints()),
                   Integer.toString(cTeam.GetFrags()),
                   "");
    }
    
    void SetRow(UIControlObject cRow, Vector vColor, float fAlpha, float fFontScale, String sPlace, String sNick, String sPoints, String sFrags, String sPing)
    {
        SetElemText((UIStatic)cRow.GetElem("_PLACE"), sPlace, vColor, fAlpha, fFontScale);
        SetElemText((UIStatic)cRow.GetElem("_NICK"), sNick, vColor, fAlpha, fFontScale);
        SetElemText((UIStatic)cRow.GetElem("_POINTS"), sPoints, vColor, fAlpha, fFontScale);        
        SetElemText((UIStatic)cRow.GetElem("_FRAGS"), sFrags, vColor, fAlpha, fFontScale);
        SetElemText((UIStatic)cRow.GetElem("_PING"), sPing, vColor, fAlpha, fFontScale);
    }
    
    void SetRow(UIControlObject cRow, Vector vColor, float fAlpha, float fFontScale, String sPlace, NetPlayerInfo cPlayer, String sPoints, String sFrags, String sPing)
    {
        SetElemText((UIStatic)cRow.GetElem("_PLACE"), sPlace, vColor, fAlpha, fFontScale);
        UIStatic cNick = (UIStatic)cRow.GetElem("_NICK");
        SetElemText(cNick, cPlayer.GetNickClamped(cNick), vColor, fAlpha, fFontScale);
        SetElemText((UIStatic)cRow.GetElem("_POINTS"), sPoints, vColor, fAlpha, fFontScale);        
        SetElemText((UIStatic)cRow.GetElem("_FRAGS"), sFrags, vColor, fAlpha, fFontScale);
        SetElemText((UIStatic)cRow.GetElem("_PING"), sPing, vColor, fAlpha, fFontScale);
    }
}
