public class HUDMapASSAULT extends HUDMapTeam 
{
    NetGameInfoASSAULT m_cGameInfoASSAULT = null;
    
    HudNetMapSpriteAssault m_aBases[] = null;
    
    int METHOD_ComputeBasesPos = 0;
    
    public void OnCreate()
    {
        METHOD_ComputeBasesPos = RegisterCallMethod( "ComputeBasesPos" );
        
        super.OnCreate();   
                
        if (m_bDisableInNetGame)
            return;
        
        m_aBases = new HudNetMapSpriteAssault[ NetGameInfoASSAULT.sm_nMaxBases ];
        
        for ( int i=0; i<m_aBases.length; i++ )
        {
            HudNetMapSpriteAssault aBase = (HudNetMapSpriteAssault)CreateObject("HudNetMapSpriteAssault");
         
            LogR("BASE " + aBase);
            m_cMap.AddChild( aBase );
            m_aBases[i] = aBase;
        }
    }
    
    void StartComputeObjectsPos()
    {
        super.StartComputeObjectsPos();
        
        DisableCallMethod( METHOD_ComputeBasesPos );
        CallMethodEvery( METHOD_ComputeBasesPos, 0.25f );
    }
    
    void SetCompassRef(HUDCompass cCompass)
    {
        if (m_bDisableInNetGame)
            return;
        
        super.SetCompassRef(cCompass);
        
        for ( int i=0; i<m_aBases.length; i++ )
        {
            m_aBases[i].m_cCompassElement = ((HUDCompassNet)cHUDCompasRef).AddWaypointNet(new Vector(), true, m_aBases[i]);
        }
        DrawDoUnderCursor();
    }
    
    public void OnDestroy()
    {
        if ( m_aBases != null )
        {
            for ( int i=0; i<m_aBases.length; i++ )
            {
                if ( m_aBases[i] != null )
                {
                    RemoveSprite( m_aBases[i] );
                    m_aBases[i].delete();
                    m_aBases[i] = null;
                }
            }
            m_aBases = null;
        }
        
        super.OnDestroy();
    }
    
    void SetNetGameInfo(NetGameInfo cGameInfo)
    {
        super.SetNetGameInfo( cGameInfo );
        
        if ( cGameInfo instanceof NetGameInfoASSAULT )
            m_cGameInfoASSAULT = (NetGameInfoASSAULT) cGameInfo;
    }
    
    public void Activate()
    {
		if (bActiveFlag)
			return;
		if (!cHUDManager.m_bActivateAllowed)
			return;
		
        super.Activate();   
    }
    
    
    void DrawDoUnderCursor()
    {
        for ( int i=0; i<m_nVisibleBases; i++ )
        {
            HudNetMapSpriteAssault cSpriteBase = m_aBases[i];
            if ( cSpriteBase == null )
                continue;
            if ( cSpriteBase.CanBeVisible() )
            {
                cSpriteBase.MoveTop();
                cSpriteBase.Show();
            }
            else
                cSpriteBase.Hide();
        }
        
        super.DrawDoUnderCursor();
    }
    
    public void HideAll()
	{
        super.HideAll();
        
        HideRemainingBases( 0 );
    }
        
    //TODO: tak naprawde pozycji nie trzeba aktualizowac tylko tryb
    void ComputeBasesPos()
    {
        int nBaseSpriteIndex = 0;
        
        if ( m_cGameInfoASSAULT == null )
        {
            HideRemainingBases( nBaseSpriteIndex );
            return;
        }
        
        for ( int i=0; i<m_cGameInfoASSAULT.GetASSAULTBaseCnt() && nBaseSpriteIndex < m_aBases.length; i++ )
        {
            ASSAULTDestroyable cBase = m_cGameInfoASSAULT.GetASSAULTBase( i ); 
            if ( cBase == null )
                continue;
                                    
            HudNetMapSpriteAssault cBaseSprite = m_aBases[ nBaseSpriteIndex ];
            cBaseSprite.SetMode( cBase.IsAlive() ? 
                                 HudNetMapSpriteAssault._MODE_ALIVE :
                                 HudNetMapSpriteAssault._MODE_DEAD );
            
            ComputeSpritePos( cBaseSprite, cBase.GetPosition() );
            
            cBaseSprite.Show();
            
            nBaseSpriteIndex++;
        }
                
        HideRemainingBases( nBaseSpriteIndex );
    }
    
    int m_nVisibleBases = 0;
    
    void HideRemainingBases( int nVisibleBases )
    {
        m_nVisibleBases = nVisibleBases;
        
        for ( int i=nVisibleBases; i<m_aBases.length; i++ )
        {
            HudNetMapSpriteAssault cBaseSprite = m_aBases[i];
            if ( cBaseSprite == null )
                continue;
            
            cBaseSprite.SetMode( HudNetMapSpritePlayer._MODE_UNKNOWN );
            cBaseSprite.Hide();
        }
    }
}

