public class ModuleNetBase extends ChromeModule
{
    /** Informacje o inicjalizacji gry
     */
    NetGameInitInfo m_cNetGameInitInfo = null;
    NetGameInitInfo GetGameInitInfo(){ return m_cNetGameInitInfo; }
    
    /** Obiekt trzymajacy informacje o grze. Poprzez ten obiekt odbywa sie cala komunikacja
     * miedzy klientami a serwerem dotyczaca informacji o grze takich jak: przylaczanie graczy,
     * odlaczanie graczy, zdobywanie fragow itp. itd.
     */
    NetGameInfo m_cGameInfo = null;
    void        SetGameInfo(NetGameInfo cGameInfo){ m_cGameInfo = cGameInfo; }
    NetGameInfo GetGameInfo(){ return m_cGameInfo;}
    
    /**CLIENT Gracz bedacy wlascicielem tego clienta.
     */
    protected   PlayerNet m_cMainPlayerNet = null;
    void        SetMainPlayerNet(PlayerNet cPlayer){   m_cMainPlayerNet = cPlayer; }
    PlayerNet   GetMainPlayerNet()                 {   return m_cMainPlayerNet;    }
    Player      GetMainPlayer()                    {   return m_cMainPlayerNet;    }
    
    
    /**SERVER Menadzer graczy na levelu po stronie servera
     */
    PlayerNetManager m_cPlayerManager = null;
    PlayerNetManager GetPlayerManager() { return m_cPlayerManager; }
    
    
    private
    NetObjectsManager m_cObjectsManager = null;
    NetObjectsManager GetObjectsManager(){ return m_cObjectsManager; }

    private
    boolean m_bAmIDedicatedServer = false;
    boolean AmIDedicatedServer(){ return m_bAmIDedicatedServer; }
    
    /** System spawnpointow
     */
    NetSpawnPointManager m_cSpawnPointManager = null;

    //tu bedziemy pamietac czy mamy aktualnie na ekranie 
    //inwentory menu, czy nie
    private 
    boolean m_bInventoryMenuActive = false;                                  
    boolean IsActiveInventoryMenu() { return m_bInventoryMenuActive; }
    
    
    /** Kamera do fruwania
     */
    FreeCamera m_cFreeCam = null;
    FreeCamera GetFreeCam() { return m_cFreeCam; }
    
    /** Kamera do smierci playera
     */
    CameraMovie m_cPlayerDeathCam = null;
    
    /**
     * Lista pojazdow na levelu
     */
    java.util.Vector m_aVehiclesOnLevel = new java.util.Vector(0,8);
    
    int GetVehiclesCnt() { return m_aVehiclesOnLevel.size(); }
    
    java.util.Vector GetVehicles() { return m_aVehiclesOnLevel; }
    
    /** Lista z informacjami o obiektach do automatycznego wyspawnowania
     * 
     */
    //InvObjecty beda spawnowane po jakims czasie od zebrania z ziemi
    java.util.Vector m_aInvObjectsToAutoRespawn = new java.util.Vector(0,8);
    //Vehicle beda spawnowane po jakims czasie od zepsucia
    java.util.Vector m_aVehiclesToAutoRespawn = new java.util.Vector(0,8);
    //Vehicle beda tez chowane po jakims czasie od wyjscia z niego pasazerow
    java.util.Vector m_aVehiclesToAutoHide = new java.util.Vector(0,8);
    
    /** Lista z informacjami o obiektach do wyspawnowania
     * podczas restartu levelu
     */
    //obiekty inwentory beda sie kasowaly i spawnowaly nowe obiekty
    java.util.Vector m_aInvObjectsToRespawnOnRestart = new java.util.Vector(0,8);
    //pojazdy beda caly czas te same, beda tylko "powracac" na odpowiednie miejsce
    java.util.Vector m_aVehiclesToRespawnOnRestart = new java.util.Vector(0,8);

    /**pobranie LevelsManagera*/
    LevelsManager GetLevelManager()
    {
        if ( cGameInitInfo != null )
            return cGameInitInfo.cLevels;
        return null;
    }
    
    /**pobranie LevelContent biezacego levelu*/ 
    LevelContent GetCurrentLevelContent()
    {
        LevelsManager cLevelManager = GetLevelManager();
        if ( cLevelManager != null )
            return cLevelManager.GetCurrent();
        return null;
    }
        
    int METHOD_CheckObjectsToAutoRespawnOrHide = 0;

    ModuleNetBase()
    {
        // ta rola to taki myk, zeby wiedziec na hostcie czy jest sie klientem czy serwerem
        Role=ERole._PROXY;
        
        sInventoryMenuName = "MenuNetInventoryRoom";
    }
    
    public boolean IsNetModule()    {   return true;  }
    
    
    static String PROF_RESTARTROUND_TAB = "NetRestartRound";
    
    int PROFILE_RestartLevel                = 0;
    int PROFILE_DelInvObjects               = 0;
    int PROFILE_DelBullets                  = 0;
    int PROFILE_RespawnInvObjects           = 0;
    int PROFILE_RespawnVehicles             = 0;
    int PROFILE_ClearInvObjectsToAutoRespawn= 0;
    
    void OnCreate()
    {
        METHOD_CheckObjectsToAutoRespawnOrHide = RegisterCallMethod("CheckObjectsToAutoRespawnOrHide");
        
        super.OnCreate();

        PROFILE_RestartLevel        = ProfileAdd(PROF_RESTARTROUND_TAB, "  RestartLevel");
        PROFILE_DelInvObjects       = ProfileAdd(PROF_RESTARTROUND_TAB, "   DelInvObjects");
        PROFILE_DelBullets          = ProfileAdd(PROF_RESTARTROUND_TAB, "   DelBullets");
        PROFILE_RespawnInvObjects   = ProfileAdd(PROF_RESTARTROUND_TAB, "   RespawnInvObjects");
        PROFILE_RespawnVehicles     = ProfileAdd(PROF_RESTARTROUND_TAB, "   RespawnVehicles");
        PROFILE_ClearInvObjectsToAutoRespawn = ProfileAdd(PROF_RESTARTROUND_TAB, "   ClearInvObjectsToAutoRespawn");
            
        NetPlayerProfile.LoadCurrentControlsAndApply();

        //TODO: dorobic wylaczanie tego cuda...
        SetMaxTimerUpdate(10000000);
        
        //sami bedziemy decydowali co mamy zrobic z portalami
        bPlayerStartInside = false;
        
        // tworzymy system SpawnPointow na levelu
        m_cSpawnPointManager = new NetSpawnPointManager( this );
                        
        // inicjalizacja kamery dla niezywego gracza, przeniesc do playera
        m_cPlayerDeathCam = (CameraMovie)CreateObject("CameraMovie");
        
        // inicjalizacja free kamery (sterowanie myszka + 5,1,2,3 NumPad)
        m_cFreeCam = (FreeCamera)CreateObject("FreeCamera");
        SetViewFullscreen( m_cFreeCam );
            
        // ustawiamy kamere tak, zeby patrzyla z rogu mapy do jej srodka
        m_cFreeCam.FromForwardUpPos( new Vector(-100.0f, 0.0f, -100.0f), 
                                         Vector.Up, 
                                     new Vector(-300.0f, 300.0f, -300.0f) );
        /*GameObject[] aCameras = GetObjectsOfClass("NetJoinCameraDummy");
        NetJoinCameraDummy cJoinCamera =  aCameras != null && aCameras.length > 0 ?
                                          (NetJoinCameraDummy)aCameras[ 0 ]: null;*/
        NetSpawnPoint cJoinCameraPositioner = GetJoinPoint();
        if ( cJoinCameraPositioner != null )
        {
            Vector vPos = cJoinCameraPositioner.GetPosition();
            Vector vDir = cJoinCameraPositioner.GetForwardVector();
            vPos.fY += 120.0f;
            vDir.Negate();
            m_cFreeCam.FromForwardUpPos( vDir, Vector.Up, vPos );
            SetView( m_cFreeCam, cJoinCameraPositioner.IsInside() );
        }
    }
    
    boolean m_bNetInitialized = false;
    /**Inicjalizacja gry na podstawie informacji z GameInfo
     */
    void InitNetwork()
    {
        LogD("InitNetwork()\n");
        if ( cGameInitInfo instanceof NetGameInitInfo)
            m_cNetGameInitInfo = (NetGameInitInfo)cGameInitInfo;
        else
        {
            CrashLog("[ModuleNet.Init] Wrong gameinfo type - not network game\n");
            return;
        }
        
        LogD("Role "+ Role +
             " nGameType:"+GetGameInitInfo().nGameType+"\n");
        
        //SERVER
        if (Role == ERole._AUTHORITY)
        {
            // tworzymy gameinfo
            int        nGameType  = GetGameInitInfo().nGameType;
            String     sClassName = ENetGameType.GetGameInfoClassName( nGameType );
            GameObject cGameInfo  = CreateObject( sClassName );
            if ( cGameInfo instanceof NetGameInfo )
            {
                //jesli wszystko ok, to sobie je zapamietujemy
                m_cGameInfo           = (NetGameInfo)cGameInfo;
                // ponadto sprawdzamy czy "siedzimy" na dedykowanym serwerze
                m_bAmIDedicatedServer = (! m_cGameInfo.IsPlayerOnServer());
            }
            else
            {
                CrashLog(" Obiekt GameInfo: "+cGameInfo+
                         " dla ModuleNet "+this+
                         " nie zostal stworzony poprawnie!\n");
                return;
            }
            
            LogD(" "+m_cGameInfo+" created\n");
            
            // tworzymy liste graczy
            int nMaxPlayers = GetGameInitInfo().GetServerInfo().GetMaxPlayers();
            m_cPlayerManager = new PlayerNetManager( nMaxPlayers );
            
            m_cObjectsManager = (NetObjectsManager)CreateObject("NetObjectsManager");
         
            InitRespawnSystem();
            EnableOrDisableVehicles();
            
            SetServerState( EServerState.PLAYING, 
                            GetGameInitInfo().GetCurrentLevelName() );
        }
        else
        {
            InitRespawnSystem();
        }
        m_bNetInitialized = true;
        Log("NetworkInitialized\n");        
    }


    /**
     * Metoda na podstawie ustawien z gry uaktywnia albo 
     * deaktywuje pojazdy w grze
     * 
     * Uwaga: na razie rezygnuje z tej metody
     */
    void EnableOrDisableVehicles()
    {
        /*boolean bEnable = GetGameInfo().GetGameSettings().GetAvailableVehicles();
            
        GameObject []aVehicles = GetObjectsFromClass("Vehicle");
        for (int i=0; i<aVehicles.length; i++)
        {
            Vehicle cVehicle = (Vehicle)aVehicles[i];
            
            if ( cVehicle != null )
            {
                if ( bEnable )
                    cVehicle.Enable();
                else
                    cVehicle.Disable();
            }
        }*/
    }
    
    public void OnDestroy()
    {
        if ( m_cSpawnPointManager != null )
        {
            m_cSpawnPointManager.Destroy();
            m_cSpawnPointManager = null;
        }
            
        // na serwerze zamykamy caly burdel !
        if (Role == ERole._AUTHORITY)
        {
            SetServerState(EServerState.DESTROYING, GetGameInitInfo().GetCurrentLevelName());
            
            if ( m_cGameInfo != null )
            {
                m_cGameInfo.delete();
                m_cGameInfo = null;
            }
            
            if ( m_cPlayerManager != null )
            {
                m_cPlayerManager.Destroy();
                m_cPlayerManager = null;
            }
            
            if ( m_cObjectsManager != null )
            {
                m_cObjectsManager.delete();
                m_cObjectsManager = null;
            }
        }
        
        if ( m_cFreeCam != null )
        {
            m_cFreeCam.delete();
            m_cFreeCam=null;
        }
        
        if ( m_cPlayerDeathCam != null )
        {
            m_cPlayerDeathCam.delete();
            m_cPlayerDeathCam = null;
        }
        
        super.OnDestroy();
    }
        
    /**
     * 
     * Spawn pointy
     * 
     */
    
    /**Zwraca losowo wybrany punkt spawnowania
     */
    NetSpawnPoint GetRandomSpawnPoint(PlayerNet cPlayer)
    {
        return m_cSpawnPointManager.GetRandomSpawnPoint( cPlayer );
    }
    
    /**Zwraza losowo wybrany punkt spawnowania
     */
    NetSpawnPoint GetJoinPoint()
    {
        return m_cSpawnPointManager.GetJoinPoint();
    }
    
    /**
     * 
     * Inwentory menu
     * 
     */

    /** 
     * Wolane z gracza do wlaczenia inwentory menu
     * Gracz wczesniej chowa wszystkie niepotrzebne hudy,
     * tu tylko jest wyswietlenie inventory menu
     */
    void SetInventoryMenu()
    {
        super.SetInventoryMenu();
        
        m_bInventoryMenuActive = true;
    }
    
    /** 
     * Wolane z inwentory menu celem jego schowania
     */
    void RestoreAfterInventoryMenu()
    {
        // odkladamy to troszke na pozniej, bo inaczej sie wywali...
        CallMethodIn( "RestoreAfterInventoryMenuDo", 0f );
    }
     
    /**
     * Faktyczna metoda wykonawcza chowajaca inwentory menu
     */
    void RestoreAfterInventoryMenuDo()
    {
        DisableCallMethod( "RestoreAfterInventoryMenuDo" );
        
        if ( m_InventoryWindow != null )
        {
            m_InventoryWindow.Hide();
            /*RemoveSprite( m_InventoryWindow );
            m_InventoryWindow.delete();
            m_InventoryWindow = null;*/
        }
        
        if ( cCursor != null )
             cCursor.Hide();
        
        m_bInventoryMenuActive = false;
    }
  
    /**
     * 
     * System do spawnowania obiektow
     * 
     * TODO: Zrobic osobna klase - managera respawnow
     * 
     */
    
    void InitRespawnSystem()
    {
        GameObject []aInvObjects = GetObjectsFromClass("InvObject");
        for (int i=0; i<aInvObjects.length; i++)
        {
            InvObject cInvObject = (InvObject)aInvObjects[i];
            NetLog.RespawnObj("Found "+cInvObject.GetNetInfo());
            if ( cInvObject.RespawnOnLevelRestartEnabled() )
            {
                NetLog.RespawnObj("ADD on restart "+cInvObject.GetNetInfo()+
                                  " RespawnCnt "+cInvObject.m_nAutoRespawnCnt+ 
                                  " RespawnTime "+cInvObject.m_fAutoRespawnTime);
                cInvObject.EnableDeleteOnLevelRestart();
                cInvObject.EnableAutoRespawn();
                AddInvObjectToRespawnOnRestart( cInvObject );    
            }
        }
        
        GameObject []aVehicles = GetObjectsFromClass("Vehicle");
        for (int i=0; i<aVehicles.length; i++)
        {
            Vehicle cVehicle = (Vehicle)aVehicles[i];
            
            if ( cVehicle != null )
            {
                
                m_aVehiclesOnLevel.addElement( cVehicle );
                //TODO: jakies dodatkowe warunki?            
                AddVehicleToRespawnOnRestart( cVehicle );    
                cVehicle.Enable();
                //cVehicle.Disable();
                AddToBarrierSystem( cVehicle );
            }
        }
    }

    /** Co jaki czas bedzie przegladana lista z obiektami do wyspawnowania
     */
    static float _OBJECTS_AUTO_RESPAWN_CHECK_TIME = 5.0f;
    
    void AddInvObjectToAutoRespawn( InvObject cInvObj )
    {
        if ( Role != ERole._AUTHORITY )
            return;
        
        if ( m_aInvObjectsToAutoRespawn == null )
        {
            CrashLog("ERROR: Lista obiektow Inventory do wyspawnowania == NULL!\n");
            return;
        }
        
        NetLog.RespawnObj("Try to ADD to auto respawn "+cInvObj.GetNetInfo());
        
        if ( cInvObj != null && cInvObj.AutoRespawnEnabled() )
        {
            NetLog.RespawnObj("ADD to auto respawn "+cInvObj.GetNetInfo()+
                                  " RespawnCnt "+cInvObj.m_nAutoRespawnCnt+ 
                                  " RespawnTime "+cInvObj.m_fAutoRespawnTime);
            //pobieramy informacje o obiekcie
            InvObjectAutoSpawnInfo cSpawnInfo = 
                new InvObjectAutoSpawnInfo( this, cInvObj );
            //wpisujemy je na liscte
            m_aInvObjectsToAutoRespawn.addElement( cSpawnInfo );
            //zaplanujmy sprawdzanie tej listy
            StartCheckObjectsToAutoRespawnOrHide();
            //a temu obiektowi juz nie kazmy sie wiecej spawnowac
            cInvObj.DisableAutoRespawn();
        }
    }
    
    void CheckAddVehicleToAutoRespawn( Vehicle cVehicle, boolean bNow )
    {
        if ( Role != ERole._AUTHORITY )
            return;
        if ( cVehicle == null )
            return;
        if ( m_cGameInfo == null || m_cGameInfo.GetGameSettings() == null )
            return;

        //sprawdzmy czy czasem nie jest juz zaplanowane wyspawnowanie tego pojazdu
        if ( FindVehicleSpawnInfo( cVehicle, m_aVehiclesToAutoRespawn ) != null )
            return;
        
        //sprawdzmy czy nie skonczyl sie juz czasem limit spawnow
        int nRespawnLimit = m_cGameInfo.GetGameSettings().GetVehicleRespawnCntLimit();
        if (( nRespawnLimit > -1 ) && nRespawnLimit <= cVehicle.GetRespawnCnt() )
            return;
        
        //no to pobiezmy opoznienie
        float fRespawnDelay = m_cGameInfo.GetGameSettings().GetVehicleMinRespawnTime();
        //pomniejszmy to opoznienie o czas samego cyklu spawnowania
        fRespawnDelay -= Vehicle.GetSpawnDelayTime();
        if ( bNow )
            fRespawnDelay = 0.0f;
        //i heja...
        AddVehicleToAutoRespawn( cVehicle, GetTime() + fRespawnDelay );
    }
    
    
    private void AddVehicleToAutoRespawn( Vehicle cVehicle, float fTime )
    {
        if ( Role != ERole._AUTHORITY )
            return;
        
        if ( m_aVehiclesToAutoRespawn == null )
        {
            CrashLog("ERROR: Lista obiektow Vehicle do wyspawnowania == NULL!\n");
            return;
        }
        
        if ( cVehicle != null )
        {
            //musimy sprawdzic gdzie powinien sie pojazd wyspawnowac
            //w przyszlosci bedziemy mogli od razu go przeniesc
            //na nowe miejsce (jak beda wraki)
            //teraz poprostu poszukam informacji w liscie
            SpawnInfo cStartSpawnInfo = FindVehicleSpawnInfo( cVehicle, m_aVehiclesToRespawnOnRestart );
            if ( cStartSpawnInfo == null )
                return;
            
            //pobieramy informacje o obiekcie
            VehicleAutoSpawnInfo cSpawnInfo = 
                new VehicleAutoSpawnInfo( cVehicle, cStartSpawnInfo, fTime );
            
            //wpisujemy je na liscte
            m_aVehiclesToAutoRespawn.addElement( cSpawnInfo );
            //zaplanujmy sprawdzanie tej listy
            StartCheckObjectsToAutoRespawnOrHide();
            //a temu obiektowi juz nie kazmy sie wiecej spawnowac
            //cVehicle.DisableAutoRespawn();
        }
    }
    
    void CheckAddVehicleToAutoHide( Vehicle cVehicle )
    {
        if ( Role != ERole._AUTHORITY )
            return;
        if ( cVehicle == null )
            return;
        if ( m_cGameInfo == null || m_cGameInfo.GetGameSettings() == null )
            return;

        //sprawdzmy czy w ogole mamy zaplanowane automatyczne powroty
        float fHideTime = m_cGameInfo.GetGameSettings().GetVehicleAutoReturnTime();
        //jesli nie to nic wiecej nie robimy
        if ( fHideTime < 0.0f )
            return;
        
        //sprawdzmy czy czasem nie jest juz zaplanowane wyspawnowanie tego pojazdu
        if ( FindVehicleSpawnInfo( cVehicle, m_aVehiclesToAutoHide ) != null )
            return;
        
        RemoveVehicleFromAutoHide( cVehicle );
                
        //TODO: co z limitem spawnow? czy takie znikniecie (a pozniej spawn)
        //powinny byc postrzegane jako kolejny prawdziwy spawn?
        //A moze tu odjac 1 od liczby spawnow, zeby nie wykorzystac limitu?
        /*
        //sprawdzmy czy nie skonczyl sie juz czasem limit spawnow
        int nRespawnLimit = m_cGameInfo.GetGameSettings().GetVehicleRespawnCntLimit();
        if (( nRespawnLimit > -1 ) && nRespawnLimit <= cVehicle.GetRespawnCnt() )
            return;
        */
                
        //pomniejszmy czas opoznienie o czas samego cyklu chowania
        fHideTime -= Vehicle.GetHideDelayTime();
        //i heja...
        AddVehicleToAutoHide( cVehicle, GetTime() + fHideTime );
    }
    
    private void AddVehicleToAutoHide( Vehicle cVehicle, float fTime )
    {
        if ( Role != ERole._AUTHORITY )
            return;
        
        if ( m_aVehiclesToAutoHide == null )
        {
            CrashLog("ERROR: Lista obiektow Vehicle do schowania == NULL!\n");
            return;
        }
        
        if ( cVehicle != null )
        {
            //musimy sprawdzic gdzie powinien sie pojazd wyspawnowac
            //w przyszlosci bedziemy mogli od razu go przeniesc
            //na nowe miejsce (jak beda wraki)
            //teraz poprostu poszukam informacji w liscie
            //TODO: wywalic to
            SpawnInfo cStartSpawnInfo = FindVehicleSpawnInfo( cVehicle, m_aVehiclesToRespawnOnRestart );
            if ( cStartSpawnInfo == null )
                return;
            
            //pobieramy informacje o obiekcie
            VehicleAutoSpawnInfo cSpawnInfo = 
                new VehicleAutoSpawnInfo( cVehicle, cStartSpawnInfo, fTime );
            
            //wpisujemy je na liscte
            m_aVehiclesToAutoHide.addElement( cSpawnInfo );
            //zaplanujmy sprawdzanie tej listy
            StartCheckObjectsToAutoRespawnOrHide();
        }
    }
    
    void RemoveVehicleFromAutoHide(Vehicle cVehicle)
    {
         VehicleSpawnInfo cInfo = FindVehicleSpawnInfo( cVehicle, m_aVehiclesToAutoHide );
         if ( cInfo != null )
            m_aVehiclesToAutoHide.removeElement( cInfo );
    }
    
    void StartCheckObjectsToAutoRespawnOrHide()
    {
        DisableCallMethod( METHOD_CheckObjectsToAutoRespawnOrHide );
        CallMethodEvery( METHOD_CheckObjectsToAutoRespawnOrHide, _OBJECTS_AUTO_RESPAWN_CHECK_TIME );
        CheckObjectsToAutoRespawnOrHide();
    }
    
    void CheckObjectsToAutoRespawnOrHide()
    {
        if ( (m_aInvObjectsToAutoRespawn == null) ||
             (m_aVehiclesToAutoRespawn   == null) ||
             (m_aVehiclesToAutoHide      == null) )
        {
            CrashLog("ERROR: CheckObjectsToAutoRespawnOrHide()\n");
            return;
        }
            
        float fTime = GetTime();
        for ( int i=0; i<m_aInvObjectsToAutoRespawn.size(); i++ )
        {
            if ( !(m_aInvObjectsToAutoRespawn.elementAt( i ) instanceof InvObjectAutoSpawnInfo) )
                continue;
                
            InvObjectAutoSpawnInfo cSpawnInfo = 
                (InvObjectAutoSpawnInfo)m_aInvObjectsToAutoRespawn.elementAt( i );
            
            if ( cSpawnInfo.m_fTime <= fTime )
            {
                ServerRespawnInvObject( cSpawnInfo );
                
                m_aInvObjectsToAutoRespawn.removeElement( cSpawnInfo );
                i--;
            }
        }
        for ( int i=0; i<m_aVehiclesToAutoRespawn.size(); i++ )
        {
            if ( !(m_aVehiclesToAutoRespawn.elementAt( i ) instanceof VehicleAutoSpawnInfo) )
                continue;
                
            VehicleAutoSpawnInfo cSpawnInfo = 
                (VehicleAutoSpawnInfo)m_aVehiclesToAutoRespawn.elementAt( i );
            
            if ( cSpawnInfo.m_fTime <= fTime )
            {
                ServerRespawnVehicle( cSpawnInfo, false );
                
                m_aVehiclesToAutoRespawn.removeElement( cSpawnInfo );
                i--;
                                
                RemoveVehicleFromAutoHide( cSpawnInfo.m_cVehicle );
            }
        }
        for ( int i=0; i<m_aVehiclesToAutoHide.size(); i++ )
        {
            if ( !(m_aVehiclesToAutoHide.elementAt( i ) instanceof VehicleAutoSpawnInfo) )
                continue;
                
            VehicleAutoSpawnInfo cSpawnInfo = 
                (VehicleAutoSpawnInfo)m_aVehiclesToAutoHide.elementAt( i );
            
            if ( cSpawnInfo.m_fTime <= fTime )
            {
                ServerHideVehicle( cSpawnInfo );
                
                m_aVehiclesToAutoHide.removeElement( cSpawnInfo );
                i--;
            }
        }
        
        if ( m_aInvObjectsToAutoRespawn.size() +  
             m_aVehiclesToAutoRespawn.size()   +
             m_aVehiclesToAutoHide.size()        <= 0 )
        {
            DisableCallMethod( METHOD_CheckObjectsToAutoRespawnOrHide );
        }
    }
            
    void ServerRespawnInvObject( InvObjectSpawnInfo cSpawnInfo )
    {
        GameObject obj = CreateObject( cSpawnInfo.m_nClassId );
        if ( obj instanceof InvObject )
        {
            InvObject cInvObj = ((InvObject)obj);
            //respawnujemy obiekt
            cInvObj.ServerRespawn( cSpawnInfo ,0.4f );
            cInvObj.RespawnedOnLevel();
            NetLog.RespawnObj(" Respawn "+cInvObj.GetNetInfo()+
                              " RespawnCnt "+cInvObj.m_nAutoRespawnCnt+ 
                              " RespawnTime "+cInvObj.m_fAutoRespawnTime);
            
            //podpiac jakis dzwiek i FX
            ServerRespawnFX( cSpawnInfo.m_vPos, _FX_RESPAWN_INVOBJ );
        }
    }
    
    void ServerRespawnVehicle( VehicleSpawnInfo cSpawnInfo, 
                               boolean          bOnRestartLevel )
    {
        Vehicle cVehicle = cSpawnInfo.m_cVehicle;
        
        //respawnujemy obiekt
        cVehicle.ServerRespawn( cSpawnInfo , 
                                Vehicle.GetSpawnDelayTime(), 
                                bOnRestartLevel );
        cVehicle.RespawnedOnLevel();
        
        if ( bOnRestartLevel )
            cVehicle.ResetRespawnCnt();
        else
            ServerRespawnFX( cSpawnInfo.m_vPos, _FX_RESPAWN_VEHICLE );
    }
    
    void ServerHideVehicle( VehicleSpawnInfo cSpawnInfo )
    {
        Vehicle cVehicle = cSpawnInfo.m_cVehicle;
        Vector  vPos     = cVehicle.GetPosition();
        //chowamy obiekt po odpowiednim czasie
        cVehicle.ServerHide( Vehicle.GetHideDelayTime() );
                
        ServerRespawnFX( vPos, _FX_RESPAWN_VEHICLE );
    }
    
    final static byte _FX_RESPAWN_PLAYER  = 0,
                      _FX_RESPAWN_INVOBJ  = 1,
                      _FX_RESPAWN_VEHICLE = 2,
                      _FX_HIDE_VEHICLE    = 3;

    static String[] sm_aFxRespawn = {"FXRespawnPlayer",   //_FX_RESPAWN_PLAYER
                                     "FXRespawnInvObj",   //_FX_RESPAWN_INVOBJ
                                     "FXRespawnVehicle",  //_FX_RESPAWN_VEHICLE
                                     "FXHideVehicle"};    //_FX_HIDE_VEHICLE
    
    //Uwaga: dzwiek do respawn i hide taki sam
    static String[] sm_aSoundRespawn = {"Data/Sounds/Net/Respawn/Player",   //_FX_RESPAWN_PLAYER
                                        "Data/Sounds/Net/Respawn/InvObj",   //_FX_RESPAWN_INVOBJ
                                        "Data/Sounds/Net/Respawn/Vehicle",  //_FX_RESPAWN_VEHICLE
                                        "Data/Sounds/Net/Respawn/Vehicle"}; //_FX_HIDE_VEHICLE
    
    void ServerRespawnFX(Vector vPos,byte nFx)
    {
        if ( Role == ERole._AUTHORITY )
        {
            if ( m_cGameInfo != null )
                m_cGameInfo.MsgSendClientFXRespawnOnLevel( vPos, nFx );
            RespawnFX( vPos, nFx );
        }
    }
    
    void RespawnFX(Vector vPos,byte nFx)
    {
        if ( sm_aFxRespawn != null && 
             nFx < sm_aFxRespawn.length &&
             sm_aFxRespawn[ nFx ] != null )
        {
            ExecuteFX( sm_aFxRespawn[ nFx ] , vPos );
        }

        if ( sm_aSoundRespawn != null && 
             nFx < sm_aSoundRespawn.length &&
             sm_aSoundRespawn[ nFx ] != null )
        {
            PlaySound( sm_aSoundRespawn[ nFx ] , vPos );
        }
    }
    
 
    void AddInvObjectToRespawnOnRestart( InvObject cInvObj )
    {
        if ( Role != ERole._AUTHORITY )
            return;
        
        if ( cInvObj == null )
            return;
        
        InvObjectSpawnInfo cSpawnInfo = new InvObjectSpawnInfo( this, cInvObj );
                        
        if ( m_aInvObjectsToRespawnOnRestart != null )
            m_aInvObjectsToRespawnOnRestart.addElement( cSpawnInfo );
        else
            CrashLog("ERROR: Lista obiektow Inventory do wyspawnowania == NULL!\n");
    }
    
    void AddVehicleToRespawnOnRestart( Vehicle cVehicle )
    {
        if ( Role != ERole._AUTHORITY )
            return;
        
        if ( cVehicle == null )
            return;
        
        VehicleSpawnInfo cSpawnInfo = new VehicleSpawnInfo( cVehicle );
                        
        if ( m_aVehiclesToRespawnOnRestart != null )
            m_aVehiclesToRespawnOnRestart.addElement( cSpawnInfo );
        else
            CrashLog("ERROR: Lista obiektow Vehicle do wyspawnowania == NULL!\n");
    }
    
    void ServerRestartLevel()
    {
        NetLog.RespawnObj("--------------------- ServerRestartLevel() -------------------- \n");
            
        ProfileBegin( PROFILE_RestartLevel );
        
        ProfileBegin( PROFILE_DelInvObjects );
        //kasujemy wszystkie "luzne" invobjecty na levelu
        GameObject []aInvObjects = GetObjectsFromClass("InvObject");
        for (int i=0; i<aInvObjects.length; i++)
        {
            InvObject cInvObject = (InvObject)aInvObjects[i];
            
            //ten juz jest pewnie do inwentory do nastepnego respawnu
            if ( cInvObject.GetInventory() != null )
                continue;
            
            if ( cInvObject.DeleteOnLevelRestartEnabled() )
            {
                if ( (GetObjectsManager() != null) && ModuleNet.IsGameGoing() )
                    GetObjectsManager().DeleteObject( cInvObject );
                else
                    cInvObject.delete();
            }
        }
        NetLog.Profile(" -DelInvObjects ("+aInvObjects.length+") "+ProfileEnd( PROFILE_DelInvObjects ));
                
        ProfileBegin( PROFILE_DelBullets );
        //trzeba tez pokasowac wszystkie lecace Bullety (granaty, rakiety)
        GameObject []aBullets = GetObjectsFromClass("Bullet");
        for (int i=0; i<aBullets.length; i++)
        {
            Bullet cBullet = (Bullet)aBullets[i];
            
            if ( cBullet.IsStarted() )
                 cBullet.delete();
        }
        NetLog.Profile(" -DelBullets "+ProfileEnd(PROFILE_DelBullets));
        
        ProfileBegin( PROFILE_ClearInvObjectsToAutoRespawn );
        //zapominamy o zaplanowanych obiektach do wyspawnowania lub schowania
        m_aInvObjectsToAutoRespawn.removeAllElements();
        m_aVehiclesToAutoRespawn.removeAllElements();
        m_aVehiclesToAutoHide.removeAllElements();
        DisableCallMethod( METHOD_CheckObjectsToAutoRespawnOrHide );
        
        NetLog.Profile(" -ClearInvObjectsToAutoRespawn "+ProfileEnd(PROFILE_ClearInvObjectsToAutoRespawn));
        
        //jesli to koniec gry to wychodzimy
        if ( ! ModuleNet.IsGameGoing() )
            return;
        
        ProfileBegin( PROFILE_RespawnInvObjects );
        
        //spawnujemy wszystkie obiekty, ktore byly domyslnie na levelu        
        if ( m_aInvObjectsToRespawnOnRestart != null )
        {
            for ( int i=0; i<m_aInvObjectsToRespawnOnRestart.size(); i++ )
            {
                if ( m_aInvObjectsToRespawnOnRestart.elementAt( i ) instanceof InvObjectSpawnInfo )
                {                    
                    InvObjectSpawnInfo cSpawnInfo = 
                        (InvObjectSpawnInfo)m_aInvObjectsToRespawnOnRestart.elementAt( i );
                
                    ServerRespawnInvObject( cSpawnInfo );
                }
            }
        }
        
        NetLog.Profile(" -RespawnInvObjects "+ProfileEnd(PROFILE_RespawnInvObjects));
        
        ProfileBegin( PROFILE_RespawnVehicles );
        
        if ( m_aVehiclesToRespawnOnRestart != null &&
             m_cGameInfo                   != null &&
             m_cGameInfo.GetGameSettings() != null /*&&
             m_cGameInfo.GetGameSettings().GetAvailableVehicles()*/ )
        {
            for ( int i=0; i<m_aVehiclesToRespawnOnRestart.size(); i++ )
            {
                if ( m_aVehiclesToRespawnOnRestart.elementAt( i ) instanceof VehicleSpawnInfo )
                {                    
                    VehicleSpawnInfo cSpawnInfo = 
                        (VehicleSpawnInfo)m_aVehiclesToRespawnOnRestart.elementAt( i );
                    
                    ServerRespawnVehicle( cSpawnInfo, true );
                }
            }
        }
        NetLog.Profile(" -RespawnVehicles "+ProfileEnd(PROFILE_RespawnVehicles));
        
        NetLog.Profile("-RestartLevel "+ProfileEnd(PROFILE_RestartLevel));
    
        NetLog.RespawnObj("--------------------- ServerRestartLevel() END ---------------- \n");
    }
    
    VehicleSpawnInfo FindVehicleSpawnInfo(Vehicle cVehicle, java.util.Vector aList )
    {
        if ( aList == null )
            return null;
        
        for ( int i=0; i<aList.size(); i++ )
        {
            if ( aList.elementAt( i ) instanceof VehicleSpawnInfo )
            {                    
                VehicleSpawnInfo cSpawnInfo = (VehicleSpawnInfo)aList.elementAt( i );
                
                if ( cSpawnInfo.m_cVehicle == cVehicle )
                    return cSpawnInfo;
            }
        }
        return null;
    }
    
        
    /**
     * 
     * System widokow i kamer
     * 
     * TODO: przeniesc do osobnego managera
     * 
     */
    
    void SetView(Camera cCamera, boolean bPortalsActive )
    {
        if ( cCamera == null )
        {
            LogD("ERROR: Camera not found\n");
            Thread.dumpStack();
            return;
        }
        SetViewFullscreen( cCamera );
        PortalSystemActive( iViewID, bPortalsActive );
    }
        
    final static int _DEATH_CAMERA_MODE_NORMAL      = 0;
    final static int _DEATH_CAMERA_MODE_CHANGETEAM  = 1;
    final static int _DEATH_CAMERA_MODE_GAMEOVER    = 2;
    final static int _DEATH_CAMERA_MODE_GAMERESTART = 3;
    
    Player   m_cDeadPlayer = null;
    DeadBody m_cDeadBody   = null;
    
    void ActivatePlayerDeathCamera( PlayerNetBase cPlayer, int nMode )
    {
        LogD("\n");
        DisableCallMethod("ContinueMovePlayerDeathCamera");
        DisableCallMethod("StopMovePlayerDeathCamera");
        
        m_cDeadPlayer       = cPlayer;
        m_cDeadBody         = cPlayer.GetDeadBody();
        CameraMovie cCamera = m_cPlayerDeathCam;

        //ustawienie kamery
        /*
        {        
            Vector vPos = player.GetPosition();
            cCamera.NextTarget( player, player.GetElementID("Bip01 Head"),0);
            
            player.CameraModeChanged( CameraPlayer.CMODE_TPP );

            //vPos.Add(new Vector(100, 200,100));
            vPos.Add( vDeathCameraPos1 );
            cCamera.NextPosition(vPos, 0);

            //plynne przejscie do nowej pozycji 
            //vPos.Add(new Vector(0, 1000, 0));
            vPos.Add( vDeathCameraPos2 );
            cCamera.NextPosition(vPos, 8.5f);
        }*/
        
        Vector vPlayerPos = m_cDeadPlayer.GetPosition();
        Vector vPlayerDir = m_cDeadPlayer.GetForwardVector();
        
        Vector vTarget = new Vector( vPlayerDir );
        
        switch ( nMode )
        {
        case _DEATH_CAMERA_MODE_CHANGETEAM :
            vTarget.Mul( +10.0f );
            vTarget.Add( vPlayerPos );
            vTarget.fY += 10.0f;
            break;
        case _DEATH_CAMERA_MODE_GAMEOVER   :
        case _DEATH_CAMERA_MODE_GAMERESTART:
            vTarget.Mul( -500.0f );
            vTarget.Add( vPlayerPos );
            vTarget.fY += 100.0f;
            break;
        default:            
            vTarget.Mul( 500.0f );
            vTarget.Add( vPlayerPos );
            vTarget.fY += 30.0f;
        }
        
        cCamera.NextTarget( vTarget, 0.0f );
            
        m_cDeadPlayer.CameraModeChanged( CameraPlayer.CMODE_TPP );
        
        Vector vPos = new Vector( vPlayerPos );
        
        switch ( nMode )
        {
        case _DEATH_CAMERA_MODE_CHANGETEAM :
        case _DEATH_CAMERA_MODE_GAMEOVER   :
        case _DEATH_CAMERA_MODE_GAMERESTART:
            vPos.fY += 180.0f;
            Vector vMove = new Vector( vPlayerDir );
            vMove.Mul( 800.0f );
            vPos.Add( vMove );
            break;
        default:            
            vPos.fY += 180.0f;
        }
        
        
        cCamera.NextPosition( vPos, 0.0f );
        
        SetViewFullscreen( m_cPlayerDeathCam );
        
        switch ( nMode )
        {
        case _DEATH_CAMERA_MODE_CHANGETEAM :
        case _DEATH_CAMERA_MODE_GAMEOVER   :
        case _DEATH_CAMERA_MODE_GAMERESTART:
            //plynne przejscie do nowej pozycji 
            Vector vMove = new Vector( vPlayerDir );
            vMove.Mul( -300.0f );
            vPos.Add( vMove );
            //cCamera.NextPosition( vPos, 1.5f );
        
            m_vDeathCameraStartPos = new Vector(vPos);
            vPlayerDir.Mul( -200.0f );
            m_vDeathCameraStartPos.Add( vPlayerDir );
            //m_vDeathCameraStartPos.fY += 100.0f;
        
            m_vDeathCameraStartTarget = new Vector( vPlayerDir );
            m_vDeathCameraStartTarget.Mul( 10.0f );
            m_vDeathCameraStartTarget.Add( vPlayerPos );
        
            m_vDeathCameraStopPos     = new Vector(vPos);
            m_vDeathCameraStopPos.fY += 200.0f;
            break;
            
        default:
            //plynne przejscie do nowej pozycji 
            vPos.fY -= 150.0f;
            cCamera.NextPosition( vPos, 0.5f );
        
            m_vDeathCameraStartPos = new Vector(vPos);
            vPlayerDir.Mul( -200.0f );
            m_vDeathCameraStartPos.Add( vPlayerDir );
            //m_vDeathCameraStartPos.fY += 100.0f;
        
            m_vDeathCameraStartTarget = new Vector( vPlayerDir );
            m_vDeathCameraStartTarget.Mul( 10.0f );
            m_vDeathCameraStartTarget.Add( vPlayerPos );
        
            m_vDeathCameraStopPos     = new Vector(vPos);
            m_vDeathCameraStopPos.fY += 200.0f;
        }
        
        CallMethodIn("ContinueMovePlayerDeathCamera",2.5f);
    }
    
    Vector m_vDeathCameraStartPos = null;
    Vector m_vDeathCameraStopPos = null;
    Vector m_vDeathCameraStartTarget = null;
    
    void ContinueMovePlayerDeathCamera()
    {
        if ( m_cPlayerDeathCam == null )
            return;
        
        CameraMovie cCamera = m_cPlayerDeathCam;
        
        cCamera.NextPosition( m_vDeathCameraStartPos, 3.0f );
        
        //CallMethodIn("StopMovePlayerDeathCamera",2.9f);
    }
    
    void StopMovePlayerDeathCamera()
    {
        if ( m_cDeadBody       == null ||
             m_cPlayerDeathCam == null )
        {
            CrashLog("StopMovePlayerDeathCamera() m_cDeadBody "+m_cDeadBody+
                     " m_cPlayerDeathCam "+m_cPlayerDeathCam+"\n");
            return;
        }
             
        CameraMovie cCamera = m_cPlayerDeathCam;
        
        /*cCamera.NextTarget( m_cDeadBody, 
                            m_cDeadBody.GetElementID("Bip01 Head"), 1.0f );
        */
        cCamera.NextTarget( m_vDeathCameraStartTarget, 1.0f );
        
        cCamera.NextPosition( m_vDeathCameraStopPos, 7.0f );
    }

    /**
     * Powoduje dodania obiektu do interakcji z odpowiednimi barierami.
     * Metoda wolana dla:
     * - gracza po jego stworzeniu
     * - pojazdu po jego znalezieniu na levelu
     */
    void AddToBarrierSystem( ControlObject cObj )
    {
        if ( m_tBarriers == null )
            return;
        
        for ( int i=0; i<m_tBarriers.length; i++ )
        {
            if ( m_tBarriers[ i ] != null )
                 m_tBarriers[ i ].SetInteractionWithObject( cObj );
        }
    }
    
    //////////////////////////////////
    // do testow
    
    // TODO
    // wywalic w przyszlosci
    
    // czy maja byc aktywne boty
    boolean bBotsForTest = true;
    
    // identyfikator pierszego bota
    final static int sm_nBotsIdMin = 100000;
    
    static String sm_sPlayerNetBotClassName  =  "PlayerNetTestBot";
    static String sm_sPlayerNetAutoClassName =  "PlayerNetTestAuto";
 
    String GetSpecialTip(TriggerObject obj)
    {
        Vector pos = obj.GetPosition();
        return ""
               //+" /"
               //+"netid:"+String.valueOf( obj.GetNetId() )
               //+" pos:["+String.valueOf( (int)pos.fX )+","+String.valueOf( (int)pos.fZ )+"]"
               //+"/"
            ;
    }
    
    
    static boolean bTestBroadcast = false;
    
    String CheatTimerPlus()
    {
        if ( Game.CheatsEnabled() )
        {
            ReplicationManagerMsg( EReplicationManagerMsg._MSG_CHEAT_TIMER_PLUS );
            return "ok";
        }
        return " Game.CheatsEnabled() == false !!!!! ";
    }
    String CheatTimerMinus()
    {
        if ( Game.CheatsEnabled() )
        {
            ReplicationManagerMsg( EReplicationManagerMsg._MSG_CHEAT_TIMER_MINUS );
            return "ok";
        }
        return " Game.CheatsEnabled() == false !!!!! ";
    }
    
    
    void CheatSendingAndReceivingStop(float fTime)
    {
        CheatSendingStop( fTime );
        CheatReceivingStop( fTime );
    }
    
    String CheatSendingStop()
    {
        if ( Game.CheatsEnabled() )
        {
            ReplicationManagerMsg( EReplicationManagerMsg._MSG_CHEAT_SENDING_STOP );
            return "ok";
        }
        return " Game.CheatsEnabled() == false !!!!! ";
    }
    
    void ScheduledCheatSendingStart()
    {
        CheatSendingStart();
    }
    String CheatSendingStart()
    {
        if ( Game.CheatsEnabled() )
        {
            ReplicationManagerMsg( EReplicationManagerMsg._MSG_CHEAT_SENDING_START );
            return "ok";
        }
        return " Game.CheatsEnabled() == false !!!!! ";
    }
    
    String CheatSendingStop(float fTime)
    {
        if ( Game.CheatsEnabled() )
        {
            CheatSendingStop();
            CallMethodIn("ScheduledCheatSendingStart",fTime);
            return "ok";
        }
        return " Game.CheatsEnabled() == false !!!!! ";
    }

    String CheatReceivingStop()
    {
        if ( Game.CheatsEnabled() )
        {
            ReplicationManagerMsg( EReplicationManagerMsg._MSG_CHEAT_RECEIVING_STOP );
            return "ok";
        }
        return " Game.CheatsEnabled() == false !!!!! ";
    }

    void ScheduledCheatReceivingStart()
    {
        CheatReceivingStart();
    }
    String CheatReceivingStart()
    {
        if ( Game.CheatsEnabled() )
        {
            ReplicationManagerMsg( EReplicationManagerMsg._MSG_CHEAT_RECEIVING_START );
            return "ok";
        }
        return " Game.CheatsEnabled() == false !!!!! ";
    }

    
    String CheatReceivingStop(float fTime)
    {
        if ( Game.CheatsEnabled() )
        {
            CheatReceivingStop();
            CallMethodIn("ScheduledCheatReceivingStart",fTime);
            return "ok";
        }
        return " Game.CheatsEnabled() == false !!!!! ";
    }    
    
    void CreateTestSpawnObject()
    {
        if ( Role == ERole._AUTHORITY && Game.CheatsEnabled() )
        {
            GameObject cObj = CreateObject("TestSpawnObject");
        }
        
    }
}
