
public class ChromeNetShowMeshModule extends Module
{
    int                m_nView      = -1;
    Camera             m_cCamera    = null;
    PlayerProfileModel m_cModel     = null;
    boolean            m_bActive    = false;
    
    public void OnCreate()
    {
        InitGrid(2000, 2000, -1000, 1000, -1000, 1000, -1000, 1000);
        TimerStart();
        SetRenderAfterSprites(true);
        CreateCamera();
        CreatePlayerModel();
    }
    
    public void Activate()
    {
        if (m_bActive) 
            return;
        super.Activate();
        m_bActive = true;
    }
    
    public void Deactivate()
    {
        if (!m_bActive)
            return;
        super.Deactivate();
        m_bActive = false;
    }
    
    void CreateCamera()
    {
        m_cCamera = (Camera)CreateObject("Camera");
        m_nView = AddView(m_cCamera, 0f,0f,1f,1f);//0.5f, 0.5f, 0.25f, 0.25f);
        ActivateView(m_nView);
        m_cCamera.SetClipNear(10);
        m_cCamera.SetClipFar(20000);
        m_cCamera.FromForwardUpPos(new Vector(0,0,1), new Vector(0,1,0), new Vector(0, 0, 1500));
        UpdateCamera();
    }
    
    float fX = 15.0f;
    float fY = 25.0f;
    float fZ = 1400.0f;
    
    void UpdateCamera()
    {
        /*m_cCamera.FromForwardUpPos(new Vector(0,0,1), 
                                   new Vector(0,1,0), 
                                   new Vector( fX, fY, fZ ));        */
    }
    
    void CreatePlayerModel()
    {
        m_cModel = (PlayerProfileModel)CreateObject("PlayerProfileModel");
    }
    
    void SetModel(NetPlayerModelInfo cModelInfo)
    {
        if (cModelInfo == null)
            return;
        m_cModel.SetModel( cModelInfo );
    }
        
    void OnChangeResolution()
    {
        if (m_nView != -1)
		{
			DeactivateView(m_nView);
			RemoveView(m_nView);
			m_nView = -1;
		}
        m_nView = super.AddView(m_cCamera, 0f,0f,1f,1f);//0.5f, 0.5f, 0.25f, 0.25f);
        SetViewOrigin(m_nView, -1f, -1f);
        ActivateView(m_nView);
        if ( m_cModel != null )
            m_cModel.SetPosition();
    }
    
    void OnDestroy()
    {
        if ( m_cModel != null )
        {
            m_cModel.delete();
            m_cModel = null;
        }
        if (m_nView != -1)
		{
			DeactivateView(m_nView);
			RemoveView(m_nView);
			m_nView = -1;
		}
        m_cCamera.delete();
        m_cCamera = null;
    }

    /**
     * Testy ustawienia mesha
     */
    int nMove = -1;
    final static int _POS = 0,
                     _ROT = 1;
    float m_fRotationF = 0, m_fRotationUp = 0;
    void OnInputKey(int nKeyCode, boolean bKeyState, char nKeyAscii)
    {
		if (!bKeyState)
		{
			switch(nKeyCode)
			{
                case EKey._1:
                    if (nMove != _POS)
                        nMove = _POS;
                    else
                        nMove = -1;
                    break;
                 
                case EKey._2:
                    if (nMove != _ROT)
                        nMove = _ROT;
                    else
                        nMove = -1;
                    break;
            }
            
            switch (nMove)
            {
                case _POS:
                    Tools.MoveObjectByKeys(m_cModel, nKeyCode, 0);
                    Tools.ShowInfoTop(m_cModel.GetPosition().toString(), this);
                    break;
                case _ROT:
                    Vector vRot = new Vector(m_fRotationF, m_fRotationUp, 0);
                    Tools.MovePointByKeys(vRot, nKeyCode, 0);
                    m_cModel.RotateLocal(m_cModel.VectorWorldToLocal(Vector.Forward), -m_fRotationF);
                    m_cModel.RotateLocal(m_cModel.VectorWorldToLocal(Vector.Up), -m_fRotationUp);
                
                    m_fRotationF  = vRot.fX;
                    m_fRotationUp = vRot.fY;
                
                    m_cModel.RotateLocal(m_cModel.VectorWorldToLocal(Vector.Up), m_fRotationUp);
                    m_cModel.RotateLocal(m_cModel.VectorWorldToLocal(Vector.Forward), m_fRotationF);
                    Tools.ShowInfoTop("rot f: " + vRot.fX + " rot up: " + vRot.fY, this);
                    break;
                default:
                    //Tools.ShowInfoTop("", this);
                    break;
            
            }
        }
    }
}
