public class ChromeListBoxMap extends ListBox 
{
    void Init(UIElement data, Module module)
    {
        super.Init(data,module);
        vItemsFirstPos.fX = 4.0f;
        vItemsFirstPos.fY = 4.0f;
    }
    
    void CreateScrollBar()
    {
        btnUpArrow = (Button) this.CreateObject("Button");
        AddChild(btnUpArrow);
        AddChildWnd(btnUpArrow, wndRoot);
        btnUpArrow.Init(new UIElement(EUI.ID_SCROLL_UP,0,
                                    new Vector(0,0,0),
                                    new Vector(32,32,0),
                                    MenuTextures.sGuzikGora,
                                    MenuTextures.sGuzik2Gora,
                                    MenuTextures.sGuzikGora,
                                    MenuTextures.sGuzik2Gora,
                                    EButtonFlags.BTN_TYPE_PRESSBUTTON,
                                    ""),
                      module);
                
        btnDnArrow = (Button) this.CreateObject("Button");
        AddChild(btnDnArrow);
        AddChildWnd(btnDnArrow, wndRoot);
        btnDnArrow.Init(new UIElement(EUI.ID_SCROLL_DN,0,
                                    new Vector(0,0,0),
                                    new Vector(32,32,0),
                                    MenuTextures.sGuzikDol,
                                    MenuTextures.sGuzik2Dol,
                                    MenuTextures.sGuzikDol,
                                    MenuTextures.sGuzik2Dol,
                                    EButtonFlags.BTN_TYPE_PRESSBUTTON,
                                    ""),
                      module);
		
		btnScrollBar = (Button)CreateObject("Button");
        AddChild(btnScrollBar);
        AddChildWnd(btnScrollBar, wndRoot);
		btnScrollBar.Init( new UIElement(0,0,
										 new Vector(0.0f,0.0f,0.0f),
										 new Vector(32.0f,32.0f,0.0f),
										 MenuTextures.sCheckbox,
										 MenuTextures.sCheckbox,
										 MenuTextures.sCheckbox,
										 MenuTextures.sCheckbox,
										 EButtonFlags.BTN_TYPE_PRESSBUTTON,
										 ""),
						   module);
    }
    
    void SetSelection(int nIndex)
    {
        int i;
        String sClassName = "";
        for(i = 0; i < nItemCount; i++)
        {
            ((Button)vItems.elementAt(i)).SetCheck(false);
            ((Button)vItems.elementAt(i)).SetTextColor(1,1,1,1);
            ((Button)vItems.elementAt(i)).SetTextPosFlags(ESpriteText.VERT_MIDDLE);
            ((Button)vItems.elementAt(i)).DisplayText(((Button)vItems.elementAt(i)).sText);
        }
        if ((nIndex > -1) && (nIndex < nItemCount))
        {
            ((Button)vItems.elementAt(nIndex)).SetCheck(true);
            ((Button)vItems.elementAt(nIndex)).SetTextColor(1,1,0,1);
            ((Button)vItems.elementAt(nIndex)).SetTextPosFlags(ESpriteText.VERT_MIDDLE);
            ((Button)vItems.elementAt(nIndex)).DisplayText(((Button)vItems.elementAt(nIndex)).sText);
        }
    }
    
    void RemoveItemFromList(int nIndex)
    {
        if ((nIndex < 0) || (nIndex >= nItemCount)) 
            return;
        Button cItem = ((Button)vItems.elementAt(nIndex));
        cItem.SetCheck(false);
        cItem.SetTextColor(1,1,1,1);
        cItem.DisplayText(((Button)vItems.elementAt(nIndex)).sText);
        vItems.removeElementAt(nIndex);
        RemoveChildWnd(cItem);
        //cItem.DetachFromParent();
        int nLastFirstVisible = nItemCount - nCapacity;
        if ((nIndex == nFirstVisible) || (nFirstVisible > nLastFirstVisible))
        {
            if (nFirstVisible > 0) nFirstVisible--;
        }   
        nItemCount = vItems.size();
        UpdateList();
    }
    
    /**Metoda zwraca wybrany Button*/ 
    Button GetSelectionItem()
    {
        return GetItem(GetSelection());
    }
}
