public class ChromeListSort extends ListBox 
{
    /**Przycisk sortujacy lise*/
    Button Button_Sort = null;
    
    /**ID przycisku sortujacego lise*/
    final static int ID_BTN_SORT = 70;
    
    /**Do tej listy nalezy dodac listy ktore maja sie posortowac razem z ta*/
    java.util.Vector aListToSort = new java.util.Vector();
    
    /**Typ danych znajdujacych sie na liscie wazne przysortowaniu*/
    final static int _TEXT      = 0;
    final static int _NUMERICAL = 1;
    
    /**Domyslny typ danych to text*/
    public int nDataType = _TEXT;
    public int fFontHight = 10;
    
    void Init(UIElement data, Module module)
    {
        super.Init(data,module);
        vItemsFirstPos.fX = 4.0f;
        vItemsFirstPos.fY = 4.0f;
        sText = data.sText;
        CreateSortButton();
        SetCapacity((int)(GetSize().fY / (fFontHight + 4)));
        ShowScroll(false);
    }
    
    void CreateSortButton()
    {
        Button_Sort = (Button)CreateObject("Button");
		Button_Sort.Init( new UIElement(ID_BTN_SORT,0,
										 new Vector(GetPos().fX,GetPos().fY - 32.0f,0.0f),
										 new Vector(GetSize().fX,32.0f,0.0f),
										 MenuTextures.sRamkaMala,
										 MenuTextures.sRamka2Mala,
										 MenuTextures.sRamkaMala,
										 MenuTextures.sRamkaMala,
										 EButtonFlags.BTN_TYPE_CHECKBUTTON,
										 sText),
						   module);
		AddChild(Button_Sort);
        AddChildWnd(Button_Sort, wndRoot);
        Button_Sort.SetTextPosFlags(ESpriteText.VERT_MIDDLE | ESpriteText.HORIZ_MIDDLE);
        //LogD("na przycisku ma byc" + sText + "\n");
        Button_Sort.DisplayText(sText);
        
        //FIXIT jak bedzie poprawione to mozna sortowac
        Button_Sort.SetCheck(false);
        Button_Sort.SetHighlight(false, false);
        Button_Sort.Enable(false);
    }
    
    void OnButton(Button btnSender)
    {
        if (btnSender.nID == ID_BTN_SORT)
        {
            Sort();
            return;
        }
        super.OnButton(btnSender);
    }
    
    void Sort()
    {
        switch( nDataType )
        {
            case _NUMERICAL:
            {
                for ( int index = 0 ; index < vItems.size() ; index ++ )
                {
                    int nTemp = Integer.parseInt(((Button)vItems.elementAt(index)).sText);
                    int index2 = 0;
                    for ( ;index2 < index ; index2++)
                    {
                        if(Button_Sort.GetCheck() ? nTemp > Integer.parseInt(((Button)vItems.elementAt(index2)).sText) : nTemp > Integer.parseInt(((Button)vItems.elementAt(index2)).sText)) break;
                    }
                    ChangePos(index,index2);
                }
                break;
            }
            case _TEXT:
            { 
                for ( int index = 0 ; index < vItems.size() ; index ++ )
                {
                    String sTemp = ((Button)vItems.elementAt(index)).sText;
                    int index2 = 0;
                    for ( ;index2 < index ; index2++)
                    {
                        if(Button_Sort.GetCheck() ? sTemp.compareTo(((Button)vItems.elementAt(index2)).sText) > 0 : sTemp.compareTo(((Button)vItems.elementAt(index2)).sText) < 0) break;
                    }
                    ChangePos(index,index2);
                }
                break;
            }
        }
        UpdateList();
        for ( int index = 0; index < aListToSort.size() ; index++) ((ListBox)aListToSort.elementAt(index)).UpdateList();
    }
    
    void ChangePos(int nCurr,int nAk)
    {
        Button cTemp = ((Button)vItems.elementAt(nCurr));
        vItems.removeElementAt(nCurr);
        vItems.insertElementAt(cTemp,nAk);
        for ( int index = 0; index < aListToSort.size() ; index++)
        {
            ListBox cListTemp = (ListBox)aListToSort.elementAt(index);
            cTemp = ((Button)cListTemp.vItems.elementAt(nCurr));
            cListTemp.vItems.removeElementAt(nCurr);
            cListTemp.vItems.insertElementAt(cTemp,nAk);
        }
    }
    
    public void SetSize(Vector v)
    {
        super.SetSize(v);
        Vector arrowSize = btnUpArrow.GetSize();
        Vector pos = GetPos();
        Vector size = GetSize();
        if ( btnUpArrow.IsVisible() )
        {
            btnUpArrow.SetRelativePos(new Vector(size.fX, 0, 0));
            btnDnArrow.SetRelativePos(new Vector(size.fX, size.fY - arrowSize.fY ,0));
		    if (btnScrollBar != null)btnScrollBar.SetRelativePos(new Vector(size.fX,arrowSize.fY,0.0f));
            vClientSize.fX = v.fX - arrowSize.fX;
            vClientSize.fY = v.fY;
        }
        else
        {
            vClientSize.fX = v.fX;
            vClientSize.fY = v.fY;
        }
        SetCapacity(nCapacity);
    }
    
    void ChnageScrollBarPos()
    {
        if ( btnScrollBar != null )
		{
			Vector size = GetSize();
			Vector arrowSize = btnUpArrow.GetSize();
			Vector vScrollSize = btnScrollBar.GetSize();
			btnScrollBar.SetRelativePos(new Vector(size.fX, arrowSize.fY + ((nFirstVisible) * ((size.fY - (2.0f * arrowSize.fY + vScrollSize.fY))/(nItemCount - nCapacity))),0.0f));   	
		}
    }
    
    void CreateScrollBar()
    {
        btnUpArrow = (Button) this.CreateObject("Button");
        AddChild(btnUpArrow);
        AddChildWnd(btnUpArrow, wndRoot);
        btnUpArrow.Init(new UIElement(EUI.ID_SCROLL_UP,0,
                                    new Vector(0,0,0),
                                    new Vector(32,32,0),
                                    MenuTextures.sGuzikGora,
                                    MenuTextures.sGuzik2Gora,
                                    MenuTextures.sGuzikGora,
                                    MenuTextures.sGuzik2Gora,
                                    EButtonFlags.BTN_TYPE_PRESSBUTTON,
                                    ""),
                      module);
                
        btnDnArrow = (Button) this.CreateObject("Button");
        AddChild(btnDnArrow);
        AddChildWnd(btnDnArrow, wndRoot);
        btnDnArrow.Init(new UIElement(EUI.ID_SCROLL_DN,0,
                                    new Vector(0,0,0),
                                    new Vector(32,32,0),
                                    MenuTextures.sGuzikDol,
                                    MenuTextures.sGuzik2Dol,
                                    MenuTextures.sGuzikDol,
                                    MenuTextures.sGuzik2Dol,
                                    EButtonFlags.BTN_TYPE_PRESSBUTTON,
                                    ""),
                      module);
		
		btnScrollBar = (Button)CreateObject("Button");
        AddChild(btnScrollBar);
        AddChildWnd(btnScrollBar, wndRoot);
		btnScrollBar.Init( new UIElement(0,0,
										 new Vector(0.0f,0.0f,0.0f),
										 new Vector(32.0f,32.0f,0.0f),
										 MenuTextures.sCheckbox,
										 MenuTextures.sCheckbox,
										 MenuTextures.sCheckbox,
										 MenuTextures.sCheckbox,
										 EButtonFlags.BTN_TYPE_PRESSBUTTON,
										 ""),
						   module);
    }
    
    /**Metoda zostala nadpisane po to by scrolowane bylo wiele list*/
    void OnScrollDown()
    {
        OnScrollDown1();
        for ( int index = 0 ; index < aListToSort.size() ; index++) ((ChromeListSort)aListToSort.elementAt(index)).OnScrollDown1();
    }
    
    /**Metoda zostala nadpisane po to by scrolowane bylo wiele list*/
    void OnScrollUp()
    {
        OnScrollUp1();
        for ( int index = 0 ; index < aListToSort.size() ; index++) ((ChromeListSort)aListToSort.elementAt(index)).OnScrollUp1();
    }
    /**Metoda wlasciwa metoda przesowania list*/
    void OnScrollDown1()
    {
        //ostatni element ktory moze byc na szczycie listy
        int nLastFirstVisible = nItemCount - nCapacity;
        if (nFirstVisible < nLastFirstVisible) 
        {
            nFirstVisible++;
            UpdateList();
        }
    }
    /**Metoda wlasciwa metoda przesowania list*/
    void OnScrollUp1()
    {
        if (nFirstVisible > 0) 
        {
            nFirstVisible--;
            UpdateList();
        }
    }
    
    void SetSelection(int nIndex)
    {
        SetSelection1(nIndex);
        for ( int i = 0 ; i < aListToSort.size() ; i++) 
            ((ChromeListSort)aListToSort.elementAt(i)).SetSelection1(nIndex);    
    }
    
    void SetSelection1(int nIndex)
    {
        int i;
        String sClassName = "";
        for(i = 0; i < nItemCount; i++)
        {
            ((Button)vItems.elementAt(i)).SetCheck(false);
            ((Button)vItems.elementAt(i)).SetTextColor(1,1,1,1);
            ((Button)vItems.elementAt(i)).SetTextPosFlags(ESpriteText.VERT_MIDDLE);
            ((Button)vItems.elementAt(i)).DisplayText(((Button)vItems.elementAt(i)).sText);
        }
        if ((nIndex > -1) && (nIndex < nItemCount))
        {
            ((Button)vItems.elementAt(nIndex)).SetCheck(true);
            ((Button)vItems.elementAt(nIndex)).SetTextColor(1,1,0,1);
            ((Button)vItems.elementAt(nIndex)).SetTextPosFlags(ESpriteText.VERT_MIDDLE);
            ((Button)vItems.elementAt(nIndex)).DisplayText(((Button)vItems.elementAt(nIndex)).sText);
        }
    }
    
    /**metoda dodaje string do listy. pierwszy parametr to string ktory ma byc dodany drugi 
     * to id tej pozycji w liscie by bylo wiadomo przy kliknieciu co zostalo wybrane*/
    void AddString( String sAddText, int nIDString)
    {
        Button item = (Button)CreateObject("Button");
        item.Init(new UIElement(nIDString,0,
                                    new Vector(0,0,0),
                                    new Vector(0,0,0),
                                    "",
                                    "",
                                    "",
                                    "",
                                    EButtonFlags.BTN_TYPE_LISTBOX_ITEM,
                                    sAddText),module);
        AddItem(item);
        DisplayText(sAddText,item);   
    }
    
    void ChangeString( String sChangeText , int nIndex)
    {
        Button Button_Item = GetItem(nIndex);
        DisplayText(sChangeText,Button_Item);
    }
    
    void DisplayText( String sTextToWrite, Button item )
    {
        item.sText = sTextToWrite;
        item.SetTextPosFlags(ESpriteText.VERT_MIDDLE);
        item.DisplayText(sTextToWrite);
    }
    
    /**Metoda wyszukuje element listy po identyfikatorze( nie po indexie) i zwraca zawarty w nim string
     * jeeli brak to zwraca null
     */
    String GetStringItmeID( int nIDItem )
    {
        for (int nIndex = 0; nIndex < vItems.size() ; nIndex++)
        {
            if ( nIDItem == ((Button)vItems.elementAt(nIndex)).nID ) return ((Button)vItems.elementAt(nIndex)).sText;
        }
        return null;
    }
    
    /**Szuka w liscie Itemu o podanym identyfikatorze i zwraca jego aktualny index*/
    int FindItemFromID( int nIDItem )
    {
        for (int nIndex = 0; nIndex < vItems.size() ; nIndex++)
        {
            if ( nIDItem == ((Button)vItems.elementAt(nIndex)).nID ) return nIndex;
        }
        return -1;
    }
    
    /**Metoda sprawdza czy dany przycisk jest na liscie, sprawdza referencje*/
    boolean IsInList(Button btn_find)
    {
        boolean bRet = false;
        bRet = IsInList1(btn_find);
        if (bRet)
            return true;
        for ( int i = 0 ; i < aListToSort.size() ; i++)   
        {
            bRet = ((ChromeListSort)aListToSort.elementAt(i)).IsInList1(btn_find); 
            if (bRet)
                return true;
        }
        return false;
    }
    
    boolean IsInList1(Button btn_find)
    {
        return super.IsInList(btn_find);
    }
}