public class ENetEditWindowUI extends EUI 
{
    final static int ID_LABEL               = 1000;
    final static int ID_BTN                 = 1100;
    final static int ID_EDIT                = 1200;
    
    static UIElement GetUILabel(MenuNetEditControlsSet cSet,
                                String sText)
    {
        if ( cSet == null || cSet.GetWindow() == null )
        {
            GameObject.LogD(" ERROR: nie potrafie stworzyc obiektu UI dla "+cSet+"\n");
            return null;
        }
        int    nElement  = cSet.GetWindow().GetCurrentElement();
        Vector vPosOffset= cSet.GetWindow().GetCurrentSetPos();
        
        Vector vSize    = new Vector( cSet.IsBigSize() ? 256 : 128 ,32,0);
        String sTexture = cSet.IsBigSize() ? 
                          MenuTextures.sRamka : MenuTextures.sRamkaMala;

        Vector vPos = new Vector(10,0,0);
        vPos.Add( vPosOffset );
        return new UIElement(
            ID_LABEL + nElement,0,
            vPos,
            vSize,
            sTexture,
            sTexture, 
            sTexture,
            sTexture,
            EButtonFlags.BTN_TYPE_PUSHBUTTON, 
            sText
            );
    }
    
    static UIElement GetUIButton(MenuNetEditControlsSet cSet)
    {
        if ( cSet == null || cSet.GetWindow() == null )
        {
            GameObject.LogD(" ERROR: nie potrafie stworzyc obiektu UI dla "+cSet+"\n");
            return null;
        }
        int    nElement  = cSet.GetWindow().GetCurrentElement();
        Vector vPosOffset= cSet.GetWindow().GetCurrentSetPos();
        
        Vector vPos = new Vector(10+(cSet.IsBigSize() ? 256 : 128)+10,0,0);
        vPos.Add( vPosOffset );
        return new UIElement(
            ID_BTN + nElement,0,
            vPos,
            new Vector(32,32,0),
            MenuTextures.sCheckbox, 
            MenuTextures.sCheckbox2, 
            "", 
            "", 
            EButtonFlags.BTN_TYPE_CHECKBUTTON,
            ""
            );
    }
    
    static UIElement GetUIEdit(MenuNetEditControlsSet cSet)
    {
        if ( cSet == null || cSet.GetWindow() == null )
        {
            GameObject.LogD(" ERROR: nie potrafie stworzyc obiektu UI dla "+cSet+"\n");
            return null;
        }
        int    nElement  = cSet.GetWindow().GetCurrentElement();
        Vector vPosOffset= cSet.GetWindow().GetCurrentSetPos();
        
        Vector vPos = new Vector(10+(cSet.IsBigSize()?256:128)+10+32,0,0);
        Vector vSize = new Vector(64,32,0);
        if ( ! cSet.GetCheckBoxVisible() )
            vPos.fX -= 32.0f;
            vSize.fX += 32.0f;
        vPos.Add( vPosOffset );
        return new UIElement(
            ID_EDIT + nElement,0,
            vPos,
            vSize,
            MenuTextures.sRamka64,
            MenuTextures.sRamka264, 
            MenuTextures.sRamka64,
            MenuTextures.sRamka264,
            EButtonFlags.WND_TYPE_EDIT, 
            ""
            );
    }
}
