import java.io.*;
import java.util.Vector;

class FavoriteServer
{
    public FavoriteServer()
    {
        Name = null;
        IP = null;
    }
    public FavoriteServer(String IP, String Name, int PortGame)
    {
        this.Name = Name;
        this.IP = IP;
        this.PortGame = PortGame;
    }
    public boolean Equals(String IP, int PortGame)
    {
        if (IP.equals(IP) && this.PortGame == PortGame)
            return true;
        return false;
    }
    
    public void Write(BufferedWriter bw) throws IOException
    {
        bw.write(Name);
        bw.newLine();
        bw.write(IP);
        bw.newLine();
        bw.write(Integer.toString(PortGame));
        bw.newLine();
        bw.write(Integer.toString(0));
        bw.newLine();
    }

    public int Read(BufferedReader br) throws IOException
    {
        Name = br.readLine();
        IP   = br.readLine();
        String pg = br.readLine();
        String pc = br.readLine();
        if (Name == null || 
            IP == null ||
            pg == null ||
            pc == null) return -1;
        try
        {
            PortGame = Integer.decode(pg).intValue();
            //PortCom = Integer.decode(pc).intValue();
        }
        catch(NumberFormatException e)
        {
            return 0;
        }
        if (IsIPStringCorrect(IP)) 
            return 1;
        return 0;
    }
    
    public int PortGame;
    //public int PortCom;//teraz juz obsolete, ale w plikach jeszcze jest
    public String Name;
    public String IP;
    
    private boolean IsIPStringCorrect(String IP)
    {
        boolean correct = true;
        int count = 0;
        if (IP != null)
        {
            StreamTokenizer st = new StreamTokenizer(new StringReader(IP));
            st.whitespaceChars(0,255);
            st.ordinaryChars('0','9');
            st.wordChars('0','9');
            try
            {
                st.nextToken();
                while (st.ttype != st.TT_EOF)
                {
                    String s = st.sval;
                    try
                    {
                        int i = Integer.parseInt(s);
                        if (i<0 || i>255) correct = false;
                    }
                    catch(NumberFormatException e)
                    {
                        correct = false;    
                    }
                    count++;
                    st.nextToken();
                }
            }
            catch(IOException e){}
            if (correct == true && count == 4) return true;
        }
        return false;
    }    
}

public class ChromeNetFavorites
{
    private static String GetFileName() { return NetPlayerProfile.GetCurrentFavoritesServersFileName(); }
    
    public static void AddServer(String IP, String Name, int PortGame)
    {
        if (IsServerOnList(IP, PortGame) == false)
        {
            try
            {
                BufferedWriter bw = new BufferedWriter( new FileWriter( GetFileName(),true));
                (new FavoriteServer(IP,Name,PortGame)).Write(bw);
                bw.close();
            }
            catch (IOException e){}
        }
    }

    public static void RemoveServer(String IP, int PortGame)
    {
        Vector ServersList = ReadList();
        
        for (int i=0; i<ServersList.size(); i++)
        {
            if (((FavoriteServer)ServersList.elementAt(i)).Equals(IP,PortGame) == true)
            {
                ServersList.removeElementAt(i);
                i--;
            }
        }
        WriteList(ServersList);
    }
    
    public static void UpdateServer(String IP, String Name, int PortGame)
    {
        Vector ServersList = ReadList();
        
        for (int i=0; i<ServersList.size(); i++)
        {
            if (((FavoriteServer)ServersList.elementAt(i)).Equals(IP,PortGame) == true)
            {
                ((FavoriteServer)ServersList.elementAt(i)).Name = Name;
            }
        }
        WriteList(ServersList);
    }
    
    public static void OpenList()
    {
        try
        {
            br = new BufferedReader( new FileReader( GetFileName() ));
        }
        catch(FileNotFoundException e){}
    }
    
    
    public static FavoriteServer GetServer()
    {
        try
        {
            if (br!=null)
            {
                int ret;
                FavoriteServer fs = new FavoriteServer();
                while(0==(ret = fs.Read(br)));
                if (ret == -1) 
                    return null;
                return fs;
            }
            else
            {
                return null;
            }
        }
        catch (IOException e)
        {
            return null;
        }
    }
    
    public static void CloseList()
    {
        try
        {
            if (br!=null)
            {
                br.close();
            }
        }
        catch (IOException e)
        {}
        br = null;
    }
    
    private static BufferedReader br;
    
    private static boolean IsServerOnList(String IP, int PortGame)
    {
        FavoriteServer fs;
        OpenList();
        while ((fs=GetServer())!=null)
        {
            if (fs.Equals(IP,PortGame))
            {
                CloseList();
                return true;
            }
        }
        CloseList();
        return false;
    }
    
    private static void WriteList(Vector ServersList)
    {
        try
        {
            BufferedWriter bw = new BufferedWriter( new FileWriter( GetFileName() ));
        
            for (int i=0; i<ServersList.size(); i++)
            {
                ((FavoriteServer)ServersList.elementAt(i)).Write(bw);
            }
            bw.close();
        }
        catch(FileNotFoundException e){}
        catch (IOException e){}
    }
    
    private static Vector ReadList()
    {
        Vector ServersList = new Vector();
        FavoriteServer fs;
        OpenList();
        while ((fs=GetServer())!=null)
        {
            ServersList.add(fs);
        }
        CloseList();
        return ServersList;
    }
}
