public class MenuNetServerFullInfo extends ChromeMenuWindow
{
    UIStatic	m_staticServer		= null;    
    UIStatic    m_staticPlayersList	= null;
	UIStatic	m_staticMapsList	= null;
    UIListBox	m_lbPlayersList		= null;        
    UIListBox	m_lbMapsList		= null;    
    UIButton	m_btnGameSettings   = null;
    UIButton	m_btnOK				= null;    
    UIButton	m_btnDedicated		= null;
    UIButton	m_btnPassword		= null;
	    
    static NetServerFullInfo m_cServerFullInfo = null;
	ChromeMenuWindow m_cParentChromeWindow = null;
        
	
	MenuNetGameSettings cMenu = null;
	
	public void OnCreate()
    {
		super.OnCreate();

		MenuModule = (ChromeMenuModule)GetModule();
        //MenuModule.cMenuBackground.ShowFrame();
        //MenuModule.cMenuBackground.HideCaption();
		
		m_staticServer = (UIStatic)GetElem("ID_SERVER");		
		m_lbPlayersList = (UIListBox)GetElem("ID_LISTBOX_PLAYERS");
		m_lbMapsList = (UIListBox)GetElem("ID_LISTBOX_MAPS");
		m_staticPlayersList = (UIStatic)GetElem("ID_PLAYERS");
		m_staticMapsList = (UIStatic)GetElem("ID_MAPS");		
		m_btnGameSettings = (UIButton)GetElem("ID_BTN_CGS");
		m_btnOK = (UIButton)GetElem("ID_BTN_OK");
		m_btnDedicated = (UIButton)GetElem("ID_BTN_DEDICATED");
		m_btnPassword = (UIButton)GetElem("ID_BTN_PASSWORD");		
	}
	
	public void Show()
		{
			if(MenuModule != null && MenuModule.cMenuBackground != null)
				MenuModule.cMenuBackground.CallMethodIn("ShowGameVersion",0.1f);
			super.Show();
		}
	
	public void OnDestroy()
    {
        super.OnDestroy();

		if(cMenu != null)
        {
            cMenu.Remove();
            RemoveSprite(cMenu);
            cMenu.delete();
            cMenu = null;
        }
    }
	
	void PrepareSettings()
	{
        m_btnDedicated.SetCheck( m_cServerFullInfo.GetDedicated() );
        m_btnDedicated.SetActive(false);
        
        m_btnPassword.SetCheck( m_cServerFullInfo.IsPassword() );
        m_btnPassword.SetActive(false);
		
		String sAddres = m_cServerFullInfo.GetAddress();
		((UIStatic)GetElem("ID_IP_TEXT")).SetText(sAddres);
		
		((UIStatic)GetElem("ID_VERSION_TEXT")).SetText(m_cServerFullInfo.GetNetGameVersionNumber());
		
        m_staticServer.DisplayText( Text.Get("&MenuNetServerInfoTitle&") + " : "
									+ m_cServerFullInfo.GetServerName());
            
        m_lbPlayersList.Clear();
		
        for (int i=0; i < m_cServerFullInfo.GetPlayersCnt(); i++)
        {
            String sPlayer = m_cServerFullInfo.GetPlayer( i );
            if ( sPlayer == null )
                continue;
			m_lbPlayersList.AddItem(sPlayer,null);
        }
		
        String sLabelPlayers = Text.Get("&MenuNetServerInfoPlayersList&") +
                                 "  ( "+m_lbPlayersList.nItemCount+
                                  " / "+m_cServerFullInfo.GetMaxPlayers()+
                                  " )";
		
        m_staticPlayersList.DisplayText( sLabelPlayers );
        
		m_lbMapsList.Clear();
		
        for (int i=0; i<m_cServerFullInfo.GetMapsCnt(); i++)
        {
            MapsListItem cItem = m_cServerFullInfo.GetMap( i );
            if ( cItem == null )
                continue;
            String sMap = cItem.m_sName + 
                          " " + 
                          ENetGameType.GetGameNameShort( cItem.m_nType );
            
            if (i == m_cServerFullInfo.GetCurrentGame())
                sMap +=" ("+ Text.Get("&MenuNetServerInfoCurrentGame&")+")";
			m_lbMapsList.AddItem(sMap,null);
				
        }
		
        String sLabelMaps = Text.Get("&MenuNetServerInfoMapsList&") +
                            "  ( "+m_lbMapsList.nItemCount+
                            (m_cServerFullInfo.GetLoopLevels()?
                             " - "+"&MenuNetServerInfoLoopLevelsMode&":"")+
                             " )";
        m_staticMapsList.DisplayText( sLabelMaps );        
        m_lbMapsList.SetSelection( m_cServerFullInfo.GetCurrentGame() );  
		
		for(int i = 0; i < m_lbMapsList.nItemCount; i++)
        {
            ((UIButton)m_lbMapsList.vItems.elementAt(i)).SetActive(false);
        }
	}
	
    /*void SetParams( java.util.Vector vParams )
    {
		super.SetParams(vParams);
		
		if ((vParams != null) && (vParams.size() == 1))
			m_cServerFullInfo = (NetServerFullInfo)vParams.get(0);
    }*/
    
    void OnUICommand(UIWindow cSender, int nCommand)
	{
		super.OnUICommand(cSender,nCommand);
            
		if(nCommand == EUIConst.CM_CLICK || nCommand == EUIConst.CM_DBCLICK)
        {
			if (cSender.m_sId.equals("ID_BTN_CGS")) 
			{
				ShowCurrentGameSettings();
			}
			else if (cSender.m_sId.equals("ID_BTN_OK")) 
			{
				//MenuModule.SetMenu(MenuModule.sMenuBackName);
				Discard();
			}
        }
    }
	
	void Discard()
	{
		if(!CanDiscard())
			return;
		Hide();
        m_cParentChromeWindow.Show();
		m_cServerFullInfo = null;
	}
	
	void SetServerWindow(ChromeMenuWindow cChromeMenuWindow,ChromeMenuModule cMenuModule)
    {
        m_cParentChromeWindow = cChromeMenuWindow;
        MenuModule=cMenuModule; 
    }
	
	void SetServerFullInfo(NetServerFullInfo cServerFullInfo)
	{
		m_cServerFullInfo = cServerFullInfo;
		PrepareSettings();
	}
	
    void ShowCurrentGameSettings()
    {
        NetGameSettings cSettings = m_cServerFullInfo.GetCurrentGameSettings();
        int             nGameType = cSettings.GetGameType();
        
        String sMenuClassName = ENetGameType.GetMenuGameSettingsClassName( nGameType );
		if(cMenu != null)
        {
            cMenu.Remove();
            RemoveSprite(cMenu);
            cMenu.delete();
        }
        cMenu = (MenuNetGameSettings)CreateObjectNoInit( sMenuClassName );
        cMenu.SetParams( MenuModule, this, cSettings );
        cMenu.InitObject();
        cMenu.CallMethodIn( "Show", 0.0f );
    }
}
