import java.io.*;
public class MenuNetServerSettings extends ChromeMenuWindow //MenuNetEditWindow
{
    UIEdit Edit_ServerName    = null;
    UIEdit Edit_MaxPlayers    = null;
	UIEdit Edit_GamePort	        = null;
    UIButton Button_LoopLevels      = null;
    UIButton Button_Dedicated       = null;
	UIButton Button_Password        = null;
	
	int m_iLastGamePort;
    
    MenuNetSetPassword cMenu = null; 
    
    /**
     * Tu bedziemy trzymali informacje czy edytujemy
     * parametry serwera internetowago czy lokalnego
     * Po to trzeba to zapamietac, zeby po wczytaniu default
     * ustawic (wymusic) odpowiednia wersje
     */
    boolean m_bInternetGame = false;
      
    public void OnCreate()
    {
        super.OnCreate();
    }
    
	void Init(MenuBackground cBack) 
    {
        MenuModule=(ChromeMenuModule)GetModule(); 
		
		Button_LoopLevels = (UIButton)GetElem("ID_313");
		Button_Dedicated = (UIButton)GetElem("ID_314");
		Button_Password = (UIButton)GetElem("ID_315");
    	
		Edit_ServerName  = (UIEdit)GetElem("ID_311");
        Edit_ServerName.m_nMaxChar = 14;
		Edit_MaxPlayers    = (UIEdit)GetElem("ID_312");
		Edit_MaxPlayers.m_sAllowedChars = _DIGITS_ONLY;
		
		Edit_GamePort = (UIEdit)GetElem("ID_317");
		Edit_GamePort.m_sAllowedChars = _DIGITS_ONLY;
		
        LoadSettings( false );
        		
	 //ustawienie checkboxa password
		if (m_sPassword != null)
		{
			Button_Password.SetCheck(true);
		}
    }
    
    void OnUICommand(UIWindow cSender, int nCommand)
	{
		int nID = GetButtonId(cSender.m_sId);
		
		if (nCommand == EUIConst.CM_EDIT_ENTER)
			{
				switch(nID)
				{
				case ENetServerSettingsUI.ID_EDIT_GAME_PORT:
					VeryfiPort(nID);
					break;
				}
		}
		
		super.OnUICommand(cSender,nCommand);
		
            
		if(nCommand == EUIConst.CM_CLICK || nCommand == EUIConst.CM_DBCLICK)
        {
            switch(nID)
            {
            case ENetServerSettingsUI.ID_BTN_DONE:
                SaveSettings();
                //tu nie ma byc break'a
            case ENetServerSettingsUI.ID_BTN_BACK:
                //Hide();
				MenuModule.SetMenu("ChromeNetCreatMenu");
                break;
                
            case ENetServerSettingsUI.ID_BTN_DEFAULT:
                LoadSettings( true );
                //wylaczenie buttona password
                Button_Password.SetCheck(false);
                break;
			
			case ENetServerSettingsUI.ID_CHECKBUTTON_PASSWORD:
				if(Button_Password.GetCheck())
				{
					CallMethodIn("OnPassword", 0);
					//MenuModule.SetMenu("MenuNetSetPassword");
				}else
				{
					TypedPassword( null, false);
				}
				break;
            }
        }
    }
    
	void VeryfiPort(int nID)
	{
		String sNewGamePort = Edit_GamePort.GetText();		
		
		int iNewGamePort = -1;		
		
		if (sNewGamePort.length() < 10)
			iNewGamePort = Integer.parseInt(sNewGamePort);
		
		//weryfikacja wpisanych portow
		if ( NetServerInitInfo.VerifyPorts( iNewGamePort) )
		{
			m_iLastGamePort = iNewGamePort;
		}
        else
        {			
		    Edit_GamePort.SetText(String.valueOf(m_iLastGamePort));
		}
	}
	
    void OnPassword()
    {
        if(cMenu != null)
        {
            cMenu.Remove();
            RemoveSprite(cMenu);
            cMenu.delete();
        }
        
        cMenu = (MenuNetSetPassword)CreateObjectNoInit( "MenuNetSetPassword" );
        cMenu.InitObject();
        cMenu.SetServerWindow(this,MenuModule);
        Hide();
        cMenu.MoveTop();
        cMenu.CallMethodIn( "Show", 0.0f );
    }
    
    public void OnDestroy()
    {
        if ( cMenu != null )
        {
            cMenu.Remove();
            RemoveSprite( cMenu );
            cMenu.delete();
            cMenu = null;	 
        }
        super.OnDestroy();
    }
    
    /**Wczytanie wartosci dla servera*/
    void LoadSettings(boolean bDefault)
    {
        //tworzymy obiekt ServerInfo
        NetServerInitInfo cServerInfo = new NetServerInitInfo();
        
        //odczytujemy ustawienia domyslne
        if ( bDefault )
        {
            cServerInfo.ParseDefaultScriptFile();
            //przy ladowaniu pliku domyslnego forcujemy
            //stan flagi IsInternetGame w zaleznosci od faktycznego trybu menu
            cServerInfo.SetInternetGame( m_bInternetGame );
        }
        else
        {
            cServerInfo.ParseScriptFile();
            //przy ladowaniu pliku z aktualnymi ustawieniami pobieramy
            //stan flagi IsInternetGame
            m_bInternetGame = cServerInfo.IsInternetGame();
        }
       
		//i zlecamy ich edycje
        Edit_ServerName.SetText( cServerInfo.GetServerName() );
        Edit_MaxPlayers.SetText( String.valueOf( cServerInfo.GetMaxPlayers() ) );
        Button_LoopLevels.SetCheck( cServerInfo.GetLoopLevels() );
        Button_Dedicated.SetCheck( cServerInfo.GetDedicated() );
        //Button_Internet_Game.SetCheck( cServerInfo.IsInternetGame() );
        
		if ( cServerInfo.IsInternetGame() )
		{
			Edit_GamePort.Show();
			m_iLastGamePort = cServerInfo.GetGamePort();
			Edit_GamePort.SetText(String.valueOf(m_iLastGamePort));
			((UIStatic)GetElem("ID_GAME_PORT_TXT")).Show();
		}else
		{			
			Edit_GamePort.Hide();
			((UIStatic)GetElem("ID_GAME_PORT_TXT")).Hide();
		}
		
        TypedPassword( cServerInfo.GetPassword(), false );
    }
    
    
    void SaveSettings()
    {
        //tworzymy obiekt ServerSettings
        NetServerInitInfo cServerInfo = new NetServerInitInfo();
        
        //znowu forsujemy flage InternetGame
        cServerInfo.SetInternetGame( m_bInternetGame );
        
        //nanosimy na niego zmiany z menu
        cServerInfo.SetServerName( Edit_ServerName.GetText() ); 
        cServerInfo.SetMaxPlayers( Edit_MaxPlayers.GetText() );
        cServerInfo.SetLoopLevels( Button_LoopLevels.GetCheck() );
        cServerInfo.SetDedicated( Button_Dedicated.GetCheck() );
        cServerInfo.SetPassword( m_sPassword ); 
		
		if (Edit_GamePort.IsVisible())
			cServerInfo.SetGamePort(Integer.parseInt(Edit_GamePort.GetText()));

        //i zapisujemy do skryptu dane
        cServerInfo.SaveSettings();
    }
    
    /*void OnCheckButtonPushed( MenuNetEditControlsSet cControls )
    {
        if ( cControls == m_cPassword )
        {
            if ( m_cPassword.GetBoolean() == false )
            {
                TypedPassword( null );
                return;
            }
            MenuNetSetPassword cMenu = (MenuNetSetPassword)CreateObjectNoInit( "MenuNetSetPassword" );
            cMenu.SetParams( m_cMenuModule, this );
            cMenu.InitObject();
            cMenu.CallMethodIn( "Show", 0.0f );
            
            m_cPassword.SetValue( false );
        }
    }*/

	static String m_sPassword = null;
	static boolean m_bTopPriority = false;
	
	//ustawienie chasla, priorytet pozwala nam na przekazanie chasla miedzy dwoma 
	//oknami oraz na odpowiednie dzialanie przy cancel
	static void TypedPassword(String sPassword, boolean bTopPriority)
    {
        if(bTopPriority)
		{
			m_sPassword = sPassword;
			m_bTopPriority = true;
		} else
		{
			if(m_bTopPriority)
			{
				m_bTopPriority = false;
			} else
			{
			    m_sPassword = sPassword;
			}
		}
    }
}
