public class MenuNetServersFilter extends ChromeMenuWindow
{
    ChromeNetJoinMenu m_cChromeNetJoinMenu = null;
    
    UIEdit m_cPlayers = null;
    UIEdit m_cPing = null;
    
    public void OnCreate()
    {
        super.OnCreate();
        m_cPlayers = (UIEdit)GetElem("ID_PLAYERS_EDIT");
        m_cPing = (UIEdit)GetElem("ID_PING_EDIT");
        
        m_cPlayers.m_sAllowedChars = ChromeMenuWindow._DIGITS_ONLY;
        m_cPing.m_sAllowedChars = ChromeMenuWindow._DIGITS_ONLY;
        m_cPlayers.SetDisabled(true);
        m_cPing.SetDisabled(true);
    }
    
    void OnUICommand(UIWindow cSender, int nCommand)
	{
		super.OnUICommand(cSender,nCommand);

        if(nCommand == EUIConst.CM_CLICK || nCommand == EUIConst.CM_DBCLICK)
        {
			if(cSender.m_sId.equals("ID_DONE"))
			{
				Done();
			}else
				if(cSender.m_sId.equals("ID_CANCEL"))
				{
		            m_cChromeNetJoinMenu.CancelFromServersFilters();	
					m_cPing.SetText("");
					m_cPlayers.SetText("");
					Hide();
                    m_cChromeNetJoinMenu.Show();
        		}else
				if(cSender.m_sId.equals("ID_PLAYERS_CHECKBOX"))
				{
                    boolean bCheckBox = ((UIButton)cSender).GetCheck();
		            m_cPlayers.SetDisabled(!bCheckBox);
                    if(bCheckBox)
                    {
                        m_cPlayers.SetCheck(true);
                        m_cPlayers.SetFocus(true);
                    }else
                    {
                        m_cPlayers.SetText("");
                    }
                }else
				if(cSender.m_sId.equals("ID_PING_CHECKBOX"))
				{
                    boolean bCheckBox = ((UIButton)cSender).GetCheck();
                    m_cPing.SetDisabled(!bCheckBox);
                    if(bCheckBox)
                    {
                        m_cPing.SetCheck(true);
                        m_cPing.SetFocus(true);
                    }else
                    {
                        m_cPing.SetText("");
                    }
        		}
        }
	}
    
    
    void Done()
    {
        Hide();
        String sPing = m_cPing.GetText();
        String sPlayers = m_cPlayers.GetText();
        m_cChromeNetJoinMenu.SetFilters(((UIButton)GetElem("ID_AVAILABLE_CHECKBOX")).GetCheck(),
                                        ((UIButton)GetElem("ID_PASSWORD_CHECKBOX")).GetCheck(),
                                        (sPing.length()>0) ? Integer.parseInt(sPing) : 0, 
                                        (sPlayers.length()>0) ? Integer.parseInt(sPlayers) : 0,
										((UIButton)GetElem("ID_AVAILABLE_CHECKBOX")).GetCheck()||
                                        ((UIButton)GetElem("ID_PASSWORD_CHECKBOX")).GetCheck()||
                                        (sPing.length()>0)||(sPlayers.length()>0));
        m_cChromeNetJoinMenu.Show();
    }
    
    void SetServerWindow(ChromeNetJoinMenu cChromeNetJoinMenu,ChromeMenuModule cMenuModule)
    {
        m_cChromeNetJoinMenu = cChromeNetJoinMenu;
        MenuModule=cMenuModule; 
    }
    
    void SetFilters(boolean bAvailable, boolean bWithoutPassword, int iMaxPing, int iMinPlayers)
    {
        ((UIButton)GetElem("ID_AVAILABLE_CHECKBOX")).SetCheck(bAvailable);
        ((UIButton)GetElem("ID_PASSWORD_CHECKBOX")).SetCheck(bWithoutPassword);
        ((UIButton)GetElem("ID_PING_CHECKBOX")).SetCheck(iMaxPing>0);
        m_cPing.SetDisabled(!(iMaxPing>0));
        ((UIButton)GetElem("ID_PLAYERS_CHECKBOX")).SetCheck(iMinPlayers>0);
        m_cPlayers.SetDisabled(!(iMinPlayers>0));
        if(iMaxPing>0)
            m_cPing.SetText(String.valueOf(iMaxPing));
        if(iMinPlayers>0)
            m_cPlayers.SetText(String.valueOf(iMinPlayers));
    }
    
    public void Show()
    {
        super.Show();
    }
    
    public void MoveTop()
    {
        super.MoveTop();
        MenuModule.cCursor.MoveTop();
    }
}
