/**
 * message sieciowy 
 * moze byc albo zwyklym tekstem, 
 * albo identyfikatorem voice'a
 */ 
public class NetMsg
{
    String m_sText  = null;
    int    m_nVoice = -1;
     
    NetMsg(String sText)
    {
        m_sText = sText;
    }
    NetMsg(int nVoice)
    {
        m_nVoice = nVoice;
    }
    
    boolean IsVoice(){ return m_nVoice > -1; }
    
    
    //hud na ktorym ma sie znalesc komunikat
    final static int _TARGETHUD_INCOMING  = 0;
    final static int _TARGETHUD_OBJECTIVE = 1;
    
    //kolor w jakim ma sie wyswietlc komunikat
    final static Vector _COLOR_WHITE    = new Vector(1.0f,1.0f,1.0f);
    final static Vector _COLOR_YELLOW   = new Vector(1.0f,1.0f,0.0f);
    final static Vector _COLOR_RED      = new Vector(1.0f,0.4f,0.4f);
    final static Vector _COLOR_BLUE     = new Vector(0.4f,0.4f,1.0f);
    final static Vector _COLOR_TURKUS   = new Vector(0.0f,1.0f,1.0f);
    final static Vector _COLOR_GREEN    = new Vector(0.0f,1.0f,0.0f);
    final static Vector _COLOR_DEFAULT  = _COLOR_WHITE;     
    
    final static Vector _COL_INMSG_DEFAULT = _COLOR_WHITE;
    final static Vector _COL_INMSG_SERVER  = _COLOR_TURKUS;//_COLOR_RED;
    final static Vector _COL_INMSG_COMMAND = _COLOR_TURKUS;
    final static Vector _COL_INMSG_ADMIN   = _COLOR_TURKUS;//_COLOR_WHITE;
    final static Vector _COL_INMSG_SYSTEM  = _COLOR_GREEN;
    final static Vector _COL_INMSG_GAME    = _COLOR_YELLOW;
    final static Vector _COL_INMSG_CHAT    = _COLOR_WHITE;
    final static Vector _COL_INMSG_CHAT_MY = _COLOR_WHITE;
        
    //dzwiek jaki ma towarzyszyc komunikatowi
    static String _SND_INMSG_DEFAULT  = "Data/Sounds/Net/Msg/Default";
    static String _SND_INMSG_SERVER   = "Data/Sounds/Net/Msg/Server";
    static String _SND_INMSG_SYSTEM   = "Data/Sounds/Net/Msg/System";
    static String _SND_INMSG_GAME     = "Data/Sounds/Net/Msg/Game";
    
    static String _SND_INMSG_CHAT     = "Data/Sounds/Net/Msg/Chat";
    static String _SND_INMSG_CHAT_MY  = "Data/Sounds/Net/Msg/ChatMy";
    
    static String _SND_INMSG_GAME_PLAYEREXCLUDED_MY = "Data/Sounds/Net/Msg/PlayerExcluded";
    static String _SND_INMSG_GAME_OBJECTCAPTURED_MY = "Data/Sounds/Net/Msg/ObjectCaptured";
    static String _SND_INMSG_GAME_FLAGCAPTURED_MY   = "Data/Sounds/Net/Msg/FlagCaptured";
    static String _SND_INMSG_GAME_FLAGDELIVERED_MY  = "Data/Sounds/Net/Msg/FlagDelivered";
    static String _SND_INMSG_GAME_FLAGRETURNED_MY   = "Data/Sounds/Net/Msg/FlagReturned";
    static String _SND_INMSG_GAME_FLAGDROPPED_MY    = "Data/Sounds/Net/Msg/FlagDropped";
    static String _SND_INMSG_GAME_BASEDESTROYED_MY  = "Data/Sounds/Net/Msg/BaseDestroyed";
        
    // Komunikaty pojawiajace sie na liscie komunikatow przychodzacych
    static String sGameStarted      = "Game Started.";
    static String sGameOver         = "Game Over.";
    static String sGameRestarted    = "Game Restarted.";
    static String sGameRestartedNextRound = "Next Round Started";
    static String sGameRestartedNextRevengeRound = "Next Round Started. Teams Swapped Sides.";
    static String sGameRestartedRevengeMatch = "Revenge match started.";
    
    static String sYouJoinedGame            = "You have joined the game";
    static String sPlayerJoinedGame         = "Player '%s' has joined the game";
    static String sYouCantJoinGame          = "You can't join the game";
    static String sYouCantJoinGameBecauseWrongCRCMap = "You can't join the game. Wrong map CRC";
    static String sYouCantJoinGameBecauseWrongGameVersion = "You can't join the game. Wrong game version.";
    
    static String sYouJoinedGameTeam        = "You have joined game as %s";
    static String sPlayerJoinedGameTeam     = "Player '%s' has joined the game as %s";
    
    static String sYouKilled                = "You have been killed.";
    static String sPlayerKilled             = "Player '%s' has been killed";
    static String sYouKilledByYouSelf       = "You have been killed by yourself.";
    static String sPlayerKilledByHisSelf    = "Player '%s' has been killed by himself";
    static String sYouKilledByPlayer        = "You have been killed by '%s'";
    static String sPlayerKilledByYou        = "Player '%s' has been killed by you";
    static String sPlayerKilledByPlayer     = "Player '%s' has been killed by '%s'";
     
    
    static String sFlagBlue = "BLUE";
    static String sFlagRed = "RED";
    static String sFlagRedFullName = "Flag RED";
    static String sFlagBlueFullName = "Flag BLUE";

    
    static String sFlagCapturedByYou = "You have captured the %s flag";
    static String sFlagCapturedByPlayer = "The %s flag has been captured by '%s'";
    static String sFlagCaptured = "Flag %s has been captured";
        
    static String sFlagDroppedByYou = "You have dropped the %s flag!";
    static String sFlagDroppedByPlayer = "The %s flag has been dropped by '%s'";
    static String sFlagDropped = "The %s flag has been dropped";
            
    static String sFlagReturnedByYou = "You have returned the %s flag to the base!";
    static String sFlagReturnedByPlayer = "The %s flag has been returned to the base by '%s'";
    static String sFlagReturned = "The %s flag has been returned to the base";
        
    static String sFlagDeliveredByYouTeamScored = "You have delivered the %s flag, '%s' team scores";
    static String sFlagDeliveredByPlayerTeamScored = "The %s flag has been delivered by '%s', '%s' team scores";
    static String sFlagDeliveredTeamScored = "The %s flag has been delivered, team '%s' scores";
        
    //TODO
    static String sBaseCapturedByYouYouAreOwner    = "You have captured the base";
    static String sBaseCapturedByPlayerHeIsOwner   = "Base has been captured by '%s'";
    static String sBaseCapturedByYouYouTeamIsOwner = "Base has been captured by you, team '%s' is now controlling it";
    static String sBaseCapturedByPlayerTeamIsOwner = "Base has been captured by '%s', team '%s' is now controlling it";
    static String sBaseLostByYou                   = "You lost control.";
    static String sBaseLostByPlayer                = "Player '%s' has lost control.";
        
    static String sFrontBaseBlue = "Base BLUE";
    static String sFrontBaseRed = "Base RED";
    static String sBaseDestroyed = "Object %s has been destroyed";
    static String sBaseDestroyedByYou = "Object %s has been destroyed by you";
    static String sBaseDestroyedByPlayer = "Object %s has been destroyed by '%s'";
    
    static String sAssaultObjectiveCompletedTeamScored = "'%s' Team wins the round.";
    static String sAssaultObjectiveFailedTeamScored    = "'%s' Team wins the round.";
    
    static String sYouLeftGame              = "You have left the game";
    static String sPlayerLeftGame           = "'%s' has left the game";
    static String sYouAssignedToTeam        = "You have joined the %s team";
    static String sPlayerAssignedToTeam     = "'%s' has joined the %s team";
    static String sYouChangedTeamFor        = "You have changed the team to %s";
    static String sPlayerChangedTeamFor     = "'%s' has changed the team to %s";
    static String sYouChangedTeam           = "You have changed the team";
    static String sPlayerChangedTeam        = "'%s' has changed the team";
    
    
    
    static String sYouRespawnLimitOut       = "Wlasnie wykorzystales limit spawnow!";
    static String sPlayerRespawnLimitOut    = "Gracz '%s' wlasnie wykorzystal limit spawnow!";
    
    static String sYouExcluded              = "You have been excluded";
    static String sPlayerExcluded           = "'%s' has been excluded";
    static String sTeamExcluded             = "Team '%s' has been excluded";
   
    static String sNextLevel                = "Next map %s";
    
    static String sServerMessage            = "<SERVER> %s";
    static String sAnswerCommand            = "%s %s";
    
    //zauwaznono problem z polaczeniem
    static String sServerNotResponding      = " < Server is not responding! > ";
    //problem z polaczeniem trwa juz od jakiegos czasu
    static String sConnectionToServerLost   = " < Connection To Server Lost! > ";
    //komunikat z niskiego poziomu o rozlaczeniu z serwerem
    static String sDisconnectFromServer     = " < Connection To Server Lost! > ";
    //static String sServerDown               = " < Server down! > ";
    

    
    // dodatkowe komunikaty pojawiajace sie na oknie statystyk
    // nie zawsze beda "wolane" przez system komunikatow
    
    static String sTipWelcomeOnDedicatedServer = "Dedicated server started.";
    static String sTipChooseTeam               = "Choose team:   '1' - BLUE,   '2' - RED"; 
    static String sTipPressEnterToRespawn      = "Press FIRE to spawn.";
    static String sTipRespawnOrInventoryRoom   = "FIRE - spawn, '%s' - inventory room.";
    static String sTipPressEnterToNextLevel    = "Press ENTER to start the next map";
    static String sTipPleaseWait               = "Please wait...";
    static String sTipCantRespawn              = "You can't spawn";
    static String sTipCantRespawnCauseGameOver = "You can't spawn. Game over.";
    static String sTipCantRespawnCauseLimitOut = "You can't spawn. Respawn limit reached.";
    static String sTipCantRespawnWaitForGameStart  = "Please wait for the game to start.";
    static String sTipGameOver                 = "Game Over.";
    
    static String GetTipRespawnOrInventoryRoom()
    {
        return NetGameTools.MixString( sTipRespawnOrInventoryRoom, 
                                       ControlLoadSave.GetKeyName(
                                                       EGameControl.INVENTORY
                                                                 )
                                     ); 
    }
    
    //zasady gry
    static String sGameRuleUnknown      = " No Game Rules";
    static String sGameRuleFragsAndTime = "Game ends at %s frags or %s minutes";
    static String sGameRulePointsAndTime= "Game ends at %s points or %s minutes";
    static String sGameRuleFragsOnly    = "Game ends at %s frags. No time limit.";
    static String sGameRulePointsOnly   = "Game ends at %s points. No time limit.";
    static String sGameRuleTimeOnly     = "Game ends at %s minutes. No points limit.";
    static String sGameRuleAssaultPointsAndTime= "Game ends at %s points. Round limit time: %s min.";
    
 
    static String sGameTime             = "Time";
    static String sRespawnTimeLimit     = "Time for spawn:";
    static String sSecondsShort         = "sec.";
    
    static String sEnterMessage         = "Enter message:";
    static String sEnterTeamMessage     = "Enter team message:";
    
    
    static String sControllingBase      = "is controlling the base";
    static String sControllingBases     = "is controlling %s bases";
    
    static String sHoldingFlag          = "is holding the flag";
    
    
    static String sTipWaitingForOtherPlayers = "Waiting for other players...";
    static String sAttackingTeam = "Attacking team: '%s'";
    static String sDefendingTeam = "Defending team: '%s'";
    
    static String sYouHaveBeenKickedOutFromTheGame = "You have been kicked out from the game %s.";
    static String sPlayerHasBeenKickedOutFromTheGame = "Player '%s' has been kicked out from the game %s.";
    static String sKickReasonIncompatibleData = "incompatible data";
    static String sKickReasonTeamKill = "team kill";
    static String sKickReasonCheating = "cheating";
    static String sKickReasonIdle = "idle";
    static String sKickReasonLag = "lag";
    
    static String sYouHaveBeenBannedOnTheServer = "You have beenbannedon the server%s.";
    static String sPlayerHasBeenBannedOnTheServer = "Player '%s' has been bannedon the server%s.";

    //TODO: zlokalizowac
    static String sObjectUnderAttack = "Object '%s' is under attack!";
    //to sa te same co sBaseDestroyed...
    static String sObjectDestroyed = "Object '%s' has been destroyed";
    static String sObjectDestroyedByYou = "Object '%s' has been destroyed by you";
    static String sObjectDestroyedByPlayer = "Object '%s' has been destroyed by '%s'";
    
    /*
    static String sMapSettingsHaveBeenChanged = "Map settings have been changed (%s).";
    static String sGameSettingsHaveBeenChanged = "Game settings have been changed (%s).";
    static String sOptionOn  = "on";
    static String sOptionOff = "off";
    
    static String sMapIsWillBeRestarted = "Map is will be restarted"; 
    
    static String sMinTeamsWithPlayersToStartGame = "Min. teams with playersto start game";
    static String sStartGameWhenBothTeamsHavePlayers = "Start game when both teams have players";
    static String sMinPlayersToStartGame = "Min. players to start game";
    static String sAllowSpawnWhenWaitingForTheGameToStart = "Allow spawn when waiting for the game to start";
    */
    
    //jeszcze nie jest przetlumaczone
    //static String sCommandAvailableOnServer = "Command Available On Server";
    
    static void UpdateStrings()
    {
        sGameStarted      = Text.Get("&sGameStarted&");
        sGameOver         = Text.Get("&sGameOver&");
        sGameRestarted    = Text.Get("&sGameRestarted&");
        sGameRestartedNextRound = Text.Get("&sGameRestartedNextRound&");
        sGameRestartedNextRevengeRound = Text.Get("&sGameRestartedNextRevengeRound&");
        sGameRestartedRevengeMatch = Text.Get("&sGameRestartedRevengeMatch&");
        sYouJoinedGame            = Text.Get("&sYouJoinedGame&");
        sPlayerJoinedGame         = Text.Get("&sPlayerJoinedGame&");
        sYouCantJoinGame          = Text.Get("&sYouCantJoinGame&");
        sYouCantJoinGameBecauseWrongCRCMap = Text.Get("&sYouCantJoinGameBecauseWrongCRCMap&");
        sYouCantJoinGameBecauseWrongGameVersion = Text.Get("&sYouCantJoinGameBecauseWrongGameVersion&");
        sYouJoinedGameTeam        = Text.Get("&sYouJoinedGameTeam&");
        sPlayerJoinedGameTeam     = Text.Get("&sPlayerJoinedGameTeam&");
        sYouKilled                = Text.Get("&sYouKilled&");
        sPlayerKilled             = Text.Get("&sPlayerKilled&");
        sYouKilledByYouSelf       = Text.Get("&sYouKilledByYouSelf&");
        sPlayerKilledByHisSelf    = Text.Get("&sPlayerKilledByHisSelf&");
        sYouKilledByPlayer        = Text.Get("&sYouKilledByPlayer&");
        sPlayerKilledByYou        = Text.Get("&sPlayerKilledByYou&");
        sPlayerKilledByPlayer     = Text.Get("&sPlayerKilledByPlayer&");
        sFlagBlue = Text.Get("&sFlagBlue&");
        sFlagRed = Text.Get("&sFlagRed&");
        sFlagRedFullName = Text.Get("&sFlagRedFullName&");
        sFlagBlueFullName = Text.Get("&sFlagBlueFullName&");
        sFlagCapturedByYou = Text.Get("&sFlagCapturedByYou&");
        sFlagCapturedByPlayer = Text.Get("&sFlagCapturedByPlayer&");
        sFlagCaptured = Text.Get("&sFlagCaptured&");
        sFlagDroppedByYou = Text.Get("&sFlagDroppedByYou&");
        sFlagDroppedByPlayer = Text.Get("&sFlagDroppedByPlayer&");
        sFlagDropped = Text.Get("&sFlagDropped&");
        sFlagReturnedByYou = Text.Get("&sFlagReturnedByYou&");
        sFlagReturnedByPlayer = Text.Get("&sFlagReturnedByPlayer&");
        sFlagReturned = Text.Get("&sFlagReturned&");
        sFlagDeliveredByYouTeamScored = Text.Get("&sFlagDeliveredByYouTeamScored&");
        sFlagDeliveredByPlayerTeamScored = Text.Get("&sFlagDeliveredByPlayerTeamScored&");
        sFlagDeliveredTeamScored = Text.Get("&sFlagDeliveredTeamScored&");
        sBaseCapturedByYouYouAreOwner    = Text.Get("&sBaseCapturedByYouYouAreOwner&");
        sBaseCapturedByPlayerHeIsOwner   = Text.Get("&sBaseCapturedByPlayerHeIsOwner&");
        sBaseCapturedByYouYouTeamIsOwner = Text.Get("&sBaseCapturedByYouYouTeamIsOwner&");
        sBaseCapturedByPlayerTeamIsOwner = Text.Get("&sBaseCapturedByPlayerTeamIsOwner&");
        sBaseLostByYou                   = Text.Get("&sBaseLostByYou&");
        sBaseLostByPlayer                = Text.Get("&sBaseLostByPlayer&");
        sFrontBaseBlue = Text.Get("&sFrontBaseBlue&");
        sFrontBaseRed = Text.Get("&sFrontBaseRed&");
        sBaseDestroyed = Text.Get("&sBaseDestroyed&");
        sBaseDestroyedByYou = Text.Get("&sBaseDestroyedByYou&");
        sBaseDestroyedByPlayer = Text.Get("&sBaseDestroyedByPlayer&");
        sAssaultObjectiveCompletedTeamScored = Text.Get("&sAssaultObjectiveCompletedTeamScored&");
        sAssaultObjectiveFailedTeamScored    = Text.Get("&sAssaultObjectiveFailedTeamScored&");
        sYouLeftGame              = Text.Get("&sYouLeftGame&");
        sPlayerLeftGame           = Text.Get("&sPlayerLeftGame&");
        sYouAssignedToTeam        = Text.Get("&sYouAssignedToTeam&");
        sPlayerAssignedToTeam     = Text.Get("&sPlayerAssignedToTeam&");
        sYouChangedTeamFor        = Text.Get("&sYouChangedTeamFor&");
        sPlayerChangedTeamFor     = Text.Get("&sPlayerChangedTeamFor&");
        sYouChangedTeam           = Text.Get("&sYouChangedTeam&");
        sPlayerChangedTeam        = Text.Get("&sPlayerChangedTeam&");
        sYouRespawnLimitOut       = Text.Get("&sYouRespawnLimitOut&");
        sPlayerRespawnLimitOut    = Text.Get("&sPlayerRespawnLimitOut&");
        sYouExcluded              = Text.Get("&sYouExcluded&");
        sPlayerExcluded           = Text.Get("&sPlayerExcluded&");
        sTeamExcluded             = Text.Get("&sTeamExcluded&");
        sNextLevel                = Text.Get("&sNextLevel&");
        sServerMessage            = Text.Get("&sServerMessage&");
        //don't change it!
        //sAnswerCommand            = Text.Get("&sAnswerCommand&");
        sServerNotResponding      = Text.Get("&sServerNotResponding&");
        sConnectionToServerLost   = Text.Get("&sConnectionToServerLost&");
        sDisconnectFromServer     = Text.Get("&sDisconnectFromServer&");
        sTipWelcomeOnDedicatedServer = Text.Get("&sTipWelcomeOnDedicatedServer&");
        sTipChooseTeam               = Text.Get("&sTipChooseTeam&");
        sTipPressEnterToRespawn      = Text.Get("&sTipPressEnterToRespawn&");
        sTipRespawnOrInventoryRoom   = Text.Get("&sTipRespawnOrInventoryRoom&");
        sTipPressEnterToNextLevel    = Text.Get("&sTipPressEnterToNextLevel&");
        sTipPleaseWait               = Text.Get("&sTipPleaseWait&");
        sTipCantRespawn              = Text.Get("&sTipCantRespawn&");
        sTipCantRespawnCauseGameOver = Text.Get("&sTipCantRespawnCauseGameOver&");
        sTipCantRespawnCauseLimitOut = Text.Get("&sTipCantRespawnCauseLimitOut&");
        sTipCantRespawnWaitForGameStart  = Text.Get("&sTipCantRespawnWaitForGameStart&");
        sTipGameOver                 = Text.Get("&sTipGameOver&");
        sGameRuleUnknown      = Text.Get("&sGameRuleUnknown&");
        sGameRuleFragsAndTime = Text.Get("&sGameRuleFragsAndTime&");
        sGameRulePointsAndTime= Text.Get("&sGameRulePointsAndTime&");
        sGameRuleFragsOnly    = Text.Get("&sGameRuleFragsOnly&");
        sGameRulePointsOnly   = Text.Get("&sGameRulePointsOnly&");
        sGameRuleTimeOnly     = Text.Get("&sGameRuleTimeOnly&");
        sGameRuleAssaultPointsAndTime= Text.Get("&sGameRuleAssaultPointsAndTime&");
        sGameTime             = Text.Get("&sGameTime&");
        sRespawnTimeLimit     = Text.Get("&sRespawnTimeLimit&");
        sSecondsShort         = Text.Get("&sSecondsShort&");
        sEnterMessage         = Text.Get("&sEnterMessage&");
        sEnterTeamMessage     = Text.Get("&sEnterTeamMessage&");
        sControllingBase      = Text.Get("&sControllingBase&");
        sControllingBases     = Text.Get("&sControllingBases&");
        sHoldingFlag          = Text.Get("&sHoldingFlag&");
                
        //nowe do dodania do skryptow
        sTipWaitingForOtherPlayers = Text.Get("&sTipWaitingForOtherPlayers&");
        sAttackingTeam        = Text.Get("&sAttackingTeam&");
        sDefendingTeam        = Text.Get("&sDefendingTeam&");
        
        sYouHaveBeenKickedOutFromTheGame = Text.Get("&sYouHaveBeenKickedOutFromTheGame&");
        sPlayerHasBeenKickedOutFromTheGame = Text.Get("&sPlayerHasBeenKickedOutFromTheGame&");
        
        sKickReasonIncompatibleData = Text.Get("&sKickReasonIncompatibleData&");
        sKickReasonTeamKill = Text.Get("&sKickReasonTeamKill&");
        sKickReasonCheating = Text.Get("&sKickReasonCheating&");
        sKickReasonIdle = Text.Get("&sKickReasonIdle&");
        sKickReasonLag = Text.Get("&sKickReasonLag&");

        sYouHaveBeenBannedOnTheServer = Text.Get("&sYouHaveBeenBannedOnTheServer&");
        sPlayerHasBeenBannedOnTheServer = Text.Get("&sPlayerHasBeenBannedOnTheServer&");

        sObjectUnderAttack = Text.Get("&sObjectUnderAttack&");
        sObjectDestroyed = Text.Get("&sObjectDestroyed&");
        sObjectDestroyedByYou = Text.Get("&sObjectDestroyedByYou&");
        sObjectDestroyedByPlayer = Text.Get("&sObjectDestroyedByPlayer&");
    
        /*
        sMapSettingsHaveBeenChanged = Text.Get("&sMapSettingsHaveBeenChanged&");
        sGameSettingsHaveBeenChanged = Text.Get("&sGameSettingsHaveBeenChanged&");
        sOptionOn  = Text.Get("&sOptionOn&");
        sOptionOff = Text.Get("&sOptionOff&");

        sMapIsWillBeRestarted = Text.Get("&sMapIsWillBeRestarted&");
    
        sMinTeamsWithPlayersToStartGame = Text.Get("&sMinTeamsWithPlayersToStartGame&");
        sStartGameWhenBothTeamsHavePlayers = Text.Get("&sStartGameWhenBothTeamsHavePlayers&");
        sMinPlayersToStartGame = Text.Get("&sMinPlayersToStartGame&");
        sAllowSpawnWhenWaitingForTheGameToStart = Text.Get("&sAllowSpawnWhenWaitingForTheGameToStart&");
        */
    }
}
