public class DominationBaseFlagStand extends MeshObject
{
    void OnCreate()
    {
        super.OnCreate();
        
        SetFlag( EFlags._PORTAL_INDEPENDENT );
        ClearFlag( EFlags._COLLISION );
    
        // preloadujemy skiny
        PreloadSkin("Red");
        PreloadSkin("Blue");
        PreloadSkin("Green");
    }
    
    public void OnDestroy()
    {
        super.OnDestroy();
        
        UnloadSkin("Red");
        UnloadSkin("Blue");
        UnloadSkin("Green");
    }
    
    
    
    void SetLocalState(int nState)   
    {   
        String sSkin = "Default";

        switch ( nState )
        {
        case DominationBase._STATE_ENEMY:
        case DominationBase._STATE_RED:
            sSkin = "Red";
            break;
        case DominationBase._STATE_BLUE:
            sSkin = "Blue";
            break;
        case DominationBase._STATE_OWNER:
            sSkin = "Green";
            break;
        }
        
        SetSkin( sSkin );
    }
    
    Vector GetFlagPos()
    {
        int nId = GetElementID("hook1");
        if ( nId > 0 )
            return GetElementPos( nId );
        return GetPosition();
    }
}
