public class SpareNetObjectsList extends GameObjectsList
{
    void Add(GameObject cObj)
    {
        super.Add( cObj );
        
        if ( cObj instanceof InvObject )
        {
            ((InvObject)cObj).AddedToSpareList();
        }
    }
    //metoda sprawdza czy na liscie istnieje obiekt o podanej klasie
    //jesli tak, to usuwa go z listy i go zwraca
    //jesli nie to zwraca null
    GameObject GetSpareObject( String sClassName )
    {
        GameObject cObj = null;
        boolean bFoundDeleted;
        do 
        {
            bFoundDeleted = false;
            cObj = FindFirstGameObjectOfClass( sClassName );
            if ( cObj != null )
            {
                Remove( cObj );
                
                if ( cObj instanceof InvObject && ((InvObject)cObj).bDeleted )    
                {
                    //GameObject.CrashLog("ERROR: Skasowany obiekt klasy "+sClassName+" na liscie spare\n");
                    bFoundDeleted = true;        
                }
            }
        } while ( bFoundDeleted );
        return cObj;
    }
    
}
