/**CLIENT 
 * Klasa przechowujaca informacje z ostatnio wyslanego 
 * ruchu konieczne do stwierdzania czy doslac serverowi nowy ruch
 */
public class PlayerNetLastSentState
{
    /**Poprzedni motion state
     */
    MotionState cMotion  = null;
    boolean bWalking     = false;
    boolean bDucking     = false;
    boolean bCrawling    = false;
    boolean bRecoiling   = false;
    byte    nHitReaction = 0;
    float   fSpeedMult   = 1.0f;
    
    /** ostatnio ustawiona pozycja patrzenia
     */
    Vector      vDir    = null;
    /** czas kiedy ostatnio wyslano serverowi ruch
     */
    float       fTime   = 0.0f;
    
    ControlObject cParent = null;
    
    PlayerNetLastSentState()
    {
        cMotion = new MotionState();
        vDir    = new Vector();
        cParent = null;
        fTime   = 0.0f;
    }
    PlayerNetLastSentState(Player cPlayer,float fTime)
    {
        cMotion             = new MotionState( cPlayer.motion );
        bWalking            = cPlayer.bWalking;
        bDucking            = cPlayer.bDucking;
        bCrawling           = cPlayer.bCrawling;
        fSpeedMult          = cPlayer.fSpeedMult;
        bRecoiling          = cPlayer.bRecoiling;
        nHitReaction        = cPlayer.nHitReaction;
        vDir                = cPlayer.GetAimDirection();
        cParent             = cPlayer.GetParent();
        this.fTime          = fTime;
        
        //po to by "lapal" podskoki wystepujace szybko po sobie
        cMotion.nJumping = MotionState._CLIMBING_FALSE; 
    }
    
    boolean TimeOut(float fTimeNow)
    {
        return (fTimeNow - fTime) > PlayerNetBaseMover._MAX_RESEND_MOVE_TIME;    
    }
}
