public class ChangeStateCounter
{
    private final static int _INIT_VALUE = -1;
    private int m_nCounter = _INIT_VALUE;
    
    static int GetInitValue(){ return _INIT_VALUE; }
    
    
    GameObject m_cOwner = null;
    String     m_sOwner = null;
    
    ChangeStateCounter(GameObject cOwner)
    {
        this();
        m_cOwner = cOwner;
    }
    ChangeStateCounter(String sOwner)
    {
        this();
        m_sOwner = sOwner;
    }
    ChangeStateCounter()
    {
        Clean();
    }
    
    void Clean()
    { 
        m_nCounter = _INIT_VALUE; 
    }
    
    void Destroy()
    {
        m_cOwner = null;
        m_sOwner = null;
    }
        
        
    int Get() 
    { 
        return m_nCounter;
    }
    
    int GetNext() 
    { 
        ++m_nCounter;
        NetLog.Counter( "GETNEXT " + GetNetInfo() );
        return m_nCounter;
    }
  
    
    boolean Verify( int nCounter )
    {
        if ( m_nCounter < nCounter )
        {
            if ( NetLog.IsEnabled( NetLog._TYPE_COUNTER ) )
            {
                if ( (NetLog.IsEnabled( NetLog._TYPE_ASSAULT)) &&
                     (m_cOwner instanceof NetGameInfoASSAULT) )
                {
                    NetLog.Counter("ASSAULT verify ok - "+
                                   ((m_cOwner!=null)?m_cOwner.GetNetInfo():""+this)+
                                    " my:"+m_nCounter+",in:"+nCounter );
                }
                else
                if ( (NetLog.IsEnabled( NetLog._TYPE_DESTROYABLE)) &&
                     (m_cOwner instanceof DestroyableNet) )
                {
                    NetLog.Counter("DESTROYABLE verify ok - "+
                                ((m_cOwner!=null)?m_cOwner.GetNetInfo():""+this)+
                                " my:"+m_nCounter+",in:"+nCounter );
                }
                else
                    NetLog.Counter( "OK " + GetNetInfo()+ " (inVal:"+nCounter);
            }
            m_nCounter = nCounter;
            return true;
        }
        else
        {
            if ( NetLog.IsEnabled( NetLog._TYPE_COUNTER ) )
            {
                if ( (NetLog.IsEnabled( NetLog._TYPE_ASSAULT)) &&
                     (m_cOwner instanceof NetGameInfoASSAULT) )
                {
                    NetLog.Counter("ASSAULT --------- verify failed - "+
                                   ((m_cOwner!=null)?m_cOwner.GetNetInfo():""+this)+
                                   " my:"+m_nCounter+",in:"+nCounter );
                }
                else
                if ( (NetLog.IsEnabled( NetLog._TYPE_DESTROYABLE)) &&
                     (m_cOwner instanceof DestroyableNet) )
                {
                    NetLog.Counter("DESTROYABLE --------- verify failed - "+
                                   ((m_cOwner!=null)?m_cOwner.GetNetInfo():""+this)+
                                   " my:"+m_nCounter+",in:"+nCounter );
                }
                else
                    NetLog.Counter("FAILED " + GetNetInfo()+ " (inVal:"+nCounter);
            }
        }
        return false;
    }
    
    String GetNetInfo()
    {
        String sOwner = ""+this;
        if (m_cOwner!=null)
            sOwner = m_cOwner.GetNetInfo();
        else if (m_sOwner!=null)
            sOwner = m_sOwner;
        
        return sOwner+" myVal:"+m_nCounter;
    }
    
}
