public class PrecacheNet extends Precache
{
    public static int ID_DIALOG = 1;
    MenuYesNoDialog cYesNoDialog = null;
    String sProgress = null;
    
    CursorChrome cCursor = null;
    
    MeshObject cHSoldier = null;
    MeshObject cHSoldierDead = null;
    
    String[] aMeshesToPrecache = new String[] {"Data/Meshes/Equipment/ammo_12ga.3DA",
                                "Data/Meshes/Equipment/ammo_12short.3DA",
                                "Data/Meshes/Equipment/ammo_14long.3DA",
                                "Data/Meshes/Equipment/ammo_8long.3DA",
                                "Data/Meshes/Equipment/ammo_9short.3DA",
                                "Data/Meshes/Equipment/ammo_electro.3DA",
                                "Data/Meshes/Equipment/DragoonAmmo.3da",
                                "Data/Meshes/Equipment/Drag_health.3da",
                                "Data/Meshes/Equipment/Drag_neural.3da",
                                "Data/Meshes/Equipment/granat_zaczepny.3DA",
                                "Data/Meshes/Equipment/granat_zaczepny_fly.3DA",
                                "Data/Meshes/Equipment/grenade_cluster_part.3DA",
                                "Data/Meshes/Equipment/Lornetka.3da",
                                "Data/Meshes/Equipment/m_pistolet.3DA",
                                "Data/Meshes/Equipment/m_rifle.3DA",
                                "Data/Meshes/Equipment/m_sniper1.3DA",
                                "Data/Meshes/Equipment/pistol3_b.3DA",
                                "Data/Meshes/Equipment/Rakieta.3da",
                                "Data/Meshes/Equipment/RakietaHex.3DA",
                                "Data/Meshes/Equipment/TPPGauss.3DA",
                                "Data/Meshes/Equipment/TPPGrenadeCluster.3DA",
                                "Data/Meshes/Equipment/TPPGrenadeEMP.3DA",
                                "Data/Meshes/Equipment/TPPheavy.3DA",
                                "Data/Meshes/Equipment/TPPknife.3DA",
                                "Data/Meshes/Equipment/TPPpistol.3DA",
                                "Data/Meshes/Equipment/TPPpistol2.3DA",
                                "Data/Meshes/Equipment/TPPpistol3.3DA",
                                "Data/Meshes/Equipment/TPPpistol3_b.3DA",
                                "Data/Meshes/Equipment/TPPpistol_b.3DA",
                                "Data/Meshes/Equipment/TPPplasma.3DA",
                                "Data/Meshes/Equipment/TPPRifle01.3DA",
                                "Data/Meshes/Equipment/TPProcketl.3DA",
                                "Data/Meshes/Equipment/TPPshotgun.3DA",
                                "Data/Meshes/Equipment/TPPsniper.3DA",
                                "Data/Meshes/Equipment/TPPsniper2.3DA",
                                "Data/Meshes/Equipment/TPPstrzelba.3DA"
                                };
    
    MeshObject[] aPrecahedMeshes = null;
    
    PrecacheNet()
    {
        super();
        bSimplePrecacheMode = true;
        m_sPrecachingText   = Text.Get("&NetPrecaching&");
    }
    
    public void OnCreate()
    {
        super.OnCreate();
    
        //GameObject.EnableLogSum(true);
        
        PrecacheWeapons();
        PrecacheHSoldier();
        PrecacheSounds();
        
        //GameObject.EnableLogSum(false);
    }
    
    public void OnDestroy()
    {
        ReleaseHSoldier();
        ReleaseSounds();
        
        DisablePrecacheNetMethods();
        
        if (cYesNoDialog != null)
        {
            ReleaseDialog();
        }
        
        super.OnDestroy();
    }
    
    void OnFrame()
    {
    }
    
    void StartGameInTime(float fTime)
    {
        CallMethodIn( "StartGame",fTime );
    }
    
    void StartGame()
    {
        //wszystkie dotychczasowe funkcje sa juz niepotrzebne
        DisablePrecacheNetMethods();
        
        ModuleNet cModule = (ModuleNet)GetModule();
        if (cModule != null)
        {
            if (cModule.Role < ERole._AUTHORITY)
            {
                //robimy ostateczne zapytanie o stan servera
                QueryServerState();

                //iFinalChecksLeft = 10;
                CallMethodIn("FinalServerCheck", 0.0f);
                
                //za 5s odpalamy okno z "waiting for server response"
                CallMethodIn("StartDialog", 5.0f);
                
                cCursor =(CursorChrome)CreateObject("CursorChrome");
                cCursor.Init(cModule);
                cCursor.Hide();
            }
            else
            {
                ConfirmedStartGame();
            }
        }
    }
    
    void PrecacheWeapons()
    {
        // precachujemy cyferki
        PrecacheDigits();

        aPreloadedWeapons = new java.util.Vector(10);
        
        LevelContent cLevelCont = ((ChromeModule)GetModule()).cGameInitInfo.cLevels.GetCurrent();
        for(int i=0; i<cLevelCont.aInventoryRoomModifiers.size(); ++i)
        {
            InventoryRoomModifier cModifier = (InventoryRoomModifier)cLevelCont.aInventoryRoomModifiers.get(i);
            
            if(cModifier.m_Command == EInventoryRoomModifiers._SET)
            {
//                CrashLog("cModifier.m_Object.m_Name="+cModifier.m_Object.m_Name+"\n");
                InvObject cInvObj = (InvObject)GetObjectOfClass( cModifier.m_Object.m_Name );
                if(cInvObj instanceof Weapon)
                {
                    PrecacheWeaponFPP((Weapon)cInvObj);
                }
            }
        }
        
        //LogR("aPreloadedWeapons.size()="+aPreloadedWeapons.size()+"\n");
    }
    
    
    //okresla, ile jeszcze sprawdzen przeprowadzimy, przed stwierdzeniem, ze nie podlaczymy
    //sie do servera   
    //int iFinalChecksLeft = 0;
    
    void FinalServerCheck()
    {
        //LogR("[PrecacheNet.FinalServerCheck] CheckServerState() call\n");
        int iState = CheckServerState();        
        if (iState == EQueryServerStateResponse.NO ||
            iState == EQueryServerStateResponse.CONNECTION_LOST /*||
            iFinalChecksLeft == 0*/)
        {
            CrashLog("[PrecacheNet::FinalServerCheck] cannot join server\n");            
                    
            DisablePrecacheNetMethods();
            ReleaseDialog();
            
            CallOnFrameEnd("ExitServerAndReturnToMenu");
        }
        else if (iState == EQueryServerStateResponse.YES)
        {
            ConfirmedStartGame();
        }
        else
        {
            //--iFinalChecksLeft;
            CallMethodIn("FinalServerCheck", 1.0f);
        }
    }
    
    void ConfirmedStartGame()
    {
        //dla pewnosci...
        DisablePrecacheNetMethods();
        
        ModuleNet cModule = (ModuleNet)GetModule();
        if ( cModule != null )
            cModule.RemoveSprite(this);
        CallMethodIn("delete", 0.0f);                

        if (cModule.Role < ERole._AUTHORITY &&
            cModule.GetGameInitInfo().GetServerInfo().IsInternetGame() == true)
        {
            MasterClient.GetMasterClient().JoinGame();
        }
        
        GameObject.SendClientAliveSignal();
    }
    
    public void StartDialog()
    {
        cText.DisplayText("");
        
        cYesNoDialog = (MenuYesNoDialog)CreateObject("MenuYesNoDialog");
        cYesNoDialog.SetCallback(this, null, "Canceled");
        
        sProgress = "";
        cYesNoDialog.InitCancel(ID_DIALOG, "&WAITING_FOR_SERVER_RESPONSE&", sProgress, null);
            
        cYesNoDialog.Show();
        cYesNoDialog.MoveTop();
        
        CallMethodIn("ProgressFn", 0.0f);
        
        QueryServerState();
        
        if (cCursor != null)
        {
            cCursor.Show();
            cCursor.MoveTop();
        }
    }
    
    public void ProgressFn()
    {
        if (cYesNoDialog != null)
        {
            if (sProgress.length() < 15)
                sProgress += ".";
            else
            {
                sProgress = "";
                
                QueryServerState();       
            }
            
            CallMethodIn("ProgressFn", 1.0f);
        
            cYesNoDialog.SetQuestionText(sProgress);
        }
/*
        CrashLog("[PrecacheNet.ProgressFn] CheckServerState() call\n");
        int iState = CheckServerState();
        if (iState == EQueryServerStateResponse.NO ||
            iState == EQueryServerStateResponse.CONNECTION_LOST)
        {
            CrashLog("[PrecacheNet::ProgressFn] cannot join server\n");

            DisablePrecacheNetMethods();
            ReleaseDialog();
            CallOnFrameEnd("ExitServerAndReturnToMenu");
        }
//*/        
    }
    
    public void Canceled()
    {
        Log("[PrecacheNet::Canceled]\n");
            
        DisablePrecacheNetMethods();
        ReleaseDialog();
        CallOnFrameEnd("ExitServerAndReturnToMenu");
    }
    
    void QueryServerState()
    {
        Module cModule = GetModule();
        if ( cModule != null )
        {
            //CrashLog("[PrecacheNet.QueryServerState] map: " + ((ModuleNet)cModule).GetGameInitInfo().GetCurrentLevelName() + "\n");
            CheckServerStateStart(((ModuleNet)cModule).GetGameInitInfo().GetCurrentLevelName());
        }
    }
    
    void ReleaseDialog()
    {
        if (cYesNoDialog != null)
        {
            cYesNoDialog.Remove();
            RemoveSprite(cYesNoDialog);
            cYesNoDialog.delete();
            cYesNoDialog = null;
        }
        
        if (cCursor != null)
        {
            cCursor.Destroy();
            cCursor.delete();
            cCursor = null;
        }
    }
    
    void ExitServerAndReturnToMenu()
    {
        //deaktywujemy modul sieciowy
        Module cModule = GetModule();
        if ( cModule != null )
        {
            cModule.Deactivate();
        }
        
        //RemoveSprite(this);
        //aktywujemy modul menu - on w czasie aktywacji zalatwi reszte
        ChromeMenuModule cMenu = ((ChromeGame)ChromeGame.cSingleton).Menu;
        cMenu.ActiveLevelReturnValue = ChromeModule._LEVEL_CLIENT_FAILED_TO_ENTER_GAME;
        cMenu.Activate();
    }
    
    void DisablePrecacheNetMethods()
    {
        DisableCallMethod("StartDialog");
        DisableCallMethod("ProgressFn");
        DisableCallMethod("StartGame");
        DisableCallMethod("FinalServerCheck");        
    }
    
    java.util.Vector aPreloadSkin = new java.util.Vector(50);
    
    void PrecacheHSoldier()
    {
        //TODO: odczytac ze skryptu ModelsNet.scr wszystkie dostepne
        //meshe w grze i je zaczytac (wraz z ich trupkami)
        
        cHSoldier = (MeshObject)CreateObjectNoInit("MeshObject");
        cHSoldier.MeshName = "Data/Meshes/AI/HSoldierNet.3DA";
        cHSoldier.InitObject();
        
        cHSoldierDead = (MeshObject)CreateObjectNoInit("MeshObject");
        cHSoldierDead.MeshName = "Data/Meshes/AI/HSoldierNetDead.3DA";
        cHSoldierDead.InitObject();
        
        aPrecahedMeshes = new MeshObject[aMeshesToPrecache.length];
        for(int i=0; i<aMeshesToPrecache.length; ++i)
        {
            aPrecahedMeshes[i] = (MeshObject)CreateObjectNoInit("MeshObject");
            aPrecahedMeshes[i].MeshName = aMeshesToPrecache[i];
            aPrecahedMeshes[i].InitObject();
        }
        
        // pobieramy wszystkie skiny
        ParseKeyword cRoot = ParseFile("Data/Meshes/AI/HSoldierNet.skn");
        
        if (cRoot!=null)
        {
            ParseKeyword cKey;
            for(cKey=cRoot; cKey!=null; cKey=cKey.GetNext() )
            {
                if (cKey.Equals("Skin"))
                {
                    String sSkin = cKey.GetSParam(0);
                    
                    // preloadujemy tylko materialy z @
                    if(sSkin.startsWith("@"))
                    {
                        aPreloadSkin.addElement(sSkin);
                        cHSoldier.PreloadSkin(sSkin);
                    }
                }
            }
        
            cRoot.delete();
        }
    }
    
    void ReleaseHSoldier()
    {
        if(aPreloadSkin == null) return;
        for(int i=0; i<aPreloadSkin.size(); ++i)
        {
            String sSkin = (String)aPreloadSkin.elementAt(i);
            cHSoldier.UnloadSkin(sSkin);
        }
    }
    
    void PrecacheSounds()
    {
        LoadSoundTemplates("Data\\Sounds\\NetPrecacheSounds.ini");
    }
    
    void ReleaseSounds()
    {
        //TODO czy wogole da sie kasowac dzwieki ze skryptu?
    }
}
    