public class NewAIDino extends NewAIAnimal
{
    float _MAX_STEP_SHAKE_DIST = 3500;
    float _MAX_STEP_SHAKE_DIST2 = _MAX_STEP_SHAKE_DIST * _MAX_STEP_SHAKE_DIST;
    float _MAX_STEP_SHAKE_STRENGTH = 120;    
    
    NewAIDino()
    {
        MeshName = "Data/Meshes/Animals/Dino.3DA";
        m_aMotionVelocity = new float[] {80, 80, 80, 80, 80, 600};
        m_aMotionAngularVelocity = new float[] { 80, 80, 80, 80, 80, 100 };
        
        m_aAggressiveMotionVelocity = new float[] {70, 70, 70, 70, 70, 600};
        m_aAggressiveMotionAngularVelocity = new float[] { 100, 100, 100, 100, 100, 100 };
        aDamageMultipliers = new float[] { 1.f, 1.f, 1.f, 1.f};

        fHealth = fMaxHealth = 2000;

        fSightRange = 2000;
        fSightRangeRecognitionMult = 0.5f;
        fSightAngle = 180;
        fMaxEnemyRecognitionTime = 3.f;
        fMaxEnemyKeepingDistance = 2000;
        
        fBiteDamage = 2000;
        fBiteAttackRange = 330.f;
        sJawElementName = "Bip01 Ponytail2";
        fJawSize = 120;
        fBiteAnimDelay = 0.5f;
        m_fTimeBtwBites = 1.f;
        m_iPathFinderStampSize = 8;
        m_fDestinationRadius = 100;
        
        sDeathSound = "Data/Sounds/Animals/DinoDeath";
        sHitSound = "Data/Sounds/Animals/DinoHit";
        sStepSoundAttack = "Data/Sounds/Animals/DinoAttackStep";
        sAttackSound = "Data/Sounds/Animals/DinoAttack";
        sBlobMaterial = "blob_dino.mat";
        fBlobMapSize = 255;
    }
    
    
    public void OnCreate()
    {
        super.OnCreate();
        
        m_Anims = new AIAnimationsDino(0);
        m_Anims.Initialize(this, sAnimSeqFile, "", "");

        SetAnimMorphTime(0.7f);
        SetEllipsoid(300, 300, 150); 
        SetEllipsoidNoExtents(270, 300, 150); 
    }

    
    
    public void StepDone()
    {
        super.StepDone();
        if (!SoundEmitter.bListenerInsideBuilding &&
            m_Motion.GetSpeed() == MotionState.SPEED_RUN)
        {
            Player player = ((ChromeModuleSingle)GetModule()).MainPlayer;
            float dist2 = GetDistance2To(player);
            float val = _MAX_STEP_SHAKE_STRENGTH *
                        (1 - Tools.InterpLinear(0, _MAX_STEP_SHAKE_DIST2, dist2));
            if (val > 1)
                player.Camera.ShakeImpulse(0, val, 0, CameraPlayer._SHAKE_STEPS);
        }
    }
}
