public class NewAILizard extends NewAIAnimal
{
    NewAILizard()
    {
        MeshName = "Data/Meshes/Animals/Lizard.3DA";

        m_aMotionVelocity = new float[] {150, 150, 150, 150, 150, 600};
        m_aMotionAngularVelocity = new float[] { 60, 60, 60, 60, 60, 300 };
        
        m_aAggressiveMotionVelocity = new float[] {150, 150, 150, 150, 150, 600};
        m_aAggressiveMotionAngularVelocity = new float[] { 300, 300, 300, 300, 300, 300 };
        aDamageMultipliers = new float[] { 3.f, 1.f, 1.f, 1.f};

        fHealth = fMaxHealth = 1000;

        fSightRange = 4000;
        fSightRangeRecognitionMult = 0.5f;
        fSightAngle = 230;
        fMaxEnemyRecognitionTime = 3.f;
        fMaxEnemyKeepingDistance = 2000;
        
        fBiteDamage = 300;
        fBiteAttackRange = 170.f;
        sJawElementName = "Bip01 PonyTail1";
        fJawSize = 80;
        fBiteAnimDelay = 0.4f;
        m_fTimeBtwBites = 1f;
        
        sDeathSound = "Data/Sounds/Animals/LizardDeath";
        sHitSound = "Data/Sounds/Animals/LizardHit";
        sStepSoundAttack = "Data/Sounds/Animals/LizardAttackStep";
        sAttackSound = "Data/Sounds/Animals/LizardAttack";
        
        sBlobMaterial = "blob_lizard.mat";
        fBlobMapSize = 120;
        m_iPathFinderStampSize = 5;
    }
    
    
    public void OnCreate()
    {
        super.OnCreate();
        
        m_Anims = new AIAnimationsLizard(0);
        m_Anims.Initialize(this, sAnimSeqFile, "", "");

        SetAnimMorphTime(0.5f);
        SetEllipsoid(160, 160, 80);
        SetEllipsoidNoExtents(100, 160, 80);
    }
}
