public class AIAnimationsWalker extends AIAnimations
{
    //////////////////////////////////////////////////
    // Indeksy do tablicy animacji
    
    /** Poruszanie sie */
    public final static int A_STAND                 = 0;
    public final static int A_FORWARD               = 1;
    public final static int A_BACKWARD              = 2;
    public final static int A_ROTATE_LEFT           = 3;
    public final static int A_ROTATE_RIGHT          = 4;
    
    /** Zmiana stanu */
    public final static int A_NORMAL2STANDBY        = 5;
    public final static int A_STANDBY               = 6;
    public final static int A_STANDBY2STANDBY_OPEN  = 7;
    public final static int A_STANDBY_OPEN          = 8;
    public final static int A_STANDBY_OPEN2STANDBY  = 9;
    public final static int A_WAKEUP                = 10;
    public final static int A_NORMAL2UP             = 11;
    public final static int A_UP                    = 12;
    public final static int A_UP2NORMAL             = 13;
    public final static int A_NORMAL2DOWN           = 14;
    public final static int A_DOWN                  = 15;
    public final static int A_DOWN2NORMAL           = 16;

    ///////////////////////////////////////////////////////////////////////////////
    
    
    
    ///////////////////////////////////////////////////////////////////////////////

    public AIAnimationsWalker(int nVal)
    {
        super(nVal);
    }
    
    
    public void InitializeImmutableAnimations()
    {
        m_aAnims[A_STAND]                = m_OwnerMesh.GetAnimID(m_sRootElementName, "normal");
        m_aAnims[A_FORWARD]              = m_OwnerMesh.GetAnimID(m_sRootElementName, "walk");
        m_aAnims[A_BACKWARD]             = m_OwnerMesh.GetAnimID(m_sRootElementName, "walk_back");
        m_aAnims[A_ROTATE_LEFT]          = m_OwnerMesh.GetAnimID(m_sRootElementName, "rotate_left");
        m_aAnims[A_ROTATE_RIGHT]         = m_OwnerMesh.GetAnimID(m_sRootElementName, "rotate_right");
        m_aAnims[A_NORMAL2STANDBY]       = m_OwnerMesh.GetAnimID(m_sRootElementName, "normal-standby");
        m_aAnims[A_STANDBY]              = m_OwnerMesh.GetAnimID(m_sRootElementName, "Standby");
        m_aAnims[A_STANDBY2STANDBY_OPEN] = m_OwnerMesh.GetAnimID(m_sRootElementName, "standby-standby_open");
        m_aAnims[A_STANDBY_OPEN]         = m_OwnerMesh.GetAnimID(m_sRootElementName, "standby_open");
        m_aAnims[A_STANDBY_OPEN2STANDBY] = m_OwnerMesh.GetAnimID(m_sRootElementName, "Standby_open-standby");
        m_aAnims[A_WAKEUP]               = m_OwnerMesh.GetAnimID(m_sRootElementName, "Wakeup");
        m_aAnims[A_NORMAL2UP]            = m_OwnerMesh.GetAnimID(m_sRootElementName, "normal-up");
        m_aAnims[A_UP]                   = m_OwnerMesh.GetAnimID(m_sRootElementName, "up");
        m_aAnims[A_UP2NORMAL]            = m_OwnerMesh.GetAnimID(m_sRootElementName, "up-normal");
        m_aAnims[A_NORMAL2DOWN]          = m_OwnerMesh.GetAnimID(m_sRootElementName, "normal-down");
        m_aAnims[A_DOWN]                 = m_OwnerMesh.GetAnimID(m_sRootElementName, "down");
        m_aAnims[A_DOWN2NORMAL]          = m_OwnerMesh.GetAnimID(m_sRootElementName, "down-normal");
   }
    
    
    
    public void SetupAnimations(AIMotionState cMotion)
    {
    }
}
