public class NewAIWalker extends NewAI implements ISeatVehicle
{
    public NewAIHuman cDriver = null;//#NEWAIWALKER;Driver of this walker
    public float fDieExplosionRange = 1000.f;
    public float fDieExplosionDamage = 1000.f;

    // Trzesienie kamera
    public float fBlowUpShakeStrength = 0;//#NEWAIWALKER;
    public float fBlowUpShakeDistMin = 0;//#NEWAIWALKER;
    public float fBlowUpShakeDistMax = 0;//#NEWAIWALKER;
    
    //////////////////////////////////////////////////////////////
    // Implementacja interface'u ISeatVehicle
    
    protected SeatInfo m_cSeat = null;
    
    boolean m_bSoundDirty = false;
    
    public SeatInfo GetFirstFreeSeat(int nPassengerRole)
    {
        if ( ((m_cSeat.GetRole() == nPassengerRole) || (nPassengerRole == EPassengerRole._VEHICLE_ANY )) &&
             (!m_cSeat.IsOccupied()) &&
             (m_cSeat.GetReserver() == null) )
            return m_cSeat;
        else
            return null;
    }
    
    public void PawnGotIn(SeatInfo info, Pawn pawn) {};
    public void PawnGotOut(SeatInfo info, Pawn pawn) {};
    
    public SeatInfo [] GetSeats()
    {
        SeatInfo tab[] = new SeatInfo[1];
        tab[0] = m_cSeat;
        return tab;
    }
    
    /** Matoda zwraca miejsce kolo pojazdu gdzie moze obiekt wysiasc */ 
    public Vector GetCheckedPosToGetOut(SeatInfo info)
    {
        return null;
    }
    
    public void TurnOffPassengersCollisions()
    {
        if (m_cSeat == null)
            return;
		if (m_cSeat.IsOccupied())
            m_cSeat.GetOccupant().ClearFlag(EFlags._COLLISION);
    }
    
    public void TurnOnPassengersCollisions()
    {
        if (m_cSeat == null)
            return;
		if (m_cSeat.IsOccupied())
            m_cSeat.GetOccupant().SetFlag(EFlags._COLLISION);
    }
    
    /*
    if (info.GetOccupant() == null)
    return info.GetStartPos();
    
    int iFlags = info.GetOccupant().GetFlags();
    info.GetOccupant().ClearFlag(EFlags._BLOCK_TRACE);
    
    Vector vStart = new Vector(info.GetSeatPos());
    Vector vEnd = new Vector(info.GetStartPos());
    Vector vTemp = new Vector(vEnd);
    vTemp.Sub(vStart);
    vTemp.Normalize();
    vTemp.Mul(50f); // grubosc obiektu
    vEnd.Add(vTemp);
    
    vTemp = Collision(vStart, vEnd, this);
    if (vTemp.Distance(vEnd) < 1f)
    {
    vTemp.Set(info.GetStartPos());
    vTemp.fY -= 150f;
    vTemp = Collision(info.GetStartPos(), vTemp, this);
    }
    else
    {
    Vector vMove = new Vector(info.GetStartDir());
    vMove.Mul(info.GetMoveInRadius());
    vEnd.Set(info.GetStartPos());
    vEnd.Add(vMove);
    vTemp = Collision(vStart, vEnd, this);
    if (vTemp.Distance(vEnd) < 1f)
    {
    vTemp.Set(info.GetStartPos());
    vTemp.fY -= 150f;
    vTemp = Collision(info.GetStartPos(), vTemp, this);
    }
    else
    {
    vMove = new Vector(info.GetStartDir());
    vMove.Negate();
    vMove.Mul(info.GetMoveInRadius());
    vEnd.Set(info.GetStartPos());
    vEnd.Add(vMove);
    vTemp = Collision(vStart, vEnd, this);
    if (vTemp.Distance(vEnd) < 1f)
    {
    vTemp.Set(info.GetStartPos());
    vTemp.fY -= 150f;
    vTemp = Collision(info.GetStartPos(), vTemp, this);
    }
    else
    return null;
    }
    }
    info.GetOccupant().SetFlags(iFlags);
    return vTemp;
    }

    void InitializeDriver()
    {
    if (cDriver != null)
    {
    nSeatID = GetElementID("WW_Fotel");
    cDriver.Freeze();
    int nDriveAnim = cDriver.GetAnimID("", "drive");
    int nDriveFrame = cDriver.GetFirstFrame(nDriveAnim);
    cDriver.SetFrame(animID!!!, nDriveFrame, 0);
    cDriver.SetFlag(EFlags._NO_ANIMATION | 
    EFlags._NO_ANIMATION_REFRESH);
    AttachChild(cDriver, nSeatID);
    Vector vPos = GetElementPos(nSeatID);
    vPos.fY -= 30;
    Vector vBack = GetElementForwardVector(nSeatID);
    vBack.Mul(10);
    vPos.Sub(vBack);
    cDriver.FromUpForwardPos(GetElementUpVector(nSeatID),
    GetElementForwardVector(nSeatID),
    vPos);
    cDriver.fDamageThreshold = 1e6f;
    cDriver.ClearFlag(EFlags._CAST_SHADOWS);
    if (cDriver.ActiveWeapon != null)
    cDriver.ActiveWeapon.EnableRendering(false);
    }
    }
    */
    
    
    public float fSightRange = 4000;//#NEWAIWALKER;AI sight range in centimeters
    public float fSightRangeRecognitionMult = 0.75f;//#NEWAIWALKER;fSightRangeRecognitionMult * fSightRange = distance of recognizing object as enemy (if it is enemy)
    public float fSightAngle = 180;//#NEWAIWALKER;AI sight angle in degrees
    /** Mnoznik celnosci AI niezalezny od broni ani jego stanu */
    public float fOverallAIAccMult   = 1.0f;//#NEWAIWALKER;Multiplier of overall AI accuracy
    
    public float fMaxFireDeviation   = 0.1f;
    
    /** FX odpalany po rozwaleniu Walkera */
    String m_sWkrDieBlowFX = "FXBlowWalker";
    /** Dzwiek odpalany po rozwalenio Walkera */
    String m_sWkrDieBlowSound = "Data/Sounds/Explosion/WalkerDieExplosion.wav";
    /** Tablica nazw meshelementow glowy walkera (do ukrycia po smierci) */
    String[] m_aHeadElements = null;

    String m_sMeshElementToLookAt = null;
    int m_nElemPointToLookAt = -1;
    
    protected int m_nVertRotateElem = -1;
    protected int m_nHorizRotateElem = -1;
    protected int m_nGunRotateElem = -1;
    protected int m_nLookFromElem = -1;
    
    /** Droga przebywana w jednej klatce animacji kroku walkera */
    protected float m_fWalkAnimSpeed = 1;
    
    /** ID stanu klapy wejsciowej Walkera */
    public final static int _PANE_CLOSED  = 0;
    public final static int _PANE_OPENING = 1;
    public final static int _PANE_OPENED  = 2;
    public final static int _PANE_CLOSING = 3;
    
    /** Stan klapy wejsciowej */
    protected int m_nCabinState = _PANE_CLOSED;

    /** ID stanu walkera ze wzgledu na kontrolujacego go goscia */
    public final static int _CONTROL_MODE_STANDBY  = 0;
    public final static int _CONTROL_MODE_AI       = 1;
    public final static int _CONTROL_MODE_PLAYER   = 2;
    
    /** Stan walkera ze wzgledu na kontrolujacego go goscia */
    protected int m_nControlMode = _CONTROL_MODE_AI;
    
    /** Dzwieki dla poszczegolnych animacji walkera - tablica indeksowana
     *  intem o wartosci AIAnimationsWalker.A_* (pozycja == null dla animacji bez dzwieku)
     */
    String[] m_aWalkerAnimsSounds = null;

    /** Dzwiek krokow walkera  */
    String m_sStepSound = null;
    
    /** Dzwiek do odpalania w loopie przy obracaniu 'glowy' walkera  */
    String m_sHeadLoopSound = null;
    /** Dzwiek do odpalania w loopie przy obracaniu broni walkera  */
    String m_sGunRotateLoopSound = null;

    /** ID dzwieku m_sHeadLoopSound */
    protected int m_nHeadRotateSoundID = -1;
    /** ID dzwieku m_sGunRotateLoopSound */
    protected int m_nGunRotateSoundID = -1;
   
    
    float _MAX_TARGET_TRACKING_COS;
    float _MAX_TARGET_TRACKING_ANGLE = 45.f;
    
    ///////////////////////////////////////////////////
    int METHOD_StopHeadRotateSound = -1;
    int METHOD_StopGunRotateSound = -1;
    int METHOD_StepDone = -1;
    
    
    public NewAIWalker()
    {
        bForceWholeObjectCollision = false;
        m_iPathFinderStampSize = 7;
        m_fMinAngleToTurnWhileMovingCos = (float)Math.cos(5 * Tools.DEG2RAD);
        bUsePhysicsToDeathFall = false;
        bCanUseRadioCommunication = true;
        bCanTurnWhileMoving = false;
    }
    
    public void OnCreate()
    {
        super.OnCreate();
        
        METHOD_StopHeadRotateSound = RegisterCallMethod("StopHeadRotateSound");
        METHOD_StopGunRotateSound = RegisterCallMethod("StopGunRotateSound");
        METHOD_StepDone = RegisterCallMethod("StepDone");
        
        m_Anims = new AIAnimationsWalker(0);
        m_Anims.Initialize(this, sAnimSeqFile, "", "");

        m_Motion.SetSpeed(MotionState.SPEED_WALK);
        
        SetAnimMorphTime(0.2f);
        SetCollType(ECollFlags.OBJCOL_TYPE_PERFACEOBJECT);
        InitWalkerMesh();
        
        m_nElemPointToLookAt = GetElementID(m_sMeshElementToLookAt);
        if (m_nElemPointToLookAt == -1)
            CrashLog("ERROR !!! NewAIWalker.OnCreate() - m_nElemPointToLookAt == -1\n");
        _MAX_TARGET_TRACKING_COS = (float)Math.cos(_MAX_TARGET_TRACKING_ANGLE * Tools.DEG2RAD);
    }
    
    public void OnPostCreate()
    {
        super.OnPostCreate();

        SetControlMode(m_nControlMode);// Odswiezenie control mode
    }

    public void InitWalkerMesh()
    {
    }
    
    /** Obliczenie drogi przebywanej w jednej klatce animacji chodzenia
     * @param sFoot1 nazwa elementu stopy #1
     * @param sFoot2 nazwa elementu stopy #2
     * @return - ustawia zmienna m_fWalkAnimFrameDistance
     */
    protected void CalcWalkAnimSpeed(String sFoot1, String sFoot2)
    {
        int foot1 = GetElementID(sFoot1),
            foot2 = GetElementID(sFoot2);
        int nNonAIAnimID = m_Anims.m_aAnims[AIAnimationsWalker.A_FORWARD];
        
        // ustaw pierwsza klatke animacji chodzenia
        SetFrame(nNonAIAnimID, GetFirstFrame(nNonAIAnimID), -1);
        
        // pobierz pozycje 'stop'
        Vector vDist = GetElementPos(foot1);
        vDist.Sub(GetElementPos(foot2));
        // zmien na uklad lokalny - fZ bedzie przebywana droga
        vDist = VectorWorldToLocal(vDist);
        
        float fDist = (float)Math.abs(vDist.fZ);
        m_fWalkAnimSpeed = 2 * fDist / (m_Anims.GetLength(AIAnimationsWalker.A_FORWARD) * 
                                        m_Anims.GetFreq(AIAnimationsWalker.A_FORWARD));
    }
    
    
    /** Rozszerzona wersja metody z NewAI. Dodatkowo ustawia predkosc animacji chodzenia
     */
    float GetSpeedValueForMotion(AIMotionState cMotion)
    {
        float fSpeed = super.GetSpeedValueForMotion(cMotion);

        float fAnimSpeed = fSpeed / m_fWalkAnimSpeed;
        if (cMotion.iMoveZ > 0)
            m_Anims.SetFreq(AIAnimationsWalker.A_FORWARD, fAnimSpeed);
        else if (cMotion.iMoveZ < 0)
            m_Anims.SetFreq(AIAnimationsWalker.A_BACKWARD, fAnimSpeed);
        
        return fSpeed;
    }
    
    
    public float m_fMinVertHeadAngle = -25;
    public float m_fMaxVertHeadAngle = 16;
    public float m_fMaxHorizHeadAngle = 40;

    public float m_fHorizVertAddAngle = -20;

    public float m_fMinGunAngle = -15;
    public float m_fMaxGunAngle = 70;

    protected float m_fLastHorizAngle = 0;
    protected float m_fLastVertAngle = 0;
    
    public void RotateHead(float fHorizAngle, float fVertAngle)
    {
        // obetnij wartosci do tych 'bezpiecznych' ze wzgledu na ograniczenia modelu
        fHorizAngle = MathUtils.crop(fHorizAngle, -m_fMaxHorizHeadAngle, m_fMaxHorizHeadAngle);
        fVertAngle = MathUtils.crop(fVertAngle, m_fMinVertHeadAngle, m_fMaxVertHeadAngle);

        // oblicz wzniesienie 'glowy' do gory zalezne od skretu w bok (zeby nie kopal sie w zuchwe)
        float fMaxVertAngle = Tools.InterpLinear(0, m_fMaxHorizHeadAngle, Math.abs(fHorizAngle)) * 
                              m_fHorizVertAddAngle;

        if (fVertAngle > fMaxVertAngle)
            fVertAngle = fMaxVertAngle;

        RotateElementWithAnim(m_nVertRotateElem, Vector.Right, fVertAngle);
        RotateElementWithAnim(m_nHorizRotateElem, Vector.Up, fHorizAngle);

        if ((Math.abs(fHorizAngle - m_fLastHorizAngle) +
             Math.abs(fVertAngle - m_fLastVertAngle)) > 5)
        {
            PlayHeadRotateSound((float)Math.max(GetAnimMorphTime(m_nHorizRotateElem),
                                                GetAnimMorphTime(m_nVertRotateElem)));
        }
        m_fLastHorizAngle = fHorizAngle;
        m_fLastVertAngle = fVertAngle;
    }
    
    void PlayHeadRotateSound(float fTime)
    {
        if (m_nHeadRotateSoundID < 0)
        {            
            if (m_sHeadLoopSound != null)
                m_nHeadRotateSoundID = AttachSound(m_sHeadLoopSound);
        }
        else
            PlaySound(m_nHeadRotateSoundID);
        CallMethodOnceIn(METHOD_StopHeadRotateSound, fTime);
    }
    
    void StopHeadRotateSound()
    {
        if (m_nHeadRotateSoundID > 0)
            StopSound(m_nHeadRotateSoundID);
    }
    
    protected float m_fLastGunAngle = 0;
    
    public void RotateGun(float fAngle)
    {
        fAngle = MathUtils.crop(fAngle, m_fMinGunAngle, m_fMaxGunAngle);
        RotateElementWithAnim(m_nGunRotateElem, Vector.Right, fAngle);
        
        if (Math.abs(fAngle - m_fLastGunAngle) > 2)
            PlayGunRotateSound(GetAnimMorphTime(m_nGunRotateElem));
        m_fLastGunAngle = fAngle;
    }

    
    void PlayGunRotateSound(float fTime)
    {
        if (m_nGunRotateSoundID < 0)
        {            
            if (m_sGunRotateLoopSound != null)
                m_nGunRotateSoundID = AttachSound(m_sGunRotateLoopSound);
        }
        else
            PlaySound(m_nGunRotateSoundID);
        CallMethodOnceIn(METHOD_StopGunRotateSound, fTime);
    }
    
    void StopGunRotateSound()
    {
        if (m_nGunRotateSoundID > 0)
            StopSound(m_nGunRotateSoundID);
    }

    protected void UpdateTrackingObject()
    {
        Vector vTgtPos = m_TrackedObject.GetPointToLookAt(0);
        vTgtPos.Sub(GetElementPos(m_nHorizRotateElem));
        Vector vLocalDirHead = VectorWorldToLocal(vTgtPos);
        
        vTgtPos = m_TrackedObject.GetPointToLookAt(0);
        vTgtPos.Sub(GetElementPos(m_nVertRotateElem));        
        Vector vLocalDirNeck = VectorWorldToLocal(vTgtPos);
        
        vTgtPos = m_TrackedObject.GetPointToLookAt(0);
        vTgtPos.Sub(GetElementPos(m_nGunRotateElem));
        Vector vLocalDirGun = VectorWorldToLocal(vTgtPos);
        
        float fHorizAngle = (float)(Math.atan2(vLocalDirHead.fX, vLocalDirHead.fZ) * 180 / Math.PI),
            fLenXZ = (float)Math.sqrt(vLocalDirNeck.fX * vLocalDirNeck.fX + vLocalDirNeck.fZ * vLocalDirNeck.fZ),
            fVertAngle = (float)(-Math.atan2(vLocalDirNeck.fY, fLenXZ) * 180 / Math.PI),
            
            fLenGunXZ = (float)Math.sqrt(vLocalDirGun.fX * vLocalDirGun.fX + vLocalDirGun.fZ * vLocalDirGun.fZ),
            fGunAngle = (float)(-Math.atan2(vLocalDirGun.fY, fLenGunXZ) * 180 / Math.PI);
        
        if (Math.abs(fHorizAngle) > m_fMaxHorizHeadAngle 
            && !m_ActualMotion.IsMovingLinear())
        {
            Turn(fHorizAngle);
            fHorizAngle = 0;
        }
        RotateHead(fHorizAngle, fVertAngle);
        RotateGun(fGunAngle);
    }
    

    public boolean StopTrackingObject()
    {
        if (m_TrackedObject != null)
        {
            RotateHead(0,0);
            RotateGun(0);
        }
        return super.StopTrackingObject();
    }

    
    static Vector l_UTD_vDir = new Vector();
    static Vector l_UTD_vDestDir = new Vector();
    
    public void UpdateTrackingDir()
    {
        super.UpdateTrackingDir();
        if (m_TrackedObject != null && m_vCurrentGoToPoint != null)
        {
            l_UTD_vDir.Set(m_TrackedObject.GetPointToLookAt(0));
            l_UTD_vDir.Sub(GetPositionVectorVolatile());
            
            l_UTD_vDestDir.Set(m_vCurrentGoToPoint);
            l_UTD_vDestDir.Sub(GetPositionVectorVolatile());

            if (Math.abs(MathUtils.dot2D(l_UTD_vDir,l_UTD_vDestDir)) > _MAX_TARGET_TRACKING_COS)
            {
                SetMaxAngSpeed(GetAngSpeedForMotion(m_Motion));
                SetFacingDestDir(l_UTD_vDir);
            }
        }
    }

    
    
    protected void CalcMotionStateFromSpeedDir(AIMotionState cMotion, 
                                               Vector vBodyForward,
                                               Vector vSpeedDir)
    {
        //ustaw zerowa predkosc
        cMotion.iMoveX = cMotion.iMoveZ = 0;

        vSpeedDir.fY = 0;
        float fSpeedLen2 = vSpeedDir.Len2();
        if (fSpeedLen2 > 0.01f)
        {
            if (vSpeedDir.Dot(vBodyForward) < 0)
                cMotion.iMoveZ = -1;
            else
                cMotion.iMoveZ = 1;
        }
    }
    
    protected int m_nLastLoopAnimID = 0;
    public float UpdateMotion()
    {
        DisableCallMethod(METHOD_CallUpdateMotion);
        
        float fTime = 0;
        m_ActualMotion = new AIMotionState(m_Motion);

        //LogR("ActualMotion: " + DescribeMotionState(m_Motion) + "\n");

        if (!IsDead() && !IsFrozen() && 
            (!m_ActualMotion.IsEqual(m_OldMotion) || !IsPlaying("")) )
        {
            if ( m_ActualMotion.IsMoving())
                fTime = UpdateMotion_Moving(m_ActualMotion);
            else
                fTime = UpdateMotion_Still(m_ActualMotion);
            
            m_OldMotion = new AIMotionState(m_ActualMotion);
            
            m_Controller.MotionStateChanged();
        }
        return fTime;
    }
    
    protected float UpdateMotion_Moving(AIMotionState cMotion)
    {
        int nAnimID = -1;

        if (cMotion.IsMovingLinear())
        {
            switch ((int)cMotion.iMoveZ)
            {
            case -1 : //backward
                nAnimID = AIAnimationsWalker.A_BACKWARD;
                break;
            case 0 : //strafe
                LogR("ERROR: Walker is strafing! Evacuate all personel immediately!\n");
                break;
            case 1 : //forward
                nAnimID = AIAnimationsWalker.A_FORWARD;
                break;
            }
        } 
        else if (cMotion.iTurn != 0) //obroty
        {
            if (cMotion.iTurn > 0)
                nAnimID = AIAnimationsWalker.A_ROTATE_LEFT;
            else
                nAnimID = AIAnimationsWalker.A_ROTATE_RIGHT;
        }

        if (nAnimID != -1)
        {
            if (m_OldMotion.iMoveX != cMotion.iMoveX ||
                m_OldMotion.iMoveZ != cMotion.iMoveZ ||
                m_OldMotion.GetSpeed() != cMotion.GetSpeed() ||
                m_OldMotion.iTurn != cMotion.iTurn)
            {
                PlayAIAnimLoop( nAnimID );
                m_nLastLoopAnimID = m_Anims.m_aAnims[nAnimID];
                OnAnimCycle(m_nLastLoopAnimID, 0);
            }
            
        }
        return 0; //TODO moze zwracac animmorphtime
    }
    
    void OnAnimCycle(int iAnimID, int iCount)
    {
        if (iAnimID == m_nLastLoopAnimID && m_Motion.IsMoving())
        {
            StepDone();
            CallMethodIn(METHOD_StepDone, GetAnimLength(iAnimID) / 2);
        }
    }
    
    void StepDone()
    {
        if (m_sStepSound != null)
            PlaySound(m_sStepSound);
    }
    
    protected float UpdateMotion_Still(AIMotionState cMotion)
    {
        int nAnimID = AIAnimationsWalker.A_STAND;
        //TODO: reszta stania walkera
        PlayAIAnimLoop( nAnimID );
        DisableCallMethod(METHOD_StepDone);
        return 0;
    }

    
    public void Die()
    {
        if (!IsDead())
        {
            super.Die();

            DeleteAttachedFXes();

            if( m_sWkrDieBlowFX != null)
            {
                ExecuteFX(m_sWkrDieBlowFX, GetElementPos(m_nHorizRotateElem), Vector.Up);
                ExecuteParticleSystem(m_sWkrDieBlowFX, GetElementPos(m_nHorizRotateElem), Vector.Up);
            }

            if( m_sWkrDieBlowSound != null)
                PlaySound(m_sWkrDieBlowSound);
            
            MakeBlastDamage(fDieExplosionDamage, fDieExplosionDamage, GetPosition(),
                            fDieExplosionRange, true, this, EnumDamageType._BLAST);
            
            if (fBlowUpShakeStrength > 0)
                ShakePlayersCamera(fBlowUpShakeStrength, fBlowUpShakeDistMin, fBlowUpShakeDistMax);

            
            SetCollType(ECollFlags.OBJCOL_TYPE_PERFACE);
            HideWalkerHead();
            if (m_nControlMode != _CONTROL_MODE_STANDBY)
                PlayAIAnim(AIAnimationsWalker.A_NORMAL2STANDBY);
        }
    }
    
    protected void HideWalkerHead()
    {
        if (m_aHeadElements != null)
            for (int i = 0; i < m_aHeadElements.length; i++)
            {
                int id = GetElementID(m_aHeadElements[i]);
                HideElement(id);
                EnableCollisionsElement(id, false);
            }
    }
    
    public boolean IsActive(ControlObject Activator)
    {
        return !IsDead() && m_nControlMode == _CONTROL_MODE_STANDBY;
    }
    
    public String GetTip()
    {
        return "%Walker (get in)%";
    }
    
    public void SetControlMode(int nNewControlMode)
    {
        if (nNewControlMode != m_nControlMode)
        {
            m_nControlMode = nNewControlMode;
            switch (nNewControlMode)
            {
            case _CONTROL_MODE_STANDBY:
                PlayAIAnim(AIAnimationsWalker.A_NORMAL2STANDBY);
                break;
            case _CONTROL_MODE_AI:
            case _CONTROL_MODE_PLAYER:
                CallMethodIn(METHOD_CallUpdateMotion, 0);
                break;
            }            
        }
    }
    
    public int GetControlMode()
    {
        return m_nControlMode;
    }
    
    public Vector GetPointToLookAt(int nPoint)
    {
        return GetElementPos(m_nElemPointToLookAt);
    }
    
    
    public void PlayAIAnim(int nAnimID, int nTimes)
    {
        if (m_aWalkerAnimsSounds != null && 
            m_aWalkerAnimsSounds[nAnimID] != null)
        {
            PlaySound(m_aWalkerAnimsSounds[nAnimID]);
        }
        super.PlayAIAnim(nAnimID, nTimes);
    }
    
    /** Walker ma w dupie jak stuka w niego samochod
     */
    public void OnVehicleCollision(float fDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed)
    {
    }
    
    //*********************************************************
    //                      SaveGame
    //*********************************************************

    int m_nSGHeadRotateSoundID = 0;
    int m_nSGGunRotateSoundID = 0;
    
    public void SGLoadChunk(FileChunk cParentFC)
    {	
        FileChunk.Log("[NewAIWalker.SGLoadChunk]\n");
        
        FileChunk cFC = GameObject.LoadChunk(cParentFC);
        
        if (cFC.GetID() == ESGChunksChrome._CHK_NEWAI_WALKER)
        {
            super.SGLoadChunk(cFC);
			
			if (bDead == false) // dla true jest robione w Actor
				LoadMeshElements(cFC);									
            
            cDriver = (NewAIHuman)cFC.LoadObjectRef();
            m_cSeat = (SeatInfo)cFC.LoadObjectRef();
            
            m_nSGHeadRotateSoundID = cFC.LoadInt();
            m_nSGGunRotateSoundID = cFC.LoadInt();

            // Stan klapy wejsciowej
            m_nCabinState = cFC.LoadInt();
            // Stan walkera ze wzgledu na kontrolujacego go goscia 
            m_nControlMode = cFC.LoadInt();
            
            //m_fHorizVertAddAngle = cFC.LoadFloat();
            m_fLastHorizAngle = cFC.LoadFloat();
            m_fLastVertAngle = cFC.LoadFloat();
            
            m_fLastGunAngle = cFC.LoadFloat();
            m_nLastLoopAnimID = cFC.LoadInt();
        }
        
        cFC.delete();
    }
    

    public void SGSaveChunk(FileChunk cFCParent)
    {
        FileChunk.Log("[NewAIWalker.SGSaveChunk]\n");
        
        FileChunk cFC = NewChunk(ESGChunksChrome._CHK_NEWAI_WALKER, cFCParent);
        
        super.SGSaveChunk(cFC);
		
		if (bDead == false) // dla true jest robione w Actor
			SaveMeshElements(cFC);						

        cFC.SaveObjectRef(cDriver);
        cFC.SaveObjectRef(m_cSeat);
        
        cFC.SaveInt(m_nHeadRotateSoundID);
        cFC.SaveInt(m_nGunRotateSoundID);
        
        // Stan klapy wejsciowej
        cFC.SaveInt(m_nCabinState);
        // Stan walkera ze wzgledu na kontrolujacego go goscia 
        cFC.SaveInt(m_nControlMode);
        
        // cFC.SaveFloat(m_fHorizVertAddAngle);
        cFC.SaveFloat(m_fLastHorizAngle);
        cFC.SaveFloat(m_fLastVertAngle);
        
        cFC.SaveFloat(m_fLastGunAngle);
        cFC.SaveInt(m_nLastLoopAnimID);

        cFC.delete(); 
    }
    
    public void SGUpdate()
    {
        FileChunk.Log("[NewAIWalker.SGUpdate]\n");
        
        if (m_nHeadRotateSoundID > 0)
        {
            DetachSound(m_nHeadRotateSoundID);
            m_nHeadRotateSoundID = -1;
        }
        
        if (m_nGunRotateSoundID > 0)
        {
            DetachSound(m_nGunRotateSoundID);
            m_nGunRotateSoundID = -1;
        }

        super.SGUpdate();

        /*
        if ((m_nSGHeadRotateSoundID != 0) && (m_sHeadLoopSound != null))
        {
        m_nHeadRotateSoundID = AttachSound(m_sHeadLoopSound);
        if (m_nHeadRotateSoundID > 0)
        PlaySound(m_nHeadRotateSoundID);
        }
        */
    }
    
    public void OnAudioReinitialize()
    {
        m_nHeadRotateSoundID = -1;
        m_nGunRotateSoundID = -1;
    }
}
