/** Generator odpowiadajacy za reakcje po zobaczeniu wroga.
 * Uzywany w AIHuman i w AIWalker */
public class EnemySpotted extends Generator
{
	EnemySpotted(AIController controller)
	{
		super(controller);
        
		m_GenScenarios.SetAllBits();
		m_GenScenarios.ClearBit(ReactOnEnemyPresence._ID);
	}
	
	void UpdateScenarios()
	{
		super.UpdateScenarios();

		if ( m_Controller.JustSpottedEnemyOnce() && 
            (!m_Controller.HeardScreamLately()) &&
			(!m_Controller.ShouldPerformEditorActivity()) ) // gdy jedzie samochodem, to przegenerowalby scenariusze
		{
            DebugUtils.AddLog(m_Controller.m_MeshAI, "JustSpottedEnemyOnce()");
            // jesli wlasnie zauwazyl wroga
            m_CurrScenarios.ClearAllBits();
            m_CurrScenarios.SetBit(ReactOnEnemyPresence._ID);
		}
		else
		{
            m_CurrScenarios.Set(m_GenScenarios);
		}
		
#if AI_DEBUG        
        DebugUtils.AddLog(m_Controller.m_MeshAI, "\n");
#endif        
	}
}
