/** Generator odpowiadajacy za reakcje po rozpoczeciu rozpoznawania obiektu jako wroga 
 */
public class SuspectSpotted extends Generator
{
    SuspectSpotted(AIController controller)
    {
        super(controller);
        
        m_GenScenarios.SetAllBits();
        m_GenScenarios.ClearBit(ReactOnSuspectSpotted._ID);
    }
    
    void UpdateScenarios()
    {
        super.UpdateScenarios();
        
        if (m_Controller.GetAlarmLevel() == AIController._ALARM_LEVEL_LOW &&
            m_Controller.IsSuspectValid() &&
            !m_Controller.ShouldPerformEditorActivity() &&
            !m_Controller.InsideCannon())
        {
#if AI_DEBUG
            DebugUtils.AddLog(m_Controller.m_MeshAI, "IsSuspectValid() && ...\n");
#endif
            m_CurrScenarios.ClearAllBits();
            m_CurrScenarios.SetBit(ReactOnSuspectSpotted._ID);
        }
        else
        {
            m_CurrScenarios.Set(m_GenScenarios);
        }
        
#if AI_DEBUG
            DebugUtils.AddLog(m_Controller.m_MeshAI, "\n");
#endif
    }

}
