public class EditorGetInOut extends Scenario
{
    static int _ID = _NUM_OF_SCENARIOS++;
    
    static int init = _EDITOR_SCENARIOS.SetBit(_ID);

	void PrepareScenario(AIController ai)
	{
		if (!ai.InsideVehicle())
		{
			if (ai.GetSeat() != null)
			{
                mt_GetIn getInData = (mt_GetIn) ai.GetCurrWaypoint().cMotion;
                
				if (!getInData.bImmediate &&
                    ai.GetSeat().GetStartPos().Distance(ai.GetMesh().GetPosition()) > ai.GetSeat().GetMoveInRadius())
                {
					ai.AddTask(new TaskGotoPos(ai.GetSeat().GetStartPos(), 5f));
                }
				else
				{
                    ai.AddCleaningTask(new TaskEnableHitReaction(false));
                    if (!getInData.bImmediate)
					    ai.AddCleaningTask(new TaskMotionStateChange(MotionState.SPEED_WALK));
					ai.AddCleaningTask(new TaskExecuteExtended(ai.GetSeat().m_ObjectToOccupy, getInData.bImmediate));
                    if (ai.GetSeat().m_ObjectToOccupy instanceof StationaryCannon)
                        ai.AddCleaningTask(new TaskSetInCannon(true));
					ai.AddCleaningTask(new TaskEditorActivityEnd());
				}
			}
			else
				ai.AddTask(new TaskWait(5f)); // cos poszlo nie tak, czekamy
		}
		else
        {
            if (ai.GetSeat() != null &&
                ai.GetSeat().WaitForNoticeBeforeGetOut())
            {
			    ai.AddTask(new TaskWaitForExternalNotice()); // czekamy, az pojazd sie zatrzyma
            }
			
			mt_GetOut getOutData = (mt_GetOut) ai.GetCurrWaypoint().cMotion;
			
			ai.AddCleaningTask(new TaskMotionStateChange(MotionState.SPEED_WALK));
			ai.AddCleaningTask(new TaskExecuteExtended(ai.GetSeat().m_ObjectToOccupy));
            ai.AddCleaningTask(new TaskEnableHitReaction(true));
			ai.AddCleaningTask(new TaskEditorActivityEnd());
		}

        super.PrepareScenario(ai);
	}            
    
    public String toString()
    {
        return "EGIO";
    }
    
    int GetID()
    {
        return _ID;   
    }    
}