public class EditorMove extends Scenario
{
    static int _ID = _NUM_OF_SCENARIOS++;
    
    static int init = _EDITOR_SCENARIOS.SetBit(_ID);

	void PrepareScenario(AIController ai)
	{
		if (ai.InsideVehicle())
		{
			ai.AddTask(new TaskTrackingStop());
			ai.AddTask(new TaskStopFire());
			ai.AddTask(new TaskDrive());
			ai.AddCleaningTask(new TaskDriveStop());
            ai.AddCleaningTask(new TaskEditorActivityEnd());
		}
		else
		{
			Vector vDestPos = ai.GetCurrWaypoint().GetPosition();
			ChromeActor cEnemy = ai.GetActiveEnemy();
            
            Vector vDist = ai.GetMesh().GetPosition();
            vDist.Sub(ai.GetMesh().GetInFormationPosition(vDestPos, null));
            vDist.fY = 0;
        
			mt_Move moveData = (mt_Move)ai.GetCurrWaypoint().cMotion;

            // sprawdz, czy jeszcze nie doszedl
            if (vDist.Len2() < moveData.fRadius * moveData.fRadius)
            {
                ai.AddCleaningTask(new TaskEditorActivityEnd());
            }
            else
            {
                int iSpeed = moveData.cSpeed.GetValue();
                if (iSpeed < 0)
                    iSpeed = MotionState.SPEED_RUN; //defaultowe
                
                if ((cEnemy != null) && (moveData.bCanShoot) )
                {
                    ai.AddTask(new TaskTrackingStart(cEnemy)); 
                    ai.AddTask(new TaskStartFire());		

                    if ( (ai.GetActiveWeapon() != null) &&
                         (ai.GetActiveWeaponAmmo() == 0) &&
                         (ai.GetMesh().m_nAmmoForActiveWeapon > 0) )
                    {
                        ai.AddTask(new TaskReload());
                    }
                }
                else
                {
                    vDestPos.Sub(ai.GetMesh().GetPositionVectorVolatile());
                    vDestPos.Normalize();
                    if (vDestPos.Dot(ai.GetMesh().GetForwardVectorVolatile()) < 
                        ai.GetMesh().m_fMinAngleToTurnWhileMovingCos)
                    {
                        ai.AddTask(new TaskTurnAtDir(vDestPos));
                    }
                }
                ai.AddTask(new TaskMotionStateChange((byte)iSpeed));
                
                boolean bLastGotoWrong = (ai.m_nLastPreparedScenario == _ID) && (!ai.GetMesh().m_bLastGoToSuccessfull);
                if (!bLastGotoWrong ||
                    ai.GetMesh().CanStandAtPos(ai.GetCurrWaypoint().GetPositionVectorVolatile()))
                {
                    ai.AddTask(new TaskGoToObject(ai.GetCurrWaypoint(),
                                                  5f,
                                                  moveData.fRadius));
                }
                
                if (bLastGotoWrong)
                    ai.AddTask(new TaskWait(1, TaskWait._STOP_CND_TAKE_DAMAGE | TaskWait._STOP_CND_RELOAD));

                ai.AddCleaningTask(new TaskTrackingStop());
                ai.AddCleaningTask(new TaskStopFire());
            }
		}
		
        super.PrepareScenario(ai);        
    }

    public String toString()
    {
        return "EM";
    }
    
    int GetID()
    {
        return _ID;   
    }    
}