public class EditorUse extends Scenario
{
    static int _ID = _NUM_OF_SCENARIOS++;

    static int init = _EDITOR_SCENARIOS.SetBit(_ID);

    void PrepareScenario(AIController ai)
    {
        mt_Use useData = (mt_Use) ai.GetCurrWaypoint().cMotion;

        Vector vDestPos = useData.cObject.GetExecutionOrigin();
        Vector vDestDir = useData.cObject.GetExecutionDir();
        vDestDir.Normalize();

        // zawsze stajemy w odpowiedniej pozycji
        int iSpeed = useData.cSpeed.GetValue();
        if (iSpeed < 0)
            iSpeed = MotionState.SPEED_RUN; //default
        ai.AddTask(new TaskMotionStateChange((byte) iSpeed));

        // probujemy dojsc do punktu docelowego
        Vector vMeshPos = ai.GetMesh().GetPosition();
        vMeshPos.Sub(vDestPos);
        vMeshPos.fY = 0;
        if (vMeshPos.Len2() > useData.fRadius * useData.fRadius)
        {
            if ((ai.GetActiveEnemy() != null) && (useData.bCanShoot) )
            {
                ai.AddTask(new TaskTrackingStart(ai.GetActiveEnemy())); 
                ai.AddTask(new TaskStartFire());		
            }
            else
                ai.AddTask(new TaskTurnAtPos(vDestPos));
            
            ai.AddTask(new TaskGotoPos(vDestPos, 5f));
            
            ai.AddCleaningTask(new TaskTrackingStop());
            ai.AddCleaningTask(new TaskStopFire());
        }
        else 
        {
            if (useData.cObject.bExtendedExecutionMode)
            {
                ai.AddCleaningTask(new TaskMotionStateChange(MotionState.SPEED_WALK));
                ai.AddCleaningTask(new TaskEnableHitReaction(false));
                ai.AddCleaningTask(new TaskExecuteExtended(useData.cObject));
                ai.AddCleaningTask(new TaskEditorActivityEnd());
            }
            else
            {
                if ( vDestDir.Dot(ai.GetMesh().GetForwardVector()) < 0.99f)
                {
                    ai.AddTask(new TaskTurnAtDir(vDestDir));
                }
                else 
                {
                    ai.AddCleaningTask(new TaskEnableHitReaction(false));
                    int iMode = useData.cObject.cExecuteMode.GetValue();
                    if (iMode == EnumExecuteMode._BUTTON_PRESS)
                        ai.AddTask(new TaskPlayAnim(AIAnimationsHuman.A_BUTT_HIT));
                    else
                        if (iMode == EnumExecuteMode._KEYBOARD_TYPE)
                            ai.AddTask(new TaskPlayAnim(AIAnimationsHuman.A_KEYBOARD));
                        else
                            ai.AddTask(new TaskPlayAnim(AIAnimationsHuman.A_IDLE_SCRATCH));
                    
                    ai.AddTask(new TaskExecute(useData.cObject));
                    ai.AddCleaningTask(new TaskEditorActivityEnd());
                }
            }
            ai.AddCleaningTask(new TaskEnableHitReaction(true));
        }
    
        super.PrepareScenario(ai);        
    }

    public String toString()
    {
        return "EMTU";
    }
    
    int GetID()
    {
        return _ID;   
    }    
}