public class IdlePlayAnim extends Scenario
{
    static int _ID = _NUM_OF_SCENARIOS++;

	final static int[] m_aIdleFreq = { 
        AIAnimationsHuman.A_LOOK_AROUND, //rozglada_sie
        AIAnimationsHuman.A_IDLE_STAND, //op_stoi
        AIAnimationsHuman.A_IDLE_LOOK_AROUND, //op_rozglada_sie 
        AIAnimationsHuman.A_IDLE01 //gapi_sie_w_niebo
    }; 
    
    final static int[] m_aIdleMed = { 
        AIAnimationsHuman.A_IDLE02, //grzebie_noga             
        AIAnimationsHuman.A_IDLE03, //majstruje_przy_zamku_loop
    };
    
    final static int[] m_aIdleRare = {
        AIAnimationsHuman.A_WONDERING, //zastanawia_sie         
        AIAnimationsHuman.A_IDLE_SCRATCH,  //op_drapie_sie_po_jajach
        AIAnimationsHuman.A_IDLE04, //komar  
        AIAnimationsHuman.A_IDLE05, //przeciaga_sie
        AIAnimationsHuman.A_IDLE06 //gimnastyka
    };
    

    /** Prawdopodobienstwo, ze odegrany zostanie ciag animacji z gunem na ramieniu
     * (inaczej odegrana bedzie ktoras z pozostalych animacji) */
    public int m_nGunAnimProb = 15;
    
    /** Prawdop. wybrania animacji z m_aIdleRare [%] */
    public int m_nRareAnimProb = 25;

    /** Prawdop. wybrania animacji z m_aIdleMed [%] */
    public int m_nMedAnimProb = 30;
    

    void PrepareScenario(AIController ai)
    {
        if (GameObject.RandomInt(100) < m_nGunAnimProb)
        {
            if (!TryToPlayGunAnim(ai))
                PlayRandomIdleAnim(ai);
        }
        else
            PlayRandomIdleAnim(ai);
        
        super.PrepareScenario(ai);        
    }
    
    private void PlayRandomIdleAnim(AIController ai)
    {
        int nRand = GameObject.RandomInt(100);
        int[] aAnims;
        
        if ( (nRand < m_nRareAnimProb) && (ai.CanPlayCalmIdleAnims()) )
            aAnims = m_aIdleRare;
        else if (nRand < m_nMedAnimProb)
            aAnims = m_aIdleMed;
        else 
            aAnims = m_aIdleFreq;
        
        int nAnimID = GameObject.RandomInt(aAnims.length);
        ai.AddTask(new TaskPlayAnim(aAnims[nAnimID]));
    }
    
    private boolean TryToPlayGunAnim(AIController ai)
    {
        Weapon wpn = ai.GetActiveWeapon();
        if (wpn != null &&
            (wpn.nType == EWeaponType._HEAVY ||
             wpn.nType == EWeaponType._RIFLE ||
             wpn.nType == EWeaponType._MINIGUN)) // dyskusyjne, ale skoro moze sie z nim przeciagac...
        {
            ai.AddTask(new TaskPlayAnim(AIAnimationsHuman.A_GUN_IDLE_START));
            ai.AddTask(new TaskPlayAnim((GameObject.RandomInt(2) < 1) ? AIAnimationsHuman.A_GUN_IDLE_LOOP1 :
                                                             AIAnimationsHuman.A_GUN_IDLE_LOOP2,
                                        2 + GameObject.RandomInt(3)));
            ai.AddTask(new TaskPlayAnim(AIAnimationsHuman.A_GUN_IDLE_STOP));
            return true;
        }
        else
            return false;
    }
    
    public String toString()
    {
        return "IPA";
    }
    // pt:. -------------   TESTY -----------  
    int GetID()
    {
        return _ID;   
    }        

}
