public class RunAway extends Scenario
{
    static int _ID = _NUM_OF_SCENARIOS++;
    
    /** zakres odleglosci na jaka ma uciekac    */
    final static float _MIN_RUN_DIST = 500;
    final static float _MAX_RUN_DIST = 1000;        

    final static float _MIN_DANGER_SPEED = 10.f;
    
    RunAway()
    {
        super(_PRIORITY_CLASS_HIGH);   
    }

    void PrepareScenario(AIController ai)
    {
        // trzeba sie zastanowic jak ustalac obiekt od ktorego ma uciekac
        ChromeActor cEnemy = null;
        Vector vDangerSpeed = null;
        if ( (ai.JustHeardDangerousObject()) && (ai.m_LastDangerousObject != null) )
        {
            cEnemy = ai.m_LastDangerousObject;
            vDangerSpeed = cEnemy.GetSpeed();
            if(vDangerSpeed == null)
            {
                GameObject.LogR("[RunAway.PrepareScenario] vDangerSpeed == null, cEnemy="+cEnemy+" <"+cEnemy.GetName()+":"+cEnemy.GetUniqueID()+"> cEnemy.bDeletedInEngine="+cEnemy.bDeletedInEngine+"\n");
            }
            else
            {
                if (vDangerSpeed.Len() < _MIN_DANGER_SPEED) // jesli odpowiednio male - nie uciekaj poprzecznie
                    vDangerSpeed = null;
            }
        }
        else
            cEnemy = ai.m_cActiveEnemy;        

        if ( (cEnemy == null) || (cEnemy.GetPosition() == null) )
        {
            ai.AddTask(new TaskWait(GameObject.RandomFloat(1, 2)));
        }
        else
        {
            Vector vDestPos = ai.GetMesh().GetPosition();
            
            float fDist = GameObject.RandomFloat(_MIN_RUN_DIST, _MAX_RUN_DIST);
            Vector vDir;
            if (vDangerSpeed != null) // jesli poruszajacy sie niebezpieczny obiekt
            {
                // policz wektor prostopadly do kier. obiektu
                Vector vDangerRight = vDangerSpeed.Cross(Vector.Up);
                Vector vTmpDir = ai.GetMesh().GetPosition();
                vTmpDir.Sub(cEnemy.GetPositionVectorVolatile());
                // sprawdz, po ktorej jestes stronie
                float fDot = vDangerRight.Dot(vTmpDir);
                if (Math.abs(fDot) < 0.01)
                    fDot = 1;
                vDangerRight.Normalize();
                vDangerRight.Mul(MathUtils.sign(fDot) * fDist);
                vDir = vDangerRight;
            }
            else
            {
                vDir = ((AIControllerHuman)ai).GetOppositeDir(cEnemy); // kierunek przeciwny
                vDir.Mul(fDist);
            }
            vDestPos.Add(vDir);
            
            if (!ai.GetMesh().m_bGuardCritical)
                ai.AddTask(new TaskGuard(null, 0, false)); //wylacz guardowanie
            ai.AddTask(new TaskMotionStateChange(MotionState.SPEED_RUN));
//            ai.AddTask(new TaskTurnAtPos(vDestPos));
            ai.AddTask(new TaskGotoPos(vDestPos,  0.5f));
        }
        
        super.PrepareScenario(ai);
    }    

    public String toString()
    {
        return "RAw";
    }
    // pt:. -------------   TESTY -----------  
    int GetID()
    {
        return _ID;   
    }        
}
