public class LookAroundAlarmed_W extends Scenario
{
    static int _ID = _NUM_OF_SCENARIOS++;
    final static int[] aAlarmedAnims = { AIAnimationsHuman.A_HEARD_SHOT1, 
                                         AIAnimationsHuman.A_HEARD_SHOT1_UP,
                                         AIAnimationsHuman.A_HEARD_SHOT2,
                                         AIAnimationsHuman.A_HEARD_SHOT2_UP };
    
	void PrepareScenario(AIController ai)
	{
		if ( ai.JustHeardEnemyShot() && (ai.GetLastHeardEnemyShotPos() != null) )
			ai.AddTask(new TaskTurnAtPos(ai.GetLastHeardEnemyShotPos()));
		else
		if (ai.JustHeardScream())
		{
			Vector vPos = ai.GetLastDyingScreamPos();
			if (vPos != null)
			{
				ai.AddTask(new TaskTurnAtPos(vPos));
				ai.AddTask(new TaskWait(1f));
				if (ai.GetLastDeadBodySpotted() != null)
				{
					FriendInfo friendInfo = ai.GetDeadBodyFriendInfo();
					if ( (friendInfo != null) && (friendInfo.m_Reference instanceof NewAI) &&
						 (((NewAI) friendInfo.m_Reference).m_Killer != null) )
					{
						vPos = ((NewAI) friendInfo.m_Reference).m_Killer.GetPosition();
						ai.AddTask(new TaskTurnAtPos(vPos));
						ai.AddTask(new TaskWait(2f));
					}
					else
						ai.AddTask(new TaskPlayAnim(AIAnimationsHuman.A_LOOK_AROUND));
				}
			}
			else	
				ai.AddTask(new TaskPlayAnim(AIAnimationsHuman.A_LOOK_AROUND));
		}
		else
        if ( ai.JustHeardRicochet() || ai.JustHeardExplosion() )
        {
            int nAnim = aAlarmedAnims[GameObject.RandomInt(aAlarmedAnims.length)];
            ai.AddTask(new TaskPlayAnim(nAnim));
        }
        else
			ai.AddTask(new TaskPlayAnim(AIAnimationsHuman.A_LOOK_AROUND));
		
        super.PrepareScenario(ai);
	}
	
    public String toString()
    {
        return "LAA";
    }
    // pt:. -------------   TESTY -----------  
    int GetID()
    {
        return _ID;   
    }        
}
