public class LookForEnemy_W extends Scenario
{
    static int _ID = _NUM_OF_SCENARIOS++;
    
    static float _MIN_SEARCH_DISTANCE = 2000f;
    static float _MAX_SEARCH_DISTANCE = 4000f;
    static float _MAX_SEARCH_TIME = 60f;
	static float _MAX_RICOCHET_DIR_DISTORTION_ANGLE = 90.f;//maksymalny kat odchylenia od kierunku do przeciwnika, ktory wydal noise'a
	static float _MIN_DIST_TO_LAST_ENEMY_POS = 500f;
	static float _DEST_DIST_TO_ENEMY = 200f; // odleglosc od ai do przeciwnika, na jaka ai ma dobiec;
											 // musi byc wieksza niz szerokosc elipsoid i mniejsza od
											 // _MIN_DIST_TO_LAST_ENEMY_POS

    private static Vector m_vDestPos = new Vector();
    void PrepareScenario(AIController ai)
	{
        // zainicjuj na totalnie losowa pozycje...
        m_vDestPos.Set(MathUtils.CalcRandomMoveVolatile(_MIN_SEARCH_DISTANCE, _MAX_SEARCH_DISTANCE));
        m_vDestPos.Add(ai.GetMesh().GetPositionVectorVolatile());

        ChromeActor cEnemy = ai.GetActiveEnemy();
        if (cEnemy != null)
        {
			EnemyInfo info = (EnemyInfo) ai.m_aEnemies.get(cEnemy);
			if ( (info != null) && (info.m_vLastKnownPos != null) )
			{
				float fDist = ai.GetMesh().GetDistanceTo(info.m_vLastKnownPos);
				if (fDist > _MIN_DIST_TO_LAST_ENEMY_POS)
				{
					Vector vPos = ai.GetMesh().GetPositionVectorVolatile();
    	            m_vDestPos.Set(info.m_vLastKnownPos);
					m_vDestPos.Sub(vPos);
					m_vDestPos.Mul( (fDist - _DEST_DIST_TO_ENEMY) / fDist);
					m_vDestPos.Add(vPos);
				}
			}
        }
		else 
        {
            if (ai.JustHeardEnemyShot())
                m_vDestPos.Set(ai.GetLastHeardEnemyShotPos());
			else
			{
				Vector vPos = ai.GetLastRicochetMakerPos();
				if (vPos == null)
					vPos = ai.GetLastExplosionMakerPos();
				if (vPos != null)
				{
					m_vDestPos.Set(vPos);
					m_vDestPos.Sub(ai.GetMesh().GetPositionVectorVolatile());
					m_vDestPos.Mul(GameObject.RandomFloat(0.1f, 1f)); // nie chcemy podbiegac do samego celu
					m_vDestPos = ai.RotateVector(m_vDestPos, 
												 GameObject.RandomFloat(-_MAX_RICOCHET_DIR_DISTORTION_ANGLE, 
																		_MAX_RICOCHET_DIR_DISTORTION_ANGLE),
												 Vector.Up);
					m_vDestPos.Add(ai.GetMesh().GetPositionVectorVolatile());
				}
			}
		}
			
		ai.AddTask(new TaskTrackingStop());
		ai.AddTask(new TaskStopFire());
		ai.AddTask(new TaskTurnAtPos(m_vDestPos));
		ai.AddTask(new TaskMotionStateChange(MotionState.SPEED_WALK));
		ai.AddTask(new TaskGotoPos(m_vDestPos, _MAX_SEARCH_TIME));
        
        super.PrepareScenario(ai);
	}
	
    public String toString()
    {
        return "LE_W";
    }
    
    // pt:. -------------   TESTY -----------  
    int GetID()
    {
        return _ID;   
    }        
}