public class TaskCheckBody extends Task
{
    /** o ile moze byc max. oddalony by sprawdzil cialo     */
    final static int _MAX_BODY_DIST = 150;
    /** sprawdzane cialo     */
    ChromeActor m_cBody = null;

    public TaskCheckBody()
    {
        //SG
    }
    
    TaskCheckBody(ChromeActor cBody)
	{
        m_cBody = cBody;
	}

    /** wykonuje zadanie     */
    public void Perform()
    {
		super.Perform();
        if(m_cBody!=null && m_cBody.GetDistanceTo(m_cAI.GetMesh())<_MAX_BODY_DIST)
        {
            m_cAI.GetMesh().CallOrRemoveUpdateMotion();
            m_cAI.GetMesh().PlayAIAnim(AIAnimationsHuman.A_WONDERING, 1);
        }
        else
            m_cAI.Notify(AIEvents._NOTICE_END_TASK);
    }	
    
    /** Odwolanie akcji */
    public void Cancel(boolean bQuick)
    {
        super.Cancel(bQuick);
        m_cAI.GetMesh().StopAIAnim(false);
		
    }
    
    /** obsluguje komunikat wyslany z AIControllera     */
    public void ServeNotice(int nNotice)
    {
        super.ServeNotice(nNotice);
        switch(nNotice)
		{
		case AIEvents._NOTICE_ANIM_END:			
		case AIEvents._NOTICE_ANIM_STOPPED:			
			m_cAI.Notify(AIEvents._NOTICE_END_TASK);
		}
    }	    
	
	public String toString()
	{
		return 	"CheckBody("+m_cBody+")";
	}
    
    //*********************************************************
    //					SaveGame
    //*********************************************************
    
    public void SGLoadChunk(FileChunk cParentFC)
    {	
        FileChunk.Log("[TaskCheckBody.SGLoadChunk]\n");
        
        FileChunk cFC = GameObject.LoadChunk(cParentFC);   
        
        if (cFC.GetID() == ESGChunksChrome._CHK_TASK_CHECK_BODY)
        {
			super.SGLoadChunk(cFC);
            m_cBody = (ChromeActor)cFC.LoadObjectRef();
        }
        
        cFC.delete();
    }
    
    public void SGSaveChunk(FileChunk cFCParent)
    {
        FileChunk.Log("[TaskCheckBody.SGSaveChunk]\n");
        
        FileChunk cFC = GameObject.NewChunk(ESGChunksChrome._CHK_TASK_CHECK_BODY, cFCParent);
        
        super.SGSaveChunk(cFC);
        cFC.SaveObjectRef(m_cBody);
        cFC.delete(); 
    }				
    
    public void SGUpdate()
    {
        FileChunk.Log("[TaskCheckBody.SGUpdate]\n");
        super.SGUpdate();
        //
    }

    
}
