public class TaskPlayRandomAnims extends Task
{
    AnimObject[] m_aAnims = null;
    
    public TaskPlayRandomAnims()
    {
        //SG
    }
    
    public TaskPlayRandomAnims(AnimObject[] aAnims)
    {
        m_aAnims = aAnims;
    }

    /** wykonuje zadanie */
    public void Perform()
    {
        super.Perform();

        if ((m_aAnims == null) || (m_aAnims.length == 0))
            m_cAI.Notify(AIEvents._NOTICE_END_TASK);
        else
        {
            m_cAI.GetMesh().CallOrRemoveUpdateMotion();
            PlayNextAnim();
        }
    }
    
    public void PlayNextAnim()
    {
        int iAnim = GameObject.RandomInt(m_aAnims.length);
        
        int nAnimsCount = m_aAnims[iAnim].nTimes;
        if (nAnimsCount < 0)
            nAnimsCount = Integer.MAX_VALUE;
        
        if (m_aAnims[iAnim].cAnimFromSet != null)
            m_cAI.GetMesh().PlayAIAnim(m_aAnims[iAnim].cAnimFromSet.GetSelectedAnimID(), nAnimsCount);
        else
            m_cAI.GetMesh().PlayAIAnim(m_aAnims[iAnim].sAnimName, nAnimsCount);
    }
    
    /** Odwolanie akcji */
    public void Cancel(boolean bQuick)
    {
        super.Cancel(bQuick);
        
        m_cAI.GetMesh().StopAIAnim(false);
    }
    
    /** obsluguje komunikat wyslany z AIControllera */
    public void ServeNotice(int nNotice)
    {
        super.ServeNotice(nNotice);
        
        switch(nNotice)
        {
        case AIEvents._NOTICE_ANIM_END:
        case AIEvents._NOTICE_ANIM_STOPPED:
            PlayNextAnim();
            break;
        }
    }
    
    public String toString()
    {
        if (m_cAI != null && m_cAI.GetMesh() != null && m_cAI.GetMesh().m_Anims != null)
            return "PlayRandomAnims";
        return null;
    }
    
    //*********************************************************
    //                     SaveGame
    //*********************************************************
    
    public void SGLoadChunk(FileChunk cParentFC)
    {	
        FileChunk.Log("[TaskPlayRandomAnims.SGLoadChunk]\n");
        
        FileChunk cFC = GameObject.LoadChunk(cParentFC);   
        
        if (cFC.GetID() == ESGChunksChrome._CHK_TASK_PLAY_RANDOM_ANIMS)
        {
            super.SGLoadChunk(cFC);
            int elemz = cFC.LoadInt();
            if (elemz < 0)
                m_aAnims = null;
            else
            {
                m_aAnims = new AnimObject[elemz];
                for (int i = 0; i < elemz; i++)
                    m_aAnims[i] = (AnimObject)cFC.LoadObjectRef();
            }
        }

        cFC.delete();
    }
    
    public void SGSaveChunk(FileChunk cFCParent)
    {
        FileChunk.Log("[TaskPlayRandomAnims.SGSaveChunk]\n");
        
        FileChunk cFC = GameObject.NewChunk(ESGChunksChrome._CHK_TASK_PLAY_RANDOM_ANIMS, cFCParent);
        
        super.SGSaveChunk(cFC);
        if (m_aAnims != null)
        {
            cFC.SaveInt(m_aAnims.length);
            for (int i = 0; i < m_aAnims.length; i++)
                cFC.SaveObjectRef(m_aAnims[i]);
        }
        else
            cFC.SaveInt(-1);

        cFC.delete(); 
    }
    
    public void SGUpdate()
    {
        FileChunk.Log("[TaskPlayRandomAnims.SGUpdate]\n");
        super.SGUpdate();
        //
    }

}
