public class TaskTrackingStart extends Task
{
    protected ChromeActor m_TrackedTarget = null;
    protected boolean m_bLookOnly = false;
    protected boolean m_bCanTurn = true;
    
    public TaskTrackingStart()
    {
        //SG
    }
        
    public TaskTrackingStart(ChromeActor cTarget)
	{
        this(cTarget, false);    
	}

    public TaskTrackingStart(ChromeActor cTarget, boolean bLookOnly)
	{
        this(cTarget, bLookOnly, true);
	}
    
    public TaskTrackingStart(ChromeActor cTarget, boolean bLookOnly, boolean bCanTurn)
	{
        m_TrackedTarget = cTarget;
        m_bLookOnly = bLookOnly;
        m_bCanTurn = bCanTurn;
	}
    
    /** wykonuje zadanie     */
    public void Perform()
    {
        super.Perform();
        //DebugUtils.CrashLog(" TASK Tracking "+m_TrackedTarget+"\n");
        m_cAI.GetMesh().StartTrackingObject(m_TrackedTarget, m_bLookOnly, m_bCanTurn);
        m_cAI.Notify(AIEvents._NOTICE_END_TASK);
    }	
    
    /** Odwolanie akcji */
    public void Cancel(boolean bQuick)
    {
        m_cAI.GetMesh().StopTrackingObject();
        super.Cancel(bQuick);
    }
	
	public String toString()
	{
		return 	"TrackingStart";
	}			
    
    //*********************************************************
    //					SaveGame
    //*********************************************************
    
    public void SGLoadChunk(FileChunk cParentFC)
    {	
        FileChunk.Log("[TaskTrackingStart.SGLoadChunk]\n");
        
        FileChunk cFC = GameObject.LoadChunk(cParentFC);   
        
        if (cFC.GetID() == ESGChunksChrome._CHK_TASK_TRACKING_START)
        {
            super.SGLoadChunk(cFC);
            m_TrackedTarget = (ChromeActor)cFC.LoadObjectRef();
            m_bLookOnly = cFC.LoadBool();
            m_bCanTurn = cFC.LoadBool();
      }
        
        cFC.delete();
    }
    
    public void SGSaveChunk(FileChunk cFCParent)
    {
        FileChunk.Log("[TaskTrackingStart.SGSaveChunk]\n");
        
        FileChunk cFC = GameObject.NewChunk(ESGChunksChrome._CHK_TASK_TRACKING_START, cFCParent);
        
        super.SGSaveChunk(cFC);
        cFC.SaveObjectRef(m_TrackedTarget);
        cFC.SaveBool(m_bLookOnly);
        cFC.SaveBool(m_bCanTurn);

        cFC.delete(); 
    }				
    
    public void SGUpdate()
    {
        FileChunk.Log("[TaskTrackingStart.SGUpdate]\n");
        super.SGUpdate();
        //
    }

}
