public class TasksList implements ISaveGame
{
	java.util.ArrayList aTasksList = new java.util.ArrayList();
    boolean bWarningPrinted = false;
    
    
    /** Dodaje do listy taskow task podanego typu
     *  @param task task, ktory ma byc dodany do listy
     *  @param bCleaningTask znacznik, ze jest to task 'sprzatajacy' po scenariuszu
     */
    void AddTask(Task task, boolean bCleaningTask)
    {
        aTasksList.add(task);
        if (bCleaningTask)
            task.SetScenarioCleaning();
        if (!bWarningPrinted && aTasksList.size() > 50)
        {
            GameObject.CrashLog("WARNING: Tasks count exceeds 50 in TasksList.AddTask for " + 
                                task.m_cAI.GetMesh().GetName() +
                                "!!!\n");
            bWarningPrinted = true;
        }
    }
    
	/***usuwa task na zadanej pozycji	 */
	void RemoveTask(int nId)
	{
		aTasksList.remove(nId);
	}
	
	/** pobiera pierwszy task usuwajac go z kolejki
	 */
	Task GetFirstTask()
	{
		if (aTasksList.size() == 0)
			return null;
		Task task = (Task) aTasksList.get(0);
		aTasksList.remove(0);
		return task;
	}
	
	/** pobiera referencje na task w kolejce
	 */
	Task GetFirstTaskNoRemove(int iNum)
	{
		if ( (iNum < 0) || (iNum >= aTasksList.size()) )
			return null;
		
		return (Task) aTasksList.get(iNum);
	}
	
	Task GetTask(int iNum)
	{
		return (Task)aTasksList.get(iNum);
	}
	void ClearAll()
	{
		aTasksList.clear();
	}
	
	boolean IsEmpty()
	{
		return (aTasksList.size() == 0);
	}
	
	int GetTasksNum()
	{
		return aTasksList.size();
	}
	
	public String toString()
	{
		return " "+aTasksList;
	}	
    
    public void SetAIControllerInTasks(AIController controller)
    {
        Task task;
        for (int i = 0; i < aTasksList.size(); i++)
        {
            task = (Task)aTasksList.get(i);
            if (task != null)
                task.SetAIController(controller);
        }
    }

    //*********************************************************
    //					SaveGame
    //*********************************************************
	
    public void SGLoadChunk(FileChunk cParentFC)
    {	
		FileChunk.Log("[TasksList.SGLoadChunk]\n");
        
        if (aTasksList == null)
            FileChunk.Log("[TasksList] NULL\n");
		
		FileChunk cFC = GameObject.LoadChunk(cParentFC);   
        if (cFC.GetID() == ESGChunksChrome._CHK_TASKS_LIST)
        {
            aTasksList.clear();
            int elems = cFC.LoadInt();
            for (int i = 0; i < elems; i++)
                aTasksList.add((Task)cFC.LoadObjectRef());
        }
		
		cFC.delete();
	}
    
    public void SGSaveChunk(FileChunk cFCParent)
    {
		FileChunk.Log("[TasksList.SGSaveChunk]\n");
		
        FileChunk cFC = GameObject.NewChunk(ESGChunksChrome._CHK_TASKS_LIST, cFCParent);

        int elems = aTasksList.size();
        cFC.SaveInt(elems);
        for (int i = 0; i < elems; i++)
            cFC.SaveObjectRef((Task)aTasksList.get(i));

        cFC.delete(); 
	}				
	
	public void SGUpdate()
	{
		FileChunk.Log("[TasksList.SGUpdate]\n");
	}
}
