public class EditorLocation extends EditorRenderableObject implements iact_EnableDisable, iact_Accomplish
{
    /** tip wyswietlajacy sie nad tekstura lokacja */
    public String sTipID = "";//#EDITORLOCATION;Location tip - identifier from localized strings
    
    /** tekstura wyswietlajaca sie na mapie w miejscu lokacji */
    public EnumLocPicture cPicture = new EnumLocPicture(EnumLocPicture._1);//#EDITORLOCATION;Picture of this location
    
    /** obiekt, ktory jest sledzony */
    public ControlObject cTrackedObject = null;//#EDITORLOCATION;Tracked object

    public boolean bTrackDynamic = false;//#EDITORLOCATION;Should location be updated (moving object)
    
    /** obiekt objective, z ktorym zwiazana jest ta lokacja */
    EditorObjective cObjective = null;
    
    /** numer location, jezeli nie jest zwiazane ono z zadna lokacja */
    int m_iAutoNumber = 0;

    public boolean bEnableOnStart = true;//#EDITORLOCATION;Should location be enabled on mission start
	
    EditorLocation()
	{		
		iRenderType = EEditorRenderType._MESH;
		EditorMeshName = "data\\interface\\choragiewka.3da";
	}
	
    public void OnCreate()
    {
        bSG = true;
        super.OnCreate();
    }
    
    public boolean UpdateDataByMatrix(){ return false; }
    
	public boolean UpdateMatrixByData(){ return false; }

    public void OnPostCreate()
    {
        // jezeli location nie jest przyporzadkowany do zadnego objective
        if (cObjective == null)
            m_iAutoNumber = ObjectivesManager.GetNextAutoNumber();
    }
    
    public void Enable()
    {
        if ( !(GetModule() instanceof ChromeModule) )
            return;
        
        ChromeModule module = (ChromeModule) GetModule();
        if (m_iAutoNumber != 0)
            module.m_ObjectivesManager.EnableLocation(m_iAutoNumber);
    }
    
    public void Disable()
    {
        if ( !(GetModule() instanceof ChromeModule) )
            return;
        
        ChromeModule module = (ChromeModule) GetModule();
        if (m_iAutoNumber != 0)
            module.m_ObjectivesManager.DisableLocation(m_iAutoNumber);
    }
    
    public boolean IsEnabled()
    {
        if ( !(GetModule() instanceof ChromeModule) )
            return false;
        
        ChromeModule module = (ChromeModule) GetModule();
        if (m_iAutoNumber != 0)
            return module.m_ObjectivesManager.IsEnabledLocation(m_iAutoNumber);
        
        return false;
    }
    
    public void Accomplish()
    {
        if ( !(GetModule() instanceof ChromeModule) )
            return;
        
        ChromeModule module = (ChromeModule) GetModule();
        if (m_iAutoNumber != 0)
            module.m_ObjectivesManager.AccomplishedLocation(m_iAutoNumber);
    }
    
    public void Unaccomplish()
    {
        if ( !(GetModule() instanceof ChromeModule) )
            return;
        
        ChromeModule module = (ChromeModule) GetModule();
        if (m_iAutoNumber != 0)
            module.m_ObjectivesManager.UnaccomplishedLocation(m_iAutoNumber);
    }
    
    public boolean IsAccomplished()
    {
        if ( !(GetModule() instanceof ChromeModule) )
            return false;
        
        ChromeModule module = (ChromeModule) GetModule();
        if (m_iAutoNumber != 0)
            return module.m_ObjectivesManager.IsAccomplishedLocation(m_iAutoNumber);
        
        return false;
    }
    
    //*********************************************************
	//					SaveGame
    //*********************************************************
	
    /** Metoda wczytujaca zapisane dane w Save gracza
     */	
    public void SGLoadChunk(FileChunk cParentFC)
    {
		FileChunk.Log("[EditorLocation.SGLoadChunk]\n");
        
		FileChunk cFC = GameObject.LoadChunk(cParentFC);
        
        if (cFC.GetID() == ESGChunksChrome._CHK_EDITOR_LOCATION)
        {
			super.SGLoadChunk(cFC);
            
            ChromeModule module = (ChromeModule) GetModule();
            module.m_ObjectivesManager.SetMessagesActive(false);
            
            if(cFC.LoadBool())
                Enable();
            else
                Disable();
            
            if(cFC.LoadBool())
                Accomplish();
            else
                Unaccomplish();
            
            module.m_ObjectivesManager.SetMessagesActive(true);
        }
		
		cFC.delete();
	}
	
    /** Metoda zapisujaca dane do Save gracza
     */		
    public void SGSaveChunk(FileChunk cFCParent)
    {
		FileChunk.Log("[DefLocation.SGSaveChunk]\n");
        
        FileChunk cFC = NewChunk(ESGChunksChrome._CHK_EDITOR_LOCATION, cFCParent);
		
		super.SGSaveChunk(cFC);
		
        cFC.SaveBool(IsEnabled());
        cFC.SaveBool(IsAccomplished());
        
		cFC.delete();
	}			
}
