
public class FPPHands extends MeshObject
{
    /** Tablica z numerami materialow do podmieniania cyferek.
     * Im mlodsza cyfra jest tym nizej w tablicy jest. */
    int aDigitMaterials[] = null;
    
    /**Tablica z numerami materialow do podmiany przy cloaking device
     */
    int iOriginalMaterials[] = null;
    
    String sOriginalMaterials[] = null;
    
    boolean m_bCloakingOn = false;
    
    boolean m_bTermovisionOn = false;

    boolean m_bCloakingBeforeTermo = false;
    
    int nDigitSet = -1;
    
    FPPHands()
    {
        MeshName = "Data/Meshes/Logan/Knife.3DA";
        
        //aDigitMaterials = new int[] { 0,1,2 };
    }

    public String sBarrelDummyName = "Barrel";
    int nBarrelElement = -1;

    void OnCreate()
    {
		bSG = false;
		
        nBarrelElement = GetElementID(sBarrelDummyName);

        SetFlag(EFlags._ALWAYS_ON_TOP);
        SetFlag(EFlags._PORTAL_INDEPENDENT);
        SetFlag(EFlags.USE_TERRAIN_LIGHTMAP_FOR_LIGHTING);
        ClearFlag(EFlags._RECEIVE_SHADOWS);
        ClearFlag(EFlags._BLOCK_MOVE);
        ClearFlag(EFlags._BLOCK_TRACE);
        ClearFlag(EFlags._FXPARTICLE_COLLISION);
        ClearFlag(EFlags._IS_REFLECTED);
        
        SetLighting(true);
        
        // wylaczamy renderowanie rekom defaultowo
        EnableRendering(false);
        
        sOriginalMaterials = GetMaterials(0);
        
        //sOriginalMaterials[0] = "Dlonie.mat";
        //sOriginalMaterials[1] = "DlonieRekawica.mat";
        
        iOriginalMaterials = new int[sOriginalMaterials.length];
        for (int i = 0; i < sOriginalMaterials.length; i ++)
            iOriginalMaterials[i] = MaterialGetID(sOriginalMaterials[i]);

        //PROFILE_MAT_CHANGE = ProfileAdd("Czesiu", "Weapon shot mat change");
    }

    //static int PROFILE_MAT_CHANGE = 0;
    boolean bProfileMaterialChange = false;
    
	void OnDestroy()
	{
		DetachFromParent();
		super.OnDestroy();
	}
	
    void SetPlayer(Player cPlayer)
    {
        SetReflectionObject(cPlayer);
    }
    
    /** Zwraca aktualna pozycje guna
     */
    Vector GetBarrelPos()
    {
        if( nBarrelElement > -1)
            return GetElementLocalPos( nBarrelElement );
        else
            return new Vector();
    }
    
    Vector GetBarrelWorldPos()
    {
        if( nBarrelElement > -1)
            return GetElementPos( nBarrelElement );
        else
            return Vector.Zero;
    }
	
	void SetHandsOnTop(boolean bOnTop)
	{
		if (bOnTop)
			SetFlag(EFlags._ALWAYS_ON_TOP);
		else
			ClearFlag(EFlags._ALWAYS_ON_TOP);
	}
    
    public void ChangedAmmoQuantity(Weapon cWeapon)
    {
        if(nDigitSet==-1 || aDigitMaterials==null || m_bCloakingOn || m_bTermovisionOn) 
            return;

        // wyciagamy cyferki
        int nPow10 = 1;
        for(int i=0; i<aDigitMaterials.length; i++)
        {
            int n = (cWeapon.nAmmo / nPow10) % 10;
            nPow10 *= 10;
			
            //if(bProfileMaterialChange) ProfileBegin(PROFILE_MAT_CHANGE);
            if (i >= 0 && i < aDigitMaterials.length)
            {
                int iMat = Precache.GetDigitMat(nDigitSet, n);
                if(iMat > -1) ReplaceOriginalMaterial(aDigitMaterials[i], iMat);
            }
            
            //if(bProfileMaterialChange) ProfileEnd(PROFILE_MAT_CHANGE);
        }
    }
    
    public void SetCloaking(boolean bOn)
    {
        if(iOriginalMaterials == null) 
            return;

        //termowizja jest wazniejsza
        if (m_bTermovisionOn)
        {
            m_bCloakingBeforeTermo = bOn;
            return;
        }
        
        if (m_bCloakingOn != bOn)
        {
            m_bCloakingOn = bOn;
            if (bOn)
            {
                sOriginalMaterials = GetMaterials(0);
                for(int i=0; i<iOriginalMaterials.length; i++)
                {
                    ReplaceOriginalMaterial(iOriginalMaterials[i], "cloaked.mat" );
                }
            }
            else
            {
                for(int i=0; i<iOriginalMaterials.length; i++)
                {
                    ReplaceOriginalMaterial(iOriginalMaterials[i], sOriginalMaterials[i] );
                }
            }
        }
   }
	
    public void SetTermovision(boolean bOn)
    {
        /*if(iOriginalMaterials == null) 
            return;
        
        if (m_bTermovisionOn != bOn)
        {
            m_bTermovisionOn = bOn;
            
            if (bOn)
            {
                if (!m_bCloakingOn)
                    sOriginalMaterials = GetMaterials(0);
                
                m_bCloakingBeforeTermo = m_bCloakingOn;
                //SetCloaking(false);
                
                for(int i=0; i<iOriginalMaterials.length; i++)
                {
                    ReplaceOriginalMaterial(iOriginalMaterials[i], "Termowizja_gun.mat" );
                }
                
                m_bCloakingOn = false;
            }
            else
            {
                for(int i=0; i<iOriginalMaterials.length; i++)
                {
                    ReplaceOriginalMaterial(iOriginalMaterials[i], sOriginalMaterials[i] );
                }
                SetCloaking(m_bCloakingBeforeTermo);
            }
        }*/
        
    }        
}
