public class PlayerLevel02 extends PlayerSingle
{
    String sBeforeMovieState = null;

    AnimActor cMovieModel = null;
    
    boolean bIsMovieModelActive = false;
    
    
    public void OnCreate()
    {
        super.OnCreate();
        CallMethodIn("InitMovieModel", 0);
    }
    
    void InitMovieModel()
    {
        cMovieModel = (AnimActor)CreateObjectNoInit("AnimActor");
        cMovieModel.MeshName = "Data/Meshes/Movies/Logan2_LODs.3da";
        cMovieModel.InitObject();
        cMovieModel.SetFlags(EFlags._CAST_SHADOWS | EFlags._PORTAL_INDEPENDENT | 
                             EFlags._RECEIVE_SHADOWS);
        cMovieModel.SetLighting(true);
        cMovieModel.InitAnimSeqFile("Data/Meshes/Movies/Logan2_LODs.scr");
        cMovieModel.ActivateOnModule();
        cMovieModel.SetPhysicsType(EPhysics._WALK);
        cMovieModel.SetPhysicsActive(false);
        cMovieModel.EnableRendering(false);
        cMovieModel.SetEllipsoidNoExtents(70.f, 180.f, 90.f);
        cMovieModel.SetAnimMorphTime(0.3f);
    }

    /** Pokryte, bo na filmie gracz 'mowi przez inny model'
     */
    public void Speak(String sText)
    {
        if (bIsMovieModelActive)
        {
            String sLower = sText.toLowerCase();
            // znajdz nazwe animacji do odtworzenia
            if (sLower.indexOf("film02-03") != -1)// jesli to z wlasciwego filmu
            {
                if (sLower.indexOf("gadka03") != -1)
                    cMovieModel.PlayAnim("Gadka03", 1);
                else if (sLower.indexOf("gadka05") != -1)
                    cMovieModel.PlayAnim("Gadka05", 1);
                else if (sLower.indexOf("gadka07") != -1)
                    cMovieModel.PlayAnim("Gadka07", 1);
                else if (sLower.indexOf("gadka09") != -1)
                    cMovieModel.PlayAnim("Gadka09", 1);
            }
            cMovieModel.Speak(sText);
            cMovieModel.SetAnimMorphTime(0.3f);
        }
        else
            super.Speak(sText);
    }

    
    /** Przelaczenie na model z filmu
     */
    public void SwitchModels(boolean bUseMovieModel)
    {
        bIsMovieModelActive = bUseMovieModel;

        if (ActiveWeapon != null)
            ActiveWeapon.EnableRendering(!bUseMovieModel);
        EnableRendering(!bUseMovieModel);

        if (bUseMovieModel)
            ClearFlag(EFlags._BLOCK_MOVE);
        else
            SetFlag(EFlags._BLOCK_MOVE);
        
        cMovieModel.EnableRendering(bUseMovieModel);
    }


    /** Wolane z Level02
     */
    public void TriggerEnterHangarMovie(Vector vStartPos, Vector vDir)
    {
        SwitchModels(true);
        cMovieModel.SetPosition(vStartPos);
        cMovieModel.SetDir(vDir);
        StartEnterHangarMovie();
    }
    
    
    public void TriggerMoveToSpeakPos(ControlObject cPlaceholder)
    {
        cMovieModel.FromUpForwardPos(cPlaceholder.GetUpVector(),
                                     cPlaceholder.GetForwardVector(),
                                     cPlaceholder.GetPosition());
        FromUpForwardPos(cPlaceholder.GetUpVector(),
                                     cPlaceholder.GetForwardVector(),
                                     cPlaceholder.GetPosition());
        cMovieModel.PlayAnim("stoi", -1);
        cMovieModel.SetPhysicsActive(false);
    }
    
    public void TriggerMovieEnd()
    {
        SwitchModels(false);
        StopEnterHangarMovie();
    }
        
        
    public void StartEnterHangarMovie()
    {
        sBeforeMovieState = sCurrentState;
        SetState("Level02_Movie03");
    }
    
    public void StopEnterHangarMovie()
    {
        StopGo();
        SetState(sBeforeMovieState);
    }
    
    public void StopGo()
    {
        //SetPhysicsActive(false);
        motion.Stop();
        SetSpeedValue(0);
        CharacterAnims.PlayLoop(BaseAnimations.A_STAND);
    }
    
    public void Go()
    {
        /*
        SetPhysicsActive(true);
        
        byte iSpeed = MotionState.SPEED_WALK;
        SetLocalSpeed(new Vector(0,0, aMotionVelocity[iSpeed]));

        motion.iSpeed = iSpeed;
        motion.iMoveX = 0;
        motion.iMoveX = 1;
        BodyDeformAimAtVReset();
        BodyDeformAimAtHReset();

        CharacterAnims.SetupAnims(motion, ActiveWeapon);
        CharacterAnims.PlayLoop(BaseAnimations.A_FORWARD);
        */
        
        cMovieModel.SetPhysicsActive(true);
        cMovieModel.SetLocalSpeed(new Vector(0,0,150));
        cMovieModel.PlayAnim("idzie", -1);
    }
    
    
    void CheckIfSwimming()
    {
        super.CheckIfSwimming();

        if(GetPosition().fY < -3000.0f)
        {
            //FIXIT
            PlaySound("Data/Sounds/Ai/krzyk 09");
            Die();
        }

    }
    
    public class Level02_Movie03 extends PlayerState
    {
        public void OnEnter()
        {
            super.OnEnter();
            Go();
        }
    }
}
