public class PlayerSingle extends PlayerHUD
{
    //TODO : do wyjebania - zmienne pomocznicze do dzialanie implantu BioREgeneration (nie dziala ACQUIRE dla implantow)
    float fAddingHealthFreq = 1.0f;
    float fAddingHealthUnits = 10.0f;
    
    
    
    PlayerSingle()
    {
        super();
        //w grze single zawsze mamy do czynienia w "naszym" graczem
        bNetIsOwner = true;
    }

    /** Single Player ma tylko jeden spawn point
     */
    SpawnPoint spawnPoint = null;
    
    
    
    //TODO : Wyjebac ta metoda i jej wolanie do implantu PO NAPRAWIENIU ACQUIRE
    public void AddHealthUnit()
    {
		if (fHealth+fAddingHealthUnits >= fMaxHealth)   
			fHealth = fMaxHealth;
		else fHealth+=fAddingHealthUnits;
       
		HUD.GetHUDPlayer().SetTextHealth(fHealth);
    }


    /** W SinglePlayer gracz ma zawsze takie same obrazenia zewnetrzne.
     */
    float GetDamageMultiplier(int nBone)
    {
        return 1.0f;
    }
    
    /** Pokryta metoda OnTakeDamage. W SinglePlayer dodatkowo notyfikuje AI o tym ze trafil
     * skutecznie gracza.
     */
/*    public void OnTakeDamage(float fDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed, int nDamageType)
    {
        super.OnTakeDamage(fDamage, Assassin, vHitLocation, vSpeed, nDamageType);

        // powiadamiamy AI, ze nas trafilo
        if(Assassin != null)
            if(Assassin instanceof AIAttacker)
            {
                AIAttacker cAttacker  = (AIAttacker)Assassin;
                cAttacker.NotifyPlayerHit(this);
            }
        
        // wyslanie komunikatu do modulu ze gracz zarobil
        if ( GetModule() != null && GetModule() instanceof ChromeModuleSingle )
        {
            ((ChromeModuleSingle)GetModule()).MessageToHints( HintManager._MSG_TAKENDAMAGE );
        }
    }
*/    
	// poprawione OnTakeDamage //////////////////////////////////////////////////////////////
    public void OnTakeDamage(float fDamage, float fPhSimDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed, int nMeshElementorBoneID, int nDamageType)
    {
        super.OnTakeDamage(fDamage, fPhSimDamage, Assassin, vHitLocation, vSpeed, nMeshElementorBoneID, nDamageType);
        
        // powiadom przeciwnika, ze trafil
        if (Assassin instanceof ChromeActor)
            ((ChromeActor)Assassin).NotifyHit(this, nDamageType);

        /*
        //tego juz chyba nie ma?
        
        // powiadamiamy AI, ze nas trafilo
        if(Assassin != null)
            if(Assassin instanceof AIAttacker)
            {
                AIAttacker cAttacker  = (AIAttacker)Assassin;
                cAttacker.NotifyPlayerHit(this);
            }*/
        
        // wyslanie komunikatu do modulu ze gracz zarobil
        if ( GetModule() != null && GetModule() instanceof ChromeModuleSingle )
        {
            ((ChromeModuleSingle)GetModule()).MessageToHints( HintManager._MSG_TAKENDAMAGE );
        }
    }

///////////////////////////////////////////////////////////////////////////////    
    public void OnCreate()
    {
        Log("[PlayerSingle.OnCreate] Inicjalizuje "+MeshName+"\n");

        super.OnCreate();
        
        SetCollFlags(ECollFlags.OBJCOL_FLAG_AUTOATTACH |
                     ECollFlags.OBJCOL_FLAG_CHECKFROMLASTPOS |
                     ECollFlags.OBJCOL_FLAG_DONTDETACHINAIR);
        // inicjalizacja HUDa
        InitHUD();

        //stworzenie kamery
        Camera=(CameraPlayer)CreateObject("CameraPlayer");
        Camera.Target=this;

        //playerSingle ddomyslnie w FPP
        Camera.SetMode(CameraPlayer.CMODE_FPP);
        Camera.SetTake(motion, false);

        SetName("lodzian");
        
        if (ChromeGame.bFilms)
        {
            fHealth = 100000.0f;
            fMaxHealth = 100000.0f;
        }
        
        PrecacheWeaponFPPMeshes();
        
        Log("[PlayerSingle.OnCreate] DONE \n");
    }

    /** Doczytanie broni jakie ma gracz w inventory
     */
    void PrecacheWeaponFPPMeshes()
    {
        // dodajemy graczowi standardowe bronie, jakie ma w inventory
        java.util.Vector aInvWeapons = cInventory.GetInvObjects(EInvObjType._GUN);
        if(aInvWeapons != null)
            for(int i=0; i<aInvWeapons.size(); ++i)
            {
                InvObject cInvWeapon = (InvObject)aInvWeapons.elementAt(i);
                FindWeaponByName(cInvWeapon.getClass());
            }
    }
    
    Weapon cStartWeapon = null;
    
    /** inicjalizacja inventory playera
     */
    void InitInventory()
    {
        Log("[PlayerSingle.InitInventory] \n");
        // pobieramy inventory z poprzedniego levelu
        Module module=GetModule();
        ChromeModuleSingle cModule = null;
        try {
            cModule= (ChromeModuleSingle)module;
        } catch (ClassCastException e)
        {
            Log("[PlayerSingle.InitInventory] Player single created on module not inherited from ChromeModuleSingle!\n");
            e.printStackTrace();
            return;
        }
        
        GameInitInfoSingle cGameInfoSingle = null;
        
        try {
            cGameInfoSingle = (GameInitInfoSingle)cModule.cGameInitInfo;
        } catch (ClassCastException e)
        {
            Log("[PlayerSingle.InitInventory] Module created with wrong GameInitInfo class not inherited from GameInitInfoSingle!\n");
            e.printStackTrace();
            return;
        }
        
        if(cGameInfoSingle.GetInventory() != null)
        {
            Log("[PlayerSingle.InitInventory] Getting inventory from previous level\n");
        
            cInventory = cGameInfoSingle.GetInventory();
        
            // teraz trzeba w inventory poprzestawiac wszystko na aktualnego gracza
            cInventory.Acquire(GetModule(), this);
        }
        else
        {
            Log("[PlayerSingle.InitInventory] Creating new inventory for player\n");
            
            cInventory = (InventoryPlayer)CreateObjectNoInit("InventoryPlayer");
            cInventory.Owner = this;
            cInventory.InitObject();

            
            // zawsze gracz ma noz
            //((Weapon)CreateObject("WeaponKnife")).AddToInventory(this);
            //MK:
            //bedzie mozna w jednym miejscu zdecydowac czy rodzimy sie z nozem czy z raczkami
            String cWeaponClassName = GetInbornWeaponClass().getName();
            Weapon cWeapon = (Weapon)CreateObject( cWeaponClassName );
            cWeapon.SetInborn();
            cWeapon.AddToInventory( this );
            
            // dodajemy rifle'a, ale na prologu nie moze go byc od razu
            /*
            if(!(GetModule() instanceof Level00))
                ((Weapon)CreateObject("WeaponRifle")).AddToInventory(this);
            */
            
            java.util.Vector aItems = cGameInfoSingle.cLevels.GetCurrent().aStartItems;
            if(aItems != null)
            {
                String sName = null;
                
                for(int i=0; i<aItems.size(); ++i)
                {
                    sName = (String)aItems.elementAt(i);
                    if(sName != null)
                    {
                        InvObject cObj = (InvObject)CreateObject(sName);
                        if(cObj != null)
                            cObj.AddToInventory(this);
                        else
                            CrashLog("[PlayerSingle.InitInventory] <"+sName+"> no such class!\n");
                    }
                }
            }
        }
        
        // znajdujemy bron poczatkowa
        String sStartWeapon = cGameInfoSingle.cLevels.GetCurrent().sStartWithWeapon;
        if(sStartWeapon != null)
        {
            InvObject cObj = cInventory.GetFirstInvObject( EInvObjType._GUN );
            while( cObj != null )
            {
                if( cObj.getClass().getName().equals(sStartWeapon))
                {
                    cStartWeapon = (Weapon)cObj;
                    break;
                }
                cObj = cInventory.GetNextInvObject();
            }
        }
        
        // ustawiamy identyfikator obiektow
		//module.SetNextIDValue(200000000);
    }

    /** Metoda zwraca punkt na ktorym mozna stanac w podanej pozycji
     */
    Vector GetGround(Vector vPos)
    {
        // puszczamy promien w dol po obiektach
        Vector vStart = new Vector(vPos);
        vPos.fY = -10.0f;
        Collision col = TraceObjects(vStart, vPos);
        
        // teraz sprawdzamy jaka jest wysokosc w punkcie
        Vector vTerrSize = GetTerrainSize();
        
        float fTerrainLevel = -1000.0f;
        
        if( (vPos.fX < vTerrSize.fX) && (vPos.fX > 0) &&
            (vPos.fZ < vTerrSize.fZ) && (vPos.fZ > 0) )
        {
            fTerrainLevel = TerrainHeight(vPos.fX, vPos.fZ);
        }
        
        if(fTerrainLevel > vPos.fY)
            return new Vector(vPos.fX, fTerrainLevel, vPos.fZ);
        else
            return new Vector(vPos);
    }

    public void Respawn()
    {
        if (spawnPoint != null)
        {
            SetPosition(GetGround(spawnPoint.GetPosition()));
            SetDir(spawnPoint.GetForwardVector());
        }

        super.Respawn();

        // pobieramy jaka bron jest defaultowa
        if(cStartWeapon != null)
            UseWeapon(cStartWeapon);
        else
            UseWeapon(GetBestWeapon());
            //UseWeapon( GetNextWeapon( EWeaponType._HAND ) );

        ComputeAccuracy();

        ResetHUD();

		/* IMPLANT TO CHANGE
        //TODO : to trzeba wyjebac do implantu po naprawieniu ACQUIRE
        //jesli aktywny jest implant BioREGENRATION SYSTEM to wlaczam go (dodwannie ciagle zdrowia)
        if ((cInventory != null) && (cInventory.IsImplantActive(cInventory._IMPLANT_BIO_REGENERATOR)))
        {
            fAddingHealthFreq = ((Implant02)cInventory.aImplantList[cInventory._IMPLANT_BIO_REGENERATOR]).fAddingFreq;
            fAddingHealthUnits = ((Implant02)cInventory.aImplantList[cInventory._IMPLANT_BIO_REGENERATOR]).fHealthUnits;
            CallMethodEvery("AddHealthUnit", fAddingHealthFreq);
        }
		*/
        
    }


    void OnDestroy()
    {
        super.OnDestroy();
        
        LogD("\n");
        
        // odlaczamy bronie podlaczone do kolesia
        for(int i=0; i<cInventory.aInvObjects.size(); i++)
        {
            ((InvObject)cInventory.aInvObjects.elementAt(i)).DetachFromParent();
        }
    }
    
    /** po ch.. to bylo w PlayerHUD
     *  dotyczy to tylko ChromeModuleSingle
     */
    public void Die()
    {
        //nie mozna umrzec dwa razy
        if (bDead)
            return;
        
        boolean bBurbotDie = bBurbotMode;

        super.Die();
        
        if (!bBurbotDie)
        {
            //printStackTrace("\n");
            ((ChromeModuleSingle)GetModule()).PlayerDied();
        }
    }

    /*
    void OnPhysicsUpdate(float fAbsoulteTime, float fSimInterval)
    {
        CrashLog("fAbsoulteTime"+fAbsoulteTime+" fSimInterval"+fSimInterval+"\n");
    }
    */
	
	/** proste sprawdzenie, czy gracz nie jest atakowany w danej chwili - 
	 * sprawdzana jest odleglosc od przeciwikow
	 */
	public boolean IsBeingAttacked(float fRange)
	{
		ControlObject[] aObj = GetObjectsInRadiusFromClass(GetPosition(),
														   fRange,
														   "Pawn");
        for (int i = 0; i < aObj.length; i++)
        {
            Pawn cPawn = (Pawn) aObj[i];
			
			if (!cPawn.bDead)
			{
				if (GetTeamRelation( cPawn ) < _TEAM_RELATION_NEUTRAL)
					return true;
			}
		}
		return false;
	}

    void GetIn(SeatInfo seatInfo) 
    {
        super.GetIn(seatInfo);
        
        // wyslanie komunikatu do modulu ze gracz uzyl jeepa
        if ( seatInfo.GetOccupiedObject() != null && 
             seatInfo.GetOccupiedObject() instanceof Jeep &&
             GetModule() != null && 
             GetModule() instanceof ChromeModuleSingle )
        {
            ((ChromeModuleSingle)GetModule()).MessageToHints( HintManager._MSG_JEEPUSED );
        }
    }

    void MessageWeapon(int nState)
    {
        super.MessageWeapon(nState);
        
        if ((nState & Weapon.STATE_NO_AMMO) != 0)
        {
            // wyslanie komunikatu do modulu ze braklo amunicji
            if ( GetModule() != null && GetModule() instanceof ChromeModuleSingle )
            {
                ((ChromeModuleSingle)GetModule()).MessageToHints( HintManager._MSG_NOAMMO );
            }    
        }
    }    
        
    boolean WeaponReload()
    {
        // wyslanie komunikatu do modulu ze braklo amunicji
        if ( GetModule() != null && GetModule() instanceof ChromeModuleSingle )
        {
            ((ChromeModuleSingle)GetModule()).MessageToHints( HintManager._MSG_WEAPONRELOADED );
        }    
        return super.WeaponReload();
    }
	
	
    ///////////////////////////////////////////////////////////////////////////
    // inventory room
    ///////////////////////////////////////////////////////////////////////////

	InventoryRoom GetInventoryRoom()
	{
		return ((ChromeModuleSingle) GetModule()).cGameInitInfo.cInventoryRoom;
	}
    
    void RefreshUpVector()
    {
        if (GetParent() == null &&
            !((ChromeModuleSingle)GetModule()).IsMoviePlaying())
            FromUpForwardPos(Vector.Up, GetForwardVector(),GetPosition());
    }
    
    void UpdateMotion()
    {
        super.UpdateMotion();
        RefreshUpVector();
    }
    
    ////////////////////////////////////////////////////////////////////////////
    
    public Vector GetPointToLookAt(int idx)
    {
        if (Camera.GetMode() == CameraPlayer.CMODE_FPP)
        { 
            if (!IsLeaning())
            {
                return Camera.GetPosition();
            }
            else
            {
                Vector vPos = GetRenderPosition();
                vPos.fY = Camera.GetPosition().fY;
                return vPos;
            }
        }
        else
            return super.GetPointToLookAt(idx);
    }

    
    static Collision l_cCollision = new Collision();
    static Vector l_vNearestPoint = new Vector();
    static Vector l_vNearestPointNormal = new Vector();
    
    public float _CAMERA_TARGET_SIZE = 30f;
    public float _MIN_WEAPON_CAMERA_DISTANCE2 = 50f * 50f;
    
    public Collision CheckBulletTrajectory(Weapon weapon, Vector vStart, Vector vEnd)
    {
        Vector vCameraPos = Camera.GetPositionVolatile();
        // jesli strzela gracza albo bron zbyt blisko - zignoruj, zeby gracz nie trafial sam siebie
        if (weapon.Owner == this ||
            weapon.GetDistance2To(vCameraPos) < _MIN_WEAPON_CAMERA_DISTANCE2)
            return null;
        
        Tools.findNearestPointOnSection(vStart, vEnd, vCameraPos, l_vNearestPoint);
        float fDist = l_vNearestPoint.Distance(vCameraPos);
        if (fDist <= _CAMERA_TARGET_SIZE)
        {
            l_vNearestPointNormal.Set(l_vNearestPoint);
            l_vNearestPointNormal.Sub(vCameraPos);
            l_vNearestPointNormal.Mul(1.f / fDist);
            l_cCollision.vNormal = l_vNearestPointNormal;

            l_cCollision.fDistance = vStart.Distance(l_vNearestPoint);
            l_cCollision.Obstacle = this;
            l_cCollision.ObstacleElement = 0;
            l_cCollision.nMaterial = 0;
            return l_cCollision;
        }
        else 
            return null;
    }
}
