public class SoundEmitterSimple extends SoundEmitter
{
    /** Nazwa dzwieku do odgrywania */
    public String sSoundName = "Data/Sounds/Generator.wav";//#SOUND_EMITTER_SIMPLE
    
/************************************************************************************/
    
    /** Identyfikator odgrywanego dzwieku */
    int nPlayedSound = 0;
    
    void Init()
    {
    }

    void Check()
    {
        UpdateDistanceToCamera();
        CheckSound();
    }
    
    boolean ShouldIStopSound()
    {
        return (bSoundDisabled) ||
            (bSoundsDisabled) ||
            (bListenerInsideBuilding) ||
            (GetModule() instanceof ChromeModuleSingle && ((ChromeModuleSingle)GetModule()).m_bMissionEnded)||
            (fDistanceToCamera > (fMaxDistance + fCameraMaxSpeed * fCheckTime));
    }
    
    void CheckSound()
    {
        if (ShouldIStopSound())
        {
			if ((nPlayedSound != 0) && IsSoundPlaying(nPlayedSound))
                StopSound(nPlayedSound);
        }
        else
        {
            if (nPlayedSound == 0)
                nPlayedSound = AttachSound(sSoundName, fMinDistance, fMaxDistance);
            
            if (!IsSoundPlaying(nPlayedSound))
                PlaySound(nPlayedSound);
        }
    }
    
    /**********************************************
     ** implementacja interfejsu iact_EnableDisable
     ***********************************************/    
    public void Enable()
    {
        super.Enable();
        Check();
    }
    
    public void Disable()
    {
        super.Disable();
        Check();
    }
    
    public void OnAudioReinitialize()
    {
		nPlayedSound = 0; 
        Check();
    }

}
