public class FlyingTransporter extends FlyingVehicle 
    implements iact_Appear, iact_LockOpened, iact_LockUnlock
{
    public boolean bAppearAttached = true;//#\FLYINGTRANSPORTER;true if act_Appear works also on attached objects

    /** nazwy meshelementow i ich numery */
    String sForwardWheel = "GolenP";
    int m_iForwardWheelElem = -1;
    String sBackwardRightWheel = "GolenTP";
    int m_iBackwardRightWheelElem = -1;
    String sBackwardLeftWheel = "GloenTL";
    int m_iBackwardLeftWheelElem = -1;
    String sHideWheelsAnim = "chowaniep";
    String sShowWheelsAnim = "wysuwaniep";
    
    String sDoor = "Rampa";
	int m_iDoorElem = -1;
    String sWysiegnikP = "WysiegnikP1";
	int m_iWysiegnikPElem = -1;
    String sWysiegnikL = "WysiegnikL1";
	int m_iWysiegnikLElem = -1;
    String sOpenAnim = "otwieraniedrzwi";
    String sCloseAnim = "zamykaniedrzwi";

    boolean m_bLocked = false;
    
    boolean m_bClosed = false; // czy drzwi sa otwarte
    boolean m_bChangingState = false; // czy drzwi sie wlasnie otwieraja/zamykaja
    
    String sEngineLeft = "SilnikL";
	int m_iEngine1Elem = -1;
    String sEngineRight = "SilnikP";
	int m_iEngine2Elem = -1;
    boolean m_bEngineRotating = true;
	
    /** zarzace sie silniki */
	String sEnginesExhaust = "FXFlyingEngine";
	/** dym za pojazdem po jego trafieniu */
	String _VEHICLE_SMOKE = "SmokeFlyingVehicle";
	
    /** Dzwiek otwierania i zamykania klapy */
    String sDoorOpenSound = "Data/Sounds/DoorD_Open";
    String sDoorCloseSound = "Data/Sounds/DoorD_Close";

    /** liczba zarzacych sie silnikow */
	int _ENGINE_EXHAUST_NUM = 4;
	/** czas pomiedzy updatem zarzenia sie */
	float _UPDATE_ENGINE_TIME = 0.1f;
	
	/** parametry dotyczace obracania sie silnikow */
	float _ENGINE_ROT_SPEED = 30f;
	float _ENGINE_STOP_ANGLE = -90f;
	float _ENGINE_FLY_ANGLE = -20f;
	float _ENGINE_LAND_ANGLE = 0f;
	
	float m_fLastUpdateTime = 0f;

	float m_fCurrEngAngle = 0;

    float fFXSmokeUpdateTime = 0.15f;
	boolean m_bSmokeSpawned = false;
	public float fSmokeHealthLevel = 10f;//#FLYINGTRANSPORTER;Level of health [%] when smoke is generated after hit
	
	int m_EnginesExhaust[] = new int[_ENGINE_EXHAUST_NUM];

	boolean m_bLanded = true;

    // Trzesienie kamera
    public float fBlowUpShakeStrength = 0;//#FX;
    public float fBlowUpShakeDistMin = 0;//#FX;
    public float fBlowUpShakeDistMax = 0;//#FX;

    /////////////////////////////////////////////////////////////////////
    // SIEC
    final static int _STATE_ONGROUND        = 0;
    final static int _STATE_STARTING        = 1;
    final static int _STATE_FLYING          = 2;
    final static int _STATE_LANDING         = 3;
        
    int m_nState = _STATE_ONGROUND;
    float m_fStateTime = -1.0f;
    
    static float _READYTOSTART_DELAY = 2.0f;

    /////////////////////////////////////////////////////////////////////
    // Przewozenie pasazerow
    
    /** Co jaki czas sprawdzani sa pasazerowie, zeby moc ich w pore odpiac */
    float _UPDATE_PASSENGERS_TIME = 0.7f;
    
    int _PASSENGERS_COLL_FLAGS = ECollFlags.OBJCOL_FLAG_AUTOATTACH |
                                 ECollFlags.OBJCOL_FLAG_CHECKFROMLASTPOS |
                                 ECollFlags.OBJCOL_FLAG_DONTDETACHINAIR;
    
    /** O ile maja byc powiekszone extenty w swiecie, zeby stworzyc 'otoczenie' 
     * transportera, w ktorym moga przebywac pasazerowie*/
    float m_fHorizExtMod = 100;
    float m_fMinVertExtMod = 50;
    float m_fMaxVertExtMod = 200;
    
    /** Zapamietane extenty */
    private Vector m_vMinExt = new Vector();
    private Vector m_vMaxExt = new Vector();
    
    /////////////////////////////////////////////////////////////////////
    // OBSLUGA WAYPOINTOW - ROZKAZY EDYTOROWE
    /** referencja na pierwszy waipoint */
    public Waypoint cWaypoint = null;//#\FLYINGTRANSPORTER;Reference to first Waypoint
    
    /** biezacy waypoint */
    Waypoint m_CurrWaypoint = null;
    /** biezaca aktywnosc */
    IAIActivity m_CurrActivity = null;
    /** biezacy condition dla m_CurrActivity */
    Condition m_CurrCondition = null;
    /** numer biezaco wykonywanego behaviora w waypoincie */
    int m_iCurrWaypointBehavior = 0;
    /** czy mozna wykonywac biezaca aktywnosc - m_CurrCondition zostal spelniony */
    boolean m_bPerformCurrActivity = false;
    /** rodzaj wykonywanej aktywnosci - motiontype czy behavior */
    boolean m_bActivityInWaypoint = false;

    int METHOD_CheckCurrWaypointCnd = 0;
    int METHOD_WaitingForAppear = 0;
	int METHOD_UpdatePassengers = 0;
    int METHOD_ActivateCannons = 0;
    int METHOD_DeactivateCannons = 0;

    boolean bSetEnginesInLandingPos = true;
    
    // definiujemy rysowanie kresek miedzy kolejnymi Waypointami
    public static void DefineVisualisation()
    {
        DefineDebugLine("cWaypoint", new Vector(1,1,1));
    }
    
    /////////////////////////////////////////////////////////////////////////////
    public FlyingTransporter()
    {
        fHealth = fMaxHealth = 5000;
        fDamageThreshold = 100;
        
        fBlowUpShakeStrength = 2000;
        fBlowUpShakeDistMin = 2000;
        fBlowUpShakeDistMax = 7000;
    }
    
	public void OnCreate()
	{
		super.OnCreate();

		// ustawienie maxHealth przy zalozeniu, ze jest ustawiane health w edytorze
        fMaxHealth = fHealth;
		
		SetFlag(EFlags._CAST_SHADOWS);
		SetFlag(EFlags._RECEIVE_SHADOWS);
		SetFlag(EFlags._FXPARTICLE_COLLISION);
		
		ClearFlag(EFlags._NO_ANIMATION);
		ClearFlag(EFlags._NO_ANIMATION_REFRESH);
        SetAnimMorphTime(0f);

        SetDoors();

        SetEngines();

        SetWheels();
        
        PrepareInterior();
        
        m_nState = _STATE_ONGROUND;
        m_fStateTime = -1.0f;

        METHOD_CheckCurrWaypointCnd = RegisterCallMethod("CheckCurrWaypointCnd");
        METHOD_WaitingForAppear = RegisterCallMethod("WaitingForAppear");
        METHOD_UpdatePassengers = RegisterCallMethod("UpdatePassengers");
        
        METHOD_ActivateCannons = RegisterCallMethod("ActivateCannons");
        METHOD_DeactivateCannons = RegisterCallMethod("DeactivateCannons");

		SetLighting(true);

		// jezeli pojazd jest ustawiony na nowym systemie waypointow
		if (cWaypoint != null)
		{
			ActivateVehicle(); // na poczatku jest aktywny
	        ServeNextWaypointActivity();
		}
	}

    void PrepareInterior()
    {
        ControlObject children[] = GetChildren();
        if (children == null)
            return;
        for (int i = 0; i < children.length; i++)
        {
            if (children[i] instanceof MeshObject)
            {
                MeshObject mesh = (MeshObject) children[i];
                if (mesh.MeshName.toLowerCase().lastIndexOf("interior") != -1)
                {
                    mesh.ClearFlag(EFlags._CAST_SHADOWS);
                    mesh.ClearFlag(EFlags._RECEIVE_SHADOWS);
                    return;
                }
            }
        }
    }
    
    void SetCannonsShadows()
    {
        GameObject [] children = GetChildren();
        if (children == null)
            return;
        for (int i = 0; i < children.length; i++)
        {
            if (children[i] instanceof SecurityCannon)
                ((SecurityCannon) children[i]).ClearFlag(EFlags._CAST_SHADOWS | EFlags._RECEIVE_SHADOWS);
        }
    }
    
    void SetDoors()
    {
		m_iDoorElem = GetElementID(sDoor);
        if (m_iDoorElem == -1)
            m_iDoorElem = GetElementID("Box01");
        m_iWysiegnikPElem = GetElementID(sWysiegnikP);
        m_iWysiegnikLElem = GetElementID(sWysiegnikL);
    }
    
    void SetEngines()
    {
		m_iEngine1Elem = GetElementID(sEngineRight);
		m_iEngine2Elem = GetElementID(sEngineLeft);
        
        if (m_iEngine1Elem != -1)
            SetElementAnimType(m_iEngine1Elem, (byte)(EAnimType._SEQUENCE | EAnimType._TRANSFORM), false);
        if (m_iEngine2Elem != -1)
            SetElementAnimType(m_iEngine2Elem, (byte)(EAnimType._SEQUENCE | EAnimType._TRANSFORM), false);
        
		for (int i = 0; i < _ENGINE_EXHAUST_NUM; i++)
			m_EnginesExhaust[i] = GetElementID("Engine0" + Integer.toString(i + 1));
    }
    
    void SetWheels()
    {
        m_iForwardWheelElem = GetElementID(sForwardWheel);
        m_iBackwardRightWheelElem = GetElementID(sBackwardRightWheel);
        m_iBackwardLeftWheelElem = GetElementID(sBackwardLeftWheel);
    }

    /////////////////////////////////////////////////////////////////////
    // IMPLEMENTACJA iact_Appear
    public void Appear(ControlObject m_cRefMtxHolder)
    {
        if (m_cRefMtxHolder != null && 
            m_cRefMtxHolder.GetPositionVectorVolatile() != null)
        {
			FromUpForwardPos(m_cRefMtxHolder.GetUpVectorVolatile(),
							 m_cRefMtxHolder.GetForwardVectorVolatile(),
							 m_cRefMtxHolder.GetPositionVectorVolatile());
        }        
		UnfreezeCallMethods();
        ActivateVehicle();
        if (bAppearAttached)
        {
            ControlObject[] aChildren = GetChildren();
			if (aChildren == null)
				return;
            for (int i=0; i<aChildren.length; i++)
                if (aChildren[i] instanceof iact_Appear)
                    ((iact_Appear)aChildren[i]).Appear(null);
        }
    }
    
    public void Disappear(ControlObject m_cRefMtxHolder)
    {
        if (m_cRefMtxHolder != null && 
            m_cRefMtxHolder.GetPositionVectorVolatile() != null)
        {
			FromUpForwardPos(m_cRefMtxHolder.GetUpVectorVolatile(),
							 m_cRefMtxHolder.GetForwardVectorVolatile(),
							 m_cRefMtxHolder.GetPositionVectorVolatile());
        }
		
		FreezeCallMethods();
        DeactivateVehicle();
        UnfreezeCallMethod(METHOD_WaitingForAppear);
        if (m_CurrActivity instanceof mt_Appear)
            StartWaitingForAppear();

		if (bAppearAttached)
        {
            ControlObject[] aChildren = GetChildren();
			if (aChildren == null)
				return;
            for (int i=0; i<aChildren.length; i++)
                if (aChildren[i] instanceof iact_Appear)
                    ((iact_Appear)aChildren[i]).Disappear(null);
        }
    }
    
    void StartWaitingForAppear()
    {
        CallMethodEvery(METHOD_WaitingForAppear, 0.1f);
		UnfreezeCallMethod(METHOD_WaitingForAppear);
    }
    
    public void WaitingForAppear()
    {
        if (!m_bVehicleActive)
            CheckCurrWaypointCnd();
    }
    
    public void Lock()
    {
        if ( (!m_bClosed) || (m_bClosed && m_bChangingState) )
        {
            m_bLocked = false;
            CloseDoor();
        }
        m_bLocked = true;
    }
    
    public void Unlock()
    {
        m_bLocked = false;
    }
    
    public void LockOpened()
    {
        if ( (m_bClosed) || ((!m_bClosed) && m_bChangingState) )
        {
            m_bLocked = false;
            OpenDoor();
        }
        m_bLocked = true;
    }
    
    public boolean IsLocked()
    {
        return m_bLocked;
    }
    
    public void ToggleLockUnlock()
    {
        if (IsLocked())
            Unlock();
        else
            Lock();
    }

	public void ActivateVehicle()
	{
		super.ActivateVehicle();
		
		if (m_bSmokeSpawned)
		{
			DisableCallMethod("BurnEngines");
			CallMethodEvery("BurnEngines", _UPDATE_ENGINE_TIME);
		}
        
        DisableCallMethod(METHOD_DeactivateCannons);
        DisableCallMethod(METHOD_ActivateCannons);
        
        CallMethodIn(METHOD_ActivateCannons, 0f);
        UnfreezeCallMethod(METHOD_ActivateCannons);
	}
	
	public void DeactivateVehicle()
	{
		super.DeactivateVehicle();
		
		DisableCallMethod("BurnEngines");

        DisableCallMethod(METHOD_DeactivateCannons);
        DisableCallMethod(METHOD_ActivateCannons);
        
        CallMethodIn(METHOD_DeactivateCannons, 0f);
        UnfreezeCallMethod(METHOD_DeactivateCannons);
	}

    public void DeactivateCannons()
    {
        GameObject [] children = GetChildren();
        if (children == null)
            return;
        for (int i = 0; i < children.length; i++)
        {
            if (children[i] instanceof SecurityCannon)
                ((SecurityCannon) children[i]).Disable();
        }
    }
    
    public void ActivateCannons()
    {
        GameObject [] children = GetChildren();
        if (children == null)
            return;
        for (int i = 0; i < children.length; i++)
        {
            if (children[i] instanceof SecurityCannon)
                ((SecurityCannon) children[i]).Enable();
        }
    }
    
	public void EditorStartFly(mt_StartFlying motionType)
	{
		float fTime = GetTime();
		
        m_bStarting = true;
        
        m_nState = _STATE_STARTING;
        m_fStateTime = fTime;
        
		m_bLanded = false;
		CloseDoor();
		DisableCallMethod("BurnEngines");
		CallMethodEvery("BurnEngines", _UPDATE_ENGINE_TIME);
		PlayStartSound( fTime );
		
		m_Physics.SetAccelUpDown(motionType.fAccelUpDown); 
		m_Physics.SetMaxUpDownSpeed(motionType.fSpeedUpDown);
		m_Physics.StartFly(GetCurrWaypoint().GetPosition());
		CallMethodEvery(METHOD_UpdatePassengers, _UPDATE_PASSENGERS_TIME);
        
        float fDelay = _READYTOSTART_DELAY + m_fStateTime - GetTime();
        if ( fDelay > 0.0f )
        {
            LogD(" fDelay "+fDelay +"\n");
            DisableCallMethod("ReadyToStart");    
            CallMethodIn("ReadyToStart", fDelay );
        }
        else
            ReadyToStart();
	}
	
	public void ReadyToStart()
	{
        DisableCallMethod("ReadyToStart");
        
        PlayAnimStart( m_fStateTime + _READYTOSTART_DELAY );
	}
    
    void VehicleStarted()
    {
        VehicleStarted( GetTime() );
    }
	
	void VehicleStarted(float fTime)
	{
        m_nState = _STATE_FLYING;
        m_fStateTime = fTime;
        
        m_bStarting = false;
        
		m_Physics.SetAccelUpDown(1000f); 
		m_Physics.SetState("IdleState");
		AttachFlySound();
		
		if (m_bPerformCurrActivity)
			EditorActivityEnded();
	}

    void PlayAnimStart(float fTimeToIgnoreInSingleGame)
    {
        PlayAnimStart();
    }
	
    void PlayAnimStart()
    {
        if (m_iForwardWheelElem != -1)
		    PlayAnim(sForwardWheel, sHideWheelsAnim, 1);
        if (m_iBackwardLeftWheelElem != -1)
    		PlayAnim(sBackwardLeftWheel, sHideWheelsAnim, 1);
        if (m_iBackwardRightWheelElem != -1)
    		PlayAnim(sBackwardRightWheel, sHideWheelsAnim, 1);
    }
    
    void PlayAnimLand(float fTimeToIgnoreInSingleGame)
    {
        PlayAnimLand();
    }
	
    void PlayAnimLand()
    {
        if (m_iForwardWheelElem != -1)
		    PlayAnim(sForwardWheel, sShowWheelsAnim, 1);
        if (m_iBackwardLeftWheelElem != -1)
		    PlayAnim(sBackwardLeftWheel, sShowWheelsAnim, 1);
        if (m_iBackwardRightWheelElem != -1)
		    PlayAnim(sBackwardRightWheel, sShowWheelsAnim, 1);
    }

	public void EditorLand(mt_Land motionType)
	{
		float fTime = GetTime();

        m_bLanding = true;
    
        m_nState = _STATE_LANDING;
        m_fStateTime = fTime;
        
		PlayAnimLand();
		m_Physics.SetAccelUpDown(motionType.fAccelUpDown); 
		m_Physics.SetMaxUpDownSpeed(motionType.fSpeedUpDown);
		Vector vDestDir = null;
		if (motionType.DestinationDirObj != null)
			vDestDir = motionType.DestinationDirObj.GetForwardVector();

		m_Physics.StartLand(GetCurrWaypoint().GetPosition(), vDestDir);
        
        bSetEnginesInLandingPos = motionType.bSetEnginesInLandingPos;
	}
	
    void VehicleLanded()
    {
        VehicleLanded( GetTime() );
    }
	
	void VehicleLanded(float fTime)
	{
        m_nState = _STATE_ONGROUND;
        m_fStateTime = fTime;
        
        m_bLanding = false;
        
		OpenDoor();
		m_Physics.SetAccelUpDown(1000f);
		m_bLanded = true;
		m_Physics.SetState("IdleState");
		DisableCallMethod("BurnEngines");
		DetachFlySound();
		
		if (m_bPerformCurrActivity)
			EditorActivityEnded();
        DisableCallMethod(METHOD_UpdatePassengers);
	}
	
	public void EditorMoveTo(mt_Fly motionType)
	{
		SetPreciseMoving(true);
		
		m_Physics.SetMovePrecision(motionType.fRadius);
        if (m_Physics.GetMaxForwardSpeed() < motionType.fSpeed)
    		m_Physics.SetMaxForwardSpeed(motionType.fSpeed);
		m_Physics.SetCurrMaxForwardSpeed(motionType.fSpeed);
		
		// sprawdzamy, czy musimy hamowac w tym punkcie, czy nie
		if ( (GetCurrWaypoint().cNext != null) && (GetCurrWaypoint().cNext.cMotion instanceof mt_Fly) )
			m_Physics.MoveTo(GetCurrWaypoint().GetPosition(), false, false);
		else
			m_Physics.MoveTo(GetCurrWaypoint().GetPosition(), false, true);
	}
    
	void OnDestinationPos()
	{
		super.OnDestinationPos();

		if (m_bPerformCurrActivity)
		{
			if (GetCurrActivity() instanceof mt_Fly)
				EditorActivityEnded();
		}
	}
	
	void CloseDoor()
	{
        if (m_bLocked)
            return;
        if (!m_bClosed && m_bChangingState)
            return;

        CallMethodIn("DoorsClosed", GetAnimLength(sCloseAnim));
        if (m_iDoorElem != -1)
		    PlayAnim(sDoor, sCloseAnim, 1);
        if (m_iWysiegnikPElem != -1)
            PlayAnim(sWysiegnikP, sCloseAnim, 1);
        if (m_iWysiegnikLElem != -1)
            PlayAnim(sWysiegnikL, sCloseAnim, 1);
        if ( (sDoorCloseSound != null) && (m_iDoorElem != -1) )
            PlaySound(sDoorCloseSound, GetElementPos(m_iDoorElem));
	}
    
    public void DoorsClosed()
    {
        m_bChangingState = false;
        m_bClosed = true;
    }
    
	void OpenDoor()
	{
        if (m_bLocked)
            return;
        if (m_bClosed && m_bChangingState)
            return;
        
        CallMethodIn("DoorsOpen", GetAnimLength(sOpenAnim));
        if (m_iDoorElem != -1)
		    PlayAnim(sDoor, sOpenAnim, 1);
        if (m_iWysiegnikPElem != -1)
            PlayAnim(sWysiegnikP, sOpenAnim, 1);
        if (m_iWysiegnikLElem != -1)
            PlayAnim(sWysiegnikL, sOpenAnim, 1);
        if ( (sDoorOpenSound != null) && (m_iDoorElem != -1) )
            PlaySound(sDoorOpenSound, GetElementPos(m_iDoorElem));
	}

    public void DoorsOpen()
    {
        m_bChangingState = false;
        m_bClosed = false;
    }
	
	public void OnFrame()
	{
		float fCurrTime = GetTime();
		
		if (m_bEngineRotating)
			SetEnginePos(fCurrTime - m_fLastUpdateTime);
		
		m_fLastUpdateTime = fCurrTime;
	}
	
	void SetEnginePos(float fTime)
	{
		if (m_Physics == null)
			return;
		
		float fNewAngle = m_fCurrEngAngle;
		
		if ( (m_bLanded) && (bSetEnginesInLandingPos) )
		{
			if (fNewAngle < _ENGINE_LAND_ANGLE)
			{
				fNewAngle += _ENGINE_ROT_SPEED * fTime;
				if (fNewAngle > _ENGINE_LAND_ANGLE)
					fNewAngle = _ENGINE_LAND_ANGLE;
			}
		}
		else
		{
			float fDestAngle = m_Physics.m_fCurrSpeed / m_Physics._MAX_FW_SPEED;
			fDestAngle = _ENGINE_STOP_ANGLE - (_ENGINE_STOP_ANGLE - _ENGINE_FLY_ANGLE) * fDestAngle;
			
			if (fNewAngle < fDestAngle)
			{
				fNewAngle += _ENGINE_ROT_SPEED * fTime;
				if (fNewAngle > fDestAngle)
					fNewAngle = fDestAngle;
			}
			else
			if (fNewAngle > fDestAngle)
			{
				fNewAngle -= _ENGINE_ROT_SPEED * fTime;
				if (fNewAngle < fDestAngle)
					fNewAngle = fDestAngle;
			}
		}
		
        SetEngineAngle( fNewAngle );    
	}
	
    void SetEngineAngle(float fAngle)
    {
        if (m_iEngine1Elem != -1)
    		RotateElementWithAnim(m_iEngine1Elem, Vector.Right, fAngle);
        if (m_iEngine2Elem != -1)
    		RotateElementWithAnim(m_iEngine2Elem, Vector.Right, fAngle);
        m_fCurrEngAngle = fAngle;
    }
	
    public void Die() 
    {
        if (bDead)
            return;
        
		SpawnBlowFX();
		PlaySound("Data/Sounds/Explosion/WalkerDieExplosion.wav", 10000f, 15000f);
        
        if (fBlowUpShakeStrength > 0)
            ShakePlayersCamera(fBlowUpShakeStrength, fBlowUpShakeDistMin, fBlowUpShakeDistMax);
        
		DisableCallMethod(METHOD_CheckCurrWaypointCnd);
		DisableCallMethod(METHOD_WaitingForAppear);

        DeactivateChildren();
        
        EnableRendering(false);
        ClearFlag(EFlags._COLLISION);
		DisableCallMethod("BurnEngines");
        
		CallMethodIn("DeleteFlying", 10f);
        
		super.Die();
    }
    
    public void DeleteFlying()
    {
        DeactivateVehicle();

        if (m_Physics != null)
		{
            m_Physics.delete();
			m_Physics = null;
		}
		
        DeactivateOnModuleAlways();       
        DeleteAttachedFXes();
    }

    void DeactivateChildren()
    {
        GameObject [] children = GetChildren();
        if (children == null)
            return;
        for (int i = 0; i < children.length; i++)
        {
            if (children[i] instanceof SecurityCannon)
            {
                SecurityCannon cannon = (SecurityCannon) children[i];
                cannon.DetachFromParent();
                cannon.Die();
            }
            else
            if (children[i] instanceof NewAI)
            {
                NewAI ai = (NewAI) children[i];
                if (ai.m_bIsActive)
                {
                    ai.Die();
                    ai.Deactivate();
                }
            }
            else
            {
                MeshObject mesh = (MeshObject) children[i];
                // zwykle obiekty odlaczamy i chowamy
                mesh.DetachFromParent();
                mesh.EnableRendering(false);
                mesh.DeactivateOnModuleAlways();
                mesh.DeleteAttachedFXes();
            }
        }
    }
    
	void SpawnBlowFX()
	{
		Vector vUp = new Vector(Vector.Up);
		vUp.Mul(400f);
        ExecuteFX(this, "FXBlowFlyingVehicle", vUp, Vector.Up);
        ExecuteParticleSystem(this, "FXBlowFlyingVehicle", vUp, Vector.Up);
	}
	
	void SpawnSmoke()
	{
		CallMethodIn("FXUpdate", fFXSmokeUpdateTime);
		m_bSmokeSpawned = true;
	}
    
    void StopSmoke()
    {
        DisableCallMethod("FXUpdate");
    }
	
    void FXUpdate()
    {
        ExecuteFX(_VEHICLE_SMOKE, GetPosition());
        if (!bDead)
            CallMethodIn("FXUpdate", fFXSmokeUpdateTime);
    }

    void BurnEngines()
    {
        for (int i = 0; i < _ENGINE_EXHAUST_NUM; i++)
        {
            if (m_EnginesExhaust[i] != -1)
                ExecuteFX(this, m_EnginesExhaust[i], sEnginesExhaust, Vector.Zero);
        }
    }

    void StartMovieBurnEngine()
    {
        DisableCallMethod("BurnEngines");
	    CallMethodEvery("BurnEngines", _UPDATE_ENGINE_TIME);
    }
    
    void StopMovieBurnEngine()
    {
        DisableCallMethod("BurnEngines");
    }
    
    /////////////////////////////////////////////////////////////////////////////
    // OBSLUGA WAYPOINTOW
    public void ServeNextWaypointActivity()
    {
		if (m_CurrActivity != null)
			m_CurrActivity.StopActivity(this);
		
        m_bPerformCurrActivity = false;
        if (m_CurrWaypoint == null)
        {
            // pierwszy waypoint
            m_CurrWaypoint = cWaypoint;
            m_bActivityInWaypoint = false;
            m_iCurrWaypointBehavior = 0;
            if (m_CurrWaypoint != null)
            {
                if (m_CurrWaypoint.cMotion == null)
                    m_CurrWaypoint.cMotion = new mt_Fly();
                m_CurrActivity = (IAIActivity) m_CurrWaypoint.cMotion;
                m_CurrCondition = m_CurrWaypoint.cEnterCondition;
            }
        }
        else
        {
            if ( ((!m_bActivityInWaypoint) && (m_CurrWaypoint.aBehaviors != null) && (m_CurrWaypoint.aBehaviors.length > 0)) ||
                 ((m_bActivityInWaypoint) && (m_iCurrWaypointBehavior > 0) &&
                  (m_iCurrWaypointBehavior < m_CurrWaypoint.aBehaviors.length)) )
            {
                // jezeli wykonalismy wlasnie motiontype i w punkcie jest behavior lub
                // wykonujemy juz behavior i chcemy wykonac nastepny
                m_bActivityInWaypoint = true;
                m_CurrActivity = (IAIActivity) m_CurrWaypoint.aBehaviors[m_iCurrWaypointBehavior];
                if (m_CurrActivity != null)
                    m_CurrCondition = m_CurrWaypoint.aBehaviors[m_iCurrWaypointBehavior].cCondition;
				if (m_iCurrWaypointBehavior == 0)
				{
					// wykonujemy akcje w waypoincie
					m_CurrWaypoint.InvokeActionChain(m_CurrWaypoint.aActions);
				}
                m_iCurrWaypointBehavior++;
            }
            else
            {
				// wykonujemy akcje w waypoincie
				m_CurrWaypoint.InvokeActionChain(m_CurrWaypoint.aActions);
				
                m_CurrWaypoint = m_CurrWaypoint.cNext;
                if (m_CurrWaypoint != null)
                {
                    m_bActivityInWaypoint = false;
                    m_iCurrWaypointBehavior = 0;
                    if (m_CurrWaypoint.cMotion == null)
                        m_CurrWaypoint.cMotion = new mt_Move();
                    m_CurrActivity = (IAIActivity) m_CurrWaypoint.cMotion;
                    m_CurrCondition = m_CurrWaypoint.cEnterCondition;
                }
                else
                {
                    m_CurrActivity = null;
                    m_CurrCondition = null;
                }
            }
        }
		
        CallMethodEvery(METHOD_CheckCurrWaypointCnd, 0.1f);
        CheckCurrWaypointCnd();
    }
    
    public void CheckCurrWaypointCnd()
    {
        if (m_CurrWaypoint == null)
        {
            DisableCallMethod(METHOD_CheckCurrWaypointCnd);
            return;
        }
		
        if (!m_bPerformCurrActivity)
        {
            if (m_CurrCondition == null ||
                m_CurrCondition.Evaluate())
            {
                m_bPerformCurrActivity = true;

		        DisableCallMethod(METHOD_WaitingForAppear);
                DisableCallMethod(METHOD_CheckCurrWaypointCnd);
				m_CurrActivity.StartActivity(this);
            }
        }
    }
    
    public void EditorActivityEnded()
    {
		ServeNextWaypointActivity();
    }
    
	public void EditorAppear(boolean bAppear)
	{
		if (bAppear)
			Appear(null);
		else
			Disappear(null);
		EditorActivityEnded();
	}
	
    public Waypoint GetCurrWaypoint()
    {
        return m_CurrWaypoint;
    } 
	
    public IAIActivity GetCurrActivity()
    {
		if (m_CurrWaypoint != null)
	        return m_CurrActivity;
		else
			return null;
    }
    
    /** Metoda detach'uje potencjalnych pasazerow od transportera jesli wyjda poza
     *  wyznaczone extenty
     */
    void UpdatePassengers()
    {
        ControlObject[] aChildren = GetChildren();
        if (aChildren != null)
        {
            GetMeshExtentsInWorld(m_vMinExt, m_vMaxExt);
            m_vMinExt.fX -= m_fHorizExtMod;
            m_vMinExt.fY -= m_fHorizExtMod;
            m_vMinExt.fZ -= m_fMinVertExtMod;
 
            m_vMaxExt.fX += m_fHorizExtMod;
            m_vMaxExt.fY += m_fHorizExtMod;
            m_vMaxExt.fZ += m_fMaxVertExtMod;
            
            for (int i=0; i<aChildren.length; i++)
            {
                ControlObject child = aChildren[i];
                if (child != null && 
                    (child.GetCollFlags() & _PASSENGERS_COLL_FLAGS) == _PASSENGERS_COLL_FLAGS)
                {
                    // jest automatycznie attachowany - sprawdz, czy nie wyszedl za daleko
                    Vector vPos = child.GetPositionVectorVolatile();
                    if (m_vMinExt.fX > vPos.fX || vPos.fX > m_vMaxExt.fX ||
                        m_vMinExt.fY > vPos.fY || vPos.fY > m_vMaxExt.fY ||
                        m_vMinExt.fZ > vPos.fZ || vPos.fZ > m_vMaxExt.fZ)
                    {
                        child.DetachFromParentAndKeepWorldPos();
                    }
                }
            }
        }
    }
	
	public void OnTakeDamage(float fDamage, float fPhSimDamage, GameObject Assassin, Vector vHitLocation, Vector vSpeed, int nMeshElementorBoneID, int nDamageType)
	{
        if (bDead)
            return;
        
		super.OnTakeDamage(fDamage, fPhSimDamage, Assassin, vHitLocation, vSpeed, nMeshElementorBoneID, nDamageType);
		
		if (!m_bSmokeSpawned)
		{
			if (fHealth <= fMaxHealth * fSmokeHealthLevel / 100f)
			{
				SpawnSmoke();
				m_bSmokeSpawned = true;
			}
		}
	}
    
    void PlayFXDustStart()
    {
        super.PlayFXDustStart();
        
        if (_VEHICLE_DUST_START != null)
            ExecuteFX(_VEHICLE_DUST_START, GetPosition());
    }
    
    void PlayFXDustLand()
    {
        super.PlayFXDustLand();
        
        if ( (_VEHICLE_DUST_LAND != null) && (GetCurrWaypoint() != null) )
            ExecuteFX(_VEHICLE_DUST_LAND, GetCurrWaypoint().GetPosition());
    }

    public void SetVehicleForMovie(boolean bEnable, boolean bPlayEngineStartStopSound)
    {
        super.SetVehicleForMovie(bEnable, bPlayEngineStartStopSound);
    	
        if (bEnable)
        {
            //CloseDoor();
            StartMovieBurnEngine();
            //PlayAnimStart();
        }
        else
        {
            //OpenDoor();
            StopMovieBurnEngine();
            StopSmoke();
            //PlayAnimLand();
        }
    }
    
    //*********************************************************
	//					SaveGame
    //*********************************************************
    public void SGLoadChunk(FileChunk cParentFC)
    {	
		FileChunk.Log("[FlyingTransporter.SGLoadChunk]\n");
		
		FileChunk cFC = GameObject.LoadChunk(cParentFC);   
		
        if (cFC.GetID() == ESGChunksChrome._CHK_FLYING_TRANSPORTER)
        {	
			super.SGLoadChunk(cFC);
			
            m_bClosed = cFC.LoadBool();
            m_bChangingState = cFC.LoadBool();
			m_bLocked = cFC.LoadBool();
            
			m_bEngineRotating = cFC.LoadBool();
		
			m_fLastUpdateTime = cFC.LoadFloat();

			m_fCurrEngAngle = cFC.LoadFloat();
			fFXSmokeUpdateTime = cFC.LoadFloat();
			m_bSmokeSpawned = cFC.LoadBool();
			fSmokeHealthLevel = cFC.LoadFloat();
				
			m_bLanded = cFC.LoadBool();
		
			m_nState = cFC.LoadInt();
        
			m_fStateTime = cFC.LoadFloat();
        
			// Zapamietane extenty
			m_vMinExt = cFC.LoadVector();
			m_vMaxExt = cFC.LoadVector();
				        
			// biezacy waypoint 
			m_CurrWaypoint =(Waypoint) cFC.LoadObjectRef();
		
			// biezaca aktywnosc
			m_CurrActivity = (IAIActivity)cFC.LoadObjectRef();
			// biezacy condition dla m_CurrActivity
			m_CurrCondition = (Condition)cFC.LoadObjectRef();
		
			// numer biezaco wykonywanego behaviora w waypoincie
			m_iCurrWaypointBehavior = cFC.LoadInt();
			// czy mozna wykonywac biezaca aktywnosc - m_CurrCondition zostal spelniony 
			m_bPerformCurrActivity = cFC.LoadBool();
			// rodzaj wykonywanej aktywnosci - motiontype czy behavior
			m_bActivityInWaypoint = cFC.LoadBool();					
            
            bSetEnginesInLandingPos = cFC.LoadBool();
            
			LoadMeshElements(cFC);		
        }
		
		cFC.delete();
    }
	    
    public void SGSaveChunk(FileChunk cFCParent)
    {
		FileChunk.Log("[FlyingTransporter.SGSaveChunk]\n");
		
        FileChunk cFC = NewChunk(ESGChunksChrome._CHK_FLYING_TRANSPORTER, cFCParent);
		
		super.SGSaveChunk(cFC);

        cFC.SaveBool(m_bClosed);
        cFC.SaveBool(m_bChangingState);
        cFC.SaveBool(m_bLocked);
        
		cFC.SaveBool(m_bEngineRotating);
		
		cFC.SaveFloat(m_fLastUpdateTime);

		cFC.SaveFloat(m_fCurrEngAngle);
		cFC.SaveFloat(fFXSmokeUpdateTime);
		cFC.SaveBool(m_bSmokeSpawned);
		cFC.SaveFloat(fSmokeHealthLevel);
			
		cFC.SaveBool(m_bLanded);
		
		cFC.SaveInt(m_nState);
        
		cFC.SaveFloat(m_fStateTime);
        
		// Zapamietane extenty
		cFC.SaveVector(m_vMinExt);
		cFC.SaveVector(m_vMaxExt);
			        
		// biezacy waypoint 
		cFC.SaveObjectRef(m_CurrWaypoint);
		
		// biezaca aktywnosc
		cFC.SaveObjectRef((ISaveGame)m_CurrActivity);
		// biezacy condition dla m_CurrActivity
		cFC.SaveObjectRef(m_CurrCondition);
		
		// numer biezaco wykonywanego behaviora w waypoincie
		cFC.SaveInt(m_iCurrWaypointBehavior);
		// czy mozna wykonywac biezaca aktywnosc - m_CurrCondition zostal spelniony 
		cFC.SaveBool(m_bPerformCurrActivity);
		// rodzaj wykonywanej aktywnosci - motiontype czy behavior
		cFC.SaveBool(m_bActivityInWaypoint);		

        cFC.SaveBool(bSetEnginesInLandingPos);
        
        SaveMeshElements(cFC);		
		
        cFC.delete();
    }	    				
	
	public void SGUpdate()
	{
		FileChunk.Log("[FlyingTransporter.SGUpdate]\n");
		
		super.SGUpdate();		
        
        if (m_bChangingState)
        {
            if (m_bClosed)
                CallMethodIn("DoorsOpen", GetAnimLength(sOpenAnim));
            else
                CallMethodIn("DoorsClosed", GetAnimLength(sCloseAnim));
        }
	}		
}
