public class PhysicsVehicle implements ISaveGame
{
    int _MAX_WHEELS = 8;						// kola - maksymalna i aktualna liczba kol
    int _DEFAULT_WHEELS = 4;					
    int  m_nWheelCnt = _DEFAULT_WHEELS;
    int  m_nWheelBaseCnt = _DEFAULT_WHEELS;
	
	float m_fFrameTime = 0.0f;					// czas biezacej ramki
	float m_fNowTime = 2.0f;					// aktualny czas
	
	final float _FALL_DOWN_TEST_COEF = 0.2f;	// modyfikator testu kolizji w dol przy spadaniu
												// wplywa na to, czy pojazd ma sie ustawiac wzgl. kol
												// jezeli wiekszy, to wyzej w powietrzu sie ustawia
	float _HALF_WHEEL_SIZE = 0;					// polowa wielkosci kola
	static final float _CORRECTION = 0.01f;		// podniesienie pojazdu po kolizji nad ziemie
	
	float _HEIGHT_OVER_GROUND = 0f;				// wysokosc "jezdzenia" pojazdu nad ziemia
	
	VehicleParams m_Params = null;				// ogolne parametry pojazdu
	float m_fFlyingTime = 0f;					// czas lotu pojazdu 
	float m_fLandingTime = 0f;					// czas ladowania pojazdu 
	boolean m_bEnableBack = true;				// uzywane do cofania po hamowaniu
	Vector m_vSlideVector = new Vector(0,0,0);	// wektor z wszelkich odbic od terenu
	
	float m_fAccelerate = 0;					// ile przyspieszamy w danej chwili
	float m_fBrake = 0;							// ile hamujemy w danej chwili
	float m_fTurnLeft = 0;						// ile obracamy sie w danej chwili
	float m_fTurnRight = 0;						// ile obracamy sie w danej chwili
	
	float m_fCurrSpeed = 0;						// predkosc biezaca pojazdu
	float m_fCurrGravity = 0;					// biezaca grawitacja
	float m_fCurrDirAngle = 0;					// biezaca wartosc skretu pojazdu
	boolean m_bIsFlyingOnFrame = false;			// czy pojazd w danej chwili odrywa sie od ziemi
	int m_Wheels[] = {-1, -1, -1, -1,
					  -1, -1, -1, -1};			// kola (numerki elementow)
	int m_WheelsBase[] = {-1, -1, -1,-1,
						  -1, -1, -1, -1};		// numery obiektow bazowych kol
	Vector vWheelTmp[] = new Vector[_MAX_WHEELS];// tablica pomocnicza ref na wektory
	float m_Springs[] = {0, 0, 0, 0,
						 0, 0, 0, 0};			// wychylenia kol
	float m_SpringsNew[] = {0, 0, 0, 0,
							0, 0, 0, 0};		// nowe wychylenia kol
	float m_fWheelRotationSpeed = 0;			// biezaca predkosc obrotu kolami
	boolean m_bFlying = false;					// czy pojazd w tej chwili leci
	boolean m_bLanding = false;					// czy pojazd w tej chwili laduje
	Vector m_vTurningSlide = new Vector(0,0,0);	// wektor poslizgu od skrecania
	float m_fCurrVehicleHAngle = 0;				// biezace odchylenie pojazdu od pionu
	float m_fCurrVehicleVAngle = 0;				// biezace odchylenie pojazdu od pionu
	Vector m_vVehicleNormal = null;				// biezaca normalna pojazdu bez przechylenia
	Vector m_vVehicleForward = null;			// wektor "w przod" pojazdu bez przechylenia
	Vector m_vVehicleRight = null;				// wektor "w prawo" pojazdu bez przechylenia
	Vector m_vVehicleTForward = null;			// wektor "w przod" pojazdu z przechyleniem
	Vector m_vVehicleTNormal = null;			// biezaca normalna pojazdu z przechyleniem
	Vector m_vVehiclePosition = null;			// pozycja pojazdu
	Vector m_vCollisionVector = null;			// wektor obliczany po kolizji
	Vector m_vMoveDir = null;					// wektor rzeczywistego przesuniecia na ramke
	boolean m_bGotCollision = false;			// czy ten pojazd zostal uderzony przez inny?
    float m_fLastAccelFXTimeStart = 0;			// ostatni czas FX'a przyspieszania
	float m_fLastAccelFXTime = 0;				// ostatni czas FX'a przyspieszania
	float m_fLastBrakeFXTime = 0;				// ostatni czas FX'a hamowania
	float m_fLastSlideFXTime = 0;				// ostatni czas FX'a slizgania
    float m_fLastWheelFXTime = 0;               // ostatni czas FX'a dymu z pod kol
	Vehicle m_Vehicle = null;					// wlasciciel fizyki
	float m_fHitTurnAngle = 0;					// kat o jaki pojazd ma sie jeszcze obrocic po trafieniu
	float m_fBrakePressTime = 0f;				// czas ostatniego nacisniecia klawisza hamulca
	float m_fLastCollisionSound = 0;			// czas ostatniego odpalenia dzwieku kolizji
	float m_fLastSlideSound = 0;			    // czas ostatniego odpalenia dzwieku poslizgu
    float m_fLastAccelSound = 0;			    // czas ostatniego odpalenia dzwieku przyspieszania
	float m_fMoveSpeed	= 0.0f;					// aktualne predkosc pojazdu liczona z dlugosci m_vMovedir
    float m_fRealSpeed  = 0f;                   // rzeczywista predkosc pojazdu, po uwzglednieniu kolizji
	float m_fRealAccel	= 0f;					// rzeczywiste przyspieszenie pojazdu, po uwzglednieniu kolizji
	
	CollInfo m_collInfo = new CollInfo();
	
	/** czy w tej mamy detektowac kolizje, czy juz obsluzylismy i dajemy sobie spokoj */
	boolean m_bCheckCollision = false;	
    
    /** Nazwa FX odpalanego przy jezdzie */
    String sWheelSmokeFX = "Smoke";
    
    /** Czy ma byc odpalany kurz spod kol */
    boolean bWheelSmokeFX = false;
    
    /** Czy dym ma isc tylko z pod tylnich kol */
    boolean bWheelSmokeRearOnly = false;
        
    /** Przesuniecie dymu w gore */
    float fWheelSmokeShiftY = 0.0f; 
    
    /** Minimalny kat przy ktorym odpalany jest FX i dzwiek poslizgu */
    float m_fMinDirAngleSlide = 60.0f;
	
	/** czy np. przy skrecie w lewo pojazd ma sie przechylac w lewo (jak dla motoru) */
	boolean m_bMotorLikeAlign = false;
	
	float m_fTurnInPathMove = 0f;

    // czy ponowic movebyellipsoid z powodu spotkania z bulletem (np. rakieta)
    boolean m_bRecalculateMove = false;

    float m_fMovieWheelsAngleMult = 1f;

    boolean m_bFlyOverWater = false;

    float m_fLastYPos = 0f; // pozycja w Y jeepa sluzaca do obliczania damage

    boolean m_bNetPawnCollision = false;
    
	float m_fAngleSpeed = 0f;
	
	final void SetVehicleParams(VehicleParams Params)
	{
		m_Params = Params;
	}
	
    PhysicsVehicle()
    {
        //SG
    }
    
	PhysicsVehicle(Vehicle vehicle)
	{
		m_Vehicle = vehicle;
		
		VehicleParams params = new VehicleParams();
		SetVehicleParams(params);
		
		m_fCurrGravity = 0;
		
		m_vCollisionVector	= new Vector(0, 0, 0);
		m_vMoveDir			= new Vector(m_Vehicle.GetForwardVector());
	}
    
    void Init()
    {
        InitWheelsElements();
        
		// obliczamy promien kola
        if (m_Wheels[0] != -1)
        {
		    Vector vTemp = m_Vehicle.GetElementPos(m_Wheels[0]);
        
    		vTemp.Sub(m_Vehicle.GetPosition());
		    _HALF_WHEEL_SIZE = vTemp.fY;
        }
        
		InitParamsFromVehicle();
        		
		for (int i = 0; i < _MAX_WHEELS; i++)
			vWheelTmp[i] = new Vector(0, 0, 0);
        
		m_Vehicle.SetMaxClimbAngle(90f);
    }

    public void InitWheelsElements()
    {
		m_Wheels[0] = m_Vehicle.GetElementID("kolo_PP");
		m_Wheels[1] = m_Vehicle.GetElementID("kolo_LP");
		m_Wheels[2] = m_Vehicle.GetElementID("kolo_LT");
        m_Wheels[3] = m_Vehicle.GetElementID("kolo_PT");
        				
        m_WheelsBase[0] = m_Vehicle.GetElementID("kolobase_PP");
		m_WheelsBase[1] = m_Vehicle.GetElementID("kolobase_LP");
		m_WheelsBase[2] = m_Vehicle.GetElementID("kolobase_LT");
		m_WheelsBase[3] = m_Vehicle.GetElementID("kolobase_PT");
    }
    
    void InitParamsFromVehicle()
    {
        m_vVehicleNormal	= new Vector(m_Vehicle.GetUpVector());
		m_vVehicleForward	= m_Vehicle.GetForwardVector();
		m_vVehicleRight		= m_Vehicle.GetRightVector();
		m_vVehicleTForward	= new Vector(m_vVehicleForward);
		m_vVehicleTNormal	= new Vector(m_vVehicleNormal);
		m_vVehiclePosition	= m_Vehicle.GetPosition();
        m_fLastYPos         = m_vVehiclePosition.fY;
    }
    
	void Simulate(byte iAccel, float fTurn, float fDeltaTime)
	{
		m_fFrameTime = fDeltaTime;
		m_fNowTime += m_fFrameTime;
        
		UpdateMovementParams(iAccel, fTurn);
		UpdateVehiclePhysics();
		
        if ( (bWheelSmokeFX) && (Math.abs(m_fCurrSpeed) > 10) )
            WheelSmokeFX();
	}
	
    /** Metoda do uproszczonej symulacji, podajemy juz wyliczone (w inny sposob)
     * predkosc i docelowy kierunek, a ta metoda tylko ustawia odpowiednio kola
     * i odpala FXy i dzwieki */
    void MovieSimulate(float fSpeed, float fAngleSpeed, float fDeltaTime)
    {
        float fSpeedDiff = fSpeed - m_fCurrSpeed;
        
        // to musimy dostac z zewnatrz
        m_fCurrSpeed = fSpeed;
        m_fFrameTime = fDeltaTime;
        m_fNowTime += m_fFrameTime;
        
        boolean bSlide = false;
        boolean bAccel = false;
        boolean bBrake = false;
        boolean bFX = false;

        if (fSpeedDiff / fDeltaTime > 600f)
            bAccel = true;
        
        if (fSpeedDiff / fDeltaTime < -600f)
            bBrake = true;

        m_fCurrDirAngle = fAngleSpeed;
        if ( m_fCurrDirAngle > m_Params._MAX_TURN_ANGLE)
            m_fCurrDirAngle = m_Params._MAX_TURN_ANGLE;
        if ( m_fCurrDirAngle < -m_Params._MAX_TURN_ANGLE)
            m_fCurrDirAngle = -m_Params._MAX_TURN_ANGLE;

        if (m_fCurrDirAngle > 0f)
            m_fTurnRight = m_fCurrDirAngle / m_Params._MAX_TURN_ANGLE;
        else
            m_fTurnLeft = -m_fCurrDirAngle / m_Params._MAX_TURN_ANGLE;

        float fCoeff = Math.abs((m_Params._MAX_TURN_ANGLE - m_fCurrDirAngle) * fSpeed) / m_Params.GetMaxSpeed();

        if (fCoeff > 60f)
            bSlide = true;
        
        Vector vProduct = CalculateNewNormal();
				
		if (vProduct.Len2() != 0f)
		{
			vProduct.Mul(m_Params._GROUND_ALIGN_INERTIA * m_fFrameTime);
			m_vVehicleNormal.Mul( m_Params._NORMAL_INTERPOLATION_COEFF );
			vProduct.Add(m_vVehicleNormal);
			vProduct.Normalize();
			m_vVehicleNormal.Set(vProduct);	
            
            m_vVehicleTNormal.Set( m_vVehicleNormal );
		}

        if (bSlide)
        {
            TurnSlideSmokeFX();
            PlaySoundSlide();
            bFX = true;
        }
        if (bAccel)
        {
            AccelerateSmokeFX();
            PlaySoundAccel();
            bFX = true;
        }
		if (bBrake)
        {
            BrakeSmokeFX();
            PlaySoundBrake();
            bFX = true;
        }
        
        if ((!bFX) && (bWheelSmokeFX) && (Math.abs(m_fCurrSpeed) > 10))
            WheelSmokeFX();
            
        // zupdateujmy dzwieki
		UpdateSounds();
        
        // teraz zapdatujemy pozycje kol
        
        m_fCurrDirAngle *= m_fMovieWheelsAngleMult;
        UpdateSpringsAndWheels();
    }
    
    boolean m_bNetSimulate = false;
    void NetSimulate( float fDeltaTime, boolean bServer )
    {
        m_bNetSimulate  = true; 
        m_fFrameTime    = fDeltaTime;
        m_fNowTime     += m_fFrameTime;
                        
        boolean bSlide = ( m_fCurrDirAngle > m_fMinDirAngleSlide || m_fCurrDirAngle < -m_fMinDirAngleSlide )&&
                         ( (m_fCurrSpeed < m_Params._MIN_SPEED/2.0f)||(m_fCurrSpeed > m_Params.GetMaxSpeed()/2.0f) );
        
        // policzyc czy przyspieszamy lub zwalniamy 
        boolean bAccel = false;//(m_fLastAccelFXTimeStart > m_fNowTime - 1.0f);
        boolean bBrake = false;
                
        Vector vProduct = CalculateNewNormal();
				
		if (vProduct.Len2() != 0f)
		{
			vProduct.Mul(m_Params._GROUND_ALIGN_INERTIA * m_fFrameTime);
			m_vVehicleNormal.Mul( m_Params._NORMAL_INTERPOLATION_COEFF );
			vProduct.Add(m_vVehicleNormal);
			vProduct.Normalize();
			m_vVehicleNormal.Set(vProduct);	
            
            m_vVehicleTNormal.Set( m_vVehicleNormal );
		}

        boolean bFX = false;
        if ( bSlide )
		{
			TurnSlideSmokeFX();
            bFX = true;
            
			PlaySoundSlide();
		}
		
        if ( bAccel )
        {
            AccelerateSmokeFX();
            bFX = true;
            
            PlaySoundAccel();
        }
				
		if ( bBrake )
        {
			BrakeSmokeFX();
            bFX = true;
            
            PlaySoundBrake();
        }

        if ((!bFX) && (bWheelSmokeFX) && (Math.abs(m_fCurrSpeed) > 10))
            WheelSmokeFX();
            
        // zupdateujmy dzwieki
		UpdateSounds();
        
        // teraz zapdatujemy pozycje kol
        UpdateSpringsAndWheels();
        
        //i ustawmy parametry fizyki wg danych z pojazdu
        InitParamsFromVehicle();
        
        m_bNetSimulate  = false; 
    }
	
	/** interpretacja komunikatow od inputow */
	void UpdateMovementParams(byte iAccel, float fTurn)
	{
		if (iAccel > 0)
		{
			m_fAccelerate = (float) iAccel;
			m_fBrake	  = 0.0f;
		}
		else
		if (iAccel < 0)
		{
			m_fAccelerate	= 0.0f;
			m_fBrake		= - (float) iAccel;
		}
		else
		{
			m_fAccelerate	= 0.0f;
			m_fBrake		= 0.0f;
		}
		
		if (fTurn > 0)
		{
			m_fTurnRight	= fTurn;
			m_fTurnLeft		= 0.0f;
		}
		else
		if ( fTurn < 0 )
		{
			m_fTurnRight	= 0.0f;
			m_fTurnLeft		= - fTurn;
		}
		else
		{
			m_fTurnRight	= 0.0f;
			m_fTurnLeft		= 0.0f;
		}
		
		boolean bSpeedChange = false;
		float fTemp;
		
		// jezeli przyspieszamy
		if (m_fAccelerate > 0)
		{
			if ( m_fCurrSpeed < m_Params._MIN_SPEED / 2.0f )
				PlaySoundBrake();
				
			bSpeedChange = true;
			
			if ( (m_fFlyingTime < m_Params._REAL_FLY_TIME_CONTROL) && (m_bEnableBack) )
			{
				if (m_fCurrSpeed < 0)
				{
					m_fCurrSpeed += m_Params._BRAKE_COEF * m_fFrameTime;
					if (m_fCurrSpeed > 0)
					{
						m_fCurrSpeed = 0f;
						EnableBackLater();
					}
				}
				else
				{
					if (m_fCurrSpeed < m_fAccelerate * m_Params._CURR_MAX_SPEED)
					{
						fTemp = m_fAccelerate * m_Params._CURR_MAX_SPEED;
						m_fCurrSpeed += m_Params._ACCELERATION_COEF * m_fFrameTime;
						if (m_fCurrSpeed > fTemp)
							m_fCurrSpeed = fTemp;
					}
					else
					if (m_fCurrSpeed > m_fAccelerate * m_Params._CURR_MAX_SPEED)
					{
						m_fCurrSpeed -= m_Params._ACCELERATION_COEF * m_fFrameTime;
						if (m_fCurrSpeed < m_fAccelerate * m_Params._CURR_MAX_SPEED)
							m_fCurrSpeed = m_fAccelerate * m_Params._CURR_MAX_SPEED;
					}
					m_Vehicle.fFuel -= m_Vehicle.fFuelConsumption * m_fFrameTime;
				}
			}
			else
			{
				if (m_fCurrSpeed < 0)
				{
					m_fCurrSpeed += m_Params._FLY_SLOW_COEF * m_fFrameTime;
					if (m_fCurrSpeed > 0)
						m_fCurrSpeed = 0;
				}
				else
				{
					m_fCurrSpeed -= m_Params._FLY_SLOW_COEF * m_fFrameTime;
					if (m_fCurrSpeed < 0)
						m_fCurrSpeed = 0;
				}
			}
		}
		
		// jezeli hamujemy
		if ((m_fBrake > 0) && (m_fFlyingTime < m_Params._REAL_FLY_TIME_CONTROL) && (m_bEnableBack))
		{
			bSpeedChange = true;
			
			if (!m_Vehicle.m_bIsPatrolling)
			{
				if ( m_fCurrSpeed > m_Params.GetMaxSpeed() / 2.0f )
					PlaySoundBrake();
			}
			
			if (m_fCurrSpeed > 0)
			{
				m_fCurrSpeed -= m_Params._BRAKE_COEF * m_fFrameTime;
				if (m_fCurrSpeed < 0)
				{
					m_fCurrSpeed = 0f;
					EnableBackLater();
				}
			}
			else
			{
				if (m_fCurrSpeed > m_fBrake * m_Params._MIN_SPEED)
				{
					fTemp = m_fBrake * m_Params._MIN_SPEED;
					m_fCurrSpeed -= m_Params._ACCELERATION_COEF * m_fFrameTime;
					if (m_fCurrSpeed < fTemp)
						m_fCurrSpeed = fTemp;
				}
				m_Vehicle.fFuel -= m_Vehicle.fFuelConsumption * m_fFrameTime;
			}
		}
		
		// jezeli ani nie przyspieszamy ani nie hamujemy
		if (!bSpeedChange)
		{
			if (m_fCurrSpeed < 0)
			{
				m_fCurrSpeed += m_Params._SLOW_COEF * m_fFrameTime;
				if (m_fCurrSpeed > 0)
					m_fCurrSpeed = 0;
			}
			else
			{
				m_fCurrSpeed -= m_Params._SLOW_COEF * m_fFrameTime;
				if (m_fCurrSpeed < 0)
					m_fCurrSpeed = 0;
			}
		}

		if (m_Vehicle.m_bIsPatrolling)
		{
			// o tyle mozemy sie maksymalnie obrocic
			m_fTurnInPathMove = m_Params._TURNING_SPEED * m_fFrameTime;
			
			// w m_fTurnLeft i m_fTurnRight dostajemy katy, jakie sa od wektora biezacego do docelowego
			if (m_fTurnLeft > 0)
			{
				if (m_fTurnInPathMove > m_fTurnLeft * m_Params._MAX_TURN_ANGLE)
					m_fTurnInPathMove = m_fTurnLeft * m_Params._MAX_TURN_ANGLE; // nie chcemy skrecic wiecej niz potrzeba
				
				m_fTurnInPathMove *= -1f;
				
				m_fCurrDirAngle = m_fTurnInPathMove / m_fFrameTime; // szybkosc obrotu na sekunde
				if (m_fCurrDirAngle < - m_Params._MAX_TURN_ANGLE)
					m_fCurrDirAngle = - m_Params._MAX_TURN_ANGLE;
			}

			if (m_fTurnRight > 0)
			{
				if (m_fTurnInPathMove > m_fTurnRight * m_Params._MAX_TURN_ANGLE)
					m_fTurnInPathMove = m_fTurnRight * m_Params._MAX_TURN_ANGLE;
				
				m_fCurrDirAngle = m_fTurnInPathMove / m_fFrameTime;
				if (m_fCurrDirAngle > m_Params._MAX_TURN_ANGLE)
					m_fCurrDirAngle = m_Params._MAX_TURN_ANGLE;
			}
		}
		else
		{
			if (m_fTurnLeft > 0)
			{
				fTemp = m_fTurnLeft * m_Params._MAX_TURN_ANGLE;
				m_fCurrDirAngle -= m_Params._TURNING_SPEED * m_fFrameTime;
				if (m_fCurrDirAngle < - fTemp)
					m_fCurrDirAngle = - fTemp;
			}

			if (m_fTurnRight > 0)
			{
				fTemp = m_fTurnRight * m_Params._MAX_TURN_ANGLE;
				m_fCurrDirAngle += m_Params._TURNING_SPEED * m_fFrameTime;
				if (m_fCurrDirAngle > fTemp)
					m_fCurrDirAngle = fTemp;
			}
		}
	}
	
	void EnableBackLater()
	{
        if (m_bPhysicsCalcOnly)
            return;
        
		m_bEnableBack = false;
		m_Vehicle.EnableBackLater(m_Params._TIME_TO_GOING_BACK);
	}
	
	void EnableBack()
	{
		m_bEnableBack = true;
	}
	
	void UpdateVehiclePhysics()
	{
		m_bIsFlyingOnFrame = false;
		
		if (m_fCurrDirAngle != 0)
			DecreaseTurning();
		
		if (m_vTurningSlide.Len2() > 0)
		{
			DecreaseTurnSlide();

			if (m_vTurningSlide.Len() > m_Params._SLIDE_SMOKE_COEF)
			{
				TurnSlideSmokeFX();
				PlaySoundSlide();
			}
		}
		if ( (m_fCurrDirAngle != 0) && (m_fCurrSpeed != 0) && (!m_bFlying) )
			AddSlideFromTurning();
		
		// jezeli pojazd skreca
		if ((m_fCurrDirAngle != 0) && (m_fCurrSpeed != 0) &&
			(m_fFlyingTime < m_Params._REAL_FLY_TIME_CONTROL))
			TurnVehicle();
		else
			m_fAngleSpeed = 0f;
		
		if (m_vSlideVector.Len2() > 0)
		{
			// zmniejszamy predkosc pojazdu
			SlowDown();
			
			// wygaszamy wektor slizgania sie
			DecreaseSlide();
		}

		if (m_vCollisionVector.Len2() > 0)
			SupressCollVector();

		MoveVehicle();
		
		if ( (m_fAccelerate > 0) && (!m_bFlying) && (m_fCurrSpeed > 0) &&
			 (m_fCurrSpeed < m_Params.GetMaxSpeed() / 20f) )
			AccelerateSmokeFX();

		if ( (m_fAccelerate > 0) && (!m_bFlying) && (m_fCurrSpeed < 0) )
			BrakeSmokeFX();
		
		if ( (m_fBrake > 0) && (!m_bFlying) && (m_fCurrSpeed > 0) )
			BrakeSmokeFX();
			
		UpdateSounds();
		
		if ( (!m_bFlying) && (!m_bIsFlyingOnFrame) )
		{
			// obliczamy przechyl V pojazdu
			if (m_fAccelerate > 0)
				AccelVAngle(true);
					
			if (m_fBrake > 0)
				AccelVAngle(false);
					
			if ((m_fAccelerate == 0) && (m_fBrake == 0))
				DecreaseVehicleVAngle();
		}
		
		if (!m_bFlying)
		{
			// obliczamy przechyl H pojazdu
			if (m_fTurnLeft > 0)
				TurnRightHAngle(false);
			else
			if (m_fTurnRight > 0)
				TurnRightHAngle(true);
			else
				DecreaseVehicleHAngle();
		}
		else
			DecreaseVehicleHAngle();

		if (m_bFlying)
		{
			// spadamy jeszcze przez m_fLandingTime
			FallDown();
			DecreaseVehicleVAngle();
		}
		else
		{
			if (!m_bIsFlyingOnFrame)
			{
				// pojazd dotyka ziemi
				m_fFlyingTime = 0f;
                
				Vector vProduct = null;
				if (m_vMoveDir.Len() > 1f)
					vProduct = CalculateNewNormal();
				else
					vProduct = new Vector(m_vVehicleNormal);
					
				if (vProduct.Len2() == 0f)
				{
					// kola nie znalazly kolizji, zmieniamy tylko pozycje, nie orientacje
					SetVehiclePosAndOrientation();
					return;
				}
				
				vProduct.Mul(m_Params._GROUND_ALIGN_INERTIA * m_fFrameTime);
				m_vVehicleNormal.Mul( m_Params._NORMAL_INTERPOLATION_COEFF );
				vProduct.Add(m_vVehicleNormal);
				vProduct.Normalize();
				m_vVehicleNormal.Set(vProduct);
            }
			else
			{
				// chwilowo lecimy w powietrzu
				AlignToUp();
				m_fFlyingTime += m_fFrameTime;
				// czy lecimy juz troche dluzej?
				if (m_fFlyingTime > m_Params._REAL_FLY_TIME)
					m_bFlying = true;
			}
		}
	    SetVehiclePosAndOrientation();
	}
    
    void TakeDamageFromFall()
    {
        if (!m_bPhysicsCalcOnly)
        {
            if ( (m_fCurrGravity <= -3000f) && (m_fLastYPos - m_vVehiclePosition.fY > m_Params._FALL_DAMAGE_HEIGHT_MIN) )
            {
                // zadajemy damage vehicle od uderzenia w ziemie
                float fDamage = (m_fLastYPos - m_vVehiclePosition.fY - m_Params._FALL_DAMAGE_HEIGHT_MIN);
                fDamage *= m_Params._FALL_DAMAGE * m_Params._FALL_DAMAGE / 10000f;
                
                if ( m_Vehicle.m_bLocalPlayerDriver && m_Vehicle.Role < ERole._AUTHORITY )
                    m_Vehicle.MsgSendServerVehicleCollision(fDamage);
                else
                    if (m_Vehicle.m_bLocalPlayerDriver && m_Vehicle.Role == ERole._AUTHORITY)
                        m_Vehicle.TakeDamage( fDamage, EnumDamageType._BULLET );
                
                m_fLastYPos = m_vVehiclePosition.fY;
            }
        }
    }
    
    Vector vMoveDir = new Vector();
    Vector vTemp1 = new Vector();
    Vector vTemp2 = new Vector();

	void MoveVehicle()
	{
        float fWaterLevel = m_Vehicle.GetModule().GetWaterLevel();
        
		// wektor o jaki probujemy si przesuna
		m_vMoveDir.Set(m_vVehicleForward);
		m_vMoveDir.Mul(m_fFrameTime * m_fCurrSpeed);
							
		// uwzgledniamy wektor slizgania sie wskutek odbicia przy przesunieciu
		Vector vTemp = new Vector(m_vSlideVector);
		vTemp.Mul(m_fFrameTime);
		m_vMoveDir.Add(vTemp);

		// uwzgledniamy wektor slizgania sie na zakretach
		vTemp.Set(m_vTurningSlide);
		vTemp.Mul(m_fFrameTime);
		m_vMoveDir.Add(vTemp);
		
		// uwzgledniamy wektor poslizgu
		vTemp.Set(m_vCollisionVector);
		vTemp.Mul(m_fFrameTime);
		m_vMoveDir.Add(vTemp);
		
		// przesuwamy pojazd
		Vector vStart = new Vector(m_vVehicleNormal);
		if (java.lang.Math.abs(m_fCurrSpeed) > 3f)
            vStart.Set(m_vVehicleNormal);
        else
            vStart.Set(Vector.Up);
		vStart.Mul(m_Params._SUSPENSION_HEIGHT);
		vStart.Add(m_vVehiclePosition);
		
		// w vEnd bedziemy mieli nastepna pozycje
		Vector vEnd = new Vector(vStart);
		vEnd.Add(m_vMoveDir);
		m_fMoveSpeed = m_vMoveDir.Len() / m_fFrameTime;

        if (m_bFlyOverWater)
        {
            if (vEnd.fY < fWaterLevel)
                vEnd.fY = fWaterLevel;
        }
        
		// szukamy kolizji z bardziej pionowa sciana
		TestTrack(vStart, vEnd);
		vEnd.Set(m_collInfo.vEnd);
		if (m_collInfo.coll != null)
		{
			// sprawdzamy, czy sciana nie jest za stroma
			if (Vector.Up.Dot(m_collInfo.coll.vNormal) < m_Params._MAX_SLOPE_ANGLE)
				SetBounceVector(m_collInfo.coll.vNormal);
			else
				vEnd.fY += _CORRECTION; // odsuwamy sie od ziemi
			vEnd.fY += _HEIGHT_OVER_GROUND;

			// grawitacje ustawiamy na mala, bo uderzylismy tor
			m_fCurrGravity = 0;
            TakeDamageFromFall();
            if (!m_bPhysicsCalcOnly)
                m_fLastYPos = m_vVehiclePosition.fY;
		}
		else
		{
			// obliczamy wektor biezacej grawitacji
			Vector vCurrGravity = new Vector();
			if (java.lang.Math.abs(m_fCurrSpeed) > 3f)
				vCurrGravity.Set(m_vVehicleNormal);
			else
				vCurrGravity.Set(Vector.Up);
			m_fCurrGravity += m_Params._GRAVITY_ACCEL * m_fFrameTime;
			vCurrGravity.Mul(m_fFrameTime * m_fCurrGravity);
			
			vStart.Set(vEnd);
			
			Vector vVehicleDown = new Vector();
			if (java.lang.Math.abs(m_fCurrSpeed) > 3f)
    			vVehicleDown.Set(m_vVehicleNormal);
			else
    			vVehicleDown.Set(Vector.Up);
			vVehicleDown.Negate();
			vVehicleDown.Mul(m_Params._SUSPENSION_HEIGHT + _HEIGHT_OVER_GROUND);
			vEnd.Add(vVehicleDown);
			vEnd.Add(vCurrGravity);

            boolean bIsOverWater = false;
            if (m_bFlyOverWater)
            {
                if (vEnd.fY < fWaterLevel)
                {
                    vEnd.fY = fWaterLevel;
                    bIsOverWater = true;
                }
            }
            
			TestTrack(vStart, vEnd);
			vEnd.Set(m_collInfo.vEnd);
			if (m_collInfo.coll != null)
			{
				if (Vector.Up.Dot(m_collInfo.coll.vNormal) < m_Params._MAX_SLOPE_ANGLE)
					SetBounceVector(m_collInfo.coll.vNormal);
				vEnd.fY += _CORRECTION + _HEIGHT_OVER_GROUND;
                TakeDamageFromFall();
				m_fCurrGravity = 0;
                if (!m_bPhysicsCalcOnly)
                    m_fLastYPos = m_vVehiclePosition.fY;
			}
			else
			{
                if (bIsOverWater)
                    m_fCurrGravity = 0;
                else
				    m_bIsFlyingOnFrame = true;
                
				vEnd.fY += _HEIGHT_OVER_GROUND;
			}
		}
		
		// sprawdzamy, czy mozemy sie przesunac (kolizje na elipsoidach)
		m_vMoveDir.Set(vEnd);
		
		m_vMoveDir.Sub(m_vVehiclePosition);
        
        if (vEnd.fY + m_Params._WATER_LEVEL_MARGIN < fWaterLevel)
        {
            m_vMoveDir.Mul(0.4f);
            TakeWaterDamage(m_fFrameTime);
        }
            
		float fMoveLen = m_vMoveDir.Len();
		m_fMoveSpeed = fMoveLen / m_fFrameTime;
		m_bCheckCollision = true;
		if (m_vMoveDir.Len2() > 0f)
		{
			vMoveDir.Set(m_vMoveDir);
    	    boolean bCouldMoveAfterColl = m_Vehicle.MoveByEllipsoid(m_vMoveDir);

			Vector vPos = new Vector(m_vVehiclePosition);
			vPos.Add(m_vMoveDir);
			if (!CanMoveToPosition(vPos))
			{
				m_vMoveDir.fX = 0;				
				m_vMoveDir.fZ = 0;
			}
			
            if (m_bRecalculateMove)
            {
                m_vMoveDir.Set(vMoveDir);
                bCouldMoveAfterColl = m_Vehicle.MoveByEllipsoid( m_vMoveDir );
                m_bRecalculateMove = false;
				
				vPos = new Vector(m_vVehiclePosition);
				vPos.Add(m_vMoveDir);
				if (!CanMoveToPosition(vPos))
				{
					m_vMoveDir.fX = 0;				
					m_vMoveDir.fZ = 0;
				}
            }
            
            if (m_bNetPawnCollision)
            {
                m_vMoveDir.Set(vMoveDir);
                bCouldMoveAfterColl = true;
                m_bNetPawnCollision = false;
            }
            /** komentarz: jezeli bCouldMoveAfterColl zwroci true, a wektor vMoveDir zostanie przyciety do zera (X i Z),
             * oznaczac to bedzie, ze co prawda obiekt mogl sie poruszac (movebyellipsoid go puscilo), ale zatrzymala
             * go mapa przechodnosci */
			m_vVehiclePosition.Add( m_vMoveDir );

			float fOldRealSpeed = m_fRealSpeed;
			
            m_fRealSpeed = m_vMoveDir.Len() / m_fFrameTime;
			m_fRealAccel = (m_fRealSpeed - fOldRealSpeed) / m_fFrameTime;
			
			if (m_bCheckCollision)
			{
                // jezeli mamy jakas predkosc, ale z przesuniecia wyszlo, ze stoimy, to byla kolizja
				if (Math.abs(m_fCurrSpeed) > 0f && m_vMoveDir.Len2() == 0f)
                {
					HandleDetectedCollision(vMoveDir, bCouldMoveAfterColl);
                }
                else
                // jezeli sie przesunelismy, ale zesliznelismy sie na ellipsoidzie, to byla kolizja
                if (m_vMoveDir.Len2() > 0f)
                {
                    vTemp1.Set(vMoveDir); vTemp1.fY = 0f; vTemp1.Normalize();
                    vTemp2.Set(m_vMoveDir); vTemp2.fY = 0f; vTemp2.Normalize();
                    if ( (Math.abs(m_fCurrSpeed) > 300f) && (vTemp1.Dot(vTemp2) < 0.7f) )
				    	HandleDetectedCollision(vMoveDir, bCouldMoveAfterColl);
                }
			}
		}
        else
        {
            m_fRealSpeed = 0f;
			m_fRealAccel = 0f;
        }
        
        if (m_Vehicle.m_iStampSize > 0)
        {
            if (m_bPhysicsCalcOnly)
                return;
            
            if (m_vMoveDir.Len2() == 0f || m_fCurrSpeed == 0)
            {
                if (!m_Vehicle.IsUpdatingPathMap())
                    m_Vehicle.UpdatePathMap(true, m_Vehicle.m_iStampSize, true);
            }
            else
            {
                if (m_Vehicle.IsUpdatingPathMap())
                    m_Vehicle.UpdatePathMap(false, m_Vehicle.m_iStampSize, true);
            }
        }
	}

	float _TERRAIN_TEST_LEN = 100f;
	
	boolean CanMoveToPosition(Vector vPos)
	{
        if ( (m_Vehicle.GetTerrainType(vPos.fX + _TERRAIN_TEST_LEN, vPos.fZ) == 0) ||
			 (m_Vehicle.GetTerrainType(vPos.fX - _TERRAIN_TEST_LEN, vPos.fZ) == 0) ||
			 (m_Vehicle.GetTerrainType(vPos.fX, vPos.fZ + _TERRAIN_TEST_LEN) == 0) ||
			 (m_Vehicle.GetTerrainType(vPos.fX, vPos.fZ - _TERRAIN_TEST_LEN) == 0) )
            return false;
		return true;
	}
	
	void TestTrack(Vector vStart, Vector vEnd)
	{
        float fTerrainHeight = m_Vehicle.TerrainHeight(vStart.fX, vStart.fZ);
        
		if ( vStart.fY <= fTerrainHeight )
		{
			GameObject.LogLine( "Autko juz jest pod ziemia!!!! Wyciagamy!!! ");
			vStart.fY = fTerrainHeight + 20.0f;
		}
        
    	TestTrackNoCheckTerrainHeight(vStart, vEnd);
	}
	
	void TestTrackNoCheckTerrainHeight(Vector vStart, Vector vEnd)
	{
        if (vStart.fX == vEnd.fX && vStart.fZ == vEnd.fZ)
        {
            // to przez buga w trace'ach (pionowe trace'y)
            Vector vNormal = new Vector();
            float fTerrainHeight = m_Vehicle.TerrainHeightNormal(vStart.fX, vStart.fZ, vNormal);
            if (vStart.fY >= fTerrainHeight && vEnd.fY <= fTerrainHeight)
            {
		        m_collInfo.coll = new Collision();
                m_collInfo.coll.vNormal = vNormal;
                m_collInfo.coll.fDistance = vStart.fY - fTerrainHeight;
                m_collInfo.coll.Obstacle = null;
                m_collInfo.coll.ObstacleElement = -1;
                m_collInfo.coll.nMaterial = 0;
                m_collInfo.coll.nMaterialFlags = 0;
                
		        m_collInfo.vEnd = new Vector(vEnd);
                m_collInfo.vEnd.fY = fTerrainHeight;
            }
            else
            {
                m_collInfo.coll = null;
                m_collInfo.vEnd = new Vector(vEnd);
            }
        }
        else
        {
		    m_collInfo.coll = m_Vehicle.TraceTerrain(vStart, vEnd);
		    m_collInfo.vEnd = new Vector(vEnd);
        }
        
		Collision colObj = m_Vehicle.TraceObjectsExclude(vStart, vEnd, m_Vehicle); // test na obiekty
		if (colObj != null)
		{
			m_collInfo.coll = colObj;
			m_collInfo.vEnd.Set(vEnd);
		}
	}
	
	void TurnVehicle()
	{
		if (m_Vehicle.m_bIsPatrolling)
		{
			Vector vUp = new Vector(m_vVehicleRight);
			if (m_fCurrSpeed < 0) 
				vUp.Negate(); // jezeli jedzie do tylu, to skreca przeciwnie
			vUp = m_vVehicleForward.Cross(vUp);
			m_vVehicleForward = m_Vehicle.RotateVector(m_vVehicleForward,
											 -m_fCurrDirAngle * m_fFrameTime,
											 vUp);
			m_fAngleSpeed = -m_fCurrDirAngle;
			if (m_fCurrSpeed < 0)
				m_fAngleSpeed *= -1f;
		}
		else
		{
			float fSpeedCoef = GetSpeedToTurnCoeff(m_fCurrSpeed);

			Vector vUp = new Vector(m_vVehicleRight);
			if (m_fCurrSpeed < 0) 
				vUp.Negate(); // jezeli jedzie do tylu, to skreca przeciwnie
			vUp = m_vVehicleForward.Cross(vUp);
			m_vVehicleForward = m_Vehicle.RotateVector(m_vVehicleForward,
											 -m_fCurrDirAngle * m_fFrameTime * fSpeedCoef * m_Params._COEFF_TURN,
											 vUp);
			m_fAngleSpeed = -m_fCurrDirAngle * fSpeedCoef * m_Params._COEFF_TURN;
			if (m_fCurrSpeed < 0)
				m_fAngleSpeed *= -1f;
		}
	}
	
	float GetSpeedToTurnCoeff(float fSpeed)
	{
		// by MacKi
		float fSpeedCoef = fSpeed;
		if (fSpeedCoef >= 0)
			fSpeedCoef /= m_Params.GetMaxSpeed();
		else
			fSpeedCoef /= -m_Params.GetMaxSpeed();
		
		// by MZM - lepiej, jak wspolczynnik bedzie nieliniowy (tutaj kwadrat)
		if (fSpeedCoef < 0)
			fSpeedCoef = 0;
		if (fSpeedCoef > 1)
			fSpeedCoef = 1;
		fSpeedCoef *= 1.5f;
		float fTemp = -fSpeedCoef;
		fSpeedCoef -= 2f;
		fSpeedCoef *= fTemp;
		// MZM end
		return fSpeedCoef;
	}
		
	void AddSlideFromTurning()
	{
		// poslizg przy skrecie
		Vector vTemp = new Vector(m_vVehicleRight);
		vTemp.fY = 0;
		vTemp.Normalize();
		
		float fSpeedCoef = m_fCurrSpeed;
		if (m_fCurrSpeed >= 0)
			fSpeedCoef /= m_Params.GetMaxSpeed();
		else
			fSpeedCoef /= -m_Params.GetMaxSpeed();

		vTemp.Mul(m_fFrameTime * m_Params._SLIDE_COEF *
				  m_fCurrDirAngle / m_Params._MAX_TURN_ANGLE *
				  fSpeedCoef);
		
		m_vTurningSlide.Add(vTemp);
	}
		
	void UpdateSpringsAndWheels()
	{
        if (m_bPhysicsCalcOnly)
            return;
        
		// obliczamy docelowe w danej chwili ustawienie sprezyn dla kazdego kola pojazdu
		CalculateSprings();

		// modyfikujemy ustawienie sprezyn zgodnie z uplywem czasu
		AlignSprings();
	
		// obracamy i skrecamy kola
		UpdateVehicleWheels();
	}
    
    void AlignSpringsAndWheelsToTerrain()
    {
        CalculateSprings();
		for (int i = 0; i < m_nWheelCnt; i++)
        {
			m_Springs[i] = m_SpringsNew[i];
			if (m_Springs[i] < m_Params._SPRING_MIN)
				m_Springs[i] = m_Params._SPRING_MIN;
			if (m_Springs[i] > m_Params._SPRING_MAX)
				m_Springs[i] = m_Params._SPRING_MAX;
		}
        ShiftUpDownWheels();
    }
	
	void TurnRightHAngle(boolean bRight)
	{
		if (m_fCurrSpeed == 0)
		{
			DecreaseVehicleHAngle();
			return;
		}
		
		if (bRight)
		{
			m_fCurrVehicleHAngle -= java.lang.Math.abs(m_fCurrSpeed) / m_Params.GetMaxSpeed() *
									m_fFrameTime * m_Params._HORIZ_DEV_ACCEL;
			if (m_fCurrVehicleHAngle < -m_Params._MAX_HORIZ_DEV)
				m_fCurrVehicleHAngle = -m_Params._MAX_HORIZ_DEV;
		}
		else
		{
			m_fCurrVehicleHAngle += java.lang.Math.abs(m_fCurrSpeed) / m_Params.GetMaxSpeed() *
									m_fFrameTime * m_Params._HORIZ_DEV_ACCEL;
			if (m_fCurrVehicleHAngle > m_Params._MAX_HORIZ_DEV)
				m_fCurrVehicleHAngle = m_Params._MAX_HORIZ_DEV;
		}
	}
	
	void AccelVAngle(boolean bAccel)
	{
		if (m_fCurrSpeed == 0)
		{
			DecreaseVehicleVAngle();
			return;
		}
			
		float fCoef = m_fCurrSpeed;
		if (bAccel)
		{
			m_fCurrVehicleVAngle -= m_fFrameTime * m_Params._VERT_DEV_ACCEL;
			if (fCoef < 0)
				fCoef = 0;
			if (m_fCurrVehicleVAngle < -m_Params._MAX_VERT_DEV * (1 - fCoef / m_Params.GetMaxSpeed()))
				m_fCurrVehicleVAngle = -m_Params._MAX_VERT_DEV * (1 - fCoef / m_Params.GetMaxSpeed());
		}
		else
		{
			m_fCurrVehicleVAngle += m_fFrameTime * m_Params._VERT_DEV_ACCEL;
			if (fCoef > 0)
				fCoef = 0;
			if (m_fCurrVehicleVAngle > m_Params._MAX_VERT_DEV * (1 - fCoef / m_Params._MIN_SPEED))
				m_fCurrVehicleVAngle = m_Params._MAX_VERT_DEV * (1 - fCoef / m_Params._MIN_SPEED);
		}
	}
	
	void DecreaseVehicleVAngle()
	{
		if (m_fCurrVehicleVAngle >= 0)
		{
			m_fCurrVehicleVAngle -= m_fFrameTime * m_Params._VERT_DEV_ACCEL;
			if (m_fCurrVehicleVAngle < 0)
				m_fCurrVehicleVAngle = 0;
		}
		else
		{
			m_fCurrVehicleVAngle += m_fFrameTime * m_Params._VERT_DEV_ACCEL;
			if (m_fCurrVehicleVAngle > 0)
				m_fCurrVehicleVAngle = 0;
		}
	}

	void DecreaseVehicleHAngle()
	{
		if (m_fCurrVehicleHAngle >= 0)
		{
			m_fCurrVehicleHAngle -= m_fFrameTime * m_Params._HORIZ_DEV_ACCEL;
			if (m_fCurrVehicleHAngle < 0)
				m_fCurrVehicleHAngle = 0;
		}
		else
		{
			m_fCurrVehicleHAngle += m_fFrameTime * m_Params._HORIZ_DEV_ACCEL;
			if (m_fCurrVehicleHAngle > 0)
				m_fCurrVehicleHAngle = 0;
		}
	}
	
	void SlowDown()
	{
		// zmniejszamy predkosc w zaleznosci od wektora poslizgu (on sam w czasie maleje)
		float fValue = m_Params._SLIDE_SPEED_COEF * m_vSlideVector.Len() / m_Params._MAX_BOUNCE_RANGE;

		if (m_fCurrSpeed >= 0)
		{
			m_fCurrSpeed -= m_fCurrSpeed * m_fFrameTime * fValue;
			if (m_fCurrSpeed < 0)
				m_fCurrSpeed = 0;
		}
		else
		{
			m_fCurrSpeed -= m_fCurrSpeed * m_fFrameTime * fValue;
			if (m_fCurrSpeed > 0)
				m_fCurrSpeed = 0;
		}
	}
	
	void AlignToUp()
	{
		Vector vProduct = new Vector(Vector.Up);
		vProduct.Mul(m_Params._UP_FLY_ALIGN_INERTIA * m_fFrameTime);
		vProduct.Add(m_vVehicleNormal);
		vProduct.Normalize();
		m_vVehicleNormal.Set(vProduct);
	}
	
	void FallDown()
	{
		Vector vStart = new Vector(m_vVehicleNormal);
		vStart.Mul(m_Params._SUSPENSION_HEIGHT);
		vStart.Add(m_vVehiclePosition);
		Vector vEnd = new Vector(m_vVehiclePosition);
		vEnd.Sub(vStart);
		vEnd.Mul(2.0f + _FALL_DOWN_TEST_COEF + _HEIGHT_OVER_GROUND);
		vEnd.Add(vStart);

		if (m_bLanding)
		{
			m_fLandingTime -= m_fFrameTime;

			if (m_fLandingTime <= 0)
			{
				m_fLandingTime = 0;
				m_fFlyingTime = 0;
				m_bFlying = false;
				m_bLanding = false;
				return;
			}
		}
		
        TestTrack(vStart, vEnd);
		vEnd.Set(m_collInfo.vEnd);
		if (m_collInfo.coll != null)
		{
			vEnd.fY += _HEIGHT_OVER_GROUND;
			if (!m_bLanding)
			{
				m_bLanding = true;
				m_fLandingTime = m_Params._MAX_LANDING_TIME;
			}
			
			Vector vProduct = CalculateNewNormal();

			if (vProduct.Len2() == 0f)
			{
				// kola nie znalazly kolizji, zmieniamy tylko pozycje, nie orientacje
				AlignToUp();
				return;
			}
				
			vProduct.Mul(m_Params._GROUND_FLY_ALIGN_INERTIA * m_fFrameTime);
			vProduct.Add(m_vVehicleNormal);
			vProduct.Normalize();
			m_vVehicleNormal.Set(vProduct);
		}
		else
		{
			AlignToUp();
			vEnd.fY += _HEIGHT_OVER_GROUND;
		}
	}

	void SetVehiclePosAndOrientation()
	{
		m_vVehicleNormal.Normalize();
		m_vVehicleRight = m_vVehicleNormal.Cross(m_vVehicleForward);
		m_vVehicleRight.Normalize();
		m_vVehicleForward = m_vVehicleRight.Cross(m_vVehicleNormal);
		m_vVehicleForward.Normalize();
		
		m_vVehicleTForward.Set(m_vVehicleForward);
		m_vVehicleTNormal.Set(m_vVehicleNormal);
		
		m_vVehicleTForward = m_Vehicle.RotateVector(m_vVehicleTForward, m_fCurrVehicleVAngle, m_vVehicleRight);
		m_vVehicleTNormal = m_Vehicle.RotateVector(m_vVehicleTNormal, m_fCurrVehicleVAngle, m_vVehicleRight);
		if (m_bMotorLikeAlign)
			m_vVehicleTNormal = m_Vehicle.RotateVector(m_vVehicleTNormal, -m_fCurrVehicleHAngle, m_vVehicleTForward);
		else
			m_vVehicleTNormal = m_Vehicle.RotateVector(m_vVehicleTNormal, m_fCurrVehicleHAngle, m_vVehicleTForward);
        
		m_Vehicle.FromUpForwardPos(m_vVehicleTNormal, m_vVehicleTForward, m_vVehiclePosition);

		UpdateSpringsAndWheels();
	}
	
	void DecreaseSlide()
	{
		float fNewValue = m_vSlideVector.Len() - m_Params._SLIDE_TIME_COEF * m_fFrameTime;
		if (fNewValue < 0)
			fNewValue = 0;
		m_vSlideVector.Normalize();
		m_vSlideVector.Mul(fNewValue);
	}

	void DecreaseTurning()
	{
		if ((m_fTurnRight == 0) && (m_fTurnLeft == 0) && (m_fCurrDirAngle != 0))
		{
			float fNewValue;
			
			if (m_fCurrDirAngle < 0)
				fNewValue = m_fCurrDirAngle + m_Params._DECREASE_TURNING_SPEED * m_fFrameTime;
			else
				fNewValue = m_fCurrDirAngle - m_Params._DECREASE_TURNING_SPEED * m_fFrameTime;
			
			if (fNewValue * m_fCurrDirAngle < 0)
				fNewValue = 0;
			
			m_fCurrDirAngle = fNewValue;
		}
	}
	
	Vector CalculateNewNormal()
	{
		Vector vDown = new Vector(0, -1, 0);
				   
		Vector vSuspensionDir = new Vector(m_vVehicleNormal);
		vSuspensionDir.Mul( m_Params._SUSPENSION_HEIGHT );
		
		for (int i = 0; i < m_nWheelBaseCnt; i++)
		{
            if (m_WheelsBase[i] != -1)
                vWheelTmp[i].Set(m_Vehicle.GetElementPos(m_WheelsBase[i]));
            else
                vWheelTmp[i].Set(m_Vehicle.GetPosition());
            vWheelTmp[i].Add(vSuspensionDir);
		}

		// sprawdzamy kolizje kol z podlozem
		vSuspensionDir.Negate();
		vSuspensionDir.Mul(2f);

		Vector vEnd = null;
		
		for (int i = 0; i < m_nWheelBaseCnt; i++)
		{
			vEnd = new Vector(vSuspensionDir);
			vEnd.Add(vWheelTmp[i]);
			
			TestTrack(vWheelTmp[i], vEnd);
			
			if (m_collInfo.coll != null)
				vWheelTmp[i].Set(m_collInfo.coll.vNormal);
			else
				vWheelTmp[i].Set(Vector.Zero);
		}

		// w vProduct jest usredniona normalna pojazdu wynikajaca z polozenia kol
		Vector vProduct = new Vector(vWheelTmp[m_nWheelBaseCnt - 1]);
		for (int i = 0; i < m_nWheelBaseCnt - 1; i++)
			vProduct.Add(vWheelTmp[i]);
		vProduct.Normalize();
				
		if (vProduct.Len2() == 0)
		{
			// zadne z kol nie zlapalo kolizji, probujemy zlapac kolizje srodkiem pojazdu
			Vector vTemp = new Vector(m_vVehiclePosition);
			vTemp.fY += m_Params._SUSPENSION_HEIGHT;
			vEnd = new Vector(vTemp);
			vEnd.fY -= 2 * m_Params._SUSPENSION_HEIGHT;
			
			TestTrack(vTemp, vEnd);
			
			if (m_collInfo.coll != null)
				vProduct.Set(m_collInfo.coll.vNormal);
			else
				vProduct.Set(Vector.Up);
		}
        
		return vProduct;
	}

	Vector GetWheelBasePos(int nWheel)
	{
        return (m_WheelsBase[nWheel] != -1) ? m_Vehicle.GetElementPos( m_WheelsBase[ nWheel ] ) :
                                              m_Vehicle.GetPosition();
	}
	
	Vector GetWheelBaseLocalPos(int nWheel)
	{
        return (m_WheelsBase[nWheel] != -1) ? m_Vehicle.GetElementLocalPos( m_WheelsBase[ nWheel ] ) :
                                              Vector.Zero;
	}
	
	Vector GetWheelFXPos( int nWheel )
	{
        Vector vPos = (m_Wheels[nWheel] != -1) ? m_Vehicle.GetElementPos( m_Wheels[ nWheel ] ) :
                                                 m_Vehicle.GetPosition();
		vPos.fY += (fWheelSmokeShiftY - _HALF_WHEEL_SIZE);
		return vPos;
	}
	
	void CalculateSprings()
	{
		Vector vSuspensionDir = new Vector(m_vVehicleTNormal);
		vSuspensionDir.Mul(2 * m_Params._SUSPENSION_HEIGHT);
		
		for (int i = 0; i < m_nWheelCnt; i++)
		{
			vWheelTmp[i].Set(GetWheelBasePos( i ));
			vWheelTmp[i].Add(vSuspensionDir);
		}

		vSuspensionDir.Negate();
		vSuspensionDir.Mul(2f);

		Vector vEnd = null;
		Collision col = null;

		// sprawdzamy kolizje kol z podlozem
		for (int i = 0; i < m_nWheelCnt; i++)
		{
			vEnd = new Vector(vSuspensionDir);
			vEnd.Add(vWheelTmp[i]);
			TestTrack(vWheelTmp[i], vEnd);
			vEnd.Set(m_collInfo.vEnd);
			if (m_collInfo.coll != null)
			{
				vEnd.Sub(vWheelTmp[i]);
				m_SpringsNew[i] = 2 * m_Params._SUSPENSION_HEIGHT + _HALF_WHEEL_SIZE - vEnd.Len();
			}
			else
				m_SpringsNew[i] = m_Params._SPRING_NORMAL;
		}
	}
	
	void AlignSprings()
	{
		for (int i = 0; i < m_nWheelCnt; i++)
		{
			if (m_Springs[i] < m_SpringsNew[i])
			{
				m_Springs[i] += m_Params._SPRING_TIME_MOVE_COEF * m_fFrameTime;
				if (m_Springs[i] > m_SpringsNew[i])
					m_Springs[i] = m_SpringsNew[i];
			}
			else
			{
//				m_Springs[i] -= m_Params._SPRING_TIME_MOVE_COEF * m_fFrameTime;
//				if (m_Springs[i] < m_SpringsNew[i])
                // chcemy uniknac wbijania sie kola w ziemie
				m_Springs[i] = m_SpringsNew[i];
			}
			if (m_Springs[i] < m_Params._SPRING_MIN)
				m_Springs[i] = m_Params._SPRING_MIN;
			if (m_Springs[i] > m_Params._SPRING_MAX)
				m_Springs[i] = m_Params._SPRING_MAX;
		}
	}
	
	void UpdateVehicleWheels()
	{
		ShiftUpDownWheels();
		
        if ( m_bNetSimulate )
		    RotateTurnWheels( m_fCurrDirAngle );
        else
            RotateTurnWheels();

		RotateRevolutionWheels();
	}

	Vector m_vShiftUp = new Vector(0, 1, 0);
	Vector m_vShiftForward = new Vector(0, 0, 1);
	Vector m_vRotateTurn = new Vector(0, 0, -1);
	Vector m_vRotateRevolution = new Vector(0, -1, 0);
	
	void ShiftUpDownWheels()
	{
		Vector vPos = new Vector();
		
		for (int i = 0; i < m_nWheelCnt; i++)
		{
			vPos.Set( GetWheelBaseLocalPos(i) );
			vPos.fZ -= m_Springs[i];
            if (m_Wheels[i] != -1)
			    m_Vehicle.FromUpForwardPosElement( m_Wheels[i], m_vShiftUp, m_vShiftForward , vPos);
		}
	}
	    
	void RotateTurnWheels()
	{
        RotateTurnWheels( m_fCurrDirAngle );
	}
    
    void RotateTurnWheels(float fAngle)
    {
        for (int i = 0; i < 2; i++)
		{
			if (m_Wheels[i] != -1)
			    m_Vehicle.RotateElement( m_Wheels[i],
                                         m_vRotateTurn,
                                         -fAngle / 2f);
		}
    }
	
	void RotateRevolutionWheels()
	{
		m_fWheelRotationSpeed -= m_fCurrSpeed * m_Params._WHEEL_MOVE_SPEED_COEF * m_fFrameTime;
		for (int i = 0; i < m_nWheelCnt; i++)
        {
            if (m_Wheels[i] != -1)
                m_Vehicle.RotateElement( m_Wheels[i], m_vRotateRevolution, m_fWheelRotationSpeed);
        }
	}
	
	void SetBounceVector(Vector vNormal)
	{
		Vector vTemp = new Vector(Vector.Up);
		vTemp.Negate();
		vTemp.Add(vNormal);
		vTemp.Normalize();
		vTemp.Mul(m_Params._MAX_BOUNCE_RANGE);
		m_vSlideVector.Add(vTemp);
		m_vSlideVector.Normalize();
		m_vSlideVector.Mul(m_Params._MAX_BOUNCE_RANGE);
	}
	
	void DecreaseTurnSlide()
	{
		float fNewValue = m_vTurningSlide.Len() - m_Params._SLIDE_SUPRESS * m_fFrameTime;
		if (fNewValue < 0)
			fNewValue = 0;
		m_vTurningSlide.Normalize();
		m_vTurningSlide.Mul(fNewValue);
	}
	
	public void HandleDetectedCollision(Vector vMoveDir, boolean bCouldMoveAfterColl)
	{
        if (m_fRealSpeed < m_Params._MIN_SPEED_TO_COLLIDE)
        {
            m_fCurrSpeed /= 2;
            return;
        }
        
        if ((!bCouldMoveAfterColl) && (m_fNowTime - m_fLastCollisionSound > m_Params._TIME_BETWEEN_HIT_SOUNDS))
			PlaySoundHit();
				
		Vector vNormal = new Vector( vMoveDir );
		
		vNormal.Mul( -1 );
		vNormal.Normalize();
					
		GameObject.LogLine( "PseudoKolizja z obiektem "+
							" vNormal "+vNormal);
				
		float fMoveSpeed = m_fRealSpeed;
		// jezeli autko stoi to daje mu predkosc jednostkowa
		if ( fMoveSpeed <= 0.01f && fMoveSpeed >= -0.01f )
			fMoveSpeed = 1.0f;
			
		vNormal.Mul( m_Params._TREE_HIT_SUPR * fMoveSpeed );	
		m_vCollisionVector.Add( vNormal );
							
		if (m_vCollisionVector.Len() > m_Params._COLL_COEF_MAX_SPEED)
		{
			m_vCollisionVector.Normalize();
			m_vCollisionVector.Mul( m_Params._COLL_COEF_MAX_SPEED );
			GameObject.LogLine("wektor za dlugi, obcinamy do m_vCollisionVector "+m_vCollisionVector);
		}
		
		m_fCurrSpeed = 0;
        
        if (!bCouldMoveAfterColl)
		    TakeCollisionDamage(fMoveSpeed);
	}
	
	void TakeCollisionDamage(float fSpeed)
	{
        if (m_bPhysicsCalcOnly)
            return;
        
		float fDamageCoeff = m_Params._DAMAGE_COEFF_SAFE_COLLISION;
		if ( fSpeed >  m_Params._MAX_SPEED_TO_SAFE_COLLISION ||
			 fSpeed < -m_Params._MAX_SPEED_TO_SAFE_COLLISION )
		{
			fDamageCoeff = m_Params._DAMAGE_COEFF_HARD_COLLISION;
		}
					 
        // wysylamy do servera informacje, ze sie z czyms zderzylismy
        if ( m_Vehicle.m_bLocalPlayerDriver && m_Vehicle.Role < ERole._AUTHORITY )
            m_Vehicle.MsgSendServerVehicleCollision(m_Vehicle.fMaxHealth * fDamageCoeff); // u nas chodzi, ale nie jestesmy serverem
        else
        if (m_Vehicle.m_bLocalPlayerDriver && m_Vehicle.Role == ERole._AUTHORITY)
        	m_Vehicle.TakeDamage( m_Vehicle.fMaxHealth * fDamageCoeff, EnumDamageType._BULLET );
	}
    
    void TakeWaterDamage(float fTime)
	{
        if (m_bPhysicsCalcOnly)
            return;
        
		float fDamageCoeff = m_Params._DAMAGE_COEFF_WATER_COLLISION * fTime;
        float fDamage      = m_Vehicle.fMaxHealth * fDamageCoeff;					 
		m_Vehicle.TakeDamage( fDamage, EnumDamageType._BULLET );	
        //niestety w sieci ktos wymyslil zeby przy strzale w pojazd
        //wcale nie zabierac graczowi energii.
        //w takim przypadku trzeba recznie wywolac zabranie
        //energi pasazerom (o tyle ile mniej dostaja w stosunku do singla)
        if ( m_Vehicle.m_bModuleNet )
        {
            //sprawdzmy jakie sa roznice
            float fOccupantsDamageMul =  m_Vehicle.m_fSingleOccupantsDamageMul
                                        -m_Vehicle.m_fNetOccupantsDamageMul; 
            //jesli w sieci sa mniejsze obrazenia nic w singu
            //to dodatkowo wymuszamy roznice
            if ( fOccupantsDamageMul > 0 )
                m_Vehicle.OccupantsDamage( fDamage*fOccupantsDamageMul, 
                                           null );
        }
	}
	
	public void HandlePawnCollision(Pawn obj, Vector vNormal, Vector vMove,float fSpeed,Vector vPoint)
	{
		if (obj instanceof NewAIWalker)
		{
			HandleDetectedCollision(vMove, false);
			return;
		}
        
        if (m_bPhysicsCalcOnly)
            return;
        
		// jezeli predkosc pojazdu jest mniejsza od zadanej, nie robimy krzywdy pawnowi
		if (Math.abs(fSpeed) <= 500f)
			return;

		vMove.Normalize();

		// jezeli pojazd nie jedzie na pawna, nie zadajemy mu obrazen
		Vector vToPlayerDir = new Vector(obj.GetPosition());
		vToPlayerDir.Sub(m_Vehicle.GetPosition());
		vToPlayerDir.fY = 0;
		vToPlayerDir.Normalize();
		Vector vMoveDir = new Vector(vMove);
		vMoveDir.fY = 0;
		vMoveDir.Normalize();
		if (vMoveDir.Dot(vToPlayerDir) <= 0f)
			return;
		
		vMove.Mul( fSpeed );
		m_vMoveDir.Set( vMove );
		m_vMoveDir.Mul( m_fFrameTime );
			
		float fDamage = obj.fMaxHealth;
		
		float fHitStrength = java.lang.Math.abs(fSpeed) * m_Params._PAWN_HIT_COEF;
		
        if (fDamage < fHitStrength)
			fDamage = fHitStrength;
		
        obj.OnVehicleCollision(fDamage , m_Vehicle.GetFirstOccupant(EPassengerRole._VEHICLE_DRIVER),
							   null, vMove);
        
        if (obj instanceof Player)
            m_Vehicle.OnCollisionWithPlayer();
	}
	
	public void HandleCollision(ControlObject obj, Vector vPoint, Vector vNormal, Vector vMove)
	{
        // nie chcemy kolidowac z lecaca rakieta czy granatem
        if (obj instanceof Bullet)
        {
            obj.ClearFlag(EFlags._BLOCK_MOVE);
            m_bRecalculateMove = true;
            return;
        }
        
        if ( (m_Vehicle.m_bModuleNet) && (obj instanceof Pawn) )
        {
            m_bNetPawnCollision = true;
            return;
        }
        
		m_bCheckCollision = false;
		// jak bedziemy dostawac normalna elipsidy to trzeba ja odwrocic
	 	vNormal.Mul( -1 );
        
        if (vNormal.Dot(Vector.Up) > 0.5f)
            return;
        
		/*
		GameObject.LogLine( "Kolizja z obiektem "+obj+
							" vMove "+vMove+
							" vNormal "+vNormal);
		*/
		float fMoveSpeed = m_fRealSpeed;
		
        if (fMoveSpeed < m_Params._MIN_SPEED_TO_COLLIDE)
        {
            m_fCurrSpeed /= 2;
            return;
        }
        
		// jezeli autko stoi to daje mu predkosc jednostkowa
		if ( fMoveSpeed <= 0.1f && fMoveSpeed >= -0.1f )
			fMoveSpeed = 1.0f;
		
		if ( obj != null && obj instanceof Pawn )
		{
			HandlePawnCollision( (Pawn)obj,vNormal,vMove,fMoveSpeed,vPoint);
			return;
		}
                
		if ( (m_fNowTime - m_fLastCollisionSound > m_Params._TIME_BETWEEN_HIT_SOUNDS) && (!(obj instanceof Barrier)) )
			PlaySoundHit();
		
		if (vMove.Len2() > 0)
		{
			// o tyle mozemy sie przesunac
			m_vMoveDir.Set( vMove );
					
			// znormalizowany ruch
			Vector vMoveDirNorm = new Vector(m_vMoveDir);
			vMoveDirNorm.Normalize();
						
			// liczymy kat pod jakim ma sie odbic
			float fAngle = 180f - (float) java.lang.Math.acos(vNormal.Dot(vMoveDirNorm)) * 57.29f;
			
			// no i obracamy normalna o ten kat zeby wyliczyc wektor odbicia
			Vector vBounceDir = m_Vehicle.RotateVector( vNormal, fAngle, Vector.Up );
						
			// odbijamy wg wspolczynnika i predkosci wyliczonej przez MoveByElipsoid()
			vBounceDir.Mul( m_Params._TREE_HIT_SUPR * fMoveSpeed );
				
			m_vCollisionVector.Add( vBounceDir );
							
			if (m_vCollisionVector.Len() > m_Params._COLL_COEF_MAX_SPEED)
			{
				m_vCollisionVector.Normalize();
				m_vCollisionVector.Mul( m_Params._COLL_COEF_MAX_SPEED );
				GameObject.LogLine("wektor za dlugi, obcinamy do m_vCollisionVector "+m_vCollisionVector);
			}
		}
        if (!m_bPhysicsCalcOnly)
    		TakeCollisionDamage(fMoveSpeed);
		m_fCurrSpeed = 0;
		return;
	}
			
	void ZeroParams()
	{
		m_fFlyingTime = 0;
		m_fLandingTime = 0;
		m_bEnableBack = true;
		m_vSlideVector.Set(Vector.Zero);
		m_fCurrDirAngle = 0;
		m_bIsFlyingOnFrame = false;
		m_fWheelRotationSpeed = 0;
		m_bLanding = false;
		m_vTurningSlide.Set(Vector.Zero);
		m_vCollisionVector.Set(Vector.Zero);
		m_bGotCollision = false;
        
	}
	
	void SupressCollVector()
	{
		float fNewValue = m_vCollisionVector.Len() - m_Params._COLL_SUPRESS * m_fFrameTime;
		if (fNewValue < 0)
			fNewValue = 0;
		m_vCollisionVector.Normalize();
		m_vCollisionVector.Mul(fNewValue);
	}
            
	void AccelerateSmokeFX()
	{
        if (m_bPhysicsCalcOnly)
            return;
        
		if (m_fNowTime - m_fLastAccelFXTime > m_Params._TIME_BTW_SMOKES)
			m_fLastAccelFXTime = m_fNowTime;
		else
			return;
        if ( sWheelSmokeFX != null )
        {
		    m_Vehicle.ExecuteFX(sWheelSmokeFX, GetWheelFXPos(2), m_vVehicleNormal);
		    m_Vehicle.ExecuteFX(sWheelSmokeFX, GetWheelFXPos(3), m_vVehicleNormal);
        }
	}
	
	void BrakeSmokeFX()
	{
        if (m_bPhysicsCalcOnly)
            return;
        
		if (m_fNowTime - m_fLastBrakeFXTime > m_Params._TIME_BTW_SMOKES)
			m_fLastBrakeFXTime = m_fNowTime;
		else
			return;

        if ( sWheelSmokeFX != null )
            for ( int i = 0; i< m_nWheelCnt ; i++ )
		        m_Vehicle.ExecuteFX(sWheelSmokeFX, GetWheelFXPos(i), m_vVehicleNormal);
	}
        
    void WheelSmokeFX()
	{
        if (m_bPhysicsCalcOnly)
            return;
        
		if (m_fNowTime - m_fLastWheelFXTime > m_Params._TIME_BTW_SMOKES)
			m_fLastWheelFXTime = m_fNowTime;
		else
			return;
        
        if ( sWheelSmokeFX != null )
        {
            if ( bWheelSmokeRearOnly )
            {
                m_Vehicle.ExecuteFX(sWheelSmokeFX, GetWheelFXPos(2), m_vVehicleNormal);
		        m_Vehicle.ExecuteFX(sWheelSmokeFX, GetWheelFXPos(3), m_vVehicleNormal);
            }
            else
            {
		    	for ( int i = 0; i< m_nWheelCnt ; i++ )
		    	    m_Vehicle.ExecuteFX(sWheelSmokeFX, GetWheelFXPos(i), m_vVehicleNormal);
            }
        }
	}
    
	void TurnSlideSmokeFX()
	{
        if (m_bPhysicsCalcOnly)
            return;
        
		if (m_fNowTime - m_fLastSlideFXTime > m_Params._TIME_BTW_SMOKES_SLIDE)
			m_fLastSlideFXTime = m_fNowTime;
		else
			return;
        
        if ( sWheelSmokeFX != null )
            for ( int i = 0; i< m_nWheelCnt ; i++ )
		        m_Vehicle.ExecuteFX(sWheelSmokeFX, GetWheelFXPos(i), m_vVehicleNormal);
	}
				
	void SetVehicle(Vehicle obj)
	{
		m_Vehicle = obj;
	}
	
	void UpdateSounds()
	{
        if (m_bPhysicsCalcOnly)
            return;
        
		m_Vehicle.UpdateSounds();
	}
		
	void PlaySoundHit()
	{
        if (m_bPhysicsCalcOnly)
            return;
        
		m_Vehicle.HitSound();
		m_fLastCollisionSound = m_fNowTime;
	}
    
	void PlaySoundBrake()
	{
        if (m_bPhysicsCalcOnly)
            return;
        
        if ( m_fNowTime - m_fBrakePressTime > m_Params._TIME_BETWEEN_BRAKE_SOUNDS )
        {
		    m_Vehicle.BrakeSound();
		    m_fBrakePressTime = m_fNowTime;
        }
	}
    void PlaySoundAccel()
	{
        if (m_bPhysicsCalcOnly)
            return;
        
        if (m_fNowTime - m_fLastAccelSound > m_Params._TIME_BETWEEN_ACCEL_SOUNDS)
        {
		    m_Vehicle.AccelSound();
		    m_fBrakePressTime = m_fNowTime;
        }
	}
	void PlaySoundSlide()
	{
        if (m_bPhysicsCalcOnly)
            return;
        
        if (m_fNowTime - m_fLastSlideSound > m_Params._TIME_BETWEEN_SLIDE_SOUNDS)
        {
		    m_Vehicle.SlideSound();
		    m_fLastSlideSound = m_fNowTime;
        }
	}
	
	void SetCurrMaxSpeed(float fValue)
	{
		m_Params._CURR_MAX_SPEED = fValue;
		if (m_Params.GetMaxSpeed() < fValue)
			m_Params.SetMaxSpeed(fValue);
	}
	
	float GetMaxSpeed()
	{
		return m_Params.GetMaxSpeed();
	}
	
	float GetCurrMaxSpeed()
	{
		return m_Params._CURR_MAX_SPEED;
	}
    
    VehiclePhysicsState m_PhysicsState = null; // not SG - net only
    boolean m_bPhysicsCalcOnly = false; // not SG - net only
    
    void SavePhysicsState()
    {
        m_bPhysicsCalcOnly = true;
        if (m_PhysicsState == null)
            m_PhysicsState = new VehiclePhysicsState();
        m_PhysicsState.SavePhysicsState(this);
    }
    
    void RestorePhysicsState()
    {
        m_bPhysicsCalcOnly = false;
        m_PhysicsState.RestorePhysicsState(this);
    }
    
    void AdditionalSimulate( byte iAcc, float fTurn, float fDeltaTime, 
                             Vector vEndPos, Vector vEndDir, 
                             Vector vEndRight, Vector vEndUp )
    {
        SavePhysicsState();
        Simulate( iAcc, fTurn, fDeltaTime );
        //1 TODO: nie wiem czy to w ogole potrzebne, ale jesli tak,
        //to jak juz wszystko zadziala to dodac pobieranie vUp i vDir
        m_Vehicle.GetPosition( vEndPos );    
        if ( vEndDir != null )
            m_Vehicle.GetForwardVector( vEndDir );    
        if ( vEndRight != null )
            m_Vehicle.GetRightVector( vEndRight );    
        if ( vEndUp != null )
            m_Vehicle.GetUpVector( vEndUp );    
        RestorePhysicsState();
    }
    
    void Clear()
    {
        m_fAccelerate = 0f;
        m_fBrake = 0f;
        m_fTurnRight = 0f;
        m_fTurnLeft = 0f;
        m_fFlyingTime = 0f;
        m_fCurrSpeed = 0f;
        m_fCurrDirAngle = 0f;
        m_fMoveSpeed = 0f;
        m_vTurningSlide.Set(Vector.Zero);
        /*m_fCurrGravity = 0f;
        m_vSlideVector.Set(Vector.Zero);
        m_vCollisionVector.Set(Vector.Zero);
        m_bEnableBack = false;
        m_bIsFlyingOnFrame = false;
        m_bCheckCollision = false;
        m_bRecalculateMove = false;
        m_bLanding = false;
        m_bFlying = false;
        //m_collInfo = null;*/
        
        RotateTurnWheels( 0.0f );
       
        m_fFrameTime = 0.0f;
    }
	
    //*********************************************************
	//					SaveGame
    //*********************************************************
	
    /** Metoda wczytujaca zapisane dane w Save gracza
     */	
    public void SGLoadChunk(FileChunk cParentFC)
    {	
		FileChunk.Log("[PhysicsVehicle.SGLoadChunk]\n");
		
		FileChunk cFC = GameObject.LoadChunk(cParentFC);   
		
        if (cFC.GetID() == ESGChunksChrome._CHK_PHYSICS_VEHICLE)
        {	
    		m_fFrameTime = cFC.LoadFloat();					
			m_fNowTime = cFC.LoadFloat();
            _HALF_WHEEL_SIZE = cFC.LoadFloat();
            m_Params = (VehicleParams) cFC.LoadObjectRef();
			m_fFlyingTime = cFC.LoadFloat();
			m_fLandingTime = cFC.LoadFloat();			
            m_bEnableBack = cFC.LoadBool();
			m_vSlideVector = cFC.LoadVector();			
            m_fAccelerate = cFC.LoadFloat();
            m_fBrake = cFC.LoadFloat();
            m_fTurnLeft = cFC.LoadFloat();
            m_fTurnRight = cFC.LoadFloat();
            m_fCurrSpeed = cFC.LoadFloat();
            m_fCurrGravity = cFC.LoadFloat();
            m_fCurrDirAngle = cFC.LoadFloat();
            m_bIsFlyingOnFrame = cFC.LoadBool();
            m_fWheelRotationSpeed = cFC.LoadFloat();
            m_bFlying = cFC.LoadBool();
            m_bLanding = cFC.LoadBool();
            m_vTurningSlide = cFC.LoadVector();
            m_fCurrVehicleHAngle = cFC.LoadFloat();
            m_fCurrVehicleVAngle = cFC.LoadFloat();
			m_vVehicleNormal = cFC.LoadVector();		
			m_vVehicleForward = cFC.LoadVector();		
			m_vVehicleRight = cFC.LoadVector();		
			m_vVehicleTForward = cFC.LoadVector();
			m_vVehicleTNormal = cFC.LoadVector();
			m_vVehiclePosition = cFC.LoadVector();
			m_vCollisionVector = cFC.LoadVector();
			m_vMoveDir = cFC.LoadVector();
            m_bGotCollision = cFC.LoadBool();
            m_fLastAccelFXTimeStart = cFC.LoadFloat();
            m_fLastAccelFXTime = cFC.LoadFloat();
            m_fLastBrakeFXTime = cFC.LoadFloat();
            m_fLastSlideFXTime = cFC.LoadFloat();
            m_fLastWheelFXTime = cFC.LoadFloat();
            m_Vehicle = (Vehicle) cFC.LoadObjectRef();
			m_fHitTurnAngle = cFC.LoadFloat();
			m_fBrakePressTime = cFC.LoadFloat();
			m_fLastCollisionSound = cFC.LoadFloat();
			m_fLastSlideSound = cFC.LoadFloat();
			m_fLastAccelSound = cFC.LoadFloat();			
			m_fMoveSpeed = cFC.LoadFloat();			
            m_collInfo.vEnd = cFC.LoadVector();
            m_collInfo.coll = (Collision) cFC.LoadObjectRef();
            m_bCheckCollision = cFC.LoadBool();
            m_fTurnInPathMove = cFC.LoadFloat();
            m_vShiftUp = cFC.LoadVector();
            m_vShiftForward = cFC.LoadVector();
            m_vRotateTurn = cFC.LoadVector();
            m_vRotateRevolution = cFC.LoadVector();
            m_bMotorLikeAlign = cFC.LoadBool();
            bWheelSmokeRearOnly = cFC.LoadBool();
            m_fMovieWheelsAngleMult = cFC.LoadFloat();
            m_fLastYPos = cFC.LoadFloat();
        }
		
		cFC.delete();
    }
    
    /** Metoda zapisujaca dane do Save gracza
     */	
    public void SGSaveChunk(FileChunk cFCParent)
    {
		FileChunk.Log("[PhysicsVehicle.SGSaveChunk]\n");
		
        FileChunk cFC = GameObject.NewChunk(ESGChunksChrome._CHK_PHYSICS_VEHICLE, cFCParent);

    	cFC.SaveFloat(m_fFrameTime);
		cFC.SaveFloat(m_fNowTime);					
        cFC.SaveFloat(_HALF_WHEEL_SIZE);
        cFC.SaveObjectRef(m_Params);
		cFC.SaveFloat(m_fFlyingTime);
		cFC.SaveFloat(m_fLandingTime);			
        cFC.SaveBool(m_bEnableBack);
		cFC.SaveVector(m_vSlideVector);			
        cFC.SaveFloat(m_fAccelerate);
        cFC.SaveFloat(m_fBrake);
        cFC.SaveFloat(m_fTurnLeft);
        cFC.SaveFloat(m_fTurnRight);
        cFC.SaveFloat(m_fCurrSpeed);
        cFC.SaveFloat(m_fCurrGravity);
        cFC.SaveFloat(m_fCurrDirAngle);
        cFC.SaveBool(m_bIsFlyingOnFrame);
        cFC.SaveFloat(m_fWheelRotationSpeed);
        cFC.SaveBool(m_bFlying);
        cFC.SaveBool(m_bLanding);
        cFC.SaveVector(m_vTurningSlide);
        cFC.SaveFloat(m_fCurrVehicleHAngle);
        cFC.SaveFloat(m_fCurrVehicleVAngle);
		cFC.SaveVector(m_vVehicleNormal);		
		cFC.SaveVector(m_vVehicleForward);		
		cFC.SaveVector(m_vVehicleRight);		
		cFC.SaveVector(m_vVehicleTForward);
		cFC.SaveVector(m_vVehicleTNormal);
		cFC.SaveVector(m_vVehiclePosition);
		cFC.SaveVector(m_vCollisionVector);
		cFC.SaveVector(m_vMoveDir);
        cFC.SaveBool(m_bGotCollision);
        cFC.SaveFloat(m_fLastAccelFXTimeStart);
        cFC.SaveFloat(m_fLastAccelFXTime);
        cFC.SaveFloat(m_fLastBrakeFXTime);
        cFC.SaveFloat(m_fLastSlideFXTime);
        cFC.SaveFloat(m_fLastWheelFXTime);
        cFC.SaveObjectRef(m_Vehicle);
		cFC.SaveFloat(m_fHitTurnAngle);
		cFC.SaveFloat(m_fBrakePressTime);
		cFC.SaveFloat(m_fLastCollisionSound);
		cFC.SaveFloat(m_fLastSlideSound);
		cFC.SaveFloat(m_fLastAccelSound);			
		cFC.SaveFloat(m_fMoveSpeed);			
        cFC.SaveVector(m_collInfo.vEnd);
        cFC.SaveObjectRef(m_collInfo.coll);
        cFC.SaveBool(m_bCheckCollision);
        cFC.SaveFloat(m_fTurnInPathMove);
        cFC.SaveVector(m_vShiftUp);
        cFC.SaveVector(m_vShiftForward);
        cFC.SaveVector(m_vRotateTurn);
        cFC.SaveVector(m_vRotateRevolution);
        cFC.SaveBool(m_bMotorLikeAlign);
        cFC.SaveBool(bWheelSmokeRearOnly);
        cFC.SaveFloat(m_fMovieWheelsAngleMult);
        cFC.SaveFloat(m_fLastYPos);
				
		cFC.delete();
    }	    				
	
	public void SGUpdate()
    {
		for (int i = 0; i < _MAX_WHEELS; i++)
			vWheelTmp[i] = new Vector(0, 0, 0);
        
        AlignSpringsAndWheelsToTerrain();
    }
}