public class PhysicsVehicleSwayBeam extends PhysicsVehicle
{
	// wahacze (numerki elementow)
	int m_SwayBeams[] = {-1, -1, -1, -1};		
		
	// posredniki pomiedzy kolami w wahaczami (numerki elementow)
	int m_WheelHolders[] = {-1, -1, -1, -1};
	// numery obiektow bazowych jw
	int m_WheelHoldersBase[] = {-1, -1, -1, -1};
	
	// minimalne pozycje kol
    int m_Min[] = {-1, -1, -1, -1};		
	// maksymalne pozycje kol
	int m_Max[] = {-1, -1, -1, -1};		
	
	// numer poczatkowej klatki animacji przednich kol
	int m_nFrontWheelFrameMin = 0;	
	// numer koncowej klatki animacji przednich kol
	int m_nFrontWheelFrameMax = 0;	
	// ilosc klatek
	int m_nFrontWheelFrames = 0;
	
	// numer poczatkowej klatki animacji tylnich kol
	int m_nRearWheelFrameMin = 0;	
	// numer koncowej klatki animacji tylnich kol
	int m_nRearWheelFrameMax = 0;	
	// ilosc klatek
	int m_nRearWheelFrames = 0;
	
    PhysicsVehicleSwayBeam()
	{
        //SG
    }
         
	PhysicsVehicleSwayBeam( Vehicle vehicle )
	{
		super( vehicle );
		
		m_Params._SPRING_MIN = 0.0f;
		m_Params._SPRING_MAX = 1.0f;
		m_Params._SPRING_TIME_MOVE_COEF = 1.5f;
        
		m_vShiftUp.Set(-1, 0, 0);
		m_vShiftForward.Set(0, 1, 0);
		m_vRotateTurn.Set(0, 0, 1);
		m_vRotateRevolution.Set(0, -1, 0);
	}
    
    void Init()
    {
        super.Init();
        
		// obliczamy promien kola
        if ( m_Wheels[0] != -1 && m_Min[0] != - 1)
        {
		    Vector vTemp = m_Vehicle.GetElementPos(m_Wheels[0]);
		    vTemp.Sub( m_Vehicle.GetElementPos(m_Min[0]) );
		    _HALF_WHEEL_SIZE = vTemp.fY;
		    GameObject.LogLine("_HALF_WHEEL_SIZE "+_HALF_WHEEL_SIZE);
        }
        
        Clear();
    }
    
    
    public void InitWheelsElements()
    {
        super.InitWheelsElements();
        
		m_WheelHolders[0] = m_Vehicle.GetElementID("link_PP");
		m_WheelHolders[1] = m_Vehicle.GetElementID("link_LP");
		
		m_WheelHoldersBase[0] = m_Vehicle.GetElementID("linkbase_PP");
		m_WheelHoldersBase[1] = m_Vehicle.GetElementID("linkbase_LP");
		
		m_SwayBeams[0] = m_Vehicle.GetElementID("wahacz_PP");
		m_SwayBeams[1] = m_Vehicle.GetElementID("wahacz_LP");
		m_SwayBeams[2] = m_Vehicle.GetElementID("wahacz_LT");
		m_SwayBeams[3] = m_Vehicle.GetElementID("wahacz_PT");
		
		m_Min[0] = m_Vehicle.GetElementID("min_PP");
		m_Min[1] = m_Vehicle.GetElementID("min_LP");
		m_Min[2] = m_Vehicle.GetElementID("min_LT");
		m_Min[3] = m_Vehicle.GetElementID("min_PT");
		
		m_Max[0] = m_Vehicle.GetElementID("max_PP");
		m_Max[1] = m_Vehicle.GetElementID("max_LP");
		m_Max[2] = m_Vehicle.GetElementID("max_LT");
		m_Max[3] = m_Vehicle.GetElementID("max_PT");
        
        m_Vehicle.SetAnimMorphTime(m_WheelHolders[0], 0.0f, false);
        m_Vehicle.SetAnimMorphTime(m_WheelHolders[1], 0.0f, false);
		
    }
		
	void SetFrontWheelFrames(int nMin, int nMax)
	{
		m_nFrontWheelFrameMin	= nMin;	
		m_nFrontWheelFrameMax	= nMax;	
		m_nFrontWheelFrames		= nMax-nMin/*+1*/;
	}
	
	void SetRearWheelFrames(int nMin, int nMax)
	{
		m_nRearWheelFrameMin	= nMin;	
		m_nRearWheelFrameMax	= nMax;	
		m_nRearWheelFrames		= nMax-nMin/*+1*/;
	}

	void CalculateSprings()
	{
		for (int i = 0; i < 4; i++)
		{
			Vector vStart = new Vector( GetMinPosWheel( i ) );
			Vector vEnd   = new Vector( GetMaxPosWheel( i ) );
			
			float fMaxDist = vStart.Distance( vEnd );
			
			TestTrackNoCheckTerrainHeight( vStart, vEnd );
			vEnd.Set( m_collInfo.vEnd );
			if (m_collInfo.coll != null)
			{
				float fDist = vStart.Distance( vEnd );
				m_SpringsNew[i] = fDist / fMaxDist;
			}
			else
			{
				if ( m_Vehicle.TerrainHeight( vStart.fX, vStart.fZ ) > vStart.fY )
					m_SpringsNew[i] = 0.0f;
				else
					m_SpringsNew[i] = 1.0f;
			}
		}
	}
		
    float m_LastDirAngle[] = {0f, 0f};	
    int   m_LastFrame[] = {-1, -1};
    
	float m_fTurnWheelsAngle = 0f;
    float _TURN_WHEELS_ROTATION_SPEED = 450f;
	
	void RotateTurnWheels()
	{
		float fDestAngle = 0f;

		// m_fTurnLeft lub m_fTurnRight to kat w stopniach od wektora biezacego do docelowego
		if (m_fTurnLeft > 0f)
		{
			fDestAngle = -m_fTurnLeft * m_Params._MAX_TURN_ANGLE;
			if (fDestAngle < -m_Params._MAX_TURN_ANGLE)
				fDestAngle = -m_Params._MAX_TURN_ANGLE;
		}
		else
		if (m_fTurnRight > 0f)
		{
			fDestAngle = m_fTurnRight * m_Params._MAX_TURN_ANGLE;
			if (fDestAngle > m_Params._MAX_TURN_ANGLE)
				fDestAngle = m_Params._MAX_TURN_ANGLE;
		}
        
        // bezwladnosc
		if (m_fTurnWheelsAngle < m_fCurrDirAngle)
		{
			m_fTurnWheelsAngle += m_fFrameTime * _TURN_WHEELS_ROTATION_SPEED;
			if (m_fTurnWheelsAngle > m_fCurrDirAngle)
				m_fTurnWheelsAngle = m_fCurrDirAngle;
		}
		else
		if (m_fTurnWheelsAngle > m_fCurrDirAngle)
		{
			m_fTurnWheelsAngle -= m_fFrameTime * _TURN_WHEELS_ROTATION_SPEED;
			if (m_fTurnWheelsAngle < m_fCurrDirAngle)
				m_fTurnWheelsAngle = m_fCurrDirAngle;
        }
        
        RotateTurnWheels(m_fTurnWheelsAngle);
	}
    
    void RotateTurnWheels(float fAngle)
    {
        for ( int i = 0; i < 2; i++ )
        {
	        if (m_Wheels[i] != -1)
				m_Vehicle.RotateElement( m_WheelHolders[i], m_vRotateTurn, fAngle / m_Params._MAX_TURN_ANGLE * m_Params._MAX_VIS_TURN_ANGLE );
		}
    }
	
	void ShiftUpDownWheels()
	{
		for (int i = 0; i < 4; i++)
		{
			int nFirstFrame = (i<2)?m_nFrontWheelFrameMin:m_nRearWheelFrameMin;
			int nFrames     = (i<2)?m_nFrontWheelFrames:m_nRearWheelFrames;
			int nFrame		= nFirstFrame + (int)(nFrames * m_Springs[i]);
			
			m_Vehicle.SetFrame( nFrame, m_SwayBeams[i] );
			if ( i < 2 )
            {
                m_Vehicle.SetFrame( nFrame, m_WheelHolders[i] );
                
                // "zerowanie" holderow robione automatycznie przy zmianie nFrame, 
                // natomiast przy tym samym nFrame skrety kol robione beda 
                // w RotateTurnWheels() przyrostowo, bowiem damies WheelHolderBase
                // niestety NIE jest animowany razem z wachaczem i holderem, zatem
                // nie mozemy na jego podstawie ustawiac holdera

                // jezeli nowa klatka animacji, to przyrosty zerujemy
                if ( m_LastFrame[i] != nFrame ) 
                {
                    m_LastFrame[i]    = nFrame;
                    m_LastDirAngle[i] = 0.0f;	
                }
            }
			m_Vehicle.FromUpForwardPosElement( m_Wheels[i], Vector.Up , Vector.Forward , GetWheelBaseLocalPos( i ) );
		}
	}
		
	Vector GetWheelHolderBaseLocalPos( int nWheel )
	{
		return m_Vehicle.GetElementLocalPos( m_WheelHoldersBase[ nWheel ] );
	}
	
	Vector GetMinPosWheel( int nWheel )
	{
		return m_Vehicle.GetElementPos( m_Min[ nWheel ] );
	}
	
	Vector GetMaxPosWheel( int nWheel )
	{
		return m_Vehicle.GetElementPos( m_Max[ nWheel ] );
	}
    
    void Clear()
    {
        super.Clear();
        
        for (int i = 0; i < m_Springs.length; i++)
            m_Springs[i] = 0.5f;
        for (int i = 0; i < m_SpringsNew.length; i++)
			m_SpringsNew[i] = 0.5f;
        
        ShiftUpDownWheels();
    }
    
    //*********************************************************
	//					SaveGame
    //*********************************************************
	
    /** Metoda wczytujaca zapisane dane w Save gracza
     */	
    public void SGLoadChunk(FileChunk cParentFC)
    {	
		FileChunk.Log("[VehicleSwayBeam.SGLoadChunk]\n");
		
		FileChunk cFC = GameObject.LoadChunk(cParentFC);   
		
        if (cFC.GetID() == ESGChunksChrome._CHK_VEHICLE_SWAY_BEAM)
        {
			super.SGLoadChunk(cFC);
            
            for (int i = 0; i < m_LastDirAngle.length; i++)
                m_LastDirAngle[i] = cFC.LoadFloat();
            for (int i = 0; i < m_LastFrame.length; i++)
                m_LastFrame[i] = cFC.LoadInt();

	        m_nFrontWheelFrameMin = cFC.LoadInt();
	        m_nFrontWheelFrameMax = cFC.LoadInt();
	        m_nFrontWheelFrames = cFC.LoadInt();
	        m_nRearWheelFrameMin = cFC.LoadInt();
	        m_nRearWheelFrameMax = cFC.LoadInt();
	        m_nRearWheelFrames = cFC.LoadInt();
        }
		
		cFC.delete();
    }
    
    /** Metoda zapisujaca dane do Save gracza
     */	
    public void SGSaveChunk(FileChunk cFCParent)
    {
		FileChunk.Log("[VehicleSwayBeam.SGSaveChunk]\n");
		
        FileChunk cFC = GameObject.NewChunk(ESGChunksChrome._CHK_VEHICLE_SWAY_BEAM, cFCParent);
		
		super.SGSaveChunk(cFC);

        for (int i = 0; i < m_LastDirAngle.length; i++)
            cFC.SaveFloat(m_LastDirAngle[i]);
        for (int i = 0; i < m_LastFrame.length; i++)
            cFC.SaveInt(m_LastFrame[i]);
						
	    cFC.SaveInt(m_nFrontWheelFrameMin);
	    cFC.SaveInt(m_nFrontWheelFrameMax);
	    cFC.SaveInt(m_nFrontWheelFrames);
	    cFC.SaveInt(m_nRearWheelFrameMin);
	    cFC.SaveInt(m_nRearWheelFrameMax);
	    cFC.SaveInt(m_nRearWheelFrames);

        cFC.delete();
    }
}
