public class Truck6Wheels extends Vehicle
{
    Truck6Wheels()
    {
        m_sSoundStartName = "Data\\Sounds\\ambient\\Vehicles\\MMZ\\start_22.wav";
        m_sSoundLoopName  = "Data\\Sounds\\ambient\\Vehicles\\MMZ\\MMz_engine_loop_22kHz";
        m_sSoundStopName  = null; // nie ma tego dzwieku
        LoadSoundParams("Data/Sounds/Vehicles/Truck.scr");
		
		m_fObservedSightVAngle = 20f;
		m_fOverObservedHeight = 800f;
		m_fOverObservedBack = 800f;
    }
    
	void OnCreate()
    {
        super.OnCreate();

		DeleteAllSeatsInfos();
		AddSeatInfo(new SeatInfo(this, "Driver", EPassengerRole._VEHICLE_DRIVER,
								 EGetInOutAnimType._LEFT_SIDE, new Vector(0f, -460f, 280f)));
        ClearFlag(EFlags._NO_ANIMATION);
        SetFlag(EFlags._NO_ANIMATION_REFRESH);
		m_Physics.m_Params._WHEEL_MOVE_SPEED_COEF = 0.5f;
	}
	
    void CreatePhysics()
    {
		m_Physics = new PhysicsVehicle6Wheels(this);
        m_Physics.Init();
        m_Physics.sWheelSmokeFX = "SmokeBigTruck";
        m_Physics.bWheelSmokeFX = true;
        m_Physics.bWheelSmokeRearOnly = true;
        m_Physics.fWheelSmokeShiftY = 15.0f; 
        m_Physics.m_fMinDirAngleSlide = 30.0f;
        m_Physics.m_Params._TIME_BTW_SMOKES = 0.4f;
        m_Physics.m_Params._SLIDE_SUPRESS = 700.0f;
    }
    
    /** Ciezarowka nie moze wybuchnac na jakims kamieniu
     */
    public void OnCollisionFullInfoMove(ControlObject obj, Vector vPoint, Vector vNormal, Vector vMove)
	{
    }
    
    ControlObject cAttachedSoundObj = this;
    int AttachSound(String sSoundName, float fPar1, float fPar2)
    {
        if ( cAttachedSoundObj == this )
        {
            cAttachedSoundObj = ((ChromeModuleSingle)(GetModule())).MainPlayer;
        }
        
        if ( cAttachedSoundObj != this ) 
        {
            CrashLog("OK, Truck sound attached to "+cAttachedSoundObj );
            return cAttachedSoundObj.AttachSound(sSoundName,fPar1,fPar2);
        }
        else
        {
            CrashLog("FAILED, Truck sound attached to "+this );
            return super.AttachSound(sSoundName,fPar1,fPar2);
        }
    }

    void DetachSound(int nSoundId)
    {
        if ( cAttachedSoundObj != this ) 
            cAttachedSoundObj.DetachSound(nSoundId);
        else
            super.DetachSound(nSoundId);
    }
    
    void SetSoundFreq( int nSoundId, float fFreq )
    {
        if ( cAttachedSoundObj != this ) 
            cAttachedSoundObj.SetSoundFreq( nSoundId, fFreq );
        else
            super.SetSoundFreq( nSoundId, fFreq );
    }

    void TryDetachAndAttach()
    {
        if ( cAttachedSoundObj == this )
        {
            cAttachedSoundObj = ((ChromeModuleSingle)(GetModule())).MainPlayer;
        }
    }
    
    public boolean IsActive(ControlObject Activator)
    {
        if (!bActiveTrigger)
			return false;
        
        if ( (GetFirstOccupant(EPassengerRole._VEHICLE_DRIVER) == null) && (fHealth > 0) && m_bCanDrive )
            return true;
        else
            return false;
    }    
    
    //*********************************************************
	//					SaveGame
    //*********************************************************
	
    /** Metoda wczytujaca zapisane dane w Save gracza
     */	
    public void SGLoadChunk(FileChunk cParentFC)
    {	
		FileChunk.Log("[Truck6Wheels.SGLoadChunk]\n");
		
		FileChunk cFC = GameObject.LoadChunk(cParentFC);   
		
        if (cFC.GetID() == ESGChunksChrome._CHK_TRUCK6WHEELS)
        {	
			super.SGLoadChunk(cFC);
            
            cAttachedSoundObj = (ControlObject) cFC.LoadObjectRef();
        }
		
		cFC.delete();
    }
    
    /** Metoda zapisujaca dane do Save gracza
     */	
    public void SGSaveChunk(FileChunk cFCParent)
    {
		FileChunk.Log("[Truck6Wheels.SGSaveChunk]\n");
		
        FileChunk cFC = NewChunk(ESGChunksChrome._CHK_TRUCK6WHEELS, cFCParent);
		
		super.SGSaveChunk(cFC);
		
        cFC.SaveObjectRef(cAttachedSoundObj);
	
        cFC.delete();
    }	    			
}
