public class WalkerHeavy extends Walker
{
    WalkerHeavy()
    {
        super();                    
        MeshName = "Data/Meshes/Ai/Walker_w.3da";
        
//        fHealth    = 
//        fMaxHealth = 4500.f;
//        fDamageThreshold = 20;
        fHealth = fMaxHealth = 8000.f;
        fDamageThreshold = 160;
        
        m_fWalkSpeed        = 400.0f;
        m_fWalkSpeedBack    = 250.0f;
        m_fRotateSpeed      = 25.0f;
        //zeby za szybko nie przebieral "nozkami" to zwalniamy animacje
        m_fWalkAnimSpeedMul = 0.85f;

        m_sVertRotateElem  = "Walker Neck";
        m_sHorizRotateElem = "Walker Head";
        m_sMeshElementToLookAt = "Walker Cockpit";
        
        m_aWalkerAnimsSounds = new String[] {
                                  null, //A_STAND
                                  null, //A_FORWARD
                                  null, //A_BACKWARD
                                  null, //A_ROTATE_LEFT
                                  null, //A_ROTATE_RIGHT
                                  "Data/Sounds/Walker/Walker_Standby_w", //A_NORMAL2STANDBY
                                  null, //A_STANDBY
                                  "Data/Sounds/Walker/Walker_OpenCabin_w", //A_STANDBY2STANDBY_OPEN
                                  null, //A_STANDBY_OPEN
                                  "Data/Sounds/Walker/Walker_CloseCabin_w", //A_STANDBY_OPEN2STANDBY
                                  "Data/Sounds/Walker/Walker_WakeUp_w", //A_WAKEUP
                                  "Data/Sounds/Walker/Walker_NormUp_w", //A_NORMAL2UP
                                  null, //A_UP
                                  "Data/Sounds/Walker/Walker_UpNorm_w", //A_UP2NORMAL
                                  "Data/Sounds/Walker/Walker_NormDown_w", //A_NORMAL2DOWN
                                  null, //A_DOWN
                                  "Data/Sounds/Walker/Walker_DownNorm_w"  //A_DOWN2NORMAL
                                  };

        m_sStepSound = "Data/Sounds/Walker/Walker_Walk_w";
        m_sHeadLoopSound = "Data/Sounds/Walker/Walker_HeadLoop_w2";
        
        m_aHeadElements = new String[] { "Walker Head", "Walker Cannon Link", "Walker L Cannon",
                             "Walker R Cannon", "Walker Cover", "Walker Inside", "Walker Cockpit", 
                             "WW_Fotel"};

        fBlowUpShakeStrength = 700;
        fBlowUpShakeDistMin = 700;
        fBlowUpShakeDistMax = 3000;
	}
    
    public void OnCreate()
    {
        super.OnCreate();
        
		DeleteAllSeatsInfos();
        SeatInfo seatInfo = new SeatInfo(this, "Driver", EPassengerRole._VEHICLE_DRIVER,
                                         EGetInOutAnimType._UNKNOWN, new Vector(0, 0, 100));
        seatInfo.m_fBeginPosRadius = 500f;
        AddSeatInfo(seatInfo);
    }
    
    void CreateWeapons()
    { 
        CreateNewWeapon( WeaponWalker_w_Gun.class   , 
                         "Gun L",    
                         WeaponWalker._MODE_PRIMARY   );
        CreateNewWeapon( WeaponWalker_w_Gun.class   , 
                         "Gun R",    
                         WeaponWalker._MODE_PRIMARY   );
        //TODO: fixit, tymczasowo w grze sieciowej nie powinno
        //byc tej broni bo nie dziala poprawnie
        if ( m_bModuleNet )
            return;
        CreateNewWeapon( WeaponWalker_w_Rocket.class, 
                         "Rocket L", 
                         WeaponWalker._MODE_SECONDARY );
        CreateNewWeapon( WeaponWalker_w_Rocket.class, 
                         "Rocket R", 
                         WeaponWalker._MODE_SECONDARY );
    }
}
