import java.io.*;
public class VideoAudioSetings extends GameObject
{
    /**Audio*/
    static int iVolume_Speech   = 0;
    static int iVolume_FX       = 0;
    static int iVolume_Music    = 0;
    static int iSound_Quality   = 0;
    static boolean bEAX         = false;
    
    /**Video*/
    
    static int  iVideoMode      = 0;
    static int  iBpp            = 0;
    static int  iTreesQuality   = 0;
    static int  iTerrainQuality = 0;
    static int  iObjectsQuality = 0;
    static int  iTexturesQuality= 0;
    static int  iFXQuality      = 0;
    static int  iVisiblityRange = 0;
    static boolean bLighting    = false;
    static int iBrightness      = 0;
    static boolean bAdvancedPhysics = false;
    
    static void LoadAudio( String sFileName )
    {
        ParseKeyword Root=ParseFile(sFileName);
        
        if(Root==null)
        {
            CrashLog("No file !\n");
        }
        else
        {
            ParseKeyword Key, SubKey;
            for(Key=Root; Key!=null; Key=Key.GetNext())
            {
                if(Key.Equals("VolumeSpeech")) iVolume_Speech = Key.GetIParam(0);
                if(Key.Equals("VolumeFX")) iVolume_FX = Key.GetIParam(0);
                if(Key.Equals("VolumeMusic")) iVolume_Music = Key.GetIParam(0);
                if(Key.Equals("SoundQuality")) iSound_Quality = Key.GetIParam(0);
                if(Key.Equals("EAX")) bEAX = Key.GetIParam(0) != 0;
            }
            Root.delete();
        }
    }
    
    static void LoadVideo( String sFileName )
    {
        ParseKeyword Root=ParseFile(sFileName);
        
        if(Root==null)
        {
            CrashLog("No file !\n");
        }
        else
        {
            ParseKeyword Key, SubKey;
            for(Key=Root; Key!=null; Key=Key.GetNext())
            {
                if(Key.Equals("VideoMode")) iVideoMode = Key.GetIParam(0);
                if(Key.Equals("Bpp")) iBpp = Key.GetIParam(0);
                if(Key.Equals("TreesQuality")) iTreesQuality = Key.GetIParam(0);
                if(Key.Equals("TerrainQuality")) iTerrainQuality = Key.GetIParam(0);
                if(Key.Equals("ObjectsQuality")) iObjectsQuality = Key.GetIParam(0);
                if(Key.Equals("TexturesQuality")) iTexturesQuality = Key.GetIParam(0);
                if(Key.Equals("FXQuality")) iFXQuality = Key.GetIParam(0);
                if(Key.Equals("VisiblityRange")) iVisiblityRange = Key.GetIParam(0);
                if(Key.Equals("Lighting")) bLighting = Key.GetIParam(0) != 0;
                if(Key.Equals("Brightness")) iBrightness = Key.GetIParam(0);
                if(Key.Equals("AdvancedPhysics")) bAdvancedPhysics = Key.GetIParam(0) != 0;
            }
            Root.delete();
        }
    }
    
    static void SaveSetings ( String sFileName )
    {
        try
        {
            BufferedWriter Buff = new BufferedWriter(new FileWriter(sFileName));
            
            //--------Audio Definicje
            
            String sBuffor = "!VolumeSpeech(i)";
            Buff.write(sBuffor, 0, sBuffor.length());
            Buff.newLine();
            sBuffor = "!VolumeFX(i)";
            Buff.write(sBuffor, 0, sBuffor.length());
            Buff.newLine();
            sBuffor = "!VolumeMusic(i)";
            Buff.write(sBuffor, 0, sBuffor.length());
            Buff.newLine();
            sBuffor = "!SoundQuality(i)";
            Buff.write(sBuffor, 0, sBuffor.length());
            Buff.newLine();
            sBuffor = "!EAX(i)";
            Buff.write(sBuffor, 0, sBuffor.length());
            Buff.newLine();
            Buff.newLine();
            Buff.newLine();
            
            //---------Video Definicje
            
            sBuffor = "!VideoMode(i)";
            Buff.write(sBuffor, 0, sBuffor.length());
            Buff.newLine();
            sBuffor = "!Bpp(i)";
            Buff.write(sBuffor, 0, sBuffor.length());
            Buff.newLine();
            sBuffor = "!TreesQuality(i)";
            Buff.write(sBuffor, 0, sBuffor.length());
            Buff.newLine();
            sBuffor = "!TerrainQuality(i)";
            Buff.write(sBuffor, 0, sBuffor.length());
            Buff.newLine();
            sBuffor = "!ObjectsQuality(i)";
            Buff.write(sBuffor, 0, sBuffor.length());
            Buff.newLine();
            sBuffor = "!TexturesQuality(i)";
            Buff.write(sBuffor, 0, sBuffor.length());
            Buff.newLine();
            sBuffor = "!FXQuality(i)";
            Buff.write(sBuffor, 0, sBuffor.length());
            Buff.newLine();
            sBuffor = "!VisiblityRange(i)";
            Buff.write(sBuffor, 0, sBuffor.length());
            Buff.newLine();
            sBuffor = "!Lighting(i)";
            Buff.write(sBuffor, 0, sBuffor.length());
            Buff.newLine();
            sBuffor = "!Brightness(i)";
            Buff.write(sBuffor, 0, sBuffor.length());
            Buff.newLine();
            sBuffor = "!AdvancedPhysics(i)";
            Buff.write(sBuffor, 0, sBuffor.length());
            Buff.newLine();
            Buff.newLine();
            Buff.newLine();
            
            //---zapisanie ustawien audio
            
            sBuffor = "VolumeSpeech(" + iVolume_Speech + ")";
            Buff.write(sBuffor, 0, sBuffor.length());
            Buff.newLine();
            sBuffor = "VolumeFX(" + iVolume_FX + ")";
            Buff.write(sBuffor, 0, sBuffor.length());
            Buff.newLine();
            sBuffor = "VolumeMusic(" + iVolume_Music + ")";
            Buff.write(sBuffor, 0, sBuffor.length());
            Buff.newLine();
            sBuffor = "SoundQuality(" + iSound_Quality + ")";
            Buff.write(sBuffor, 0, sBuffor.length());
            Buff.newLine();
            sBuffor = "EAX(" + (bEAX ? 1 : 0 ) + ")";
            Buff.write(sBuffor, 0, sBuffor.length());
            Buff.newLine();
            Buff.newLine();
            Buff.newLine();
            
            //------zapisanie ustawien video
            
            sBuffor = "VideoMode(" + iVideoMode + ")";
            Buff.write(sBuffor, 0, sBuffor.length());
            Buff.newLine();
            sBuffor = "Bpp(" + iBpp + ")";
            Buff.write(sBuffor, 0, sBuffor.length());
            Buff.newLine();
            sBuffor = "TreesQuality(" + iTreesQuality + ")";
            Buff.write(sBuffor, 0, sBuffor.length());
            Buff.newLine();
            sBuffor = "TerrainQuality(" + iTerrainQuality + ")"; 
            Buff.write(sBuffor, 0, sBuffor.length());
            Buff.newLine();
            sBuffor = "ObjectsQuality(" + iObjectsQuality + ")";
            Buff.write(sBuffor, 0, sBuffor.length());
            Buff.newLine();
            sBuffor = "TexturesQuality(" + iTexturesQuality + ")";
            Buff.write(sBuffor, 0, sBuffor.length());
            Buff.newLine();
            sBuffor = "FXQuality(" + iFXQuality + ")";
            Buff.write(sBuffor, 0, sBuffor.length());
            Buff.newLine();
            sBuffor = "VisiblityRange(" + iVisiblityRange + ")";
            Buff.write(sBuffor, 0, sBuffor.length());
            Buff.newLine();
            sBuffor = "Lighting(" + (bLighting ? 1 : 0) + ")";
            Buff.write(sBuffor, 0, sBuffor.length());
            Buff.newLine();
            sBuffor = "Brightness(" + iBrightness + ")";
            Buff.write(sBuffor, 0, sBuffor.length());
            Buff.newLine();
            sBuffor = "AdvancedPhysics(" + (bAdvancedPhysics ? 1:0)+ ")";
            Buff.write(sBuffor, 0, sBuffor.length());
            Buff.newLine();
            Buff.newLine();
            Buff.close();
        }
        catch (IOException e)
        { 
            Log("ERROR definig sequences" + e.getMessage()); 
        }
    }
    
}
