public class InfoScreen
{
	static float _TITLE_Y = 0.25f;
	static float _TITLE_WIDTH = 0.5f;
	static float _TITLE_HEIGHT = 0.1f;
	
	static float _TEXT_Y = 0.3f;
	static float _TEXT_WIDTH = 0.5f;
	static float _TEXT_HEIGHT = 0.5f;
	
	Sprite cTitle = null;
	Sprite cBlack = null;
	Sprite cText = null;

	int nBlackTex = 0;
	
	void DisplayScreen(Module mod, String sTitle, String sText)
	{
		float fScreenWidth = mod.GetScreenWidth();
		float fScreenHeight = mod.GetScreenHeight();
		
		cBlack = (Sprite) mod.CreateObject("Sprite");
		mod.AddSprite(cBlack);
		cBlack.MoveTop();
		cBlack.SetPos(new Vector(0, 0, 0));
		cBlack.SetSize(new Vector(fScreenWidth, fScreenHeight, 0));
		nBlackTex = cBlack.AddTexture("CH_K_Czarny.png");
		cBlack.SetTexture(nBlackTex, new Rect(0f, 0f, 1f, 1f));
		
		cTitle = (Sprite) mod.CreateObject("Sprite");
		mod.AddSprite(cTitle);
		cTitle.MoveTop();
		cTitle.SetTextPosFlags(ESpriteText.HORIZ_MIDDLE);
		cTitle.SetFont(ChromeFonts.FONT_HUD_BIGGER);
		cTitle.SetPos(new Vector((1f - _TITLE_WIDTH) * fScreenWidth * 0.5f,
								  fScreenHeight * _TITLE_Y,
								  0));
		cTitle.SetSize(new Vector(fScreenWidth * _TITLE_WIDTH,
								  fScreenHeight * _TITLE_HEIGHT,
								  0));
		cTitle.DisplayText(Text.Get(sTitle));
		cTitle.Show();

		cText = (Sprite) mod.CreateObject("Sprite");
		mod.AddSprite(cText);
		cText.MoveTop();
		cText.SetTextPosFlags(ESpriteText.MULTILINE);
		cText.SetFont(Fonts.FONT_MSSANSSERIF_10);
		cText.SetPos(new Vector((1 - _TITLE_WIDTH) * fScreenWidth * 0.5f,
								 fScreenHeight * _TEXT_Y,
								 0));
		cText.SetSize(new Vector(fScreenWidth * _TEXT_WIDTH,
								 fScreenHeight * _TEXT_HEIGHT,
								 0));
		cText.DisplayText(Text.Get(sText));
		cText.Show();
	}
	
	void Black()
	{
		cBlack.Show();
	}
	
	void DeleteScreen()
	{
		if (nBlackTex != 0)
			cBlack.ReleaseTexture(nBlackTex);
		cBlack.DetachFromParent();
		cBlack.GetModule().RemoveSprite(cBlack);
		cBlack.delete();
		cBlack = null;
		
		cTitle.DetachFromParent();
		cTitle.GetModule().RemoveSprite(cTitle);
		cTitle.delete();
		cTitle = null;
		
		cText.DetachFromParent();
		cText.GetModule().RemoveSprite(cText);
		cText.delete();
		cText = null;
	}
}
